/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the ARM target                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 85;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(ARMInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(ARMInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static ARMInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static ARMInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testMOPredicate_MO(unsigned PredicateID, const MachineOperand &MO, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_v2s1,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v4s1,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v4s64,
  GILLT_v8s1,
  GILLT_v8s8,
  GILLT_v8s16,
  GILLT_v8s64,
  GILLT_v16s1,
  GILLT_v16s8,
};
const static size_t NumTypeObjects = 16;
const static LLT TypeObjects[] = {
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::vector(ElementCount::getFixed(2), 1),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 1),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(4), 64),
  LLT::vector(ElementCount::getFixed(8), 1),
  LLT::vector(ElementCount::getFixed(8), 8),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(8), 64),
  LLT::vector(ElementCount::getFixed(16), 1),
  LLT::vector(ElementCount::getFixed(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_NoHonorSignDependentRoundingBit = 75,
  Feature_HasV4TBit = 6,
  Feature_NoV4TBit = 7,
  Feature_HasV5TBit = 13,
  Feature_NoV5TBit = 65,
  Feature_HasV5TEBit = 11,
  Feature_HasV6Bit = 0,
  Feature_NoV6Bit = 9,
  Feature_HasV6MBit = 28,
  Feature_HasV8MBaselineBit = 35,
  Feature_HasV8_1MMainlineBit = 41,
  Feature_HasMVEIntBit = 63,
  Feature_HasMVEFloatBit = 64,
  Feature_HasCDEBit = 84,
  Feature_HasFPRegsBit = 42,
  Feature_HasFPRegs16Bit = 43,
  Feature_HasFPRegs64Bit = 76,
  Feature_HasV6T2Bit = 8,
  Feature_HasV6KBit = 18,
  Feature_HasV7Bit = 3,
  Feature_HasV8Bit = 55,
  Feature_PreV8Bit = 19,
  Feature_HasV8_1aBit = 78,
  Feature_HasV8_3aBit = 79,
  Feature_NoVFPBit = 22,
  Feature_HasVFP2Bit = 21,
  Feature_HasVFP3Bit = 52,
  Feature_HasVFP4Bit = 50,
  Feature_HasDPVFPBit = 44,
  Feature_HasFPARMv8Bit = 47,
  Feature_HasNEONBit = 53,
  Feature_HasSHA2Bit = 62,
  Feature_HasAESBit = 54,
  Feature_HasDotProdBit = 56,
  Feature_HasCRCBit = 14,
  Feature_HasLOBBit = 40,
  Feature_HasFP16Bit = 61,
  Feature_HasFullFP16Bit = 46,
  Feature_HasMatMulInt8Bit = 57,
  Feature_HasDivideInThumbBit = 37,
  Feature_HasDivideInARMBit = 12,
  Feature_HasDSPBit = 36,
  Feature_HasDBBit = 15,
  Feature_HasV7ClrexBit = 17,
  Feature_HasAcquireReleaseBit = 16,
  Feature_HasMPBit = 2,
  Feature_Has8MSecExtBit = 29,
  Feature_HasZCZBit = 58,
  Feature_UseNEONForFPBit = 82,
  Feature_DontUseNEONForFPBit = 45,
  Feature_IsThumbBit = 26,
  Feature_IsThumb1OnlyBit = 27,
  Feature_IsThumb2Bit = 34,
  Feature_IsNotMClassBit = 38,
  Feature_IsARMBit = 1,
  Feature_IsWindowsBit = 30,
  Feature_IsNotWindowsBit = 31,
  Feature_IsReadTPTPIDRURWBit = 68,
  Feature_IsReadTPTPIDRUROBit = 69,
  Feature_IsReadTPTPIDRPRWBit = 70,
  Feature_IsReadTPSoftBit = 20,
  Feature_UseNaClTrapBit = 4,
  Feature_DontUseNaClTrapBit = 5,
  Feature_UseMovtBit = 39,
  Feature_DontUseMovtBit = 23,
  Feature_UseMovtInPicBit = 24,
  Feature_DontUseMovtInPicBit = 25,
  Feature_UseFPVMLxBit = 49,
  Feature_SLSBLRMitigationBit = 67,
  Feature_NoSLSBLRMitigationBit = 66,
  Feature_UseMulOpsBit = 10,
  Feature_UseFusedMACBit = 51,
  Feature_HasFastVGETLNi32Bit = 59,
  Feature_HasSlowVGETLNi32Bit = 80,
  Feature_HasFastVDUP32Bit = 60,
  Feature_HasSlowVDUP32Bit = 81,
  Feature_UseVMOVSRBit = 48,
  Feature_DontUseVMOVSRBit = 83,
  Feature_IsLEBit = 74,
  Feature_IsBEBit = 77,
  Feature_GenExecuteOnlyBit = 33,
  Feature_DontGenExecuteOnlyBit = 32,
  Feature_GenT1ExecuteOnlyBit = 73,
  Feature_SignRetAddrBit = 72,
  Feature_NoSignRetAddrBit = 71,
};

PredicateBitset ARMInstructionSelector::
computeAvailableModuleFeatures(const ARMSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (!TM.Options.HonorSignDependentRoundingFPMath())
    Features.set(Feature_NoHonorSignDependentRoundingBit);
  if (Subtarget->hasV4TOps())
    Features.set(Feature_HasV4TBit);
  if (!Subtarget->hasV4TOps())
    Features.set(Feature_NoV4TBit);
  if (Subtarget->hasV5TOps())
    Features.set(Feature_HasV5TBit);
  if (!Subtarget->hasV5TOps())
    Features.set(Feature_NoV5TBit);
  if (Subtarget->hasV5TEOps())
    Features.set(Feature_HasV5TEBit);
  if (Subtarget->hasV6Ops())
    Features.set(Feature_HasV6Bit);
  if (!Subtarget->hasV6Ops())
    Features.set(Feature_NoV6Bit);
  if (Subtarget->hasV6MOps())
    Features.set(Feature_HasV6MBit);
  if (Subtarget->hasV8MBaselineOps())
    Features.set(Feature_HasV8MBaselineBit);
  if (Subtarget->hasV8_1MMainlineOps())
    Features.set(Feature_HasV8_1MMainlineBit);
  if (Subtarget->hasMVEIntegerOps())
    Features.set(Feature_HasMVEIntBit);
  if (Subtarget->hasMVEFloatOps())
    Features.set(Feature_HasMVEFloatBit);
  if (Subtarget->hasCDEOps())
    Features.set(Feature_HasCDEBit);
  if (Subtarget->hasFPRegs())
    Features.set(Feature_HasFPRegsBit);
  if (Subtarget->hasFPRegs16())
    Features.set(Feature_HasFPRegs16Bit);
  if (Subtarget->hasFPRegs64())
    Features.set(Feature_HasFPRegs64Bit);
  if (Subtarget->hasV6T2Ops())
    Features.set(Feature_HasV6T2Bit);
  if (Subtarget->hasV6KOps())
    Features.set(Feature_HasV6KBit);
  if (Subtarget->hasV7Ops())
    Features.set(Feature_HasV7Bit);
  if (Subtarget->hasV8Ops())
    Features.set(Feature_HasV8Bit);
  if (!Subtarget->hasV8Ops())
    Features.set(Feature_PreV8Bit);
  if (Subtarget->hasV8_1aOps())
    Features.set(Feature_HasV8_1aBit);
  if (Subtarget->hasV8_3aOps())
    Features.set(Feature_HasV8_3aBit);
  if (!Subtarget->hasVFP2Base())
    Features.set(Feature_NoVFPBit);
  if (Subtarget->hasVFP2Base())
    Features.set(Feature_HasVFP2Bit);
  if (Subtarget->hasVFP3Base())
    Features.set(Feature_HasVFP3Bit);
  if (Subtarget->hasVFP4Base())
    Features.set(Feature_HasVFP4Bit);
  if (Subtarget->hasFP64())
    Features.set(Feature_HasDPVFPBit);
  if (Subtarget->hasFPARMv8Base())
    Features.set(Feature_HasFPARMv8Bit);
  if (Subtarget->hasNEON())
    Features.set(Feature_HasNEONBit);
  if (Subtarget->hasSHA2())
    Features.set(Feature_HasSHA2Bit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  if (Subtarget->hasCRC())
    Features.set(Feature_HasCRCBit);
  if (Subtarget->hasLOB())
    Features.set(Feature_HasLOBBit);
  if (Subtarget->hasFP16())
    Features.set(Feature_HasFP16Bit);
  if (Subtarget->hasFullFP16())
    Features.set(Feature_HasFullFP16Bit);
  if (Subtarget->hasMatMulInt8())
    Features.set(Feature_HasMatMulInt8Bit);
  if (Subtarget->hasDivideInThumbMode())
    Features.set(Feature_HasDivideInThumbBit);
  if (Subtarget->hasDivideInARMMode())
    Features.set(Feature_HasDivideInARMBit);
  if (Subtarget->hasDSP())
    Features.set(Feature_HasDSPBit);
  if (Subtarget->hasDataBarrier())
    Features.set(Feature_HasDBBit);
  if (Subtarget->hasV7Clrex())
    Features.set(Feature_HasV7ClrexBit);
  if (Subtarget->hasAcquireRelease())
    Features.set(Feature_HasAcquireReleaseBit);
  if (Subtarget->hasMPExtension())
    Features.set(Feature_HasMPBit);
  if (Subtarget->has8MSecExt())
    Features.set(Feature_Has8MSecExtBit);
  if (Subtarget->hasZeroCycleZeroing())
    Features.set(Feature_HasZCZBit);
  if (Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_UseNEONForFPBit);
  if (!Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_DontUseNEONForFPBit);
  if (Subtarget->isThumb())
    Features.set(Feature_IsThumbBit);
  if (Subtarget->isThumb1Only())
    Features.set(Feature_IsThumb1OnlyBit);
  if (Subtarget->isThumb2())
    Features.set(Feature_IsThumb2Bit);
  if (!Subtarget->isMClass())
    Features.set(Feature_IsNotMClassBit);
  if (!Subtarget->isThumb())
    Features.set(Feature_IsARMBit);
  if (Subtarget->isTargetWindows())
    Features.set(Feature_IsWindowsBit);
  if (!Subtarget->isTargetWindows())
    Features.set(Feature_IsNotWindowsBit);
  if (Subtarget->isReadTPTPIDRURW())
    Features.set(Feature_IsReadTPTPIDRURWBit);
  if (Subtarget->isReadTPTPIDRURO())
    Features.set(Feature_IsReadTPTPIDRUROBit);
  if (Subtarget->isReadTPTPIDRPRW())
    Features.set(Feature_IsReadTPTPIDRPRWBit);
  if (Subtarget->isReadTPSoft())
    Features.set(Feature_IsReadTPSoftBit);
  if (Subtarget->useNaClTrap())
    Features.set(Feature_UseNaClTrapBit);
  if (!Subtarget->useNaClTrap())
    Features.set(Feature_DontUseNaClTrapBit);
  if (Subtarget->useMulOps())
    Features.set(Feature_UseMulOpsBit);
  if (TM.Options.AllowFPOpFusion ==  FPOpFusion::Fast && Subtarget->useFPVFMx())
    Features.set(Feature_UseFusedMACBit);
  if (!Subtarget->hasSlowVGETLNi32())
    Features.set(Feature_HasFastVGETLNi32Bit);
  if (Subtarget->hasSlowVGETLNi32())
    Features.set(Feature_HasSlowVGETLNi32Bit);
  if (!Subtarget->hasSlowVDUP32())
    Features.set(Feature_HasFastVDUP32Bit);
  if (Subtarget->hasSlowVDUP32())
    Features.set(Feature_HasSlowVDUP32Bit);
  if (Subtarget->preferVMOVSR() ||!Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_UseVMOVSRBit);
  if (!Subtarget->preferVMOVSR() &&Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_DontUseVMOVSRBit);
  if (Subtarget->genExecuteOnly())
    Features.set(Feature_GenExecuteOnlyBit);
  if (!Subtarget->genExecuteOnly())
    Features.set(Feature_DontGenExecuteOnlyBit);
  if (Subtarget->genExecuteOnly() && Subtarget->isThumb1Only() && !Subtarget->hasV8MBaselineOps())
    Features.set(Feature_GenT1ExecuteOnlyBit);
  return Features;
}

void ARMInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const ARMSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset ARMInstructionSelector::
computeAvailableFunctionFeatures(const ARMSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (Subtarget->useMovt())
    Features.set(Feature_UseMovtBit);
  if (!Subtarget->useMovt())
    Features.set(Feature_DontUseMovtBit);
  if (Subtarget->useMovt() && Subtarget->allowPositionIndependentMovt())
    Features.set(Feature_UseMovtInPicBit);
  if (!Subtarget->useMovt() || !Subtarget->allowPositionIndependentMovt())
    Features.set(Feature_DontUseMovtInPicBit);
  if (((Subtarget->useFPVMLx() &&  TM.Options.AllowFPOpFusion != FPOpFusion::Fast) ||Subtarget->hasMinSize()))
    Features.set(Feature_UseFPVMLxBit);
  if ( MF->getSubtarget<ARMSubtarget>().hardenSlsBlr() )
    Features.set(Feature_SLSBLRMitigationBit);
  if ( !MF->getSubtarget<ARMSubtarget>().hardenSlsBlr() )
    Features.set(Feature_NoSLSBLRMitigationBit);
  if (MF->getDataLayout().isLittleEndian())
    Features.set(Feature_IsLEBit);
  if (MF->getDataLayout().isBigEndian())
    Features.set(Feature_IsBEBit);
  if ( MF->getInfo<ARMFunctionInfo>()->shouldSignReturnAddress(true) )
    Features.set(Feature_SignRetAddrBit);
  if ( !MF->getInfo<ARMFunctionInfo>()->shouldSignReturnAddress(true) )
    Features.set(Feature_NoSignRetAddrBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasDotProd,
  GIFBS_HasFP16,
  GIFBS_HasFPARMv8,
  GIFBS_HasFPRegs,
  GIFBS_HasFullFP16,
  GIFBS_HasMVEFloat,
  GIFBS_HasMVEInt,
  GIFBS_HasMatMulInt8,
  GIFBS_HasNEON,
  GIFBS_HasVFP2,
  GIFBS_HasVFP3,
  GIFBS_HasVFP4,
  GIFBS_IsARM,
  GIFBS_IsThumb,
  GIFBS_IsThumb2,
  GIFBS_NoHonorSignDependentRounding,
  GIFBS_DontUseNEONForFP_HasVFP2,
  GIFBS_DontUseNaClTrap_IsARM,
  GIFBS_DontUseVMOVSR_HasNEON,
  GIFBS_Has8MSecExt_IsThumb,
  GIFBS_HasAES_HasV8,
  GIFBS_HasCRC_IsARM,
  GIFBS_HasCRC_IsThumb2,
  GIFBS_HasDB_IsARM,
  GIFBS_HasDB_IsThumb,
  GIFBS_HasDPVFP_HasFPARMv8,
  GIFBS_HasDPVFP_HasVFP2,
  GIFBS_HasDPVFP_HasVFP3,
  GIFBS_HasDPVFP_HasVFP4,
  GIFBS_HasDPVFP_NoHonorSignDependentRounding,
  GIFBS_HasDSP_IsThumb2,
  GIFBS_HasDivideInARM_IsARM,
  GIFBS_HasFP16_HasNEON,
  GIFBS_HasFPARMv8_HasNEON,
  GIFBS_HasFPRegs_HasFastVGETLNi32,
  GIFBS_HasFPRegs_UseVMOVSR,
  GIFBS_HasFullFP16_HasNEON,
  GIFBS_HasMVEInt_HasV8_1MMainline,
  GIFBS_HasMVEInt_IsBE,
  GIFBS_HasMVEInt_IsLE,
  GIFBS_HasNEON_HasV8,
  GIFBS_HasNEON_HasV8_1a,
  GIFBS_HasNEON_HasV8_3a,
  GIFBS_HasNEON_HasVFP4,
  GIFBS_HasNEON_IsBE,
  GIFBS_HasNEON_IsLE,
  GIFBS_HasNEON_UseNEONForFP,
  GIFBS_HasSHA2_HasV8,
  GIFBS_HasV5T_IsARM,
  GIFBS_HasV5T_IsThumb,
  GIFBS_HasV5TE_IsARM,
  GIFBS_HasV6_IsARM,
  GIFBS_HasV6K_IsARM,
  GIFBS_HasV6M_IsThumb,
  GIFBS_HasV6T2_IsARM,
  GIFBS_HasV7_IsARM,
  GIFBS_HasV7Clrex_IsThumb,
  GIFBS_HasV8MBaseline_IsThumb,
  GIFBS_IsARM_NoV5T,
  GIFBS_IsARM_NoV6,
  GIFBS_IsARM_PreV8,
  GIFBS_IsARM_UseNaClTrap,
  GIFBS_IsThumb_IsThumb1Only,
  GIFBS_IsThumb_IsWindows,
  GIFBS_IsThumb_NoV5T,
  GIFBS_IsThumb_UseMovt,
  GIFBS_IsThumb2_PreV8,
  GIFBS_IsThumb2_UseMulOps,
  GIFBS_DontUseMovt_GenExecuteOnly_IsThumb1Only,
  GIFBS_HasDSP_IsThumb2_UseMulOps,
  GIFBS_HasDivideInThumb_HasV8MBaseline_IsThumb,
  GIFBS_HasFPARMv8_HasFullFP16_HasNEON,
  GIFBS_HasFullFP16_HasNEON_HasV8,
  GIFBS_HasFullFP16_HasNEON_HasV8_3a,
  GIFBS_HasFullFP16_HasNEON_UseFPVMLx,
  GIFBS_HasFullFP16_HasNEON_UseFusedMAC,
  GIFBS_HasLOB_HasV8_1MMainline_IsThumb2,
  GIFBS_HasNEON_UseFPVMLx_UseNEONForFP,
  GIFBS_HasV5TE_IsARM_UseMulOps,
  GIFBS_HasV6_IsARM_UseMulOps,
  GIFBS_HasV6_IsThumb_IsThumb1Only,
  GIFBS_HasV6T2_IsARM_UseMulOps,
  GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP,
  GIFBS_IsARM_NoV6_UseMulOps,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasDotProdBit, },
  {Feature_HasFP16Bit, },
  {Feature_HasFPARMv8Bit, },
  {Feature_HasFPRegsBit, },
  {Feature_HasFullFP16Bit, },
  {Feature_HasMVEFloatBit, },
  {Feature_HasMVEIntBit, },
  {Feature_HasMatMulInt8Bit, },
  {Feature_HasNEONBit, },
  {Feature_HasVFP2Bit, },
  {Feature_HasVFP3Bit, },
  {Feature_HasVFP4Bit, },
  {Feature_IsARMBit, },
  {Feature_IsThumbBit, },
  {Feature_IsThumb2Bit, },
  {Feature_NoHonorSignDependentRoundingBit, },
  {Feature_DontUseNEONForFPBit, Feature_HasVFP2Bit, },
  {Feature_DontUseNaClTrapBit, Feature_IsARMBit, },
  {Feature_DontUseVMOVSRBit, Feature_HasNEONBit, },
  {Feature_Has8MSecExtBit, Feature_IsThumbBit, },
  {Feature_HasAESBit, Feature_HasV8Bit, },
  {Feature_HasCRCBit, Feature_IsARMBit, },
  {Feature_HasCRCBit, Feature_IsThumb2Bit, },
  {Feature_HasDBBit, Feature_IsARMBit, },
  {Feature_HasDBBit, Feature_IsThumbBit, },
  {Feature_HasDPVFPBit, Feature_HasFPARMv8Bit, },
  {Feature_HasDPVFPBit, Feature_HasVFP2Bit, },
  {Feature_HasDPVFPBit, Feature_HasVFP3Bit, },
  {Feature_HasDPVFPBit, Feature_HasVFP4Bit, },
  {Feature_HasDPVFPBit, Feature_NoHonorSignDependentRoundingBit, },
  {Feature_HasDSPBit, Feature_IsThumb2Bit, },
  {Feature_HasDivideInARMBit, Feature_IsARMBit, },
  {Feature_HasFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFPARMv8Bit, Feature_HasNEONBit, },
  {Feature_HasFPRegsBit, Feature_HasFastVGETLNi32Bit, },
  {Feature_HasFPRegsBit, Feature_UseVMOVSRBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasMVEIntBit, Feature_HasV8_1MMainlineBit, },
  {Feature_HasMVEIntBit, Feature_IsBEBit, },
  {Feature_HasMVEIntBit, Feature_IsLEBit, },
  {Feature_HasNEONBit, Feature_HasV8Bit, },
  {Feature_HasNEONBit, Feature_HasV8_1aBit, },
  {Feature_HasNEONBit, Feature_HasV8_3aBit, },
  {Feature_HasNEONBit, Feature_HasVFP4Bit, },
  {Feature_HasNEONBit, Feature_IsBEBit, },
  {Feature_HasNEONBit, Feature_IsLEBit, },
  {Feature_HasNEONBit, Feature_UseNEONForFPBit, },
  {Feature_HasSHA2Bit, Feature_HasV8Bit, },
  {Feature_HasV5TBit, Feature_IsARMBit, },
  {Feature_HasV5TBit, Feature_IsThumbBit, },
  {Feature_HasV5TEBit, Feature_IsARMBit, },
  {Feature_HasV6Bit, Feature_IsARMBit, },
  {Feature_HasV6KBit, Feature_IsARMBit, },
  {Feature_HasV6MBit, Feature_IsThumbBit, },
  {Feature_HasV6T2Bit, Feature_IsARMBit, },
  {Feature_HasV7Bit, Feature_IsARMBit, },
  {Feature_HasV7ClrexBit, Feature_IsThumbBit, },
  {Feature_HasV8MBaselineBit, Feature_IsThumbBit, },
  {Feature_IsARMBit, Feature_NoV5TBit, },
  {Feature_IsARMBit, Feature_NoV6Bit, },
  {Feature_IsARMBit, Feature_PreV8Bit, },
  {Feature_IsARMBit, Feature_UseNaClTrapBit, },
  {Feature_IsThumbBit, Feature_IsThumb1OnlyBit, },
  {Feature_IsThumbBit, Feature_IsWindowsBit, },
  {Feature_IsThumbBit, Feature_NoV5TBit, },
  {Feature_IsThumbBit, Feature_UseMovtBit, },
  {Feature_IsThumb2Bit, Feature_PreV8Bit, },
  {Feature_IsThumb2Bit, Feature_UseMulOpsBit, },
  {Feature_DontUseMovtBit, Feature_GenExecuteOnlyBit, Feature_IsThumb1OnlyBit, },
  {Feature_HasDSPBit, Feature_IsThumb2Bit, Feature_UseMulOpsBit, },
  {Feature_HasDivideInThumbBit, Feature_HasV8MBaselineBit, Feature_IsThumbBit, },
  {Feature_HasFPARMv8Bit, Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_HasV8Bit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_HasV8_3aBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_UseFPVMLxBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_UseFusedMACBit, },
  {Feature_HasLOBBit, Feature_HasV8_1MMainlineBit, Feature_IsThumb2Bit, },
  {Feature_HasNEONBit, Feature_UseFPVMLxBit, Feature_UseNEONForFPBit, },
  {Feature_HasV5TEBit, Feature_IsARMBit, Feature_UseMulOpsBit, },
  {Feature_HasV6Bit, Feature_IsARMBit, Feature_UseMulOpsBit, },
  {Feature_HasV6Bit, Feature_IsThumbBit, Feature_IsThumb1OnlyBit, },
  {Feature_HasV6T2Bit, Feature_IsARMBit, Feature_UseMulOpsBit, },
  {Feature_HasVFP4Bit, Feature_UseFusedMACBit, Feature_UseNEONForFPBit, },
  {Feature_IsARMBit, Feature_NoV6Bit, Feature_UseMulOpsBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

ARMInstructionSelector::ComplexMatcherMemFn
ARMInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_bf_inv_mask_imm = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_vfp_f32imm,
  GICXXPred_MI_Predicate_vfp_f64imm,
};
bool ARMInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_bf_inv_mask_imm: {
    
        // There's better methods of implementing this check. IntImmLeaf<> would be
        // equivalent and have less boilerplate but we need a test for C++
        // predicates and this one causes new rules to be imported into GlobalISel
        // without requiring additional features first.
        const auto &MO = MI.getOperand(1);
        if (!MO.isCImm())
          return false;
        return ARM::isBitFieldInvertedMask(MO.getCImm()->getZExtValue());
      
    llvm_unreachable("bf_inv_mask_imm should have returned");
  }
  case GICXXPred_MI_Predicate_vfp_f32imm: {
    
          const auto &MO = MI.getOperand(1);
          if (!MO.isFPImm())
            return false;
          return ARM_AM::getFP32Imm(MO.getFPImm()->getValueAPF()) != -1;
        
    llvm_unreachable("vfp_f32imm should have returned");
  }
  case GICXXPred_MI_Predicate_vfp_f64imm: {
    
          const auto &MO = MI.getOperand(1);
          if (!MO.isFPImm())
            return false;
          return ARM_AM::getFP64Imm(MO.getFPImm()->getValueAPF()) != -1;
        
    llvm_unreachable("vfp_f64imm should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool ARMInstructionSelector::testMOPredicate_MO(unsigned PredicateID, const MachineOperand & MO, const MatcherState &State) const {
  const auto &Operands = State.RecordedOperands;
  Register Reg = MO.getReg();
  (void)Operands;
  (void)Reg;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_VectorIndex8 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_VectorIndex16,
  GICXXPred_I64_Predicate_VectorIndex32,
  GICXXPred_I64_Predicate_VectorIndex64,
  GICXXPred_I64_Predicate_asr_imm,
  GICXXPred_I64_Predicate_imm0_7,
  GICXXPred_I64_Predicate_imm0_15,
  GICXXPred_I64_Predicate_imm0_31,
  GICXXPred_I64_Predicate_imm0_32,
  GICXXPred_I64_Predicate_imm0_63,
  GICXXPred_I64_Predicate_imm0_239,
  GICXXPred_I64_Predicate_imm0_255,
  GICXXPred_I64_Predicate_imm0_255_expr,
  GICXXPred_I64_Predicate_imm0_4095,
  GICXXPred_I64_Predicate_imm0_65535,
  GICXXPred_I64_Predicate_imm0_65535_expr,
  GICXXPred_I64_Predicate_imm0_65535_neg,
  GICXXPred_I64_Predicate_imm1_7,
  GICXXPred_I64_Predicate_imm1_15,
  GICXXPred_I64_Predicate_imm1_16,
  GICXXPred_I64_Predicate_imm1_31,
  GICXXPred_I64_Predicate_imm8,
  GICXXPred_I64_Predicate_imm8_255,
  GICXXPred_I64_Predicate_imm8_or_16,
  GICXXPred_I64_Predicate_imm16,
  GICXXPred_I64_Predicate_imm16_31,
  GICXXPred_I64_Predicate_imm24b,
  GICXXPred_I64_Predicate_imm32,
  GICXXPred_I64_Predicate_imm256_510,
  GICXXPred_I64_Predicate_imm_3b,
  GICXXPred_I64_Predicate_imm_4b,
  GICXXPred_I64_Predicate_imm_6b,
  GICXXPred_I64_Predicate_imm_7b,
  GICXXPred_I64_Predicate_imm_9b,
  GICXXPred_I64_Predicate_imm_11b,
  GICXXPred_I64_Predicate_imm_12b,
  GICXXPred_I64_Predicate_imm_13b,
  GICXXPred_I64_Predicate_imm_even,
  GICXXPred_I64_Predicate_imm_odd,
  GICXXPred_I64_Predicate_imm_sr,
  GICXXPred_I64_Predicate_long_shift,
  GICXXPred_I64_Predicate_mod_imm,
  GICXXPred_I64_Predicate_mod_imm_not,
  GICXXPred_I64_Predicate_pkh_asr_amt,
  GICXXPred_I64_Predicate_pkh_lsl_amt,
  GICXXPred_I64_Predicate_shr_imm8,
  GICXXPred_I64_Predicate_shr_imm16,
  GICXXPred_I64_Predicate_shr_imm32,
  GICXXPred_I64_Predicate_shr_imm64,
  GICXXPred_I64_Predicate_t2_so_imm,
  GICXXPred_I64_Predicate_t2_so_imm_neg,
};
bool ARMInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_VectorIndex8: {
    
      return ((uint64_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_VectorIndex16: {
    
      return ((uint64_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_VectorIndex32: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_VectorIndex64: {
    
      return ((uint64_t)Imm) < 1;
    
  }
  case GICXXPred_I64_Predicate_asr_imm: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_imm0_7: {
    
      return Imm >= 0 && Imm < 8;
    
  }
  case GICXXPred_I64_Predicate_imm0_15: {
    
      return Imm >= 0 && Imm < 16;
    
  }
  case GICXXPred_I64_Predicate_imm0_31: {
    
      return Imm >= 0 && Imm < 32;
    
  }
  case GICXXPred_I64_Predicate_imm0_32: {
    
      return Imm >= 0 && Imm < 33;
    
  }
  case GICXXPred_I64_Predicate_imm0_63: {
    
      return Imm >= 0 && Imm < 64;
    
  }
  case GICXXPred_I64_Predicate_imm0_239: {
     return Imm >= 0 && Imm < 240; 
  }
  case GICXXPred_I64_Predicate_imm0_255: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_imm0_255_expr: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_imm0_4095: {
    
      return Imm >= 0 && Imm < 4096;
    
  }
  case GICXXPred_I64_Predicate_imm0_65535: {
    
      return Imm >= 0 && Imm < 65536;
    
  }
  case GICXXPred_I64_Predicate_imm0_65535_expr: {
    
      return Imm >= 0 && Imm < 65536;
    
  }
  case GICXXPred_I64_Predicate_imm0_65535_neg: {
    
      return -Imm >= 0 && -Imm < 65536;
    
  }
  case GICXXPred_I64_Predicate_imm1_7: {
     return Imm > 0 && Imm < 8; 
  }
  case GICXXPred_I64_Predicate_imm1_15: {
     return Imm > 0 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_imm1_16: {
    
        return Imm > 0 && Imm <= 16;
      
  }
  case GICXXPred_I64_Predicate_imm1_31: {
     return Imm > 0 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_imm8: {
     return Imm == 8; 
  }
  case GICXXPred_I64_Predicate_imm8_255: {
    
      return Imm >= 8 && Imm < 256;
    
  }
  case GICXXPred_I64_Predicate_imm8_or_16: {
     return Imm == 8 || Imm == 16;
  }
  case GICXXPred_I64_Predicate_imm16: {
     return Imm == 16; 
  }
  case GICXXPred_I64_Predicate_imm16_31: {
    
      return (int32_t)Imm >= 16 && (int32_t)Imm < 32;
    
  }
  case GICXXPred_I64_Predicate_imm24b: {
    
      return Imm >= 0 && Imm <= 0xffffff;
    
  }
  case GICXXPred_I64_Predicate_imm32: {
     return Imm == 32; 
  }
  case GICXXPred_I64_Predicate_imm256_510: {
    
      return Imm >= 256 && Imm < 511;
    
  }
  case GICXXPred_I64_Predicate_imm_3b: {
    { return Imm >= 0 && Imm < (1 << 3); }
    llvm_unreachable("imm_3b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_4b: {
    { return Imm >= 0 && Imm < (1 << 4); }
    llvm_unreachable("imm_4b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_6b: {
    { return Imm >= 0 && Imm < (1 << 6); }
    llvm_unreachable("imm_6b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_7b: {
    { return Imm >= 0 && Imm < (1 << 7); }
    llvm_unreachable("imm_7b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_9b: {
    { return Imm >= 0 && Imm < (1 << 9); }
    llvm_unreachable("imm_9b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_11b: {
    { return Imm >= 0 && Imm < (1 << 11); }
    llvm_unreachable("imm_11b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_12b: {
    { return Imm >= 0 && Imm < (1 << 12); }
    llvm_unreachable("imm_12b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_13b: {
    { return Imm >= 0 && Imm < (1 << 13); }
    llvm_unreachable("imm_13b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_even: {
     return (Imm & 1) == 0; 
  }
  case GICXXPred_I64_Predicate_imm_odd: {
     return (Imm & 1) == 1; 
  }
  case GICXXPred_I64_Predicate_imm_sr: {
    
      return Imm > 0 && Imm <= 32;
    
  }
  case GICXXPred_I64_Predicate_long_shift: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_mod_imm: {
    
        return ARM_AM::getSOImmVal(Imm) != -1;
      
  }
  case GICXXPred_I64_Predicate_mod_imm_not: {
    
        return ARM_AM::getSOImmVal(~(uint32_t)Imm) != -1;
      
  }
  case GICXXPred_I64_Predicate_pkh_asr_amt: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_pkh_lsl_amt: {
     return Imm >= 0 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_shr_imm8: {
     return Imm > 0 && Imm <= 8; 
  }
  case GICXXPred_I64_Predicate_shr_imm16: {
     return Imm > 0 && Imm <= 16; 
  }
  case GICXXPred_I64_Predicate_shr_imm32: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_shr_imm64: {
     return Imm > 0 && Imm <= 64; 
  }
  case GICXXPred_I64_Predicate_t2_so_imm: {
    
        return ARM_AM::getT2SOImmVal(Imm) != -1;
      
  }
  case GICXXPred_I64_Predicate_t2_so_imm_neg: {
    
      return Imm && ARM_AM::getT2SOImmVal(-(uint32_t)Imm) != -1;
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool ARMInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_arm_i32imm = GICXXPred_Invalid + 1,
};
bool ARMInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_arm_i32imm: {
    
      if (Subtarget->useMovt())
        return true;
      if (ARM_AM::isSOImmTwoPartVal(Imm.getZExtValue()))
        return true;
      return ARM_AM::isSOImmTwoPartValNeg(Imm.getZExtValue());
    
    llvm_unreachable("arm_i32imm should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool ARMInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("ARMInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderInvertedImm,
  GICR_renderVFPF32Imm,
  GICR_renderVFPF64Imm,
};
ARMInstructionSelector::CustomRendererFn
ARMInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &ARMInstructionSelector::renderInvertedImm,
  &ARMInstructionSelector::renderVFPF32Imm,
  &ARMInstructionSelector::renderVFPF64Imm,
};

bool ARMInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool ARMInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("ARMInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *ARMInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(308), /*)*//*default:*//*Label 79*/ GIMT_Encode4(131021),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(1030),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(10357),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(13601),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(15305),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(15401), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 5*/ GIMT_Encode4(15497),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 6*/ GIMT_Encode4(18677),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 7*/ GIMT_Encode4(24486), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 8*/ GIMT_Encode4(26181), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 9*/ GIMT_Encode4(26568), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(35580),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 11*/ GIMT_Encode4(35876), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 12*/ GIMT_Encode4(36139), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 13*/ GIMT_Encode4(36402), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    294 */ /*TargetOpcode::G_FENCE*//*Label 14*/ GIMT_Encode4(36565), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    314 */ /*TargetOpcode::G_INTRINSIC*//*Label 15*/ GIMT_Encode4(36586),
     /*    318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 16*/ GIMT_Encode4(91482), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    330 */ /*TargetOpcode::G_ANYEXT*//*Label 17*/ GIMT_Encode4(99144),
     /*    334 */ /*TargetOpcode::G_TRUNC*//*Label 18*/ GIMT_Encode4(99302),
     /*    338 */ /*TargetOpcode::G_CONSTANT*//*Label 19*/ GIMT_Encode4(99460),
     /*    342 */ /*TargetOpcode::G_FCONSTANT*//*Label 20*/ GIMT_Encode4(99781), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    354 */ /*TargetOpcode::G_SEXT*//*Label 21*/ GIMT_Encode4(99877),
     /*    358 */ /*TargetOpcode::G_SEXT_INREG*//*Label 22*/ GIMT_Encode4(100035),
     /*    362 */ /*TargetOpcode::G_ZEXT*//*Label 23*/ GIMT_Encode4(100640),
     /*    366 */ /*TargetOpcode::G_SHL*//*Label 24*/ GIMT_Encode4(100798),
     /*    370 */ /*TargetOpcode::G_LSHR*//*Label 25*/ GIMT_Encode4(101014),
     /*    374 */ /*TargetOpcode::G_ASHR*//*Label 26*/ GIMT_Encode4(101122), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    386 */ /*TargetOpcode::G_ROTR*//*Label 27*/ GIMT_Encode4(101395), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    454 */ /*TargetOpcode::G_UMULH*//*Label 28*/ GIMT_Encode4(101727),
     /*    458 */ /*TargetOpcode::G_SMULH*//*Label 29*/ GIMT_Encode4(101975),
     /*    462 */ /*TargetOpcode::G_UADDSAT*//*Label 30*/ GIMT_Encode4(102344),
     /*    466 */ /*TargetOpcode::G_SADDSAT*//*Label 31*/ GIMT_Encode4(102989),
     /*    470 */ /*TargetOpcode::G_USUBSAT*//*Label 32*/ GIMT_Encode4(104289),
     /*    474 */ /*TargetOpcode::G_SSUBSAT*//*Label 33*/ GIMT_Encode4(104934), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    518 */ /*TargetOpcode::G_FADD*//*Label 34*/ GIMT_Encode4(105954),
     /*    522 */ /*TargetOpcode::G_FSUB*//*Label 35*/ GIMT_Encode4(108307),
     /*    526 */ /*TargetOpcode::G_FMUL*//*Label 36*/ GIMT_Encode4(109984),
     /*    530 */ /*TargetOpcode::G_FMA*//*Label 37*/ GIMT_Encode4(110965), GIMT_Encode4(0),
     /*    538 */ /*TargetOpcode::G_FDIV*//*Label 38*/ GIMT_Encode4(113056), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    586 */ /*TargetOpcode::G_FNEG*//*Label 39*/ GIMT_Encode4(113221),
     /*    590 */ /*TargetOpcode::G_FPEXT*//*Label 40*/ GIMT_Encode4(114752),
     /*    594 */ /*TargetOpcode::G_FPTRUNC*//*Label 41*/ GIMT_Encode4(114988),
     /*    598 */ /*TargetOpcode::G_FPTOSI*//*Label 42*/ GIMT_Encode4(115260),
     /*    602 */ /*TargetOpcode::G_FPTOUI*//*Label 43*/ GIMT_Encode4(116594),
     /*    606 */ /*TargetOpcode::G_SITOFP*//*Label 44*/ GIMT_Encode4(117928),
     /*    610 */ /*TargetOpcode::G_UITOFP*//*Label 45*/ GIMT_Encode4(118580), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    622 */ /*TargetOpcode::G_FABS*//*Label 46*/ GIMT_Encode4(119232), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    638 */ /*TargetOpcode::G_FMINNUM*//*Label 47*/ GIMT_Encode4(120008),
     /*    642 */ /*TargetOpcode::G_FMAXNUM*//*Label 48*/ GIMT_Encode4(120600), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    654 */ /*TargetOpcode::G_FMINIMUM*//*Label 49*/ GIMT_Encode4(121192),
     /*    658 */ /*TargetOpcode::G_FMAXIMUM*//*Label 50*/ GIMT_Encode4(121926), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    670 */ /*TargetOpcode::G_GET_FPENV*//*Label 51*/ GIMT_Encode4(122660),
     /*    674 */ /*TargetOpcode::G_SET_FPENV*//*Label 52*/ GIMT_Encode4(122693),
     /*    678 */ /*TargetOpcode::G_RESET_FPENV*//*Label 53*/ GIMT_Encode4(122729),
     /*    682 */ /*TargetOpcode::G_GET_FPMODE*//*Label 54*/ GIMT_Encode4(122858), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    702 */ /*TargetOpcode::G_SMIN*//*Label 55*/ GIMT_Encode4(122891),
     /*    706 */ /*TargetOpcode::G_SMAX*//*Label 56*/ GIMT_Encode4(123434),
     /*    710 */ /*TargetOpcode::G_UMIN*//*Label 57*/ GIMT_Encode4(123977),
     /*    714 */ /*TargetOpcode::G_UMAX*//*Label 58*/ GIMT_Encode4(124898),
     /*    718 */ /*TargetOpcode::G_ABS*//*Label 59*/ GIMT_Encode4(125819), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    730 */ /*TargetOpcode::G_BR*//*Label 60*/ GIMT_Encode4(126290), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    750 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 61*/ GIMT_Encode4(126363),
     /*    754 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 62*/ GIMT_Encode4(126663), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    782 */ /*TargetOpcode::G_CTLZ*//*Label 63*/ GIMT_Encode4(126720), GIMT_Encode4(0),
     /*    790 */ /*TargetOpcode::G_CTPOP*//*Label 64*/ GIMT_Encode4(127281),
     /*    794 */ /*TargetOpcode::G_BSWAP*//*Label 65*/ GIMT_Encode4(127389),
     /*    798 */ /*TargetOpcode::G_BITREVERSE*//*Label 66*/ GIMT_Encode4(127679),
     /*    802 */ /*TargetOpcode::G_FCEIL*//*Label 67*/ GIMT_Encode4(128111), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    850 */ /*TargetOpcode::G_FSQRT*//*Label 68*/ GIMT_Encode4(128374),
     /*    854 */ /*TargetOpcode::G_FFLOOR*//*Label 69*/ GIMT_Encode4(128512),
     /*    858 */ /*TargetOpcode::G_FRINT*//*Label 70*/ GIMT_Encode4(128887),
     /*    862 */ /*TargetOpcode::G_FNEARBYINT*//*Label 71*/ GIMT_Encode4(129183), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    950 */ /*TargetOpcode::G_TRAP*//*Label 72*/ GIMT_Encode4(129321),
     /*    954 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 73*/ GIMT_Encode4(129367), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    994 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 74*/ GIMT_Encode4(129454), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1014 */ /*TargetOpcode::G_VECREDUCE_SMAX*//*Label 75*/ GIMT_Encode4(129875),
     /*   1018 */ /*TargetOpcode::G_VECREDUCE_SMIN*//*Label 76*/ GIMT_Encode4(130155),
     /*   1022 */ /*TargetOpcode::G_VECREDUCE_UMAX*//*Label 77*/ GIMT_Encode4(130444),
     /*   1026 */ /*TargetOpcode::G_VECREDUCE_UMIN*//*Label 78*/ GIMT_Encode4(130725),
     /*   1030 */ // Label 0: @1030
     /*   1030 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 89*/ GIMT_Encode4(10356),
     /*   1041 */ /*GILLT_s32*//*Label 80*/ GIMT_Encode4(1101),
     /*   1045 */ /*GILLT_s64*//*Label 81*/ GIMT_Encode4(6877), GIMT_Encode4(0),
     /*   1053 */ /*GILLT_v2s32*//*Label 82*/ GIMT_Encode4(6924),
     /*   1057 */ /*GILLT_v2s64*//*Label 83*/ GIMT_Encode4(7109), GIMT_Encode4(0),
     /*   1065 */ /*GILLT_v4s16*//*Label 84*/ GIMT_Encode4(7820),
     /*   1069 */ /*GILLT_v4s32*//*Label 85*/ GIMT_Encode4(8005), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1081 */ /*GILLT_v8s8*//*Label 86*/ GIMT_Encode4(8961),
     /*   1085 */ /*GILLT_v8s16*//*Label 87*/ GIMT_Encode4(9146), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1097 */ /*GILLT_v16s8*//*Label 88*/ GIMT_Encode4(10102),
     /*   1101 */ // Label 80: @1101
     /*   1101 */ GIM_Try, /*On fail goto*//*Label 90*/ GIMT_Encode4(6876),
     /*   1106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   1109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   1112 */   GIM_Try, /*On fail goto*//*Label 91*/ GIMT_Encode4(1187), // Rule ID 5670 //
     /*   1117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1145 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1162 */     // (add:{ *:[i32] } (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (UXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAB),
     /*   1165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1179 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1185 */     GIR_RootConstrainSelectedInstOperands,
     /*   1186 */     // GIR_Coverage, 5670,
     /*   1186 */     GIR_EraseRootFromParent_Done,
     /*   1187 */   // Label 91: @1187
     /*   1187 */   GIM_Try, /*On fail goto*//*Label 92*/ GIMT_Encode4(1262), // Rule ID 5671 //
     /*   1192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1220 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1237 */     // (add:{ *:[i32] } (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (UXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAH),
     /*   1240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1254 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1260 */     GIR_RootConstrainSelectedInstOperands,
     /*   1261 */     // GIR_Coverage, 5671,
     /*   1261 */     GIR_EraseRootFromParent_Done,
     /*   1262 */   // Label 92: @1262
     /*   1262 */   GIM_Try, /*On fail goto*//*Label 93*/ GIMT_Encode4(1337), // Rule ID 5705 //
     /*   1267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1295 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1312 */     // (add:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2UXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAB),
     /*   1315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1329 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1335 */     GIR_RootConstrainSelectedInstOperands,
     /*   1336 */     // GIR_Coverage, 5705,
     /*   1336 */     GIR_EraseRootFromParent_Done,
     /*   1337 */   // Label 93: @1337
     /*   1337 */   GIM_Try, /*On fail goto*//*Label 94*/ GIMT_Encode4(1412), // Rule ID 5706 //
     /*   1342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1370 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1387 */     // (add:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2UXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAH),
     /*   1390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1404 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1410 */     GIR_RootConstrainSelectedInstOperands,
     /*   1411 */     // GIR_Coverage, 5706,
     /*   1411 */     GIR_EraseRootFromParent_Done,
     /*   1412 */   // Label 94: @1412
     /*   1412 */   GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(1487), // Rule ID 2000 //
     /*   1417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1449 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1462 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }))  =>  (UXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAB),
     /*   1465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1467 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1479 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1485 */     GIR_RootConstrainSelectedInstOperands,
     /*   1486 */     // GIR_Coverage, 2000,
     /*   1486 */     GIR_EraseRootFromParent_Done,
     /*   1487 */   // Label 95: @1487
     /*   1487 */   GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(1562), // Rule ID 2001 //
     /*   1492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1524 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1537 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }))  =>  (UXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAH),
     /*   1540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1554 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1560 */     GIR_RootConstrainSelectedInstOperands,
     /*   1561 */     // GIR_Coverage, 2001,
     /*   1561 */     GIR_EraseRootFromParent_Done,
     /*   1562 */   // Label 96: @1562
     /*   1562 */   GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1637), // Rule ID 2239 //
     /*   1567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1599 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1612 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }))  =>  (t2UXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAB),
     /*   1615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1617 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1629 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1635 */     GIR_RootConstrainSelectedInstOperands,
     /*   1636 */     // GIR_Coverage, 2239,
     /*   1636 */     GIR_EraseRootFromParent_Done,
     /*   1637 */   // Label 97: @1637
     /*   1637 */   GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1712), // Rule ID 2240 //
     /*   1642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1674 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1687 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }))  =>  (t2UXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAH),
     /*   1690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1692 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1704 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1710 */     GIR_RootConstrainSelectedInstOperands,
     /*   1711 */     // GIR_Coverage, 2240,
     /*   1711 */     GIR_EraseRootFromParent_Done,
     /*   1712 */   // Label 98: @1712
     /*   1712 */   GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1840), // Rule ID 5681 //
     /*   1717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   1732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   1740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   1744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   1748 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   1752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   1756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   1760 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   1764 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   1768 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1773 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*   1777 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   1781 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   1785 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   1789 */     // MIs[4] Rm
     /*   1789 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   1794 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*   1798 */     // MIs[1] Operand 2
     /*   1798 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   1809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1813 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   1815 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] })), i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   1815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   1818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   1826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   1829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1832 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1838 */     GIR_RootConstrainSelectedInstOperands,
     /*   1839 */     // GIR_Coverage, 5681,
     /*   1839 */     GIR_EraseRootFromParent_Done,
     /*   1840 */   // Label 99: @1840
     /*   1840 */   GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1968), // Rule ID 5682 //
     /*   1845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   1860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   1868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   1872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   1876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   1880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   1884 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   1888 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   1892 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   1896 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1901 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 8,
     /*   1905 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   1909 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   1913 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   1917 */     // MIs[4] Rm
     /*   1917 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   1922 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*   1926 */     // MIs[1] Operand 2
     /*   1926 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   1937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1941 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   1943 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] })), i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   1943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   1946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   1954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   1957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1966 */     GIR_RootConstrainSelectedInstOperands,
     /*   1967 */     // GIR_Coverage, 5682,
     /*   1967 */     GIR_EraseRootFromParent_Done,
     /*   1968 */   // Label 100: @1968
     /*   1968 */   GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(2096), // Rule ID 2106 //
     /*   1973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   1992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   2004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2008 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2012 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   2016 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   2020 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2024 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2028 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2033 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*   2037 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   2041 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   2045 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   2049 */     // MIs[4] Rm
     /*   2049 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   2054 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*   2058 */     // MIs[1] Operand 2
     /*   2058 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   2069 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   2071 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] })), i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   2071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   2074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2076 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   2078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   2085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2088 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2094 */     GIR_RootConstrainSelectedInstOperands,
     /*   2095 */     // GIR_Coverage, 2106,
     /*   2095 */     GIR_EraseRootFromParent_Done,
     /*   2096 */   // Label 101: @2096
     /*   2096 */   GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(2224), // Rule ID 5680 //
     /*   2101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   2104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   2132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2136 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2140 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   2144 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   2148 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2152 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2156 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2161 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 8,
     /*   2165 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   2169 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   2173 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   2177 */     // MIs[4] Rm
     /*   2177 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   2182 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*   2186 */     // MIs[1] Operand 2
     /*   2186 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   2197 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   2199 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] })), i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   2199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   2202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2204 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   2206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   2213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2216 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2222 */     GIR_RootConstrainSelectedInstOperands,
     /*   2223 */     // GIR_Coverage, 5680,
     /*   2223 */     GIR_EraseRootFromParent_Done,
     /*   2224 */   // Label 102: @2224
     /*   2224 */   GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(2334), // Rule ID 5449 //
     /*   2229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2264 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2268 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2273 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2281 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2285 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2289 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2293 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2298 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2306 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2308 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLATT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATT),
     /*   2311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2326 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2332 */     GIR_RootConstrainSelectedInstOperands,
     /*   2333 */     // GIR_Coverage, 5449,
     /*   2333 */     GIR_EraseRootFromParent_Done,
     /*   2334 */   // Label 103: @2334
     /*   2334 */   GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(2444), // Rule ID 5486 //
     /*   2339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   2342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2374 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2378 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2383 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2395 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2399 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2403 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2408 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2416 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2418 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLATT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   2418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATT),
     /*   2421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2436 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2442 */     GIR_RootConstrainSelectedInstOperands,
     /*   2443 */     // GIR_Coverage, 5486,
     /*   2443 */     GIR_EraseRootFromParent_Done,
     /*   2444 */   // Label 104: @2444
     /*   2444 */   GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(2554), // Rule ID 192 //
     /*   2449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2488 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2492 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2497 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2501 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2505 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2509 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2513 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2517 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2522 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2526 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2528 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (SMLATT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATT),
     /*   2531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2541 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   2543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2546 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2552 */     GIR_RootConstrainSelectedInstOperands,
     /*   2553 */     // GIR_Coverage, 192,
     /*   2553 */     GIR_EraseRootFromParent_Done,
     /*   2554 */   // Label 105: @2554
     /*   2554 */   GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(2664), // Rule ID 521 //
     /*   2559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   2562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2598 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2602 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2607 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2611 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2615 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2619 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2623 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2627 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2632 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2636 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2638 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (t2SMLATT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   2638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATT),
     /*   2641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2651 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   2653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2662 */     GIR_RootConstrainSelectedInstOperands,
     /*   2663 */     // GIR_Coverage, 521,
     /*   2663 */     GIR_EraseRootFromParent_Done,
     /*   2664 */   // Label 106: @2664
     /*   2664 */   GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(2777), // Rule ID 5448 //
     /*   2669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2704 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2713 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2721 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2725 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2729 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2734 */     // MIs[3] Operand 2
     /*   2734 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   2745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2749 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2751 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLABT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*   2754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*   2760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   2764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2769 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2775 */     GIR_RootConstrainSelectedInstOperands,
     /*   2776 */     // GIR_Coverage, 5448,
     /*   2776 */     GIR_EraseRootFromParent_Done,
     /*   2777 */   // Label 107: @2777
     /*   2777 */   GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(2890), // Rule ID 5485 //
     /*   2782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   2785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2817 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2821 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2826 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2830 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2834 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2838 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2842 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2847 */     // MIs[3] Operand 2
     /*   2847 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   2858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2862 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2864 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLABT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   2864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*   2867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*   2873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   2877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2882 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2888 */     GIR_RootConstrainSelectedInstOperands,
     /*   2889 */     // GIR_Coverage, 5485,
     /*   2889 */     GIR_EraseRootFromParent_Done,
     /*   2890 */   // Label 108: @2890
     /*   2890 */   GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(3003), // Rule ID 5447 //
     /*   2895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2926 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2930 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2935 */     // MIs[2] Operand 2
     /*   2935 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   2946 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2950 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2954 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2958 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2962 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2967 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2975 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2977 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLABT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*   2980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3001 */     GIR_RootConstrainSelectedInstOperands,
     /*   3002 */     // GIR_Coverage, 5447,
     /*   3002 */     GIR_EraseRootFromParent_Done,
     /*   3003 */   // Label 109: @3003
     /*   3003 */   GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(3116), // Rule ID 5484 //
     /*   3008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3043 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3048 */     // MIs[2] Operand 2
     /*   3048 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3059 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3063 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3067 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3071 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   3075 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3080 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   3084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3088 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3090 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLABT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*   3093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   3105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3108 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3114 */     GIR_RootConstrainSelectedInstOperands,
     /*   3115 */     // GIR_Coverage, 5484,
     /*   3115 */     GIR_EraseRootFromParent_Done,
     /*   3116 */   // Label 110: @3116
     /*   3116 */   GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(3229), // Rule ID 191 //
     /*   3121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3160 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3164 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3169 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   3173 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3177 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3181 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3185 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3190 */     // MIs[3] Operand 2
     /*   3190 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3201 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3203 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (SMLATB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   3203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATB),
     /*   3206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3216 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3227 */     GIR_RootConstrainSelectedInstOperands,
     /*   3228 */     // GIR_Coverage, 191,
     /*   3228 */     GIR_EraseRootFromParent_Done,
     /*   3229 */   // Label 111: @3229
     /*   3229 */   GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(3342), // Rule ID 520 //
     /*   3234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3273 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3282 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   3286 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3290 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3294 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3298 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3303 */     // MIs[3] Operand 2
     /*   3303 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3314 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3316 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (t2SMLATB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATB),
     /*   3319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3329 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3334 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3340 */     GIR_RootConstrainSelectedInstOperands,
     /*   3341 */     // GIR_Coverage, 520,
     /*   3341 */     GIR_EraseRootFromParent_Done,
     /*   3342 */   // Label 112: @3342
     /*   3342 */   GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(3455), // Rule ID 190 //
     /*   3347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3386 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3391 */     // MIs[2] Operand 2
     /*   3391 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3402 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3406 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3410 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3414 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   3418 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3423 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   3427 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3429 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (SMLABT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   3429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*   3432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3442 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3447 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3453 */     GIR_RootConstrainSelectedInstOperands,
     /*   3454 */     // GIR_Coverage, 190,
     /*   3454 */     GIR_EraseRootFromParent_Done,
     /*   3455 */   // Label 113: @3455
     /*   3455 */   GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(3568), // Rule ID 519 //
     /*   3460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3499 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3504 */     // MIs[2] Operand 2
     /*   3504 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3515 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3519 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3523 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3527 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   3531 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3536 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   3540 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3542 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (t2SMLABT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*   3545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3560 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3566 */     GIR_RootConstrainSelectedInstOperands,
     /*   3567 */     // GIR_Coverage, 519,
     /*   3567 */     GIR_EraseRootFromParent_Done,
     /*   3568 */   // Label 114: @3568
     /*   3568 */   GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(3659), // Rule ID 5679 //
     /*   3573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   3576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*   3600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3604 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3608 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3613 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*   3617 */     // MIs[1] Operand 2
     /*   3617 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   3628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3634 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   3634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   3637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   3641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   3645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   3648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3651 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3657 */     GIR_RootConstrainSelectedInstOperands,
     /*   3658 */     // GIR_Coverage, 5679,
     /*   3658 */     GIR_EraseRootFromParent_Done,
     /*   3659 */   // Label 115: @3659
     /*   3659 */   GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(3750), // Rule ID 2105 //
     /*   3664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   3667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*   3695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3699 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3703 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3708 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*   3712 */     // MIs[1] Operand 2
     /*   3712 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   3723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3725 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   3725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   3728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3730 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   3732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   3736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   3739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3742 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3748 */     GIR_RootConstrainSelectedInstOperands,
     /*   3749 */     // GIR_Coverage, 2105,
     /*   3749 */     GIR_EraseRootFromParent_Done,
     /*   3750 */   // Label 116: @3750
     /*   3750 */   GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(3866), // Rule ID 5446 //
     /*   3755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3795 */     // MIs[2] Operand 2
     /*   3795 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3814 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3818 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3823 */     // MIs[3] Operand 2
     /*   3823 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3838 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3840 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLABB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   3840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABB),
     /*   3843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   3855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3858 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3864 */     GIR_RootConstrainSelectedInstOperands,
     /*   3865 */     // GIR_Coverage, 5446,
     /*   3865 */     GIR_EraseRootFromParent_Done,
     /*   3866 */   // Label 117: @3866
     /*   3866 */   GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(3982), // Rule ID 5483 //
     /*   3871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3906 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3911 */     // MIs[2] Operand 2
     /*   3911 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3922 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3926 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3930 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3934 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3939 */     // MIs[3] Operand 2
     /*   3939 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3954 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3956 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLABB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABB),
     /*   3959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   3971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3974 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3980 */     GIR_RootConstrainSelectedInstOperands,
     /*   3981 */     // GIR_Coverage, 5483,
     /*   3981 */     GIR_EraseRootFromParent_Done,
     /*   3982 */   // Label 118: @3982
     /*   3982 */   GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(4098), // Rule ID 189 //
     /*   3987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   4010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   4014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   4026 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   4031 */     // MIs[2] Operand 2
     /*   4031 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   4042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4050 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   4054 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   4059 */     // MIs[3] Operand 2
     /*   4059 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   4070 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4072 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (SMLABB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   4072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABB),
     /*   4075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   4081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   4085 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   4087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4096 */     GIR_RootConstrainSelectedInstOperands,
     /*   4097 */     // GIR_Coverage, 189,
     /*   4097 */     GIR_EraseRootFromParent_Done,
     /*   4098 */   // Label 119: @4098
     /*   4098 */   GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(4214), // Rule ID 518 //
     /*   4103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   4106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   4126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   4130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   4142 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4147 */     // MIs[2] Operand 2
     /*   4147 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   4158 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4162 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4166 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   4170 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4175 */     // MIs[3] Operand 2
     /*   4175 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   4186 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4188 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (t2SMLABB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   4188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABB),
     /*   4191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   4197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   4201 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   4203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4206 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4212 */     GIR_RootConstrainSelectedInstOperands,
     /*   4213 */     // GIR_Coverage, 518,
     /*   4213 */     GIR_EraseRootFromParent_Done,
     /*   4214 */   // Label 120: @4214
     /*   4214 */   GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(4302), // Rule ID 3248 //
     /*   4219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4250 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4259 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4268 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4270 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2)), tGPREven:{ *:[i32] }:$src3)  =>  (MVE_VMLADAVau32:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /*   4270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau32),
     /*   4273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4275 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4288 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4294 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4300 */     GIR_RootConstrainSelectedInstOperands,
     /*   4301 */     // GIR_Coverage, 3248,
     /*   4301 */     GIR_EraseRootFromParent_Done,
     /*   4302 */   // Label 121: @4302
     /*   4302 */   GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(4390), // Rule ID 3249 //
     /*   4307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4338 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   4342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4347 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4356 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4358 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2)), tGPREven:{ *:[i32] }:$src3)  =>  (MVE_VMLADAVau16:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /*   4358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau16),
     /*   4361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4363 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4376 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4382 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4388 */     GIR_RootConstrainSelectedInstOperands,
     /*   4389 */     // GIR_Coverage, 3249,
     /*   4389 */     GIR_EraseRootFromParent_Done,
     /*   4390 */   // Label 122: @4390
     /*   4390 */   GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(4478), // Rule ID 3252 //
     /*   4395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4426 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   4430 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4435 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4446 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, MQPR:{ *:[v16i8] }:$src2)), tGPREven:{ *:[i32] }:$src3)  =>  (MVE_VMLADAVau8:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /*   4446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau8),
     /*   4449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4451 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4470 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4476 */     GIR_RootConstrainSelectedInstOperands,
     /*   4477 */     // GIR_Coverage, 3252,
     /*   4477 */     GIR_EraseRootFromParent_Done,
     /*   4478 */   // Label 123: @4478
     /*   4478 */   GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(4566), // Rule ID 5950 //
     /*   4483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4514 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4518 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4522 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4527 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4534 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$src3, (vecreduce_add:{ *:[i32] } (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2)))  =>  (MVE_VMLADAVau32:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /*   4534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau32),
     /*   4537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4539 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4552 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4558 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4564 */     GIR_RootConstrainSelectedInstOperands,
     /*   4565 */     // GIR_Coverage, 5950,
     /*   4565 */     GIR_EraseRootFromParent_Done,
     /*   4566 */   // Label 124: @4566
     /*   4566 */   GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(4654), // Rule ID 5951 //
     /*   4571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4606 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   4610 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4615 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4622 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$src3, (vecreduce_add:{ *:[i32] } (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2)))  =>  (MVE_VMLADAVau16:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /*   4622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau16),
     /*   4625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4627 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4640 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4646 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4652 */     GIR_RootConstrainSelectedInstOperands,
     /*   4653 */     // GIR_Coverage, 5951,
     /*   4653 */     GIR_EraseRootFromParent_Done,
     /*   4654 */   // Label 125: @4654
     /*   4654 */   GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(4742), // Rule ID 5954 //
     /*   4659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4694 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   4698 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4703 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4708 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4710 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$src3, (vecreduce_add:{ *:[i32] } (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, MQPR:{ *:[v16i8] }:$src2)))  =>  (MVE_VMLADAVau8:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /*   4710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau8),
     /*   4713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4715 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4734 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4740 */     GIR_RootConstrainSelectedInstOperands,
     /*   4741 */     // GIR_Coverage, 5954,
     /*   4741 */     GIR_EraseRootFromParent_Done,
     /*   4742 */   // Label 126: @4742
     /*   4742 */   GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(4799), // Rule ID 72 //
     /*   4747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*   4750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   4754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   4758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4766 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*   4770 */     // MIs[1] Operand 1
     /*   4770 */     // No operand predicates
     /*   4770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4772 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (ADDri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   4772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ADDri),
     /*   4775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   4782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4797 */     GIR_RootConstrainSelectedInstOperands,
     /*   4798 */     // GIR_Coverage, 72,
     /*   4798 */     GIR_EraseRootFromParent_Done,
     /*   4799 */   // Label 127: @4799
     /*   4799 */   GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(4856), // Rule ID 303 //
     /*   4804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*   4807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*   4827 */     // MIs[1] Operand 1
     /*   4827 */     // No operand predicates
     /*   4827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4829 */     // (add:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm3)  =>  (tADDi3:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm3)
     /*   4829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tADDi3),
     /*   4832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*   4840 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*   4842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm3
     /*   4845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4854 */     GIR_RootConstrainSelectedInstOperands,
     /*   4855 */     // GIR_Coverage, 303,
     /*   4855 */     GIR_EraseRootFromParent_Done,
     /*   4856 */   // Label 128: @4856
     /*   4856 */   GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(4913), // Rule ID 304 //
     /*   4861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*   4864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4880 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255_expr),
     /*   4884 */     // MIs[1] Operand 1
     /*   4884 */     // No operand predicates
     /*   4884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4886 */     // (add:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_imm0_255_expr>>:$imm8)  =>  (tADDi8:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm8)
     /*   4886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tADDi8),
     /*   4889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   4891 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*   4897 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm8
     /*   4902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4911 */     GIR_RootConstrainSelectedInstOperands,
     /*   4912 */     // GIR_Coverage, 304,
     /*   4912 */     GIR_EraseRootFromParent_Done,
     /*   4913 */   // Label 129: @4913
     /*   4913 */   GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(4970), // Rule ID 407 //
     /*   4918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   4921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   4929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*   4941 */     // MIs[1] Operand 1
     /*   4941 */     // No operand predicates
     /*   4941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4943 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2ADDri:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   4943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDri),
     /*   4946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4948 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   4953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4956 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4968 */     GIR_RootConstrainSelectedInstOperands,
     /*   4969 */     // GIR_Coverage, 407,
     /*   4969 */     GIR_EraseRootFromParent_Done,
     /*   4970 */   // Label 130: @4970
     /*   4970 */   GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(5021), // Rule ID 408 //
     /*   4975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   4978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   4986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4994 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_4095),
     /*   4998 */     // MIs[1] Operand 1
     /*   4998 */     // No operand predicates
     /*   4998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5000 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_imm0_4095>>:$imm)  =>  (t2ADDri12:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   5000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDri12),
     /*   5003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5005 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   5007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   5010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5013 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5019 */     GIR_RootConstrainSelectedInstOperands,
     /*   5020 */     // GIR_Coverage, 408,
     /*   5020 */     GIR_EraseRootFromParent_Done,
     /*   5021 */   // Label 131: @5021
     /*   5021 */   GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(5097), // Rule ID 171 //
     /*   5026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   5029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5065 */     // (add:{ *:[i32] } (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm), GPRnopc:{ *:[i32] }:$Ra)  =>  (MLA:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLA),
     /*   5068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5083 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5089 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5095 */     GIR_RootConstrainSelectedInstOperands,
     /*   5096 */     // GIR_Coverage, 171,
     /*   5096 */     GIR_EraseRootFromParent_Done,
     /*   5097 */   // Label 132: @5097
     /*   5097 */   GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(5173), // Rule ID 172 //
     /*   5102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV6),
     /*   5105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5141 */     // (add:{ *:[i32] } (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm), GPRnopc:{ *:[i32] }:$Ra)  =>  (MLAv5:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLAv5),
     /*   5144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5159 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5165 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5171 */     GIR_RootConstrainSelectedInstOperands,
     /*   5172 */     // GIR_Coverage, 172,
     /*   5172 */     GIR_EraseRootFromParent_Done,
     /*   5173 */   // Label 133: @5173
     /*   5173 */   GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(5243), // Rule ID 503 //
     /*   5178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_UseMulOps),
     /*   5181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5217 */     // (add:{ *:[i32] } (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm), rGPR:{ *:[i32] }:$Ra)  =>  (t2MLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   5217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MLA),
     /*   5220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5235 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5241 */     GIR_RootConstrainSelectedInstOperands,
     /*   5242 */     // GIR_Coverage, 503,
     /*   5242 */     GIR_EraseRootFromParent_Done,
     /*   5243 */   // Label 134: @5243
     /*   5243 */   GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(5314), // Rule ID 5672 //
     /*   5248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   5251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5272 */     // MIs[1] Operand 2
     /*   5272 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   5283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5289 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i8:{ *:[Other] }), GPR:{ *:[i32] }:$Rn)  =>  (SXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAB),
     /*   5292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5306 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5312 */     GIR_RootConstrainSelectedInstOperands,
     /*   5313 */     // GIR_Coverage, 5672,
     /*   5313 */     GIR_EraseRootFromParent_Done,
     /*   5314 */   // Label 135: @5314
     /*   5314 */   GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(5385), // Rule ID 5673 //
     /*   5319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   5322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5343 */     // MIs[1] Operand 2
     /*   5343 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   5354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5360 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] }), GPR:{ *:[i32] }:$Rn)  =>  (SXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAH),
     /*   5363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5377 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5383 */     GIR_RootConstrainSelectedInstOperands,
     /*   5384 */     // GIR_Coverage, 5673,
     /*   5384 */     GIR_EraseRootFromParent_Done,
     /*   5385 */   // Label 136: @5385
     /*   5385 */   GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(5456), // Rule ID 5707 //
     /*   5390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   5393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5414 */     // MIs[1] Operand 2
     /*   5414 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   5425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5431 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i8:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAB),
     /*   5434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5448 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5454 */     GIR_RootConstrainSelectedInstOperands,
     /*   5455 */     // GIR_Coverage, 5707,
     /*   5455 */     GIR_EraseRootFromParent_Done,
     /*   5456 */   // Label 137: @5456
     /*   5456 */   GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(5527), // Rule ID 5708 //
     /*   5461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   5464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5485 */     // MIs[1] Operand 2
     /*   5485 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   5496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5502 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   5505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5519 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5525 */     GIR_RootConstrainSelectedInstOperands,
     /*   5526 */     // GIR_Coverage, 5708,
     /*   5526 */     GIR_EraseRootFromParent_Done,
     /*   5527 */   // Label 138: @5527
     /*   5527 */   GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(5597), // Rule ID 180 //
     /*   5532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   5535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   5547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5571 */     // (add:{ *:[i32] } (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm), GPR:{ *:[i32] }:$Ra)  =>  (SMMLA:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   5571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMMLA),
     /*   5574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5595 */     GIR_RootConstrainSelectedInstOperands,
     /*   5596 */     // GIR_Coverage, 180,
     /*   5596 */     GIR_EraseRootFromParent_Done,
     /*   5597 */   // Label 139: @5597
     /*   5597 */   GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(5667), // Rule ID 509 //
     /*   5602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   5605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   5617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5641 */     // (add:{ *:[i32] } (mulhs:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMMLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   5641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMMLA),
     /*   5644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   5650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5659 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5665 */     GIR_RootConstrainSelectedInstOperands,
     /*   5666 */     // GIR_Coverage, 509,
     /*   5666 */     GIR_EraseRootFromParent_Done,
     /*   5667 */   // Label 140: @5667
     /*   5667 */   GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(5730), // Rule ID 3053 //
     /*   5672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   5675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   5687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   5691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   5696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5702 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } MQPR:{ *:[v16i8] }:$vec), tGPREven:{ *:[i32] }:$acc)  =>  (MVE_VADDVu8acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v16i8] }:$vec)
     /*   5702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu8acc),
     /*   5705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   5707 */     GIR_RootToRootCopy, /*OpIdx*/2, // acc
     /*   5709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   5713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5716 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5728 */     GIR_RootConstrainSelectedInstOperands,
     /*   5729 */     // GIR_Coverage, 3053,
     /*   5729 */     GIR_EraseRootFromParent_Done,
     /*   5730 */   // Label 141: @5730
     /*   5730 */   GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(5793), // Rule ID 3081 //
     /*   5735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   5738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   5750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   5754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   5759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5765 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } MQPR:{ *:[v8i16] }:$vec), tGPREven:{ *:[i32] }:$acc)  =>  (MVE_VADDVu16acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v8i16] }:$vec)
     /*   5765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu16acc),
     /*   5768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   5770 */     GIR_RootToRootCopy, /*OpIdx*/2, // acc
     /*   5772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   5776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5779 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5791 */     GIR_RootConstrainSelectedInstOperands,
     /*   5792 */     // GIR_Coverage, 3081,
     /*   5792 */     GIR_EraseRootFromParent_Done,
     /*   5793 */   // Label 142: @5793
     /*   5793 */   GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(5856), // Rule ID 3091 //
     /*   5798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   5801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   5813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   5822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5828 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } MQPR:{ *:[v4i32] }:$vec), tGPREven:{ *:[i32] }:$acc)  =>  (MVE_VADDVu32acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v4i32] }:$vec)
     /*   5828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu32acc),
     /*   5831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   5833 */     GIR_RootToRootCopy, /*OpIdx*/2, // acc
     /*   5835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   5839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5842 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5854 */     GIR_RootConstrainSelectedInstOperands,
     /*   5855 */     // GIR_Coverage, 3091,
     /*   5855 */     GIR_EraseRootFromParent_Done,
     /*   5856 */   // Label 143: @5856
     /*   5856 */   GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(5932), // Rule ID 5443 //
     /*   5861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   5864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5900 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Ra, (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm))  =>  (MLA:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLA),
     /*   5903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   5915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5918 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5930 */     GIR_RootConstrainSelectedInstOperands,
     /*   5931 */     // GIR_Coverage, 5443,
     /*   5931 */     GIR_EraseRootFromParent_Done,
     /*   5932 */   // Label 144: @5932
     /*   5932 */   GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(6008), // Rule ID 5444 //
     /*   5937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV6),
     /*   5940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5976 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Ra, (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm))  =>  (MLAv5:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLAv5),
     /*   5979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5989 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   5991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5994 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6000 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6006 */     GIR_RootConstrainSelectedInstOperands,
     /*   6007 */     // GIR_Coverage, 5444,
     /*   6007 */     GIR_EraseRootFromParent_Done,
     /*   6008 */   // Label 145: @6008
     /*   6008 */   GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(6078), // Rule ID 5481 //
     /*   6013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_UseMulOps),
     /*   6016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   6040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6052 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm))  =>  (t2MLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   6052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MLA),
     /*   6055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   6061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   6065 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6070 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6076 */     GIR_RootConstrainSelectedInstOperands,
     /*   6077 */     // GIR_Coverage, 5481,
     /*   6077 */     GIR_EraseRootFromParent_Done,
     /*   6078 */   // Label 146: @6078
     /*   6078 */   GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(6149), // Rule ID 2004 //
     /*   6083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   6086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6111 */     // MIs[1] Operand 2
     /*   6111 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   6122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6124 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i8:{ *:[Other] }))  =>  (SXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAB),
     /*   6127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6141 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6147 */     GIR_RootConstrainSelectedInstOperands,
     /*   6148 */     // GIR_Coverage, 2004,
     /*   6148 */     GIR_EraseRootFromParent_Done,
     /*   6149 */   // Label 147: @6149
     /*   6149 */   GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(6220), // Rule ID 2005 //
     /*   6154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   6157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6182 */     // MIs[1] Operand 2
     /*   6182 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   6193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6195 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (SXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAH),
     /*   6198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6200 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6212 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6218 */     GIR_RootConstrainSelectedInstOperands,
     /*   6219 */     // GIR_Coverage, 2005,
     /*   6219 */     GIR_EraseRootFromParent_Done,
     /*   6220 */   // Label 148: @6220
     /*   6220 */   GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(6291), // Rule ID 2243 //
     /*   6225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   6228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6253 */     // MIs[1] Operand 2
     /*   6253 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   6264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6266 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i8:{ *:[Other] }))  =>  (t2SXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAB),
     /*   6269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6271 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6283 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6289 */     GIR_RootConstrainSelectedInstOperands,
     /*   6290 */     // GIR_Coverage, 2243,
     /*   6290 */     GIR_EraseRootFromParent_Done,
     /*   6291 */   // Label 149: @6291
     /*   6291 */   GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(6362), // Rule ID 2244 //
     /*   6296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   6299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6324 */     // MIs[1] Operand 2
     /*   6324 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   6335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6337 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   6340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6342 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6354 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6360 */     GIR_RootConstrainSelectedInstOperands,
     /*   6361 */     // GIR_Coverage, 2244,
     /*   6361 */     GIR_EraseRootFromParent_Done,
     /*   6362 */   // Label 150: @6362
     /*   6362 */   GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(6432), // Rule ID 5445 //
     /*   6367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   6370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   6386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   6394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6406 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm))  =>  (SMMLA:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   6406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMMLA),
     /*   6409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   6415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   6419 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6424 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6430 */     GIR_RootConstrainSelectedInstOperands,
     /*   6431 */     // GIR_Coverage, 5445,
     /*   6431 */     GIR_EraseRootFromParent_Done,
     /*   6432 */   // Label 151: @6432
     /*   6432 */   GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(6502), // Rule ID 5482 //
     /*   6437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   6440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   6456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   6464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6476 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mulhs:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn))  =>  (t2SMMLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   6476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMMLA),
     /*   6479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   6485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6494 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6500 */     GIR_RootConstrainSelectedInstOperands,
     /*   6501 */     // GIR_Coverage, 5482,
     /*   6501 */     GIR_EraseRootFromParent_Done,
     /*   6502 */   // Label 152: @6502
     /*   6502 */   GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(6565), // Rule ID 5926 //
     /*   6507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   6510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   6526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   6530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   6535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6537 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$acc, (vecreduce_add:{ *:[i32] } MQPR:{ *:[v16i8] }:$vec))  =>  (MVE_VADDVu8acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v16i8] }:$vec)
     /*   6537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu8acc),
     /*   6540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   6542 */     GIR_RootToRootCopy, /*OpIdx*/1, // acc
     /*   6544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   6548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6557 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6563 */     GIR_RootConstrainSelectedInstOperands,
     /*   6564 */     // GIR_Coverage, 5926,
     /*   6564 */     GIR_EraseRootFromParent_Done,
     /*   6565 */   // Label 153: @6565
     /*   6565 */   GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(6628), // Rule ID 5940 //
     /*   6570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   6573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   6589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   6593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   6598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6600 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$acc, (vecreduce_add:{ *:[i32] } MQPR:{ *:[v8i16] }:$vec))  =>  (MVE_VADDVu16acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v8i16] }:$vec)
     /*   6600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu16acc),
     /*   6603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   6605 */     GIR_RootToRootCopy, /*OpIdx*/1, // acc
     /*   6607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   6611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6614 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6620 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6626 */     GIR_RootConstrainSelectedInstOperands,
     /*   6627 */     // GIR_Coverage, 5940,
     /*   6627 */     GIR_EraseRootFromParent_Done,
     /*   6628 */   // Label 154: @6628
     /*   6628 */   GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(6691), // Rule ID 5945 //
     /*   6633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   6636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   6652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   6661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6663 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$acc, (vecreduce_add:{ *:[i32] } MQPR:{ *:[v4i32] }:$vec))  =>  (MVE_VADDVu32acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v4i32] }:$vec)
     /*   6663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu32acc),
     /*   6666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   6668 */     GIR_RootToRootCopy, /*OpIdx*/1, // acc
     /*   6670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   6674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6677 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6683 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6689 */     GIR_RootConstrainSelectedInstOperands,
     /*   6690 */     // GIR_Coverage, 5945,
     /*   6690 */     GIR_EraseRootFromParent_Done,
     /*   6691 */   // Label 155: @6691
     /*   6691 */   GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(6737), // Rule ID 73 //
     /*   6696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*   6699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6711 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (ADDrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*   6711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ADDrr),
     /*   6714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6716 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*   6720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6723 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6729 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6735 */     GIR_RootConstrainSelectedInstOperands,
     /*   6736 */     // GIR_Coverage, 73,
     /*   6736 */     GIR_EraseRootFromParent_Done,
     /*   6737 */   // Label 156: @6737
     /*   6737 */   GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(6783), // Rule ID 305 //
     /*   6742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*   6745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   6749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   6753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   6757 */     // (add:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tADDrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*   6757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tADDrr),
     /*   6760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6762 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*   6768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*   6772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6775 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6781 */     GIR_RootConstrainSelectedInstOperands,
     /*   6782 */     // GIR_Coverage, 305,
     /*   6782 */     GIR_EraseRootFromParent_Done,
     /*   6783 */   // Label 157: @6783
     /*   6783 */   GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(6829), // Rule ID 409 //
     /*   6788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   6791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6803 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ADDrr:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*   6803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDrr),
     /*   6806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6808 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*   6812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6815 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6821 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6827 */     GIR_RootConstrainSelectedInstOperands,
     /*   6828 */     // GIR_Coverage, 409,
     /*   6828 */     GIR_EraseRootFromParent_Done,
     /*   6829 */   // Label 158: @6829
     /*   6829 */   GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(6875), // Rule ID 5463 //
     /*   6834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   6837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6849 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2ADDrr:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*   6849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDrr),
     /*   6852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6856 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*   6858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6867 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6873 */     GIR_RootConstrainSelectedInstOperands,
     /*   6874 */     // GIR_Coverage, 5463,
     /*   6874 */     GIR_EraseRootFromParent_Done,
     /*   6875 */   // Label 159: @6875
     /*   6875 */   GIM_Reject,
     /*   6876 */ // Label 90: @6876
     /*   6876 */ GIM_Reject,
     /*   6877 */ // Label 81: @6877
     /*   6877 */ GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(6923), // Rule ID 762 //
     /*   6882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   6885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   6888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   6891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6899 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6903 */   // (add:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VADDv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /*   6903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv1i64),
     /*   6906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   6908 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   6910 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   6912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6915 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6921 */   GIR_RootConstrainSelectedInstOperands,
     /*   6922 */   // GIR_Coverage, 762,
     /*   6922 */   GIR_EraseRootFromParent_Done,
     /*   6923 */ // Label 160: @6923
     /*   6923 */ GIM_Reject,
     /*   6924 */ // Label 82: @6924
     /*   6924 */ GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(7108),
     /*   6929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   6935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6939 */   GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(7005), // Rule ID 5532 //
     /*   6944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   6947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   6963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6979 */     // (add:{ *:[v2i32] } (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm), DPR:{ *:[v2i32] }:$src1)  =>  (VMLAv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   6979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv2i32),
     /*   6982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   6984 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   6990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   6994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6997 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7003 */     GIR_RootConstrainSelectedInstOperands,
     /*   7004 */     // GIR_Coverage, 5532,
     /*   7004 */     GIR_EraseRootFromParent_Done,
     /*   7005 */   // Label 162: @7005
     /*   7005 */   GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(7071), // Rule ID 889 //
     /*   7010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   7033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7045 */     // (add:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VMLAv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv2i32),
     /*   7048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7050 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   7060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7063 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7069 */     GIR_RootConstrainSelectedInstOperands,
     /*   7070 */     // GIR_Coverage, 889,
     /*   7070 */     GIR_EraseRootFromParent_Done,
     /*   7071 */   // Label 163: @7071
     /*   7071 */   GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(7107), // Rule ID 758 //
     /*   7076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7087 */     // (add:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VADDv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv2i32),
     /*   7090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7092 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   7096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7099 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7105 */     GIR_RootConstrainSelectedInstOperands,
     /*   7106 */     // GIR_Coverage, 758,
     /*   7106 */     GIR_EraseRootFromParent_Done,
     /*   7107 */   // Label 164: @7107
     /*   7107 */   GIM_Reject,
     /*   7108 */ // Label 161: @7108
     /*   7108 */ GIM_Reject,
     /*   7109 */ // Label 83: @7109
     /*   7109 */ GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(7819),
     /*   7114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   7120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7124 */   GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(7192), // Rule ID 782 //
     /*   7129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7168 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7184 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7190 */     GIR_RootConstrainSelectedInstOperands,
     /*   7191 */     // GIR_Coverage, 782,
     /*   7191 */     GIR_EraseRootFromParent_Done,
     /*   7192 */   // Label 166: @7192
     /*   7192 */   GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(7260), // Rule ID 781 //
     /*   7197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7229 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7236 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7252 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7258 */     GIR_RootConstrainSelectedInstOperands,
     /*   7259 */     // GIR_Coverage, 781,
     /*   7259 */     GIR_EraseRootFromParent_Done,
     /*   7260 */   // Label 167: @7260
     /*   7260 */   GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(7328), // Rule ID 770 //
     /*   7265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7297 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7304 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLsv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLsv2i64),
     /*   7307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7320 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7326 */     GIR_RootConstrainSelectedInstOperands,
     /*   7327 */     // GIR_Coverage, 770,
     /*   7327 */     GIR_EraseRootFromParent_Done,
     /*   7328 */   // Label 168: @7328
     /*   7328 */   GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(7396), // Rule ID 780 //
     /*   7333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7372 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7388 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7394 */     GIR_RootConstrainSelectedInstOperands,
     /*   7395 */     // GIR_Coverage, 780,
     /*   7395 */     GIR_EraseRootFromParent_Done,
     /*   7396 */   // Label 169: @7396
     /*   7396 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(7464), // Rule ID 779 //
     /*   7401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7433 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7440 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7462 */     GIR_RootConstrainSelectedInstOperands,
     /*   7463 */     // GIR_Coverage, 779,
     /*   7463 */     GIR_EraseRootFromParent_Done,
     /*   7464 */   // Label 170: @7464
     /*   7464 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(7517), // Rule ID 5511 //
     /*   7469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7495 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$Vn)  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   7502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7509 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7515 */     GIR_RootConstrainSelectedInstOperands,
     /*   7516 */     // GIR_Coverage, 5511,
     /*   7516 */     GIR_EraseRootFromParent_Done,
     /*   7517 */   // Label 171: @7517
     /*   7517 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(7570), // Rule ID 5505 //
     /*   7522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7548 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$Vn)  =>  (VADDWsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv2i64),
     /*   7551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   7555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7562 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7568 */     GIR_RootConstrainSelectedInstOperands,
     /*   7569 */     // GIR_Coverage, 5505,
     /*   7569 */     GIR_EraseRootFromParent_Done,
     /*   7570 */   // Label 172: @7570
     /*   7570 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(7623), // Rule ID 5510 //
     /*   7575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7601 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$Vn)  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   7608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7621 */     GIR_RootConstrainSelectedInstOperands,
     /*   7622 */     // GIR_Coverage, 5510,
     /*   7622 */     GIR_EraseRootFromParent_Done,
     /*   7623 */   // Label 173: @7623
     /*   7623 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(7676), // Rule ID 791 //
     /*   7628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7654 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7659 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7668 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7674 */     GIR_RootConstrainSelectedInstOperands,
     /*   7675 */     // GIR_Coverage, 791,
     /*   7675 */     GIR_EraseRootFromParent_Done,
     /*   7676 */   // Label 174: @7676
     /*   7676 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(7729), // Rule ID 785 //
     /*   7681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7707 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDWsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv2i64),
     /*   7710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7712 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7721 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7727 */     GIR_RootConstrainSelectedInstOperands,
     /*   7728 */     // GIR_Coverage, 785,
     /*   7728 */     GIR_EraseRootFromParent_Done,
     /*   7729 */   // Label 175: @7729
     /*   7729 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(7782), // Rule ID 790 //
     /*   7734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7760 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7774 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7780 */     GIR_RootConstrainSelectedInstOperands,
     /*   7781 */     // GIR_Coverage, 790,
     /*   7781 */     GIR_EraseRootFromParent_Done,
     /*   7782 */   // Label 176: @7782
     /*   7782 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(7818), // Rule ID 763 //
     /*   7787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7798 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VADDv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*   7798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv2i64),
     /*   7801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7803 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   7807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7810 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7816 */     GIR_RootConstrainSelectedInstOperands,
     /*   7817 */     // GIR_Coverage, 763,
     /*   7817 */     GIR_EraseRootFromParent_Done,
     /*   7818 */   // Label 177: @7818
     /*   7818 */   GIM_Reject,
     /*   7819 */ // Label 165: @7819
     /*   7819 */ GIM_Reject,
     /*   7820 */ // Label 84: @7820
     /*   7820 */ GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(8004),
     /*   7825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   7828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*   7831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7835 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(7901), // Rule ID 5531 //
     /*   7840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   7855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*   7859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7875 */     // (add:{ *:[v4i16] } (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm), DPR:{ *:[v4i16] }:$src1)  =>  (VMLAv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   7875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i16),
     /*   7878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7880 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   7890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7893 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7899 */     GIR_RootConstrainSelectedInstOperands,
     /*   7900 */     // GIR_Coverage, 5531,
     /*   7900 */     GIR_EraseRootFromParent_Done,
     /*   7901 */   // Label 179: @7901
     /*   7901 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(7967), // Rule ID 888 //
     /*   7906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   7925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*   7929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7941 */     // (add:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VMLAv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   7941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i16),
     /*   7944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7946 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   7956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7959 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7965 */     GIR_RootConstrainSelectedInstOperands,
     /*   7966 */     // GIR_Coverage, 888,
     /*   7966 */     GIR_EraseRootFromParent_Done,
     /*   7967 */   // Label 180: @7967
     /*   7967 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(8003), // Rule ID 757 //
     /*   7972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7983 */     // (add:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VADDv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   7983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv4i16),
     /*   7986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7988 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   7992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8001 */     GIR_RootConstrainSelectedInstOperands,
     /*   8002 */     // GIR_Coverage, 757,
     /*   8002 */     GIR_EraseRootFromParent_Done,
     /*   8003 */   // Label 181: @8003
     /*   8003 */   GIM_Reject,
     /*   8004 */ // Label 178: @8004
     /*   8004 */ GIM_Reject,
     /*   8005 */ // Label 85: @8005
     /*   8005 */ GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(8960),
     /*   8010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8016 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(8088), // Rule ID 778 //
     /*   8021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8064 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8080 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8086 */     GIR_RootConstrainSelectedInstOperands,
     /*   8087 */     // GIR_Coverage, 778,
     /*   8087 */     GIR_EraseRootFromParent_Done,
     /*   8088 */   // Label 183: @8088
     /*   8088 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(8160), // Rule ID 777 //
     /*   8093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8129 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8134 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8136 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8158 */     GIR_RootConstrainSelectedInstOperands,
     /*   8159 */     // GIR_Coverage, 777,
     /*   8159 */     GIR_EraseRootFromParent_Done,
     /*   8160 */   // Label 184: @8160
     /*   8160 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(8232), // Rule ID 769 //
     /*   8165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8197 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8201 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8206 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8208 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLsv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLsv4i32),
     /*   8211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8230 */     GIR_RootConstrainSelectedInstOperands,
     /*   8231 */     // GIR_Coverage, 769,
     /*   8231 */     GIR_EraseRootFromParent_Done,
     /*   8232 */   // Label 185: @8232
     /*   8232 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(8304), // Rule ID 776 //
     /*   8237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8273 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8280 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8296 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8302 */     GIR_RootConstrainSelectedInstOperands,
     /*   8303 */     // GIR_Coverage, 776,
     /*   8303 */     GIR_EraseRootFromParent_Done,
     /*   8304 */   // Label 186: @8304
     /*   8304 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(8376), // Rule ID 775 //
     /*   8309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8345 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8352 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8368 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8374 */     GIR_RootConstrainSelectedInstOperands,
     /*   8375 */     // GIR_Coverage, 775,
     /*   8375 */     GIR_EraseRootFromParent_Done,
     /*   8376 */   // Label 187: @8376
     /*   8376 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(8446), // Rule ID 5535 //
     /*   8381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8420 */     // (add:{ *:[v4i32] } (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm), QPR:{ *:[v4i32] }:$src1)  =>  (VMLAv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*   8420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i32),
     /*   8423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8425 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   8435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8438 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8444 */     GIR_RootConstrainSelectedInstOperands,
     /*   8445 */     // GIR_Coverage, 5535,
     /*   8445 */     GIR_EraseRootFromParent_Done,
     /*   8446 */   // Label 188: @8446
     /*   8446 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(8503), // Rule ID 5509 //
     /*   8451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8481 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$Vn)  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   8488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8495 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8501 */     GIR_RootConstrainSelectedInstOperands,
     /*   8502 */     // GIR_Coverage, 5509,
     /*   8502 */     GIR_EraseRootFromParent_Done,
     /*   8503 */   // Label 189: @8503
     /*   8503 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(8560), // Rule ID 5504 //
     /*   8508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8538 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$Vn)  =>  (VADDWsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv4i32),
     /*   8541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   8545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8552 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8558 */     GIR_RootConstrainSelectedInstOperands,
     /*   8559 */     // GIR_Coverage, 5504,
     /*   8559 */     GIR_EraseRootFromParent_Done,
     /*   8560 */   // Label 190: @8560
     /*   8560 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(8617), // Rule ID 5508 //
     /*   8565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8595 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$Vn)  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   8602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8609 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8615 */     GIR_RootConstrainSelectedInstOperands,
     /*   8616 */     // GIR_Coverage, 5508,
     /*   8616 */     GIR_EraseRootFromParent_Done,
     /*   8617 */   // Label 191: @8617
     /*   8617 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(8687), // Rule ID 892 //
     /*   8622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8661 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm))  =>  (VMLAv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*   8661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i32),
     /*   8664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8666 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   8676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8679 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8685 */     GIR_RootConstrainSelectedInstOperands,
     /*   8686 */     // GIR_Coverage, 892,
     /*   8686 */     GIR_EraseRootFromParent_Done,
     /*   8687 */   // Label 192: @8687
     /*   8687 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(8744), // Rule ID 789 //
     /*   8692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8722 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8727 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8742 */     GIR_RootConstrainSelectedInstOperands,
     /*   8743 */     // GIR_Coverage, 789,
     /*   8743 */     GIR_EraseRootFromParent_Done,
     /*   8744 */   // Label 193: @8744
     /*   8744 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(8801), // Rule ID 784 //
     /*   8749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8779 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDWsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv4i32),
     /*   8782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8793 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8799 */     GIR_RootConstrainSelectedInstOperands,
     /*   8800 */     // GIR_Coverage, 784,
     /*   8800 */     GIR_EraseRootFromParent_Done,
     /*   8801 */   // Label 194: @8801
     /*   8801 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(8858), // Rule ID 788 //
     /*   8806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8836 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8850 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8856 */     GIR_RootConstrainSelectedInstOperands,
     /*   8857 */     // GIR_Coverage, 788,
     /*   8857 */     GIR_EraseRootFromParent_Done,
     /*   8858 */   // Label 195: @8858
     /*   8858 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(8898), // Rule ID 761 //
     /*   8863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8878 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VADDv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*   8878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv4i32),
     /*   8881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8883 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   8887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8890 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8896 */     GIR_RootConstrainSelectedInstOperands,
     /*   8897 */     // GIR_Coverage, 761,
     /*   8897 */     GIR_EraseRootFromParent_Done,
     /*   8898 */   // Label 196: @8898
     /*   8898 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(8959), // Rule ID 3496 //
     /*   8903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   8906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   8910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   8914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   8918 */     // (add:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VADDi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*   8918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*   8921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDi32),
     /*   8933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*   8935 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*   8937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*   8939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   8942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8948 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   8957 */     GIR_RootConstrainSelectedInstOperands,
     /*   8958 */     // GIR_Coverage, 3496,
     /*   8958 */     GIR_EraseRootFromParent_Done,
     /*   8959 */   // Label 197: @8959
     /*   8959 */   GIM_Reject,
     /*   8960 */ // Label 182: @8960
     /*   8960 */ GIM_Reject,
     /*   8961 */ // Label 86: @8961
     /*   8961 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(9145),
     /*   8966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   8969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*   8972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8976 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(9042), // Rule ID 5530 //
     /*   8981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   8996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*   9000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9016 */     // (add:{ *:[v8i8] } (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm), DPR:{ *:[v8i8] }:$src1)  =>  (VMLAv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i8),
     /*   9019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9021 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   9023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9034 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9040 */     GIR_RootConstrainSelectedInstOperands,
     /*   9041 */     // GIR_Coverage, 5530,
     /*   9041 */     GIR_EraseRootFromParent_Done,
     /*   9042 */   // Label 199: @9042
     /*   9042 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(9108), // Rule ID 887 //
     /*   9047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   9062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*   9070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9082 */     // (add:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm))  =>  (VMLAv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i8),
     /*   9085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9087 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9100 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9106 */     GIR_RootConstrainSelectedInstOperands,
     /*   9107 */     // GIR_Coverage, 887,
     /*   9107 */     GIR_EraseRootFromParent_Done,
     /*   9108 */   // Label 200: @9108
     /*   9108 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(9144), // Rule ID 756 //
     /*   9113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9124 */     // (add:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VADDv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv8i8),
     /*   9127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   9133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9136 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9142 */     GIR_RootConstrainSelectedInstOperands,
     /*   9143 */     // GIR_Coverage, 756,
     /*   9143 */     GIR_EraseRootFromParent_Done,
     /*   9144 */   // Label 201: @9144
     /*   9144 */   GIM_Reject,
     /*   9145 */ // Label 198: @9145
     /*   9145 */ GIM_Reject,
     /*   9146 */ // Label 87: @9146
     /*   9146 */ GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(10101),
     /*   9151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9157 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(9229), // Rule ID 774 //
     /*   9162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9194 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9198 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9205 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9227 */     GIR_RootConstrainSelectedInstOperands,
     /*   9228 */     // GIR_Coverage, 774,
     /*   9228 */     GIR_EraseRootFromParent_Done,
     /*   9229 */   // Label 203: @9229
     /*   9229 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(9301), // Rule ID 773 //
     /*   9234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9270 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9275 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9277 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9293 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9299 */     GIR_RootConstrainSelectedInstOperands,
     /*   9300 */     // GIR_Coverage, 773,
     /*   9300 */     GIR_EraseRootFromParent_Done,
     /*   9301 */   // Label 204: @9301
     /*   9301 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(9373), // Rule ID 768 //
     /*   9306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9349 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLsv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLsv8i16),
     /*   9352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9365 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9371 */     GIR_RootConstrainSelectedInstOperands,
     /*   9372 */     // GIR_Coverage, 768,
     /*   9372 */     GIR_EraseRootFromParent_Done,
     /*   9373 */   // Label 205: @9373
     /*   9373 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(9445), // Rule ID 772 //
     /*   9378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9414 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9419 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9421 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9437 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9443 */     GIR_RootConstrainSelectedInstOperands,
     /*   9444 */     // GIR_Coverage, 772,
     /*   9444 */     GIR_EraseRootFromParent_Done,
     /*   9445 */   // Label 206: @9445
     /*   9445 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(9517), // Rule ID 771 //
     /*   9450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9482 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9486 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9493 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9509 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9515 */     GIR_RootConstrainSelectedInstOperands,
     /*   9516 */     // GIR_Coverage, 771,
     /*   9516 */     GIR_EraseRootFromParent_Done,
     /*   9517 */   // Label 207: @9517
     /*   9517 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(9587), // Rule ID 5534 //
     /*   9522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   9537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9561 */     // (add:{ *:[v8i16] } (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm), QPR:{ *:[v8i16] }:$src1)  =>  (VMLAv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*   9561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i16),
     /*   9564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9566 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   9568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9579 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9585 */     GIR_RootConstrainSelectedInstOperands,
     /*   9586 */     // GIR_Coverage, 5534,
     /*   9586 */     GIR_EraseRootFromParent_Done,
     /*   9587 */   // Label 208: @9587
     /*   9587 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(9644), // Rule ID 5507 //
     /*   9592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9622 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm), QPR:{ *:[v8i16] }:$Vn)  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   9629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9636 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9642 */     GIR_RootConstrainSelectedInstOperands,
     /*   9643 */     // GIR_Coverage, 5507,
     /*   9643 */     GIR_EraseRootFromParent_Done,
     /*   9644 */   // Label 209: @9644
     /*   9644 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(9701), // Rule ID 5503 //
     /*   9649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9679 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm), QPR:{ *:[v8i16] }:$Vn)  =>  (VADDWsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv8i16),
     /*   9682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   9686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9693 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9699 */     GIR_RootConstrainSelectedInstOperands,
     /*   9700 */     // GIR_Coverage, 5503,
     /*   9700 */     GIR_EraseRootFromParent_Done,
     /*   9701 */   // Label 210: @9701
     /*   9701 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(9758), // Rule ID 5506 //
     /*   9706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9736 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm), QPR:{ *:[v8i16] }:$Vn)  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   9743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9750 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9756 */     GIR_RootConstrainSelectedInstOperands,
     /*   9757 */     // GIR_Coverage, 5506,
     /*   9757 */     GIR_EraseRootFromParent_Done,
     /*   9758 */   // Label 211: @9758
     /*   9758 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(9828), // Rule ID 891 //
     /*   9763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   9782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9802 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm))  =>  (VMLAv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*   9802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i16),
     /*   9805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9807 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9820 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9826 */     GIR_RootConstrainSelectedInstOperands,
     /*   9827 */     // GIR_Coverage, 891,
     /*   9827 */     GIR_EraseRootFromParent_Done,
     /*   9828 */   // Label 212: @9828
     /*   9828 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(9885), // Rule ID 787 //
     /*   9833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9863 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9868 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9877 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9883 */     GIR_RootConstrainSelectedInstOperands,
     /*   9884 */     // GIR_Coverage, 787,
     /*   9884 */     GIR_EraseRootFromParent_Done,
     /*   9885 */   // Label 213: @9885
     /*   9885 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(9942), // Rule ID 783 //
     /*   9890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9913 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9920 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDWsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv8i16),
     /*   9923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9940 */     GIR_RootConstrainSelectedInstOperands,
     /*   9941 */     // GIR_Coverage, 783,
     /*   9941 */     GIR_EraseRootFromParent_Done,
     /*   9942 */   // Label 214: @9942
     /*   9942 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(9999), // Rule ID 786 //
     /*   9947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9977 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9982 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9991 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9997 */     GIR_RootConstrainSelectedInstOperands,
     /*   9998 */     // GIR_Coverage, 786,
     /*   9998 */     GIR_EraseRootFromParent_Done,
     /*   9999 */   // Label 215: @9999
     /*   9999 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(10039), // Rule ID 760 //
     /*  10004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10019 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VADDv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  10019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv8i16),
     /*  10022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10024 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  10026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  10028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10031 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10037 */     GIR_RootConstrainSelectedInstOperands,
     /*  10038 */     // GIR_Coverage, 760,
     /*  10038 */     GIR_EraseRootFromParent_Done,
     /*  10039 */   // Label 216: @10039
     /*  10039 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(10100), // Rule ID 3492 //
     /*  10044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  10047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10059 */     // (add:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VADDi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  10059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDi16),
     /*  10074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  10076 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  10078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  10080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  10083 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10089 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  10098 */     GIR_RootConstrainSelectedInstOperands,
     /*  10099 */     // GIR_Coverage, 3492,
     /*  10099 */     GIR_EraseRootFromParent_Done,
     /*  10100 */   // Label 217: @10100
     /*  10100 */   GIM_Reject,
     /*  10101 */ // Label 202: @10101
     /*  10101 */ GIM_Reject,
     /*  10102 */ // Label 88: @10102
     /*  10102 */ GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(10355),
     /*  10107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10113 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(10183), // Rule ID 5533 //
     /*  10118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10157 */     // (add:{ *:[v16i8] } (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm), QPR:{ *:[v16i8] }:$src1)  =>  (VMLAv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  10157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv16i8),
     /*  10160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10162 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  10164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  10168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  10172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10175 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10181 */     GIR_RootConstrainSelectedInstOperands,
     /*  10182 */     // GIR_Coverage, 5533,
     /*  10182 */     GIR_EraseRootFromParent_Done,
     /*  10183 */   // Label 219: @10183
     /*  10183 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(10253), // Rule ID 890 //
     /*  10188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10227 */     // (add:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm))  =>  (VMLAv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  10227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv16i8),
     /*  10230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10232 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  10238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  10242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10245 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10251 */     GIR_RootConstrainSelectedInstOperands,
     /*  10252 */     // GIR_Coverage, 890,
     /*  10252 */     GIR_EraseRootFromParent_Done,
     /*  10253 */   // Label 220: @10253
     /*  10253 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(10293), // Rule ID 759 //
     /*  10258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10273 */     // (add:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VADDv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  10273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv16i8),
     /*  10276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  10280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  10282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10285 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10291 */     GIR_RootConstrainSelectedInstOperands,
     /*  10292 */     // GIR_Coverage, 759,
     /*  10292 */     GIR_EraseRootFromParent_Done,
     /*  10293 */   // Label 221: @10293
     /*  10293 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(10354), // Rule ID 3488 //
     /*  10298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  10301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10313 */     // (add:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VADDi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  10313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDi8),
     /*  10328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  10330 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  10332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  10334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  10337 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10343 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  10352 */     GIR_RootConstrainSelectedInstOperands,
     /*  10353 */     // GIR_Coverage, 3488,
     /*  10353 */     GIR_EraseRootFromParent_Done,
     /*  10354 */   // Label 222: @10354
     /*  10354 */   GIM_Reject,
     /*  10355 */ // Label 218: @10355
     /*  10355 */ GIM_Reject,
     /*  10356 */ // Label 89: @10356
     /*  10356 */ GIM_Reject,
     /*  10357 */ // Label 1: @10357
     /*  10357 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 232*/ GIMT_Encode4(13600),
     /*  10368 */ /*GILLT_s32*//*Label 223*/ GIMT_Encode4(10428),
     /*  10372 */ /*GILLT_s64*//*Label 224*/ GIMT_Encode4(11042), GIMT_Encode4(0),
     /*  10380 */ /*GILLT_v2s32*//*Label 225*/ GIMT_Encode4(11089),
     /*  10384 */ /*GILLT_v2s64*//*Label 226*/ GIMT_Encode4(11204), GIMT_Encode4(0),
     /*  10392 */ /*GILLT_v4s16*//*Label 227*/ GIMT_Encode4(11756),
     /*  10396 */ /*GILLT_v4s32*//*Label 228*/ GIMT_Encode4(11871), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  10408 */ /*GILLT_v8s8*//*Label 229*/ GIMT_Encode4(12586),
     /*  10412 */ /*GILLT_v8s16*//*Label 230*/ GIMT_Encode4(12701), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  10424 */ /*GILLT_v16s8*//*Label 231*/ GIMT_Encode4(13416),
     /*  10428 */ // Label 223: @10428
     /*  10428 */ GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(11041),
     /*  10433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  10436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  10439 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(10483), // Rule ID 330 //
     /*  10444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  10447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10451 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  10455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10459 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, tGPR:{ *:[i32] }:$Rn)  =>  (tRSB:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)
     /*  10459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tRSB),
     /*  10462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  10470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10475 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10481 */     GIR_RootConstrainSelectedInstOperands,
     /*  10482 */     // GIR_Coverage, 330,
     /*  10482 */     GIR_EraseRootFromParent_Done,
     /*  10483 */   // Label 234: @10483
     /*  10483 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(10540), // Rule ID 96 //
     /*  10488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  10491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  10507 */     // MIs[1] Operand 1
     /*  10507 */     // No operand predicates
     /*  10507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10513 */     // (sub:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm, GPR:{ *:[i32] }:$Rn)  =>  (RSBri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::RSBri),
     /*  10516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10520 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10526 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10532 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10538 */     GIR_RootConstrainSelectedInstOperands,
     /*  10539 */     // GIR_Coverage, 96,
     /*  10539 */     GIR_EraseRootFromParent_Done,
     /*  10540 */   // Label 235: @10540
     /*  10540 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(10597), // Rule ID 427 //
     /*  10545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  10548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10560 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  10564 */     // MIs[1] Operand 1
     /*  10564 */     // No operand predicates
     /*  10564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10570 */     // (sub:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, rGPR:{ *:[i32] }:$Rn)  =>  (t2RSBri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RSBri),
     /*  10573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10583 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10595 */     GIR_RootConstrainSelectedInstOperands,
     /*  10596 */     // GIR_Coverage, 427,
     /*  10596 */     GIR_EraseRootFromParent_Done,
     /*  10597 */   // Label 236: @10597
     /*  10597 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(10654), // Rule ID 76 //
     /*  10602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  10605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  10625 */     // MIs[1] Operand 1
     /*  10625 */     // No operand predicates
     /*  10625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10627 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (SUBri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SUBri),
     /*  10630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10640 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10646 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10652 */     GIR_RootConstrainSelectedInstOperands,
     /*  10653 */     // GIR_Coverage, 76,
     /*  10653 */     GIR_EraseRootFromParent_Done,
     /*  10654 */   // Label 237: @10654
     /*  10654 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(10711), // Rule ID 411 //
     /*  10659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  10662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  10670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10678 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  10682 */     // MIs[1] Operand 1
     /*  10682 */     // No operand predicates
     /*  10682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10684 */     // (sub:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2SUBri:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SUBri),
     /*  10687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10697 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10703 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10709 */     GIR_RootConstrainSelectedInstOperands,
     /*  10710 */     // GIR_Coverage, 411,
     /*  10710 */     GIR_EraseRootFromParent_Done,
     /*  10711 */   // Label 238: @10711
     /*  10711 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(10762), // Rule ID 412 //
     /*  10716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  10719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_4095),
     /*  10739 */     // MIs[1] Operand 1
     /*  10739 */     // No operand predicates
     /*  10739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10741 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_imm0_4095>>:$imm)  =>  (t2SUBri12:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SUBri12),
     /*  10744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10746 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10754 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10760 */     GIR_RootConstrainSelectedInstOperands,
     /*  10761 */     // GIR_Coverage, 412,
     /*  10761 */     GIR_EraseRootFromParent_Done,
     /*  10762 */   // Label 239: @10762
     /*  10762 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(10832), // Rule ID 173 //
     /*  10767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM_UseMulOps),
     /*  10770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  10790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  10794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10806 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm))  =>  (MLS:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*  10806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLS),
     /*  10809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  10815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  10819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  10821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10824 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10830 */     GIR_RootConstrainSelectedInstOperands,
     /*  10831 */     // GIR_Coverage, 173,
     /*  10831 */     GIR_EraseRootFromParent_Done,
     /*  10832 */   // Label 240: @10832
     /*  10832 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(10902), // Rule ID 504 //
     /*  10837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_UseMulOps),
     /*  10840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  10860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  10864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10876 */     // (sub:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm))  =>  (t2MLS:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  10876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MLS),
     /*  10879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  10885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  10889 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  10891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10894 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10900 */     GIR_RootConstrainSelectedInstOperands,
     /*  10901 */     // GIR_Coverage, 504,
     /*  10901 */     GIR_EraseRootFromParent_Done,
     /*  10902 */   // Label 241: @10902
     /*  10902 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(10948), // Rule ID 77 //
     /*  10907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  10910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10922 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SUBrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  10922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SUBrr),
     /*  10925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10927 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  10931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10940 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10946 */     GIR_RootConstrainSelectedInstOperands,
     /*  10947 */     // GIR_Coverage, 77,
     /*  10947 */     GIR_EraseRootFromParent_Done,
     /*  10948 */   // Label 242: @10948
     /*  10948 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(10994), // Rule ID 333 //
     /*  10953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  10956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10968 */     // (sub:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tSUBrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  10968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tSUBrr),
     /*  10971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10973 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  10979 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  10983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10986 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10992 */     GIR_RootConstrainSelectedInstOperands,
     /*  10993 */     // GIR_Coverage, 333,
     /*  10993 */     GIR_EraseRootFromParent_Done,
     /*  10994 */   // Label 243: @10994
     /*  10994 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(11040), // Rule ID 413 //
     /*  10999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  11002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  11006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  11010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  11014 */     // (sub:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SUBrr:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  11014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SUBrr),
     /*  11017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  11019 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  11021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  11023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11026 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11032 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11038 */     GIR_RootConstrainSelectedInstOperands,
     /*  11039 */     // GIR_Coverage, 413,
     /*  11039 */     GIR_EraseRootFromParent_Done,
     /*  11040 */   // Label 244: @11040
     /*  11040 */   GIM_Reject,
     /*  11041 */ // Label 233: @11041
     /*  11041 */ GIM_Reject,
     /*  11042 */ // Label 224: @11042
     /*  11042 */ GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(11088), // Rule ID 966 //
     /*  11047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  11053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  11056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11064 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11068 */   // (sub:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VSUBv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /*  11068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv1i64),
     /*  11071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11073 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11075 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11080 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11086 */   GIR_RootConstrainSelectedInstOperands,
     /*  11087 */   // GIR_Coverage, 966,
     /*  11087 */   GIR_EraseRootFromParent_Done,
     /*  11088 */ // Label 245: @11088
     /*  11088 */ GIM_Reject,
     /*  11089 */ // Label 225: @11089
     /*  11089 */ GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(11203),
     /*  11094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11097 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11108 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(11170), // Rule ID 917 //
     /*  11113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  11124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11144 */     // (sub:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VMLSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv2i32),
     /*  11147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11149 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  11159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11162 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11168 */     GIR_RootConstrainSelectedInstOperands,
     /*  11169 */     // GIR_Coverage, 917,
     /*  11169 */     GIR_EraseRootFromParent_Done,
     /*  11170 */   // Label 247: @11170
     /*  11170 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(11202), // Rule ID 962 //
     /*  11175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11182 */     // (sub:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VSUBv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv2i32),
     /*  11185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11187 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11194 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11200 */     GIR_RootConstrainSelectedInstOperands,
     /*  11201 */     // GIR_Coverage, 962,
     /*  11201 */     GIR_EraseRootFromParent_Done,
     /*  11202 */   // Label 248: @11202
     /*  11202 */   GIM_Reject,
     /*  11203 */ // Label 246: @11203
     /*  11203 */ GIM_Reject,
     /*  11204 */ // Label 226: @11204
     /*  11204 */ GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(11755),
     /*  11209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  11212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  11215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11219 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(11287), // Rule ID 986 //
     /*  11224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11256 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11263 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11279 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11285 */     GIR_RootConstrainSelectedInstOperands,
     /*  11286 */     // GIR_Coverage, 986,
     /*  11286 */     GIR_EraseRootFromParent_Done,
     /*  11287 */   // Label 250: @11287
     /*  11287 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(11355), // Rule ID 985 //
     /*  11292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11324 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11331 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11347 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11353 */     GIR_RootConstrainSelectedInstOperands,
     /*  11354 */     // GIR_Coverage, 985,
     /*  11354 */     GIR_EraseRootFromParent_Done,
     /*  11355 */   // Label 251: @11355
     /*  11355 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(11423), // Rule ID 974 //
     /*  11360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11392 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11399 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLsv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLsv2i64),
     /*  11402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11415 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11421 */     GIR_RootConstrainSelectedInstOperands,
     /*  11422 */     // GIR_Coverage, 974,
     /*  11422 */     GIR_EraseRootFromParent_Done,
     /*  11423 */   // Label 252: @11423
     /*  11423 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(11491), // Rule ID 984 //
     /*  11428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11456 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11460 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11467 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11483 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11489 */     GIR_RootConstrainSelectedInstOperands,
     /*  11490 */     // GIR_Coverage, 984,
     /*  11490 */     GIR_EraseRootFromParent_Done,
     /*  11491 */   // Label 253: @11491
     /*  11491 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(11559), // Rule ID 983 //
     /*  11496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11528 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11533 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11535 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11557 */     GIR_RootConstrainSelectedInstOperands,
     /*  11558 */     // GIR_Coverage, 983,
     /*  11558 */     GIR_EraseRootFromParent_Done,
     /*  11559 */   // Label 254: @11559
     /*  11559 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(11612), // Rule ID 995 //
     /*  11564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11590 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv2i64),
     /*  11593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11595 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  11601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11604 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11610 */     GIR_RootConstrainSelectedInstOperands,
     /*  11611 */     // GIR_Coverage, 995,
     /*  11611 */     GIR_EraseRootFromParent_Done,
     /*  11612 */   // Label 255: @11612
     /*  11612 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(11665), // Rule ID 989 //
     /*  11617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11643 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBWsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWsv2i64),
     /*  11646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11648 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  11654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11663 */     GIR_RootConstrainSelectedInstOperands,
     /*  11664 */     // GIR_Coverage, 989,
     /*  11664 */     GIR_EraseRootFromParent_Done,
     /*  11665 */   // Label 256: @11665
     /*  11665 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(11718), // Rule ID 994 //
     /*  11670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11696 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv2i64),
     /*  11699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  11707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11710 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11716 */     GIR_RootConstrainSelectedInstOperands,
     /*  11717 */     // GIR_Coverage, 994,
     /*  11717 */     GIR_EraseRootFromParent_Done,
     /*  11718 */   // Label 257: @11718
     /*  11718 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(11754), // Rule ID 967 //
     /*  11723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11734 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VSUBv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*  11734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv2i64),
     /*  11737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11739 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11752 */     GIR_RootConstrainSelectedInstOperands,
     /*  11753 */     // GIR_Coverage, 967,
     /*  11753 */     GIR_EraseRootFromParent_Done,
     /*  11754 */   // Label 258: @11754
     /*  11754 */   GIM_Reject,
     /*  11755 */ // Label 249: @11755
     /*  11755 */ GIM_Reject,
     /*  11756 */ // Label 227: @11756
     /*  11756 */ GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(11870),
     /*  11761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  11767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11775 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(11837), // Rule ID 916 //
     /*  11780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  11791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  11799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11811 */     // (sub:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VMLSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  11811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv4i16),
     /*  11814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11816 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  11826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11829 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11835 */     GIR_RootConstrainSelectedInstOperands,
     /*  11836 */     // GIR_Coverage, 916,
     /*  11836 */     GIR_EraseRootFromParent_Done,
     /*  11837 */   // Label 260: @11837
     /*  11837 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(11869), // Rule ID 961 //
     /*  11842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11849 */     // (sub:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VSUBv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  11849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv4i16),
     /*  11852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11854 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11867 */     GIR_RootConstrainSelectedInstOperands,
     /*  11868 */     // GIR_Coverage, 961,
     /*  11868 */     GIR_EraseRootFromParent_Done,
     /*  11869 */   // Label 261: @11869
     /*  11869 */   GIM_Reject,
     /*  11870 */ // Label 259: @11870
     /*  11870 */ GIM_Reject,
     /*  11871 */ // Label 228: @11871
     /*  11871 */ GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(12585),
     /*  11876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11882 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(11954), // Rule ID 982 //
     /*  11887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11930 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  11930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  11933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11946 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11952 */     GIR_RootConstrainSelectedInstOperands,
     /*  11953 */     // GIR_Coverage, 982,
     /*  11953 */     GIR_EraseRootFromParent_Done,
     /*  11954 */   // Label 263: @11954
     /*  11954 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(12026), // Rule ID 981 //
     /*  11959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11995 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12000 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12002 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  12005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12018 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12024 */     GIR_RootConstrainSelectedInstOperands,
     /*  12025 */     // GIR_Coverage, 981,
     /*  12025 */     GIR_EraseRootFromParent_Done,
     /*  12026 */   // Label 264: @12026
     /*  12026 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(12098), // Rule ID 973 //
     /*  12031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12067 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12074 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLsv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLsv4i32),
     /*  12077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12096 */     GIR_RootConstrainSelectedInstOperands,
     /*  12097 */     // GIR_Coverage, 973,
     /*  12097 */     GIR_EraseRootFromParent_Done,
     /*  12098 */   // Label 265: @12098
     /*  12098 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(12170), // Rule ID 980 //
     /*  12103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12139 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12144 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12146 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  12149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12162 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12168 */     GIR_RootConstrainSelectedInstOperands,
     /*  12169 */     // GIR_Coverage, 980,
     /*  12169 */     GIR_EraseRootFromParent_Done,
     /*  12170 */   // Label 266: @12170
     /*  12170 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(12242), // Rule ID 979 //
     /*  12175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12211 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12218 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  12221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12234 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12240 */     GIR_RootConstrainSelectedInstOperands,
     /*  12241 */     // GIR_Coverage, 979,
     /*  12241 */     GIR_EraseRootFromParent_Done,
     /*  12242 */   // Label 267: @12242
     /*  12242 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(12312), // Rule ID 920 //
     /*  12247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  12266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12286 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm))  =>  (VMLSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  12286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv4i32),
     /*  12289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12291 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  12301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12310 */     GIR_RootConstrainSelectedInstOperands,
     /*  12311 */     // GIR_Coverage, 920,
     /*  12311 */     GIR_EraseRootFromParent_Done,
     /*  12312 */   // Label 268: @12312
     /*  12312 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(12369), // Rule ID 993 //
     /*  12317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12347 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv4i32),
     /*  12350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12352 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  12358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12361 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12367 */     GIR_RootConstrainSelectedInstOperands,
     /*  12368 */     // GIR_Coverage, 993,
     /*  12368 */     GIR_EraseRootFromParent_Done,
     /*  12369 */   // Label 269: @12369
     /*  12369 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(12426), // Rule ID 988 //
     /*  12374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12404 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBWsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWsv4i32),
     /*  12407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12409 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  12415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12418 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12424 */     GIR_RootConstrainSelectedInstOperands,
     /*  12425 */     // GIR_Coverage, 988,
     /*  12425 */     GIR_EraseRootFromParent_Done,
     /*  12426 */   // Label 270: @12426
     /*  12426 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(12483), // Rule ID 992 //
     /*  12431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12461 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv4i32),
     /*  12464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  12472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12475 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12481 */     GIR_RootConstrainSelectedInstOperands,
     /*  12482 */     // GIR_Coverage, 992,
     /*  12482 */     GIR_EraseRootFromParent_Done,
     /*  12483 */   // Label 271: @12483
     /*  12483 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(12523), // Rule ID 965 //
     /*  12488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12503 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VSUBv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  12503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv4i32),
     /*  12506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12508 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  12512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12515 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12521 */     GIR_RootConstrainSelectedInstOperands,
     /*  12522 */     // GIR_Coverage, 965,
     /*  12522 */     GIR_EraseRootFromParent_Done,
     /*  12523 */   // Label 272: @12523
     /*  12523 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(12584), // Rule ID 3508 //
     /*  12528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  12531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  12535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  12539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  12543 */     // (sub:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VSUBi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  12543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBi32),
     /*  12558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  12560 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  12562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  12564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  12567 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12573 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  12582 */     GIR_RootConstrainSelectedInstOperands,
     /*  12583 */     // GIR_Coverage, 3508,
     /*  12583 */     GIR_EraseRootFromParent_Done,
     /*  12584 */   // Label 273: @12584
     /*  12584 */   GIM_Reject,
     /*  12585 */ // Label 262: @12585
     /*  12585 */ GIM_Reject,
     /*  12586 */ // Label 229: @12586
     /*  12586 */ GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(12700),
     /*  12591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  12597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12605 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(12667), // Rule ID 915 //
     /*  12610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  12621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  12629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12641 */     // (sub:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm))  =>  (VMLSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv8i8),
     /*  12644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12646 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  12656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12659 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12665 */     GIR_RootConstrainSelectedInstOperands,
     /*  12666 */     // GIR_Coverage, 915,
     /*  12666 */     GIR_EraseRootFromParent_Done,
     /*  12667 */   // Label 275: @12667
     /*  12667 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(12699), // Rule ID 960 //
     /*  12672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12679 */     // (sub:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VSUBv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv8i8),
     /*  12682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12684 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  12688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12691 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12697 */     GIR_RootConstrainSelectedInstOperands,
     /*  12698 */     // GIR_Coverage, 960,
     /*  12698 */     GIR_EraseRootFromParent_Done,
     /*  12699 */   // Label 276: @12699
     /*  12699 */   GIM_Reject,
     /*  12700 */ // Label 274: @12700
     /*  12700 */ GIM_Reject,
     /*  12701 */ // Label 230: @12701
     /*  12701 */ GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(13415),
     /*  12706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  12709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  12712 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(12784), // Rule ID 978 //
     /*  12717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12753 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12760 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  12763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12776 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12782 */     GIR_RootConstrainSelectedInstOperands,
     /*  12783 */     // GIR_Coverage, 978,
     /*  12783 */     GIR_EraseRootFromParent_Done,
     /*  12784 */   // Label 278: @12784
     /*  12784 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(12856), // Rule ID 977 //
     /*  12789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12825 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12830 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12832 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  12835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12854 */     GIR_RootConstrainSelectedInstOperands,
     /*  12855 */     // GIR_Coverage, 977,
     /*  12855 */     GIR_EraseRootFromParent_Done,
     /*  12856 */   // Label 279: @12856
     /*  12856 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(12928), // Rule ID 972 //
     /*  12861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12897 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12904 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLsv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLsv8i16),
     /*  12907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12920 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12926 */     GIR_RootConstrainSelectedInstOperands,
     /*  12927 */     // GIR_Coverage, 972,
     /*  12927 */     GIR_EraseRootFromParent_Done,
     /*  12928 */   // Label 280: @12928
     /*  12928 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(13000), // Rule ID 976 //
     /*  12933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12965 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12976 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  12979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12992 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12998 */     GIR_RootConstrainSelectedInstOperands,
     /*  12999 */     // GIR_Coverage, 976,
     /*  12999 */     GIR_EraseRootFromParent_Done,
     /*  13000 */   // Label 281: @13000
     /*  13000 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(13072), // Rule ID 975 //
     /*  13005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13048 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  13051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  13057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  13061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13064 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13070 */     GIR_RootConstrainSelectedInstOperands,
     /*  13071 */     // GIR_Coverage, 975,
     /*  13071 */     GIR_EraseRootFromParent_Done,
     /*  13072 */   // Label 282: @13072
     /*  13072 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(13142), // Rule ID 919 //
     /*  13077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  13096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  13100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  13104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13116 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm))  =>  (VMLSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  13116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv8i16),
     /*  13119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13121 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  13127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  13131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13134 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13140 */     GIR_RootConstrainSelectedInstOperands,
     /*  13141 */     // GIR_Coverage, 919,
     /*  13141 */     GIR_EraseRootFromParent_Done,
     /*  13142 */   // Label 283: @13142
     /*  13142 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(13199), // Rule ID 991 //
     /*  13147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13177 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv8i16),
     /*  13180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13182 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  13188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13191 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13197 */     GIR_RootConstrainSelectedInstOperands,
     /*  13198 */     // GIR_Coverage, 991,
     /*  13198 */     GIR_EraseRootFromParent_Done,
     /*  13199 */   // Label 284: @13199
     /*  13199 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(13256), // Rule ID 987 //
     /*  13204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13234 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBWsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWsv8i16),
     /*  13237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  13245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13248 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13254 */     GIR_RootConstrainSelectedInstOperands,
     /*  13255 */     // GIR_Coverage, 987,
     /*  13255 */     GIR_EraseRootFromParent_Done,
     /*  13256 */   // Label 285: @13256
     /*  13256 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(13313), // Rule ID 990 //
     /*  13261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13291 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv8i16),
     /*  13294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  13302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13305 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13311 */     GIR_RootConstrainSelectedInstOperands,
     /*  13312 */     // GIR_Coverage, 990,
     /*  13312 */     GIR_EraseRootFromParent_Done,
     /*  13313 */   // Label 286: @13313
     /*  13313 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(13353), // Rule ID 964 //
     /*  13318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13333 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VSUBv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  13333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv8i16),
     /*  13336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13338 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  13342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13345 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13351 */     GIR_RootConstrainSelectedInstOperands,
     /*  13352 */     // GIR_Coverage, 964,
     /*  13352 */     GIR_EraseRootFromParent_Done,
     /*  13353 */   // Label 287: @13353
     /*  13353 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(13414), // Rule ID 3504 //
     /*  13358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  13361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13373 */     // (sub:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VSUBi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  13373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBi16),
     /*  13388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  13390 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  13392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  13394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  13397 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13403 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  13412 */     GIR_RootConstrainSelectedInstOperands,
     /*  13413 */     // GIR_Coverage, 3504,
     /*  13413 */     GIR_EraseRootFromParent_Done,
     /*  13414 */   // Label 288: @13414
     /*  13414 */   GIM_Reject,
     /*  13415 */ // Label 277: @13415
     /*  13415 */ GIM_Reject,
     /*  13416 */ // Label 231: @13416
     /*  13416 */ GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(13599),
     /*  13421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  13424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  13427 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(13497), // Rule ID 918 //
     /*  13432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  13451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  13455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  13459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13471 */     // (sub:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm))  =>  (VMLSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  13471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv16i8),
     /*  13474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13476 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  13482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  13486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13489 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13495 */     GIR_RootConstrainSelectedInstOperands,
     /*  13496 */     // GIR_Coverage, 918,
     /*  13496 */     GIR_EraseRootFromParent_Done,
     /*  13497 */   // Label 290: @13497
     /*  13497 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(13537), // Rule ID 963 //
     /*  13502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13517 */     // (sub:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VSUBv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  13517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv16i8),
     /*  13520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  13526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13529 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13535 */     GIR_RootConstrainSelectedInstOperands,
     /*  13536 */     // GIR_Coverage, 963,
     /*  13536 */     GIR_EraseRootFromParent_Done,
     /*  13537 */   // Label 291: @13537
     /*  13537 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(13598), // Rule ID 3500 //
     /*  13542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  13545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13557 */     // (sub:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VSUBi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  13557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBi8),
     /*  13572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  13574 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  13576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  13578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  13581 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13587 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  13596 */     GIR_RootConstrainSelectedInstOperands,
     /*  13597 */     // GIR_Coverage, 3500,
     /*  13597 */     GIR_EraseRootFromParent_Done,
     /*  13598 */   // Label 292: @13598
     /*  13598 */   GIM_Reject,
     /*  13599 */ // Label 289: @13599
     /*  13599 */ GIM_Reject,
     /*  13600 */ // Label 232: @13600
     /*  13600 */ GIM_Reject,
     /*  13601 */ // Label 2: @13601
     /*  13601 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 300*/ GIMT_Encode4(15304),
     /*  13612 */ /*GILLT_s32*//*Label 293*/ GIMT_Encode4(13672), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13624 */ /*GILLT_v2s32*//*Label 294*/ GIMT_Encode4(14591), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13636 */ /*GILLT_v4s16*//*Label 295*/ GIMT_Encode4(14638),
     /*  13640 */ /*GILLT_v4s32*//*Label 296*/ GIMT_Encode4(14685), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13652 */ /*GILLT_v8s8*//*Label 297*/ GIMT_Encode4(14914),
     /*  13656 */ /*GILLT_v8s16*//*Label 298*/ GIMT_Encode4(14961), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13668 */ /*GILLT_v16s8*//*Label 299*/ GIMT_Encode4(15190),
     /*  13672 */ // Label 293: @13672
     /*  13672 */ GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(14590),
     /*  13677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  13680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  13683 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(13771), // Rule ID 186 //
     /*  13688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  13691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13716 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13732 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  13736 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13741 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  13745 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13747 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (SMULTT:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  13747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTT),
     /*  13750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  13752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13763 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13769 */     GIR_RootConstrainSelectedInstOperands,
     /*  13770 */     // GIR_Coverage, 186,
     /*  13770 */     GIR_EraseRootFromParent_Done,
     /*  13771 */   // Label 302: @13771
     /*  13771 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(13859), // Rule ID 515 //
     /*  13776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  13779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13804 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  13824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13829 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  13833 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13835 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (t2SMULTT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  13835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTT),
     /*  13838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  13840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13851 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13857 */     GIR_RootConstrainSelectedInstOperands,
     /*  13858 */     // GIR_Coverage, 515,
     /*  13858 */     GIR_EraseRootFromParent_Done,
     /*  13859 */   // Label 303: @13859
     /*  13859 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(13950), // Rule ID 185 //
     /*  13864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  13867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13892 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  13904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13913 */     // MIs[2] Operand 2
     /*  13913 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  13924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13926 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (SMULTB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  13926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTB),
     /*  13929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  13931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13948 */     GIR_RootConstrainSelectedInstOperands,
     /*  13949 */     // GIR_Coverage, 185,
     /*  13949 */     GIR_EraseRootFromParent_Done,
     /*  13950 */   // Label 304: @13950
     /*  13950 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(14041), // Rule ID 514 //
     /*  13955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  13958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13983 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  13995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13999 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14004 */     // MIs[2] Operand 2
     /*  14004 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14017 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (t2SMULTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTB),
     /*  14020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14033 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14039 */     GIR_RootConstrainSelectedInstOperands,
     /*  14040 */     // GIR_Coverage, 514,
     /*  14040 */     GIR_EraseRootFromParent_Done,
     /*  14041 */   // Label 305: @14041
     /*  14041 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(14132), // Rule ID 184 //
     /*  14046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  14049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14070 */     // MIs[1] Operand 2
     /*  14070 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  14089 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14093 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  14097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14102 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  14106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14108 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (SMULBT:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  14108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBT),
     /*  14111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14124 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14130 */     GIR_RootConstrainSelectedInstOperands,
     /*  14131 */     // GIR_Coverage, 184,
     /*  14131 */     GIR_EraseRootFromParent_Done,
     /*  14132 */   // Label 306: @14132
     /*  14132 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(14223), // Rule ID 513 //
     /*  14137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  14140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14161 */     // MIs[1] Operand 2
     /*  14161 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  14180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14184 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  14188 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14193 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  14197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14199 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (t2SMULBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBT),
     /*  14202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14215 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14221 */     GIR_RootConstrainSelectedInstOperands,
     /*  14222 */     // GIR_Coverage, 513,
     /*  14222 */     GIR_EraseRootFromParent_Done,
     /*  14223 */   // Label 307: @14223
     /*  14223 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(14317), // Rule ID 183 //
     /*  14228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  14231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14252 */     // MIs[1] Operand 2
     /*  14252 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14275 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14280 */     // MIs[2] Operand 2
     /*  14280 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14291 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14293 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (SMULBB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  14293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBB),
     /*  14296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14309 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14315 */     GIR_RootConstrainSelectedInstOperands,
     /*  14316 */     // GIR_Coverage, 183,
     /*  14316 */     GIR_EraseRootFromParent_Done,
     /*  14317 */   // Label 308: @14317
     /*  14317 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(14411), // Rule ID 512 //
     /*  14322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  14325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14346 */     // MIs[1] Operand 2
     /*  14346 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14369 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14374 */     // MIs[2] Operand 2
     /*  14374 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14385 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14387 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (t2SMULBB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBB),
     /*  14390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14403 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14409 */     GIR_RootConstrainSelectedInstOperands,
     /*  14410 */     // GIR_Coverage, 512,
     /*  14410 */     GIR_EraseRootFromParent_Done,
     /*  14411 */   // Label 309: @14411
     /*  14411 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(14457), // Rule ID 169 //
     /*  14416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  14419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14431 */     // (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (MUL:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  14431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MUL),
     /*  14434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14436 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14443 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14449 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14455 */     GIR_RootConstrainSelectedInstOperands,
     /*  14456 */     // GIR_Coverage, 169,
     /*  14456 */     GIR_EraseRootFromParent_Done,
     /*  14457 */   // Label 310: @14457
     /*  14457 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(14503), // Rule ID 170 //
     /*  14462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV6_UseMulOps),
     /*  14465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14477 */     // (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (MULv5:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  14477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MULv5),
     /*  14480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14489 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14495 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14501 */     GIR_RootConstrainSelectedInstOperands,
     /*  14502 */     // GIR_Coverage, 170,
     /*  14502 */     GIR_EraseRootFromParent_Done,
     /*  14503 */   // Label 311: @14503
     /*  14503 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(14549), // Rule ID 323 //
     /*  14508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  14511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  14515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  14519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  14523 */     // (mul:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tMUL:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  14523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMUL),
     /*  14526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14528 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  14534 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14541 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14547 */     GIR_RootConstrainSelectedInstOperands,
     /*  14548 */     // GIR_Coverage, 323,
     /*  14548 */     GIR_EraseRootFromParent_Done,
     /*  14549 */   // Label 312: @14549
     /*  14549 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(14589), // Rule ID 502 //
     /*  14554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  14557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14569 */     // (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2MUL:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MUL),
     /*  14572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14574 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14581 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14587 */     GIR_RootConstrainSelectedInstOperands,
     /*  14588 */     // GIR_Coverage, 502,
     /*  14588 */     GIR_EraseRootFromParent_Done,
     /*  14589 */   // Label 313: @14589
     /*  14589 */   GIM_Reject,
     /*  14590 */ // Label 301: @14590
     /*  14590 */ GIM_Reject,
     /*  14591 */ // Label 294: @14591
     /*  14591 */ GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(14637), // Rule ID 837 //
     /*  14596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14613 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14617 */   // (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMULv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  14617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv2i32),
     /*  14620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14622 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14624 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14629 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14635 */   GIR_RootConstrainSelectedInstOperands,
     /*  14636 */   // GIR_Coverage, 837,
     /*  14636 */   GIR_EraseRootFromParent_Done,
     /*  14637 */ // Label 314: @14637
     /*  14637 */ GIM_Reject,
     /*  14638 */ // Label 295: @14638
     /*  14638 */ GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(14684), // Rule ID 836 //
     /*  14643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14660 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14664 */   // (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMULv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  14664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv4i16),
     /*  14667 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14669 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14671 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14676 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14682 */   GIR_RootConstrainSelectedInstOperands,
     /*  14683 */   // GIR_Coverage, 836,
     /*  14683 */   GIR_EraseRootFromParent_Done,
     /*  14684 */ // Label 315: @14684
     /*  14684 */ GIM_Reject,
     /*  14685 */ // Label 296: @14685
     /*  14685 */ GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(14913),
     /*  14690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14696 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(14811), // Rule ID 4421 //
     /*  14701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  14704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14725 */     // MIs[1] Operand 2
     /*  14725 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14748 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14753 */     // MIs[2] Operand 2
     /*  14753 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14766 */     // (mul:{ *:[v4i32] } (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, v4i16:{ *:[Other] }), (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src2, v4i16:{ *:[Other] }))  =>  (MVE_VMULLBs16:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2)
     /*  14766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs16),
     /*  14781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  14783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  14787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  14791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  14794 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14800 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  14809 */     GIR_RootConstrainSelectedInstOperands,
     /*  14810 */     // GIR_Coverage, 4421,
     /*  14810 */     GIR_EraseRootFromParent_Done,
     /*  14811 */   // Label 317: @14811
     /*  14811 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(14851), // Rule ID 840 //
     /*  14816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  14823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  14827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  14831 */     // (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMULv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  14831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv4i32),
     /*  14834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14836 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14843 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14849 */     GIR_RootConstrainSelectedInstOperands,
     /*  14850 */     // GIR_Coverage, 840,
     /*  14850 */     GIR_EraseRootFromParent_Done,
     /*  14851 */   // Label 318: @14851
     /*  14851 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(14912), // Rule ID 3466 //
     /*  14856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  14859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14871 */     // (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMULi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  14871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULi32),
     /*  14886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  14888 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  14890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  14892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  14895 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14901 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  14910 */     GIR_RootConstrainSelectedInstOperands,
     /*  14911 */     // GIR_Coverage, 3466,
     /*  14911 */     GIR_EraseRootFromParent_Done,
     /*  14912 */   // Label 319: @14912
     /*  14912 */   GIM_Reject,
     /*  14913 */ // Label 316: @14913
     /*  14913 */ GIM_Reject,
     /*  14914 */ // Label 297: @14914
     /*  14914 */ GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(14960), // Rule ID 835 //
     /*  14919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  14925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  14928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14936 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14940 */   // (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMULv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  14940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv8i8),
     /*  14943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14945 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14947 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14949 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14952 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14958 */   GIR_RootConstrainSelectedInstOperands,
     /*  14959 */   // GIR_Coverage, 835,
     /*  14959 */   GIR_EraseRootFromParent_Done,
     /*  14960 */ // Label 320: @14960
     /*  14960 */ GIM_Reject,
     /*  14961 */ // Label 298: @14961
     /*  14961 */ GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(15189),
     /*  14966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  14969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  14972 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(15087), // Rule ID 4426 //
     /*  14977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  14980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  14996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15001 */     // MIs[1] Operand 2
     /*  15001 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*  15012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  15016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  15020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  15024 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15029 */     // MIs[2] Operand 2
     /*  15029 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  15040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15042 */     // (mul:{ *:[v8i16] } (sext_inreg:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, v8i8:{ *:[Other] }), (sext_inreg:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src2, v8i8:{ *:[Other] }))  =>  (MVE_VMULLBs8:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2)
     /*  15042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  15045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs8),
     /*  15057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  15059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  15063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  15067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15070 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15076 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15085 */     GIR_RootConstrainSelectedInstOperands,
     /*  15086 */     // GIR_Coverage, 4426,
     /*  15086 */     GIR_EraseRootFromParent_Done,
     /*  15087 */   // Label 322: @15087
     /*  15087 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(15127), // Rule ID 839 //
     /*  15092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15107 */     // (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMULv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  15107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv8i16),
     /*  15110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  15112 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  15114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  15116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15119 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15125 */     GIR_RootConstrainSelectedInstOperands,
     /*  15126 */     // GIR_Coverage, 839,
     /*  15126 */     GIR_EraseRootFromParent_Done,
     /*  15127 */   // Label 323: @15127
     /*  15127 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(15188), // Rule ID 3462 //
     /*  15132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  15135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15147 */     // (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMULi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  15147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  15150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULi16),
     /*  15162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  15164 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  15166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  15168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15171 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15177 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15186 */     GIR_RootConstrainSelectedInstOperands,
     /*  15187 */     // GIR_Coverage, 3462,
     /*  15187 */     GIR_EraseRootFromParent_Done,
     /*  15188 */   // Label 324: @15188
     /*  15188 */   GIM_Reject,
     /*  15189 */ // Label 321: @15189
     /*  15189 */ GIM_Reject,
     /*  15190 */ // Label 299: @15190
     /*  15190 */ GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(15303),
     /*  15195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  15198 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  15201 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(15241), // Rule ID 838 //
     /*  15206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15221 */     // (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMULv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  15221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv16i8),
     /*  15224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  15226 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  15228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  15230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15233 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15239 */     GIR_RootConstrainSelectedInstOperands,
     /*  15240 */     // GIR_Coverage, 838,
     /*  15240 */     GIR_EraseRootFromParent_Done,
     /*  15241 */   // Label 326: @15241
     /*  15241 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(15302), // Rule ID 3458 //
     /*  15246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  15249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15261 */     // (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMULi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  15261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  15264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULi8),
     /*  15276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  15278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  15280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  15282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15285 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15291 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15300 */     GIR_RootConstrainSelectedInstOperands,
     /*  15301 */     // GIR_Coverage, 3458,
     /*  15301 */     GIR_EraseRootFromParent_Done,
     /*  15302 */   // Label 327: @15302
     /*  15302 */   GIM_Reject,
     /*  15303 */ // Label 325: @15303
     /*  15303 */ GIM_Reject,
     /*  15304 */ // Label 300: @15304
     /*  15304 */ GIM_Reject,
     /*  15305 */ // Label 3: @15305
     /*  15305 */ GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(15400),
     /*  15310 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  15313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15316 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15319 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(15359), // Rule ID 195 //
     /*  15324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInARM_IsARM),
     /*  15327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15339 */     // (sdiv:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SDIV:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  15339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SDIV),
     /*  15342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15351 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15357 */     GIR_RootConstrainSelectedInstOperands,
     /*  15358 */     // GIR_Coverage, 195,
     /*  15358 */     GIR_EraseRootFromParent_Done,
     /*  15359 */   // Label 329: @15359
     /*  15359 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(15399), // Rule ID 532 //
     /*  15364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInThumb_HasV8MBaseline_IsThumb),
     /*  15367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15379 */     // (sdiv:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SDIV:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  15379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SDIV),
     /*  15382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15384 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15391 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15397 */     GIR_RootConstrainSelectedInstOperands,
     /*  15398 */     // GIR_Coverage, 532,
     /*  15398 */     GIR_EraseRootFromParent_Done,
     /*  15399 */   // Label 330: @15399
     /*  15399 */   GIM_Reject,
     /*  15400 */ // Label 328: @15400
     /*  15400 */ GIM_Reject,
     /*  15401 */ // Label 4: @15401
     /*  15401 */ GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(15496),
     /*  15406 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  15409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15412 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15415 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(15455), // Rule ID 196 //
     /*  15420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInARM_IsARM),
     /*  15423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15435 */     // (udiv:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (UDIV:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  15435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UDIV),
     /*  15438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15440 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15447 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15453 */     GIR_RootConstrainSelectedInstOperands,
     /*  15454 */     // GIR_Coverage, 196,
     /*  15454 */     GIR_EraseRootFromParent_Done,
     /*  15455 */   // Label 332: @15455
     /*  15455 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(15495), // Rule ID 533 //
     /*  15460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInThumb_HasV8MBaseline_IsThumb),
     /*  15463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15475 */     // (udiv:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UDIV:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  15475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UDIV),
     /*  15478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15487 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15493 */     GIR_RootConstrainSelectedInstOperands,
     /*  15494 */     // GIR_Coverage, 533,
     /*  15494 */     GIR_EraseRootFromParent_Done,
     /*  15495 */   // Label 333: @15495
     /*  15495 */   GIM_Reject,
     /*  15496 */ // Label 331: @15496
     /*  15496 */ GIM_Reject,
     /*  15497 */ // Label 5: @15497
     /*  15497 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 347*/ GIMT_Encode4(18676),
     /*  15508 */ /*GILLT_s32*//*Label 334*/ GIMT_Encode4(15568),
     /*  15512 */ /*GILLT_s64*//*Label 335*/ GIMT_Encode4(17560),
     /*  15516 */ /*GILLT_v2s1*//*Label 336*/ GIMT_Encode4(17607),
     /*  15520 */ /*GILLT_v2s32*//*Label 337*/ GIMT_Encode4(17725),
     /*  15524 */ /*GILLT_v2s64*//*Label 338*/ GIMT_Encode4(17772),
     /*  15528 */ /*GILLT_v4s1*//*Label 339*/ GIMT_Encode4(17886),
     /*  15532 */ /*GILLT_v4s16*//*Label 340*/ GIMT_Encode4(18004),
     /*  15536 */ /*GILLT_v4s32*//*Label 341*/ GIMT_Encode4(18051), GIMT_Encode4(0),
     /*  15544 */ /*GILLT_v8s1*//*Label 342*/ GIMT_Encode4(18165),
     /*  15548 */ /*GILLT_v8s8*//*Label 343*/ GIMT_Encode4(18283),
     /*  15552 */ /*GILLT_v8s16*//*Label 344*/ GIMT_Encode4(18330), GIMT_Encode4(0),
     /*  15560 */ /*GILLT_v16s1*//*Label 345*/ GIMT_Encode4(18444),
     /*  15564 */ /*GILLT_v16s8*//*Label 346*/ GIMT_Encode4(18562),
     /*  15568 */ // Label 334: @15568
     /*  15568 */ GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(17559),
     /*  15573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15579 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(15652), // Rule ID 1855 //
     /*  15584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  15599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  15603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  15607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15612 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  15616 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15629 */     // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$Src, 8:{ *:[i32] }), 16711935:{ *:[i32] })  =>  (UXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 1:{ *:[i32] })
     /*  15629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB16),
     /*  15632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Src
     /*  15638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  15641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15644 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15650 */     GIR_RootConstrainSelectedInstOperands,
     /*  15651 */     // GIR_Coverage, 1855,
     /*  15651 */     GIR_EraseRootFromParent_Done,
     /*  15652 */   // Label 349: @15652
     /*  15652 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(15725), // Rule ID 2112 //
     /*  15657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  15660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  15672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  15676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  15680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15685 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  15689 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15702 */     // (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 8:{ *:[i32] }), 16711935:{ *:[i32] })  =>  (t2UXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 1:{ *:[i32] })
     /*  15702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB16),
     /*  15705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Src
     /*  15711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  15714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15717 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15723 */     GIR_RootConstrainSelectedInstOperands,
     /*  15724 */     // GIR_Coverage, 2112,
     /*  15724 */     GIR_EraseRootFromParent_Done,
     /*  15725 */   // Label 350: @15725
     /*  15725 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(15773), // Rule ID 1997 //
     /*  15730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15741 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  15752 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Src, 255:{ *:[i32] })  =>  (UXTB:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  15752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB),
     /*  15755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  15759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15765 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15771 */     GIR_RootConstrainSelectedInstOperands,
     /*  15772 */     // GIR_Coverage, 1997,
     /*  15772 */     GIR_EraseRootFromParent_Done,
     /*  15773 */   // Label 351: @15773
     /*  15773 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(15821), // Rule ID 1998 //
     /*  15778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15789 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  15800 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Src, 65535:{ *:[i32] })  =>  (UXTH:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  15800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTH),
     /*  15803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  15807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15813 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15819 */     GIR_RootConstrainSelectedInstOperands,
     /*  15820 */     // GIR_Coverage, 1998,
     /*  15820 */     GIR_EraseRootFromParent_Done,
     /*  15821 */   // Label 352: @15821
     /*  15821 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(15869), // Rule ID 1999 //
     /*  15826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15837 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15848 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Src, 16711935:{ *:[i32] })  =>  (UXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  15848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB16),
     /*  15851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15853 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  15855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15867 */     GIR_RootConstrainSelectedInstOperands,
     /*  15868 */     // GIR_Coverage, 1999,
     /*  15868 */     GIR_EraseRootFromParent_Done,
     /*  15869 */   // Label 353: @15869
     /*  15869 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(15917), // Rule ID 2236 //
     /*  15874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  15877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15885 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  15896 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] })  =>  (t2UXTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  15896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB),
     /*  15899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15901 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  15903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15909 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15915 */     GIR_RootConstrainSelectedInstOperands,
     /*  15916 */     // GIR_Coverage, 2236,
     /*  15916 */     GIR_EraseRootFromParent_Done,
     /*  15917 */   // Label 354: @15917
     /*  15917 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(15965), // Rule ID 2237 //
     /*  15922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  15925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15933 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  15944 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] })  =>  (t2UXTH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  15944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTH),
     /*  15947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  15951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15957 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15963 */     GIR_RootConstrainSelectedInstOperands,
     /*  15964 */     // GIR_Coverage, 2237,
     /*  15964 */     GIR_EraseRootFromParent_Done,
     /*  15965 */   // Label 355: @15965
     /*  15965 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(16013), // Rule ID 2238 //
     /*  15970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  15973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15981 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15992 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16711935:{ *:[i32] })  =>  (t2UXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  15992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB16),
     /*  15995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  15999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  16002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16005 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16011 */     GIR_RootConstrainSelectedInstOperands,
     /*  16012 */     // GIR_Coverage, 2238,
     /*  16012 */     GIR_EraseRootFromParent_Done,
     /*  16013 */   // Label 356: @16013
     /*  16013 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(16090), // Rule ID 5439 //
     /*  16018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16041 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16053 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16057 */     // MIs[2] Operand 1
     /*  16057 */     // No operand predicates
     /*  16057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16061 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16063 */     // (and:{ *:[i32] } (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm), GPR:{ *:[i32] }:$Rn)  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16076 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16082 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16088 */     GIR_RootConstrainSelectedInstOperands,
     /*  16089 */     // GIR_Coverage, 5439,
     /*  16089 */     GIR_EraseRootFromParent_Done,
     /*  16090 */   // Label 357: @16090
     /*  16090 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(16167), // Rule ID 5472 //
     /*  16095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16118 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16130 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16134 */     // MIs[2] Operand 1
     /*  16134 */     // No operand predicates
     /*  16134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16140 */     // (and:{ *:[i32] } (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm), rGPR:{ *:[i32] }:$Rn)  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16153 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16159 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16165 */     GIR_RootConstrainSelectedInstOperands,
     /*  16166 */     // GIR_Coverage, 5472,
     /*  16166 */     GIR_EraseRootFromParent_Done,
     /*  16167 */   // Label 358: @16167
     /*  16167 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(16244), // Rule ID 5438 //
     /*  16172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16203 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16207 */     // MIs[2] Operand 1
     /*  16207 */     // No operand predicates
     /*  16207 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16217 */     // (and:{ *:[i32] } (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm, -1:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16236 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16242 */     GIR_RootConstrainSelectedInstOperands,
     /*  16243 */     // GIR_Coverage, 5438,
     /*  16243 */     GIR_EraseRootFromParent_Done,
     /*  16244 */   // Label 359: @16244
     /*  16244 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(16321), // Rule ID 5471 //
     /*  16249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16280 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16284 */     // MIs[2] Operand 1
     /*  16284 */     // No operand predicates
     /*  16284 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16294 */     // (and:{ *:[i32] } (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16307 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16313 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16319 */     GIR_RootConstrainSelectedInstOperands,
     /*  16320 */     // GIR_Coverage, 5471,
     /*  16320 */     GIR_EraseRootFromParent_Done,
     /*  16321 */   // Label 360: @16321
     /*  16321 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(16398), // Rule ID 5437 //
     /*  16326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16353 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16365 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16369 */     // MIs[2] Operand 1
     /*  16369 */     // No operand predicates
     /*  16369 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16371 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm))  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16378 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16384 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16390 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16396 */     GIR_RootConstrainSelectedInstOperands,
     /*  16397 */     // GIR_Coverage, 5437,
     /*  16397 */     GIR_EraseRootFromParent_Done,
     /*  16398 */   // Label 361: @16398
     /*  16398 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(16475), // Rule ID 5470 //
     /*  16403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16430 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16442 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16446 */     // MIs[2] Operand 1
     /*  16446 */     // No operand predicates
     /*  16446 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16448 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm))  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16453 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16461 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16467 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16473 */     GIR_RootConstrainSelectedInstOperands,
     /*  16474 */     // GIR_Coverage, 5470,
     /*  16474 */     GIR_EraseRootFromParent_Done,
     /*  16475 */   // Label 362: @16475
     /*  16475 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(16552), // Rule ID 159 //
     /*  16480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16515 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16519 */     // MIs[2] Operand 1
     /*  16519 */     // No operand predicates
     /*  16519 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16523 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16525 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm, -1:{ *:[i32] }))  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16530 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16538 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16550 */     GIR_RootConstrainSelectedInstOperands,
     /*  16551 */     // GIR_Coverage, 159,
     /*  16551 */     GIR_EraseRootFromParent_Done,
     /*  16552 */   // Label 363: @16552
     /*  16552 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(16629), // Rule ID 490 //
     /*  16557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16592 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16596 */     // MIs[2] Operand 1
     /*  16596 */     // No operand predicates
     /*  16596 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16602 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }))  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16607 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16621 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16627 */     GIR_RootConstrainSelectedInstOperands,
     /*  16628 */     // GIR_Coverage, 490,
     /*  16628 */     GIR_EraseRootFromParent_Done,
     /*  16629 */   // Label 364: @16629
     /*  16629 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(16700), // Rule ID 5440 //
     /*  16634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16662 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16672 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (BICrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  16672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICrr),
     /*  16675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16686 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16692 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16698 */     GIR_RootConstrainSelectedInstOperands,
     /*  16699 */     // GIR_Coverage, 5440,
     /*  16699 */     GIR_EraseRootFromParent_Done,
     /*  16700 */   // Label 365: @16700
     /*  16700 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(16771), // Rule ID 5461 //
     /*  16705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  16708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16724 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16733 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16743 */     // (and:{ *:[i32] } (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), tGPR:{ *:[i32] }:$Rn)  =>  (tBIC:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  16743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tBIC),
     /*  16746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  16748 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  16754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16763 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16769 */     GIR_RootConstrainSelectedInstOperands,
     /*  16770 */     // GIR_Coverage, 5461,
     /*  16770 */     GIR_EraseRootFromParent_Done,
     /*  16771 */   // Label 366: @16771
     /*  16771 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(16842), // Rule ID 5473 //
     /*  16776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16804 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16814 */     // (and:{ *:[i32] } (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2BICrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  16814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICrr),
     /*  16817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16828 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16840 */     GIR_RootConstrainSelectedInstOperands,
     /*  16841 */     // GIR_Coverage, 5473,
     /*  16841 */     GIR_EraseRootFromParent_Done,
     /*  16842 */   // Label 367: @16842
     /*  16842 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(16913), // Rule ID 160 //
     /*  16847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16879 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16885 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (BICrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  16885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICrr),
     /*  16888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16890 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16899 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16911 */     GIR_RootConstrainSelectedInstOperands,
     /*  16912 */     // GIR_Coverage, 160,
     /*  16912 */     GIR_EraseRootFromParent_Done,
     /*  16913 */   // Label 368: @16913
     /*  16913 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(16984), // Rule ID 313 //
     /*  16918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  16921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16950 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16956 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (tBIC:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  16956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tBIC),
     /*  16959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  16961 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  16967 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16976 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16982 */     GIR_RootConstrainSelectedInstOperands,
     /*  16983 */     // GIR_Coverage, 313,
     /*  16983 */     GIR_EraseRootFromParent_Done,
     /*  16984 */   // Label 369: @16984
     /*  16984 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(17055), // Rule ID 491 //
     /*  16989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17021 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17027 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (t2BICrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  17027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICrr),
     /*  17030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17032 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  17038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17041 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17047 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17053 */     GIR_RootConstrainSelectedInstOperands,
     /*  17054 */     // GIR_Coverage, 491,
     /*  17054 */     GIR_EraseRootFromParent_Done,
     /*  17055 */   // Label 370: @17055
     /*  17055 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(17100), // Rule ID 345 //
     /*  17060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  17063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17071 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  17082 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] })  =>  (tUXTB:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /*  17082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUXTB),
     /*  17085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  17089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17092 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17098 */     GIR_RootConstrainSelectedInstOperands,
     /*  17099 */     // GIR_Coverage, 345,
     /*  17099 */     GIR_EraseRootFromParent_Done,
     /*  17100 */   // Label 371: @17100
     /*  17100 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(17145), // Rule ID 346 //
     /*  17105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  17108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17116 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  17127 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] })  =>  (tUXTH:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /*  17127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUXTH),
     /*  17130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17132 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  17134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17137 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17143 */     GIR_RootConstrainSelectedInstOperands,
     /*  17144 */     // GIR_Coverage, 346,
     /*  17144 */     GIR_EraseRootFromParent_Done,
     /*  17145 */   // Label 372: @17145
     /*  17145 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(17204), // Rule ID 1894 //
     /*  17150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  17153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm_not),
     /*  17173 */     // MIs[1] Operand 1
     /*  17173 */     // No operand predicates
     /*  17173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17175 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_mod_imm_not>><<X:imm_not_XFORM>>:$imm)  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm_not_XFORM:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm_not>>:$imm))
     /*  17175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  17178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17180 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17182 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderInvertedImm), // imm
     /*  17187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17190 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17196 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17202 */     GIR_RootConstrainSelectedInstOperands,
     /*  17203 */     // GIR_Coverage, 1894,
     /*  17203 */     GIR_EraseRootFromParent_Done,
     /*  17204 */   // Label 373: @17204
     /*  17204 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(17261), // Rule ID 147 //
     /*  17209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  17212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  17232 */     // MIs[1] Operand 1
     /*  17232 */     // No operand predicates
     /*  17232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17234 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (ANDri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  17234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ANDri),
     /*  17237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17247 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17253 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17259 */     GIR_RootConstrainSelectedInstOperands,
     /*  17260 */     // GIR_Coverage, 147,
     /*  17260 */     GIR_EraseRootFromParent_Done,
     /*  17261 */   // Label 374: @17261
     /*  17261 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(17318), // Rule ID 481 //
     /*  17266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  17269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  17289 */     // MIs[1] Operand 1
     /*  17289 */     // No operand predicates
     /*  17289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17291 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2ANDri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  17291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ANDri),
     /*  17294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17310 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17316 */     GIR_RootConstrainSelectedInstOperands,
     /*  17317 */     // GIR_Coverage, 481,
     /*  17317 */     GIR_EraseRootFromParent_Done,
     /*  17318 */   // Label 375: @17318
     /*  17318 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(17369), // Rule ID 163 //
     /*  17323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /*  17326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17342 */     // MIs[1] Operand 1
     /*  17342 */     // No operand predicates
     /*  17342 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_bf_inv_mask_imm),
     /*  17346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17348 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_bf_inv_mask_imm>>:$imm)  =>  (BFC:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm:{ *:[i32] }):$imm)
     /*  17348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BFC),
     /*  17351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17353 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17361 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17367 */     GIR_RootConstrainSelectedInstOperands,
     /*  17368 */     // GIR_Coverage, 163,
     /*  17368 */     GIR_EraseRootFromParent_Done,
     /*  17369 */   // Label 376: @17369
     /*  17369 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(17420), // Rule ID 493 //
     /*  17374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  17377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17393 */     // MIs[1] Operand 1
     /*  17393 */     // No operand predicates
     /*  17393 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_bf_inv_mask_imm),
     /*  17397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17399 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_bf_inv_mask_imm>>:$imm)  =>  (t2BFC:{ *:[i32] } rGPR:{ *:[i32] }:$src, (imm:{ *:[i32] }):$imm)
     /*  17399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BFC),
     /*  17402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17404 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17406 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17412 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17418 */     GIR_RootConstrainSelectedInstOperands,
     /*  17419 */     // GIR_Coverage, 493,
     /*  17419 */     GIR_EraseRootFromParent_Done,
     /*  17420 */   // Label 377: @17420
     /*  17420 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(17466), // Rule ID 148 //
     /*  17425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  17428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17440 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (ANDrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  17440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ANDrr),
     /*  17443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17445 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  17449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17452 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17458 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17464 */     GIR_RootConstrainSelectedInstOperands,
     /*  17465 */     // GIR_Coverage, 148,
     /*  17465 */     GIR_EraseRootFromParent_Done,
     /*  17466 */   // Label 378: @17466
     /*  17466 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(17512), // Rule ID 310 //
     /*  17471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  17474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17486 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tAND:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  17486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tAND),
     /*  17489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  17491 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  17497 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  17501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17504 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17510 */     GIR_RootConstrainSelectedInstOperands,
     /*  17511 */     // GIR_Coverage, 310,
     /*  17511 */     GIR_EraseRootFromParent_Done,
     /*  17512 */   // Label 379: @17512
     /*  17512 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(17558), // Rule ID 482 //
     /*  17517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  17520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17532 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ANDrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  17532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  17535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17537 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  17541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17550 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17556 */     GIR_RootConstrainSelectedInstOperands,
     /*  17557 */     // GIR_Coverage, 482,
     /*  17557 */     GIR_EraseRootFromParent_Done,
     /*  17558 */   // Label 380: @17558
     /*  17558 */   GIM_Reject,
     /*  17559 */ // Label 348: @17559
     /*  17559 */ GIM_Reject,
     /*  17560 */ // Label 335: @17560
     /*  17560 */ GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(17606), // Rule ID 2526 //
     /*  17565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  17571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  17574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17582 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17586 */   // (and:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)  =>  (VANDd:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)
     /*  17586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  17589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  17591 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  17593 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  17595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17598 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17604 */   GIR_RootConstrainSelectedInstOperands,
     /*  17605 */   // GIR_Coverage, 2526,
     /*  17605 */   GIR_EraseRootFromParent_Done,
     /*  17606 */ // Label 381: @17606
     /*  17606 */ GIM_Reject,
     /*  17607 */ // Label 336: @17607
     /*  17607 */ GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(17724), // Rule ID 1826 //
     /*  17612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  17615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  17618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  17621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17629 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17633 */   // (and:{ *:[v2i1] } VCCR:{ *:[v2i1] }:$p1, VCCR:{ *:[v2i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  17633 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  17636 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17640 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17645 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  17649 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17654 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  17657 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17661 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17666 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  17670 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17675 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  17678 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  17682 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17687 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  17690 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  17693 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  17696 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17702 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17708 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  17710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17715 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17718 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17723 */   // GIR_Coverage, 1826,
     /*  17723 */   GIR_EraseRootFromParent_Done,
     /*  17724 */ // Label 382: @17724
     /*  17724 */ GIM_Reject,
     /*  17725 */ // Label 337: @17725
     /*  17725 */ GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(17771), // Rule ID 1133 //
     /*  17730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17736 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17747 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17751 */   // (and:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VANDd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  17751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  17754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  17756 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  17758 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  17760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17763 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17769 */   GIR_RootConstrainSelectedInstOperands,
     /*  17770 */   // GIR_Coverage, 1133,
     /*  17770 */   GIR_EraseRootFromParent_Done,
     /*  17771 */ // Label 383: @17771
     /*  17771 */ GIM_Reject,
     /*  17772 */ // Label 338: @17772
     /*  17772 */ GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(17885),
     /*  17777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  17780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  17783 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(17823), // Rule ID 2529 //
     /*  17788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  17795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  17799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  17803 */     // (and:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)  =>  (VANDq:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)
     /*  17803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  17806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  17808 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  17810 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  17812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17815 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17821 */     GIR_RootConstrainSelectedInstOperands,
     /*  17822 */     // GIR_Coverage, 2529,
     /*  17822 */     GIR_EraseRootFromParent_Done,
     /*  17823 */   // Label 385: @17823
     /*  17823 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(17884), // Rule ID 3370 //
     /*  17828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  17831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  17835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  17839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  17843 */     // (and:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)  =>  (MVE_VAND:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)
     /*  17843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  17846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  17850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  17858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  17860 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  17862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  17864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  17867 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17873 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17882 */     GIR_RootConstrainSelectedInstOperands,
     /*  17883 */     // GIR_Coverage, 3370,
     /*  17883 */     GIR_EraseRootFromParent_Done,
     /*  17884 */   // Label 386: @17884
     /*  17884 */   GIM_Reject,
     /*  17885 */ // Label 384: @17885
     /*  17885 */ GIM_Reject,
     /*  17886 */ // Label 339: @17886
     /*  17886 */ GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(18003), // Rule ID 1827 //
     /*  17891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  17894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  17897 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  17900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17908 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17912 */   // (and:{ *:[v4i1] } VCCR:{ *:[v4i1] }:$p1, VCCR:{ *:[v4i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  17912 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  17915 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17919 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17924 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  17928 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17933 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  17936 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17940 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17945 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  17949 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17954 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  17957 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  17961 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17966 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  17969 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  17972 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  17975 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17981 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17987 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  17989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17994 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17997 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18002 */   // GIR_Coverage, 1827,
     /*  18002 */   GIR_EraseRootFromParent_Done,
     /*  18003 */ // Label 387: @18003
     /*  18003 */ GIM_Reject,
     /*  18004 */ // Label 340: @18004
     /*  18004 */ GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(18050), // Rule ID 2525 //
     /*  18009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  18015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  18018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18026 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18030 */   // (and:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)  =>  (VANDd:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)
     /*  18030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  18033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18035 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18037 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18042 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18048 */   GIR_RootConstrainSelectedInstOperands,
     /*  18049 */   // GIR_Coverage, 2525,
     /*  18049 */   GIR_EraseRootFromParent_Done,
     /*  18050 */ // Label 388: @18050
     /*  18050 */ GIM_Reject,
     /*  18051 */ // Label 341: @18051
     /*  18051 */ GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(18164),
     /*  18056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18062 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(18102), // Rule ID 1134 //
     /*  18067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18082 */     // (and:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VANDq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  18082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  18085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  18089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  18091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18094 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18100 */     GIR_RootConstrainSelectedInstOperands,
     /*  18101 */     // GIR_Coverage, 1134,
     /*  18101 */     GIR_EraseRootFromParent_Done,
     /*  18102 */   // Label 390: @18102
     /*  18102 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(18163), // Rule ID 3366 //
     /*  18107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18122 */     // (and:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VAND:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  18122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  18125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  18137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  18139 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  18141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  18143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18146 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18161 */     GIR_RootConstrainSelectedInstOperands,
     /*  18162 */     // GIR_Coverage, 3366,
     /*  18162 */     GIR_EraseRootFromParent_Done,
     /*  18163 */   // Label 391: @18163
     /*  18163 */   GIM_Reject,
     /*  18164 */ // Label 389: @18164
     /*  18164 */ GIM_Reject,
     /*  18165 */ // Label 342: @18165
     /*  18165 */ GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(18282), // Rule ID 1828 //
     /*  18170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  18176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  18179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18187 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18191 */   // (and:{ *:[v8i1] } VCCR:{ *:[v8i1] }:$p1, VCCR:{ *:[v8i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  18191 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  18194 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18198 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18203 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  18207 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18212 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  18215 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18219 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18224 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  18228 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18233 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  18236 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  18240 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18245 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  18248 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  18251 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  18254 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18260 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18266 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  18268 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18271 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18273 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18276 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18281 */   // GIR_Coverage, 1828,
     /*  18281 */   GIR_EraseRootFromParent_Done,
     /*  18282 */ // Label 392: @18282
     /*  18282 */ GIM_Reject,
     /*  18283 */ // Label 343: @18283
     /*  18283 */ GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(18329), // Rule ID 2524 //
     /*  18288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  18294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  18297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18309 */   // (and:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)  =>  (VANDd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)
     /*  18309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  18312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18314 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18316 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18318 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18321 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18327 */   GIR_RootConstrainSelectedInstOperands,
     /*  18328 */   // GIR_Coverage, 2524,
     /*  18328 */   GIR_EraseRootFromParent_Done,
     /*  18329 */ // Label 393: @18329
     /*  18329 */ GIM_Reject,
     /*  18330 */ // Label 344: @18330
     /*  18330 */ GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(18443),
     /*  18335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  18338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  18341 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(18381), // Rule ID 2528 //
     /*  18346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18361 */     // (and:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)  =>  (VANDq:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)
     /*  18361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  18364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18366 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18368 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18373 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18379 */     GIR_RootConstrainSelectedInstOperands,
     /*  18380 */     // GIR_Coverage, 2528,
     /*  18380 */     GIR_EraseRootFromParent_Done,
     /*  18381 */   // Label 395: @18381
     /*  18381 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(18442), // Rule ID 3362 //
     /*  18386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18401 */     // (and:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VAND:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  18401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  18404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  18416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  18418 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  18420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  18422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18425 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18431 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18440 */     GIR_RootConstrainSelectedInstOperands,
     /*  18441 */     // GIR_Coverage, 3362,
     /*  18441 */     GIR_EraseRootFromParent_Done,
     /*  18442 */   // Label 396: @18442
     /*  18442 */   GIM_Reject,
     /*  18443 */ // Label 394: @18443
     /*  18443 */ GIM_Reject,
     /*  18444 */ // Label 345: @18444
     /*  18444 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(18561), // Rule ID 1829 //
     /*  18449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  18455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  18458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18466 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18470 */   // (and:{ *:[v16i1] } VCCR:{ *:[v16i1] }:$p1, VCCR:{ *:[v16i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  18470 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  18473 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18477 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18482 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  18486 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18491 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  18494 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18498 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18503 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  18507 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  18515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  18519 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18524 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  18527 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  18530 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  18533 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18539 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18545 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  18547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18552 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18555 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18560 */   // GIR_Coverage, 1829,
     /*  18560 */   GIR_EraseRootFromParent_Done,
     /*  18561 */ // Label 397: @18561
     /*  18561 */ GIM_Reject,
     /*  18562 */ // Label 346: @18562
     /*  18562 */ GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(18675),
     /*  18567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  18570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  18573 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(18613), // Rule ID 2527 //
     /*  18578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18593 */     // (and:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)  =>  (VANDq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)
     /*  18593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  18596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18598 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18600 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18605 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18611 */     GIR_RootConstrainSelectedInstOperands,
     /*  18612 */     // GIR_Coverage, 2527,
     /*  18612 */     GIR_EraseRootFromParent_Done,
     /*  18613 */   // Label 399: @18613
     /*  18613 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(18674), // Rule ID 3358 //
     /*  18618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18633 */     // (and:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VAND:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  18633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  18636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  18648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  18650 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  18652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  18654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18663 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18672 */     GIR_RootConstrainSelectedInstOperands,
     /*  18673 */     // GIR_Coverage, 3358,
     /*  18673 */     GIR_EraseRootFromParent_Done,
     /*  18674 */   // Label 400: @18674
     /*  18674 */   GIM_Reject,
     /*  18675 */ // Label 398: @18675
     /*  18675 */ GIM_Reject,
     /*  18676 */ // Label 347: @18676
     /*  18676 */ GIM_Reject,
     /*  18677 */ // Label 6: @18677
     /*  18677 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 414*/ GIMT_Encode4(24485),
     /*  18688 */ /*GILLT_s32*//*Label 401*/ GIMT_Encode4(18748),
     /*  18692 */ /*GILLT_s64*//*Label 402*/ GIMT_Encode4(23369),
     /*  18696 */ /*GILLT_v2s1*//*Label 403*/ GIMT_Encode4(23416),
     /*  18700 */ /*GILLT_v2s32*//*Label 404*/ GIMT_Encode4(23534),
     /*  18704 */ /*GILLT_v2s64*//*Label 405*/ GIMT_Encode4(23581),
     /*  18708 */ /*GILLT_v4s1*//*Label 406*/ GIMT_Encode4(23695),
     /*  18712 */ /*GILLT_v4s16*//*Label 407*/ GIMT_Encode4(23813),
     /*  18716 */ /*GILLT_v4s32*//*Label 408*/ GIMT_Encode4(23860), GIMT_Encode4(0),
     /*  18724 */ /*GILLT_v8s1*//*Label 409*/ GIMT_Encode4(23974),
     /*  18728 */ /*GILLT_v8s8*//*Label 410*/ GIMT_Encode4(24092),
     /*  18732 */ /*GILLT_v8s16*//*Label 411*/ GIMT_Encode4(24139), GIMT_Encode4(0),
     /*  18740 */ /*GILLT_v16s1*//*Label 412*/ GIMT_Encode4(24253),
     /*  18744 */ /*GILLT_v16s8*//*Label 413*/ GIMT_Encode4(24371),
     /*  18748 */ // Label 401: @18748
     /*  18748 */ GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(23368),
     /*  18753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  18756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  18759 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(18886), // Rule ID 5655 //
     /*  18764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  18767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  18771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  18783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  18787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  18799 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  18803 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  18808 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  18812 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*  18823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18827 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  18831 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  18835 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  18839 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18843 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  18847 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  18851 */     // MIs[4] Rm
     /*  18851 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18856 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  18860 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  18864 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18866 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }), (sra:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }))  =>  (REVSH:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /*  18866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REVSH),
     /*  18869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18878 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18884 */     GIR_RootConstrainSelectedInstOperands,
     /*  18885 */     // GIR_Coverage, 5655,
     /*  18885 */     GIR_EraseRootFromParent_Done,
     /*  18886 */   // Label 416: @18886
     /*  18886 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(19013), // Rule ID 5697 //
     /*  18891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  18894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  18910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  18914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  18926 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  18930 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18935 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  18939 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*  18950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  18958 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  18962 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  18966 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18970 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  18974 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  18978 */     // MIs[4] Rm
     /*  18978 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18983 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  18987 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  18991 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18993 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }), (sra:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }))  =>  (t2REVSH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /*  18993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REVSH),
     /*  18996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19005 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19011 */     GIR_RootConstrainSelectedInstOperands,
     /*  19012 */     // GIR_Coverage, 5697,
     /*  19012 */     GIR_EraseRootFromParent_Done,
     /*  19013 */   // Label 417: @19013
     /*  19013 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(19140), // Rule ID 1914 //
     /*  19018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  19025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19053 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  19062 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  19066 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  19070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19078 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  19082 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  19086 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19090 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19094 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19098 */     // MIs[4] Rm
     /*  19098 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19103 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  19107 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
     /*  19118 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19120 */     // (or:{ *:[i32] } (sra:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }))  =>  (REVSH:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /*  19120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REVSH),
     /*  19123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19132 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19138 */     GIR_RootConstrainSelectedInstOperands,
     /*  19139 */     // GIR_Coverage, 1914,
     /*  19139 */     GIR_EraseRootFromParent_Done,
     /*  19140 */   // Label 418: @19140
     /*  19140 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(19267), // Rule ID 2196 //
     /*  19145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  19148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19180 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19189 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  19193 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  19197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19205 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  19209 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  19213 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19217 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19221 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19225 */     // MIs[4] Rm
     /*  19225 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19230 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  19234 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
     /*  19245 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19247 */     // (or:{ *:[i32] } (sra:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }))  =>  (t2REVSH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /*  19247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REVSH),
     /*  19250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19259 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19265 */     GIR_RootConstrainSelectedInstOperands,
     /*  19266 */     // GIR_Coverage, 2196,
     /*  19266 */     GIR_EraseRootFromParent_Done,
     /*  19267 */   // Label 419: @19267
     /*  19267 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(19400), // Rule ID 5453 //
     /*  19272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19307 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19311 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19316 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19320 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19324 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  19328 */     // MIs[3] Operand 1
     /*  19328 */     // No operand predicates
     /*  19328 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19339 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19343 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19347 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19351 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19355 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19360 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19371 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19373 */     // (or:{ *:[i32] } (and:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  19373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  19376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  19382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19392 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19398 */     GIR_RootConstrainSelectedInstOperands,
     /*  19399 */     // GIR_Coverage, 5453,
     /*  19399 */     GIR_EraseRootFromParent_Done,
     /*  19400 */   // Label 420: @19400
     /*  19400 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(19533), // Rule ID 5490 //
     /*  19405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  19408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19440 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19449 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19453 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19457 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  19461 */     // MIs[3] Operand 1
     /*  19461 */     // No operand predicates
     /*  19461 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19472 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19476 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19480 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19484 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19488 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19493 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19504 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19506 */     // (or:{ *:[i32] } (and:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  19506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  19509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  19515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19525 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19531 */     GIR_RootConstrainSelectedInstOperands,
     /*  19532 */     // GIR_Coverage, 5490,
     /*  19532 */     GIR_EraseRootFromParent_Done,
     /*  19533 */   // Label 421: @19533
     /*  19533 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(19666), // Rule ID 5660 //
     /*  19538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19573 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19577 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19582 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19586 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19590 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  19594 */     // MIs[3] Operand 1
     /*  19594 */     // No operand predicates
     /*  19594 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19605 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19609 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19613 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19617 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19621 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19626 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19637 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19639 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  19639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  19642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  19648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  19652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19658 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19664 */     GIR_RootConstrainSelectedInstOperands,
     /*  19665 */     // GIR_Coverage, 5660,
     /*  19665 */     GIR_EraseRootFromParent_Done,
     /*  19666 */   // Label 422: @19666
     /*  19666 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(19799), // Rule ID 5702 //
     /*  19671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  19674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19706 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19710 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19715 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19719 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19723 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  19727 */     // MIs[3] Operand 1
     /*  19727 */     // No operand predicates
     /*  19727 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19738 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19742 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19746 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19750 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19754 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19759 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19770 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19772 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  19772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  19775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  19781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  19785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19797 */     GIR_RootConstrainSelectedInstOperands,
     /*  19798 */     // GIR_Coverage, 5702,
     /*  19798 */     GIR_EraseRootFromParent_Done,
     /*  19799 */   // Label 423: @19799
     /*  19799 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(19932), // Rule ID 5452 //
     /*  19804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19835 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19839 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19843 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19848 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19852 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19856 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  19860 */     // MIs[3] Operand 1
     /*  19860 */     // No operand predicates
     /*  19860 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19871 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19875 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19879 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19883 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19887 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19892 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(65535),
     /*  19903 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19905 */     // (or:{ *:[i32] } (and:{ *:[i32] } (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  19905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  19908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  19914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19930 */     GIR_RootConstrainSelectedInstOperands,
     /*  19931 */     // GIR_Coverage, 5452,
     /*  19931 */     GIR_EraseRootFromParent_Done,
     /*  19932 */   // Label 424: @19932
     /*  19932 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(20065), // Rule ID 5489 //
     /*  19937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  19940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19972 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19976 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19981 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19985 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19989 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  19993 */     // MIs[3] Operand 1
     /*  19993 */     // No operand predicates
     /*  19993 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20004 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  20008 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20012 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  20016 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  20020 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20025 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(65535),
     /*  20036 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20038 */     // (or:{ *:[i32] } (and:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  20041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  20047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  20054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20057 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20063 */     GIR_RootConstrainSelectedInstOperands,
     /*  20064 */     // GIR_Coverage, 5489,
     /*  20064 */     GIR_EraseRootFromParent_Done,
     /*  20065 */   // Label 425: @20065
     /*  20065 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(20198), // Rule ID 203 //
     /*  20070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20098 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20121 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20125 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20129 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  20133 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20137 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20141 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20146 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20150 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20154 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  20158 */     // MIs[4] Operand 1
     /*  20158 */     // No operand predicates
     /*  20158 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20169 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20171 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  20174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20190 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20196 */     GIR_RootConstrainSelectedInstOperands,
     /*  20197 */     // GIR_Coverage, 203,
     /*  20197 */     GIR_EraseRootFromParent_Done,
     /*  20198 */   // Label 426: @20198
     /*  20198 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(20331), // Rule ID 540 //
     /*  20203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20231 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20254 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20258 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20262 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  20266 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20270 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20274 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20279 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20283 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20287 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  20291 */     // MIs[4] Operand 1
     /*  20291 */     // No operand predicates
     /*  20291 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20302 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20304 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  20307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20323 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20329 */     GIR_RootConstrainSelectedInstOperands,
     /*  20330 */     // GIR_Coverage, 540,
     /*  20330 */     GIR_EraseRootFromParent_Done,
     /*  20331 */   // Label 427: @20331
     /*  20331 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(20464), // Rule ID 1919 //
     /*  20336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20364 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20387 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20391 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20395 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20399 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20403 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20407 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20412 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20416 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20420 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  20424 */     // MIs[4] Operand 1
     /*  20424 */     // No operand predicates
     /*  20424 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20435 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20437 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  20437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  20440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src2
     /*  20450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20462 */     GIR_RootConstrainSelectedInstOperands,
     /*  20463 */     // GIR_Coverage, 1919,
     /*  20463 */     GIR_EraseRootFromParent_Done,
     /*  20464 */   // Label 428: @20464
     /*  20464 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(20597), // Rule ID 2201 //
     /*  20469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20497 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20520 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20524 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20528 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20532 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20536 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20540 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20545 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20549 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20553 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  20557 */     // MIs[4] Operand 1
     /*  20557 */     // No operand predicates
     /*  20557 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20568 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20570 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  20570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  20573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src2
     /*  20583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20595 */     GIR_RootConstrainSelectedInstOperands,
     /*  20596 */     // GIR_Coverage, 2201,
     /*  20596 */     GIR_EraseRootFromParent_Done,
     /*  20597 */   // Label 429: @20597
     /*  20597 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(20730), // Rule ID 202 //
     /*  20602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20630 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  20641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20653 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20657 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20661 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  20665 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20669 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20673 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20678 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20682 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20686 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  20690 */     // MIs[4] Operand 1
     /*  20690 */     // No operand predicates
     /*  20690 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20701 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20703 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (and:{ *:[i32] } (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  20706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20728 */     GIR_RootConstrainSelectedInstOperands,
     /*  20729 */     // GIR_Coverage, 202,
     /*  20729 */     GIR_EraseRootFromParent_Done,
     /*  20730 */   // Label 430: @20730
     /*  20730 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(20863), // Rule ID 539 //
     /*  20735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20763 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  20774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20794 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  20798 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20802 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20806 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20811 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20815 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20819 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  20823 */     // MIs[4] Operand 1
     /*  20823 */     // No operand predicates
     /*  20823 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20834 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20836 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (and:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  20839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20855 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20861 */     GIR_RootConstrainSelectedInstOperands,
     /*  20862 */     // GIR_Coverage, 539,
     /*  20862 */     GIR_EraseRootFromParent_Done,
     /*  20863 */   // Label 431: @20863
     /*  20863 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(20968), // Rule ID 1915 //
     /*  20868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20896 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  20907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20919 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20928 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20939 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20941 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 4294901760:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  20941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  20944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  20957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20966 */     GIR_RootConstrainSelectedInstOperands,
     /*  20967 */     // GIR_Coverage, 1915,
     /*  20967 */     GIR_EraseRootFromParent_Done,
     /*  20968 */   // Label 432: @20968
     /*  20968 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(21073), // Rule ID 2197 //
     /*  20973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21001 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  21012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21024 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21028 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21033 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21044 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21046 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src2, 4294901760:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, 0:{ *:[i32] })
     /*  21046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  21049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21065 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21071 */     GIR_RootConstrainSelectedInstOperands,
     /*  21072 */     // GIR_Coverage, 2197,
     /*  21072 */     GIR_EraseRootFromParent_Done,
     /*  21073 */   // Label 433: @21073
     /*  21073 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(21178), // Rule ID 5656 //
     /*  21078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21106 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21129 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21133 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21138 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  21149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21151 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 4294901760:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  21151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  21154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21170 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21176 */     GIR_RootConstrainSelectedInstOperands,
     /*  21177 */     // GIR_Coverage, 5656,
     /*  21177 */     GIR_EraseRootFromParent_Done,
     /*  21178 */   // Label 434: @21178
     /*  21178 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(21283), // Rule ID 5698 //
     /*  21183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21211 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21234 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21238 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21243 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  21254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21256 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src2, 4294901760:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, 0:{ *:[i32] })
     /*  21256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  21259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  21265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  21269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21275 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21281 */     GIR_RootConstrainSelectedInstOperands,
     /*  21282 */     // GIR_Coverage, 5698,
     /*  21282 */     GIR_EraseRootFromParent_Done,
     /*  21283 */   // Label 435: @21283
     /*  21283 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(21389), // Rule ID 1918 //
     /*  21288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21307 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21316 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  21335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21339 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21343 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21356 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21360 */     // MIs[3] Operand 1
     /*  21360 */     // No operand predicates
     /*  21360 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21362 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  21365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21381 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21387 */     GIR_RootConstrainSelectedInstOperands,
     /*  21388 */     // GIR_Coverage, 1918,
     /*  21388 */     GIR_EraseRootFromParent_Done,
     /*  21389 */   // Label 436: @21389
     /*  21389 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(21495), // Rule ID 2200 //
     /*  21394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21422 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  21441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21445 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21462 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21466 */     // MIs[3] Operand 1
     /*  21466 */     // No operand predicates
     /*  21466 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21468 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  21471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21487 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21493 */     GIR_RootConstrainSelectedInstOperands,
     /*  21494 */     // GIR_Coverage, 2200,
     /*  21494 */     GIR_EraseRootFromParent_Done,
     /*  21495 */   // Label 437: @21495
     /*  21495 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(21601), // Rule ID 1917 //
     /*  21500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21528 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21551 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21555 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21560 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21564 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21568 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  21572 */     // MIs[3] Operand 1
     /*  21572 */     // No operand predicates
     /*  21572 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21574 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  21574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  21577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21593 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21599 */     GIR_RootConstrainSelectedInstOperands,
     /*  21600 */     // GIR_Coverage, 1917,
     /*  21600 */     GIR_EraseRootFromParent_Done,
     /*  21601 */   // Label 438: @21601
     /*  21601 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(21707), // Rule ID 2199 //
     /*  21606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21634 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21661 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21666 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21674 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  21678 */     // MIs[3] Operand 1
     /*  21678 */     // No operand predicates
     /*  21678 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21680 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  21680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  21683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21699 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21705 */     GIR_RootConstrainSelectedInstOperands,
     /*  21706 */     // GIR_Coverage, 2199,
     /*  21706 */     GIR_EraseRootFromParent_Done,
     /*  21707 */   // Label 439: @21707
     /*  21707 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(21813), // Rule ID 1916 //
     /*  21712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21740 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  21751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  21759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21763 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21767 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21772 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21776 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21780 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21784 */     // MIs[3] Operand 1
     /*  21784 */     // No operand predicates
     /*  21784 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21786 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  21789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  21799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21805 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21811 */     GIR_RootConstrainSelectedInstOperands,
     /*  21812 */     // GIR_Coverage, 1916,
     /*  21812 */     GIR_EraseRootFromParent_Done,
     /*  21813 */   // Label 440: @21813
     /*  21813 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(21919), // Rule ID 2198 //
     /*  21818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21846 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  21857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  21865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21869 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21873 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21878 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21882 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21886 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21890 */     // MIs[3] Operand 1
     /*  21890 */     // No operand predicates
     /*  21890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21892 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }), (shl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  21895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21911 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21917 */     GIR_RootConstrainSelectedInstOperands,
     /*  21918 */     // GIR_Coverage, 2198,
     /*  21918 */     GIR_EraseRootFromParent_Done,
     /*  21919 */   // Label 441: @21919
     /*  21919 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(22025), // Rule ID 5659 //
     /*  21924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  21939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21960 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21964 */     // MIs[2] Operand 1
     /*  21964 */     // No operand predicates
     /*  21964 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21968 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21972 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  21976 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  21980 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21985 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21996 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21998 */     // (or:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  22001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22017 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22023 */     GIR_RootConstrainSelectedInstOperands,
     /*  22024 */     // GIR_Coverage, 5659,
     /*  22024 */     GIR_EraseRootFromParent_Done,
     /*  22025 */   // Label 442: @22025
     /*  22025 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(22131), // Rule ID 5701 //
     /*  22030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  22033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  22045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22066 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  22070 */     // MIs[2] Operand 1
     /*  22070 */     // No operand predicates
     /*  22070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22078 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22082 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22086 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22091 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  22102 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22104 */     // (or:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  22104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  22107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22123 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22129 */     GIR_RootConstrainSelectedInstOperands,
     /*  22130 */     // GIR_Coverage, 5701,
     /*  22130 */     GIR_EraseRootFromParent_Done,
     /*  22131 */   // Label 443: @22131
     /*  22131 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(22237), // Rule ID 5658 //
     /*  22136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  22139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22172 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  22176 */     // MIs[2] Operand 1
     /*  22176 */     // No operand predicates
     /*  22176 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22180 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22184 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22188 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22192 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22197 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  22208 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22210 */     // (or:{ *:[i32] } (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  22210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  22213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22229 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22235 */     GIR_RootConstrainSelectedInstOperands,
     /*  22236 */     // GIR_Coverage, 5658,
     /*  22236 */     GIR_EraseRootFromParent_Done,
     /*  22237 */   // Label 444: @22237
     /*  22237 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(22343), // Rule ID 5700 //
     /*  22242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  22245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22278 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  22282 */     // MIs[2] Operand 1
     /*  22282 */     // No operand predicates
     /*  22282 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22286 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22290 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22294 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22298 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22303 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  22314 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22316 */     // (or:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  22316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  22319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22335 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22341 */     GIR_RootConstrainSelectedInstOperands,
     /*  22342 */     // GIR_Coverage, 5700,
     /*  22342 */     GIR_EraseRootFromParent_Done,
     /*  22343 */   // Label 445: @22343
     /*  22343 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(22449), // Rule ID 5657 //
     /*  22348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  22351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  22363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22384 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  22388 */     // MIs[2] Operand 1
     /*  22388 */     // No operand predicates
     /*  22388 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22392 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22396 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22400 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22404 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22409 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(65535),
     /*  22420 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22422 */     // (or:{ *:[i32] } (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  22422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  22425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  22431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  22435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22441 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22447 */     GIR_RootConstrainSelectedInstOperands,
     /*  22448 */     // GIR_Coverage, 5657,
     /*  22448 */     GIR_EraseRootFromParent_Done,
     /*  22449 */   // Label 446: @22449
     /*  22449 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(22555), // Rule ID 5699 //
     /*  22454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  22457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  22469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22490 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  22494 */     // MIs[2] Operand 1
     /*  22494 */     // No operand predicates
     /*  22494 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22498 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22502 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22506 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22510 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22515 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(65535),
     /*  22526 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22528 */     // (or:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  22528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  22531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22547 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22553 */     GIR_RootConstrainSelectedInstOperands,
     /*  22554 */     // GIR_Coverage, 5699,
     /*  22554 */     GIR_EraseRootFromParent_Done,
     /*  22555 */   // Label 447: @22555
     /*  22555 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(22632), // Rule ID 5477 //
     /*  22560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22583 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  22587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22595 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22599 */     // MIs[2] Operand 1
     /*  22599 */     // No operand predicates
     /*  22599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22605 */     // (or:{ *:[i32] } (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm), rGPR:{ *:[i32] }:$Rn)  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  22612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22618 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22630 */     GIR_RootConstrainSelectedInstOperands,
     /*  22631 */     // GIR_Coverage, 5477,
     /*  22631 */     GIR_EraseRootFromParent_Done,
     /*  22632 */   // Label 448: @22632
     /*  22632 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(22709), // Rule ID 5476 //
     /*  22637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22668 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22672 */     // MIs[2] Operand 1
     /*  22672 */     // No operand predicates
     /*  22672 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22682 */     // (or:{ *:[i32] } (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  22689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22695 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22701 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22707 */     GIR_RootConstrainSelectedInstOperands,
     /*  22708 */     // GIR_Coverage, 5476,
     /*  22708 */     GIR_EraseRootFromParent_Done,
     /*  22709 */   // Label 449: @22709
     /*  22709 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(22786), // Rule ID 5475 //
     /*  22714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22741 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  22745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22753 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22757 */     // MIs[2] Operand 1
     /*  22757 */     // No operand predicates
     /*  22757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22759 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm))  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22764 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  22766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22772 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22778 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22784 */     GIR_RootConstrainSelectedInstOperands,
     /*  22785 */     // GIR_Coverage, 5475,
     /*  22785 */     GIR_EraseRootFromParent_Done,
     /*  22786 */   // Label 450: @22786
     /*  22786 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(22863), // Rule ID 496 //
     /*  22791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22826 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22830 */     // MIs[2] Operand 1
     /*  22830 */     // No operand predicates
     /*  22830 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22836 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }))  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  22843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22849 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22855 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22861 */     GIR_RootConstrainSelectedInstOperands,
     /*  22862 */     // GIR_Coverage, 496,
     /*  22862 */     GIR_EraseRootFromParent_Done,
     /*  22863 */   // Label 451: @22863
     /*  22863 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(22934), // Rule ID 5478 //
     /*  22868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22896 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22906 */     // (or:{ *:[i32] } (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2ORNrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  22906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNrr),
     /*  22909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  22913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  22917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22920 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22926 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22932 */     GIR_RootConstrainSelectedInstOperands,
     /*  22933 */     // GIR_Coverage, 5478,
     /*  22933 */     GIR_EraseRootFromParent_Done,
     /*  22934 */   // Label 452: @22934
     /*  22934 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(23005), // Rule ID 497 //
     /*  22939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22971 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22977 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (t2ORNrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  22977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNrr),
     /*  22980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22982 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  22984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  22988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22991 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22997 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23003 */     GIR_RootConstrainSelectedInstOperands,
     /*  23004 */     // GIR_Coverage, 497,
     /*  23004 */     GIR_EraseRootFromParent_Done,
     /*  23005 */   // Label 453: @23005
     /*  23005 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(23060), // Rule ID 1848 //
     /*  23010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /*  23013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  23017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23021 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294901760),
     /*  23032 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$src, 4294901760:{ *:[i32] })  =>  (MOVTi16:{ *:[i32] } GPR:{ *:[i32] }:$src, 65535:{ *:[i32] })
     /*  23032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVTi16),
     /*  23035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23037 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  23039 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(65535),
     /*  23049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23052 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23058 */     GIR_RootConstrainSelectedInstOperands,
     /*  23059 */     // GIR_Coverage, 1848,
     /*  23059 */     GIR_EraseRootFromParent_Done,
     /*  23060 */   // Label 454: @23060
     /*  23060 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(23115), // Rule ID 2094 //
     /*  23065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  23068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23076 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294901760),
     /*  23087 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$src, 4294901760:{ *:[i32] })  =>  (t2MOVTi16:{ *:[i32] } rGPR:{ *:[i32] }:$src, 65535:{ *:[i32] })
     /*  23087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVTi16),
     /*  23090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23092 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  23094 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(65535),
     /*  23104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23107 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23113 */     GIR_RootConstrainSelectedInstOperands,
     /*  23114 */     // GIR_Coverage, 2094,
     /*  23114 */     GIR_EraseRootFromParent_Done,
     /*  23115 */   // Label 455: @23115
     /*  23115 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(23172), // Rule ID 151 //
     /*  23120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  23123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  23143 */     // MIs[1] Operand 1
     /*  23143 */     // No operand predicates
     /*  23143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23145 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (ORRri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ORRri),
     /*  23148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23150 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  23155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23158 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23164 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23170 */     GIR_RootConstrainSelectedInstOperands,
     /*  23171 */     // GIR_Coverage, 151,
     /*  23171 */     GIR_EraseRootFromParent_Done,
     /*  23172 */   // Label 456: @23172
     /*  23172 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(23229), // Rule ID 484 //
     /*  23177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  23180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  23200 */     // MIs[1] Operand 1
     /*  23200 */     // No operand predicates
     /*  23200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23202 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2ORRri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORRri),
     /*  23205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  23212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23215 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23227 */     GIR_RootConstrainSelectedInstOperands,
     /*  23228 */     // GIR_Coverage, 484,
     /*  23228 */     GIR_EraseRootFromParent_Done,
     /*  23229 */   // Label 457: @23229
     /*  23229 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(23275), // Rule ID 152 //
     /*  23234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  23237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23249 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (ORRrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  23249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ORRrr),
     /*  23252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  23258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23261 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23267 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23273 */     GIR_RootConstrainSelectedInstOperands,
     /*  23274 */     // GIR_Coverage, 152,
     /*  23274 */     GIR_EraseRootFromParent_Done,
     /*  23275 */   // Label 458: @23275
     /*  23275 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(23321), // Rule ID 325 //
     /*  23280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  23283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  23287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  23291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  23295 */     // (or:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tORR:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  23295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tORR),
     /*  23298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  23300 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  23306 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  23310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23313 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23319 */     GIR_RootConstrainSelectedInstOperands,
     /*  23320 */     // GIR_Coverage, 325,
     /*  23320 */     GIR_EraseRootFromParent_Done,
     /*  23321 */   // Label 459: @23321
     /*  23321 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(23367), // Rule ID 485 //
     /*  23326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  23329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23341 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ORRrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  23341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  23344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23346 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  23350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23353 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23359 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23365 */     GIR_RootConstrainSelectedInstOperands,
     /*  23366 */     // GIR_Coverage, 485,
     /*  23366 */     GIR_EraseRootFromParent_Done,
     /*  23367 */   // Label 460: @23367
     /*  23367 */   GIM_Reject,
     /*  23368 */ // Label 415: @23368
     /*  23368 */ GIM_Reject,
     /*  23369 */ // Label 402: @23369
     /*  23369 */ GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(23415), // Rule ID 2532 //
     /*  23374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  23380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  23383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23391 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23395 */   // (or:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)  =>  (VORRd:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)
     /*  23395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  23398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23400 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  23402 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  23404 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23407 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23413 */   GIR_RootConstrainSelectedInstOperands,
     /*  23414 */   // GIR_Coverage, 2532,
     /*  23414 */   GIR_EraseRootFromParent_Done,
     /*  23415 */ // Label 461: @23415
     /*  23415 */ GIM_Reject,
     /*  23416 */ // Label 403: @23416
     /*  23416 */ GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(23533), // Rule ID 1834 //
     /*  23421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  23427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  23430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23438 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23442 */   // (or:{ *:[v2i1] } VCCR:{ *:[v2i1] }:$p1, VCCR:{ *:[v2i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  23442 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  23445 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23449 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23454 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  23458 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23463 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  23466 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23470 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23475 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  23479 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23484 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  23487 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  23491 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23496 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23499 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  23502 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  23505 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23511 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23517 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23524 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23527 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23532 */   // GIR_Coverage, 1834,
     /*  23532 */   GIR_EraseRootFromParent_Done,
     /*  23533 */ // Label 462: @23533
     /*  23533 */ GIM_Reject,
     /*  23534 */ // Label 404: @23534
     /*  23534 */ GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(23580), // Rule ID 1137 //
     /*  23539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  23545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  23548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23556 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23560 */   // (or:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VORRd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  23560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  23563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23565 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  23567 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  23569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23572 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23578 */   GIR_RootConstrainSelectedInstOperands,
     /*  23579 */   // GIR_Coverage, 1137,
     /*  23579 */   GIR_EraseRootFromParent_Done,
     /*  23580 */ // Label 463: @23580
     /*  23580 */ GIM_Reject,
     /*  23581 */ // Label 405: @23581
     /*  23581 */ GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(23694),
     /*  23586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  23589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  23592 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(23632), // Rule ID 2535 //
     /*  23597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23612 */     // (or:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)  =>  (VORRq:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)
     /*  23612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  23615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23617 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  23619 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  23621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23630 */     GIR_RootConstrainSelectedInstOperands,
     /*  23631 */     // GIR_Coverage, 2535,
     /*  23631 */     GIR_EraseRootFromParent_Done,
     /*  23632 */   // Label 465: @23632
     /*  23632 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(23693), // Rule ID 3384 //
     /*  23637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23652 */     // (or:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)  =>  (MVE_VORR:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)
     /*  23652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  23655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  23667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  23669 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  23671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  23673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23676 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23682 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23691 */     GIR_RootConstrainSelectedInstOperands,
     /*  23692 */     // GIR_Coverage, 3384,
     /*  23692 */     GIR_EraseRootFromParent_Done,
     /*  23693 */   // Label 466: @23693
     /*  23693 */   GIM_Reject,
     /*  23694 */ // Label 464: @23694
     /*  23694 */ GIM_Reject,
     /*  23695 */ // Label 406: @23695
     /*  23695 */ GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(23812), // Rule ID 1835 //
     /*  23700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  23706 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  23709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23717 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23721 */   // (or:{ *:[v4i1] } VCCR:{ *:[v4i1] }:$p1, VCCR:{ *:[v4i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  23721 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  23724 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23728 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23733 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  23737 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23742 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  23745 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23749 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23754 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  23758 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23763 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  23766 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  23770 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23775 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23778 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  23781 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  23784 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23790 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23796 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23801 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23803 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23806 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23811 */   // GIR_Coverage, 1835,
     /*  23811 */   GIR_EraseRootFromParent_Done,
     /*  23812 */ // Label 467: @23812
     /*  23812 */ GIM_Reject,
     /*  23813 */ // Label 407: @23813
     /*  23813 */ GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(23859), // Rule ID 2531 //
     /*  23818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23835 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23839 */   // (or:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)  =>  (VORRd:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)
     /*  23839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  23842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23844 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  23846 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  23848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23851 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23857 */   GIR_RootConstrainSelectedInstOperands,
     /*  23858 */   // GIR_Coverage, 2531,
     /*  23858 */   GIR_EraseRootFromParent_Done,
     /*  23859 */ // Label 468: @23859
     /*  23859 */ GIM_Reject,
     /*  23860 */ // Label 408: @23860
     /*  23860 */ GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(23973),
     /*  23865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23871 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(23911), // Rule ID 1138 //
     /*  23876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23891 */     // (or:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VORRq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  23891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  23894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23896 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  23898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  23900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23903 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23909 */     GIR_RootConstrainSelectedInstOperands,
     /*  23910 */     // GIR_Coverage, 1138,
     /*  23910 */     GIR_EraseRootFromParent_Done,
     /*  23911 */   // Label 470: @23911
     /*  23911 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(23972), // Rule ID 3380 //
     /*  23916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23931 */     // (or:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VORR:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  23931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  23934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  23946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  23948 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  23950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  23952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23955 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23961 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23970 */     GIR_RootConstrainSelectedInstOperands,
     /*  23971 */     // GIR_Coverage, 3380,
     /*  23971 */     GIR_EraseRootFromParent_Done,
     /*  23972 */   // Label 471: @23972
     /*  23972 */   GIM_Reject,
     /*  23973 */ // Label 469: @23973
     /*  23973 */ GIM_Reject,
     /*  23974 */ // Label 409: @23974
     /*  23974 */ GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(24091), // Rule ID 1836 //
     /*  23979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  23985 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  23988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23996 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24000 */   // (or:{ *:[v8i1] } VCCR:{ *:[v8i1] }:$p1, VCCR:{ *:[v8i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  24000 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  24003 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24007 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24012 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  24016 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24021 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  24024 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24028 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24033 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  24037 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24042 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  24045 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  24049 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24054 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  24057 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  24060 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  24063 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24069 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24075 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  24077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24082 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24085 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24090 */   // GIR_Coverage, 1836,
     /*  24090 */   GIR_EraseRootFromParent_Done,
     /*  24091 */ // Label 472: @24091
     /*  24091 */ GIM_Reject,
     /*  24092 */ // Label 410: @24092
     /*  24092 */ GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(24138), // Rule ID 2530 //
     /*  24097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  24110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  24114 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  24118 */   // (or:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)  =>  (VORRd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)
     /*  24118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  24121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  24123 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  24125 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  24127 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24130 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24136 */   GIR_RootConstrainSelectedInstOperands,
     /*  24137 */   // GIR_Coverage, 2530,
     /*  24137 */   GIR_EraseRootFromParent_Done,
     /*  24138 */ // Label 473: @24138
     /*  24138 */ GIM_Reject,
     /*  24139 */ // Label 411: @24139
     /*  24139 */ GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(24252),
     /*  24144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24147 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  24150 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(24190), // Rule ID 2534 //
     /*  24155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24170 */     // (or:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)  =>  (VORRq:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)
     /*  24170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  24173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  24175 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  24177 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  24179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24182 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24188 */     GIR_RootConstrainSelectedInstOperands,
     /*  24189 */     // GIR_Coverage, 2534,
     /*  24189 */     GIR_EraseRootFromParent_Done,
     /*  24190 */   // Label 475: @24190
     /*  24190 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(24251), // Rule ID 3376 //
     /*  24195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  24198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24210 */     // (or:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VORR:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  24210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  24213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  24217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  24225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  24227 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  24229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  24231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24234 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24240 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24249 */     GIR_RootConstrainSelectedInstOperands,
     /*  24250 */     // GIR_Coverage, 3376,
     /*  24250 */     GIR_EraseRootFromParent_Done,
     /*  24251 */   // Label 476: @24251
     /*  24251 */   GIM_Reject,
     /*  24252 */ // Label 474: @24252
     /*  24252 */ GIM_Reject,
     /*  24253 */ // Label 412: @24253
     /*  24253 */ GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(24370), // Rule ID 1837 //
     /*  24258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  24261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  24264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  24267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24275 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24279 */   // (or:{ *:[v16i1] } VCCR:{ *:[v16i1] }:$p1, VCCR:{ *:[v16i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  24279 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  24282 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24286 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24291 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  24295 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24300 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  24303 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24307 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24312 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  24316 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24321 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  24324 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  24328 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24333 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  24336 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  24339 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  24342 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24348 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24354 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  24356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24359 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24361 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24364 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24369 */   // GIR_Coverage, 1837,
     /*  24369 */   GIR_EraseRootFromParent_Done,
     /*  24370 */ // Label 477: @24370
     /*  24370 */ GIM_Reject,
     /*  24371 */ // Label 413: @24371
     /*  24371 */ GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(24484),
     /*  24376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  24379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  24382 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(24422), // Rule ID 2533 //
     /*  24387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24402 */     // (or:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)  =>  (VORRq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)
     /*  24402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  24405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  24407 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  24409 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  24411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24414 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24420 */     GIR_RootConstrainSelectedInstOperands,
     /*  24421 */     // GIR_Coverage, 2533,
     /*  24421 */     GIR_EraseRootFromParent_Done,
     /*  24422 */   // Label 479: @24422
     /*  24422 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(24483), // Rule ID 3372 //
     /*  24427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  24430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24442 */     // (or:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VORR:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  24442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  24445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  24449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  24457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  24459 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  24461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  24463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24466 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24472 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24481 */     GIR_RootConstrainSelectedInstOperands,
     /*  24482 */     // GIR_Coverage, 3372,
     /*  24482 */     GIR_EraseRootFromParent_Done,
     /*  24483 */   // Label 480: @24483
     /*  24483 */   GIM_Reject,
     /*  24484 */ // Label 478: @24484
     /*  24484 */ GIM_Reject,
     /*  24485 */ // Label 414: @24485
     /*  24485 */ GIM_Reject,
     /*  24486 */ // Label 7: @24486
     /*  24486 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 494*/ GIMT_Encode4(26180),
     /*  24497 */ /*GILLT_s32*//*Label 481*/ GIMT_Encode4(24557),
     /*  24501 */ /*GILLT_s64*//*Label 482*/ GIMT_Encode4(25064),
     /*  24505 */ /*GILLT_v2s1*//*Label 483*/ GIMT_Encode4(25111),
     /*  24509 */ /*GILLT_v2s32*//*Label 484*/ GIMT_Encode4(25229),
     /*  24513 */ /*GILLT_v2s64*//*Label 485*/ GIMT_Encode4(25276),
     /*  24517 */ /*GILLT_v4s1*//*Label 486*/ GIMT_Encode4(25390),
     /*  24521 */ /*GILLT_v4s16*//*Label 487*/ GIMT_Encode4(25508),
     /*  24525 */ /*GILLT_v4s32*//*Label 488*/ GIMT_Encode4(25555), GIMT_Encode4(0),
     /*  24533 */ /*GILLT_v8s1*//*Label 489*/ GIMT_Encode4(25669),
     /*  24537 */ /*GILLT_v8s8*//*Label 490*/ GIMT_Encode4(25787),
     /*  24541 */ /*GILLT_v8s16*//*Label 491*/ GIMT_Encode4(25834), GIMT_Encode4(0),
     /*  24549 */ /*GILLT_v16s1*//*Label 492*/ GIMT_Encode4(25948),
     /*  24553 */ /*GILLT_v16s8*//*Label 493*/ GIMT_Encode4(26066),
     /*  24557 */ // Label 481: @24557
     /*  24557 */ GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(25063),
     /*  24562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  24565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  24568 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(24623), // Rule ID 5480 //
     /*  24573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, uint8_t(-1),
     /*  24584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24592 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  24596 */     // MIs[1] Operand 1
     /*  24596 */     // No operand predicates
     /*  24596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24598 */     // (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2MVNi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  24598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /*  24601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24609 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24621 */     GIR_RootConstrainSelectedInstOperands,
     /*  24622 */     // GIR_Coverage, 5480,
     /*  24622 */     GIR_EraseRootFromParent_Done,
     /*  24623 */   // Label 496: @24623
     /*  24623 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(24678), // Rule ID 499 //
     /*  24628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  24647 */     // MIs[1] Operand 1
     /*  24647 */     // No operand predicates
     /*  24647 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24653 */     // (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] })  =>  (t2MVNi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  24653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /*  24656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24658 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24664 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24670 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24676 */     GIR_RootConstrainSelectedInstOperands,
     /*  24677 */     // GIR_Coverage, 499,
     /*  24677 */     GIR_EraseRootFromParent_Done,
     /*  24678 */   // Label 497: @24678
     /*  24678 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(24722), // Rule ID 500 //
     /*  24683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24694 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24698 */     // (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] })  =>  (t2MVNr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /*  24698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MVNr),
     /*  24701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24703 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  24705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24708 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24714 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24720 */     GIR_RootConstrainSelectedInstOperands,
     /*  24721 */     // GIR_Coverage, 500,
     /*  24721 */     GIR_EraseRootFromParent_Done,
     /*  24722 */   // Label 498: @24722
     /*  24722 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(24766), // Rule ID 165 //
     /*  24727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  24730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24738 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24742 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rm, -1:{ *:[i32] })  =>  (MVNr:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /*  24742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVNr),
     /*  24745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24747 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  24749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24752 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24758 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24764 */     GIR_RootConstrainSelectedInstOperands,
     /*  24765 */     // GIR_Coverage, 165,
     /*  24765 */     GIR_EraseRootFromParent_Done,
     /*  24766 */   // Label 499: @24766
     /*  24766 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(24810), // Rule ID 324 //
     /*  24771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  24774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24782 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24786 */     // (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, -1:{ *:[i32] })  =>  (tMVN:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)
     /*  24786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMVN),
     /*  24789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  24797 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24802 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24808 */     GIR_RootConstrainSelectedInstOperands,
     /*  24809 */     // GIR_Coverage, 324,
     /*  24809 */     GIR_EraseRootFromParent_Done,
     /*  24810 */   // Label 500: @24810
     /*  24810 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(24867), // Rule ID 155 //
     /*  24815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  24818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24834 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  24838 */     // MIs[1] Operand 1
     /*  24838 */     // No operand predicates
     /*  24838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24840 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (EORri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::EORri),
     /*  24843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24853 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24859 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24865 */     GIR_RootConstrainSelectedInstOperands,
     /*  24866 */     // GIR_Coverage, 155,
     /*  24866 */     GIR_EraseRootFromParent_Done,
     /*  24867 */   // Label 501: @24867
     /*  24867 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(24924), // Rule ID 487 //
     /*  24872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  24895 */     // MIs[1] Operand 1
     /*  24895 */     // No operand predicates
     /*  24895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24897 */     // (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2EORri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2EORri),
     /*  24900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24902 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24910 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24916 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24922 */     GIR_RootConstrainSelectedInstOperands,
     /*  24923 */     // GIR_Coverage, 487,
     /*  24923 */     GIR_EraseRootFromParent_Done,
     /*  24924 */   // Label 502: @24924
     /*  24924 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(24970), // Rule ID 156 //
     /*  24929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  24932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24944 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (EORrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  24944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::EORrr),
     /*  24947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  24953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24956 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24968 */     GIR_RootConstrainSelectedInstOperands,
     /*  24969 */     // GIR_Coverage, 156,
     /*  24969 */     GIR_EraseRootFromParent_Done,
     /*  24970 */   // Label 503: @24970
     /*  24970 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(25016), // Rule ID 317 //
     /*  24975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  24978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24990 */     // (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tEOR:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  24990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tEOR),
     /*  24993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  24995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  25001 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  25003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  25005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25008 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25014 */     GIR_RootConstrainSelectedInstOperands,
     /*  25015 */     // GIR_Coverage, 317,
     /*  25015 */     GIR_EraseRootFromParent_Done,
     /*  25016 */   // Label 504: @25016
     /*  25016 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(25062), // Rule ID 488 //
     /*  25021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  25024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25036 */     // (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2EORrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  25036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  25041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  25043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  25045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25048 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25054 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25060 */     GIR_RootConstrainSelectedInstOperands,
     /*  25061 */     // GIR_Coverage, 488,
     /*  25061 */     GIR_EraseRootFromParent_Done,
     /*  25062 */   // Label 505: @25062
     /*  25062 */   GIM_Reject,
     /*  25063 */ // Label 495: @25063
     /*  25063 */ GIM_Reject,
     /*  25064 */ // Label 482: @25064
     /*  25064 */ GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(25110), // Rule ID 2538 //
     /*  25069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  25075 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  25078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25086 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25090 */   // (xor:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)  =>  (VEORd:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)
     /*  25090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25093 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25095 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25097 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25099 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25102 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25108 */   GIR_RootConstrainSelectedInstOperands,
     /*  25109 */   // GIR_Coverage, 2538,
     /*  25109 */   GIR_EraseRootFromParent_Done,
     /*  25110 */ // Label 506: @25110
     /*  25110 */ GIM_Reject,
     /*  25111 */ // Label 483: @25111
     /*  25111 */ GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(25228), // Rule ID 1830 //
     /*  25116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  25122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  25125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25133 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25137 */   // (xor:{ *:[v2i1] } VCCR:{ *:[v2i1] }:$p1, VCCR:{ *:[v2i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25137 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25140 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25144 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25149 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25153 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25158 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25161 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25165 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25170 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  25174 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25179 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  25182 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25186 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25191 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25194 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25197 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  25200 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25206 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25212 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25219 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25222 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25227 */   // GIR_Coverage, 1830,
     /*  25227 */   GIR_EraseRootFromParent_Done,
     /*  25228 */ // Label 507: @25228
     /*  25228 */ GIM_Reject,
     /*  25229 */ // Label 484: @25229
     /*  25229 */ GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(25275), // Rule ID 1135 //
     /*  25234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  25240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  25243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25247 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25251 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25255 */   // (xor:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VEORd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  25255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25258 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25260 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  25262 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  25264 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25267 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25273 */   GIR_RootConstrainSelectedInstOperands,
     /*  25274 */   // GIR_Coverage, 1135,
     /*  25274 */   GIR_EraseRootFromParent_Done,
     /*  25275 */ // Label 508: @25275
     /*  25275 */ GIM_Reject,
     /*  25276 */ // Label 485: @25276
     /*  25276 */ GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(25389),
     /*  25281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  25284 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  25287 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(25327), // Rule ID 2541 //
     /*  25292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25307 */     // (xor:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)  =>  (VEORq:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)
     /*  25307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  25310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25312 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25314 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25325 */     GIR_RootConstrainSelectedInstOperands,
     /*  25326 */     // GIR_Coverage, 2541,
     /*  25326 */     GIR_EraseRootFromParent_Done,
     /*  25327 */   // Label 510: @25327
     /*  25327 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(25388), // Rule ID 3398 //
     /*  25332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25347 */     // (xor:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)  =>  (MVE_VEOR:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)
     /*  25347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  25350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  25354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  25362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  25364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  25366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  25368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25371 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25377 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25386 */     GIR_RootConstrainSelectedInstOperands,
     /*  25387 */     // GIR_Coverage, 3398,
     /*  25387 */     GIR_EraseRootFromParent_Done,
     /*  25388 */   // Label 511: @25388
     /*  25388 */   GIM_Reject,
     /*  25389 */ // Label 509: @25389
     /*  25389 */ GIM_Reject,
     /*  25390 */ // Label 486: @25390
     /*  25390 */ GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(25507), // Rule ID 1831 //
     /*  25395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  25401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  25404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25412 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25416 */   // (xor:{ *:[v4i1] } VCCR:{ *:[v4i1] }:$p1, VCCR:{ *:[v4i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25416 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25419 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25423 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25428 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25432 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25437 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25440 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25444 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25449 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  25453 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25458 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  25461 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25465 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25470 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25473 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25476 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  25479 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25485 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25491 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25498 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25501 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25506 */   // GIR_Coverage, 1831,
     /*  25506 */   GIR_EraseRootFromParent_Done,
     /*  25507 */ // Label 512: @25507
     /*  25507 */ GIM_Reject,
     /*  25508 */ // Label 487: @25508
     /*  25508 */ GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(25554), // Rule ID 2537 //
     /*  25513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25530 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25534 */   // (xor:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)  =>  (VEORd:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)
     /*  25534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25539 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25541 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25543 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25546 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25552 */   GIR_RootConstrainSelectedInstOperands,
     /*  25553 */   // GIR_Coverage, 2537,
     /*  25553 */   GIR_EraseRootFromParent_Done,
     /*  25554 */ // Label 513: @25554
     /*  25554 */ GIM_Reject,
     /*  25555 */ // Label 488: @25555
     /*  25555 */ GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(25668),
     /*  25560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25563 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25566 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(25606), // Rule ID 1136 //
     /*  25571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25586 */     // (xor:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VEORq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  25586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  25589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  25593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  25595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25598 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25604 */     GIR_RootConstrainSelectedInstOperands,
     /*  25605 */     // GIR_Coverage, 1136,
     /*  25605 */     GIR_EraseRootFromParent_Done,
     /*  25606 */   // Label 515: @25606
     /*  25606 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(25667), // Rule ID 3394 //
     /*  25611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25626 */     // (xor:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VEOR:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  25626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  25629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  25633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  25641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  25643 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  25645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  25647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25665 */     GIR_RootConstrainSelectedInstOperands,
     /*  25666 */     // GIR_Coverage, 3394,
     /*  25666 */     GIR_EraseRootFromParent_Done,
     /*  25667 */   // Label 516: @25667
     /*  25667 */   GIM_Reject,
     /*  25668 */ // Label 514: @25668
     /*  25668 */ GIM_Reject,
     /*  25669 */ // Label 489: @25669
     /*  25669 */ GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(25786), // Rule ID 1832 //
     /*  25674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  25680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  25683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25691 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25695 */   // (xor:{ *:[v8i1] } VCCR:{ *:[v8i1] }:$p1, VCCR:{ *:[v8i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25695 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25698 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25702 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25707 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25711 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25716 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25719 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25723 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25728 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  25732 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25737 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  25740 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25744 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25749 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25752 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25755 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  25758 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25764 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25770 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25777 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25780 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25785 */   // GIR_Coverage, 1832,
     /*  25785 */   GIR_EraseRootFromParent_Done,
     /*  25786 */ // Label 517: @25786
     /*  25786 */ GIM_Reject,
     /*  25787 */ // Label 490: @25787
     /*  25787 */ GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(25833), // Rule ID 2536 //
     /*  25792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  25798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  25801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25809 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25813 */   // (xor:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)  =>  (VEORd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)
     /*  25813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25818 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25820 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25822 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25825 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25831 */   GIR_RootConstrainSelectedInstOperands,
     /*  25832 */   // GIR_Coverage, 2536,
     /*  25832 */   GIR_EraseRootFromParent_Done,
     /*  25833 */ // Label 518: @25833
     /*  25833 */ GIM_Reject,
     /*  25834 */ // Label 491: @25834
     /*  25834 */ GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(25947),
     /*  25839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25842 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  25845 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(25885), // Rule ID 2540 //
     /*  25850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25865 */     // (xor:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)  =>  (VEORq:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)
     /*  25865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  25868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25870 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25872 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25877 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25883 */     GIR_RootConstrainSelectedInstOperands,
     /*  25884 */     // GIR_Coverage, 2540,
     /*  25884 */     GIR_EraseRootFromParent_Done,
     /*  25885 */   // Label 520: @25885
     /*  25885 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(25946), // Rule ID 3390 //
     /*  25890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25905 */     // (xor:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VEOR:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  25905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  25908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  25912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  25920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  25922 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  25924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  25926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25929 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25935 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25944 */     GIR_RootConstrainSelectedInstOperands,
     /*  25945 */     // GIR_Coverage, 3390,
     /*  25945 */     GIR_EraseRootFromParent_Done,
     /*  25946 */   // Label 521: @25946
     /*  25946 */   GIM_Reject,
     /*  25947 */ // Label 519: @25947
     /*  25947 */ GIM_Reject,
     /*  25948 */ // Label 492: @25948
     /*  25948 */ GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(26065), // Rule ID 1833 //
     /*  25953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  25959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  25962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25970 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25974 */   // (xor:{ *:[v16i1] } VCCR:{ *:[v16i1] }:$p1, VCCR:{ *:[v16i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25974 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25977 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25981 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25986 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25990 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25995 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25998 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26002 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26007 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  26011 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  26016 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  26019 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  26023 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26028 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  26031 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  26034 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  26037 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26043 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26049 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  26051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26054 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26056 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  26059 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  26064 */   // GIR_Coverage, 1833,
     /*  26064 */   GIR_EraseRootFromParent_Done,
     /*  26065 */ // Label 522: @26065
     /*  26065 */ GIM_Reject,
     /*  26066 */ // Label 493: @26066
     /*  26066 */ GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(26179),
     /*  26071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  26074 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  26077 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(26117), // Rule ID 2539 //
     /*  26082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26097 */     // (xor:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)  =>  (VEORq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)
     /*  26097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  26100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  26102 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  26104 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  26106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  26109 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26115 */     GIR_RootConstrainSelectedInstOperands,
     /*  26116 */     // GIR_Coverage, 2539,
     /*  26116 */     GIR_EraseRootFromParent_Done,
     /*  26117 */   // Label 524: @26117
     /*  26117 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(26178), // Rule ID 3386 //
     /*  26122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  26125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  26129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  26133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  26137 */     // (xor:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VEOR:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  26137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  26140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  26144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  26152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  26154 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  26156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  26158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  26161 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26167 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  26176 */     GIR_RootConstrainSelectedInstOperands,
     /*  26177 */     // GIR_Coverage, 3386,
     /*  26177 */     GIR_EraseRootFromParent_Done,
     /*  26178 */   // Label 525: @26178
     /*  26178 */   GIM_Reject,
     /*  26179 */ // Label 523: @26179
     /*  26179 */ GIM_Reject,
     /*  26180 */ // Label 494: @26180
     /*  26180 */ GIM_Reject,
     /*  26181 */ // Label 8: @26181
     /*  26181 */ GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(26567),
     /*  26186 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  26189 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(16), /*)*//*default:*//*Label 531*/ GIMT_Encode4(26566),
     /*  26200 */   /*GILLT_v2s64*//*Label 527*/ GIMT_Encode4(26244), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26212 */   /*GILLT_v4s32*//*Label 528*/ GIMT_Encode4(26302), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26228 */   /*GILLT_v8s16*//*Label 529*/ GIMT_Encode4(26405), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26240 */   /*GILLT_v16s8*//*Label 530*/ GIMT_Encode4(26508),
     /*  26244 */   // Label 527: @26244
     /*  26244 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(26301), // Rule ID 3024 //
     /*  26249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26252 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  26255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  26258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26270 */     // (concat_vectors:{ *:[v2i64] } DPR:{ *:[v1i64] }:$Dn, DPR:{ *:[v1i64] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v2i64] } QPR:{ *:[i32] }, DPR:{ *:[v1i64] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v1i64] }:$Dm, dsub_1:{ *:[i32] })
     /*  26270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26275 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26277 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26282 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26285 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26290 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26295 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26300 */     // GIR_Coverage, 3024,
     /*  26300 */     GIR_EraseRootFromParent_Done,
     /*  26301 */   // Label 532: @26301
     /*  26301 */   GIM_Reject,
     /*  26302 */   // Label 528: @26302
     /*  26302 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(26404),
     /*  26307 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  26310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  26313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26325 */     GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(26364), // Rule ID 3025 //
     /*  26330 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26333 */       // (concat_vectors:{ *:[v4i32] } DPR:{ *:[v2i32] }:$Dn, DPR:{ *:[v2i32] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v4i32] } QPR:{ *:[i32] }, DPR:{ *:[v2i32] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v2i32] }:$Dm, dsub_1:{ *:[i32] })
     /*  26333 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26336 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26338 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26340 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26343 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26345 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26348 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26353 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26358 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26363 */       // GIR_Coverage, 3025,
     /*  26363 */       GIR_EraseRootFromParent_Done,
     /*  26364 */     // Label 534: @26364
     /*  26364 */     GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(26403), // Rule ID 3028 //
     /*  26369 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26372 */       // (concat_vectors:{ *:[v4f32] } DPR:{ *:[v2f32] }:$Dn, DPR:{ *:[v2f32] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v4f32] } QPR:{ *:[i32] }, DPR:{ *:[v2f32] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v2f32] }:$Dm, dsub_1:{ *:[i32] })
     /*  26372 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26375 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26377 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26379 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26382 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26384 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26387 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26392 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26397 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26402 */       // GIR_Coverage, 3028,
     /*  26402 */       GIR_EraseRootFromParent_Done,
     /*  26403 */     // Label 535: @26403
     /*  26403 */     GIM_Reject,
     /*  26404 */   // Label 533: @26404
     /*  26404 */   GIM_Reject,
     /*  26405 */   // Label 529: @26405
     /*  26405 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(26507),
     /*  26410 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26428 */     GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(26467), // Rule ID 3026 //
     /*  26433 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26436 */       // (concat_vectors:{ *:[v8i16] } DPR:{ *:[v4i16] }:$Dn, DPR:{ *:[v4i16] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v8i16] } QPR:{ *:[i32] }, DPR:{ *:[v4i16] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v4i16] }:$Dm, dsub_1:{ *:[i32] })
     /*  26436 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26439 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26441 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26443 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26446 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26448 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26451 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26456 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26461 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26466 */       // GIR_Coverage, 3026,
     /*  26466 */       GIR_EraseRootFromParent_Done,
     /*  26467 */     // Label 537: @26467
     /*  26467 */     GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(26506), // Rule ID 3029 //
     /*  26472 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26475 */       // (concat_vectors:{ *:[v8f16] } DPR:{ *:[v4f16] }:$Dn, DPR:{ *:[v4f16] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v8f16] } QPR:{ *:[i32] }, DPR:{ *:[v4f16] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v4f16] }:$Dm, dsub_1:{ *:[i32] })
     /*  26475 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26478 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26480 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26482 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26485 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26487 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26490 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26495 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26500 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26505 */       // GIR_Coverage, 3029,
     /*  26505 */       GIR_EraseRootFromParent_Done,
     /*  26506 */     // Label 538: @26506
     /*  26506 */     GIM_Reject,
     /*  26507 */   // Label 536: @26507
     /*  26507 */   GIM_Reject,
     /*  26508 */   // Label 530: @26508
     /*  26508 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(26565), // Rule ID 3027 //
     /*  26513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26516 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  26519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  26522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26534 */     // (concat_vectors:{ *:[v16i8] } DPR:{ *:[v8i8] }:$Dn, DPR:{ *:[v8i8] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v16i8] } QPR:{ *:[i32] }, DPR:{ *:[v8i8] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v8i8] }:$Dm, dsub_1:{ *:[i32] })
     /*  26534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26541 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26546 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26549 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26554 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26559 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26564 */     // GIR_Coverage, 3027,
     /*  26564 */     GIR_EraseRootFromParent_Done,
     /*  26565 */   // Label 539: @26565
     /*  26565 */   GIM_Reject,
     /*  26566 */   // Label 531: @26566
     /*  26566 */   GIM_Reject,
     /*  26567 */ // Label 526: @26567
     /*  26567 */ GIM_Reject,
     /*  26568 */ // Label 9: @26568
     /*  26568 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 549*/ GIMT_Encode4(35579),
     /*  26579 */ /*GILLT_s32*//*Label 540*/ GIMT_Encode4(26639),
     /*  26583 */ /*GILLT_s64*//*Label 541*/ GIMT_Encode4(26787), GIMT_Encode4(0),
     /*  26591 */ /*GILLT_v2s32*//*Label 542*/ GIMT_Encode4(27542),
     /*  26595 */ /*GILLT_v2s64*//*Label 543*/ GIMT_Encode4(28297), GIMT_Encode4(0),
     /*  26603 */ /*GILLT_v4s16*//*Label 544*/ GIMT_Encode4(30016),
     /*  26607 */ /*GILLT_v4s32*//*Label 545*/ GIMT_Encode4(30771), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26619 */ /*GILLT_v8s8*//*Label 546*/ GIMT_Encode4(32490),
     /*  26623 */ /*GILLT_v8s16*//*Label 547*/ GIMT_Encode4(32905), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26635 */ /*GILLT_v16s8*//*Label 548*/ GIMT_Encode4(34624),
     /*  26639 */ // Label 540: @26639
     /*  26639 */ GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(26786),
     /*  26644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  26647 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(26681), // Rule ID 692 //
     /*  26652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs),
     /*  26655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  26659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  26663 */     // (bitconvert:{ *:[i32] } SPR:{ *:[f32] }:$Sn)  =>  (VMOVRS:{ *:[i32] } SPR:{ *:[f32] }:$Sn)
     /*  26663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVRS),
     /*  26666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  26668 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /*  26670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  26673 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26679 */     GIR_RootConstrainSelectedInstOperands,
     /*  26680 */     // GIR_Coverage, 692,
     /*  26680 */     GIR_EraseRootFromParent_Done,
     /*  26681 */   // Label 551: @26681
     /*  26681 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(26715), // Rule ID 693 //
     /*  26686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs_UseVMOVSR),
     /*  26689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  26693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  26697 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$Rt)  =>  (VMOVSR:{ *:[f32] } GPR:{ *:[i32] }:$Rt)
     /*  26697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVSR),
     /*  26700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sn]
     /*  26702 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rt
     /*  26704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  26707 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26713 */     GIR_RootConstrainSelectedInstOperands,
     /*  26714 */     // GIR_Coverage, 693,
     /*  26714 */     GIR_EraseRootFromParent_Done,
     /*  26715 */   // Label 552: @26715
     /*  26715 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(26785), // Rule ID 2718 //
     /*  26720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseVMOVSR_HasNEON),
     /*  26723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  26727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  26731 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (VMOVDRR:{ *:[f64] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$a), ssub_0:{ *:[i32] })
     /*  26731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  26734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VMOVDRR),
     /*  26738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26743 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /*  26747 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /*  26751 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  26754 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  26762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26767 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /*  26774 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  26779 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /*  26784 */     // GIR_Coverage, 2718,
     /*  26784 */     GIR_EraseRootFromParent_Done,
     /*  26785 */   // Label 553: @26785
     /*  26785 */   GIM_Reject,
     /*  26786 */ // Label 550: @26786
     /*  26786 */ GIM_Reject,
     /*  26787 */ // Label 541: @26787
     /*  26787 */ GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(26819), // Rule ID 2720 //
     /*  26792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  26798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26806 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26809 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26811 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26813 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26818 */   // GIR_Coverage, 2720,
     /*  26818 */   GIR_EraseRootFromParent_Done,
     /*  26819 */ // Label 554: @26819
     /*  26819 */ GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(26851), // Rule ID 2721 //
     /*  26824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  26830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26838 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  26838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26841 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26843 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26845 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26850 */   // GIR_Coverage, 2721,
     /*  26850 */   GIR_EraseRootFromParent_Done,
     /*  26851 */ // Label 555: @26851
     /*  26851 */ GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(26883), // Rule ID 2732 //
     /*  26856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  26862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26870 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26873 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26875 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26877 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26882 */   // GIR_Coverage, 2732,
     /*  26882 */   GIR_EraseRootFromParent_Done,
     /*  26883 */ // Label 556: @26883
     /*  26883 */ GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(26915), // Rule ID 2733 //
     /*  26888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  26894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26902 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26905 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26907 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26909 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26914 */   // GIR_Coverage, 2733,
     /*  26914 */   GIR_EraseRootFromParent_Done,
     /*  26915 */ // Label 557: @26915
     /*  26915 */ GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(26947), // Rule ID 2734 //
     /*  26920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26934 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26937 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26939 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26941 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26946 */   // GIR_Coverage, 2734,
     /*  26946 */   GIR_EraseRootFromParent_Done,
     /*  26947 */ // Label 558: @26947
     /*  26947 */ GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(26979), // Rule ID 2735 //
     /*  26952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26966 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26969 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26971 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26973 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26978 */   // GIR_Coverage, 2735,
     /*  26978 */   GIR_EraseRootFromParent_Done,
     /*  26979 */ // Label 559: @26979
     /*  26979 */ GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(27011), // Rule ID 2736 //
     /*  26984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  26990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26998 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27001 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27005 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27010 */   // GIR_Coverage, 2736,
     /*  27010 */   GIR_EraseRootFromParent_Done,
     /*  27011 */ // Label 560: @27011
     /*  27011 */ GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(27043), // Rule ID 2737 //
     /*  27016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27030 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27033 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27035 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27037 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27042 */   // GIR_Coverage, 2737,
     /*  27042 */   GIR_EraseRootFromParent_Done,
     /*  27043 */ // Label 561: @27043
     /*  27043 */ GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(27075), // Rule ID 2738 //
     /*  27048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27062 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27065 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27067 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27069 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27074 */   // GIR_Coverage, 2738,
     /*  27074 */   GIR_EraseRootFromParent_Done,
     /*  27075 */ // Label 562: @27075
     /*  27075 */ GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(27107), // Rule ID 2739 //
     /*  27080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27094 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27097 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27099 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27101 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27106 */   // GIR_Coverage, 2739,
     /*  27106 */   GIR_EraseRootFromParent_Done,
     /*  27107 */ // Label 563: @27107
     /*  27107 */ GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(27139), // Rule ID 2740 //
     /*  27112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27126 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27129 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27131 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27133 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27138 */   // GIR_Coverage, 2740,
     /*  27138 */   GIR_EraseRootFromParent_Done,
     /*  27139 */ // Label 564: @27139
     /*  27139 */ GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(27171), // Rule ID 2741 //
     /*  27144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27158 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27161 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27163 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27165 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27170 */   // GIR_Coverage, 2741,
     /*  27170 */   GIR_EraseRootFromParent_Done,
     /*  27171 */ // Label 565: @27171
     /*  27171 */ GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(27208), // Rule ID 2804 //
     /*  27176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27190 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2f32] }:$src)  =>  (VREV64d32:{ *:[f64] } DPR:{ *:[v2f32] }:$src)
     /*  27190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27195 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27200 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27206 */   GIR_RootConstrainSelectedInstOperands,
     /*  27207 */   // GIR_Coverage, 2804,
     /*  27207 */   GIR_EraseRootFromParent_Done,
     /*  27208 */ // Label 566: @27208
     /*  27208 */ GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(27245), // Rule ID 2805 //
     /*  27213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27227 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2i32] }:$src)  =>  (VREV64d32:{ *:[f64] } DPR:{ *:[v2i32] }:$src)
     /*  27227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27230 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27232 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27237 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27243 */   GIR_RootConstrainSelectedInstOperands,
     /*  27244 */   // GIR_Coverage, 2805,
     /*  27244 */   GIR_EraseRootFromParent_Done,
     /*  27245 */ // Label 567: @27245
     /*  27245 */ GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(27282), // Rule ID 2806 //
     /*  27250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27264 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4f16] }:$src)  =>  (VREV64d16:{ *:[f64] } DPR:{ *:[v4f16] }:$src)
     /*  27264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27269 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27274 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27280 */   GIR_RootConstrainSelectedInstOperands,
     /*  27281 */   // GIR_Coverage, 2806,
     /*  27281 */   GIR_EraseRootFromParent_Done,
     /*  27282 */ // Label 568: @27282
     /*  27282 */ GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(27319), // Rule ID 2807 //
     /*  27287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27301 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4i16] }:$src)  =>  (VREV64d16:{ *:[f64] } DPR:{ *:[v4i16] }:$src)
     /*  27301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27306 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27311 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27317 */   GIR_RootConstrainSelectedInstOperands,
     /*  27318 */   // GIR_Coverage, 2807,
     /*  27318 */   GIR_EraseRootFromParent_Done,
     /*  27319 */ // Label 569: @27319
     /*  27319 */ GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(27356), // Rule ID 2808 //
     /*  27324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27338 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v8i8] }:$src)  =>  (VREV64d8:{ *:[f64] } DPR:{ *:[v8i8] }:$src)
     /*  27338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  27341 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27343 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27348 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27354 */   GIR_RootConstrainSelectedInstOperands,
     /*  27355 */   // GIR_Coverage, 2808,
     /*  27355 */   GIR_EraseRootFromParent_Done,
     /*  27356 */ // Label 570: @27356
     /*  27356 */ GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(27393), // Rule ID 2809 //
     /*  27361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27375 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2f32] }:$src)  =>  (VREV64d32:{ *:[v1i64] } DPR:{ *:[v2f32] }:$src)
     /*  27375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27380 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27385 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27391 */   GIR_RootConstrainSelectedInstOperands,
     /*  27392 */   // GIR_Coverage, 2809,
     /*  27392 */   GIR_EraseRootFromParent_Done,
     /*  27393 */ // Label 571: @27393
     /*  27393 */ GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(27430), // Rule ID 2810 //
     /*  27398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27412 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2i32] }:$src)  =>  (VREV64d32:{ *:[v1i64] } DPR:{ *:[v2i32] }:$src)
     /*  27412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27417 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27422 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27428 */   GIR_RootConstrainSelectedInstOperands,
     /*  27429 */   // GIR_Coverage, 2810,
     /*  27429 */   GIR_EraseRootFromParent_Done,
     /*  27430 */ // Label 572: @27430
     /*  27430 */ GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(27467), // Rule ID 2811 //
     /*  27435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27449 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4f16] }:$src)  =>  (VREV64d16:{ *:[v1i64] } DPR:{ *:[v4f16] }:$src)
     /*  27449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27454 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27459 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27465 */   GIR_RootConstrainSelectedInstOperands,
     /*  27466 */   // GIR_Coverage, 2811,
     /*  27466 */   GIR_EraseRootFromParent_Done,
     /*  27467 */ // Label 573: @27467
     /*  27467 */ GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(27504), // Rule ID 2812 //
     /*  27472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27486 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4i16] }:$src)  =>  (VREV64d16:{ *:[v1i64] } DPR:{ *:[v4i16] }:$src)
     /*  27486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27489 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27491 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27496 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27502 */   GIR_RootConstrainSelectedInstOperands,
     /*  27503 */   // GIR_Coverage, 2812,
     /*  27503 */   GIR_EraseRootFromParent_Done,
     /*  27504 */ // Label 574: @27504
     /*  27504 */ GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(27541), // Rule ID 2813 //
     /*  27509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27523 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v8i8] }:$src)  =>  (VREV64d8:{ *:[v1i64] } DPR:{ *:[v8i8] }:$src)
     /*  27523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  27526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27528 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27533 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27539 */   GIR_RootConstrainSelectedInstOperands,
     /*  27540 */   // GIR_Coverage, 2813,
     /*  27540 */   GIR_EraseRootFromParent_Done,
     /*  27541 */ // Label 575: @27541
     /*  27541 */ GIM_Reject,
     /*  27542 */ // Label 542: @27542
     /*  27542 */ GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(27574), // Rule ID 2722 //
     /*  27547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27561 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27564 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27566 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27568 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27573 */   // GIR_Coverage, 2722,
     /*  27573 */   GIR_EraseRootFromParent_Done,
     /*  27574 */ // Label 576: @27574
     /*  27574 */ GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(27606), // Rule ID 2723 //
     /*  27579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27593 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27596 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27598 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27600 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27605 */   // GIR_Coverage, 2723,
     /*  27605 */   GIR_EraseRootFromParent_Done,
     /*  27606 */ // Label 577: @27606
     /*  27606 */ GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(27638), // Rule ID 2742 //
     /*  27611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27625 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27628 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27630 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27632 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27637 */   // GIR_Coverage, 2742,
     /*  27637 */   GIR_EraseRootFromParent_Done,
     /*  27638 */ // Label 578: @27638
     /*  27638 */ GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(27670), // Rule ID 2743 //
     /*  27643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27657 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27660 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27662 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27664 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27669 */   // GIR_Coverage, 2743,
     /*  27669 */   GIR_EraseRootFromParent_Done,
     /*  27670 */ // Label 579: @27670
     /*  27670 */ GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(27702), // Rule ID 2744 //
     /*  27675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27689 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27692 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27694 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27696 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27701 */   // GIR_Coverage, 2744,
     /*  27701 */   GIR_EraseRootFromParent_Done,
     /*  27702 */ // Label 580: @27702
     /*  27702 */ GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(27734), // Rule ID 2745 //
     /*  27707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27721 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27724 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27726 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27728 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27733 */   // GIR_Coverage, 2745,
     /*  27733 */   GIR_EraseRootFromParent_Done,
     /*  27734 */ // Label 581: @27734
     /*  27734 */ GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(27766), // Rule ID 2746 //
     /*  27739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27753 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27756 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27758 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27760 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27765 */   // GIR_Coverage, 2746,
     /*  27765 */   GIR_EraseRootFromParent_Done,
     /*  27766 */ // Label 582: @27766
     /*  27766 */ GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(27798), // Rule ID 2747 //
     /*  27771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27785 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27788 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27790 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27792 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27797 */   // GIR_Coverage, 2747,
     /*  27797 */   GIR_EraseRootFromParent_Done,
     /*  27798 */ // Label 583: @27798
     /*  27798 */ GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(27830), // Rule ID 2748 //
     /*  27803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27817 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27820 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27822 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27824 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27829 */   // GIR_Coverage, 2748,
     /*  27829 */   GIR_EraseRootFromParent_Done,
     /*  27830 */ // Label 584: @27830
     /*  27830 */ GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(27862), // Rule ID 2749 //
     /*  27835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27849 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27852 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27854 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27856 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27861 */   // GIR_Coverage, 2749,
     /*  27861 */   GIR_EraseRootFromParent_Done,
     /*  27862 */ // Label 585: @27862
     /*  27862 */ GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(27894), // Rule ID 2750 //
     /*  27867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27881 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27884 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27886 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27888 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27893 */   // GIR_Coverage, 2750,
     /*  27893 */   GIR_EraseRootFromParent_Done,
     /*  27894 */ // Label 586: @27894
     /*  27894 */ GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(27926), // Rule ID 2751 //
     /*  27899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27913 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27916 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27918 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27920 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27925 */   // GIR_Coverage, 2751,
     /*  27925 */   GIR_EraseRootFromParent_Done,
     /*  27926 */ // Label 587: @27926
     /*  27926 */ GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(27963), // Rule ID 2814 //
     /*  27931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27945 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[f64] }:$src)  =>  (VREV64d32:{ *:[v2f32] } DPR:{ *:[f64] }:$src)
     /*  27945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27950 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27955 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27961 */   GIR_RootConstrainSelectedInstOperands,
     /*  27962 */   // GIR_Coverage, 2814,
     /*  27962 */   GIR_EraseRootFromParent_Done,
     /*  27963 */ // Label 588: @27963
     /*  27963 */ GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(28000), // Rule ID 2815 //
     /*  27968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27982 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d32:{ *:[v2f32] } DPR:{ *:[v1i64] }:$src)
     /*  27982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27987 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27992 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27998 */   GIR_RootConstrainSelectedInstOperands,
     /*  27999 */   // GIR_Coverage, 2815,
     /*  27999 */   GIR_EraseRootFromParent_Done,
     /*  28000 */ // Label 589: @28000
     /*  28000 */ GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(28037), // Rule ID 2816 //
     /*  28005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28019 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4f16] }:$src)  =>  (VREV32d16:{ *:[v2f32] } DPR:{ *:[v4f16] }:$src)
     /*  28019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28024 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28029 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28035 */   GIR_RootConstrainSelectedInstOperands,
     /*  28036 */   // GIR_Coverage, 2816,
     /*  28036 */   GIR_EraseRootFromParent_Done,
     /*  28037 */ // Label 590: @28037
     /*  28037 */ GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(28074), // Rule ID 2817 //
     /*  28042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28056 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4i16] }:$src)  =>  (VREV32d16:{ *:[v2f32] } DPR:{ *:[v4i16] }:$src)
     /*  28056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28061 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28066 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28072 */   GIR_RootConstrainSelectedInstOperands,
     /*  28073 */   // GIR_Coverage, 2817,
     /*  28073 */   GIR_EraseRootFromParent_Done,
     /*  28074 */ // Label 591: @28074
     /*  28074 */ GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(28111), // Rule ID 2818 //
     /*  28079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  28085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28093 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v8i8] }:$src)  =>  (VREV32d8:{ *:[v2f32] } DPR:{ *:[v8i8] }:$src)
     /*  28093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  28096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28098 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28103 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28109 */   GIR_RootConstrainSelectedInstOperands,
     /*  28110 */   // GIR_Coverage, 2818,
     /*  28110 */   GIR_EraseRootFromParent_Done,
     /*  28111 */ // Label 592: @28111
     /*  28111 */ GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(28148), // Rule ID 2819 //
     /*  28116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  28122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28130 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[f64] }:$src)  =>  (VREV64d32:{ *:[v2i32] } DPR:{ *:[f64] }:$src)
     /*  28130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  28133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28135 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28140 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28146 */   GIR_RootConstrainSelectedInstOperands,
     /*  28147 */   // GIR_Coverage, 2819,
     /*  28147 */   GIR_EraseRootFromParent_Done,
     /*  28148 */ // Label 593: @28148
     /*  28148 */ GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(28185), // Rule ID 2820 //
     /*  28153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  28159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28167 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d32:{ *:[v2i32] } DPR:{ *:[v1i64] }:$src)
     /*  28167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  28170 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28172 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28174 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28177 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28183 */   GIR_RootConstrainSelectedInstOperands,
     /*  28184 */   // GIR_Coverage, 2820,
     /*  28184 */   GIR_EraseRootFromParent_Done,
     /*  28185 */ // Label 594: @28185
     /*  28185 */ GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(28222), // Rule ID 2821 //
     /*  28190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28204 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4f16] }:$src)  =>  (VREV32d16:{ *:[v2i32] } DPR:{ *:[v4f16] }:$src)
     /*  28204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28209 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28214 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28220 */   GIR_RootConstrainSelectedInstOperands,
     /*  28221 */   // GIR_Coverage, 2821,
     /*  28221 */   GIR_EraseRootFromParent_Done,
     /*  28222 */ // Label 595: @28222
     /*  28222 */ GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(28259), // Rule ID 2822 //
     /*  28227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28241 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4i16] }:$src)  =>  (VREV32d16:{ *:[v2i32] } DPR:{ *:[v4i16] }:$src)
     /*  28241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28246 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28251 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28257 */   GIR_RootConstrainSelectedInstOperands,
     /*  28258 */   // GIR_Coverage, 2822,
     /*  28258 */   GIR_EraseRootFromParent_Done,
     /*  28259 */ // Label 596: @28259
     /*  28259 */ GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(28296), // Rule ID 2823 //
     /*  28264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  28270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28278 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v8i8] }:$src)  =>  (VREV32d8:{ *:[v2i32] } DPR:{ *:[v8i8] }:$src)
     /*  28278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  28281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28283 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28288 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28294 */   GIR_RootConstrainSelectedInstOperands,
     /*  28295 */   // GIR_Coverage, 2823,
     /*  28295 */   GIR_EraseRootFromParent_Done,
     /*  28296 */ // Label 597: @28296
     /*  28296 */ GIM_Reject,
     /*  28297 */ // Label 543: @28297
     /*  28297 */ GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(28329), // Rule ID 2726 //
     /*  28302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  28308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28316 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28319 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28321 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28323 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28328 */   // GIR_Coverage, 2726,
     /*  28328 */   GIR_EraseRootFromParent_Done,
     /*  28329 */ // Label 598: @28329
     /*  28329 */ GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(28361), // Rule ID 2727 //
     /*  28334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  28340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28348 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28351 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28353 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28355 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28360 */   // GIR_Coverage, 2727,
     /*  28360 */   GIR_EraseRootFromParent_Done,
     /*  28361 */ // Label 599: @28361
     /*  28361 */ GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(28393), // Rule ID 2768 //
     /*  28366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28380 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28383 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28385 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28387 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28392 */   // GIR_Coverage, 2768,
     /*  28392 */   GIR_EraseRootFromParent_Done,
     /*  28393 */ // Label 600: @28393
     /*  28393 */ GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(28425), // Rule ID 2769 //
     /*  28398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28412 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28415 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28417 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28419 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28424 */   // GIR_Coverage, 2769,
     /*  28424 */   GIR_EraseRootFromParent_Done,
     /*  28425 */ // Label 601: @28425
     /*  28425 */ GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(28457), // Rule ID 2770 //
     /*  28430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28444 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28447 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28449 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28451 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28456 */   // GIR_Coverage, 2770,
     /*  28456 */   GIR_EraseRootFromParent_Done,
     /*  28457 */ // Label 602: @28457
     /*  28457 */ GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(28489), // Rule ID 2771 //
     /*  28462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28476 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28479 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28481 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28483 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28488 */   // GIR_Coverage, 2771,
     /*  28488 */   GIR_EraseRootFromParent_Done,
     /*  28489 */ // Label 603: @28489
     /*  28489 */ GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(28521), // Rule ID 2772 //
     /*  28494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  28500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28508 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28511 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28513 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28515 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28520 */   // GIR_Coverage, 2772,
     /*  28520 */   GIR_EraseRootFromParent_Done,
     /*  28521 */ // Label 604: @28521
     /*  28521 */ GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(28553), // Rule ID 2773 //
     /*  28526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28540 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28543 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28545 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28547 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28552 */   // GIR_Coverage, 2773,
     /*  28552 */   GIR_EraseRootFromParent_Done,
     /*  28553 */ // Label 605: @28553
     /*  28553 */ GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(28585), // Rule ID 2774 //
     /*  28558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28572 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28575 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28577 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28579 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28584 */   // GIR_Coverage, 2774,
     /*  28584 */   GIR_EraseRootFromParent_Done,
     /*  28585 */ // Label 606: @28585
     /*  28585 */ GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(28617), // Rule ID 2775 //
     /*  28590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28604 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28607 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28609 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28611 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28616 */   // GIR_Coverage, 2775,
     /*  28616 */   GIR_EraseRootFromParent_Done,
     /*  28617 */ // Label 607: @28617
     /*  28617 */ GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(28649), // Rule ID 2776 //
     /*  28622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28636 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28639 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28641 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28643 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28648 */   // GIR_Coverage, 2776,
     /*  28648 */   GIR_EraseRootFromParent_Done,
     /*  28649 */ // Label 608: @28649
     /*  28649 */ GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(28681), // Rule ID 2777 //
     /*  28654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  28660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28668 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28671 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28673 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28675 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28680 */   // GIR_Coverage, 2777,
     /*  28680 */   GIR_EraseRootFromParent_Done,
     /*  28681 */ // Label 609: @28681
     /*  28681 */ GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(28718), // Rule ID 2840 //
     /*  28686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28700 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4f32] }:$src)  =>  (VREV64q32:{ *:[v2f64] } QPR:{ *:[v4f32] }:$src)
     /*  28700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28705 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28710 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28716 */   GIR_RootConstrainSelectedInstOperands,
     /*  28717 */   // GIR_Coverage, 2840,
     /*  28717 */   GIR_EraseRootFromParent_Done,
     /*  28718 */ // Label 610: @28718
     /*  28718 */ GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(28755), // Rule ID 2841 //
     /*  28723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28737 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4i32] }:$src)  =>  (VREV64q32:{ *:[v2f64] } QPR:{ *:[v4i32] }:$src)
     /*  28737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28740 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28742 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28747 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28753 */   GIR_RootConstrainSelectedInstOperands,
     /*  28754 */   // GIR_Coverage, 2841,
     /*  28754 */   GIR_EraseRootFromParent_Done,
     /*  28755 */ // Label 611: @28755
     /*  28755 */ GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(28792), // Rule ID 2842 //
     /*  28760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28774 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8f16] }:$src)  =>  (VREV64q16:{ *:[v2f64] } QPR:{ *:[v8f16] }:$src)
     /*  28774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28779 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28781 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28784 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28790 */   GIR_RootConstrainSelectedInstOperands,
     /*  28791 */   // GIR_Coverage, 2842,
     /*  28791 */   GIR_EraseRootFromParent_Done,
     /*  28792 */ // Label 612: @28792
     /*  28792 */ GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(28829), // Rule ID 2843 //
     /*  28797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28811 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8i16] }:$src)  =>  (VREV64q16:{ *:[v2f64] } QPR:{ *:[v8i16] }:$src)
     /*  28811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28814 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28816 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28818 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28821 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28827 */   GIR_RootConstrainSelectedInstOperands,
     /*  28828 */   // GIR_Coverage, 2843,
     /*  28828 */   GIR_EraseRootFromParent_Done,
     /*  28829 */ // Label 613: @28829
     /*  28829 */ GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(28866), // Rule ID 2844 //
     /*  28834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  28840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28848 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v16i8] }:$src)  =>  (VREV64q8:{ *:[v2f64] } QPR:{ *:[v16i8] }:$src)
     /*  28848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  28851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28853 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28858 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28864 */   GIR_RootConstrainSelectedInstOperands,
     /*  28865 */   // GIR_Coverage, 2844,
     /*  28865 */   GIR_EraseRootFromParent_Done,
     /*  28866 */ // Label 614: @28866
     /*  28866 */ GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(28903), // Rule ID 2845 //
     /*  28871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28885 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4f32] }:$src)  =>  (VREV64q32:{ *:[v2i64] } QPR:{ *:[v4f32] }:$src)
     /*  28885 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28888 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28890 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28895 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28901 */   GIR_RootConstrainSelectedInstOperands,
     /*  28902 */   // GIR_Coverage, 2845,
     /*  28902 */   GIR_EraseRootFromParent_Done,
     /*  28903 */ // Label 615: @28903
     /*  28903 */ GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(28940), // Rule ID 2846 //
     /*  28908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28922 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4i32] }:$src)  =>  (VREV64q32:{ *:[v2i64] } QPR:{ *:[v4i32] }:$src)
     /*  28922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28927 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28932 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28938 */   GIR_RootConstrainSelectedInstOperands,
     /*  28939 */   // GIR_Coverage, 2846,
     /*  28939 */   GIR_EraseRootFromParent_Done,
     /*  28940 */ // Label 616: @28940
     /*  28940 */ GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(28977), // Rule ID 2847 //
     /*  28945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28959 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8f16] }:$src)  =>  (VREV64q16:{ *:[v2i64] } QPR:{ *:[v8f16] }:$src)
     /*  28959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28964 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28969 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28975 */   GIR_RootConstrainSelectedInstOperands,
     /*  28976 */   // GIR_Coverage, 2847,
     /*  28976 */   GIR_EraseRootFromParent_Done,
     /*  28977 */ // Label 617: @28977
     /*  28977 */ GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(29014), // Rule ID 2848 //
     /*  28982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28996 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8i16] }:$src)  =>  (VREV64q16:{ *:[v2i64] } QPR:{ *:[v8i16] }:$src)
     /*  28996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  29001 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29003 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  29006 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29012 */   GIR_RootConstrainSelectedInstOperands,
     /*  29013 */   // GIR_Coverage, 2848,
     /*  29013 */   GIR_EraseRootFromParent_Done,
     /*  29014 */ // Label 618: @29014
     /*  29014 */ GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(29051), // Rule ID 2849 //
     /*  29019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  29022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  29029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  29033 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v16i8] }:$src)  =>  (VREV64q8:{ *:[v2i64] } QPR:{ *:[v16i8] }:$src)
     /*  29033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  29036 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  29038 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  29043 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29049 */   GIR_RootConstrainSelectedInstOperands,
     /*  29050 */   // GIR_Coverage, 2849,
     /*  29050 */   GIR_EraseRootFromParent_Done,
     /*  29051 */ // Label 619: @29051
     /*  29051 */ GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(29083), // Rule ID 5283 //
     /*  29056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  29059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  29062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29070 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29073 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29075 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29077 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29082 */   // GIR_Coverage, 5283,
     /*  29082 */   GIR_EraseRootFromParent_Done,
     /*  29083 */ // Label 620: @29083
     /*  29083 */ GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(29115), // Rule ID 5284 //
     /*  29088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  29091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  29094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29102 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29105 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29107 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29109 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29114 */   // GIR_Coverage, 5284,
     /*  29114 */   GIR_EraseRootFromParent_Done,
     /*  29115 */ // Label 621: @29115
     /*  29115 */ GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(29147), // Rule ID 5289 //
     /*  29120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29134 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29137 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29139 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29141 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29146 */   // GIR_Coverage, 5289,
     /*  29146 */   GIR_EraseRootFromParent_Done,
     /*  29147 */ // Label 622: @29147
     /*  29147 */ GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(29179), // Rule ID 5290 //
     /*  29152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29166 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29169 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29171 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29173 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29178 */   // GIR_Coverage, 5290,
     /*  29178 */   GIR_EraseRootFromParent_Done,
     /*  29179 */ // Label 623: @29179
     /*  29179 */ GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(29211), // Rule ID 5291 //
     /*  29184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29198 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29201 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29203 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29205 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29210 */   // GIR_Coverage, 5291,
     /*  29210 */   GIR_EraseRootFromParent_Done,
     /*  29211 */ // Label 624: @29211
     /*  29211 */ GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(29243), // Rule ID 5292 //
     /*  29216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29230 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29233 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29235 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29237 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29242 */   // GIR_Coverage, 5292,
     /*  29242 */   GIR_EraseRootFromParent_Done,
     /*  29243 */ // Label 625: @29243
     /*  29243 */ GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(29275), // Rule ID 5293 //
     /*  29248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29262 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29265 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29267 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29269 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29274 */   // GIR_Coverage, 5293,
     /*  29274 */   GIR_EraseRootFromParent_Done,
     /*  29275 */ // Label 626: @29275
     /*  29275 */ GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(29307), // Rule ID 5294 //
     /*  29280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29294 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29297 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29299 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29301 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29306 */   // GIR_Coverage, 5294,
     /*  29306 */   GIR_EraseRootFromParent_Done,
     /*  29307 */ // Label 627: @29307
     /*  29307 */ GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(29339), // Rule ID 5295 //
     /*  29312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29326 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29329 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29331 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29333 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29338 */   // GIR_Coverage, 5295,
     /*  29338 */   GIR_EraseRootFromParent_Done,
     /*  29339 */ // Label 628: @29339
     /*  29339 */ GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(29371), // Rule ID 5296 //
     /*  29344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29358 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29361 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29363 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29365 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29370 */   // GIR_Coverage, 5296,
     /*  29370 */   GIR_EraseRootFromParent_Done,
     /*  29371 */ // Label 629: @29371
     /*  29371 */ GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(29403), // Rule ID 5297 //
     /*  29376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29390 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29393 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29395 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29397 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29402 */   // GIR_Coverage, 5297,
     /*  29402 */   GIR_EraseRootFromParent_Done,
     /*  29403 */ // Label 630: @29403
     /*  29403 */ GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(29435), // Rule ID 5298 //
     /*  29408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29422 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29425 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29427 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29429 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29434 */   // GIR_Coverage, 5298,
     /*  29434 */   GIR_EraseRootFromParent_Done,
     /*  29435 */ // Label 631: @29435
     /*  29435 */ GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(29493), // Rule ID 5325 //
     /*  29440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29454 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2f64] } MQPR:{ *:[v4f32] }:$src)
     /*  29454 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29457 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29461 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29469 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29471 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29476 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29482 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29488 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29491 */   GIR_RootConstrainSelectedInstOperands,
     /*  29492 */   // GIR_Coverage, 5325,
     /*  29492 */   GIR_EraseRootFromParent_Done,
     /*  29493 */ // Label 632: @29493
     /*  29493 */ GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(29551), // Rule ID 5326 //
     /*  29498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29512 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2f64] } MQPR:{ *:[v4i32] }:$src)
     /*  29512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29519 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29527 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29529 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29531 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29534 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29540 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29546 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29549 */   GIR_RootConstrainSelectedInstOperands,
     /*  29550 */   // GIR_Coverage, 5326,
     /*  29550 */   GIR_EraseRootFromParent_Done,
     /*  29551 */ // Label 633: @29551
     /*  29551 */ GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(29609), // Rule ID 5327 //
     /*  29556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29570 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2f64] } MQPR:{ *:[v8f16] }:$src)
     /*  29570 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29573 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29577 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29587 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29592 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29598 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29604 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29607 */   GIR_RootConstrainSelectedInstOperands,
     /*  29608 */   // GIR_Coverage, 5327,
     /*  29608 */   GIR_EraseRootFromParent_Done,
     /*  29609 */ // Label 634: @29609
     /*  29609 */ GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(29667), // Rule ID 5328 //
     /*  29614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29628 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2f64] } MQPR:{ *:[v8i16] }:$src)
     /*  29628 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29631 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29635 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29643 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29645 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29650 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29656 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29662 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29665 */   GIR_RootConstrainSelectedInstOperands,
     /*  29666 */   // GIR_Coverage, 5328,
     /*  29666 */   GIR_EraseRootFromParent_Done,
     /*  29667 */ // Label 635: @29667
     /*  29667 */ GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(29725), // Rule ID 5329 //
     /*  29672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29686 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV64_8:{ *:[v2f64] } MQPR:{ *:[v16i8] }:$src)
     /*  29686 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29689 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29693 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  29701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29703 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29708 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29714 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29720 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29723 */   GIR_RootConstrainSelectedInstOperands,
     /*  29724 */   // GIR_Coverage, 5329,
     /*  29724 */   GIR_EraseRootFromParent_Done,
     /*  29725 */ // Label 636: @29725
     /*  29725 */ GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(29783), // Rule ID 5330 //
     /*  29730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29744 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2i64] } MQPR:{ *:[v4f32] }:$src)
     /*  29744 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29747 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29751 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29761 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29766 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29772 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29778 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29781 */   GIR_RootConstrainSelectedInstOperands,
     /*  29782 */   // GIR_Coverage, 5330,
     /*  29782 */   GIR_EraseRootFromParent_Done,
     /*  29783 */ // Label 637: @29783
     /*  29783 */ GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(29841), // Rule ID 5331 //
     /*  29788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29802 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$src)
     /*  29802 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29805 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29809 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29817 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29819 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29821 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29824 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29830 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29836 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29839 */   GIR_RootConstrainSelectedInstOperands,
     /*  29840 */   // GIR_Coverage, 5331,
     /*  29840 */   GIR_EraseRootFromParent_Done,
     /*  29841 */ // Label 638: @29841
     /*  29841 */ GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(29899), // Rule ID 5332 //
     /*  29846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29860 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2i64] } MQPR:{ *:[v8f16] }:$src)
     /*  29860 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29863 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29867 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29877 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29882 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29888 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29894 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29897 */   GIR_RootConstrainSelectedInstOperands,
     /*  29898 */   // GIR_Coverage, 5332,
     /*  29898 */   GIR_EraseRootFromParent_Done,
     /*  29899 */ // Label 639: @29899
     /*  29899 */ GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(29957), // Rule ID 5333 //
     /*  29904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29918 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2i64] } MQPR:{ *:[v8i16] }:$src)
     /*  29918 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29921 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29925 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29935 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29940 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29946 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29952 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29955 */   GIR_RootConstrainSelectedInstOperands,
     /*  29956 */   // GIR_Coverage, 5333,
     /*  29956 */   GIR_EraseRootFromParent_Done,
     /*  29957 */ // Label 640: @29957
     /*  29957 */ GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(30015), // Rule ID 5334 //
     /*  29962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29976 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV64_8:{ *:[v2i64] } MQPR:{ *:[v16i8] }:$src)
     /*  29976 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29979 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29983 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  29991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29993 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29998 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30004 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30010 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  30013 */   GIR_RootConstrainSelectedInstOperands,
     /*  30014 */   // GIR_Coverage, 5334,
     /*  30014 */   GIR_EraseRootFromParent_Done,
     /*  30015 */ // Label 641: @30015
     /*  30015 */ GIM_Reject,
     /*  30016 */ // Label 544: @30016
     /*  30016 */ GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(30048), // Rule ID 2724 //
     /*  30021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30035 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30038 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30040 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30042 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30047 */   // GIR_Coverage, 2724,
     /*  30047 */   GIR_EraseRootFromParent_Done,
     /*  30048 */ // Label 642: @30048
     /*  30048 */ GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(30080), // Rule ID 2725 //
     /*  30053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30063 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30067 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30070 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30072 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30074 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30079 */   // GIR_Coverage, 2725,
     /*  30079 */   GIR_EraseRootFromParent_Done,
     /*  30080 */ // Label 643: @30080
     /*  30080 */ GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(30112), // Rule ID 2752 //
     /*  30085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30099 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30099 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30102 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30104 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30106 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30111 */   // GIR_Coverage, 2752,
     /*  30111 */   GIR_EraseRootFromParent_Done,
     /*  30112 */ // Label 644: @30112
     /*  30112 */ GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(30144), // Rule ID 2753 //
     /*  30117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30127 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30131 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30134 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30136 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30138 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30143 */   // GIR_Coverage, 2753,
     /*  30143 */   GIR_EraseRootFromParent_Done,
     /*  30144 */ // Label 645: @30144
     /*  30144 */ GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(30176), // Rule ID 2754 //
     /*  30149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30163 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30166 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30168 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30170 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30175 */   // GIR_Coverage, 2754,
     /*  30175 */   GIR_EraseRootFromParent_Done,
     /*  30176 */ // Label 646: @30176
     /*  30176 */ GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(30208), // Rule ID 2755 //
     /*  30181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30195 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30198 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30200 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30202 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30207 */   // GIR_Coverage, 2755,
     /*  30207 */   GIR_EraseRootFromParent_Done,
     /*  30208 */ // Label 647: @30208
     /*  30208 */ GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(30240), // Rule ID 2756 //
     /*  30213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30227 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30230 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30232 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30234 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30239 */   // GIR_Coverage, 2756,
     /*  30239 */   GIR_EraseRootFromParent_Done,
     /*  30240 */ // Label 648: @30240
     /*  30240 */ GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(30272), // Rule ID 2757 //
     /*  30245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30259 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30262 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30264 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30266 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30271 */   // GIR_Coverage, 2757,
     /*  30271 */   GIR_EraseRootFromParent_Done,
     /*  30272 */ // Label 649: @30272
     /*  30272 */ GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(30304), // Rule ID 2758 //
     /*  30277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30291 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30294 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30296 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30298 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30303 */   // GIR_Coverage, 2758,
     /*  30303 */   GIR_EraseRootFromParent_Done,
     /*  30304 */ // Label 650: @30304
     /*  30304 */ GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(30336), // Rule ID 2759 //
     /*  30309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30323 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30326 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30328 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30330 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30335 */   // GIR_Coverage, 2759,
     /*  30335 */   GIR_EraseRootFromParent_Done,
     /*  30336 */ // Label 651: @30336
     /*  30336 */ GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(30368), // Rule ID 2760 //
     /*  30341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30355 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30358 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30360 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30362 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30367 */   // GIR_Coverage, 2760,
     /*  30367 */   GIR_EraseRootFromParent_Done,
     /*  30368 */ // Label 652: @30368
     /*  30368 */ GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(30400), // Rule ID 2761 //
     /*  30373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30387 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30390 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30392 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30394 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30399 */   // GIR_Coverage, 2761,
     /*  30399 */   GIR_EraseRootFromParent_Done,
     /*  30400 */ // Label 653: @30400
     /*  30400 */ GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(30437), // Rule ID 2824 //
     /*  30405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30419 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[f64] }:$src)  =>  (VREV64d16:{ *:[v4f16] } DPR:{ *:[f64] }:$src)
     /*  30419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30424 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30429 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30435 */   GIR_RootConstrainSelectedInstOperands,
     /*  30436 */   // GIR_Coverage, 2824,
     /*  30436 */   GIR_EraseRootFromParent_Done,
     /*  30437 */ // Label 654: @30437
     /*  30437 */ GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(30474), // Rule ID 2825 //
     /*  30442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30456 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d16:{ *:[v4f16] } DPR:{ *:[v1i64] }:$src)
     /*  30456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30461 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30466 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30472 */   GIR_RootConstrainSelectedInstOperands,
     /*  30473 */   // GIR_Coverage, 2825,
     /*  30473 */   GIR_EraseRootFromParent_Done,
     /*  30474 */ // Label 655: @30474
     /*  30474 */ GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(30511), // Rule ID 2826 //
     /*  30479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30493 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2f32] }:$src)  =>  (VREV32d16:{ *:[v4f16] } DPR:{ *:[v2f32] }:$src)
     /*  30493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30498 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30503 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30509 */   GIR_RootConstrainSelectedInstOperands,
     /*  30510 */   // GIR_Coverage, 2826,
     /*  30510 */   GIR_EraseRootFromParent_Done,
     /*  30511 */ // Label 656: @30511
     /*  30511 */ GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(30548), // Rule ID 2827 //
     /*  30516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30530 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2i32] }:$src)  =>  (VREV32d16:{ *:[v4f16] } DPR:{ *:[v2i32] }:$src)
     /*  30530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30535 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30540 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30546 */   GIR_RootConstrainSelectedInstOperands,
     /*  30547 */   // GIR_Coverage, 2827,
     /*  30547 */   GIR_EraseRootFromParent_Done,
     /*  30548 */ // Label 657: @30548
     /*  30548 */ GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(30585), // Rule ID 2828 //
     /*  30553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30567 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v8i8] }:$src)  =>  (VREV16d8:{ *:[v4f16] } DPR:{ *:[v8i8] }:$src)
     /*  30567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  30570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30572 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30577 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30583 */   GIR_RootConstrainSelectedInstOperands,
     /*  30584 */   // GIR_Coverage, 2828,
     /*  30584 */   GIR_EraseRootFromParent_Done,
     /*  30585 */ // Label 658: @30585
     /*  30585 */ GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(30622), // Rule ID 2829 //
     /*  30590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30604 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[f64] }:$src)  =>  (VREV64d16:{ *:[v4i16] } DPR:{ *:[f64] }:$src)
     /*  30604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30609 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30614 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30620 */   GIR_RootConstrainSelectedInstOperands,
     /*  30621 */   // GIR_Coverage, 2829,
     /*  30621 */   GIR_EraseRootFromParent_Done,
     /*  30622 */ // Label 659: @30622
     /*  30622 */ GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(30659), // Rule ID 2830 //
     /*  30627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30641 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d16:{ *:[v4i16] } DPR:{ *:[v1i64] }:$src)
     /*  30641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30646 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30651 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30657 */   GIR_RootConstrainSelectedInstOperands,
     /*  30658 */   // GIR_Coverage, 2830,
     /*  30658 */   GIR_EraseRootFromParent_Done,
     /*  30659 */ // Label 660: @30659
     /*  30659 */ GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(30696), // Rule ID 2831 //
     /*  30664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30678 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2f32] }:$src)  =>  (VREV32d16:{ *:[v4i16] } DPR:{ *:[v2f32] }:$src)
     /*  30678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30683 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30688 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30694 */   GIR_RootConstrainSelectedInstOperands,
     /*  30695 */   // GIR_Coverage, 2831,
     /*  30695 */   GIR_EraseRootFromParent_Done,
     /*  30696 */ // Label 661: @30696
     /*  30696 */ GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(30733), // Rule ID 2832 //
     /*  30701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30715 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2i32] }:$src)  =>  (VREV32d16:{ *:[v4i16] } DPR:{ *:[v2i32] }:$src)
     /*  30715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30718 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30720 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30722 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30725 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30731 */   GIR_RootConstrainSelectedInstOperands,
     /*  30732 */   // GIR_Coverage, 2832,
     /*  30732 */   GIR_EraseRootFromParent_Done,
     /*  30733 */ // Label 662: @30733
     /*  30733 */ GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(30770), // Rule ID 2833 //
     /*  30738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30752 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v8i8] }:$src)  =>  (VREV16d8:{ *:[v4i16] } DPR:{ *:[v8i8] }:$src)
     /*  30752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  30755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30757 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30762 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30768 */   GIR_RootConstrainSelectedInstOperands,
     /*  30769 */   // GIR_Coverage, 2833,
     /*  30769 */   GIR_EraseRootFromParent_Done,
     /*  30770 */ // Label 663: @30770
     /*  30770 */ GIM_Reject,
     /*  30771 */ // Label 545: @30771
     /*  30771 */ GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(30803), // Rule ID 2728 //
     /*  30776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30790 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  30790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30793 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30795 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30797 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30802 */   // GIR_Coverage, 2728,
     /*  30802 */   GIR_EraseRootFromParent_Done,
     /*  30803 */ // Label 664: @30803
     /*  30803 */ GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(30835), // Rule ID 2729 //
     /*  30808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30822 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30825 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30827 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30829 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30834 */   // GIR_Coverage, 2729,
     /*  30834 */   GIR_EraseRootFromParent_Done,
     /*  30835 */ // Label 665: @30835
     /*  30835 */ GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(30867), // Rule ID 2778 //
     /*  30840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  30846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30854 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30857 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30859 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30861 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30866 */   // GIR_Coverage, 2778,
     /*  30866 */   GIR_EraseRootFromParent_Done,
     /*  30867 */ // Label 666: @30867
     /*  30867 */ GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(30899), // Rule ID 2779 //
     /*  30872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  30878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30886 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30889 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30891 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30893 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30898 */   // GIR_Coverage, 2779,
     /*  30898 */   GIR_EraseRootFromParent_Done,
     /*  30899 */ // Label 667: @30899
     /*  30899 */ GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(30931), // Rule ID 2780 //
     /*  30904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30918 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30921 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30923 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30925 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30930 */   // GIR_Coverage, 2780,
     /*  30930 */   GIR_EraseRootFromParent_Done,
     /*  30931 */ // Label 668: @30931
     /*  30931 */ GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(30963), // Rule ID 2781 //
     /*  30936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30950 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30953 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30955 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30957 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30962 */   // GIR_Coverage, 2781,
     /*  30962 */   GIR_EraseRootFromParent_Done,
     /*  30963 */ // Label 669: @30963
     /*  30963 */ GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(30995), // Rule ID 2782 //
     /*  30968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30982 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30985 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30987 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30989 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30994 */   // GIR_Coverage, 2782,
     /*  30994 */   GIR_EraseRootFromParent_Done,
     /*  30995 */ // Label 670: @30995
     /*  30995 */ GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(31027), // Rule ID 2783 //
     /*  31000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31014 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31017 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31019 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31021 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31026 */   // GIR_Coverage, 2783,
     /*  31026 */   GIR_EraseRootFromParent_Done,
     /*  31027 */ // Label 671: @31027
     /*  31027 */ GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(31059), // Rule ID 2784 //
     /*  31032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31046 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31049 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31051 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31053 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31058 */   // GIR_Coverage, 2784,
     /*  31058 */   GIR_EraseRootFromParent_Done,
     /*  31059 */ // Label 672: @31059
     /*  31059 */ GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(31091), // Rule ID 2785 //
     /*  31064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31078 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31081 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31083 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31085 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31090 */   // GIR_Coverage, 2785,
     /*  31090 */   GIR_EraseRootFromParent_Done,
     /*  31091 */ // Label 673: @31091
     /*  31091 */ GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(31123), // Rule ID 2786 //
     /*  31096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31110 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31113 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31115 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31117 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31122 */   // GIR_Coverage, 2786,
     /*  31122 */   GIR_EraseRootFromParent_Done,
     /*  31123 */ // Label 674: @31123
     /*  31123 */ GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(31155), // Rule ID 2787 //
     /*  31128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31142 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31145 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31147 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31149 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31154 */   // GIR_Coverage, 2787,
     /*  31154 */   GIR_EraseRootFromParent_Done,
     /*  31155 */ // Label 675: @31155
     /*  31155 */ GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(31192), // Rule ID 2850 //
     /*  31160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31174 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q32:{ *:[v4f32] } QPR:{ *:[v2f64] }:$src)
     /*  31174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31179 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31184 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31190 */   GIR_RootConstrainSelectedInstOperands,
     /*  31191 */   // GIR_Coverage, 2850,
     /*  31191 */   GIR_EraseRootFromParent_Done,
     /*  31192 */ // Label 676: @31192
     /*  31192 */ GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(31229), // Rule ID 2851 //
     /*  31197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31211 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q32:{ *:[v4f32] } QPR:{ *:[v2i64] }:$src)
     /*  31211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31216 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31221 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31227 */   GIR_RootConstrainSelectedInstOperands,
     /*  31228 */   // GIR_Coverage, 2851,
     /*  31228 */   GIR_EraseRootFromParent_Done,
     /*  31229 */ // Label 677: @31229
     /*  31229 */ GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(31266), // Rule ID 2852 //
     /*  31234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31248 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8f16] }:$src)  =>  (VREV32q16:{ *:[v4f32] } QPR:{ *:[v8f16] }:$src)
     /*  31248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31253 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31258 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31264 */   GIR_RootConstrainSelectedInstOperands,
     /*  31265 */   // GIR_Coverage, 2852,
     /*  31265 */   GIR_EraseRootFromParent_Done,
     /*  31266 */ // Label 678: @31266
     /*  31266 */ GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(31303), // Rule ID 2853 //
     /*  31271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31285 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8i16] }:$src)  =>  (VREV32q16:{ *:[v4f32] } QPR:{ *:[v8i16] }:$src)
     /*  31285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31288 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31290 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31295 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31301 */   GIR_RootConstrainSelectedInstOperands,
     /*  31302 */   // GIR_Coverage, 2853,
     /*  31302 */   GIR_EraseRootFromParent_Done,
     /*  31303 */ // Label 679: @31303
     /*  31303 */ GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(31340), // Rule ID 2854 //
     /*  31308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31322 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v16i8] }:$src)  =>  (VREV32q8:{ *:[v4f32] } QPR:{ *:[v16i8] }:$src)
     /*  31322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  31325 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31327 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31332 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31338 */   GIR_RootConstrainSelectedInstOperands,
     /*  31339 */   // GIR_Coverage, 2854,
     /*  31339 */   GIR_EraseRootFromParent_Done,
     /*  31340 */ // Label 680: @31340
     /*  31340 */ GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(31377), // Rule ID 2855 //
     /*  31345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31359 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q32:{ *:[v4i32] } QPR:{ *:[v2f64] }:$src)
     /*  31359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31364 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31366 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31369 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31375 */   GIR_RootConstrainSelectedInstOperands,
     /*  31376 */   // GIR_Coverage, 2855,
     /*  31376 */   GIR_EraseRootFromParent_Done,
     /*  31377 */ // Label 681: @31377
     /*  31377 */ GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(31414), // Rule ID 2856 //
     /*  31382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31396 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q32:{ *:[v4i32] } QPR:{ *:[v2i64] }:$src)
     /*  31396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31401 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31403 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31406 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31412 */   GIR_RootConstrainSelectedInstOperands,
     /*  31413 */   // GIR_Coverage, 2856,
     /*  31413 */   GIR_EraseRootFromParent_Done,
     /*  31414 */ // Label 682: @31414
     /*  31414 */ GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(31451), // Rule ID 2857 //
     /*  31419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31429 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31433 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8f16] }:$src)  =>  (VREV32q16:{ *:[v4i32] } QPR:{ *:[v8f16] }:$src)
     /*  31433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31438 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31443 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31449 */   GIR_RootConstrainSelectedInstOperands,
     /*  31450 */   // GIR_Coverage, 2857,
     /*  31450 */   GIR_EraseRootFromParent_Done,
     /*  31451 */ // Label 683: @31451
     /*  31451 */ GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(31488), // Rule ID 2858 //
     /*  31456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31470 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8i16] }:$src)  =>  (VREV32q16:{ *:[v4i32] } QPR:{ *:[v8i16] }:$src)
     /*  31470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31473 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31475 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31477 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31480 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31486 */   GIR_RootConstrainSelectedInstOperands,
     /*  31487 */   // GIR_Coverage, 2858,
     /*  31487 */   GIR_EraseRootFromParent_Done,
     /*  31488 */ // Label 684: @31488
     /*  31488 */ GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(31525), // Rule ID 2859 //
     /*  31493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31507 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v16i8] }:$src)  =>  (VREV32q8:{ *:[v4i32] } QPR:{ *:[v16i8] }:$src)
     /*  31507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  31510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31512 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31514 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31517 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31523 */   GIR_RootConstrainSelectedInstOperands,
     /*  31524 */   // GIR_Coverage, 2859,
     /*  31524 */   GIR_EraseRootFromParent_Done,
     /*  31525 */ // Label 685: @31525
     /*  31525 */ GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(31557), // Rule ID 5285 //
     /*  31530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  31533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31544 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31547 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31549 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31551 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31556 */   // GIR_Coverage, 5285,
     /*  31556 */   GIR_EraseRootFromParent_Done,
     /*  31557 */ // Label 686: @31557
     /*  31557 */ GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(31589), // Rule ID 5286 //
     /*  31562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  31565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31576 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31579 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31581 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31583 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31588 */   // GIR_Coverage, 5286,
     /*  31588 */   GIR_EraseRootFromParent_Done,
     /*  31589 */ // Label 687: @31589
     /*  31589 */ GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(31621), // Rule ID 5299 //
     /*  31594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31608 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31611 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31613 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31615 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31620 */   // GIR_Coverage, 5299,
     /*  31620 */   GIR_EraseRootFromParent_Done,
     /*  31621 */ // Label 688: @31621
     /*  31621 */ GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(31653), // Rule ID 5300 //
     /*  31626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31640 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31643 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31645 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31647 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31652 */   // GIR_Coverage, 5300,
     /*  31652 */   GIR_EraseRootFromParent_Done,
     /*  31653 */ // Label 689: @31653
     /*  31653 */ GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(31685), // Rule ID 5301 //
     /*  31658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31672 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31675 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31677 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31679 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31684 */   // GIR_Coverage, 5301,
     /*  31684 */   GIR_EraseRootFromParent_Done,
     /*  31685 */ // Label 690: @31685
     /*  31685 */ GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(31717), // Rule ID 5302 //
     /*  31690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31704 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31707 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31709 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31711 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31716 */   // GIR_Coverage, 5302,
     /*  31716 */   GIR_EraseRootFromParent_Done,
     /*  31717 */ // Label 691: @31717
     /*  31717 */ GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(31749), // Rule ID 5303 //
     /*  31722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31736 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31739 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31741 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31743 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31748 */   // GIR_Coverage, 5303,
     /*  31748 */   GIR_EraseRootFromParent_Done,
     /*  31749 */ // Label 692: @31749
     /*  31749 */ GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(31781), // Rule ID 5304 //
     /*  31754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31768 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31771 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31773 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31775 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31780 */   // GIR_Coverage, 5304,
     /*  31780 */   GIR_EraseRootFromParent_Done,
     /*  31781 */ // Label 693: @31781
     /*  31781 */ GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(31813), // Rule ID 5305 //
     /*  31786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31800 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31803 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31805 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31807 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31812 */   // GIR_Coverage, 5305,
     /*  31812 */   GIR_EraseRootFromParent_Done,
     /*  31813 */ // Label 694: @31813
     /*  31813 */ GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(31845), // Rule ID 5306 //
     /*  31818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31832 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31835 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31837 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31839 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31844 */   // GIR_Coverage, 5306,
     /*  31844 */   GIR_EraseRootFromParent_Done,
     /*  31845 */ // Label 695: @31845
     /*  31845 */ GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(31877), // Rule ID 5307 //
     /*  31850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31864 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31867 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31869 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31871 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31876 */   // GIR_Coverage, 5307,
     /*  31876 */   GIR_EraseRootFromParent_Done,
     /*  31877 */ // Label 696: @31877
     /*  31877 */ GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(31909), // Rule ID 5308 //
     /*  31882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31896 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31899 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31901 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31903 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31908 */   // GIR_Coverage, 5308,
     /*  31908 */   GIR_EraseRootFromParent_Done,
     /*  31909 */ // Label 697: @31909
     /*  31909 */ GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(31967), // Rule ID 5335 //
     /*  31914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  31917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31928 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4f32] } MQPR:{ *:[v2f64] }:$src)
     /*  31928 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  31931 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  31935 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  31943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  31945 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31947 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31950 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31956 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31962 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  31965 */   GIR_RootConstrainSelectedInstOperands,
     /*  31966 */   // GIR_Coverage, 5335,
     /*  31966 */   GIR_EraseRootFromParent_Done,
     /*  31967 */ // Label 698: @31967
     /*  31967 */ GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(32025), // Rule ID 5336 //
     /*  31972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  31975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31986 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4f32] } MQPR:{ *:[v2i64] }:$src)
     /*  31986 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  31989 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  31993 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  32001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32005 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32008 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32014 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32020 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32023 */   GIR_RootConstrainSelectedInstOperands,
     /*  32024 */   // GIR_Coverage, 5336,
     /*  32024 */   GIR_EraseRootFromParent_Done,
     /*  32025 */ // Label 699: @32025
     /*  32025 */ GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(32083), // Rule ID 5337 //
     /*  32030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32044 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$src)
     /*  32044 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32047 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32051 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32061 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32066 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32072 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32078 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32081 */   GIR_RootConstrainSelectedInstOperands,
     /*  32082 */   // GIR_Coverage, 5337,
     /*  32082 */   GIR_EraseRootFromParent_Done,
     /*  32083 */ // Label 700: @32083
     /*  32083 */ GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(32141), // Rule ID 5338 //
     /*  32088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32102 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4f32] } MQPR:{ *:[v8i16] }:$src)
     /*  32102 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32105 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32109 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32114 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32117 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32119 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32121 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32124 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32130 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32136 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32139 */   GIR_RootConstrainSelectedInstOperands,
     /*  32140 */   // GIR_Coverage, 5338,
     /*  32140 */   GIR_EraseRootFromParent_Done,
     /*  32141 */ // Label 701: @32141
     /*  32141 */ GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(32199), // Rule ID 5339 //
     /*  32146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  32152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32160 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV32_8:{ *:[v4f32] } MQPR:{ *:[v16i8] }:$src)
     /*  32160 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32163 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32167 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  32175 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32177 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32179 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32182 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32188 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32194 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32197 */   GIR_RootConstrainSelectedInstOperands,
     /*  32198 */   // GIR_Coverage, 5339,
     /*  32198 */   GIR_EraseRootFromParent_Done,
     /*  32199 */ // Label 702: @32199
     /*  32199 */ GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(32257), // Rule ID 5340 //
     /*  32204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  32210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32218 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4i32] } MQPR:{ *:[v2f64] }:$src)
     /*  32218 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32221 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32225 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  32233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32235 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32237 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32240 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32246 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32252 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32255 */   GIR_RootConstrainSelectedInstOperands,
     /*  32256 */   // GIR_Coverage, 5340,
     /*  32256 */   GIR_EraseRootFromParent_Done,
     /*  32257 */ // Label 703: @32257
     /*  32257 */ GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(32315), // Rule ID 5341 //
     /*  32262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  32268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32276 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4i32] } MQPR:{ *:[v2i64] }:$src)
     /*  32276 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32279 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32283 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  32291 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32293 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32298 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32304 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32310 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32313 */   GIR_RootConstrainSelectedInstOperands,
     /*  32314 */   // GIR_Coverage, 5341,
     /*  32314 */   GIR_EraseRootFromParent_Done,
     /*  32315 */ // Label 704: @32315
     /*  32315 */ GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(32373), // Rule ID 5342 //
     /*  32320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32334 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4i32] } MQPR:{ *:[v8f16] }:$src)
     /*  32334 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32337 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32341 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32351 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32356 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32362 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32368 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32371 */   GIR_RootConstrainSelectedInstOperands,
     /*  32372 */   // GIR_Coverage, 5342,
     /*  32372 */   GIR_EraseRootFromParent_Done,
     /*  32373 */ // Label 705: @32373
     /*  32373 */ GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(32431), // Rule ID 5343 //
     /*  32378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32392 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  32392 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32395 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32399 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32409 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32414 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32420 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32426 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32429 */   GIR_RootConstrainSelectedInstOperands,
     /*  32430 */   // GIR_Coverage, 5343,
     /*  32430 */   GIR_EraseRootFromParent_Done,
     /*  32431 */ // Label 706: @32431
     /*  32431 */ GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(32489), // Rule ID 5344 //
     /*  32436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  32442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32450 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV32_8:{ *:[v4i32] } MQPR:{ *:[v16i8] }:$src)
     /*  32450 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32453 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32457 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  32465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32467 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32469 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32472 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32478 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32484 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32487 */   GIR_RootConstrainSelectedInstOperands,
     /*  32488 */   // GIR_Coverage, 5344,
     /*  32488 */   GIR_EraseRootFromParent_Done,
     /*  32489 */ // Label 707: @32489
     /*  32489 */ GIM_Reject,
     /*  32490 */ // Label 546: @32490
     /*  32490 */ GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(32522), // Rule ID 2762 //
     /*  32495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32509 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32512 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32514 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32516 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32521 */   // GIR_Coverage, 2762,
     /*  32521 */   GIR_EraseRootFromParent_Done,
     /*  32522 */ // Label 708: @32522
     /*  32522 */ GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(32554), // Rule ID 2763 //
     /*  32527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32541 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32544 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32546 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32548 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32553 */   // GIR_Coverage, 2763,
     /*  32553 */   GIR_EraseRootFromParent_Done,
     /*  32554 */ // Label 709: @32554
     /*  32554 */ GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(32586), // Rule ID 2764 //
     /*  32559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32569 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32573 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32576 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32578 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32580 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32585 */   // GIR_Coverage, 2764,
     /*  32585 */   GIR_EraseRootFromParent_Done,
     /*  32586 */ // Label 710: @32586
     /*  32586 */ GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(32618), // Rule ID 2765 //
     /*  32591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32605 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32608 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32610 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32612 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32617 */   // GIR_Coverage, 2765,
     /*  32617 */   GIR_EraseRootFromParent_Done,
     /*  32618 */ // Label 711: @32618
     /*  32618 */ GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(32650), // Rule ID 2766 //
     /*  32623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32637 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32640 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32642 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32644 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32649 */   // GIR_Coverage, 2766,
     /*  32649 */   GIR_EraseRootFromParent_Done,
     /*  32650 */ // Label 712: @32650
     /*  32650 */ GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(32682), // Rule ID 2767 //
     /*  32655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32669 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32672 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32674 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32676 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32681 */   // GIR_Coverage, 2767,
     /*  32681 */   GIR_EraseRootFromParent_Done,
     /*  32682 */ // Label 713: @32682
     /*  32682 */ GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(32719), // Rule ID 2834 //
     /*  32687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32701 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[f64] }:$src)  =>  (VREV64d8:{ *:[v8i8] } DPR:{ *:[f64] }:$src)
     /*  32701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  32704 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32706 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32711 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32717 */   GIR_RootConstrainSelectedInstOperands,
     /*  32718 */   // GIR_Coverage, 2834,
     /*  32718 */   GIR_EraseRootFromParent_Done,
     /*  32719 */ // Label 714: @32719
     /*  32719 */ GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(32756), // Rule ID 2835 //
     /*  32724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32738 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d8:{ *:[v8i8] } DPR:{ *:[v1i64] }:$src)
     /*  32738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  32741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32743 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32748 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32754 */   GIR_RootConstrainSelectedInstOperands,
     /*  32755 */   // GIR_Coverage, 2835,
     /*  32755 */   GIR_EraseRootFromParent_Done,
     /*  32756 */ // Label 715: @32756
     /*  32756 */ GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(32793), // Rule ID 2836 //
     /*  32761 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32775 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2f32] }:$src)  =>  (VREV32d8:{ *:[v8i8] } DPR:{ *:[v2f32] }:$src)
     /*  32775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  32778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32780 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32782 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32785 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32791 */   GIR_RootConstrainSelectedInstOperands,
     /*  32792 */   // GIR_Coverage, 2836,
     /*  32792 */   GIR_EraseRootFromParent_Done,
     /*  32793 */ // Label 716: @32793
     /*  32793 */ GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(32830), // Rule ID 2837 //
     /*  32798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32812 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2i32] }:$src)  =>  (VREV32d8:{ *:[v8i8] } DPR:{ *:[v2i32] }:$src)
     /*  32812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  32815 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32817 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32822 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32828 */   GIR_RootConstrainSelectedInstOperands,
     /*  32829 */   // GIR_Coverage, 2837,
     /*  32829 */   GIR_EraseRootFromParent_Done,
     /*  32830 */ // Label 717: @32830
     /*  32830 */ GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(32867), // Rule ID 2838 //
     /*  32835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32849 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4f16] }:$src)  =>  (VREV16d8:{ *:[v8i8] } DPR:{ *:[v4f16] }:$src)
     /*  32849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  32852 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32854 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32859 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32865 */   GIR_RootConstrainSelectedInstOperands,
     /*  32866 */   // GIR_Coverage, 2838,
     /*  32866 */   GIR_EraseRootFromParent_Done,
     /*  32867 */ // Label 718: @32867
     /*  32867 */ GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(32904), // Rule ID 2839 //
     /*  32872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32886 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4i16] }:$src)  =>  (VREV16d8:{ *:[v8i8] } DPR:{ *:[v4i16] }:$src)
     /*  32886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  32889 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32891 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32893 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32896 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32902 */   GIR_RootConstrainSelectedInstOperands,
     /*  32903 */   // GIR_Coverage, 2839,
     /*  32903 */   GIR_EraseRootFromParent_Done,
     /*  32904 */ // Label 719: @32904
     /*  32904 */ GIM_Reject,
     /*  32905 */ // Label 547: @32905
     /*  32905 */ GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(32937), // Rule ID 2730 //
     /*  32910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32924 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  32924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32927 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32929 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32931 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  32936 */   // GIR_Coverage, 2730,
     /*  32936 */   GIR_EraseRootFromParent_Done,
     /*  32937 */ // Label 720: @32937
     /*  32937 */ GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(32969), // Rule ID 2731 //
     /*  32942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32956 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  32956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32959 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32961 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32963 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  32968 */   // GIR_Coverage, 2731,
     /*  32968 */   GIR_EraseRootFromParent_Done,
     /*  32969 */ // Label 721: @32969
     /*  32969 */ GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(33001), // Rule ID 2788 //
     /*  32974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  32980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32988 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  32988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32991 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32993 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32995 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33000 */   // GIR_Coverage, 2788,
     /*  33000 */   GIR_EraseRootFromParent_Done,
     /*  33001 */ // Label 722: @33001
     /*  33001 */ GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(33033), // Rule ID 2789 //
     /*  33006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33020 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33023 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33025 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33027 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33032 */   // GIR_Coverage, 2789,
     /*  33032 */   GIR_EraseRootFromParent_Done,
     /*  33033 */ // Label 723: @33033
     /*  33033 */ GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(33065), // Rule ID 2790 //
     /*  33038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33052 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33055 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33057 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33059 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33064 */   // GIR_Coverage, 2790,
     /*  33064 */   GIR_EraseRootFromParent_Done,
     /*  33065 */ // Label 724: @33065
     /*  33065 */ GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(33097), // Rule ID 2791 //
     /*  33070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33084 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33087 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33089 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33091 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33096 */   // GIR_Coverage, 2791,
     /*  33096 */   GIR_EraseRootFromParent_Done,
     /*  33097 */ // Label 725: @33097
     /*  33097 */ GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(33129), // Rule ID 2792 //
     /*  33102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33116 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33116 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33119 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33121 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33123 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33128 */   // GIR_Coverage, 2792,
     /*  33128 */   GIR_EraseRootFromParent_Done,
     /*  33129 */ // Label 726: @33129
     /*  33129 */ GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(33161), // Rule ID 2793 //
     /*  33134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33148 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33151 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33153 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33155 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33160 */   // GIR_Coverage, 2793,
     /*  33160 */   GIR_EraseRootFromParent_Done,
     /*  33161 */ // Label 727: @33161
     /*  33161 */ GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(33193), // Rule ID 2794 //
     /*  33166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33180 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33183 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33185 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33187 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33192 */   // GIR_Coverage, 2794,
     /*  33192 */   GIR_EraseRootFromParent_Done,
     /*  33193 */ // Label 728: @33193
     /*  33193 */ GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(33225), // Rule ID 2795 //
     /*  33198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33212 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33215 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33217 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33219 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33224 */   // GIR_Coverage, 2795,
     /*  33224 */   GIR_EraseRootFromParent_Done,
     /*  33225 */ // Label 729: @33225
     /*  33225 */ GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(33257), // Rule ID 2796 //
     /*  33230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33244 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33247 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33249 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33251 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33256 */   // GIR_Coverage, 2796,
     /*  33256 */   GIR_EraseRootFromParent_Done,
     /*  33257 */ // Label 730: @33257
     /*  33257 */ GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(33289), // Rule ID 2797 //
     /*  33262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33276 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33279 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33281 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33283 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33288 */   // GIR_Coverage, 2797,
     /*  33288 */   GIR_EraseRootFromParent_Done,
     /*  33289 */ // Label 731: @33289
     /*  33289 */ GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(33326), // Rule ID 2860 //
     /*  33294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33308 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q16:{ *:[v8f16] } QPR:{ *:[v2f64] }:$src)
     /*  33308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33313 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33318 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33324 */   GIR_RootConstrainSelectedInstOperands,
     /*  33325 */   // GIR_Coverage, 2860,
     /*  33325 */   GIR_EraseRootFromParent_Done,
     /*  33326 */ // Label 732: @33326
     /*  33326 */ GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(33363), // Rule ID 2861 //
     /*  33331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33345 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q16:{ *:[v8f16] } QPR:{ *:[v2i64] }:$src)
     /*  33345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33348 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33350 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33355 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33361 */   GIR_RootConstrainSelectedInstOperands,
     /*  33362 */   // GIR_Coverage, 2861,
     /*  33362 */   GIR_EraseRootFromParent_Done,
     /*  33363 */ // Label 733: @33363
     /*  33363 */ GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(33400), // Rule ID 2862 //
     /*  33368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33382 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4f32] }:$src)  =>  (VREV32q16:{ *:[v8f16] } QPR:{ *:[v4f32] }:$src)
     /*  33382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33387 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33389 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33392 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33398 */   GIR_RootConstrainSelectedInstOperands,
     /*  33399 */   // GIR_Coverage, 2862,
     /*  33399 */   GIR_EraseRootFromParent_Done,
     /*  33400 */ // Label 734: @33400
     /*  33400 */ GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(33437), // Rule ID 2863 //
     /*  33405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33419 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4i32] }:$src)  =>  (VREV32q16:{ *:[v8f16] } QPR:{ *:[v4i32] }:$src)
     /*  33419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33424 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33429 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33435 */   GIR_RootConstrainSelectedInstOperands,
     /*  33436 */   // GIR_Coverage, 2863,
     /*  33436 */   GIR_EraseRootFromParent_Done,
     /*  33437 */ // Label 735: @33437
     /*  33437 */ GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(33474), // Rule ID 2864 //
     /*  33442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33456 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v16i8] }:$src)  =>  (VREV16q8:{ *:[v8f16] } QPR:{ *:[v16i8] }:$src)
     /*  33456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  33459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33461 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33466 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33472 */   GIR_RootConstrainSelectedInstOperands,
     /*  33473 */   // GIR_Coverage, 2864,
     /*  33473 */   GIR_EraseRootFromParent_Done,
     /*  33474 */ // Label 736: @33474
     /*  33474 */ GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(33511), // Rule ID 2865 //
     /*  33479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33493 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q16:{ *:[v8i16] } QPR:{ *:[v2f64] }:$src)
     /*  33493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33498 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33503 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33509 */   GIR_RootConstrainSelectedInstOperands,
     /*  33510 */   // GIR_Coverage, 2865,
     /*  33510 */   GIR_EraseRootFromParent_Done,
     /*  33511 */ // Label 737: @33511
     /*  33511 */ GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(33548), // Rule ID 2866 //
     /*  33516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33530 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q16:{ *:[v8i16] } QPR:{ *:[v2i64] }:$src)
     /*  33530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33535 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33540 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33546 */   GIR_RootConstrainSelectedInstOperands,
     /*  33547 */   // GIR_Coverage, 2866,
     /*  33547 */   GIR_EraseRootFromParent_Done,
     /*  33548 */ // Label 738: @33548
     /*  33548 */ GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(33585), // Rule ID 2867 //
     /*  33553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33567 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4f32] }:$src)  =>  (VREV32q16:{ *:[v8i16] } QPR:{ *:[v4f32] }:$src)
     /*  33567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33572 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33577 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33583 */   GIR_RootConstrainSelectedInstOperands,
     /*  33584 */   // GIR_Coverage, 2867,
     /*  33584 */   GIR_EraseRootFromParent_Done,
     /*  33585 */ // Label 739: @33585
     /*  33585 */ GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(33622), // Rule ID 2868 //
     /*  33590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33604 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4i32] }:$src)  =>  (VREV32q16:{ *:[v8i16] } QPR:{ *:[v4i32] }:$src)
     /*  33604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33609 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33614 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33620 */   GIR_RootConstrainSelectedInstOperands,
     /*  33621 */   // GIR_Coverage, 2868,
     /*  33621 */   GIR_EraseRootFromParent_Done,
     /*  33622 */ // Label 740: @33622
     /*  33622 */ GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(33659), // Rule ID 2869 //
     /*  33627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33641 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v16i8] }:$src)  =>  (VREV16q8:{ *:[v8i16] } QPR:{ *:[v16i8] }:$src)
     /*  33641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  33644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33646 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33651 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33657 */   GIR_RootConstrainSelectedInstOperands,
     /*  33658 */   // GIR_Coverage, 2869,
     /*  33658 */   GIR_EraseRootFromParent_Done,
     /*  33659 */ // Label 741: @33659
     /*  33659 */ GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(33691), // Rule ID 5287 //
     /*  33664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  33667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33678 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33681 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33683 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33685 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33690 */   // GIR_Coverage, 5287,
     /*  33690 */   GIR_EraseRootFromParent_Done,
     /*  33691 */ // Label 742: @33691
     /*  33691 */ GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(33723), // Rule ID 5288 //
     /*  33696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  33699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33710 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33713 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33715 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33717 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33722 */   // GIR_Coverage, 5288,
     /*  33722 */   GIR_EraseRootFromParent_Done,
     /*  33723 */ // Label 743: @33723
     /*  33723 */ GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(33755), // Rule ID 5309 //
     /*  33728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33742 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33745 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33747 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33749 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33754 */   // GIR_Coverage, 5309,
     /*  33754 */   GIR_EraseRootFromParent_Done,
     /*  33755 */ // Label 744: @33755
     /*  33755 */ GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(33787), // Rule ID 5310 //
     /*  33760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33774 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33777 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33779 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33781 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33786 */   // GIR_Coverage, 5310,
     /*  33786 */   GIR_EraseRootFromParent_Done,
     /*  33787 */ // Label 745: @33787
     /*  33787 */ GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(33819), // Rule ID 5311 //
     /*  33792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33806 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33809 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33811 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33813 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33818 */   // GIR_Coverage, 5311,
     /*  33818 */   GIR_EraseRootFromParent_Done,
     /*  33819 */ // Label 746: @33819
     /*  33819 */ GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(33851), // Rule ID 5312 //
     /*  33824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33838 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33841 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33843 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33845 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33850 */   // GIR_Coverage, 5312,
     /*  33850 */   GIR_EraseRootFromParent_Done,
     /*  33851 */ // Label 747: @33851
     /*  33851 */ GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(33883), // Rule ID 5313 //
     /*  33856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33870 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33873 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33875 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33877 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33882 */   // GIR_Coverage, 5313,
     /*  33882 */   GIR_EraseRootFromParent_Done,
     /*  33883 */ // Label 748: @33883
     /*  33883 */ GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(33915), // Rule ID 5314 //
     /*  33888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33902 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33905 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33907 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33909 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33914 */   // GIR_Coverage, 5314,
     /*  33914 */   GIR_EraseRootFromParent_Done,
     /*  33915 */ // Label 749: @33915
     /*  33915 */ GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(33947), // Rule ID 5315 //
     /*  33920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33934 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33937 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33939 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33941 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33946 */   // GIR_Coverage, 5315,
     /*  33946 */   GIR_EraseRootFromParent_Done,
     /*  33947 */ // Label 750: @33947
     /*  33947 */ GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(33979), // Rule ID 5316 //
     /*  33952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33966 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33969 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33971 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33973 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33978 */   // GIR_Coverage, 5316,
     /*  33978 */   GIR_EraseRootFromParent_Done,
     /*  33979 */ // Label 751: @33979
     /*  33979 */ GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(34011), // Rule ID 5317 //
     /*  33984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33998 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34001 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34005 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34010 */   // GIR_Coverage, 5317,
     /*  34010 */   GIR_EraseRootFromParent_Done,
     /*  34011 */ // Label 752: @34011
     /*  34011 */ GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(34043), // Rule ID 5318 //
     /*  34016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  34019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34030 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  34030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34033 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34035 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34037 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34042 */   // GIR_Coverage, 5318,
     /*  34042 */   GIR_EraseRootFromParent_Done,
     /*  34043 */ // Label 753: @34043
     /*  34043 */ GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(34101), // Rule ID 5345 //
     /*  34048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34062 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8f16] } MQPR:{ *:[v2f64] }:$src)
     /*  34062 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34065 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34069 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34079 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34084 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34090 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34096 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34099 */   GIR_RootConstrainSelectedInstOperands,
     /*  34100 */   // GIR_Coverage, 5345,
     /*  34100 */   GIR_EraseRootFromParent_Done,
     /*  34101 */ // Label 754: @34101
     /*  34101 */ GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(34159), // Rule ID 5346 //
     /*  34106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34120 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8f16] } MQPR:{ *:[v2i64] }:$src)
     /*  34120 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34123 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34127 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34135 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34137 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34142 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34148 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34154 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34157 */   GIR_RootConstrainSelectedInstOperands,
     /*  34158 */   // GIR_Coverage, 5346,
     /*  34158 */   GIR_EraseRootFromParent_Done,
     /*  34159 */ // Label 755: @34159
     /*  34159 */ GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(34217), // Rule ID 5347 //
     /*  34164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34178 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8f16] } MQPR:{ *:[v4f32] }:$src)
     /*  34178 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34181 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34185 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34195 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34200 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34206 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34212 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34215 */   GIR_RootConstrainSelectedInstOperands,
     /*  34216 */   // GIR_Coverage, 5347,
     /*  34216 */   GIR_EraseRootFromParent_Done,
     /*  34217 */ // Label 756: @34217
     /*  34217 */ GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(34275), // Rule ID 5348 //
     /*  34222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34236 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8f16] } MQPR:{ *:[v4i32] }:$src)
     /*  34236 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34239 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34243 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34253 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34258 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34264 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34270 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34273 */   GIR_RootConstrainSelectedInstOperands,
     /*  34274 */   // GIR_Coverage, 5348,
     /*  34274 */   GIR_EraseRootFromParent_Done,
     /*  34275 */ // Label 757: @34275
     /*  34275 */ GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(34333), // Rule ID 5349 //
     /*  34280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34294 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV16_8:{ *:[v8f16] } MQPR:{ *:[v16i8] }:$src)
     /*  34294 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34297 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34301 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  34309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34311 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34316 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34322 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34328 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34331 */   GIR_RootConstrainSelectedInstOperands,
     /*  34332 */   // GIR_Coverage, 5349,
     /*  34332 */   GIR_EraseRootFromParent_Done,
     /*  34333 */ // Label 758: @34333
     /*  34333 */ GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(34391), // Rule ID 5350 //
     /*  34338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34352 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8i16] } MQPR:{ *:[v2f64] }:$src)
     /*  34352 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34355 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34359 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34367 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34369 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34371 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34374 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34380 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34386 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34389 */   GIR_RootConstrainSelectedInstOperands,
     /*  34390 */   // GIR_Coverage, 5350,
     /*  34390 */   GIR_EraseRootFromParent_Done,
     /*  34391 */ // Label 759: @34391
     /*  34391 */ GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(34449), // Rule ID 5351 //
     /*  34396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34410 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8i16] } MQPR:{ *:[v2i64] }:$src)
     /*  34410 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34413 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34417 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34425 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34427 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34432 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34438 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34444 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34447 */   GIR_RootConstrainSelectedInstOperands,
     /*  34448 */   // GIR_Coverage, 5351,
     /*  34448 */   GIR_EraseRootFromParent_Done,
     /*  34449 */ // Label 760: @34449
     /*  34449 */ GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(34507), // Rule ID 5352 //
     /*  34454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34468 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8i16] } MQPR:{ *:[v4f32] }:$src)
     /*  34468 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34471 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34475 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34483 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34485 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34490 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34496 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34502 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34505 */   GIR_RootConstrainSelectedInstOperands,
     /*  34506 */   // GIR_Coverage, 5352,
     /*  34506 */   GIR_EraseRootFromParent_Done,
     /*  34507 */ // Label 761: @34507
     /*  34507 */ GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(34565), // Rule ID 5353 //
     /*  34512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34526 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8i16] } MQPR:{ *:[v4i32] }:$src)
     /*  34526 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34529 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34533 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34541 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34543 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34548 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34554 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34560 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34563 */   GIR_RootConstrainSelectedInstOperands,
     /*  34564 */   // GIR_Coverage, 5353,
     /*  34564 */   GIR_EraseRootFromParent_Done,
     /*  34565 */ // Label 762: @34565
     /*  34565 */ GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(34623), // Rule ID 5354 //
     /*  34570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34584 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV16_8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  34584 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34587 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34591 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  34599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34601 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34606 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34612 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34618 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34621 */   GIR_RootConstrainSelectedInstOperands,
     /*  34622 */   // GIR_Coverage, 5354,
     /*  34622 */   GIR_EraseRootFromParent_Done,
     /*  34623 */ // Label 763: @34623
     /*  34623 */ GIM_Reject,
     /*  34624 */ // Label 548: @34624
     /*  34624 */ GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(34656), // Rule ID 2798 //
     /*  34629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34643 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34646 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34648 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34650 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34655 */   // GIR_Coverage, 2798,
     /*  34655 */   GIR_EraseRootFromParent_Done,
     /*  34656 */ // Label 764: @34656
     /*  34656 */ GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(34688), // Rule ID 2799 //
     /*  34661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34675 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34678 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34680 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34682 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34687 */   // GIR_Coverage, 2799,
     /*  34687 */   GIR_EraseRootFromParent_Done,
     /*  34688 */ // Label 765: @34688
     /*  34688 */ GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(34720), // Rule ID 2800 //
     /*  34693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34707 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34710 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34712 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34714 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34719 */   // GIR_Coverage, 2800,
     /*  34719 */   GIR_EraseRootFromParent_Done,
     /*  34720 */ // Label 766: @34720
     /*  34720 */ GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(34752), // Rule ID 2801 //
     /*  34725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34739 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34739 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34742 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34744 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34746 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34751 */   // GIR_Coverage, 2801,
     /*  34751 */   GIR_EraseRootFromParent_Done,
     /*  34752 */ // Label 767: @34752
     /*  34752 */ GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(34784), // Rule ID 2802 //
     /*  34757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34771 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34774 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34776 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34778 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34783 */   // GIR_Coverage, 2802,
     /*  34783 */   GIR_EraseRootFromParent_Done,
     /*  34784 */ // Label 768: @34784
     /*  34784 */ GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(34816), // Rule ID 2803 //
     /*  34789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34803 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34806 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34808 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34810 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34815 */   // GIR_Coverage, 2803,
     /*  34815 */   GIR_EraseRootFromParent_Done,
     /*  34816 */ // Label 769: @34816
     /*  34816 */ GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(34853), // Rule ID 2870 //
     /*  34821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34835 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q8:{ *:[v16i8] } QPR:{ *:[v2f64] }:$src)
     /*  34835 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  34838 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34840 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34845 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34851 */   GIR_RootConstrainSelectedInstOperands,
     /*  34852 */   // GIR_Coverage, 2870,
     /*  34852 */   GIR_EraseRootFromParent_Done,
     /*  34853 */ // Label 770: @34853
     /*  34853 */ GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(34890), // Rule ID 2871 //
     /*  34858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34872 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q8:{ *:[v16i8] } QPR:{ *:[v2i64] }:$src)
     /*  34872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  34875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34877 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34882 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34888 */   GIR_RootConstrainSelectedInstOperands,
     /*  34889 */   // GIR_Coverage, 2871,
     /*  34889 */   GIR_EraseRootFromParent_Done,
     /*  34890 */ // Label 771: @34890
     /*  34890 */ GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(34927), // Rule ID 2872 //
     /*  34895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34909 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4f32] }:$src)  =>  (VREV32q8:{ *:[v16i8] } QPR:{ *:[v4f32] }:$src)
     /*  34909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  34912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34914 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34919 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34925 */   GIR_RootConstrainSelectedInstOperands,
     /*  34926 */   // GIR_Coverage, 2872,
     /*  34926 */   GIR_EraseRootFromParent_Done,
     /*  34927 */ // Label 772: @34927
     /*  34927 */ GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(34964), // Rule ID 2873 //
     /*  34932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34946 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4i32] }:$src)  =>  (VREV32q8:{ *:[v16i8] } QPR:{ *:[v4i32] }:$src)
     /*  34946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  34949 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34951 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34956 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34962 */   GIR_RootConstrainSelectedInstOperands,
     /*  34963 */   // GIR_Coverage, 2873,
     /*  34963 */   GIR_EraseRootFromParent_Done,
     /*  34964 */ // Label 773: @34964
     /*  34964 */ GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(35001), // Rule ID 2874 //
     /*  34969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34983 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8f16] }:$src)  =>  (VREV16q8:{ *:[v16i8] } QPR:{ *:[v8f16] }:$src)
     /*  34983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  34986 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34988 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34993 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34999 */   GIR_RootConstrainSelectedInstOperands,
     /*  35000 */   // GIR_Coverage, 2874,
     /*  35000 */   GIR_EraseRootFromParent_Done,
     /*  35001 */ // Label 774: @35001
     /*  35001 */ GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(35038), // Rule ID 2875 //
     /*  35006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  35009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  35016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  35020 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8i16] }:$src)  =>  (VREV16q8:{ *:[v16i8] } QPR:{ *:[v8i16] }:$src)
     /*  35020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  35023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  35025 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35027 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35030 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35036 */   GIR_RootConstrainSelectedInstOperands,
     /*  35037 */   // GIR_Coverage, 2875,
     /*  35037 */   GIR_EraseRootFromParent_Done,
     /*  35038 */ // Label 775: @35038
     /*  35038 */ GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(35070), // Rule ID 5319 //
     /*  35043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35057 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35057 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35060 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35062 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35064 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35069 */   // GIR_Coverage, 5319,
     /*  35069 */   GIR_EraseRootFromParent_Done,
     /*  35070 */ // Label 776: @35070
     /*  35070 */ GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(35102), // Rule ID 5320 //
     /*  35075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35089 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35092 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35094 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35096 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35101 */   // GIR_Coverage, 5320,
     /*  35101 */   GIR_EraseRootFromParent_Done,
     /*  35102 */ // Label 777: @35102
     /*  35102 */ GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(35134), // Rule ID 5321 //
     /*  35107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35121 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35124 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35126 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35128 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35133 */   // GIR_Coverage, 5321,
     /*  35133 */   GIR_EraseRootFromParent_Done,
     /*  35134 */ // Label 778: @35134
     /*  35134 */ GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(35166), // Rule ID 5322 //
     /*  35139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35153 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35156 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35158 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35160 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35165 */   // GIR_Coverage, 5322,
     /*  35165 */   GIR_EraseRootFromParent_Done,
     /*  35166 */ // Label 779: @35166
     /*  35166 */ GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(35198), // Rule ID 5323 //
     /*  35171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35185 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35188 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35190 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35192 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35197 */   // GIR_Coverage, 5323,
     /*  35197 */   GIR_EraseRootFromParent_Done,
     /*  35198 */ // Label 780: @35198
     /*  35198 */ GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(35230), // Rule ID 5324 //
     /*  35203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35217 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35220 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35222 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35224 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35229 */   // GIR_Coverage, 5324,
     /*  35229 */   GIR_EraseRootFromParent_Done,
     /*  35230 */ // Label 781: @35230
     /*  35230 */ GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(35288), // Rule ID 5355 //
     /*  35235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35249 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_8:{ *:[v16i8] } MQPR:{ *:[v2f64] }:$src)
     /*  35249 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35252 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35256 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  35264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35266 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35271 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35277 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35283 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35286 */   GIR_RootConstrainSelectedInstOperands,
     /*  35287 */   // GIR_Coverage, 5355,
     /*  35287 */   GIR_EraseRootFromParent_Done,
     /*  35288 */ // Label 782: @35288
     /*  35288 */ GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(35346), // Rule ID 5356 //
     /*  35293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35307 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_8:{ *:[v16i8] } MQPR:{ *:[v2i64] }:$src)
     /*  35307 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35310 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35314 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  35322 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35324 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35326 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35329 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35335 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35341 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35344 */   GIR_RootConstrainSelectedInstOperands,
     /*  35345 */   // GIR_Coverage, 5356,
     /*  35345 */   GIR_EraseRootFromParent_Done,
     /*  35346 */ // Label 783: @35346
     /*  35346 */ GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(35404), // Rule ID 5357 //
     /*  35351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35361 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35365 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV32_8:{ *:[v16i8] } MQPR:{ *:[v4f32] }:$src)
     /*  35365 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35368 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35372 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  35380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35382 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35387 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35393 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35399 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35402 */   GIR_RootConstrainSelectedInstOperands,
     /*  35403 */   // GIR_Coverage, 5357,
     /*  35403 */   GIR_EraseRootFromParent_Done,
     /*  35404 */ // Label 784: @35404
     /*  35404 */ GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(35462), // Rule ID 5358 //
     /*  35409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35423 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_8:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src)
     /*  35423 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35426 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35430 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  35438 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35440 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35445 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35451 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35457 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35460 */   GIR_RootConstrainSelectedInstOperands,
     /*  35461 */   // GIR_Coverage, 5358,
     /*  35461 */   GIR_EraseRootFromParent_Done,
     /*  35462 */ // Label 785: @35462
     /*  35462 */ GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(35520), // Rule ID 5359 //
     /*  35467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35481 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV16_8:{ *:[v16i8] } MQPR:{ *:[v8f16] }:$src)
     /*  35481 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35484 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35488 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  35496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35498 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35503 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35509 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35515 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35518 */   GIR_RootConstrainSelectedInstOperands,
     /*  35519 */   // GIR_Coverage, 5359,
     /*  35519 */   GIR_EraseRootFromParent_Done,
     /*  35520 */ // Label 786: @35520
     /*  35520 */ GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(35578), // Rule ID 5360 //
     /*  35525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35539 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV16_8:{ *:[v16i8] } MQPR:{ *:[v8i16] }:$src)
     /*  35539 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35542 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35546 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  35554 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35556 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35558 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35561 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35567 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35573 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35576 */   GIR_RootConstrainSelectedInstOperands,
     /*  35577 */   // GIR_Coverage, 5360,
     /*  35577 */   GIR_EraseRootFromParent_Done,
     /*  35578 */ // Label 787: @35578
     /*  35578 */ GIM_Reject,
     /*  35579 */ // Label 549: @35579
     /*  35579 */ GIM_Reject,
     /*  35580 */ // Label 10: @35580
     /*  35580 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 793*/ GIMT_Encode4(35875),
     /*  35591 */ /*GILLT_s16*//*Label 788*/ GIMT_Encode4(35643),
     /*  35595 */ /*GILLT_s32*//*Label 789*/ GIMT_Encode4(35681),
     /*  35599 */ /*GILLT_s64*//*Label 790*/ GIMT_Encode4(35719), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35623 */ /*GILLT_v4s32*//*Label 791*/ GIMT_Encode4(35757), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35639 */ /*GILLT_v8s16*//*Label 792*/ GIMT_Encode4(35816),
     /*  35643 */ // Label 788: @35643
     /*  35643 */ GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(35680), // Rule ID 665 //
     /*  35648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  35651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  35654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35662 */   // (ftrunc:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTZH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  35662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZH),
     /*  35665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  35667 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /*  35669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35672 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35678 */   GIR_RootConstrainSelectedInstOperands,
     /*  35679 */   // GIR_Coverage, 665,
     /*  35679 */   GIR_EraseRootFromParent_Done,
     /*  35680 */ // Label 794: @35680
     /*  35680 */ GIM_Reject,
     /*  35681 */ // Label 789: @35681
     /*  35681 */ GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(35718), // Rule ID 666 //
     /*  35686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  35689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  35692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35700 */   // (ftrunc:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTZS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  35700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZS),
     /*  35703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  35705 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /*  35707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35710 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35716 */   GIR_RootConstrainSelectedInstOperands,
     /*  35717 */   // GIR_Coverage, 666,
     /*  35717 */   GIR_EraseRootFromParent_Done,
     /*  35718 */ // Label 795: @35718
     /*  35718 */ GIM_Reject,
     /*  35719 */ // Label 790: @35719
     /*  35719 */ GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(35756), // Rule ID 667 //
     /*  35724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  35727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  35730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35738 */   // (ftrunc:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTZD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  35738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZD),
     /*  35741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /*  35743 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /*  35745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35748 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35754 */   GIR_RootConstrainSelectedInstOperands,
     /*  35755 */   // GIR_Coverage, 667,
     /*  35755 */   GIR_EraseRootFromParent_Done,
     /*  35756 */ // Label 796: @35756
     /*  35756 */ GIM_Reject,
     /*  35757 */ // Label 791: @35757
     /*  35757 */ GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(35815), // Rule ID 3982 //
     /*  35762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  35765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35776 */   // (ftrunc:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32Z:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /*  35776 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35779 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35783 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32Z),
     /*  35791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35793 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  35795 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35798 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35804 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35810 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35813 */   GIR_RootConstrainSelectedInstOperands,
     /*  35814 */   // GIR_Coverage, 3982,
     /*  35814 */   GIR_EraseRootFromParent_Done,
     /*  35815 */ // Label 797: @35815
     /*  35815 */ GIM_Reject,
     /*  35816 */ // Label 792: @35816
     /*  35816 */ GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(35874), // Rule ID 3970 //
     /*  35821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  35824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35835 */   // (ftrunc:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16Z:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /*  35835 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35838 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35842 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16Z),
     /*  35850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35852 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  35854 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35857 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35863 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35869 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35872 */   GIR_RootConstrainSelectedInstOperands,
     /*  35873 */   // GIR_Coverage, 3970,
     /*  35873 */   GIR_EraseRootFromParent_Done,
     /*  35874 */ // Label 798: @35874
     /*  35874 */ GIM_Reject,
     /*  35875 */ // Label 793: @35875
     /*  35875 */ GIM_Reject,
     /*  35876 */ // Label 11: @35876
     /*  35876 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 804*/ GIMT_Encode4(36138),
     /*  35887 */ /*GILLT_s16*//*Label 799*/ GIMT_Encode4(35939),
     /*  35891 */ /*GILLT_s32*//*Label 800*/ GIMT_Encode4(35966),
     /*  35895 */ /*GILLT_s64*//*Label 801*/ GIMT_Encode4(35993), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35919 */ /*GILLT_v4s32*//*Label 802*/ GIMT_Encode4(36020), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35935 */ /*GILLT_v8s16*//*Label 803*/ GIMT_Encode4(36079),
     /*  35939 */ // Label 799: @35939
     /*  35939 */ GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(35965), // Rule ID 674 //
     /*  35944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  35947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  35950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35958 */   // (fround:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTAH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  35958 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTAH),
     /*  35963 */   GIR_RootConstrainSelectedInstOperands,
     /*  35964 */   // GIR_Coverage, 674,
     /*  35964 */   GIR_Done,
     /*  35965 */ // Label 805: @35965
     /*  35965 */ GIM_Reject,
     /*  35966 */ // Label 800: @35966
     /*  35966 */ GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(35992), // Rule ID 675 //
     /*  35971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  35974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  35977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35985 */   // (fround:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTAS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  35985 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTAS),
     /*  35990 */   GIR_RootConstrainSelectedInstOperands,
     /*  35991 */   // GIR_Coverage, 675,
     /*  35991 */   GIR_Done,
     /*  35992 */ // Label 806: @35992
     /*  35992 */ GIM_Reject,
     /*  35993 */ // Label 801: @35993
     /*  35993 */ GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(36019), // Rule ID 676 //
     /*  35998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  36001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  36004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36012 */   // (fround:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTAD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  36012 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTAD),
     /*  36017 */   GIR_RootConstrainSelectedInstOperands,
     /*  36018 */   // GIR_Coverage, 676,
     /*  36018 */   GIR_Done,
     /*  36019 */ // Label 807: @36019
     /*  36019 */ GIM_Reject,
     /*  36020 */ // Label 802: @36020
     /*  36020 */ GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(36078), // Rule ID 3980 //
     /*  36025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36039 */   // (fround:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32A:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /*  36039 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36042 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36046 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32A),
     /*  36054 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36056 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36058 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36061 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36067 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36073 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36076 */   GIR_RootConstrainSelectedInstOperands,
     /*  36077 */   // GIR_Coverage, 3980,
     /*  36077 */   GIR_EraseRootFromParent_Done,
     /*  36078 */ // Label 808: @36078
     /*  36078 */ GIM_Reject,
     /*  36079 */ // Label 803: @36079
     /*  36079 */ GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(36137), // Rule ID 3968 //
     /*  36084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  36090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36098 */   // (fround:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16A:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /*  36098 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36101 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36105 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16A),
     /*  36113 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36115 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36117 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36120 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36126 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36132 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36135 */   GIR_RootConstrainSelectedInstOperands,
     /*  36136 */   // GIR_Coverage, 3968,
     /*  36136 */   GIR_EraseRootFromParent_Done,
     /*  36137 */ // Label 809: @36137
     /*  36137 */ GIM_Reject,
     /*  36138 */ // Label 804: @36138
     /*  36138 */ GIM_Reject,
     /*  36139 */ // Label 12: @36139
     /*  36139 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 815*/ GIMT_Encode4(36401),
     /*  36150 */ /*GILLT_s16*//*Label 810*/ GIMT_Encode4(36202),
     /*  36154 */ /*GILLT_s32*//*Label 811*/ GIMT_Encode4(36229),
     /*  36158 */ /*GILLT_s64*//*Label 812*/ GIMT_Encode4(36256), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36182 */ /*GILLT_v4s32*//*Label 813*/ GIMT_Encode4(36283), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36198 */ /*GILLT_v8s16*//*Label 814*/ GIMT_Encode4(36342),
     /*  36202 */ // Label 810: @36202
     /*  36202 */ GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(36228), // Rule ID 678 //
     /*  36207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  36210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  36213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36221 */   // (froundeven:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTNH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  36221 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTNH),
     /*  36226 */   GIR_RootConstrainSelectedInstOperands,
     /*  36227 */   // GIR_Coverage, 678,
     /*  36227 */   GIR_Done,
     /*  36228 */ // Label 816: @36228
     /*  36228 */ GIM_Reject,
     /*  36229 */ // Label 811: @36229
     /*  36229 */ GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(36255), // Rule ID 680 //
     /*  36234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  36237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  36240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36248 */   // (froundeven:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTNS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  36248 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTNS),
     /*  36253 */   GIR_RootConstrainSelectedInstOperands,
     /*  36254 */   // GIR_Coverage, 680,
     /*  36254 */   GIR_Done,
     /*  36255 */ // Label 817: @36255
     /*  36255 */ GIM_Reject,
     /*  36256 */ // Label 812: @36256
     /*  36256 */ GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(36282), // Rule ID 682 //
     /*  36261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  36264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  36267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36275 */   // (froundeven:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTND:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  36275 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTND),
     /*  36280 */   GIR_RootConstrainSelectedInstOperands,
     /*  36281 */   // GIR_Coverage, 682,
     /*  36281 */   GIR_Done,
     /*  36282 */ // Label 818: @36282
     /*  36282 */ GIM_Reject,
     /*  36283 */ // Label 813: @36283
     /*  36283 */ GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(36341), // Rule ID 3976 //
     /*  36288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36298 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36302 */   // (froundeven:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32N:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /*  36302 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36305 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36309 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36314 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32N),
     /*  36317 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36319 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36321 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36324 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36330 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36336 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36339 */   GIR_RootConstrainSelectedInstOperands,
     /*  36340 */   // GIR_Coverage, 3976,
     /*  36340 */   GIR_EraseRootFromParent_Done,
     /*  36341 */ // Label 819: @36341
     /*  36341 */ GIM_Reject,
     /*  36342 */ // Label 814: @36342
     /*  36342 */ GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(36400), // Rule ID 3964 //
     /*  36347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  36353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36361 */   // (froundeven:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16N:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /*  36361 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36364 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36368 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16N),
     /*  36376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36378 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36380 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36383 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36389 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36395 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36398 */   GIR_RootConstrainSelectedInstOperands,
     /*  36399 */   // GIR_Coverage, 3964,
     /*  36399 */   GIR_EraseRootFromParent_Done,
     /*  36400 */ // Label 820: @36400
     /*  36400 */ GIM_Reject,
     /*  36401 */ // Label 815: @36401
     /*  36401 */ GIM_Reject,
     /*  36402 */ // Label 13: @36402
     /*  36402 */ GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(36564),
     /*  36407 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36410 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36413 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(36488), // Rule ID 2053 //
     /*  36418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  36421 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  36428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36432 */     // MIs[0] Rn
     /*  36432 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  36436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36440 */     // (ld:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (tLDRSB:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (tMOVi8:{ *:[i32] } 0:{ *:[i32] }))
     /*  36440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /*  36447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36452 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  36458 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  36461 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  36464 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLDRSB),
     /*  36475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  36477 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  36479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  36486 */     GIR_RootConstrainSelectedInstOperands,
     /*  36487 */     // GIR_Coverage, 2053,
     /*  36487 */     GIR_EraseRootFromParent_Done,
     /*  36488 */   // Label 822: @36488
     /*  36488 */   GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(36563), // Rule ID 2054 //
     /*  36493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  36496 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  36503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36507 */     // MIs[0] Rn
     /*  36507 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  36511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36515 */     // (ld:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (tLDRSH:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (tMOVi8:{ *:[i32] } 0:{ *:[i32] }))
     /*  36515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /*  36522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36527 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  36533 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  36536 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  36539 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLDRSH),
     /*  36550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  36552 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  36554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  36561 */     GIR_RootConstrainSelectedInstOperands,
     /*  36562 */     // GIR_Coverage, 2054,
     /*  36562 */     GIR_EraseRootFromParent_Done,
     /*  36563 */   // Label 823: @36563
     /*  36563 */   GIM_Reject,
     /*  36564 */ // Label 821: @36564
     /*  36564 */ GIM_Reject,
     /*  36565 */ // Label 14: @36565
     /*  36565 */ GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(36585), // Rule ID 5421 //
     /*  36570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  36573 */   // MIs[0] Operand 0
     /*  36573 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /*  36576 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  36580 */   // (atomic_fence (timm:{ *:[i32] }), 0:{ *:[i32] })  =>  (MEMBARRIER)
     /*  36580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::MEMBARRIER),
     /*  36583 */   GIR_RootConstrainSelectedInstOperands,
     /*  36584 */   // GIR_Coverage, 5421,
     /*  36584 */   GIR_EraseRootFromParent_Done,
     /*  36585 */ // Label 824: @36585
     /*  36585 */ GIM_Reject,
     /*  36586 */ // Label 15: @36586
     /*  36586 */ GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(42125),
     /*  36591 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  36594 */   GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(36642), // Rule ID 1856 //
     /*  36599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  36602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtb16),
     /*  36607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  36617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  36621 */     // (intrinsic_wo_chain:{ *:[i32] } 3943:{ *:[iPTR] }, GPR:{ *:[i32] }:$Src)  =>  (UXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  36621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB16),
     /*  36624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Src
     /*  36628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36634 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36640 */     GIR_RootConstrainSelectedInstOperands,
     /*  36641 */     // GIR_Coverage, 1856,
     /*  36641 */     GIR_EraseRootFromParent_Done,
     /*  36642 */   // Label 826: @36642
     /*  36642 */   GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(36690), // Rule ID 2110 //
     /*  36647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  36650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtb16),
     /*  36655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  36665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  36669 */     // (intrinsic_wo_chain:{ *:[i32] } 3943:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm)  =>  (t2UXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  36669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB16),
     /*  36672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  36676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36682 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36688 */     GIR_RootConstrainSelectedInstOperands,
     /*  36689 */     // GIR_Coverage, 2110,
     /*  36689 */     GIR_EraseRootFromParent_Done,
     /*  36690 */   // Label 827: @36690
     /*  36690 */   GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(36726), // Rule ID 677 //
     /*  36695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  36698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  36703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  36706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  36709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36717 */     // (intrinsic_wo_chain:{ *:[f16] } 3829:{ *:[iPTR] }, HPR:{ *:[f16] }:$Sm)  =>  (VRINTNH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  36717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNH),
     /*  36720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  36724 */     GIR_RootConstrainSelectedInstOperands,
     /*  36725 */     // GIR_Coverage, 677,
     /*  36725 */     GIR_EraseRootFromParent_Done,
     /*  36726 */   // Label 828: @36726
     /*  36726 */   GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(36762), // Rule ID 679 //
     /*  36731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  36734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  36739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36753 */     // (intrinsic_wo_chain:{ *:[f32] } 3829:{ *:[iPTR] }, SPR:{ *:[f32] }:$Sm)  =>  (VRINTNS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  36753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNS),
     /*  36756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  36760 */     GIR_RootConstrainSelectedInstOperands,
     /*  36761 */     // GIR_Coverage, 679,
     /*  36761 */     GIR_EraseRootFromParent_Done,
     /*  36762 */   // Label 829: @36762
     /*  36762 */   GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(36798), // Rule ID 681 //
     /*  36767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  36770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  36775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  36778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36789 */     // (intrinsic_wo_chain:{ *:[f64] } 3829:{ *:[iPTR] }, DPR:{ *:[f64] }:$Dm)  =>  (VRINTND:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  36789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTND),
     /*  36792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /*  36794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  36796 */     GIR_RootConstrainSelectedInstOperands,
     /*  36797 */     // GIR_Coverage, 681,
     /*  36797 */     GIR_EraseRootFromParent_Done,
     /*  36798 */   // Label 830: @36798
     /*  36798 */   GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(36843), // Rule ID 696 //
     /*  36803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /*  36806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtr),
     /*  36811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36825 */     // (intrinsic_wo_chain:{ *:[f32] } 3944:{ *:[iPTR] }, DPR:{ *:[f64] }:$Dm)  =>  (VTOSIRD:{ *:[f32] } DPR:{ *:[f64] }:$Dm)
     /*  36825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOSIRD),
     /*  36828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  36832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36835 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36841 */     GIR_RootConstrainSelectedInstOperands,
     /*  36842 */     // GIR_Coverage, 696,
     /*  36842 */     GIR_EraseRootFromParent_Done,
     /*  36843 */   // Label 831: @36843
     /*  36843 */   GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(36888), // Rule ID 697 //
     /*  36848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /*  36851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtr),
     /*  36856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36870 */     // (intrinsic_wo_chain:{ *:[f32] } 3944:{ *:[iPTR] }, SPR:{ *:[f32] }:$Sm)  =>  (VTOSIRS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  36870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOSIRS),
     /*  36873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  36877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36880 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36886 */     GIR_RootConstrainSelectedInstOperands,
     /*  36887 */     // GIR_Coverage, 697,
     /*  36887 */     GIR_EraseRootFromParent_Done,
     /*  36888 */   // Label 832: @36888
     /*  36888 */   GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(36933), // Rule ID 698 //
     /*  36893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /*  36896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtru),
     /*  36901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36915 */     // (intrinsic_wo_chain:{ *:[f32] } 3945:{ *:[iPTR] }, DPR:{ *:[f64] }:$Dm)  =>  (VTOUIRD:{ *:[f32] } DPR:{ *:[f64] }:$Dm)
     /*  36915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOUIRD),
     /*  36918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  36922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36925 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36931 */     GIR_RootConstrainSelectedInstOperands,
     /*  36932 */     // GIR_Coverage, 698,
     /*  36932 */     GIR_EraseRootFromParent_Done,
     /*  36933 */   // Label 833: @36933
     /*  36933 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(36978), // Rule ID 699 //
     /*  36938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /*  36941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtru),
     /*  36946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36960 */     // (intrinsic_wo_chain:{ *:[f32] } 3945:{ *:[iPTR] }, SPR:{ *:[f32] }:$Sm)  =>  (VTOUIRS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  36960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOUIRS),
     /*  36963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  36967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36970 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36976 */     GIR_RootConstrainSelectedInstOperands,
     /*  36977 */     // GIR_Coverage, 699,
     /*  36977 */     GIR_EraseRootFromParent_Done,
     /*  36978 */   // Label 834: @36978
     /*  36978 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(37023), // Rule ID 1242 //
     /*  36983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  36991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  36994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  36997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37005 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3796:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADDLsv8i8:{ *:[v4i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  37005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv8i8),
     /*  37008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37015 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37021 */     GIR_RootConstrainSelectedInstOperands,
     /*  37022 */     // GIR_Coverage, 1242,
     /*  37022 */     GIR_EraseRootFromParent_Done,
     /*  37023 */   // Label 835: @37023
     /*  37023 */   GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(37068), // Rule ID 1243 //
     /*  37028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37050 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3796:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADDLsv4i16:{ *:[v2i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  37050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv4i16),
     /*  37053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37060 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37066 */     GIR_RootConstrainSelectedInstOperands,
     /*  37067 */     // GIR_Coverage, 1243,
     /*  37067 */     GIR_EraseRootFromParent_Done,
     /*  37068 */   // Label 836: @37068
     /*  37068 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(37113), // Rule ID 1244 //
     /*  37073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  37084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37095 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3796:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADDLsv2i32:{ *:[v1i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  37095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv2i32),
     /*  37098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37105 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37111 */     GIR_RootConstrainSelectedInstOperands,
     /*  37112 */     // GIR_Coverage, 1244,
     /*  37112 */     GIR_EraseRootFromParent_Done,
     /*  37113 */   // Label 837: @37113
     /*  37113 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(37158), // Rule ID 1245 //
     /*  37118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  37132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37140 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3796:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADDLsv16i8:{ *:[v8i16] } QPR:{ *:[v16i8] }:$Vm)
     /*  37140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv16i8),
     /*  37143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37150 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37156 */     GIR_RootConstrainSelectedInstOperands,
     /*  37157 */     // GIR_Coverage, 1245,
     /*  37157 */     GIR_EraseRootFromParent_Done,
     /*  37158 */   // Label 838: @37158
     /*  37158 */   GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(37203), // Rule ID 1246 //
     /*  37163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37185 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3796:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADDLsv8i16:{ *:[v4i32] } QPR:{ *:[v8i16] }:$Vm)
     /*  37185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv8i16),
     /*  37188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37195 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37201 */     GIR_RootConstrainSelectedInstOperands,
     /*  37202 */     // GIR_Coverage, 1246,
     /*  37202 */     GIR_EraseRootFromParent_Done,
     /*  37203 */   // Label 839: @37203
     /*  37203 */   GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(37248), // Rule ID 1247 //
     /*  37208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  37219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37230 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3796:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADDLsv4i32:{ *:[v2i64] } QPR:{ *:[v4i32] }:$Vm)
     /*  37230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv4i32),
     /*  37233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37240 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37246 */     GIR_RootConstrainSelectedInstOperands,
     /*  37247 */     // GIR_Coverage, 1247,
     /*  37247 */     GIR_EraseRootFromParent_Done,
     /*  37248 */   // Label 840: @37248
     /*  37248 */   GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(37293), // Rule ID 1248 //
     /*  37253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  37264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  37267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37275 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3797:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADDLuv8i8:{ *:[v4i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  37275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv8i8),
     /*  37278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37285 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37291 */     GIR_RootConstrainSelectedInstOperands,
     /*  37292 */     // GIR_Coverage, 1248,
     /*  37292 */     GIR_EraseRootFromParent_Done,
     /*  37293 */   // Label 841: @37293
     /*  37293 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(37338), // Rule ID 1249 //
     /*  37298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37320 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3797:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADDLuv4i16:{ *:[v2i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  37320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv4i16),
     /*  37323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37330 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37336 */     GIR_RootConstrainSelectedInstOperands,
     /*  37337 */     // GIR_Coverage, 1249,
     /*  37337 */     GIR_EraseRootFromParent_Done,
     /*  37338 */   // Label 842: @37338
     /*  37338 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(37383), // Rule ID 1250 //
     /*  37343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  37354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37365 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3797:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADDLuv2i32:{ *:[v1i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  37365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv2i32),
     /*  37368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37375 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37381 */     GIR_RootConstrainSelectedInstOperands,
     /*  37382 */     // GIR_Coverage, 1250,
     /*  37382 */     GIR_EraseRootFromParent_Done,
     /*  37383 */   // Label 843: @37383
     /*  37383 */   GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(37428), // Rule ID 1251 //
     /*  37388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  37402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37410 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3797:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADDLuv16i8:{ *:[v8i16] } QPR:{ *:[v16i8] }:$Vm)
     /*  37410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv16i8),
     /*  37413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37420 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37426 */     GIR_RootConstrainSelectedInstOperands,
     /*  37427 */     // GIR_Coverage, 1251,
     /*  37427 */     GIR_EraseRootFromParent_Done,
     /*  37428 */   // Label 844: @37428
     /*  37428 */   GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(37473), // Rule ID 1252 //
     /*  37433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37455 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3797:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADDLuv8i16:{ *:[v4i32] } QPR:{ *:[v8i16] }:$Vm)
     /*  37455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv8i16),
     /*  37458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37465 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37471 */     GIR_RootConstrainSelectedInstOperands,
     /*  37472 */     // GIR_Coverage, 1252,
     /*  37472 */     GIR_EraseRootFromParent_Done,
     /*  37473 */   // Label 845: @37473
     /*  37473 */   GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(37518), // Rule ID 1253 //
     /*  37478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  37489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37500 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3797:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADDLuv4i32:{ *:[v2i64] } QPR:{ *:[v4i32] }:$Vm)
     /*  37500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv4i32),
     /*  37503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37510 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37516 */     GIR_RootConstrainSelectedInstOperands,
     /*  37517 */     // GIR_Coverage, 1253,
     /*  37517 */     GIR_EraseRootFromParent_Done,
     /*  37518 */   // Label 846: @37518
     /*  37518 */   GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(37563), // Rule ID 1282 //
     /*  37523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37545 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3824:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VRECPEd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  37545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEd),
     /*  37548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37555 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37561 */     GIR_RootConstrainSelectedInstOperands,
     /*  37562 */     // GIR_Coverage, 1282,
     /*  37562 */     GIR_EraseRootFromParent_Done,
     /*  37563 */   // Label 847: @37563
     /*  37563 */   GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(37608), // Rule ID 1283 //
     /*  37568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37590 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3824:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VRECPEq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  37590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEq),
     /*  37593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37600 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37606 */     GIR_RootConstrainSelectedInstOperands,
     /*  37607 */     // GIR_Coverage, 1283,
     /*  37607 */     GIR_EraseRootFromParent_Done,
     /*  37608 */   // Label 848: @37608
     /*  37608 */   GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(37653), // Rule ID 1284 //
     /*  37613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37635 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3824:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRECPEfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  37635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEfd),
     /*  37638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37645 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37651 */     GIR_RootConstrainSelectedInstOperands,
     /*  37652 */     // GIR_Coverage, 1284,
     /*  37652 */     GIR_EraseRootFromParent_Done,
     /*  37653 */   // Label 849: @37653
     /*  37653 */   GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(37698), // Rule ID 1285 //
     /*  37658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37680 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3824:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRECPEfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  37680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEfq),
     /*  37683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37690 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37696 */     GIR_RootConstrainSelectedInstOperands,
     /*  37697 */     // GIR_Coverage, 1285,
     /*  37697 */     GIR_EraseRootFromParent_Done,
     /*  37698 */   // Label 850: @37698
     /*  37698 */   GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(37743), // Rule ID 1286 //
     /*  37703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  37706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  37714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37725 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3824:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRECPEhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  37725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEhd),
     /*  37728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37735 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37741 */     GIR_RootConstrainSelectedInstOperands,
     /*  37742 */     // GIR_Coverage, 1286,
     /*  37742 */     GIR_EraseRootFromParent_Done,
     /*  37743 */   // Label 851: @37743
     /*  37743 */   GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(37788), // Rule ID 1287 //
     /*  37748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  37751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37770 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3824:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRECPEhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  37770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEhq),
     /*  37773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37780 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37786 */     GIR_RootConstrainSelectedInstOperands,
     /*  37787 */     // GIR_Coverage, 1287,
     /*  37787 */     GIR_EraseRootFromParent_Done,
     /*  37788 */   // Label 852: @37788
     /*  37788 */   GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(37833), // Rule ID 1292 //
     /*  37793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37815 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3836:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VRSQRTEd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  37815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEd),
     /*  37818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37825 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37831 */     GIR_RootConstrainSelectedInstOperands,
     /*  37832 */     // GIR_Coverage, 1292,
     /*  37832 */     GIR_EraseRootFromParent_Done,
     /*  37833 */   // Label 853: @37833
     /*  37833 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(37878), // Rule ID 1293 //
     /*  37838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37860 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3836:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VRSQRTEq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  37860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEq),
     /*  37863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37870 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37876 */     GIR_RootConstrainSelectedInstOperands,
     /*  37877 */     // GIR_Coverage, 1293,
     /*  37877 */     GIR_EraseRootFromParent_Done,
     /*  37878 */   // Label 854: @37878
     /*  37878 */   GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(37923), // Rule ID 1294 //
     /*  37883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37905 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3836:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRSQRTEfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  37905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEfd),
     /*  37908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37915 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37921 */     GIR_RootConstrainSelectedInstOperands,
     /*  37922 */     // GIR_Coverage, 1294,
     /*  37922 */     GIR_EraseRootFromParent_Done,
     /*  37923 */   // Label 855: @37923
     /*  37923 */   GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(37968), // Rule ID 1295 //
     /*  37928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37950 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3836:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRSQRTEfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  37950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEfq),
     /*  37953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37966 */     GIR_RootConstrainSelectedInstOperands,
     /*  37967 */     // GIR_Coverage, 1295,
     /*  37967 */     GIR_EraseRootFromParent_Done,
     /*  37968 */   // Label 856: @37968
     /*  37968 */   GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(38013), // Rule ID 1296 //
     /*  37973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  37976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  37984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37995 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3836:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRSQRTEhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  37995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEhd),
     /*  37998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38005 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38011 */     GIR_RootConstrainSelectedInstOperands,
     /*  38012 */     // GIR_Coverage, 1296,
     /*  38012 */     GIR_EraseRootFromParent_Done,
     /*  38013 */   // Label 857: @38013
     /*  38013 */   GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(38058), // Rule ID 1297 //
     /*  38018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  38021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  38026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  38029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38040 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3836:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRSQRTEhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  38040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEhq),
     /*  38043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38050 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38056 */     GIR_RootConstrainSelectedInstOperands,
     /*  38057 */     // GIR_Coverage, 1297,
     /*  38057 */     GIR_EraseRootFromParent_Done,
     /*  38058 */   // Label 858: @38058
     /*  38058 */   GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(38103), // Rule ID 1518 //
     /*  38063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  38077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38085 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3802:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VQABSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /*  38085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv8i8),
     /*  38088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38095 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38101 */     GIR_RootConstrainSelectedInstOperands,
     /*  38102 */     // GIR_Coverage, 1518,
     /*  38102 */     GIR_EraseRootFromParent_Done,
     /*  38103 */   // Label 859: @38103
     /*  38103 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(38148), // Rule ID 1519 //
     /*  38108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  38122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38130 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3802:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VQABSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /*  38130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv4i16),
     /*  38133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38140 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38146 */     GIR_RootConstrainSelectedInstOperands,
     /*  38147 */     // GIR_Coverage, 1519,
     /*  38147 */     GIR_EraseRootFromParent_Done,
     /*  38148 */   // Label 860: @38148
     /*  38148 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(38193), // Rule ID 1520 //
     /*  38153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38175 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3802:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VQABSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  38175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv2i32),
     /*  38178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38185 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38191 */     GIR_RootConstrainSelectedInstOperands,
     /*  38192 */     // GIR_Coverage, 1520,
     /*  38192 */     GIR_EraseRootFromParent_Done,
     /*  38193 */   // Label 861: @38193
     /*  38193 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(38238), // Rule ID 1521 //
     /*  38198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  38209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  38212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38220 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3802:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VQABSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  38220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv16i8),
     /*  38223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38236 */     GIR_RootConstrainSelectedInstOperands,
     /*  38237 */     // GIR_Coverage, 1521,
     /*  38237 */     GIR_EraseRootFromParent_Done,
     /*  38238 */   // Label 862: @38238
     /*  38238 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(38283), // Rule ID 1522 //
     /*  38243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  38254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38265 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3802:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQABSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /*  38265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv8i16),
     /*  38268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38275 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38281 */     GIR_RootConstrainSelectedInstOperands,
     /*  38282 */     // GIR_Coverage, 1522,
     /*  38282 */     GIR_EraseRootFromParent_Done,
     /*  38283 */   // Label 863: @38283
     /*  38283 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(38328), // Rule ID 1523 //
     /*  38288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38310 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3802:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQABSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  38310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv4i32),
     /*  38313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38320 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38326 */     GIR_RootConstrainSelectedInstOperands,
     /*  38327 */     // GIR_Coverage, 1523,
     /*  38327 */     GIR_EraseRootFromParent_Done,
     /*  38328 */   // Label 864: @38328
     /*  38328 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(38373), // Rule ID 1534 //
     /*  38333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  38347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38355 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3808:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VQNEGv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /*  38355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv8i8),
     /*  38358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38365 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38371 */     GIR_RootConstrainSelectedInstOperands,
     /*  38372 */     // GIR_Coverage, 1534,
     /*  38372 */     GIR_EraseRootFromParent_Done,
     /*  38373 */   // Label 865: @38373
     /*  38373 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(38418), // Rule ID 1535 //
     /*  38378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  38392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38400 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3808:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VQNEGv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /*  38400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv4i16),
     /*  38403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38410 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38416 */     GIR_RootConstrainSelectedInstOperands,
     /*  38417 */     // GIR_Coverage, 1535,
     /*  38417 */     GIR_EraseRootFromParent_Done,
     /*  38418 */   // Label 866: @38418
     /*  38418 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(38463), // Rule ID 1536 //
     /*  38423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38445 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3808:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VQNEGv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  38445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv2i32),
     /*  38448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38455 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38461 */     GIR_RootConstrainSelectedInstOperands,
     /*  38462 */     // GIR_Coverage, 1536,
     /*  38462 */     GIR_EraseRootFromParent_Done,
     /*  38463 */   // Label 867: @38463
     /*  38463 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(38508), // Rule ID 1537 //
     /*  38468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  38479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  38482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38490 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3808:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VQNEGv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  38490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv16i8),
     /*  38493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38500 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38506 */     GIR_RootConstrainSelectedInstOperands,
     /*  38507 */     // GIR_Coverage, 1537,
     /*  38507 */     GIR_EraseRootFromParent_Done,
     /*  38508 */   // Label 868: @38508
     /*  38508 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(38553), // Rule ID 1538 //
     /*  38513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  38524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38535 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3808:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQNEGv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /*  38535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv8i16),
     /*  38538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38545 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38551 */     GIR_RootConstrainSelectedInstOperands,
     /*  38552 */     // GIR_Coverage, 1538,
     /*  38552 */     GIR_EraseRootFromParent_Done,
     /*  38553 */   // Label 869: @38553
     /*  38553 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(38598), // Rule ID 1539 //
     /*  38558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38580 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3808:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQNEGv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  38580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv4i32),
     /*  38583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38590 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38596 */     GIR_RootConstrainSelectedInstOperands,
     /*  38597 */     // GIR_Coverage, 1539,
     /*  38597 */     GIR_EraseRootFromParent_Done,
     /*  38598 */   // Label 870: @38598
     /*  38598 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(38643), // Rule ID 1540 //
     /*  38603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  38617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38625 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3749:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VCLSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /*  38625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv8i8),
     /*  38628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38635 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38641 */     GIR_RootConstrainSelectedInstOperands,
     /*  38642 */     // GIR_Coverage, 1540,
     /*  38642 */     GIR_EraseRootFromParent_Done,
     /*  38643 */   // Label 871: @38643
     /*  38643 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(38688), // Rule ID 1541 //
     /*  38648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  38662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38670 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3749:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VCLSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /*  38670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv4i16),
     /*  38673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38680 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38686 */     GIR_RootConstrainSelectedInstOperands,
     /*  38687 */     // GIR_Coverage, 1541,
     /*  38687 */     GIR_EraseRootFromParent_Done,
     /*  38688 */   // Label 872: @38688
     /*  38688 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(38733), // Rule ID 1542 //
     /*  38693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38715 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3749:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VCLSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  38715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv2i32),
     /*  38718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38725 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38731 */     GIR_RootConstrainSelectedInstOperands,
     /*  38732 */     // GIR_Coverage, 1542,
     /*  38732 */     GIR_EraseRootFromParent_Done,
     /*  38733 */   // Label 873: @38733
     /*  38733 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(38778), // Rule ID 1543 //
     /*  38738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  38749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  38752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38760 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3749:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VCLSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  38760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv16i8),
     /*  38763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38770 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38776 */     GIR_RootConstrainSelectedInstOperands,
     /*  38777 */     // GIR_Coverage, 1543,
     /*  38777 */     GIR_EraseRootFromParent_Done,
     /*  38778 */   // Label 874: @38778
     /*  38778 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(38823), // Rule ID 1544 //
     /*  38783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  38794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38805 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3749:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VCLSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /*  38805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv8i16),
     /*  38808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38815 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38821 */     GIR_RootConstrainSelectedInstOperands,
     /*  38822 */     // GIR_Coverage, 1544,
     /*  38822 */     GIR_EraseRootFromParent_Done,
     /*  38823 */   // Label 875: @38823
     /*  38823 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(38868), // Rule ID 1545 //
     /*  38828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38850 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3749:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VCLSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  38850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv4i32),
     /*  38853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38860 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38866 */     GIR_RootConstrainSelectedInstOperands,
     /*  38867 */     // GIR_Coverage, 1545,
     /*  38867 */     GIR_EraseRootFromParent_Done,
     /*  38868 */   // Label 876: @38868
     /*  38868 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(38913), // Rule ID 1589 //
     /*  38873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovns),
     /*  38881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38895 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3805:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQMOVNsv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  38895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsv8i8),
     /*  38898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38911 */     GIR_RootConstrainSelectedInstOperands,
     /*  38912 */     // GIR_Coverage, 1589,
     /*  38912 */     GIR_EraseRootFromParent_Done,
     /*  38913 */   // Label 877: @38913
     /*  38913 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(38958), // Rule ID 1590 //
     /*  38918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovns),
     /*  38926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38940 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3805:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQMOVNsv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  38940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsv4i16),
     /*  38943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38950 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38956 */     GIR_RootConstrainSelectedInstOperands,
     /*  38957 */     // GIR_Coverage, 1590,
     /*  38957 */     GIR_EraseRootFromParent_Done,
     /*  38958 */   // Label 878: @38958
     /*  38958 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(39003), // Rule ID 1591 //
     /*  38963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovns),
     /*  38971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  38977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38985 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3805:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm)  =>  (VQMOVNsv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  38985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsv2i32),
     /*  38988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39001 */     GIR_RootConstrainSelectedInstOperands,
     /*  39002 */     // GIR_Coverage, 1591,
     /*  39002 */     GIR_EraseRootFromParent_Done,
     /*  39003 */   // Label 879: @39003
     /*  39003 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(39048), // Rule ID 1592 //
     /*  39008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnu),
     /*  39016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  39019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39030 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3807:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQMOVNuv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  39030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNuv8i8),
     /*  39033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39040 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39046 */     GIR_RootConstrainSelectedInstOperands,
     /*  39047 */     // GIR_Coverage, 1592,
     /*  39047 */     GIR_EraseRootFromParent_Done,
     /*  39048 */   // Label 880: @39048
     /*  39048 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(39093), // Rule ID 1593 //
     /*  39053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnu),
     /*  39061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39075 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3807:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQMOVNuv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  39075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNuv4i16),
     /*  39078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39085 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39091 */     GIR_RootConstrainSelectedInstOperands,
     /*  39092 */     // GIR_Coverage, 1593,
     /*  39092 */     GIR_EraseRootFromParent_Done,
     /*  39093 */   // Label 881: @39093
     /*  39093 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(39138), // Rule ID 1594 //
     /*  39098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnu),
     /*  39106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  39112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39120 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3807:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm)  =>  (VQMOVNuv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  39120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNuv2i32),
     /*  39123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39130 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39136 */     GIR_RootConstrainSelectedInstOperands,
     /*  39137 */     // GIR_Coverage, 1594,
     /*  39137 */     GIR_EraseRootFromParent_Done,
     /*  39138 */   // Label 882: @39138
     /*  39138 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(39183), // Rule ID 1595 //
     /*  39143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnsu),
     /*  39151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  39154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39165 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3806:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQMOVNsuv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  39165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsuv8i8),
     /*  39168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39175 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39181 */     GIR_RootConstrainSelectedInstOperands,
     /*  39182 */     // GIR_Coverage, 1595,
     /*  39182 */     GIR_EraseRootFromParent_Done,
     /*  39183 */   // Label 883: @39183
     /*  39183 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(39228), // Rule ID 1596 //
     /*  39188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnsu),
     /*  39196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39210 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3806:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQMOVNsuv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  39210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsuv4i16),
     /*  39213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39220 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39226 */     GIR_RootConstrainSelectedInstOperands,
     /*  39227 */     // GIR_Coverage, 1596,
     /*  39227 */     GIR_EraseRootFromParent_Done,
     /*  39228 */   // Label 884: @39228
     /*  39228 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(39273), // Rule ID 1597 //
     /*  39233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnsu),
     /*  39241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  39247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39255 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3806:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm)  =>  (VQMOVNsuv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  39255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsuv2i32),
     /*  39258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39265 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39271 */     GIR_RootConstrainSelectedInstOperands,
     /*  39272 */     // GIR_Coverage, 1597,
     /*  39272 */     GIR_EraseRootFromParent_Done,
     /*  39273 */   // Label 885: @39273
     /*  39273 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(39309), // Rule ID 1620 //
     /*  39278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39300 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3750:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTANSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSDf),
     /*  39303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39307 */     GIR_RootConstrainSelectedInstOperands,
     /*  39308 */     // GIR_Coverage, 1620,
     /*  39308 */     GIR_EraseRootFromParent_Done,
     /*  39309 */   // Label 886: @39309
     /*  39309 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(39345), // Rule ID 1621 //
     /*  39314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39336 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3750:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTANSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSQf),
     /*  39339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39343 */     GIR_RootConstrainSelectedInstOperands,
     /*  39344 */     // GIR_Coverage, 1621,
     /*  39344 */     GIR_EraseRootFromParent_Done,
     /*  39345 */   // Label 887: @39345
     /*  39345 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(39381), // Rule ID 1622 //
     /*  39350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39372 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3751:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTANUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUDf),
     /*  39375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39379 */     GIR_RootConstrainSelectedInstOperands,
     /*  39380 */     // GIR_Coverage, 1622,
     /*  39380 */     GIR_EraseRootFromParent_Done,
     /*  39381 */   // Label 888: @39381
     /*  39381 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(39417), // Rule ID 1623 //
     /*  39386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39408 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3751:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTANUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUQf),
     /*  39411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39415 */     GIR_RootConstrainSelectedInstOperands,
     /*  39416 */     // GIR_Coverage, 1623,
     /*  39416 */     GIR_EraseRootFromParent_Done,
     /*  39417 */   // Label 889: @39417
     /*  39417 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(39453), // Rule ID 1624 //
     /*  39422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39444 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3750:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTANSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSDh),
     /*  39447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39451 */     GIR_RootConstrainSelectedInstOperands,
     /*  39452 */     // GIR_Coverage, 1624,
     /*  39452 */     GIR_EraseRootFromParent_Done,
     /*  39453 */   // Label 890: @39453
     /*  39453 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(39489), // Rule ID 1625 //
     /*  39458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39480 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3750:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTANSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSQh),
     /*  39483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39487 */     GIR_RootConstrainSelectedInstOperands,
     /*  39488 */     // GIR_Coverage, 1625,
     /*  39488 */     GIR_EraseRootFromParent_Done,
     /*  39489 */   // Label 891: @39489
     /*  39489 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(39525), // Rule ID 1626 //
     /*  39494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39516 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3751:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTANUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUDh),
     /*  39519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39523 */     GIR_RootConstrainSelectedInstOperands,
     /*  39524 */     // GIR_Coverage, 1626,
     /*  39524 */     GIR_EraseRootFromParent_Done,
     /*  39525 */   // Label 892: @39525
     /*  39525 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(39561), // Rule ID 1627 //
     /*  39530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39552 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3751:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTANUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUQh),
     /*  39555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39559 */     GIR_RootConstrainSelectedInstOperands,
     /*  39560 */     // GIR_Coverage, 1627,
     /*  39560 */     GIR_EraseRootFromParent_Done,
     /*  39561 */   // Label 893: @39561
     /*  39561 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(39597), // Rule ID 1628 //
     /*  39566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39588 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3762:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTNNSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSDf),
     /*  39591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39595 */     GIR_RootConstrainSelectedInstOperands,
     /*  39596 */     // GIR_Coverage, 1628,
     /*  39596 */     GIR_EraseRootFromParent_Done,
     /*  39597 */   // Label 894: @39597
     /*  39597 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(39633), // Rule ID 1629 //
     /*  39602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39624 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3762:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTNNSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSQf),
     /*  39627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39631 */     GIR_RootConstrainSelectedInstOperands,
     /*  39632 */     // GIR_Coverage, 1629,
     /*  39632 */     GIR_EraseRootFromParent_Done,
     /*  39633 */   // Label 895: @39633
     /*  39633 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(39669), // Rule ID 1630 //
     /*  39638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39660 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3763:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTNNUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUDf),
     /*  39663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39667 */     GIR_RootConstrainSelectedInstOperands,
     /*  39668 */     // GIR_Coverage, 1630,
     /*  39668 */     GIR_EraseRootFromParent_Done,
     /*  39669 */   // Label 896: @39669
     /*  39669 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(39705), // Rule ID 1631 //
     /*  39674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39696 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3763:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTNNUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUQf),
     /*  39699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39703 */     GIR_RootConstrainSelectedInstOperands,
     /*  39704 */     // GIR_Coverage, 1631,
     /*  39704 */     GIR_EraseRootFromParent_Done,
     /*  39705 */   // Label 897: @39705
     /*  39705 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(39741), // Rule ID 1632 //
     /*  39710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39732 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3762:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTNNSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSDh),
     /*  39735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39739 */     GIR_RootConstrainSelectedInstOperands,
     /*  39740 */     // GIR_Coverage, 1632,
     /*  39740 */     GIR_EraseRootFromParent_Done,
     /*  39741 */   // Label 898: @39741
     /*  39741 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(39777), // Rule ID 1633 //
     /*  39746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39768 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3762:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTNNSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSQh),
     /*  39771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39775 */     GIR_RootConstrainSelectedInstOperands,
     /*  39776 */     // GIR_Coverage, 1633,
     /*  39776 */     GIR_EraseRootFromParent_Done,
     /*  39777 */   // Label 899: @39777
     /*  39777 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(39813), // Rule ID 1634 //
     /*  39782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39804 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3763:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTNNUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUDh),
     /*  39807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39811 */     GIR_RootConstrainSelectedInstOperands,
     /*  39812 */     // GIR_Coverage, 1634,
     /*  39812 */     GIR_EraseRootFromParent_Done,
     /*  39813 */   // Label 900: @39813
     /*  39813 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(39849), // Rule ID 1635 //
     /*  39818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39840 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3763:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTNNUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUQh),
     /*  39843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39847 */     GIR_RootConstrainSelectedInstOperands,
     /*  39848 */     // GIR_Coverage, 1635,
     /*  39848 */     GIR_EraseRootFromParent_Done,
     /*  39849 */   // Label 901: @39849
     /*  39849 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(39885), // Rule ID 1636 //
     /*  39854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  39862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39876 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3764:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTPNSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSDf),
     /*  39879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39883 */     GIR_RootConstrainSelectedInstOperands,
     /*  39884 */     // GIR_Coverage, 1636,
     /*  39884 */     GIR_EraseRootFromParent_Done,
     /*  39885 */   // Label 902: @39885
     /*  39885 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(39921), // Rule ID 1637 //
     /*  39890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  39898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39912 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3764:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTPNSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSQf),
     /*  39915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39919 */     GIR_RootConstrainSelectedInstOperands,
     /*  39920 */     // GIR_Coverage, 1637,
     /*  39920 */     GIR_EraseRootFromParent_Done,
     /*  39921 */   // Label 903: @39921
     /*  39921 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(39957), // Rule ID 1638 //
     /*  39926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  39934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39948 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3765:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTPNUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUDf),
     /*  39951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39955 */     GIR_RootConstrainSelectedInstOperands,
     /*  39956 */     // GIR_Coverage, 1638,
     /*  39956 */     GIR_EraseRootFromParent_Done,
     /*  39957 */   // Label 904: @39957
     /*  39957 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(39993), // Rule ID 1639 //
     /*  39962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  39970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39984 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3765:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTPNUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUQf),
     /*  39987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39991 */     GIR_RootConstrainSelectedInstOperands,
     /*  39992 */     // GIR_Coverage, 1639,
     /*  39992 */     GIR_EraseRootFromParent_Done,
     /*  39993 */   // Label 905: @39993
     /*  39993 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(40029), // Rule ID 1640 //
     /*  39998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  40006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40020 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3764:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTPNSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSDh),
     /*  40023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40027 */     GIR_RootConstrainSelectedInstOperands,
     /*  40028 */     // GIR_Coverage, 1640,
     /*  40028 */     GIR_EraseRootFromParent_Done,
     /*  40029 */   // Label 906: @40029
     /*  40029 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(40065), // Rule ID 1641 //
     /*  40034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  40042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40056 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3764:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTPNSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSQh),
     /*  40059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40063 */     GIR_RootConstrainSelectedInstOperands,
     /*  40064 */     // GIR_Coverage, 1641,
     /*  40064 */     GIR_EraseRootFromParent_Done,
     /*  40065 */   // Label 907: @40065
     /*  40065 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(40101), // Rule ID 1642 //
     /*  40070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  40078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40092 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3765:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTPNUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUDh),
     /*  40095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40099 */     GIR_RootConstrainSelectedInstOperands,
     /*  40100 */     // GIR_Coverage, 1642,
     /*  40100 */     GIR_EraseRootFromParent_Done,
     /*  40101 */   // Label 908: @40101
     /*  40101 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(40137), // Rule ID 1643 //
     /*  40106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  40114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40128 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3765:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTPNUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUQh),
     /*  40131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40135 */     GIR_RootConstrainSelectedInstOperands,
     /*  40136 */     // GIR_Coverage, 1643,
     /*  40136 */     GIR_EraseRootFromParent_Done,
     /*  40137 */   // Label 909: @40137
     /*  40137 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(40173), // Rule ID 1644 //
     /*  40142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40164 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3760:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTMNSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSDf),
     /*  40167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40171 */     GIR_RootConstrainSelectedInstOperands,
     /*  40172 */     // GIR_Coverage, 1644,
     /*  40172 */     GIR_EraseRootFromParent_Done,
     /*  40173 */   // Label 910: @40173
     /*  40173 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(40209), // Rule ID 1645 //
     /*  40178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40200 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3760:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTMNSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSQf),
     /*  40203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40207 */     GIR_RootConstrainSelectedInstOperands,
     /*  40208 */     // GIR_Coverage, 1645,
     /*  40208 */     GIR_EraseRootFromParent_Done,
     /*  40209 */   // Label 911: @40209
     /*  40209 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(40245), // Rule ID 1646 //
     /*  40214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40236 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3761:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTMNUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUDf),
     /*  40239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40243 */     GIR_RootConstrainSelectedInstOperands,
     /*  40244 */     // GIR_Coverage, 1646,
     /*  40244 */     GIR_EraseRootFromParent_Done,
     /*  40245 */   // Label 912: @40245
     /*  40245 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(40281), // Rule ID 1647 //
     /*  40250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40272 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3761:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTMNUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUQf),
     /*  40275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40279 */     GIR_RootConstrainSelectedInstOperands,
     /*  40280 */     // GIR_Coverage, 1647,
     /*  40280 */     GIR_EraseRootFromParent_Done,
     /*  40281 */   // Label 913: @40281
     /*  40281 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(40317), // Rule ID 1648 //
     /*  40286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40308 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3760:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTMNSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSDh),
     /*  40311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40315 */     GIR_RootConstrainSelectedInstOperands,
     /*  40316 */     // GIR_Coverage, 1648,
     /*  40316 */     GIR_EraseRootFromParent_Done,
     /*  40317 */   // Label 914: @40317
     /*  40317 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(40353), // Rule ID 1649 //
     /*  40322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40344 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3760:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTMNSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSQh),
     /*  40347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40351 */     GIR_RootConstrainSelectedInstOperands,
     /*  40352 */     // GIR_Coverage, 1649,
     /*  40352 */     GIR_EraseRootFromParent_Done,
     /*  40353 */   // Label 915: @40353
     /*  40353 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(40389), // Rule ID 1650 //
     /*  40358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40380 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3761:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTMNUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUDh),
     /*  40383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40387 */     GIR_RootConstrainSelectedInstOperands,
     /*  40388 */     // GIR_Coverage, 1650,
     /*  40388 */     GIR_EraseRootFromParent_Done,
     /*  40389 */   // Label 916: @40389
     /*  40389 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(40425), // Rule ID 1651 //
     /*  40394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40416 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3761:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTMNUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUQh),
     /*  40419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40423 */     GIR_RootConstrainSelectedInstOperands,
     /*  40424 */     // GIR_Coverage, 1651,
     /*  40424 */     GIR_EraseRootFromParent_Done,
     /*  40425 */   // Label 917: @40425
     /*  40425 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(40470), // Rule ID 1668 //
     /*  40430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasNEON),
     /*  40433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2hf),
     /*  40438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40452 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3756:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTf2h:{ *:[v4i16] } QPR:{ *:[v4f32] }:$Vm)
     /*  40452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2h),
     /*  40455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  40462 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40468 */     GIR_RootConstrainSelectedInstOperands,
     /*  40469 */     // GIR_Coverage, 1668,
     /*  40469 */     GIR_EraseRootFromParent_Done,
     /*  40470 */   // Label 918: @40470
     /*  40470 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(40515), // Rule ID 1669 //
     /*  40475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasNEON),
     /*  40478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvthf2fp),
     /*  40483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40497 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3759:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VCVTh2f:{ *:[v4f32] } DPR:{ *:[v4i16] }:$Vm)
     /*  40497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2f),
     /*  40500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  40507 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40513 */     GIR_RootConstrainSelectedInstOperands,
     /*  40514 */     // GIR_Coverage, 1669,
     /*  40514 */     GIR_EraseRootFromParent_Done,
     /*  40515 */   // Label 919: @40515
     /*  40515 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(40551), // Rule ID 1691 //
     /*  40520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40542 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3829:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTNNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNDf),
     /*  40545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40549 */     GIR_RootConstrainSelectedInstOperands,
     /*  40550 */     // GIR_Coverage, 1691,
     /*  40550 */     GIR_EraseRootFromParent_Done,
     /*  40551 */   // Label 920: @40551
     /*  40551 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(40587), // Rule ID 1692 //
     /*  40556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40578 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3829:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTNNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNQf),
     /*  40581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40585 */     GIR_RootConstrainSelectedInstOperands,
     /*  40586 */     // GIR_Coverage, 1692,
     /*  40586 */     GIR_EraseRootFromParent_Done,
     /*  40587 */   // Label 921: @40587
     /*  40587 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(40623), // Rule ID 1693 //
     /*  40592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40614 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3829:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTNNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNDh),
     /*  40617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40621 */     GIR_RootConstrainSelectedInstOperands,
     /*  40622 */     // GIR_Coverage, 1693,
     /*  40622 */     GIR_EraseRootFromParent_Done,
     /*  40623 */   // Label 922: @40623
     /*  40623 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(40659), // Rule ID 1694 //
     /*  40628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40650 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3829:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTNNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNQh),
     /*  40653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40657 */     GIR_RootConstrainSelectedInstOperands,
     /*  40658 */     // GIR_Coverage, 1694,
     /*  40658 */     GIR_EraseRootFromParent_Done,
     /*  40659 */   // Label 923: @40659
     /*  40659 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(40695), // Rule ID 1695 //
     /*  40664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  40672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40686 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3831:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTXNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNDf),
     /*  40689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40693 */     GIR_RootConstrainSelectedInstOperands,
     /*  40694 */     // GIR_Coverage, 1695,
     /*  40694 */     GIR_EraseRootFromParent_Done,
     /*  40695 */   // Label 924: @40695
     /*  40695 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(40731), // Rule ID 1696 //
     /*  40700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  40708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40722 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3831:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTXNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNQf),
     /*  40725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40729 */     GIR_RootConstrainSelectedInstOperands,
     /*  40730 */     // GIR_Coverage, 1696,
     /*  40730 */     GIR_EraseRootFromParent_Done,
     /*  40731 */   // Label 925: @40731
     /*  40731 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(40767), // Rule ID 1697 //
     /*  40736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  40744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40758 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3831:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTXNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNDh),
     /*  40761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40765 */     GIR_RootConstrainSelectedInstOperands,
     /*  40766 */     // GIR_Coverage, 1697,
     /*  40766 */     GIR_EraseRootFromParent_Done,
     /*  40767 */   // Label 926: @40767
     /*  40767 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(40803), // Rule ID 1698 //
     /*  40772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  40780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40794 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3831:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTXNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNQh),
     /*  40797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40801 */     GIR_RootConstrainSelectedInstOperands,
     /*  40802 */     // GIR_Coverage, 1698,
     /*  40802 */     GIR_EraseRootFromParent_Done,
     /*  40803 */   // Label 927: @40803
     /*  40803 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(40839), // Rule ID 1699 //
     /*  40808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrinta),
     /*  40816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40830 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3828:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTANDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTANDf),
     /*  40833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40837 */     GIR_RootConstrainSelectedInstOperands,
     /*  40838 */     // GIR_Coverage, 1699,
     /*  40838 */     GIR_EraseRootFromParent_Done,
     /*  40839 */   // Label 928: @40839
     /*  40839 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(40875), // Rule ID 1700 //
     /*  40844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrinta),
     /*  40852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40866 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3828:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTANQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTANQf),
     /*  40869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40873 */     GIR_RootConstrainSelectedInstOperands,
     /*  40874 */     // GIR_Coverage, 1700,
     /*  40874 */     GIR_EraseRootFromParent_Done,
     /*  40875 */   // Label 929: @40875
     /*  40875 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(40911), // Rule ID 1701 //
     /*  40880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrinta),
     /*  40888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40902 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3828:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTANDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTANDh),
     /*  40905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40909 */     GIR_RootConstrainSelectedInstOperands,
     /*  40910 */     // GIR_Coverage, 1701,
     /*  40910 */     GIR_EraseRootFromParent_Done,
     /*  40911 */   // Label 930: @40911
     /*  40911 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(40947), // Rule ID 1702 //
     /*  40916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrinta),
     /*  40924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40938 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3828:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTANQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTANQh),
     /*  40941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40945 */     GIR_RootConstrainSelectedInstOperands,
     /*  40946 */     // GIR_Coverage, 1702,
     /*  40946 */     GIR_EraseRootFromParent_Done,
     /*  40947 */   // Label 931: @40947
     /*  40947 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(40983), // Rule ID 1703 //
     /*  40952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintz),
     /*  40960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40974 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3832:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTZNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZNDf),
     /*  40977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40981 */     GIR_RootConstrainSelectedInstOperands,
     /*  40982 */     // GIR_Coverage, 1703,
     /*  40982 */     GIR_EraseRootFromParent_Done,
     /*  40983 */   // Label 932: @40983
     /*  40983 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(41019), // Rule ID 1704 //
     /*  40988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintz),
     /*  40996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41010 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3832:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTZNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  41010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZNQf),
     /*  41013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41017 */     GIR_RootConstrainSelectedInstOperands,
     /*  41018 */     // GIR_Coverage, 1704,
     /*  41018 */     GIR_EraseRootFromParent_Done,
     /*  41019 */   // Label 933: @41019
     /*  41019 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(41055), // Rule ID 1705 //
     /*  41024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  41027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintz),
     /*  41032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  41035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  41038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41046 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3832:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTZNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  41046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZNDh),
     /*  41049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41053 */     GIR_RootConstrainSelectedInstOperands,
     /*  41054 */     // GIR_Coverage, 1705,
     /*  41054 */     GIR_EraseRootFromParent_Done,
     /*  41055 */   // Label 934: @41055
     /*  41055 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(41091), // Rule ID 1706 //
     /*  41060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  41063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintz),
     /*  41068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  41071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  41074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41082 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3832:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTZNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  41082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZNQh),
     /*  41085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41089 */     GIR_RootConstrainSelectedInstOperands,
     /*  41090 */     // GIR_Coverage, 1706,
     /*  41090 */     GIR_EraseRootFromParent_Done,
     /*  41091 */   // Label 935: @41091
     /*  41091 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(41127), // Rule ID 1711 //
     /*  41096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  41099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintp),
     /*  41104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  41107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41118 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3830:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTPNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  41118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTPNDf),
     /*  41121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41125 */     GIR_RootConstrainSelectedInstOperands,
     /*  41126 */     // GIR_Coverage, 1711,
     /*  41126 */     GIR_EraseRootFromParent_Done,
     /*  41127 */   // Label 936: @41127
     /*  41127 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(41163), // Rule ID 1712 //
     /*  41132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  41135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintp),
     /*  41140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  41143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41154 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3830:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTPNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  41154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTPNQf),
     /*  41157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41161 */     GIR_RootConstrainSelectedInstOperands,
     /*  41162 */     // GIR_Coverage, 1712,
     /*  41162 */     GIR_EraseRootFromParent_Done,
     /*  41163 */   // Label 937: @41163
     /*  41163 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(41199), // Rule ID 1713 //
     /*  41168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  41171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintp),
     /*  41176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  41179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  41182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41190 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3830:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTPNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  41190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTPNDh),
     /*  41193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41197 */     GIR_RootConstrainSelectedInstOperands,
     /*  41198 */     // GIR_Coverage, 1713,
     /*  41198 */     GIR_EraseRootFromParent_Done,
     /*  41199 */   // Label 938: @41199
     /*  41199 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(41235), // Rule ID 1714 //
     /*  41204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  41207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintp),
     /*  41212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  41215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  41218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41226 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3830:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTPNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  41226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTPNQh),
     /*  41229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41233 */     GIR_RootConstrainSelectedInstOperands,
     /*  41234 */     // GIR_Coverage, 1714,
     /*  41234 */     GIR_EraseRootFromParent_Done,
     /*  41235 */   // Label 939: @41235
     /*  41235 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(41271), // Rule ID 1717 //
     /*  41240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  41243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aesimc),
     /*  41248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  41251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  41254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41262 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3719:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (AESIMC:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  41262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESIMC),
     /*  41265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41269 */     GIR_RootConstrainSelectedInstOperands,
     /*  41270 */     // GIR_Coverage, 1717,
     /*  41270 */     GIR_EraseRootFromParent_Done,
     /*  41271 */   // Label 940: @41271
     /*  41271 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(41307), // Rule ID 1718 //
     /*  41276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  41279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aesmc),
     /*  41284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  41287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  41290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41298 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3720:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (AESMC:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  41298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESMC),
     /*  41301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41305 */     GIR_RootConstrainSelectedInstOperands,
     /*  41306 */     // GIR_Coverage, 1718,
     /*  41306 */     GIR_EraseRootFromParent_Done,
     /*  41307 */   // Label 941: @41307
     /*  41307 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(41355), // Rule ID 1851 //
     /*  41312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  41315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtb16),
     /*  41320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  41334 */     // (intrinsic_wo_chain:{ *:[i32] } 3918:{ *:[iPTR] }, GPR:{ *:[i32] }:$Src)  =>  (SXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  41334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTB16),
     /*  41337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Src
     /*  41341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41347 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41353 */     GIR_RootConstrainSelectedInstOperands,
     /*  41354 */     // GIR_Coverage, 1851,
     /*  41354 */     GIR_EraseRootFromParent_Done,
     /*  41355 */   // Label 942: @41355
     /*  41355 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(41403), // Rule ID 2099 //
     /*  41360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  41363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtb16),
     /*  41368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41382 */     // (intrinsic_wo_chain:{ *:[i32] } 3918:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 0:{ *:[i32] })
     /*  41382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTB16),
     /*  41385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41395 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41401 */     GIR_RootConstrainSelectedInstOperands,
     /*  41402 */     // GIR_Coverage, 2099,
     /*  41402 */     GIR_EraseRootFromParent_Done,
     /*  41403 */   // Label 943: @41403
     /*  41403 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(41469), // Rule ID 3648 //
     /*  41408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcls),
     /*  41416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  41419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  41422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41430 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3602:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$val)  =>  (MVE_VCLSs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val)
     /*  41430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLSs8),
     /*  41445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41447 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41452 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41458 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41467 */     GIR_RootConstrainSelectedInstOperands,
     /*  41468 */     // GIR_Coverage, 3648,
     /*  41468 */     GIR_EraseRootFromParent_Done,
     /*  41469 */   // Label 944: @41469
     /*  41469 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(41535), // Rule ID 3650 //
     /*  41474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcls),
     /*  41482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  41485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  41488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41496 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3602:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$val)  =>  (MVE_VCLSs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val)
     /*  41496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLSs16),
     /*  41511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41513 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41518 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41524 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41533 */     GIR_RootConstrainSelectedInstOperands,
     /*  41534 */     // GIR_Coverage, 3650,
     /*  41534 */     GIR_EraseRootFromParent_Done,
     /*  41535 */   // Label 945: @41535
     /*  41535 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(41601), // Rule ID 3652 //
     /*  41540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcls),
     /*  41548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  41551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41562 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3602:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$val)  =>  (MVE_VCLSs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val)
     /*  41562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLSs32),
     /*  41577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41579 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41584 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41590 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41599 */     GIR_RootConstrainSelectedInstOperands,
     /*  41600 */     // GIR_Coverage, 3652,
     /*  41600 */     GIR_EraseRootFromParent_Done,
     /*  41601 */   // Label 946: @41601
     /*  41601 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(41652), // Rule ID 4864 //
     /*  41606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp8),
     /*  41614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s1,
     /*  41617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41628 */     // (intrinsic_wo_chain:{ *:[v16i1] } 3610:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP8:{ *:[v16i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP8),
     /*  41631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41638 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41644 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41650 */     GIR_RootConstrainSelectedInstOperands,
     /*  41651 */     // GIR_Coverage, 4864,
     /*  41651 */     GIR_EraseRootFromParent_Done,
     /*  41652 */   // Label 947: @41652
     /*  41652 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(41703), // Rule ID 4866 //
     /*  41657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp16),
     /*  41665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s1,
     /*  41668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41679 */     // (intrinsic_wo_chain:{ *:[v8i1] } 3607:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP16:{ *:[v8i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP16),
     /*  41682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41689 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41695 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41701 */     GIR_RootConstrainSelectedInstOperands,
     /*  41702 */     // GIR_Coverage, 4866,
     /*  41702 */     GIR_EraseRootFromParent_Done,
     /*  41703 */   // Label 948: @41703
     /*  41703 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(41754), // Rule ID 4868 //
     /*  41708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp32),
     /*  41716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s1,
     /*  41719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41730 */     // (intrinsic_wo_chain:{ *:[v4i1] } 3608:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP32:{ *:[v4i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP32),
     /*  41733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41740 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41752 */     GIR_RootConstrainSelectedInstOperands,
     /*  41753 */     // GIR_Coverage, 4868,
     /*  41753 */     GIR_EraseRootFromParent_Done,
     /*  41754 */   // Label 949: @41754
     /*  41754 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(41805), // Rule ID 4870 //
     /*  41759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp64),
     /*  41767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s1,
     /*  41770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41781 */     // (intrinsic_wo_chain:{ *:[v2i1] } 3609:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP64:{ *:[v2i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP64),
     /*  41784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41797 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41803 */     GIR_RootConstrainSelectedInstOperands,
     /*  41804 */     // GIR_Coverage, 4870,
     /*  41804 */     GIR_EraseRootFromParent_Done,
     /*  41805 */   // Label 950: @41805
     /*  41805 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(41851), // Rule ID 600 //
     /*  41810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_tt),
     /*  41818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41825 */     // MIs[0] Rn
     /*  41825 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41833 */     // (intrinsic_wo_chain:{ *:[i32] } 3492:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TT),
     /*  41836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41843 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41849 */     GIR_RootConstrainSelectedInstOperands,
     /*  41850 */     // GIR_Coverage, 600,
     /*  41850 */     GIR_EraseRootFromParent_Done,
     /*  41851 */   // Label 951: @41851
     /*  41851 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(41897), // Rule ID 601 //
     /*  41856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_ttt),
     /*  41864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41871 */     // MIs[0] Rn
     /*  41871 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41879 */     // (intrinsic_wo_chain:{ *:[i32] } 3495:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TTT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TTT),
     /*  41882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41889 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41895 */     GIR_RootConstrainSelectedInstOperands,
     /*  41896 */     // GIR_Coverage, 601,
     /*  41896 */     GIR_EraseRootFromParent_Done,
     /*  41897 */   // Label 952: @41897
     /*  41897 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(41943), // Rule ID 602 //
     /*  41902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_tta),
     /*  41910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41917 */     // MIs[0] Rn
     /*  41917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41925 */     // (intrinsic_wo_chain:{ *:[i32] } 3493:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TTA:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TTA),
     /*  41928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41935 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41941 */     GIR_RootConstrainSelectedInstOperands,
     /*  41942 */     // GIR_Coverage, 602,
     /*  41942 */     GIR_EraseRootFromParent_Done,
     /*  41943 */   // Label 953: @41943
     /*  41943 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(41989), // Rule ID 603 //
     /*  41948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_ttat),
     /*  41956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41963 */     // MIs[0] Rn
     /*  41963 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41971 */     // (intrinsic_wo_chain:{ *:[i32] } 3494:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TTAT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TTAT),
     /*  41974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41981 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41987 */     GIR_RootConstrainSelectedInstOperands,
     /*  41988 */     // GIR_Coverage, 603,
     /*  41988 */     GIR_EraseRootFromParent_Done,
     /*  41989 */   // Label 954: @41989
     /*  41989 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(42124), // Rule ID 2693 //
     /*  41994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1h),
     /*  42002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  42012 */     // (intrinsic_wo_chain:{ *:[i32] } 3727:{ *:[iPTR] }, i32:{ *:[i32] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[f32] } (SHA1H:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$Rn, SPR:{ *:[i32] }), ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] }), GPR:{ *:[i32] })
     /*  42012 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  42015 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42019 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42024 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  42028 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  42033 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /*  42036 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  42040 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42045 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  42048 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  42051 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /*  42054 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  42059 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  42064 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /*  42067 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::SHA1H),
     /*  42071 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42076 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  42081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  42084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42093 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /*  42100 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  42105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42118 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /*  42123 */     // GIR_Coverage, 2693,
     /*  42123 */     GIR_EraseRootFromParent_Done,
     /*  42124 */   // Label 955: @42124
     /*  42124 */   GIM_Reject,
     /*  42125 */ // Label 825: @42125
     /*  42125 */ GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(62679),
     /*  42130 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  42133 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(42190), // Rule ID 2117 //
     /*  42138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtab16),
     /*  42146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42167 */     // (intrinsic_wo_chain:{ *:[i32] } 3942:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UXTAB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  42167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAB16),
     /*  42170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  42176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42182 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42188 */     GIR_RootConstrainSelectedInstOperands,
     /*  42189 */     // GIR_Coverage, 2117,
     /*  42189 */     GIR_EraseRootFromParent_Done,
     /*  42190 */   // Label 957: @42190
     /*  42190 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(42289), // Rule ID 1888 //
     /*  42195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  42198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  42203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  42224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42228 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42232 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42237 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42241 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42245 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42249 */     // MIs[2] Operand 1
     /*  42249 */     // No operand predicates
     /*  42249 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /*  42253 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42257 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42261 */     // MIs[3] Operand 1
     /*  42261 */     // No operand predicates
     /*  42261 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42263 */     // (intrinsic_wo_chain:{ *:[i32] } 3937:{ *:[iPTR] }, (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft), (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft)
     /*  42263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAT),
     /*  42266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42268 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // pos
     /*  42271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /*  42275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shft
     /*  42278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42281 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42287 */     GIR_RootConstrainSelectedInstOperands,
     /*  42288 */     // GIR_Coverage, 1888,
     /*  42288 */     GIR_EraseRootFromParent_Done,
     /*  42289 */   // Label 958: @42289
     /*  42289 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(42388), // Rule ID 2154 //
     /*  42294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  42297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  42302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  42323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42344 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42348 */     // MIs[2] Operand 1
     /*  42348 */     // No operand predicates
     /*  42348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /*  42352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42356 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42360 */     // MIs[3] Operand 1
     /*  42360 */     // No operand predicates
     /*  42360 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42362 */     // (intrinsic_wo_chain:{ *:[i32] } 3937:{ *:[iPTR] }, (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft), (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (t2USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft)
     /*  42362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAT),
     /*  42365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // pos
     /*  42370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /*  42374 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shft
     /*  42377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42380 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42386 */     GIR_RootConstrainSelectedInstOperands,
     /*  42387 */     // GIR_Coverage, 2154,
     /*  42387 */     GIR_EraseRootFromParent_Done,
     /*  42388 */   // Label 959: @42388
     /*  42388 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(42472), // Rule ID 5430 //
     /*  42393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  42396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42422 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42425 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42439 */     // MIs[1] Rn
     /*  42439 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42450 */     // (intrinsic_wo_chain:{ *:[i32] } 3860:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[i32] } 3860:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rn), GPRnopc:{ *:[i32] }:$Rm)  =>  (QDADD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  42450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /*  42453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  42457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42470 */     GIR_RootConstrainSelectedInstOperands,
     /*  42471 */     // GIR_Coverage, 5430,
     /*  42471 */     GIR_EraseRootFromParent_Done,
     /*  42472 */   // Label 960: @42472
     /*  42472 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(42556), // Rule ID 5687 //
     /*  42477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42506 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42509 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42514 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42523 */     // MIs[1] Rn
     /*  42523 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42534 */     // (intrinsic_wo_chain:{ *:[i32] } 3860:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[i32] } 3860:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Rm)  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  42534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /*  42537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  42541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42548 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42554 */     GIR_RootConstrainSelectedInstOperands,
     /*  42555 */     // GIR_Coverage, 5687,
     /*  42555 */     GIR_EraseRootFromParent_Done,
     /*  42556 */   // Label 961: @42556
     /*  42556 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(42640), // Rule ID 109 //
     /*  42561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  42564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42594 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42597 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42611 */     // MIs[1] Rn
     /*  42611 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42618 */     // (intrinsic_wo_chain:{ *:[i32] } 3860:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3860:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rn))  =>  (QDADD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  42618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /*  42621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42632 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42638 */     GIR_RootConstrainSelectedInstOperands,
     /*  42639 */     // GIR_Coverage, 109,
     /*  42639 */     GIR_EraseRootFromParent_Done,
     /*  42640 */   // Label 962: @42640
     /*  42640 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(42724), // Rule ID 110 //
     /*  42645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  42648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  42653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42678 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42681 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42695 */     // MIs[1] Rn
     /*  42695 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42702 */     // (intrinsic_wo_chain:{ *:[i32] } 3865:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3860:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rn))  =>  (QDSUB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  42702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDSUB),
     /*  42705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42716 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42722 */     GIR_RootConstrainSelectedInstOperands,
     /*  42723 */     // GIR_Coverage, 110,
     /*  42723 */     GIR_EraseRootFromParent_Done,
     /*  42724 */   // Label 963: @42724
     /*  42724 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(42808), // Rule ID 2132 //
     /*  42729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42762 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42765 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42779 */     // MIs[1] Rn
     /*  42779 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42786 */     // (intrinsic_wo_chain:{ *:[i32] } 3860:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3860:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  42786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /*  42789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42800 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42806 */     GIR_RootConstrainSelectedInstOperands,
     /*  42807 */     // GIR_Coverage, 2132,
     /*  42807 */     GIR_EraseRootFromParent_Done,
     /*  42808 */   // Label 964: @42808
     /*  42808 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(42892), // Rule ID 2133 //
     /*  42813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  42821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42846 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42849 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42863 */     // MIs[1] Rn
     /*  42863 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42870 */     // (intrinsic_wo_chain:{ *:[i32] } 3865:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3860:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  42870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDSUB),
     /*  42873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42884 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42890 */     GIR_RootConstrainSelectedInstOperands,
     /*  42891 */     // GIR_Coverage, 2133,
     /*  42891 */     GIR_EraseRootFromParent_Done,
     /*  42892 */   // Label 965: @42892
     /*  42892 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(42965), // Rule ID 4058 //
     /*  42897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  42905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  42908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  42914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42918 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  42922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42926 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3618:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16a:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  42926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16a),
     /*  42941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  42943 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  42945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42948 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42954 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42963 */     GIR_RootConstrainSelectedInstOperands,
     /*  42964 */     // GIR_Coverage, 4058,
     /*  42964 */     GIR_EraseRootFromParent_Done,
     /*  42965 */   // Label 966: @42965
     /*  42965 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(43038), // Rule ID 4060 //
     /*  42970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  42978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  42981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  42987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42991 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  42995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42999 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3622:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16n:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  42999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16n),
     /*  43014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43016 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43021 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43027 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43033 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43036 */     GIR_RootConstrainSelectedInstOperands,
     /*  43037 */     // GIR_Coverage, 4060,
     /*  43037 */     GIR_EraseRootFromParent_Done,
     /*  43038 */   // Label 967: @43038
     /*  43038 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(43111), // Rule ID 4062 //
     /*  43043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43064 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43072 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3624:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16p:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16p),
     /*  43087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43089 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43094 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43100 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43109 */     GIR_RootConstrainSelectedInstOperands,
     /*  43110 */     // GIR_Coverage, 4062,
     /*  43110 */     GIR_EraseRootFromParent_Done,
     /*  43111 */   // Label 968: @43111
     /*  43111 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(43184), // Rule ID 4064 //
     /*  43116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  43124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43137 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43145 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3620:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16m:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16m),
     /*  43160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43162 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43167 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43173 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43182 */     GIR_RootConstrainSelectedInstOperands,
     /*  43183 */     // GIR_Coverage, 4064,
     /*  43183 */     GIR_EraseRootFromParent_Done,
     /*  43184 */   // Label 969: @43184
     /*  43184 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(43257), // Rule ID 4066 //
     /*  43189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  43197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43210 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43218 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3618:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16a:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16a),
     /*  43233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43235 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43240 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43246 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43255 */     GIR_RootConstrainSelectedInstOperands,
     /*  43256 */     // GIR_Coverage, 4066,
     /*  43256 */     GIR_EraseRootFromParent_Done,
     /*  43257 */   // Label 970: @43257
     /*  43257 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(43330), // Rule ID 4068 //
     /*  43262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  43270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43283 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43291 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3622:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16n:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16n),
     /*  43306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43308 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43313 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43328 */     GIR_RootConstrainSelectedInstOperands,
     /*  43329 */     // GIR_Coverage, 4068,
     /*  43329 */     GIR_EraseRootFromParent_Done,
     /*  43330 */   // Label 971: @43330
     /*  43330 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(43403), // Rule ID 4070 //
     /*  43335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43356 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43364 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3624:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16p:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16p),
     /*  43379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43381 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43386 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43392 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43401 */     GIR_RootConstrainSelectedInstOperands,
     /*  43402 */     // GIR_Coverage, 4070,
     /*  43402 */     GIR_EraseRootFromParent_Done,
     /*  43403 */   // Label 972: @43403
     /*  43403 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(43476), // Rule ID 4072 //
     /*  43408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  43416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43429 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43437 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3620:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16m:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16m),
     /*  43452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43454 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43459 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43465 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43474 */     GIR_RootConstrainSelectedInstOperands,
     /*  43475 */     // GIR_Coverage, 4072,
     /*  43475 */     GIR_EraseRootFromParent_Done,
     /*  43476 */   // Label 973: @43476
     /*  43476 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(43549), // Rule ID 4074 //
     /*  43481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  43489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43502 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43510 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3618:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32a:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32a),
     /*  43525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43527 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43532 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43538 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43547 */     GIR_RootConstrainSelectedInstOperands,
     /*  43548 */     // GIR_Coverage, 4074,
     /*  43548 */     GIR_EraseRootFromParent_Done,
     /*  43549 */   // Label 974: @43549
     /*  43549 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(43622), // Rule ID 4076 //
     /*  43554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  43562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43575 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43583 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3622:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32n:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32n),
     /*  43598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43600 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43605 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43611 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43620 */     GIR_RootConstrainSelectedInstOperands,
     /*  43621 */     // GIR_Coverage, 4076,
     /*  43621 */     GIR_EraseRootFromParent_Done,
     /*  43622 */   // Label 975: @43622
     /*  43622 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(43695), // Rule ID 4078 //
     /*  43627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43648 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43656 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3624:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32p:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43659 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43663 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32p),
     /*  43671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43673 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43678 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43684 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43693 */     GIR_RootConstrainSelectedInstOperands,
     /*  43694 */     // GIR_Coverage, 4078,
     /*  43694 */     GIR_EraseRootFromParent_Done,
     /*  43695 */   // Label 976: @43695
     /*  43695 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(43768), // Rule ID 4080 //
     /*  43700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  43708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43721 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43729 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3620:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32m:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32m),
     /*  43744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43746 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43751 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43757 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43766 */     GIR_RootConstrainSelectedInstOperands,
     /*  43767 */     // GIR_Coverage, 4080,
     /*  43767 */     GIR_EraseRootFromParent_Done,
     /*  43768 */   // Label 977: @43768
     /*  43768 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(43841), // Rule ID 4082 //
     /*  43773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  43781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43794 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43802 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3618:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32a:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32a),
     /*  43817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43819 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43824 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43830 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43839 */     GIR_RootConstrainSelectedInstOperands,
     /*  43840 */     // GIR_Coverage, 4082,
     /*  43840 */     GIR_EraseRootFromParent_Done,
     /*  43841 */   // Label 978: @43841
     /*  43841 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(43914), // Rule ID 4084 //
     /*  43846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  43854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43867 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43875 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3622:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32n:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32n),
     /*  43890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43892 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43897 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43903 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43912 */     GIR_RootConstrainSelectedInstOperands,
     /*  43913 */     // GIR_Coverage, 4084,
     /*  43913 */     GIR_EraseRootFromParent_Done,
     /*  43914 */   // Label 979: @43914
     /*  43914 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(43987), // Rule ID 4086 //
     /*  43919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43940 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43948 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3624:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32p:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32p),
     /*  43963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43965 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43970 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43976 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43985 */     GIR_RootConstrainSelectedInstOperands,
     /*  43986 */     // GIR_Coverage, 4086,
     /*  43986 */     GIR_EraseRootFromParent_Done,
     /*  43987 */   // Label 980: @43987
     /*  43987 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(44060), // Rule ID 4088 //
     /*  43992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  44000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  44009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44013 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  44017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44021 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3620:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32m:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  44021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32m),
     /*  44036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44038 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  44040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44043 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44049 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44058 */     GIR_RootConstrainSelectedInstOperands,
     /*  44059 */     // GIR_Coverage, 4088,
     /*  44059 */     GIR_EraseRootFromParent_Done,
     /*  44060 */   // Label 981: @44060
     /*  44060 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(44133), // Rule ID 4532 //
     /*  44065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  44068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_widen),
     /*  44073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  44079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44090 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  44094 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3616:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qm, 0:{ *:[i32] })  =>  (MVE_VCVTf32f16bh:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$Qm)
     /*  44094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32f16bh),
     /*  44109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  44113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44116 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44122 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44131 */     GIR_RootConstrainSelectedInstOperands,
     /*  44132 */     // GIR_Coverage, 4532,
     /*  44132 */     GIR_EraseRootFromParent_Done,
     /*  44133 */   // Label 982: @44133
     /*  44133 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(44206), // Rule ID 4538 //
     /*  44138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  44141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_widen),
     /*  44146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  44152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44163 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  44167 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3616:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qm, 1:{ *:[i32] })  =>  (MVE_VCVTf32f16th:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$Qm)
     /*  44167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32f16th),
     /*  44182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  44186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44189 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44195 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44204 */     GIR_RootConstrainSelectedInstOperands,
     /*  44205 */     // GIR_Coverage, 4538,
     /*  44205 */     GIR_EraseRootFromParent_Done,
     /*  44206 */   // Label 983: @44206
     /*  44206 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(44274), // Rule ID 1881 //
     /*  44211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  44214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  44219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44244 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  44248 */     // MIs[1] Operand 1
     /*  44248 */     // No operand predicates
     /*  44248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44250 */     // (intrinsic_wo_chain:{ *:[i32] } 3937:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPRnopc:{ *:[i32] }:$a, 0:{ *:[i32] })
     /*  44250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAT),
     /*  44253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44258 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44266 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44272 */     GIR_RootConstrainSelectedInstOperands,
     /*  44273 */     // GIR_Coverage, 1881,
     /*  44273 */     GIR_EraseRootFromParent_Done,
     /*  44274 */   // Label 984: @44274
     /*  44274 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(44339), // Rule ID 1885 //
     /*  44279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  44282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat16),
     /*  44287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44312 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  44316 */     // MIs[1] Operand 1
     /*  44316 */     // No operand predicates
     /*  44316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44318 */     // (intrinsic_wo_chain:{ *:[i32] } 3938:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos)  =>  (USAT16:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos, GPRnopc:{ *:[i32] }:$a)
     /*  44318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAT16),
     /*  44321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44326 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44331 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44337 */     GIR_RootConstrainSelectedInstOperands,
     /*  44338 */     // GIR_Coverage, 1885,
     /*  44338 */     GIR_EraseRootFromParent_Done,
     /*  44339 */   // Label 985: @44339
     /*  44339 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(44407), // Rule ID 2149 //
     /*  44344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  44347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  44352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  44365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  44369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44377 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  44381 */     // MIs[1] Operand 1
     /*  44381 */     // No operand predicates
     /*  44381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44383 */     // (intrinsic_wo_chain:{ *:[i32] } 3937:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (t2USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPR:{ *:[i32] }:$a, 0:{ *:[i32] })
     /*  44383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAT),
     /*  44386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44388 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44391 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44399 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44405 */     GIR_RootConstrainSelectedInstOperands,
     /*  44406 */     // GIR_Coverage, 2149,
     /*  44406 */     GIR_EraseRootFromParent_Done,
     /*  44407 */   // Label 986: @44407
     /*  44407 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(44472), // Rule ID 2151 //
     /*  44412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  44415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat16),
     /*  44420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  44433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  44437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44445 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  44449 */     // MIs[1] Operand 1
     /*  44449 */     // No operand predicates
     /*  44449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44451 */     // (intrinsic_wo_chain:{ *:[i32] } 3938:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos)  =>  (t2USAT16:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos, GPR:{ *:[i32] }:$a)
     /*  44451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAT16),
     /*  44454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44459 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44470 */     GIR_RootConstrainSelectedInstOperands,
     /*  44471 */     // GIR_Coverage, 2151,
     /*  44471 */     GIR_EraseRootFromParent_Done,
     /*  44472 */   // Label 987: @44472
     /*  44472 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(44555), // Rule ID 3928 //
     /*  44477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshlu_imm),
     /*  44482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  44485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  44488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44507 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  44511 */     // MIs[1] Operand 1
     /*  44511 */     // No operand predicates
     /*  44511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44513 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)  =>  (MVE_VQSHLU_imms8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  44513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLU_imms8),
     /*  44528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44530 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  44532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  44535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44538 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44553 */     GIR_RootConstrainSelectedInstOperands,
     /*  44554 */     // GIR_Coverage, 3928,
     /*  44554 */     GIR_EraseRootFromParent_Done,
     /*  44555 */   // Label 988: @44555
     /*  44555 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(44638), // Rule ID 3930 //
     /*  44560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshlu_imm),
     /*  44565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  44568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  44571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44590 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  44594 */     // MIs[1] Operand 1
     /*  44594 */     // No operand predicates
     /*  44594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44596 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)  =>  (MVE_VQSHLU_imms16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  44596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLU_imms16),
     /*  44611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44613 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  44615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  44618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44621 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44627 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44636 */     GIR_RootConstrainSelectedInstOperands,
     /*  44637 */     // GIR_Coverage, 3930,
     /*  44637 */     GIR_EraseRootFromParent_Done,
     /*  44638 */   // Label 989: @44638
     /*  44638 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(44721), // Rule ID 3932 //
     /*  44643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshlu_imm),
     /*  44648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44673 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  44677 */     // MIs[1] Operand 1
     /*  44677 */     // No operand predicates
     /*  44677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44679 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3677:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)  =>  (MVE_VQSHLU_imms32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  44679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLU_imms32),
     /*  44694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44696 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  44698 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  44701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44704 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44710 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44719 */     GIR_RootConstrainSelectedInstOperands,
     /*  44720 */     // GIR_Coverage, 3932,
     /*  44720 */     GIR_EraseRootFromParent_Done,
     /*  44721 */   // Label 990: @44721
     /*  44721 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(44782), // Rule ID 1652 //
     /*  44726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  44734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44759 */     // MIs[1] Operand 1
     /*  44759 */     // No operand predicates
     /*  44759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44761 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3754:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xsd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xsd),
     /*  44764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44768 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44774 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44780 */     GIR_RootConstrainSelectedInstOperands,
     /*  44781 */     // GIR_Coverage, 1652,
     /*  44781 */     GIR_EraseRootFromParent_Done,
     /*  44782 */   // Label 991: @44782
     /*  44782 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(44843), // Rule ID 1653 //
     /*  44787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  44795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44820 */     // MIs[1] Operand 1
     /*  44820 */     // No operand predicates
     /*  44820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44822 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3755:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xud:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xud),
     /*  44825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44835 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44841 */     GIR_RootConstrainSelectedInstOperands,
     /*  44842 */     // GIR_Coverage, 1653,
     /*  44842 */     GIR_EraseRootFromParent_Done,
     /*  44843 */   // Label 992: @44843
     /*  44843 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(44904), // Rule ID 1654 //
     /*  44848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  44856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44881 */     // MIs[1] Operand 1
     /*  44881 */     // No operand predicates
     /*  44881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44883 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3757:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2fd),
     /*  44886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44890 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44896 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44902 */     GIR_RootConstrainSelectedInstOperands,
     /*  44903 */     // GIR_Coverage, 1654,
     /*  44903 */     GIR_EraseRootFromParent_Done,
     /*  44904 */   // Label 993: @44904
     /*  44904 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(44965), // Rule ID 1655 //
     /*  44909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  44917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44942 */     // MIs[1] Operand 1
     /*  44942 */     // No operand predicates
     /*  44942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44944 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3758:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2fd),
     /*  44947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44957 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44963 */     GIR_RootConstrainSelectedInstOperands,
     /*  44964 */     // GIR_Coverage, 1655,
     /*  44964 */     GIR_EraseRootFromParent_Done,
     /*  44965 */   // Label 994: @44965
     /*  44965 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(45026), // Rule ID 1656 //
     /*  44970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  44973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  44978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  44981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45003 */     // MIs[1] Operand 1
     /*  45003 */     // No operand predicates
     /*  45003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45005 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3754:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xsd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xsd),
     /*  45008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45012 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45018 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45024 */     GIR_RootConstrainSelectedInstOperands,
     /*  45025 */     // GIR_Coverage, 1656,
     /*  45025 */     GIR_EraseRootFromParent_Done,
     /*  45026 */   // Label 995: @45026
     /*  45026 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(45087), // Rule ID 1657 //
     /*  45031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  45039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  45042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45064 */     // MIs[1] Operand 1
     /*  45064 */     // No operand predicates
     /*  45064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45066 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3755:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xud:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xud),
     /*  45069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45079 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45085 */     GIR_RootConstrainSelectedInstOperands,
     /*  45086 */     // GIR_Coverage, 1657,
     /*  45086 */     GIR_EraseRootFromParent_Done,
     /*  45087 */   // Label 996: @45087
     /*  45087 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(45148), // Rule ID 1658 //
     /*  45092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  45100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  45103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45125 */     // MIs[1] Operand 1
     /*  45125 */     // No operand predicates
     /*  45125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45127 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3757:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2hd),
     /*  45130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45134 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45140 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45146 */     GIR_RootConstrainSelectedInstOperands,
     /*  45147 */     // GIR_Coverage, 1658,
     /*  45147 */     GIR_EraseRootFromParent_Done,
     /*  45148 */   // Label 997: @45148
     /*  45148 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(45209), // Rule ID 1659 //
     /*  45153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  45161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  45164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45186 */     // MIs[1] Operand 1
     /*  45186 */     // No operand predicates
     /*  45186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45188 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3758:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2hd),
     /*  45191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45201 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45207 */     GIR_RootConstrainSelectedInstOperands,
     /*  45208 */     // GIR_Coverage, 1659,
     /*  45208 */     GIR_EraseRootFromParent_Done,
     /*  45209 */   // Label 998: @45209
     /*  45209 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(45270), // Rule ID 1660 //
     /*  45214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  45222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45247 */     // MIs[1] Operand 1
     /*  45247 */     // No operand predicates
     /*  45247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45249 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3754:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xsq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xsq),
     /*  45252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45262 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45268 */     GIR_RootConstrainSelectedInstOperands,
     /*  45269 */     // GIR_Coverage, 1660,
     /*  45269 */     GIR_EraseRootFromParent_Done,
     /*  45270 */   // Label 999: @45270
     /*  45270 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(45331), // Rule ID 1661 //
     /*  45275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  45283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45308 */     // MIs[1] Operand 1
     /*  45308 */     // No operand predicates
     /*  45308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45310 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3755:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xuq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xuq),
     /*  45313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45323 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45329 */     GIR_RootConstrainSelectedInstOperands,
     /*  45330 */     // GIR_Coverage, 1661,
     /*  45330 */     GIR_EraseRootFromParent_Done,
     /*  45331 */   // Label 1000: @45331
     /*  45331 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(45392), // Rule ID 1662 //
     /*  45336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  45344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45369 */     // MIs[1] Operand 1
     /*  45369 */     // No operand predicates
     /*  45369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45371 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3757:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2fq),
     /*  45374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45378 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45384 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45390 */     GIR_RootConstrainSelectedInstOperands,
     /*  45391 */     // GIR_Coverage, 1662,
     /*  45391 */     GIR_EraseRootFromParent_Done,
     /*  45392 */   // Label 1001: @45392
     /*  45392 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(45453), // Rule ID 1663 //
     /*  45397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  45405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45430 */     // MIs[1] Operand 1
     /*  45430 */     // No operand predicates
     /*  45430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45432 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3758:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2fq),
     /*  45435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45445 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45451 */     GIR_RootConstrainSelectedInstOperands,
     /*  45452 */     // GIR_Coverage, 1663,
     /*  45452 */     GIR_EraseRootFromParent_Done,
     /*  45453 */   // Label 1002: @45453
     /*  45453 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(45514), // Rule ID 1664 //
     /*  45458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  45466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45491 */     // MIs[1] Operand 1
     /*  45491 */     // No operand predicates
     /*  45491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45493 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3754:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xsq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xsq),
     /*  45496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45500 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45506 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45512 */     GIR_RootConstrainSelectedInstOperands,
     /*  45513 */     // GIR_Coverage, 1664,
     /*  45513 */     GIR_EraseRootFromParent_Done,
     /*  45514 */   // Label 1003: @45514
     /*  45514 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(45575), // Rule ID 1665 //
     /*  45519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  45527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45552 */     // MIs[1] Operand 1
     /*  45552 */     // No operand predicates
     /*  45552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45554 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3755:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xuq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xuq),
     /*  45557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45567 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45573 */     GIR_RootConstrainSelectedInstOperands,
     /*  45574 */     // GIR_Coverage, 1665,
     /*  45574 */     GIR_EraseRootFromParent_Done,
     /*  45575 */   // Label 1004: @45575
     /*  45575 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(45636), // Rule ID 1666 //
     /*  45580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  45588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45613 */     // MIs[1] Operand 1
     /*  45613 */     // No operand predicates
     /*  45613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45615 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3757:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2hq),
     /*  45618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45622 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45628 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45634 */     GIR_RootConstrainSelectedInstOperands,
     /*  45635 */     // GIR_Coverage, 1666,
     /*  45635 */     GIR_EraseRootFromParent_Done,
     /*  45636 */   // Label 1005: @45636
     /*  45636 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(45697), // Rule ID 1667 //
     /*  45641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  45649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45674 */     // MIs[1] Operand 1
     /*  45674 */     // No operand predicates
     /*  45674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45676 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3758:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2hq),
     /*  45679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45689 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45695 */     GIR_RootConstrainSelectedInstOperands,
     /*  45696 */     // GIR_Coverage, 1667,
     /*  45696 */     GIR_EraseRootFromParent_Done,
     /*  45697 */   // Label 1006: @45697
     /*  45697 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(45758), // Rule ID 1725 //
     /*  45702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_sqshl),
     /*  45710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45735 */     // MIs[1] Operand 1
     /*  45735 */     // No operand predicates
     /*  45735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45737 */     // (intrinsic_wo_chain:{ *:[i32] } 3582:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_SQSHL:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_SQSHL),
     /*  45740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45742 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45744 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45750 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45756 */     GIR_RootConstrainSelectedInstOperands,
     /*  45757 */     // GIR_Coverage, 1725,
     /*  45757 */     GIR_EraseRootFromParent_Done,
     /*  45758 */   // Label 1007: @45758
     /*  45758 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(45819), // Rule ID 1726 //
     /*  45763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_srshr),
     /*  45771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45796 */     // MIs[1] Operand 1
     /*  45796 */     // No operand predicates
     /*  45796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45798 */     // (intrinsic_wo_chain:{ *:[i32] } 3584:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_SRSHR:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_SRSHR),
     /*  45801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45803 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45811 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45817 */     GIR_RootConstrainSelectedInstOperands,
     /*  45818 */     // GIR_Coverage, 1726,
     /*  45818 */     GIR_EraseRootFromParent_Done,
     /*  45819 */   // Label 1008: @45819
     /*  45819 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(45880), // Rule ID 1727 //
     /*  45824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_uqshl),
     /*  45832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45857 */     // MIs[1] Operand 1
     /*  45857 */     // No operand predicates
     /*  45857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45859 */     // (intrinsic_wo_chain:{ *:[i32] } 3589:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_UQSHL:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_UQSHL),
     /*  45862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45864 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45866 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45872 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45878 */     GIR_RootConstrainSelectedInstOperands,
     /*  45879 */     // GIR_Coverage, 1727,
     /*  45879 */     GIR_EraseRootFromParent_Done,
     /*  45880 */   // Label 1009: @45880
     /*  45880 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(45941), // Rule ID 1728 //
     /*  45885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_urshr),
     /*  45893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45918 */     // MIs[1] Operand 1
     /*  45918 */     // No operand predicates
     /*  45918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45920 */     // (intrinsic_wo_chain:{ *:[i32] } 3591:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_URSHR:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_URSHR),
     /*  45923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45925 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45933 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45939 */     GIR_RootConstrainSelectedInstOperands,
     /*  45940 */     // GIR_Coverage, 1728,
     /*  45940 */     GIR_EraseRootFromParent_Done,
     /*  45941 */   // Label 1010: @45941
     /*  45941 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(45995), // Rule ID 105 //
     /*  45946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd8),
     /*  45954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45975 */     // (intrinsic_wo_chain:{ *:[i32] } 3862:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  45975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD8),
     /*  45978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  45982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  45984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45987 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45993 */     GIR_RootConstrainSelectedInstOperands,
     /*  45994 */     // GIR_Coverage, 105,
     /*  45994 */     GIR_EraseRootFromParent_Done,
     /*  45995 */   // Label 1011: @45995
     /*  45995 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(46049), // Rule ID 106 //
     /*  46000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd16),
     /*  46008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46029 */     // (intrinsic_wo_chain:{ *:[i32] } 3861:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD16),
     /*  46032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46041 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46047 */     GIR_RootConstrainSelectedInstOperands,
     /*  46048 */     // GIR_Coverage, 106,
     /*  46048 */     GIR_EraseRootFromParent_Done,
     /*  46049 */   // Label 1012: @46049
     /*  46049 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(46103), // Rule ID 107 //
     /*  46054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub16),
     /*  46062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46083 */     // (intrinsic_wo_chain:{ *:[i32] } 3866:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB16),
     /*  46086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46095 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46101 */     GIR_RootConstrainSelectedInstOperands,
     /*  46102 */     // GIR_Coverage, 107,
     /*  46102 */     GIR_EraseRootFromParent_Done,
     /*  46103 */   // Label 1013: @46103
     /*  46103 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(46157), // Rule ID 108 //
     /*  46108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub8),
     /*  46116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46137 */     // (intrinsic_wo_chain:{ *:[i32] } 3867:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB8),
     /*  46140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46149 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46155 */     GIR_RootConstrainSelectedInstOperands,
     /*  46156 */     // GIR_Coverage, 108,
     /*  46156 */     GIR_EraseRootFromParent_Done,
     /*  46157 */   // Label 1014: @46157
     /*  46157 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(46211), // Rule ID 111 //
     /*  46162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  46170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46191 */     // (intrinsic_wo_chain:{ *:[i32] } 3865:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)  =>  (QSUB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  46191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB),
     /*  46194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  46198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  46200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46203 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46209 */     GIR_RootConstrainSelectedInstOperands,
     /*  46210 */     // GIR_Coverage, 111,
     /*  46210 */     GIR_EraseRootFromParent_Done,
     /*  46211 */   // Label 1015: @46211
     /*  46211 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(46265), // Rule ID 112 //
     /*  46216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  46224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46245 */     // (intrinsic_wo_chain:{ *:[i32] } 3860:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)  =>  (QADD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  46245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD),
     /*  46248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  46252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  46254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46257 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46263 */     GIR_RootConstrainSelectedInstOperands,
     /*  46264 */     // GIR_Coverage, 112,
     /*  46264 */     GIR_EraseRootFromParent_Done,
     /*  46265 */   // Label 1016: @46265
     /*  46265 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(46319), // Rule ID 113 //
     /*  46270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd16),
     /*  46278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46299 */     // (intrinsic_wo_chain:{ *:[i32] } 3929:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQADD16),
     /*  46302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46311 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46317 */     GIR_RootConstrainSelectedInstOperands,
     /*  46318 */     // GIR_Coverage, 113,
     /*  46318 */     GIR_EraseRootFromParent_Done,
     /*  46319 */   // Label 1017: @46319
     /*  46319 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(46373), // Rule ID 114 //
     /*  46324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd8),
     /*  46332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46353 */     // (intrinsic_wo_chain:{ *:[i32] } 3930:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQADD8),
     /*  46356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46365 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46371 */     GIR_RootConstrainSelectedInstOperands,
     /*  46372 */     // GIR_Coverage, 114,
     /*  46372 */     GIR_EraseRootFromParent_Done,
     /*  46373 */   // Label 1018: @46373
     /*  46373 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(46427), // Rule ID 115 //
     /*  46378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub16),
     /*  46386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46407 */     // (intrinsic_wo_chain:{ *:[i32] } 3933:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQSUB16),
     /*  46410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46419 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46425 */     GIR_RootConstrainSelectedInstOperands,
     /*  46426 */     // GIR_Coverage, 115,
     /*  46426 */     GIR_EraseRootFromParent_Done,
     /*  46427 */   // Label 1019: @46427
     /*  46427 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(46481), // Rule ID 116 //
     /*  46432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub8),
     /*  46440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46461 */     // (intrinsic_wo_chain:{ *:[i32] } 3934:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQSUB8),
     /*  46464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46473 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46479 */     GIR_RootConstrainSelectedInstOperands,
     /*  46480 */     // GIR_Coverage, 116,
     /*  46480 */     GIR_EraseRootFromParent_Done,
     /*  46481 */   // Label 1020: @46481
     /*  46481 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(46535), // Rule ID 117 //
     /*  46486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qasx),
     /*  46494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46515 */     // (intrinsic_wo_chain:{ *:[i32] } 3863:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QASX),
     /*  46518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46527 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46533 */     GIR_RootConstrainSelectedInstOperands,
     /*  46534 */     // GIR_Coverage, 117,
     /*  46534 */     GIR_EraseRootFromParent_Done,
     /*  46535 */   // Label 1021: @46535
     /*  46535 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(46589), // Rule ID 118 //
     /*  46540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsax),
     /*  46548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46569 */     // (intrinsic_wo_chain:{ *:[i32] } 3864:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSAX),
     /*  46572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46581 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46587 */     GIR_RootConstrainSelectedInstOperands,
     /*  46588 */     // GIR_Coverage, 118,
     /*  46588 */     GIR_EraseRootFromParent_Done,
     /*  46589 */   // Label 1022: @46589
     /*  46589 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(46643), // Rule ID 119 //
     /*  46594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqasx),
     /*  46602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46623 */     // (intrinsic_wo_chain:{ *:[i32] } 3931:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQASX),
     /*  46626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46635 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46641 */     GIR_RootConstrainSelectedInstOperands,
     /*  46642 */     // GIR_Coverage, 119,
     /*  46642 */     GIR_EraseRootFromParent_Done,
     /*  46643 */   // Label 1023: @46643
     /*  46643 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(46697), // Rule ID 120 //
     /*  46648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsax),
     /*  46656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46677 */     // (intrinsic_wo_chain:{ *:[i32] } 3932:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQSAX),
     /*  46680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46689 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46695 */     GIR_RootConstrainSelectedInstOperands,
     /*  46696 */     // GIR_Coverage, 120,
     /*  46696 */     GIR_EraseRootFromParent_Done,
     /*  46697 */   // Label 1024: @46697
     /*  46697 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(46751), // Rule ID 133 //
     /*  46702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shasx),
     /*  46710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46731 */     // (intrinsic_wo_chain:{ *:[i32] } 3875:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHASX),
     /*  46734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46743 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46749 */     GIR_RootConstrainSelectedInstOperands,
     /*  46750 */     // GIR_Coverage, 133,
     /*  46750 */     GIR_EraseRootFromParent_Done,
     /*  46751 */   // Label 1025: @46751
     /*  46751 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(46805), // Rule ID 134 //
     /*  46756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd16),
     /*  46764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46785 */     // (intrinsic_wo_chain:{ *:[i32] } 3873:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHADD16),
     /*  46788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46797 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46803 */     GIR_RootConstrainSelectedInstOperands,
     /*  46804 */     // GIR_Coverage, 134,
     /*  46804 */     GIR_EraseRootFromParent_Done,
     /*  46805 */   // Label 1026: @46805
     /*  46805 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(46859), // Rule ID 135 //
     /*  46810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd8),
     /*  46818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46839 */     // (intrinsic_wo_chain:{ *:[i32] } 3874:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHADD8),
     /*  46842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46851 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46857 */     GIR_RootConstrainSelectedInstOperands,
     /*  46858 */     // GIR_Coverage, 135,
     /*  46858 */     GIR_EraseRootFromParent_Done,
     /*  46859 */   // Label 1027: @46859
     /*  46859 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(46913), // Rule ID 136 //
     /*  46864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsax),
     /*  46872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46893 */     // (intrinsic_wo_chain:{ *:[i32] } 3876:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHSAX),
     /*  46896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46911 */     GIR_RootConstrainSelectedInstOperands,
     /*  46912 */     // GIR_Coverage, 136,
     /*  46912 */     GIR_EraseRootFromParent_Done,
     /*  46913 */   // Label 1028: @46913
     /*  46913 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(46967), // Rule ID 137 //
     /*  46918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub16),
     /*  46926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46947 */     // (intrinsic_wo_chain:{ *:[i32] } 3877:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHSUB16),
     /*  46950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46959 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46965 */     GIR_RootConstrainSelectedInstOperands,
     /*  46966 */     // GIR_Coverage, 137,
     /*  46966 */     GIR_EraseRootFromParent_Done,
     /*  46967 */   // Label 1029: @46967
     /*  46967 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(47021), // Rule ID 138 //
     /*  46972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub8),
     /*  46980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47001 */     // (intrinsic_wo_chain:{ *:[i32] } 3878:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHSUB8),
     /*  47004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47013 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47019 */     GIR_RootConstrainSelectedInstOperands,
     /*  47020 */     // GIR_Coverage, 138,
     /*  47020 */     GIR_EraseRootFromParent_Done,
     /*  47021 */   // Label 1030: @47021
     /*  47021 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(47075), // Rule ID 139 //
     /*  47026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhasx),
     /*  47034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47055 */     // (intrinsic_wo_chain:{ *:[i32] } 3924:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHASX),
     /*  47058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47067 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47073 */     GIR_RootConstrainSelectedInstOperands,
     /*  47074 */     // GIR_Coverage, 139,
     /*  47074 */     GIR_EraseRootFromParent_Done,
     /*  47075 */   // Label 1031: @47075
     /*  47075 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(47129), // Rule ID 140 //
     /*  47080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd16),
     /*  47088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47109 */     // (intrinsic_wo_chain:{ *:[i32] } 3922:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHADD16),
     /*  47112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47121 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47127 */     GIR_RootConstrainSelectedInstOperands,
     /*  47128 */     // GIR_Coverage, 140,
     /*  47128 */     GIR_EraseRootFromParent_Done,
     /*  47129 */   // Label 1032: @47129
     /*  47129 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(47183), // Rule ID 141 //
     /*  47134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd8),
     /*  47142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47163 */     // (intrinsic_wo_chain:{ *:[i32] } 3923:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHADD8),
     /*  47166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47175 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47181 */     GIR_RootConstrainSelectedInstOperands,
     /*  47182 */     // GIR_Coverage, 141,
     /*  47182 */     GIR_EraseRootFromParent_Done,
     /*  47183 */   // Label 1033: @47183
     /*  47183 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(47237), // Rule ID 142 //
     /*  47188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsax),
     /*  47196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47217 */     // (intrinsic_wo_chain:{ *:[i32] } 3925:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHSAX),
     /*  47220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47229 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47235 */     GIR_RootConstrainSelectedInstOperands,
     /*  47236 */     // GIR_Coverage, 142,
     /*  47236 */     GIR_EraseRootFromParent_Done,
     /*  47237 */   // Label 1034: @47237
     /*  47237 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(47291), // Rule ID 143 //
     /*  47242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub16),
     /*  47250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47271 */     // (intrinsic_wo_chain:{ *:[i32] } 3926:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHSUB16),
     /*  47274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47283 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47289 */     GIR_RootConstrainSelectedInstOperands,
     /*  47290 */     // GIR_Coverage, 143,
     /*  47290 */     GIR_EraseRootFromParent_Done,
     /*  47291 */   // Label 1035: @47291
     /*  47291 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(47345), // Rule ID 144 //
     /*  47296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub8),
     /*  47304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47325 */     // (intrinsic_wo_chain:{ *:[i32] } 3927:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHSUB8),
     /*  47328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47337 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47343 */     GIR_RootConstrainSelectedInstOperands,
     /*  47344 */     // GIR_Coverage, 144,
     /*  47344 */     GIR_EraseRootFromParent_Done,
     /*  47345 */   // Label 1036: @47345
     /*  47345 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(47399), // Rule ID 145 //
     /*  47350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  47353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usad8),
     /*  47358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  47371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  47375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  47379 */     // (intrinsic_wo_chain:{ *:[i32] } 3935:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (USAD8:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  47379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAD8),
     /*  47382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47391 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47397 */     GIR_RootConstrainSelectedInstOperands,
     /*  47398 */     // GIR_Coverage, 145,
     /*  47398 */     GIR_EraseRootFromParent_Done,
     /*  47399 */   // Label 1037: @47399
     /*  47399 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(47444), // Rule ID 204 //
     /*  47404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32b),
     /*  47412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47433 */     // (intrinsic_wo_chain:{ *:[i32] } 3496:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32B:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32B),
     /*  47436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47442 */     GIR_RootConstrainSelectedInstOperands,
     /*  47443 */     // GIR_Coverage, 204,
     /*  47443 */     GIR_EraseRootFromParent_Done,
     /*  47444 */   // Label 1038: @47444
     /*  47444 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(47489), // Rule ID 205 //
     /*  47449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cb),
     /*  47457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47478 */     // (intrinsic_wo_chain:{ *:[i32] } 3497:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32CB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32CB),
     /*  47481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47487 */     GIR_RootConstrainSelectedInstOperands,
     /*  47488 */     // GIR_Coverage, 205,
     /*  47488 */     GIR_EraseRootFromParent_Done,
     /*  47489 */   // Label 1039: @47489
     /*  47489 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(47534), // Rule ID 206 //
     /*  47494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32h),
     /*  47502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47523 */     // (intrinsic_wo_chain:{ *:[i32] } 3500:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32H:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32H),
     /*  47526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47532 */     GIR_RootConstrainSelectedInstOperands,
     /*  47533 */     // GIR_Coverage, 206,
     /*  47533 */     GIR_EraseRootFromParent_Done,
     /*  47534 */   // Label 1040: @47534
     /*  47534 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(47579), // Rule ID 207 //
     /*  47539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32ch),
     /*  47547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47568 */     // (intrinsic_wo_chain:{ *:[i32] } 3498:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32CH:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32CH),
     /*  47571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47577 */     GIR_RootConstrainSelectedInstOperands,
     /*  47578 */     // GIR_Coverage, 207,
     /*  47578 */     GIR_EraseRootFromParent_Done,
     /*  47579 */   // Label 1041: @47579
     /*  47579 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(47624), // Rule ID 208 //
     /*  47584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32w),
     /*  47592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47613 */     // (intrinsic_wo_chain:{ *:[i32] } 3501:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32W:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32W),
     /*  47616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47622 */     GIR_RootConstrainSelectedInstOperands,
     /*  47623 */     // GIR_Coverage, 208,
     /*  47623 */     GIR_EraseRootFromParent_Done,
     /*  47624 */   // Label 1042: @47624
     /*  47624 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(47669), // Rule ID 209 //
     /*  47629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cw),
     /*  47637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47658 */     // (intrinsic_wo_chain:{ *:[i32] } 3499:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32CW:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32CW),
     /*  47661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47667 */     GIR_RootConstrainSelectedInstOperands,
     /*  47668 */     // GIR_Coverage, 209,
     /*  47668 */     GIR_EraseRootFromParent_Done,
     /*  47669 */   // Label 1043: @47669
     /*  47669 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(47723), // Rule ID 432 //
     /*  47674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd16),
     /*  47682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47703 */     // (intrinsic_wo_chain:{ *:[i32] } 3861:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD16),
     /*  47706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47715 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47721 */     GIR_RootConstrainSelectedInstOperands,
     /*  47722 */     // GIR_Coverage, 432,
     /*  47722 */     GIR_EraseRootFromParent_Done,
     /*  47723 */   // Label 1044: @47723
     /*  47723 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(47777), // Rule ID 433 //
     /*  47728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd8),
     /*  47736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47757 */     // (intrinsic_wo_chain:{ *:[i32] } 3862:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD8),
     /*  47760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47769 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47775 */     GIR_RootConstrainSelectedInstOperands,
     /*  47776 */     // GIR_Coverage, 433,
     /*  47776 */     GIR_EraseRootFromParent_Done,
     /*  47777 */   // Label 1045: @47777
     /*  47777 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(47831), // Rule ID 434 //
     /*  47782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qasx),
     /*  47790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47811 */     // (intrinsic_wo_chain:{ *:[i32] } 3863:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QASX),
     /*  47814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47823 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47829 */     GIR_RootConstrainSelectedInstOperands,
     /*  47830 */     // GIR_Coverage, 434,
     /*  47830 */     GIR_EraseRootFromParent_Done,
     /*  47831 */   // Label 1046: @47831
     /*  47831 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(47885), // Rule ID 435 //
     /*  47836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub8),
     /*  47844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47865 */     // (intrinsic_wo_chain:{ *:[i32] } 3934:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQSUB8),
     /*  47868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47877 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47883 */     GIR_RootConstrainSelectedInstOperands,
     /*  47884 */     // GIR_Coverage, 435,
     /*  47884 */     GIR_EraseRootFromParent_Done,
     /*  47885 */   // Label 1047: @47885
     /*  47885 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(47939), // Rule ID 436 //
     /*  47890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsax),
     /*  47898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47919 */     // (intrinsic_wo_chain:{ *:[i32] } 3864:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSAX),
     /*  47922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47931 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47937 */     GIR_RootConstrainSelectedInstOperands,
     /*  47938 */     // GIR_Coverage, 436,
     /*  47938 */     GIR_EraseRootFromParent_Done,
     /*  47939 */   // Label 1048: @47939
     /*  47939 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(47993), // Rule ID 437 //
     /*  47944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub16),
     /*  47952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47973 */     // (intrinsic_wo_chain:{ *:[i32] } 3866:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB16),
     /*  47976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47985 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47991 */     GIR_RootConstrainSelectedInstOperands,
     /*  47992 */     // GIR_Coverage, 437,
     /*  47992 */     GIR_EraseRootFromParent_Done,
     /*  47993 */   // Label 1049: @47993
     /*  47993 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(48047), // Rule ID 438 //
     /*  47998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub8),
     /*  48006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48027 */     // (intrinsic_wo_chain:{ *:[i32] } 3867:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB8),
     /*  48030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48039 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48045 */     GIR_RootConstrainSelectedInstOperands,
     /*  48046 */     // GIR_Coverage, 438,
     /*  48046 */     GIR_EraseRootFromParent_Done,
     /*  48047 */   // Label 1050: @48047
     /*  48047 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(48101), // Rule ID 439 //
     /*  48052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd16),
     /*  48060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48081 */     // (intrinsic_wo_chain:{ *:[i32] } 3929:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQADD16),
     /*  48084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48093 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48099 */     GIR_RootConstrainSelectedInstOperands,
     /*  48100 */     // GIR_Coverage, 439,
     /*  48100 */     GIR_EraseRootFromParent_Done,
     /*  48101 */   // Label 1051: @48101
     /*  48101 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(48155), // Rule ID 440 //
     /*  48106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd8),
     /*  48114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48135 */     // (intrinsic_wo_chain:{ *:[i32] } 3930:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQADD8),
     /*  48138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48147 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48153 */     GIR_RootConstrainSelectedInstOperands,
     /*  48154 */     // GIR_Coverage, 440,
     /*  48154 */     GIR_EraseRootFromParent_Done,
     /*  48155 */   // Label 1052: @48155
     /*  48155 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(48209), // Rule ID 441 //
     /*  48160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqasx),
     /*  48168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48189 */     // (intrinsic_wo_chain:{ *:[i32] } 3931:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQASX),
     /*  48192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48201 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48207 */     GIR_RootConstrainSelectedInstOperands,
     /*  48208 */     // GIR_Coverage, 441,
     /*  48208 */     GIR_EraseRootFromParent_Done,
     /*  48209 */   // Label 1053: @48209
     /*  48209 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(48263), // Rule ID 442 //
     /*  48214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsax),
     /*  48222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48243 */     // (intrinsic_wo_chain:{ *:[i32] } 3932:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQSAX),
     /*  48246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48255 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48261 */     GIR_RootConstrainSelectedInstOperands,
     /*  48262 */     // GIR_Coverage, 442,
     /*  48262 */     GIR_EraseRootFromParent_Done,
     /*  48263 */   // Label 1054: @48263
     /*  48263 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(48317), // Rule ID 443 //
     /*  48268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub16),
     /*  48276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48297 */     // (intrinsic_wo_chain:{ *:[i32] } 3933:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQSUB16),
     /*  48300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48309 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48315 */     GIR_RootConstrainSelectedInstOperands,
     /*  48316 */     // GIR_Coverage, 443,
     /*  48316 */     GIR_EraseRootFromParent_Done,
     /*  48317 */   // Label 1055: @48317
     /*  48317 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(48371), // Rule ID 456 //
     /*  48322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shasx),
     /*  48330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48351 */     // (intrinsic_wo_chain:{ *:[i32] } 3875:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHASX),
     /*  48354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48363 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48369 */     GIR_RootConstrainSelectedInstOperands,
     /*  48370 */     // GIR_Coverage, 456,
     /*  48370 */     GIR_EraseRootFromParent_Done,
     /*  48371 */   // Label 1056: @48371
     /*  48371 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(48425), // Rule ID 457 //
     /*  48376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd16),
     /*  48384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48405 */     // (intrinsic_wo_chain:{ *:[i32] } 3873:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHADD16),
     /*  48408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48417 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48423 */     GIR_RootConstrainSelectedInstOperands,
     /*  48424 */     // GIR_Coverage, 457,
     /*  48424 */     GIR_EraseRootFromParent_Done,
     /*  48425 */   // Label 1057: @48425
     /*  48425 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(48479), // Rule ID 458 //
     /*  48430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd8),
     /*  48438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48459 */     // (intrinsic_wo_chain:{ *:[i32] } 3874:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHADD8),
     /*  48462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48471 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48477 */     GIR_RootConstrainSelectedInstOperands,
     /*  48478 */     // GIR_Coverage, 458,
     /*  48478 */     GIR_EraseRootFromParent_Done,
     /*  48479 */   // Label 1058: @48479
     /*  48479 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(48533), // Rule ID 459 //
     /*  48484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsax),
     /*  48492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48513 */     // (intrinsic_wo_chain:{ *:[i32] } 3876:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHSAX),
     /*  48516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48525 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48531 */     GIR_RootConstrainSelectedInstOperands,
     /*  48532 */     // GIR_Coverage, 459,
     /*  48532 */     GIR_EraseRootFromParent_Done,
     /*  48533 */   // Label 1059: @48533
     /*  48533 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(48587), // Rule ID 460 //
     /*  48538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub16),
     /*  48546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48567 */     // (intrinsic_wo_chain:{ *:[i32] } 3877:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHSUB16),
     /*  48570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48579 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48585 */     GIR_RootConstrainSelectedInstOperands,
     /*  48586 */     // GIR_Coverage, 460,
     /*  48586 */     GIR_EraseRootFromParent_Done,
     /*  48587 */   // Label 1060: @48587
     /*  48587 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(48641), // Rule ID 461 //
     /*  48592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub8),
     /*  48600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48621 */     // (intrinsic_wo_chain:{ *:[i32] } 3878:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHSUB8),
     /*  48624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48633 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48639 */     GIR_RootConstrainSelectedInstOperands,
     /*  48640 */     // GIR_Coverage, 461,
     /*  48640 */     GIR_EraseRootFromParent_Done,
     /*  48641 */   // Label 1061: @48641
     /*  48641 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(48695), // Rule ID 462 //
     /*  48646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhasx),
     /*  48654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48675 */     // (intrinsic_wo_chain:{ *:[i32] } 3924:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHASX),
     /*  48678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48687 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48693 */     GIR_RootConstrainSelectedInstOperands,
     /*  48694 */     // GIR_Coverage, 462,
     /*  48694 */     GIR_EraseRootFromParent_Done,
     /*  48695 */   // Label 1062: @48695
     /*  48695 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(48749), // Rule ID 463 //
     /*  48700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd16),
     /*  48708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48729 */     // (intrinsic_wo_chain:{ *:[i32] } 3922:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHADD16),
     /*  48732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48741 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48747 */     GIR_RootConstrainSelectedInstOperands,
     /*  48748 */     // GIR_Coverage, 463,
     /*  48748 */     GIR_EraseRootFromParent_Done,
     /*  48749 */   // Label 1063: @48749
     /*  48749 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(48803), // Rule ID 464 //
     /*  48754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd8),
     /*  48762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48783 */     // (intrinsic_wo_chain:{ *:[i32] } 3923:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHADD8),
     /*  48786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48795 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48801 */     GIR_RootConstrainSelectedInstOperands,
     /*  48802 */     // GIR_Coverage, 464,
     /*  48802 */     GIR_EraseRootFromParent_Done,
     /*  48803 */   // Label 1064: @48803
     /*  48803 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(48857), // Rule ID 465 //
     /*  48808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsax),
     /*  48816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48837 */     // (intrinsic_wo_chain:{ *:[i32] } 3925:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHSAX),
     /*  48840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48849 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48855 */     GIR_RootConstrainSelectedInstOperands,
     /*  48856 */     // GIR_Coverage, 465,
     /*  48856 */     GIR_EraseRootFromParent_Done,
     /*  48857 */   // Label 1065: @48857
     /*  48857 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(48911), // Rule ID 466 //
     /*  48862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub16),
     /*  48870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48891 */     // (intrinsic_wo_chain:{ *:[i32] } 3926:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHSUB16),
     /*  48894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48903 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48909 */     GIR_RootConstrainSelectedInstOperands,
     /*  48910 */     // GIR_Coverage, 466,
     /*  48910 */     GIR_EraseRootFromParent_Done,
     /*  48911 */   // Label 1066: @48911
     /*  48911 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(48965), // Rule ID 467 //
     /*  48916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub8),
     /*  48924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48945 */     // (intrinsic_wo_chain:{ *:[i32] } 3927:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHSUB8),
     /*  48948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48957 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48963 */     GIR_RootConstrainSelectedInstOperands,
     /*  48964 */     // GIR_Coverage, 467,
     /*  48964 */     GIR_EraseRootFromParent_Done,
     /*  48965 */   // Label 1067: @48965
     /*  48965 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(49019), // Rule ID 468 //
     /*  48970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usad8),
     /*  48978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48999 */     // (intrinsic_wo_chain:{ *:[i32] } 3935:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USAD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAD8),
     /*  49002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49011 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49017 */     GIR_RootConstrainSelectedInstOperands,
     /*  49018 */     // GIR_Coverage, 468,
     /*  49018 */     GIR_EraseRootFromParent_Done,
     /*  49019 */   // Label 1068: @49019
     /*  49019 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(49073), // Rule ID 524 //
     /*  49024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  49027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuad),
     /*  49032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49053 */     // (intrinsic_wo_chain:{ *:[i32] } 3893:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUAD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUAD),
     /*  49056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49065 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49071 */     GIR_RootConstrainSelectedInstOperands,
     /*  49072 */     // GIR_Coverage, 524,
     /*  49072 */     GIR_EraseRootFromParent_Done,
     /*  49073 */   // Label 1069: @49073
     /*  49073 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(49127), // Rule ID 525 //
     /*  49078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  49081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuadx),
     /*  49086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49107 */     // (intrinsic_wo_chain:{ *:[i32] } 3894:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUADX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUADX),
     /*  49110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49119 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49125 */     GIR_RootConstrainSelectedInstOperands,
     /*  49126 */     // GIR_Coverage, 525,
     /*  49126 */     GIR_EraseRootFromParent_Done,
     /*  49127 */   // Label 1070: @49127
     /*  49127 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(49181), // Rule ID 526 //
     /*  49132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  49135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusd),
     /*  49140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49161 */     // (intrinsic_wo_chain:{ *:[i32] } 3901:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUSD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUSD),
     /*  49164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49173 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49179 */     GIR_RootConstrainSelectedInstOperands,
     /*  49180 */     // GIR_Coverage, 526,
     /*  49180 */     GIR_EraseRootFromParent_Done,
     /*  49181 */   // Label 1071: @49181
     /*  49181 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(49235), // Rule ID 527 //
     /*  49186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  49189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusdx),
     /*  49194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49215 */     // (intrinsic_wo_chain:{ *:[i32] } 3902:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUSDX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUSDX),
     /*  49218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49227 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49233 */     GIR_RootConstrainSelectedInstOperands,
     /*  49234 */     // GIR_Coverage, 527,
     /*  49234 */     GIR_EraseRootFromParent_Done,
     /*  49235 */   // Label 1072: @49235
     /*  49235 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(49280), // Rule ID 541 //
     /*  49240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32b),
     /*  49248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49269 */     // (intrinsic_wo_chain:{ *:[i32] } 3496:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32B:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32B),
     /*  49272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49278 */     GIR_RootConstrainSelectedInstOperands,
     /*  49279 */     // GIR_Coverage, 541,
     /*  49279 */     GIR_EraseRootFromParent_Done,
     /*  49280 */   // Label 1073: @49280
     /*  49280 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(49325), // Rule ID 542 //
     /*  49285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cb),
     /*  49293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49314 */     // (intrinsic_wo_chain:{ *:[i32] } 3497:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32CB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32CB),
     /*  49317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49323 */     GIR_RootConstrainSelectedInstOperands,
     /*  49324 */     // GIR_Coverage, 542,
     /*  49324 */     GIR_EraseRootFromParent_Done,
     /*  49325 */   // Label 1074: @49325
     /*  49325 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(49370), // Rule ID 543 //
     /*  49330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32h),
     /*  49338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49359 */     // (intrinsic_wo_chain:{ *:[i32] } 3500:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32H:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32H),
     /*  49362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49368 */     GIR_RootConstrainSelectedInstOperands,
     /*  49369 */     // GIR_Coverage, 543,
     /*  49369 */     GIR_EraseRootFromParent_Done,
     /*  49370 */   // Label 1075: @49370
     /*  49370 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(49415), // Rule ID 544 //
     /*  49375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32ch),
     /*  49383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49404 */     // (intrinsic_wo_chain:{ *:[i32] } 3498:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32CH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32CH),
     /*  49407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49413 */     GIR_RootConstrainSelectedInstOperands,
     /*  49414 */     // GIR_Coverage, 544,
     /*  49414 */     GIR_EraseRootFromParent_Done,
     /*  49415 */   // Label 1076: @49415
     /*  49415 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(49460), // Rule ID 545 //
     /*  49420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32w),
     /*  49428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49449 */     // (intrinsic_wo_chain:{ *:[i32] } 3501:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32W:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32W),
     /*  49452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49458 */     GIR_RootConstrainSelectedInstOperands,
     /*  49459 */     // GIR_Coverage, 545,
     /*  49459 */     GIR_EraseRootFromParent_Done,
     /*  49460 */   // Label 1077: @49460
     /*  49460 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(49505), // Rule ID 546 //
     /*  49465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cw),
     /*  49473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49494 */     // (intrinsic_wo_chain:{ *:[i32] } 3499:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32CW:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32CW),
     /*  49497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49503 */     GIR_RootConstrainSelectedInstOperands,
     /*  49504 */     // GIR_Coverage, 546,
     /*  49504 */     GIR_EraseRootFromParent_Done,
     /*  49505 */   // Label 1078: @49505
     /*  49505 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(49559), // Rule ID 792 //
     /*  49510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  49521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  49527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49539 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3766:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHADDsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  49539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv4i16),
     /*  49542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49557 */     GIR_RootConstrainSelectedInstOperands,
     /*  49558 */     // GIR_Coverage, 792,
     /*  49558 */     GIR_EraseRootFromParent_Done,
     /*  49559 */   // Label 1079: @49559
     /*  49559 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(49613), // Rule ID 793 //
     /*  49564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  49575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  49578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  49581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49593 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3766:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHADDsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  49593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv2i32),
     /*  49596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49605 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49611 */     GIR_RootConstrainSelectedInstOperands,
     /*  49612 */     // GIR_Coverage, 793,
     /*  49612 */     GIR_EraseRootFromParent_Done,
     /*  49613 */   // Label 1080: @49613
     /*  49613 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(49667), // Rule ID 794 //
     /*  49618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  49629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  49635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49647 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3766:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHADDsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  49647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv8i16),
     /*  49650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49659 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49665 */     GIR_RootConstrainSelectedInstOperands,
     /*  49666 */     // GIR_Coverage, 794,
     /*  49666 */     GIR_EraseRootFromParent_Done,
     /*  49667 */   // Label 1081: @49667
     /*  49667 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(49721), // Rule ID 795 //
     /*  49672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  49683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  49686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  49689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49701 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3766:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHADDsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  49701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv4i32),
     /*  49704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49713 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49719 */     GIR_RootConstrainSelectedInstOperands,
     /*  49720 */     // GIR_Coverage, 795,
     /*  49720 */     GIR_EraseRootFromParent_Done,
     /*  49721 */   // Label 1082: @49721
     /*  49721 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(49775), // Rule ID 796 //
     /*  49726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  49737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  49743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49755 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3766:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHADDsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  49755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv8i8),
     /*  49758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49767 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49773 */     GIR_RootConstrainSelectedInstOperands,
     /*  49774 */     // GIR_Coverage, 796,
     /*  49774 */     GIR_EraseRootFromParent_Done,
     /*  49775 */   // Label 1083: @49775
     /*  49775 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(49829), // Rule ID 797 //
     /*  49780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  49791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  49794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  49797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49809 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3766:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHADDsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  49809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv16i8),
     /*  49812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49821 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49827 */     GIR_RootConstrainSelectedInstOperands,
     /*  49828 */     // GIR_Coverage, 797,
     /*  49828 */     GIR_EraseRootFromParent_Done,
     /*  49829 */   // Label 1084: @49829
     /*  49829 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(49883), // Rule ID 798 //
     /*  49834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  49845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  49851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49863 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3767:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHADDuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  49863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv4i16),
     /*  49866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49875 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49881 */     GIR_RootConstrainSelectedInstOperands,
     /*  49882 */     // GIR_Coverage, 798,
     /*  49882 */     GIR_EraseRootFromParent_Done,
     /*  49883 */   // Label 1085: @49883
     /*  49883 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(49937), // Rule ID 799 //
     /*  49888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  49899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  49902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  49905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49917 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3767:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHADDuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  49917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv2i32),
     /*  49920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49929 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49935 */     GIR_RootConstrainSelectedInstOperands,
     /*  49936 */     // GIR_Coverage, 799,
     /*  49936 */     GIR_EraseRootFromParent_Done,
     /*  49937 */   // Label 1086: @49937
     /*  49937 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(49991), // Rule ID 800 //
     /*  49942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  49953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  49959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49971 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3767:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHADDuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  49971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv8i16),
     /*  49974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49983 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49989 */     GIR_RootConstrainSelectedInstOperands,
     /*  49990 */     // GIR_Coverage, 800,
     /*  49990 */     GIR_EraseRootFromParent_Done,
     /*  49991 */   // Label 1087: @49991
     /*  49991 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(50045), // Rule ID 801 //
     /*  49996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  50004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  50007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50025 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3767:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHADDuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv4i32),
     /*  50028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50037 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50043 */     GIR_RootConstrainSelectedInstOperands,
     /*  50044 */     // GIR_Coverage, 801,
     /*  50044 */     GIR_EraseRootFromParent_Done,
     /*  50045 */   // Label 1088: @50045
     /*  50045 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(50099), // Rule ID 802 //
     /*  50050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  50058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50079 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3767:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHADDuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  50079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv8i8),
     /*  50082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50091 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50097 */     GIR_RootConstrainSelectedInstOperands,
     /*  50098 */     // GIR_Coverage, 802,
     /*  50098 */     GIR_EraseRootFromParent_Done,
     /*  50099 */   // Label 1089: @50099
     /*  50099 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(50153), // Rule ID 803 //
     /*  50104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  50112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  50115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  50121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50133 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3767:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHADDuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  50133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv16i8),
     /*  50136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50145 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50151 */     GIR_RootConstrainSelectedInstOperands,
     /*  50152 */     // GIR_Coverage, 803,
     /*  50152 */     GIR_EraseRootFromParent_Done,
     /*  50153 */   // Label 1090: @50153
     /*  50153 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(50207), // Rule ID 804 //
     /*  50158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  50169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  50172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  50175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50187 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3826:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VRHADDsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  50187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv4i16),
     /*  50190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50199 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50205 */     GIR_RootConstrainSelectedInstOperands,
     /*  50206 */     // GIR_Coverage, 804,
     /*  50206 */     GIR_EraseRootFromParent_Done,
     /*  50207 */   // Label 1091: @50207
     /*  50207 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(50261), // Rule ID 805 //
     /*  50212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  50226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  50229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50241 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3826:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VRHADDsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  50241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv2i32),
     /*  50244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50253 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50259 */     GIR_RootConstrainSelectedInstOperands,
     /*  50260 */     // GIR_Coverage, 805,
     /*  50260 */     GIR_EraseRootFromParent_Done,
     /*  50261 */   // Label 1092: @50261
     /*  50261 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(50315), // Rule ID 806 //
     /*  50266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  50277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50295 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3826:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRHADDsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv8i16),
     /*  50298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50307 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50313 */     GIR_RootConstrainSelectedInstOperands,
     /*  50314 */     // GIR_Coverage, 806,
     /*  50314 */     GIR_EraseRootFromParent_Done,
     /*  50315 */   // Label 1093: @50315
     /*  50315 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(50369), // Rule ID 807 //
     /*  50320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  50331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50349 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3826:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRHADDsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv4i32),
     /*  50352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50361 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50367 */     GIR_RootConstrainSelectedInstOperands,
     /*  50368 */     // GIR_Coverage, 807,
     /*  50368 */     GIR_EraseRootFromParent_Done,
     /*  50369 */   // Label 1094: @50369
     /*  50369 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(50423), // Rule ID 808 //
     /*  50374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50403 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3826:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VRHADDsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  50403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv8i8),
     /*  50406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50415 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50421 */     GIR_RootConstrainSelectedInstOperands,
     /*  50422 */     // GIR_Coverage, 808,
     /*  50422 */     GIR_EraseRootFromParent_Done,
     /*  50423 */   // Label 1095: @50423
     /*  50423 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(50477), // Rule ID 809 //
     /*  50428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  50439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  50445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50457 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3826:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VRHADDsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  50457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv16i8),
     /*  50460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50469 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50475 */     GIR_RootConstrainSelectedInstOperands,
     /*  50476 */     // GIR_Coverage, 809,
     /*  50476 */     GIR_EraseRootFromParent_Done,
     /*  50477 */   // Label 1096: @50477
     /*  50477 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(50531), // Rule ID 810 //
     /*  50482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  50493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  50496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  50499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50511 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3827:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VRHADDuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  50511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv4i16),
     /*  50514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50523 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50529 */     GIR_RootConstrainSelectedInstOperands,
     /*  50530 */     // GIR_Coverage, 810,
     /*  50530 */     GIR_EraseRootFromParent_Done,
     /*  50531 */   // Label 1097: @50531
     /*  50531 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(50585), // Rule ID 811 //
     /*  50536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  50550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  50553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50565 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3827:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VRHADDuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  50565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv2i32),
     /*  50568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50577 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50583 */     GIR_RootConstrainSelectedInstOperands,
     /*  50584 */     // GIR_Coverage, 811,
     /*  50584 */     GIR_EraseRootFromParent_Done,
     /*  50585 */   // Label 1098: @50585
     /*  50585 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(50639), // Rule ID 812 //
     /*  50590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  50601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50619 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3827:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRHADDuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv8i16),
     /*  50622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50631 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50637 */     GIR_RootConstrainSelectedInstOperands,
     /*  50638 */     // GIR_Coverage, 812,
     /*  50638 */     GIR_EraseRootFromParent_Done,
     /*  50639 */   // Label 1099: @50639
     /*  50639 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(50693), // Rule ID 813 //
     /*  50644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  50655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50673 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3827:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRHADDuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv4i32),
     /*  50676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50685 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50691 */     GIR_RootConstrainSelectedInstOperands,
     /*  50692 */     // GIR_Coverage, 813,
     /*  50692 */     GIR_EraseRootFromParent_Done,
     /*  50693 */   // Label 1100: @50693
     /*  50693 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(50747), // Rule ID 814 //
     /*  50698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50727 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3827:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VRHADDuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  50727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv8i8),
     /*  50730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50739 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50745 */     GIR_RootConstrainSelectedInstOperands,
     /*  50746 */     // GIR_Coverage, 814,
     /*  50746 */     GIR_EraseRootFromParent_Done,
     /*  50747 */   // Label 1101: @50747
     /*  50747 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(50801), // Rule ID 815 //
     /*  50752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  50763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  50769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50781 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3827:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VRHADDuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  50781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv16i8),
     /*  50784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50793 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50799 */     GIR_RootConstrainSelectedInstOperands,
     /*  50800 */     // GIR_Coverage, 815,
     /*  50800 */     GIR_EraseRootFromParent_Done,
     /*  50801 */   // Label 1102: @50801
     /*  50801 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(50855), // Rule ID 832 //
     /*  50806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vraddhn),
     /*  50814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50835 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3823:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRADDHNv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRADDHNv8i8),
     /*  50838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50847 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50853 */     GIR_RootConstrainSelectedInstOperands,
     /*  50854 */     // GIR_Coverage, 832,
     /*  50854 */     GIR_EraseRootFromParent_Done,
     /*  50855 */   // Label 1103: @50855
     /*  50855 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(50909), // Rule ID 833 //
     /*  50860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vraddhn),
     /*  50868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  50871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50889 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3823:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRADDHNv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRADDHNv4i16),
     /*  50892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50901 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50907 */     GIR_RootConstrainSelectedInstOperands,
     /*  50908 */     // GIR_Coverage, 833,
     /*  50908 */     GIR_EraseRootFromParent_Done,
     /*  50909 */   // Label 1104: @50909
     /*  50909 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(50963), // Rule ID 834 //
     /*  50914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vraddhn),
     /*  50922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  50928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  50931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50943 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3823:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VRADDHNv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*  50943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRADDHNv2i32),
     /*  50946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50955 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50961 */     GIR_RootConstrainSelectedInstOperands,
     /*  50962 */     // GIR_Coverage, 834,
     /*  50962 */     GIR_EraseRootFromParent_Done,
     /*  50963 */   // Label 1105: @50963
     /*  50963 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(51017), // Rule ID 841 //
     /*  50968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmulp),
     /*  50976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50997 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3792:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMULpd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  50997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULpd),
     /*  51000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51009 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51015 */     GIR_RootConstrainSelectedInstOperands,
     /*  51016 */     // GIR_Coverage, 841,
     /*  51016 */     GIR_EraseRootFromParent_Done,
     /*  51017 */   // Label 1106: @51017
     /*  51017 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(51071), // Rule ID 842 //
     /*  51022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmulp),
     /*  51030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  51033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  51036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  51039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51051 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3792:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMULpq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  51051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULpq),
     /*  51054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51063 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51069 */     GIR_RootConstrainSelectedInstOperands,
     /*  51070 */     // GIR_Coverage, 842,
     /*  51070 */     GIR_EraseRootFromParent_Done,
     /*  51071 */   // Label 1107: @51071
     /*  51071 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(51125), // Rule ID 855 //
     /*  51076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  51084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  51087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51105 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3803:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQDMULHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv4i16),
     /*  51108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51117 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51123 */     GIR_RootConstrainSelectedInstOperands,
     /*  51124 */     // GIR_Coverage, 855,
     /*  51124 */     GIR_EraseRootFromParent_Done,
     /*  51125 */   // Label 1108: @51125
     /*  51125 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(51179), // Rule ID 856 //
     /*  51130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  51138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  51141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51159 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3803:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQDMULHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv2i32),
     /*  51162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51171 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51177 */     GIR_RootConstrainSelectedInstOperands,
     /*  51178 */     // GIR_Coverage, 856,
     /*  51178 */     GIR_EraseRootFromParent_Done,
     /*  51179 */   // Label 1109: @51179
     /*  51179 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(51233), // Rule ID 857 //
     /*  51184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  51192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  51198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  51201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51213 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3803:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQDMULHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  51213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv8i16),
     /*  51216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51225 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51231 */     GIR_RootConstrainSelectedInstOperands,
     /*  51232 */     // GIR_Coverage, 857,
     /*  51232 */     GIR_EraseRootFromParent_Done,
     /*  51233 */   // Label 1110: @51233
     /*  51233 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(51287), // Rule ID 858 //
     /*  51238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  51246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  51252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  51255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51267 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3803:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQDMULHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  51267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv4i32),
     /*  51270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51279 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51285 */     GIR_RootConstrainSelectedInstOperands,
     /*  51286 */     // GIR_Coverage, 858,
     /*  51286 */     GIR_EraseRootFromParent_Done,
     /*  51287 */   // Label 1111: @51287
     /*  51287 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(51341), // Rule ID 863 //
     /*  51292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  51303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51321 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3811:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQRDMULHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv4i16),
     /*  51324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51333 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51339 */     GIR_RootConstrainSelectedInstOperands,
     /*  51340 */     // GIR_Coverage, 863,
     /*  51340 */     GIR_EraseRootFromParent_Done,
     /*  51341 */   // Label 1112: @51341
     /*  51341 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(51395), // Rule ID 864 //
     /*  51346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  51357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51375 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3811:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQRDMULHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv2i32),
     /*  51378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51387 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51393 */     GIR_RootConstrainSelectedInstOperands,
     /*  51394 */     // GIR_Coverage, 864,
     /*  51394 */     GIR_EraseRootFromParent_Done,
     /*  51395 */   // Label 1113: @51395
     /*  51395 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(51449), // Rule ID 865 //
     /*  51400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  51414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  51417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51429 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3811:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQRDMULHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  51429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv8i16),
     /*  51432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51441 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51447 */     GIR_RootConstrainSelectedInstOperands,
     /*  51448 */     // GIR_Coverage, 865,
     /*  51448 */     GIR_EraseRootFromParent_Done,
     /*  51449 */   // Label 1114: @51449
     /*  51449 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(51503), // Rule ID 866 //
     /*  51454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  51468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  51471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51483 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3811:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQRDMULHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  51483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv4i32),
     /*  51486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51495 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51501 */     GIR_RootConstrainSelectedInstOperands,
     /*  51502 */     // GIR_Coverage, 866,
     /*  51502 */     GIR_EraseRootFromParent_Done,
     /*  51503 */   // Label 1115: @51503
     /*  51503 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(51557), // Rule ID 877 //
     /*  51508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmullp),
     /*  51516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  51522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  51525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51537 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3789:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMULLp8:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  51537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULLp8),
     /*  51540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51549 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51555 */     GIR_RootConstrainSelectedInstOperands,
     /*  51556 */     // GIR_Coverage, 877,
     /*  51556 */     GIR_EraseRootFromParent_Done,
     /*  51557 */   // Label 1116: @51557
     /*  51557 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(51602), // Rule ID 878 //
     /*  51562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  51565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmullp),
     /*  51570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  51573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  51576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  51579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51591 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3789:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VMULLp64:{ *:[v2i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /*  51591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULLp64),
     /*  51594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51600 */     GIR_RootConstrainSelectedInstOperands,
     /*  51601 */     // GIR_Coverage, 878,
     /*  51601 */     GIR_EraseRootFromParent_Done,
     /*  51602 */   // Label 1117: @51602
     /*  51602 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(51656), // Rule ID 883 //
     /*  51607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /*  51615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51636 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3804:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQDMULLv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULLv4i32),
     /*  51639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51648 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51654 */     GIR_RootConstrainSelectedInstOperands,
     /*  51655 */     // GIR_Coverage, 883,
     /*  51655 */     GIR_EraseRootFromParent_Done,
     /*  51656 */   // Label 1118: @51656
     /*  51656 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(51710), // Rule ID 884 //
     /*  51661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /*  51669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  51672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51690 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3804:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQDMULLv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULLv2i64),
     /*  51693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51702 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51708 */     GIR_RootConstrainSelectedInstOperands,
     /*  51709 */     // GIR_Coverage, 884,
     /*  51709 */     GIR_EraseRootFromParent_Done,
     /*  51710 */   // Label 1119: @51710
     /*  51710 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(51764), // Rule ID 996 //
     /*  51715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  51726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51744 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3768:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHSUBsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv4i16),
     /*  51747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51756 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51762 */     GIR_RootConstrainSelectedInstOperands,
     /*  51763 */     // GIR_Coverage, 996,
     /*  51763 */     GIR_EraseRootFromParent_Done,
     /*  51764 */   // Label 1120: @51764
     /*  51764 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(51818), // Rule ID 997 //
     /*  51769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  51780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51798 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3768:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHSUBsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv2i32),
     /*  51801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51810 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51816 */     GIR_RootConstrainSelectedInstOperands,
     /*  51817 */     // GIR_Coverage, 997,
     /*  51817 */     GIR_EraseRootFromParent_Done,
     /*  51818 */   // Label 1121: @51818
     /*  51818 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(51872), // Rule ID 998 //
     /*  51823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  51837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  51840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51852 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3768:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHSUBsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  51852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv8i16),
     /*  51855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51864 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51870 */     GIR_RootConstrainSelectedInstOperands,
     /*  51871 */     // GIR_Coverage, 998,
     /*  51871 */     GIR_EraseRootFromParent_Done,
     /*  51872 */   // Label 1122: @51872
     /*  51872 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(51926), // Rule ID 999 //
     /*  51877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  51891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  51894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51906 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3768:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHSUBsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  51906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv4i32),
     /*  51909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51918 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51924 */     GIR_RootConstrainSelectedInstOperands,
     /*  51925 */     // GIR_Coverage, 999,
     /*  51925 */     GIR_EraseRootFromParent_Done,
     /*  51926 */   // Label 1123: @51926
     /*  51926 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(51980), // Rule ID 1000 //
     /*  51931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  51942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  51945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  51948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51960 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3768:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHSUBsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  51960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv8i8),
     /*  51963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51967 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51972 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51978 */     GIR_RootConstrainSelectedInstOperands,
     /*  51979 */     // GIR_Coverage, 1000,
     /*  51979 */     GIR_EraseRootFromParent_Done,
     /*  51980 */   // Label 1124: @51980
     /*  51980 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(52034), // Rule ID 1001 //
     /*  51985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  51996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  51999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  52002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52014 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3768:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHSUBsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  52014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv16i8),
     /*  52017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52026 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52032 */     GIR_RootConstrainSelectedInstOperands,
     /*  52033 */     // GIR_Coverage, 1001,
     /*  52033 */     GIR_EraseRootFromParent_Done,
     /*  52034 */   // Label 1125: @52034
     /*  52034 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(52088), // Rule ID 1002 //
     /*  52039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52068 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3769:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHSUBuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  52068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv4i16),
     /*  52071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52080 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52086 */     GIR_RootConstrainSelectedInstOperands,
     /*  52087 */     // GIR_Coverage, 1002,
     /*  52087 */     GIR_EraseRootFromParent_Done,
     /*  52088 */   // Label 1126: @52088
     /*  52088 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(52142), // Rule ID 1003 //
     /*  52093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52122 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3769:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHSUBuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  52122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv2i32),
     /*  52125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52134 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52140 */     GIR_RootConstrainSelectedInstOperands,
     /*  52141 */     // GIR_Coverage, 1003,
     /*  52141 */     GIR_EraseRootFromParent_Done,
     /*  52142 */   // Label 1127: @52142
     /*  52142 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(52196), // Rule ID 1004 //
     /*  52147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  52158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52176 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3769:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHSUBuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  52176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv8i16),
     /*  52179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52188 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52194 */     GIR_RootConstrainSelectedInstOperands,
     /*  52195 */     // GIR_Coverage, 1004,
     /*  52195 */     GIR_EraseRootFromParent_Done,
     /*  52196 */   // Label 1128: @52196
     /*  52196 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(52250), // Rule ID 1005 //
     /*  52201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52230 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3769:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHSUBuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  52230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv4i32),
     /*  52233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52242 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52248 */     GIR_RootConstrainSelectedInstOperands,
     /*  52249 */     // GIR_Coverage, 1005,
     /*  52249 */     GIR_EraseRootFromParent_Done,
     /*  52250 */   // Label 1129: @52250
     /*  52250 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(52304), // Rule ID 1006 //
     /*  52255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  52266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  52272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52284 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3769:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHSUBuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  52284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv8i8),
     /*  52287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52296 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52302 */     GIR_RootConstrainSelectedInstOperands,
     /*  52303 */     // GIR_Coverage, 1006,
     /*  52303 */     GIR_EraseRootFromParent_Done,
     /*  52304 */   // Label 1130: @52304
     /*  52304 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(52358), // Rule ID 1007 //
     /*  52309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  52320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  52323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  52326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52338 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3769:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHSUBuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  52338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv16i8),
     /*  52341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52350 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52356 */     GIR_RootConstrainSelectedInstOperands,
     /*  52357 */     // GIR_Coverage, 1007,
     /*  52357 */     GIR_EraseRootFromParent_Done,
     /*  52358 */   // Label 1131: @52358
     /*  52358 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(52412), // Rule ID 1024 //
     /*  52363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsubhn),
     /*  52371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  52374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52392 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3838:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRSUBHNv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  52392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSUBHNv8i8),
     /*  52395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52404 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52410 */     GIR_RootConstrainSelectedInstOperands,
     /*  52411 */     // GIR_Coverage, 1024,
     /*  52411 */     GIR_EraseRootFromParent_Done,
     /*  52412 */   // Label 1132: @52412
     /*  52412 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(52466), // Rule ID 1025 //
     /*  52417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsubhn),
     /*  52425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52446 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3838:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRSUBHNv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  52446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSUBHNv4i16),
     /*  52449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52458 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52464 */     GIR_RootConstrainSelectedInstOperands,
     /*  52465 */     // GIR_Coverage, 1025,
     /*  52465 */     GIR_EraseRootFromParent_Done,
     /*  52466 */   // Label 1133: @52466
     /*  52466 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(52520), // Rule ID 1026 //
     /*  52471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsubhn),
     /*  52479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  52485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  52488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52500 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3838:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VRSUBHNv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*  52500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSUBHNv2i32),
     /*  52503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52512 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52518 */     GIR_RootConstrainSelectedInstOperands,
     /*  52519 */     // GIR_Coverage, 1026,
     /*  52519 */     GIR_EraseRootFromParent_Done,
     /*  52520 */   // Label 1134: @52520
     /*  52520 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(52574), // Rule ID 1119 //
     /*  52525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52554 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3744:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VACGEfd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  52554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEfd),
     /*  52557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52566 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52572 */     GIR_RootConstrainSelectedInstOperands,
     /*  52573 */     // GIR_Coverage, 1119,
     /*  52573 */     GIR_EraseRootFromParent_Done,
     /*  52574 */   // Label 1135: @52574
     /*  52574 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(52628), // Rule ID 1120 //
     /*  52579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52608 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3744:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VACGEfq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  52608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEfq),
     /*  52611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52620 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52626 */     GIR_RootConstrainSelectedInstOperands,
     /*  52627 */     // GIR_Coverage, 1120,
     /*  52627 */     GIR_EraseRootFromParent_Done,
     /*  52628 */   // Label 1136: @52628
     /*  52628 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(52682), // Rule ID 1121 //
     /*  52633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52662 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3744:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VACGEhd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  52662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEhd),
     /*  52665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52674 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52680 */     GIR_RootConstrainSelectedInstOperands,
     /*  52681 */     // GIR_Coverage, 1121,
     /*  52681 */     GIR_EraseRootFromParent_Done,
     /*  52682 */   // Label 1137: @52682
     /*  52682 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(52736), // Rule ID 1122 //
     /*  52687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  52698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52716 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3744:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VACGEhq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  52716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEhq),
     /*  52719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52734 */     GIR_RootConstrainSelectedInstOperands,
     /*  52735 */     // GIR_Coverage, 1122,
     /*  52735 */     GIR_EraseRootFromParent_Done,
     /*  52736 */   // Label 1138: @52736
     /*  52736 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(52790), // Rule ID 1123 //
     /*  52741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52770 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3745:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VACGTfd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  52770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGTfd),
     /*  52773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52777 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52782 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52788 */     GIR_RootConstrainSelectedInstOperands,
     /*  52789 */     // GIR_Coverage, 1123,
     /*  52789 */     GIR_EraseRootFromParent_Done,
     /*  52790 */   // Label 1139: @52790
     /*  52790 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(52844), // Rule ID 1124 //
     /*  52795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52824 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3745:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VACGTfq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  52824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGTfq),
     /*  52827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52836 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52842 */     GIR_RootConstrainSelectedInstOperands,
     /*  52843 */     // GIR_Coverage, 1124,
     /*  52843 */     GIR_EraseRootFromParent_Done,
     /*  52844 */   // Label 1140: @52844
     /*  52844 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(52898), // Rule ID 1125 //
     /*  52849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52878 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3745:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VACGThd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  52878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGThd),
     /*  52881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52890 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52896 */     GIR_RootConstrainSelectedInstOperands,
     /*  52897 */     // GIR_Coverage, 1125,
     /*  52897 */     GIR_EraseRootFromParent_Done,
     /*  52898 */   // Label 1141: @52898
     /*  52898 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(52952), // Rule ID 1126 //
     /*  52903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  52914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52932 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3745:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VACGThq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  52932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGThq),
     /*  52935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52944 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52950 */     GIR_RootConstrainSelectedInstOperands,
     /*  52951 */     // GIR_Coverage, 1126,
     /*  52951 */     GIR_EraseRootFromParent_Done,
     /*  52952 */   // Label 1142: @52952
     /*  52952 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(53006), // Rule ID 1169 //
     /*  52957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  52965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52986 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3741:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VABDfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  52986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDfd),
     /*  52989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52998 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53004 */     GIR_RootConstrainSelectedInstOperands,
     /*  53005 */     // GIR_Coverage, 1169,
     /*  53005 */     GIR_EraseRootFromParent_Done,
     /*  53006 */   // Label 1143: @53006
     /*  53006 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(53060), // Rule ID 1170 //
     /*  53011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  53019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  53022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  53025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  53028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53040 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3741:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VABDfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  53040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDfq),
     /*  53043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53052 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53058 */     GIR_RootConstrainSelectedInstOperands,
     /*  53059 */     // GIR_Coverage, 1170,
     /*  53059 */     GIR_EraseRootFromParent_Done,
     /*  53060 */   // Label 1144: @53060
     /*  53060 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(53114), // Rule ID 1171 //
     /*  53065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  53068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  53073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53094 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3741:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VABDhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  53094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDhd),
     /*  53097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53106 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53112 */     GIR_RootConstrainSelectedInstOperands,
     /*  53113 */     // GIR_Coverage, 1171,
     /*  53113 */     GIR_EraseRootFromParent_Done,
     /*  53114 */   // Label 1145: @53114
     /*  53114 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(53168), // Rule ID 1172 //
     /*  53119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  53122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  53127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  53130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  53133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  53136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53148 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3741:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VABDhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  53148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDhq),
     /*  53151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53160 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53166 */     GIR_RootConstrainSelectedInstOperands,
     /*  53167 */     // GIR_Coverage, 1172,
     /*  53167 */     GIR_EraseRootFromParent_Done,
     /*  53168 */   // Label 1146: @53168
     /*  53168 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(53222), // Rule ID 1237 //
     /*  53173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  53184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  53187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  53190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53202 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3795:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADDi8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  53202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDi8),
     /*  53205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53214 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53220 */     GIR_RootConstrainSelectedInstOperands,
     /*  53221 */     // GIR_Coverage, 1237,
     /*  53221 */     GIR_EraseRootFromParent_Done,
     /*  53222 */   // Label 1147: @53222
     /*  53222 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(53276), // Rule ID 1238 //
     /*  53227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53256 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3795:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADDi16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  53256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDi16),
     /*  53259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53268 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53274 */     GIR_RootConstrainSelectedInstOperands,
     /*  53275 */     // GIR_Coverage, 1238,
     /*  53275 */     GIR_EraseRootFromParent_Done,
     /*  53276 */   // Label 1148: @53276
     /*  53276 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(53330), // Rule ID 1239 //
     /*  53281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53310 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3795:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADDi32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  53310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDi32),
     /*  53313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53322 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53328 */     GIR_RootConstrainSelectedInstOperands,
     /*  53329 */     // GIR_Coverage, 1239,
     /*  53329 */     GIR_EraseRootFromParent_Done,
     /*  53330 */   // Label 1149: @53330
     /*  53330 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(53384), // Rule ID 1240 //
     /*  53335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53364 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3795:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VPADDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  53364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDf),
     /*  53367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53376 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53382 */     GIR_RootConstrainSelectedInstOperands,
     /*  53383 */     // GIR_Coverage, 1240,
     /*  53383 */     GIR_EraseRootFromParent_Done,
     /*  53384 */   // Label 1150: @53384
     /*  53384 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(53438), // Rule ID 1241 //
     /*  53389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  53392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53418 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3795:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VPADDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  53418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDh),
     /*  53421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53430 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53436 */     GIR_RootConstrainSelectedInstOperands,
     /*  53437 */     // GIR_Coverage, 1241,
     /*  53437 */     GIR_EraseRootFromParent_Done,
     /*  53438 */   // Label 1151: @53438
     /*  53438 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(53492), // Rule ID 1254 //
     /*  53443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  53460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53472 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3793:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADALsv8i8:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)
     /*  53472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv8i8),
     /*  53475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53477 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53484 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53490 */     GIR_RootConstrainSelectedInstOperands,
     /*  53491 */     // GIR_Coverage, 1254,
     /*  53491 */     GIR_EraseRootFromParent_Done,
     /*  53492 */   // Label 1152: @53492
     /*  53492 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(53546), // Rule ID 1255 //
     /*  53497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53526 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3793:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADALsv4i16:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)
     /*  53526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv4i16),
     /*  53529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53531 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53538 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53544 */     GIR_RootConstrainSelectedInstOperands,
     /*  53545 */     // GIR_Coverage, 1255,
     /*  53545 */     GIR_EraseRootFromParent_Done,
     /*  53546 */   // Label 1153: @53546
     /*  53546 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(53600), // Rule ID 1256 //
     /*  53551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  53562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53580 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3793:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADALsv2i32:{ *:[v1i64] } DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)
     /*  53580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv2i32),
     /*  53583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53585 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53592 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53598 */     GIR_RootConstrainSelectedInstOperands,
     /*  53599 */     // GIR_Coverage, 1256,
     /*  53599 */     GIR_EraseRootFromParent_Done,
     /*  53600 */   // Label 1154: @53600
     /*  53600 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(53654), // Rule ID 1257 //
     /*  53605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  53616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  53619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  53622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53634 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3793:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADALsv16i8:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)
     /*  53634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv16i8),
     /*  53637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53639 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53646 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53652 */     GIR_RootConstrainSelectedInstOperands,
     /*  53653 */     // GIR_Coverage, 1257,
     /*  53653 */     GIR_EraseRootFromParent_Done,
     /*  53654 */   // Label 1155: @53654
     /*  53654 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(53708), // Rule ID 1258 //
     /*  53659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  53670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  53673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  53676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53688 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3793:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADALsv8i16:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)
     /*  53688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv8i16),
     /*  53691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53693 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53700 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53706 */     GIR_RootConstrainSelectedInstOperands,
     /*  53707 */     // GIR_Coverage, 1258,
     /*  53707 */     GIR_EraseRootFromParent_Done,
     /*  53708 */   // Label 1156: @53708
     /*  53708 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(53762), // Rule ID 1259 //
     /*  53713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  53724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  53727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  53730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53742 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3793:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADALsv4i32:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)
     /*  53742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv4i32),
     /*  53745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53747 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53754 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53760 */     GIR_RootConstrainSelectedInstOperands,
     /*  53761 */     // GIR_Coverage, 1259,
     /*  53761 */     GIR_EraseRootFromParent_Done,
     /*  53762 */   // Label 1157: @53762
     /*  53762 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(53816), // Rule ID 1260 //
     /*  53767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  53784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53796 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3794:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADALuv8i8:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)
     /*  53796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv8i8),
     /*  53799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53801 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53808 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53814 */     GIR_RootConstrainSelectedInstOperands,
     /*  53815 */     // GIR_Coverage, 1260,
     /*  53815 */     GIR_EraseRootFromParent_Done,
     /*  53816 */   // Label 1158: @53816
     /*  53816 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(53870), // Rule ID 1261 //
     /*  53821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53850 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3794:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADALuv4i16:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)
     /*  53850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv4i16),
     /*  53853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53855 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53862 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53868 */     GIR_RootConstrainSelectedInstOperands,
     /*  53869 */     // GIR_Coverage, 1261,
     /*  53869 */     GIR_EraseRootFromParent_Done,
     /*  53870 */   // Label 1159: @53870
     /*  53870 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(53924), // Rule ID 1262 //
     /*  53875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  53886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53904 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3794:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADALuv2i32:{ *:[v1i64] } DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)
     /*  53904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv2i32),
     /*  53907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53909 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53916 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53922 */     GIR_RootConstrainSelectedInstOperands,
     /*  53923 */     // GIR_Coverage, 1262,
     /*  53923 */     GIR_EraseRootFromParent_Done,
     /*  53924 */   // Label 1160: @53924
     /*  53924 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(53978), // Rule ID 1263 //
     /*  53929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  53940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  53943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  53946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53958 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3794:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADALuv16i8:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)
     /*  53958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv16i8),
     /*  53961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53963 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53970 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53976 */     GIR_RootConstrainSelectedInstOperands,
     /*  53977 */     // GIR_Coverage, 1263,
     /*  53977 */     GIR_EraseRootFromParent_Done,
     /*  53978 */   // Label 1161: @53978
     /*  53978 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(54032), // Rule ID 1264 //
     /*  53983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  53994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  53997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  54000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54012 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3794:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADALuv8i16:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)
     /*  54012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv8i16),
     /*  54015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54017 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  54019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54024 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54030 */     GIR_RootConstrainSelectedInstOperands,
     /*  54031 */     // GIR_Coverage, 1264,
     /*  54031 */     GIR_EraseRootFromParent_Done,
     /*  54032 */   // Label 1162: @54032
     /*  54032 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(54086), // Rule ID 1265 //
     /*  54037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  54045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  54048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  54051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  54054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54066 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3794:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADALuv4i32:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)
     /*  54066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv4i32),
     /*  54069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54071 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  54073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54078 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54084 */     GIR_RootConstrainSelectedInstOperands,
     /*  54085 */     // GIR_Coverage, 1265,
     /*  54085 */     GIR_EraseRootFromParent_Done,
     /*  54086 */   // Label 1163: @54086
     /*  54086 */   GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(54140), // Rule ID 1266 //
     /*  54091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54120 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3798:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMAXs8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXs8),
     /*  54123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54132 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54138 */     GIR_RootConstrainSelectedInstOperands,
     /*  54139 */     // GIR_Coverage, 1266,
     /*  54139 */     GIR_EraseRootFromParent_Done,
     /*  54140 */   // Label 1164: @54140
     /*  54140 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(54194), // Rule ID 1267 //
     /*  54145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54174 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3798:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMAXs16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXs16),
     /*  54177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54186 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54192 */     GIR_RootConstrainSelectedInstOperands,
     /*  54193 */     // GIR_Coverage, 1267,
     /*  54193 */     GIR_EraseRootFromParent_Done,
     /*  54194 */   // Label 1165: @54194
     /*  54194 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(54248), // Rule ID 1268 //
     /*  54199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54228 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3798:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMAXs32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXs32),
     /*  54231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54240 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54246 */     GIR_RootConstrainSelectedInstOperands,
     /*  54247 */     // GIR_Coverage, 1268,
     /*  54247 */     GIR_EraseRootFromParent_Done,
     /*  54248 */   // Label 1166: @54248
     /*  54248 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(54302), // Rule ID 1269 //
     /*  54253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxu),
     /*  54261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54282 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3799:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMAXu8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXu8),
     /*  54285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54294 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54300 */     GIR_RootConstrainSelectedInstOperands,
     /*  54301 */     // GIR_Coverage, 1269,
     /*  54301 */     GIR_EraseRootFromParent_Done,
     /*  54302 */   // Label 1167: @54302
     /*  54302 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(54356), // Rule ID 1270 //
     /*  54307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxu),
     /*  54315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54336 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3799:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMAXu16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXu16),
     /*  54339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54348 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54354 */     GIR_RootConstrainSelectedInstOperands,
     /*  54355 */     // GIR_Coverage, 1270,
     /*  54355 */     GIR_EraseRootFromParent_Done,
     /*  54356 */   // Label 1168: @54356
     /*  54356 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(54410), // Rule ID 1271 //
     /*  54361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxu),
     /*  54369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54390 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3799:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMAXu32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXu32),
     /*  54393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54402 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54408 */     GIR_RootConstrainSelectedInstOperands,
     /*  54409 */     // GIR_Coverage, 1271,
     /*  54409 */     GIR_EraseRootFromParent_Done,
     /*  54410 */   // Label 1169: @54410
     /*  54410 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(54464), // Rule ID 1272 //
     /*  54415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54444 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3798:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VPMAXf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  54444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXf),
     /*  54447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54462 */     GIR_RootConstrainSelectedInstOperands,
     /*  54463 */     // GIR_Coverage, 1272,
     /*  54463 */     GIR_EraseRootFromParent_Done,
     /*  54464 */   // Label 1170: @54464
     /*  54464 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(54518), // Rule ID 1273 //
     /*  54469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  54472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54498 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3798:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VPMAXh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  54498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXh),
     /*  54501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54510 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54516 */     GIR_RootConstrainSelectedInstOperands,
     /*  54517 */     // GIR_Coverage, 1273,
     /*  54517 */     GIR_EraseRootFromParent_Done,
     /*  54518 */   // Label 1171: @54518
     /*  54518 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(54572), // Rule ID 1274 //
     /*  54523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54552 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3800:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMINs8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINs8),
     /*  54555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54564 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54570 */     GIR_RootConstrainSelectedInstOperands,
     /*  54571 */     // GIR_Coverage, 1274,
     /*  54571 */     GIR_EraseRootFromParent_Done,
     /*  54572 */   // Label 1172: @54572
     /*  54572 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(54626), // Rule ID 1275 //
     /*  54577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54606 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3800:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMINs16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINs16),
     /*  54609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54618 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54624 */     GIR_RootConstrainSelectedInstOperands,
     /*  54625 */     // GIR_Coverage, 1275,
     /*  54625 */     GIR_EraseRootFromParent_Done,
     /*  54626 */   // Label 1173: @54626
     /*  54626 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(54680), // Rule ID 1276 //
     /*  54631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54660 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3800:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMINs32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINs32),
     /*  54663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54672 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54678 */     GIR_RootConstrainSelectedInstOperands,
     /*  54679 */     // GIR_Coverage, 1276,
     /*  54679 */     GIR_EraseRootFromParent_Done,
     /*  54680 */   // Label 1174: @54680
     /*  54680 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(54734), // Rule ID 1277 //
     /*  54685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpminu),
     /*  54693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54714 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3801:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMINu8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINu8),
     /*  54717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54721 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54726 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54732 */     GIR_RootConstrainSelectedInstOperands,
     /*  54733 */     // GIR_Coverage, 1277,
     /*  54733 */     GIR_EraseRootFromParent_Done,
     /*  54734 */   // Label 1175: @54734
     /*  54734 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(54788), // Rule ID 1278 //
     /*  54739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpminu),
     /*  54747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54768 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3801:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMINu16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINu16),
     /*  54771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54780 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54786 */     GIR_RootConstrainSelectedInstOperands,
     /*  54787 */     // GIR_Coverage, 1278,
     /*  54787 */     GIR_EraseRootFromParent_Done,
     /*  54788 */   // Label 1176: @54788
     /*  54788 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(54842), // Rule ID 1279 //
     /*  54793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpminu),
     /*  54801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54822 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3801:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMINu32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINu32),
     /*  54825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54840 */     GIR_RootConstrainSelectedInstOperands,
     /*  54841 */     // GIR_Coverage, 1279,
     /*  54841 */     GIR_EraseRootFromParent_Done,
     /*  54842 */   // Label 1177: @54842
     /*  54842 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(54896), // Rule ID 1280 //
     /*  54847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54876 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3800:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VPMINf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  54876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINf),
     /*  54879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54888 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54894 */     GIR_RootConstrainSelectedInstOperands,
     /*  54895 */     // GIR_Coverage, 1280,
     /*  54895 */     GIR_EraseRootFromParent_Done,
     /*  54896 */   // Label 1178: @54896
     /*  54896 */   GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(54950), // Rule ID 1281 //
     /*  54901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  54904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54930 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3800:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VPMINh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  54930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINh),
     /*  54933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54948 */     GIR_RootConstrainSelectedInstOperands,
     /*  54949 */     // GIR_Coverage, 1281,
     /*  54949 */     GIR_EraseRootFromParent_Done,
     /*  54950 */   // Label 1179: @54950
     /*  54950 */   GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(55004), // Rule ID 1288 //
     /*  54955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  54963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54984 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3825:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VRECPSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  54984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPSfd),
     /*  54987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54996 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55002 */     GIR_RootConstrainSelectedInstOperands,
     /*  55003 */     // GIR_Coverage, 1288,
     /*  55003 */     GIR_EraseRootFromParent_Done,
     /*  55004 */   // Label 1180: @55004
     /*  55004 */   GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(55058), // Rule ID 1289 //
     /*  55009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  55017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  55026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55038 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3825:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VRECPSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  55038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPSfq),
     /*  55041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55050 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55056 */     GIR_RootConstrainSelectedInstOperands,
     /*  55057 */     // GIR_Coverage, 1289,
     /*  55057 */     GIR_EraseRootFromParent_Done,
     /*  55058 */   // Label 1181: @55058
     /*  55058 */   GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(55112), // Rule ID 1290 //
     /*  55063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  55066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  55071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55092 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3825:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VRECPShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  55092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPShd),
     /*  55095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55104 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55110 */     GIR_RootConstrainSelectedInstOperands,
     /*  55111 */     // GIR_Coverage, 1290,
     /*  55111 */     GIR_EraseRootFromParent_Done,
     /*  55112 */   // Label 1182: @55112
     /*  55112 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(55166), // Rule ID 1291 //
     /*  55117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  55120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  55125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55146 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3825:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VRECPShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  55146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPShq),
     /*  55149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55158 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55164 */     GIR_RootConstrainSelectedInstOperands,
     /*  55165 */     // GIR_Coverage, 1291,
     /*  55165 */     GIR_EraseRootFromParent_Done,
     /*  55166 */   // Label 1183: @55166
     /*  55166 */   GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(55220), // Rule ID 1298 //
     /*  55171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  55179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  55182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  55188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55200 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3837:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VRSQRTSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  55200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTSfd),
     /*  55203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55212 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55218 */     GIR_RootConstrainSelectedInstOperands,
     /*  55219 */     // GIR_Coverage, 1298,
     /*  55219 */     GIR_EraseRootFromParent_Done,
     /*  55220 */   // Label 1184: @55220
     /*  55220 */   GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(55274), // Rule ID 1299 //
     /*  55225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  55233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  55242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55254 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3837:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VRSQRTSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  55254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTSfq),
     /*  55257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55266 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55272 */     GIR_RootConstrainSelectedInstOperands,
     /*  55273 */     // GIR_Coverage, 1299,
     /*  55273 */     GIR_EraseRootFromParent_Done,
     /*  55274 */   // Label 1185: @55274
     /*  55274 */   GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(55328), // Rule ID 1300 //
     /*  55279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  55282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  55287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55308 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3837:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VRSQRTShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  55308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTShd),
     /*  55311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55320 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55326 */     GIR_RootConstrainSelectedInstOperands,
     /*  55327 */     // GIR_Coverage, 1300,
     /*  55327 */     GIR_EraseRootFromParent_Done,
     /*  55328 */   // Label 1186: @55328
     /*  55328 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(55382), // Rule ID 1301 //
     /*  55333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  55336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  55341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55362 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3837:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VRSQRTShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  55362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTShq),
     /*  55365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55374 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55380 */     GIR_RootConstrainSelectedInstOperands,
     /*  55381 */     // GIR_Coverage, 1301,
     /*  55381 */     GIR_EraseRootFromParent_Done,
     /*  55382 */   // Label 1187: @55382
     /*  55382 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(55436), // Rule ID 1302 //
     /*  55387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55416 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3840:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  55416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv4i16),
     /*  55419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55428 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55434 */     GIR_RootConstrainSelectedInstOperands,
     /*  55435 */     // GIR_Coverage, 1302,
     /*  55435 */     GIR_EraseRootFromParent_Done,
     /*  55436 */   // Label 1188: @55436
     /*  55436 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(55490), // Rule ID 1303 //
     /*  55441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  55452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  55458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55470 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3840:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  55470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv2i32),
     /*  55473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55482 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55488 */     GIR_RootConstrainSelectedInstOperands,
     /*  55489 */     // GIR_Coverage, 1303,
     /*  55489 */     GIR_EraseRootFromParent_Done,
     /*  55490 */   // Label 1189: @55490
     /*  55490 */   GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(55544), // Rule ID 1304 //
     /*  55495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55524 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3840:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  55524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv8i16),
     /*  55527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55536 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55542 */     GIR_RootConstrainSelectedInstOperands,
     /*  55543 */     // GIR_Coverage, 1304,
     /*  55543 */     GIR_EraseRootFromParent_Done,
     /*  55544 */   // Label 1190: @55544
     /*  55544 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(55598), // Rule ID 1305 //
     /*  55549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  55566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55578 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3840:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  55578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv4i32),
     /*  55581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55590 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55596 */     GIR_RootConstrainSelectedInstOperands,
     /*  55597 */     // GIR_Coverage, 1305,
     /*  55597 */     GIR_EraseRootFromParent_Done,
     /*  55598 */   // Label 1191: @55598
     /*  55598 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(55652), // Rule ID 1306 //
     /*  55603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  55614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  55617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  55620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55632 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3840:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  55632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv8i8),
     /*  55635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55644 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55650 */     GIR_RootConstrainSelectedInstOperands,
     /*  55651 */     // GIR_Coverage, 1306,
     /*  55651 */     GIR_EraseRootFromParent_Done,
     /*  55652 */   // Label 1192: @55652
     /*  55652 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(55706), // Rule ID 1307 //
     /*  55657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  55668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  55671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  55674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55686 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3840:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  55686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv16i8),
     /*  55689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55698 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55704 */     GIR_RootConstrainSelectedInstOperands,
     /*  55705 */     // GIR_Coverage, 1307,
     /*  55705 */     GIR_EraseRootFromParent_Done,
     /*  55706 */   // Label 1193: @55706
     /*  55706 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(55760), // Rule ID 1308 //
     /*  55711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  55722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  55725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  55728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55740 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3840:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  55740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv1i64),
     /*  55743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55752 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55758 */     GIR_RootConstrainSelectedInstOperands,
     /*  55759 */     // GIR_Coverage, 1308,
     /*  55759 */     GIR_EraseRootFromParent_Done,
     /*  55760 */   // Label 1194: @55760
     /*  55760 */   GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(55814), // Rule ID 1309 //
     /*  55765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  55776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  55782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55794 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3840:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  55794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv2i64),
     /*  55797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55806 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55812 */     GIR_RootConstrainSelectedInstOperands,
     /*  55813 */     // GIR_Coverage, 1309,
     /*  55813 */     GIR_EraseRootFromParent_Done,
     /*  55814 */   // Label 1195: @55814
     /*  55814 */   GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(55868), // Rule ID 1310 //
     /*  55819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55848 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3841:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  55848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv4i16),
     /*  55851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55860 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55866 */     GIR_RootConstrainSelectedInstOperands,
     /*  55867 */     // GIR_Coverage, 1310,
     /*  55867 */     GIR_EraseRootFromParent_Done,
     /*  55868 */   // Label 1196: @55868
     /*  55868 */   GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(55922), // Rule ID 1311 //
     /*  55873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  55884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  55890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55902 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3841:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  55902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv2i32),
     /*  55905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55914 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55920 */     GIR_RootConstrainSelectedInstOperands,
     /*  55921 */     // GIR_Coverage, 1311,
     /*  55921 */     GIR_EraseRootFromParent_Done,
     /*  55922 */   // Label 1197: @55922
     /*  55922 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(55976), // Rule ID 1312 //
     /*  55927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55956 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3841:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  55956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv8i16),
     /*  55959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55968 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55974 */     GIR_RootConstrainSelectedInstOperands,
     /*  55975 */     // GIR_Coverage, 1312,
     /*  55975 */     GIR_EraseRootFromParent_Done,
     /*  55976 */   // Label 1198: @55976
     /*  55976 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(56030), // Rule ID 1313 //
     /*  55981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  55998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56010 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3841:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  56010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv4i32),
     /*  56013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56022 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56028 */     GIR_RootConstrainSelectedInstOperands,
     /*  56029 */     // GIR_Coverage, 1313,
     /*  56029 */     GIR_EraseRootFromParent_Done,
     /*  56030 */   // Label 1199: @56030
     /*  56030 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(56084), // Rule ID 1314 //
     /*  56035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  56043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  56046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  56052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56064 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3841:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  56064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv8i8),
     /*  56067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56076 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56082 */     GIR_RootConstrainSelectedInstOperands,
     /*  56083 */     // GIR_Coverage, 1314,
     /*  56083 */     GIR_EraseRootFromParent_Done,
     /*  56084 */   // Label 1200: @56084
     /*  56084 */   GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(56138), // Rule ID 1315 //
     /*  56089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  56097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  56100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  56106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56118 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3841:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  56118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv16i8),
     /*  56121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56130 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56136 */     GIR_RootConstrainSelectedInstOperands,
     /*  56137 */     // GIR_Coverage, 1315,
     /*  56137 */     GIR_EraseRootFromParent_Done,
     /*  56138 */   // Label 1201: @56138
     /*  56138 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(56192), // Rule ID 1316 //
     /*  56143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  56151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  56154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  56157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  56160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56172 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3841:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  56172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv1i64),
     /*  56175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56184 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56190 */     GIR_RootConstrainSelectedInstOperands,
     /*  56191 */     // GIR_Coverage, 1316,
     /*  56191 */     GIR_EraseRootFromParent_Done,
     /*  56192 */   // Label 1202: @56192
     /*  56192 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(56246), // Rule ID 1317 //
     /*  56197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  56205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  56208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  56211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  56214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56226 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3841:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  56226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv2i64),
     /*  56229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56233 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56238 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56244 */     GIR_RootConstrainSelectedInstOperands,
     /*  56245 */     // GIR_Coverage, 1317,
     /*  56245 */     GIR_EraseRootFromParent_Done,
     /*  56246 */   // Label 1203: @56246
     /*  56246 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(56300), // Rule ID 1351 //
     /*  56251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  56262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  56265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  56268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56280 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3834:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VRSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  56280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv4i16),
     /*  56283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56292 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56298 */     GIR_RootConstrainSelectedInstOperands,
     /*  56299 */     // GIR_Coverage, 1351,
     /*  56299 */     GIR_EraseRootFromParent_Done,
     /*  56300 */   // Label 1204: @56300
     /*  56300 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(56354), // Rule ID 1352 //
     /*  56305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  56316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  56322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56334 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3834:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VRSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  56334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv2i32),
     /*  56337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56346 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56352 */     GIR_RootConstrainSelectedInstOperands,
     /*  56353 */     // GIR_Coverage, 1352,
     /*  56353 */     GIR_EraseRootFromParent_Done,
     /*  56354 */   // Label 1205: @56354
     /*  56354 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(56408), // Rule ID 1353 //
     /*  56359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  56370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  56376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56388 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3834:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VRSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  56388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv8i16),
     /*  56391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56400 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56406 */     GIR_RootConstrainSelectedInstOperands,
     /*  56407 */     // GIR_Coverage, 1353,
     /*  56407 */     GIR_EraseRootFromParent_Done,
     /*  56408 */   // Label 1206: @56408
     /*  56408 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(56462), // Rule ID 1354 //
     /*  56413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  56424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  56430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56442 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3834:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VRSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  56442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv4i32),
     /*  56445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56454 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56460 */     GIR_RootConstrainSelectedInstOperands,
     /*  56461 */     // GIR_Coverage, 1354,
     /*  56461 */     GIR_EraseRootFromParent_Done,
     /*  56462 */   // Label 1207: @56462
     /*  56462 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(56516), // Rule ID 1355 //
     /*  56467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  56478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  56484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56496 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3834:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VRSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  56496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv8i8),
     /*  56499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56508 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56514 */     GIR_RootConstrainSelectedInstOperands,
     /*  56515 */     // GIR_Coverage, 1355,
     /*  56515 */     GIR_EraseRootFromParent_Done,
     /*  56516 */   // Label 1208: @56516
     /*  56516 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(56570), // Rule ID 1356 //
     /*  56521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  56532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  56538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56550 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3834:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VRSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  56550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv16i8),
     /*  56553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56562 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56568 */     GIR_RootConstrainSelectedInstOperands,
     /*  56569 */     // GIR_Coverage, 1356,
     /*  56569 */     GIR_EraseRootFromParent_Done,
     /*  56570 */   // Label 1209: @56570
     /*  56570 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(56624), // Rule ID 1357 //
     /*  56575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  56586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  56589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  56592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56604 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3834:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VRSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  56604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv1i64),
     /*  56607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56616 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56622 */     GIR_RootConstrainSelectedInstOperands,
     /*  56623 */     // GIR_Coverage, 1357,
     /*  56623 */     GIR_EraseRootFromParent_Done,
     /*  56624 */   // Label 1210: @56624
     /*  56624 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(56678), // Rule ID 1358 //
     /*  56629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  56640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  56643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  56646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56658 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3834:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VRSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  56658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv2i64),
     /*  56661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56670 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56676 */     GIR_RootConstrainSelectedInstOperands,
     /*  56677 */     // GIR_Coverage, 1358,
     /*  56677 */     GIR_EraseRootFromParent_Done,
     /*  56678 */   // Label 1211: @56678
     /*  56678 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(56732), // Rule ID 1359 //
     /*  56683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  56694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  56697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  56700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56712 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3835:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VRSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  56712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv4i16),
     /*  56715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56724 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56730 */     GIR_RootConstrainSelectedInstOperands,
     /*  56731 */     // GIR_Coverage, 1359,
     /*  56731 */     GIR_EraseRootFromParent_Done,
     /*  56732 */   // Label 1212: @56732
     /*  56732 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(56786), // Rule ID 1360 //
     /*  56737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  56748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  56754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56766 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3835:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VRSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  56766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv2i32),
     /*  56769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56778 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56784 */     GIR_RootConstrainSelectedInstOperands,
     /*  56785 */     // GIR_Coverage, 1360,
     /*  56785 */     GIR_EraseRootFromParent_Done,
     /*  56786 */   // Label 1213: @56786
     /*  56786 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(56840), // Rule ID 1361 //
     /*  56791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  56802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  56808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56820 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3835:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VRSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  56820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv8i16),
     /*  56823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56827 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56832 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56838 */     GIR_RootConstrainSelectedInstOperands,
     /*  56839 */     // GIR_Coverage, 1361,
     /*  56839 */     GIR_EraseRootFromParent_Done,
     /*  56840 */   // Label 1214: @56840
     /*  56840 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(56894), // Rule ID 1362 //
     /*  56845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  56856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  56862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56874 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3835:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VRSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  56874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv4i32),
     /*  56877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56886 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56892 */     GIR_RootConstrainSelectedInstOperands,
     /*  56893 */     // GIR_Coverage, 1362,
     /*  56893 */     GIR_EraseRootFromParent_Done,
     /*  56894 */   // Label 1215: @56894
     /*  56894 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(56948), // Rule ID 1363 //
     /*  56899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  56910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  56916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56928 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3835:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VRSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  56928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv8i8),
     /*  56931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56940 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56946 */     GIR_RootConstrainSelectedInstOperands,
     /*  56947 */     // GIR_Coverage, 1363,
     /*  56947 */     GIR_EraseRootFromParent_Done,
     /*  56948 */   // Label 1216: @56948
     /*  56948 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(57002), // Rule ID 1364 //
     /*  56953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  56964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  56970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56982 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3835:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VRSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  56982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv16i8),
     /*  56985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56994 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57000 */     GIR_RootConstrainSelectedInstOperands,
     /*  57001 */     // GIR_Coverage, 1364,
     /*  57001 */     GIR_EraseRootFromParent_Done,
     /*  57002 */   // Label 1217: @57002
     /*  57002 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(57056), // Rule ID 1365 //
     /*  57007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  57015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  57018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  57024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57036 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3835:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VRSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  57036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv1i64),
     /*  57039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57048 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57054 */     GIR_RootConstrainSelectedInstOperands,
     /*  57055 */     // GIR_Coverage, 1365,
     /*  57055 */     GIR_EraseRootFromParent_Done,
     /*  57056 */   // Label 1218: @57056
     /*  57056 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(57110), // Rule ID 1366 //
     /*  57061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  57069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  57072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  57078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57090 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3835:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VRSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  57090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv2i64),
     /*  57093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57102 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57108 */     GIR_RootConstrainSelectedInstOperands,
     /*  57109 */     // GIR_Coverage, 1366,
     /*  57109 */     GIR_EraseRootFromParent_Done,
     /*  57110 */   // Label 1219: @57110
     /*  57110 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(57164), // Rule ID 1386 //
     /*  57115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  57126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  57132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57144 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3820:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  57144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv4i16),
     /*  57147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57156 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57162 */     GIR_RootConstrainSelectedInstOperands,
     /*  57163 */     // GIR_Coverage, 1386,
     /*  57163 */     GIR_EraseRootFromParent_Done,
     /*  57164 */   // Label 1220: @57164
     /*  57164 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(57218), // Rule ID 1387 //
     /*  57169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  57180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  57183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  57186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57198 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3820:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  57198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv2i32),
     /*  57201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57210 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57216 */     GIR_RootConstrainSelectedInstOperands,
     /*  57217 */     // GIR_Coverage, 1387,
     /*  57217 */     GIR_EraseRootFromParent_Done,
     /*  57218 */   // Label 1221: @57218
     /*  57218 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(57272), // Rule ID 1388 //
     /*  57223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  57234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  57240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57252 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3820:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  57252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv8i16),
     /*  57255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57264 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57270 */     GIR_RootConstrainSelectedInstOperands,
     /*  57271 */     // GIR_Coverage, 1388,
     /*  57271 */     GIR_EraseRootFromParent_Done,
     /*  57272 */   // Label 1222: @57272
     /*  57272 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(57326), // Rule ID 1389 //
     /*  57277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  57288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  57294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57306 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3820:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  57306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv4i32),
     /*  57309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57318 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57324 */     GIR_RootConstrainSelectedInstOperands,
     /*  57325 */     // GIR_Coverage, 1389,
     /*  57325 */     GIR_EraseRootFromParent_Done,
     /*  57326 */   // Label 1223: @57326
     /*  57326 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(57380), // Rule ID 1390 //
     /*  57331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  57342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  57348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57360 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3820:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  57360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv8i8),
     /*  57363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57372 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57378 */     GIR_RootConstrainSelectedInstOperands,
     /*  57379 */     // GIR_Coverage, 1390,
     /*  57379 */     GIR_EraseRootFromParent_Done,
     /*  57380 */   // Label 1224: @57380
     /*  57380 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(57434), // Rule ID 1391 //
     /*  57385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  57396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  57402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57414 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3820:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  57414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv16i8),
     /*  57417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57426 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57432 */     GIR_RootConstrainSelectedInstOperands,
     /*  57433 */     // GIR_Coverage, 1391,
     /*  57433 */     GIR_EraseRootFromParent_Done,
     /*  57434 */   // Label 1225: @57434
     /*  57434 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(57488), // Rule ID 1392 //
     /*  57439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  57450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  57456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57468 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3820:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  57468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv1i64),
     /*  57471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57480 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57486 */     GIR_RootConstrainSelectedInstOperands,
     /*  57487 */     // GIR_Coverage, 1392,
     /*  57487 */     GIR_EraseRootFromParent_Done,
     /*  57488 */   // Label 1226: @57488
     /*  57488 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(57542), // Rule ID 1393 //
     /*  57493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  57504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  57510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57522 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3820:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  57522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv2i64),
     /*  57525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57534 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57540 */     GIR_RootConstrainSelectedInstOperands,
     /*  57541 */     // GIR_Coverage, 1393,
     /*  57541 */     GIR_EraseRootFromParent_Done,
     /*  57542 */   // Label 1227: @57542
     /*  57542 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(57596), // Rule ID 1394 //
     /*  57547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  57558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  57564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57576 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3822:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  57576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv4i16),
     /*  57579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57588 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57594 */     GIR_RootConstrainSelectedInstOperands,
     /*  57595 */     // GIR_Coverage, 1394,
     /*  57595 */     GIR_EraseRootFromParent_Done,
     /*  57596 */   // Label 1228: @57596
     /*  57596 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(57650), // Rule ID 1395 //
     /*  57601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  57612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  57615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  57618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57630 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3822:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  57630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv2i32),
     /*  57633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57642 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57648 */     GIR_RootConstrainSelectedInstOperands,
     /*  57649 */     // GIR_Coverage, 1395,
     /*  57649 */     GIR_EraseRootFromParent_Done,
     /*  57650 */   // Label 1229: @57650
     /*  57650 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(57704), // Rule ID 1396 //
     /*  57655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  57666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  57672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57684 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3822:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  57684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv8i16),
     /*  57687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57696 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57702 */     GIR_RootConstrainSelectedInstOperands,
     /*  57703 */     // GIR_Coverage, 1396,
     /*  57703 */     GIR_EraseRootFromParent_Done,
     /*  57704 */   // Label 1230: @57704
     /*  57704 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(57758), // Rule ID 1397 //
     /*  57709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  57720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  57726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57738 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3822:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  57738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv4i32),
     /*  57741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57750 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57756 */     GIR_RootConstrainSelectedInstOperands,
     /*  57757 */     // GIR_Coverage, 1397,
     /*  57757 */     GIR_EraseRootFromParent_Done,
     /*  57758 */   // Label 1231: @57758
     /*  57758 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(57812), // Rule ID 1398 //
     /*  57763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  57774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  57780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57792 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3822:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  57792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv8i8),
     /*  57795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57804 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57810 */     GIR_RootConstrainSelectedInstOperands,
     /*  57811 */     // GIR_Coverage, 1398,
     /*  57811 */     GIR_EraseRootFromParent_Done,
     /*  57812 */   // Label 1232: @57812
     /*  57812 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(57866), // Rule ID 1399 //
     /*  57817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  57828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  57834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57846 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3822:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  57846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv16i8),
     /*  57849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57858 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57864 */     GIR_RootConstrainSelectedInstOperands,
     /*  57865 */     // GIR_Coverage, 1399,
     /*  57865 */     GIR_EraseRootFromParent_Done,
     /*  57866 */   // Label 1233: @57866
     /*  57866 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(57920), // Rule ID 1400 //
     /*  57871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  57882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  57888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57900 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3822:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  57900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv1i64),
     /*  57903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57912 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57918 */     GIR_RootConstrainSelectedInstOperands,
     /*  57919 */     // GIR_Coverage, 1400,
     /*  57919 */     GIR_EraseRootFromParent_Done,
     /*  57920 */   // Label 1234: @57920
     /*  57920 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(57974), // Rule ID 1401 //
     /*  57925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  57936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  57942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57954 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3822:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  57954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv2i64),
     /*  57957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57966 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57972 */     GIR_RootConstrainSelectedInstOperands,
     /*  57973 */     // GIR_Coverage, 1401,
     /*  57973 */     GIR_EraseRootFromParent_Done,
     /*  57974 */   // Label 1235: @57974
     /*  57974 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(58028), // Rule ID 1435 //
     /*  57979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  57987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  57990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  57996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58008 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3815:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQRSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  58008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv4i16),
     /*  58011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58020 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58026 */     GIR_RootConstrainSelectedInstOperands,
     /*  58027 */     // GIR_Coverage, 1435,
     /*  58027 */     GIR_EraseRootFromParent_Done,
     /*  58028 */   // Label 1236: @58028
     /*  58028 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(58082), // Rule ID 1436 //
     /*  58033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  58044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  58047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  58050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58062 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3815:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQRSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  58062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv2i32),
     /*  58065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58074 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58080 */     GIR_RootConstrainSelectedInstOperands,
     /*  58081 */     // GIR_Coverage, 1436,
     /*  58081 */     GIR_EraseRootFromParent_Done,
     /*  58082 */   // Label 1237: @58082
     /*  58082 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(58136), // Rule ID 1437 //
     /*  58087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  58098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  58101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  58104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58116 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3815:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQRSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  58116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv8i16),
     /*  58119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58128 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58134 */     GIR_RootConstrainSelectedInstOperands,
     /*  58135 */     // GIR_Coverage, 1437,
     /*  58135 */     GIR_EraseRootFromParent_Done,
     /*  58136 */   // Label 1238: @58136
     /*  58136 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(58190), // Rule ID 1438 //
     /*  58141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  58152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  58155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  58158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58170 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3815:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQRSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  58170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv4i32),
     /*  58173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58182 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58188 */     GIR_RootConstrainSelectedInstOperands,
     /*  58189 */     // GIR_Coverage, 1438,
     /*  58189 */     GIR_EraseRootFromParent_Done,
     /*  58190 */   // Label 1239: @58190
     /*  58190 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(58244), // Rule ID 1439 //
     /*  58195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  58206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  58209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  58212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58224 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3815:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQRSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  58224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv8i8),
     /*  58227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58236 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58242 */     GIR_RootConstrainSelectedInstOperands,
     /*  58243 */     // GIR_Coverage, 1439,
     /*  58243 */     GIR_EraseRootFromParent_Done,
     /*  58244 */   // Label 1240: @58244
     /*  58244 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(58298), // Rule ID 1440 //
     /*  58249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58278 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3815:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQRSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  58278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv16i8),
     /*  58281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58290 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58296 */     GIR_RootConstrainSelectedInstOperands,
     /*  58297 */     // GIR_Coverage, 1440,
     /*  58297 */     GIR_EraseRootFromParent_Done,
     /*  58298 */   // Label 1241: @58298
     /*  58298 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(58352), // Rule ID 1441 //
     /*  58303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  58314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  58317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  58320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58332 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3815:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQRSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  58332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv1i64),
     /*  58335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58344 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58350 */     GIR_RootConstrainSelectedInstOperands,
     /*  58351 */     // GIR_Coverage, 1441,
     /*  58351 */     GIR_EraseRootFromParent_Done,
     /*  58352 */   // Label 1242: @58352
     /*  58352 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(58406), // Rule ID 1442 //
     /*  58357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  58368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  58371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  58374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58386 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3815:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQRSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  58386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv2i64),
     /*  58389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58398 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58404 */     GIR_RootConstrainSelectedInstOperands,
     /*  58405 */     // GIR_Coverage, 1442,
     /*  58405 */     GIR_EraseRootFromParent_Done,
     /*  58406 */   // Label 1243: @58406
     /*  58406 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(58460), // Rule ID 1443 //
     /*  58411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  58422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  58425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  58428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58440 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3816:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQRSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  58440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv4i16),
     /*  58443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58452 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58458 */     GIR_RootConstrainSelectedInstOperands,
     /*  58459 */     // GIR_Coverage, 1443,
     /*  58459 */     GIR_EraseRootFromParent_Done,
     /*  58460 */   // Label 1244: @58460
     /*  58460 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(58514), // Rule ID 1444 //
     /*  58465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  58476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  58479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  58482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58494 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3816:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQRSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  58494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv2i32),
     /*  58497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58506 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58512 */     GIR_RootConstrainSelectedInstOperands,
     /*  58513 */     // GIR_Coverage, 1444,
     /*  58513 */     GIR_EraseRootFromParent_Done,
     /*  58514 */   // Label 1245: @58514
     /*  58514 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(58568), // Rule ID 1445 //
     /*  58519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  58530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  58533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  58536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58548 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3816:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQRSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  58548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv8i16),
     /*  58551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58560 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58566 */     GIR_RootConstrainSelectedInstOperands,
     /*  58567 */     // GIR_Coverage, 1445,
     /*  58567 */     GIR_EraseRootFromParent_Done,
     /*  58568 */   // Label 1246: @58568
     /*  58568 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(58622), // Rule ID 1446 //
     /*  58573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  58584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  58587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  58590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58602 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3816:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQRSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  58602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv4i32),
     /*  58605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58614 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58620 */     GIR_RootConstrainSelectedInstOperands,
     /*  58621 */     // GIR_Coverage, 1446,
     /*  58621 */     GIR_EraseRootFromParent_Done,
     /*  58622 */   // Label 1247: @58622
     /*  58622 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(58676), // Rule ID 1447 //
     /*  58627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  58638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  58641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  58644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58656 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3816:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQRSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  58656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv8i8),
     /*  58659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58668 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58674 */     GIR_RootConstrainSelectedInstOperands,
     /*  58675 */     // GIR_Coverage, 1447,
     /*  58675 */     GIR_EraseRootFromParent_Done,
     /*  58676 */   // Label 1248: @58676
     /*  58676 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(58730), // Rule ID 1448 //
     /*  58681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58710 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3816:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQRSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  58710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv16i8),
     /*  58713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58728 */     GIR_RootConstrainSelectedInstOperands,
     /*  58729 */     // GIR_Coverage, 1448,
     /*  58729 */     GIR_EraseRootFromParent_Done,
     /*  58730 */   // Label 1249: @58730
     /*  58730 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(58784), // Rule ID 1449 //
     /*  58735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  58746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  58749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  58752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58764 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3816:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQRSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  58764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv1i64),
     /*  58767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58776 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58782 */     GIR_RootConstrainSelectedInstOperands,
     /*  58783 */     // GIR_Coverage, 1449,
     /*  58783 */     GIR_EraseRootFromParent_Done,
     /*  58784 */   // Label 1250: @58784
     /*  58784 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(58838), // Rule ID 1450 //
     /*  58789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  58800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  58803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  58806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58818 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3816:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQRSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  58818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv2i64),
     /*  58821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58830 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58836 */     GIR_RootConstrainSelectedInstOperands,
     /*  58837 */     // GIR_Coverage, 1450,
     /*  58837 */     GIR_EraseRootFromParent_Done,
     /*  58838 */   // Label 1251: @58838
     /*  58838 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(58883), // Rule ID 1715 //
     /*  58843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  58846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aesd),
     /*  58851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58872 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3717:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)  =>  (AESD:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)
     /*  58872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESD),
     /*  58875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58877 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  58879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  58881 */     GIR_RootConstrainSelectedInstOperands,
     /*  58882 */     // GIR_Coverage, 1715,
     /*  58882 */     GIR_EraseRootFromParent_Done,
     /*  58883 */   // Label 1252: @58883
     /*  58883 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(58928), // Rule ID 1716 //
     /*  58888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  58891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aese),
     /*  58896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58917 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3718:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)  =>  (AESE:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)
     /*  58917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESE),
     /*  58920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58922 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  58924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  58926 */     GIR_RootConstrainSelectedInstOperands,
     /*  58927 */     // GIR_Coverage, 1716,
     /*  58927 */     GIR_EraseRootFromParent_Done,
     /*  58928 */   // Label 1253: @58928
     /*  58928 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(58973), // Rule ID 1719 //
     /*  58933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  58936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1su1),
     /*  58941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  58944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  58947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  58950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58962 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3731:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA1SU1:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)
     /*  58962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1SU1),
     /*  58965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58967 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  58969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  58971 */     GIR_RootConstrainSelectedInstOperands,
     /*  58972 */     // GIR_Coverage, 1719,
     /*  58972 */     GIR_EraseRootFromParent_Done,
     /*  58973 */   // Label 1254: @58973
     /*  58973 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(59018), // Rule ID 1720 //
     /*  58978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  58981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256su0),
     /*  58986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  58989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  58992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  58995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59007 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3734:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256SU0:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)
     /*  59007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256SU0),
     /*  59010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  59012 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  59014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  59016 */     GIR_RootConstrainSelectedInstOperands,
     /*  59017 */     // GIR_Coverage, 1720,
     /*  59017 */     GIR_EraseRootFromParent_Done,
     /*  59018 */   // Label 1255: @59018
     /*  59018 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(59072), // Rule ID 1729 //
     /*  59023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  59026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_sqrshr),
     /*  59031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59052 */     // (intrinsic_wo_chain:{ *:[i32] } 3580:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_SQRSHR:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)
     /*  59052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_SQRSHR),
     /*  59055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  59057 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  59059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59064 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59070 */     GIR_RootConstrainSelectedInstOperands,
     /*  59071 */     // GIR_Coverage, 1729,
     /*  59071 */     GIR_EraseRootFromParent_Done,
     /*  59072 */   // Label 1256: @59072
     /*  59072 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(59126), // Rule ID 1730 //
     /*  59077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  59080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_uqrshl),
     /*  59085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59106 */     // (intrinsic_wo_chain:{ *:[i32] } 3587:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_UQRSHL:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)
     /*  59106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_UQRSHL),
     /*  59109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  59111 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  59113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59118 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59124 */     GIR_RootConstrainSelectedInstOperands,
     /*  59125 */     // GIR_Coverage, 1730,
     /*  59125 */     GIR_EraseRootFromParent_Done,
     /*  59126 */   // Label 1257: @59126
     /*  59126 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(59183), // Rule ID 1853 //
     /*  59131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtab16),
     /*  59139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59160 */     // (intrinsic_wo_chain:{ *:[i32] } 3917:{ *:[iPTR] }, GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS)  =>  (SXTAB16:{ *:[i32] } GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS, 0:{ *:[i32] })
     /*  59160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAB16),
     /*  59163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59165 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  59167 */     GIR_RootToRootCopy, /*OpIdx*/3, // RHS
     /*  59169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  59172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59175 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59181 */     GIR_RootConstrainSelectedInstOperands,
     /*  59182 */     // GIR_Coverage, 1853,
     /*  59182 */     GIR_EraseRootFromParent_Done,
     /*  59183 */   // Label 1258: @59183
     /*  59183 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(59240), // Rule ID 1860 //
     /*  59188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtab16),
     /*  59196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59217 */     // (intrinsic_wo_chain:{ *:[i32] } 3942:{ *:[iPTR] }, GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS)  =>  (UXTAB16:{ *:[i32] } GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS, 0:{ *:[i32] })
     /*  59217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAB16),
     /*  59220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59222 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  59224 */     GIR_RootToRootCopy, /*OpIdx*/3, // RHS
     /*  59226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  59229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59232 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59238 */     GIR_RootConstrainSelectedInstOperands,
     /*  59239 */     // GIR_Coverage, 1860,
     /*  59239 */     GIR_EraseRootFromParent_Done,
     /*  59240 */   // Label 1259: @59240
     /*  59240 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(59294), // Rule ID 1907 //
     /*  59245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuad),
     /*  59253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59274 */     // (intrinsic_wo_chain:{ *:[i32] } 3893:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUAD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUAD),
     /*  59277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59286 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59292 */     GIR_RootConstrainSelectedInstOperands,
     /*  59293 */     // GIR_Coverage, 1907,
     /*  59293 */     GIR_EraseRootFromParent_Done,
     /*  59294 */   // Label 1260: @59294
     /*  59294 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(59348), // Rule ID 1908 //
     /*  59299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuadx),
     /*  59307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59328 */     // (intrinsic_wo_chain:{ *:[i32] } 3894:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUADX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUADX),
     /*  59331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59340 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59346 */     GIR_RootConstrainSelectedInstOperands,
     /*  59347 */     // GIR_Coverage, 1908,
     /*  59347 */     GIR_EraseRootFromParent_Done,
     /*  59348 */   // Label 1261: @59348
     /*  59348 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(59402), // Rule ID 1909 //
     /*  59353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusd),
     /*  59361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59382 */     // (intrinsic_wo_chain:{ *:[i32] } 3901:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUSD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUSD),
     /*  59385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59394 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59400 */     GIR_RootConstrainSelectedInstOperands,
     /*  59401 */     // GIR_Coverage, 1909,
     /*  59401 */     GIR_EraseRootFromParent_Done,
     /*  59402 */   // Label 1262: @59402
     /*  59402 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(59456), // Rule ID 1910 //
     /*  59407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusdx),
     /*  59415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59436 */     // (intrinsic_wo_chain:{ *:[i32] } 3902:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUSDX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUSDX),
     /*  59439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59448 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59454 */     GIR_RootConstrainSelectedInstOperands,
     /*  59455 */     // GIR_Coverage, 1910,
     /*  59455 */     GIR_EraseRootFromParent_Done,
     /*  59456 */   // Label 1263: @59456
     /*  59456 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(59510), // Rule ID 1984 //
     /*  59461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbb),
     /*  59469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59490 */     // (intrinsic_wo_chain:{ *:[i32] } 3895:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULBB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBB),
     /*  59493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59495 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59497 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59502 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59508 */     GIR_RootConstrainSelectedInstOperands,
     /*  59509 */     // GIR_Coverage, 1984,
     /*  59509 */     GIR_EraseRootFromParent_Done,
     /*  59510 */   // Label 1264: @59510
     /*  59510 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(59564), // Rule ID 1985 //
     /*  59515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbt),
     /*  59523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59544 */     // (intrinsic_wo_chain:{ *:[i32] } 3896:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULBT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBT),
     /*  59547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59549 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59551 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59556 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59562 */     GIR_RootConstrainSelectedInstOperands,
     /*  59563 */     // GIR_Coverage, 1985,
     /*  59563 */     GIR_EraseRootFromParent_Done,
     /*  59564 */   // Label 1265: @59564
     /*  59564 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(59618), // Rule ID 1986 //
     /*  59569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultb),
     /*  59577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59598 */     // (intrinsic_wo_chain:{ *:[i32] } 3897:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULTB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTB),
     /*  59601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59603 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59605 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59610 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59616 */     GIR_RootConstrainSelectedInstOperands,
     /*  59617 */     // GIR_Coverage, 1986,
     /*  59617 */     GIR_EraseRootFromParent_Done,
     /*  59618 */   // Label 1266: @59618
     /*  59618 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(59672), // Rule ID 1987 //
     /*  59623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultt),
     /*  59631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59652 */     // (intrinsic_wo_chain:{ *:[i32] } 3898:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULTT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTT),
     /*  59655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59657 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59659 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59664 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59670 */     GIR_RootConstrainSelectedInstOperands,
     /*  59671 */     // GIR_Coverage, 1987,
     /*  59671 */     GIR_EraseRootFromParent_Done,
     /*  59672 */   // Label 1267: @59672
     /*  59672 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(59726), // Rule ID 1988 //
     /*  59677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwb),
     /*  59685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59706 */     // (intrinsic_wo_chain:{ *:[i32] } 3899:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULWB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULWB),
     /*  59709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59711 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59713 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59718 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59724 */     GIR_RootConstrainSelectedInstOperands,
     /*  59725 */     // GIR_Coverage, 1988,
     /*  59725 */     GIR_EraseRootFromParent_Done,
     /*  59726 */   // Label 1268: @59726
     /*  59726 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(59780), // Rule ID 1989 //
     /*  59731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwt),
     /*  59739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59760 */     // (intrinsic_wo_chain:{ *:[i32] } 3900:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULWT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULWT),
     /*  59763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59765 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59767 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59772 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59778 */     GIR_RootConstrainSelectedInstOperands,
     /*  59779 */     // GIR_Coverage, 1989,
     /*  59779 */     GIR_EraseRootFromParent_Done,
     /*  59780 */   // Label 1269: @59780
     /*  59780 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(59837), // Rule ID 2100 //
     /*  59785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtab16),
     /*  59793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59814 */     // (intrinsic_wo_chain:{ *:[i32] } 3917:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SXTAB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  59814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAB16),
     /*  59817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  59826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59829 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59835 */     GIR_RootConstrainSelectedInstOperands,
     /*  59836 */     // GIR_Coverage, 2100,
     /*  59836 */     GIR_EraseRootFromParent_Done,
     /*  59837 */   // Label 1270: @59837
     /*  59837 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(59891), // Rule ID 2130 //
     /*  59842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  59850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59871 */     // (intrinsic_wo_chain:{ *:[i32] } 3860:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  59871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD),
     /*  59874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  59878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  59880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59883 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59889 */     GIR_RootConstrainSelectedInstOperands,
     /*  59890 */     // GIR_Coverage, 2130,
     /*  59890 */     GIR_EraseRootFromParent_Done,
     /*  59891 */   // Label 1271: @59891
     /*  59891 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(59945), // Rule ID 2131 //
     /*  59896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  59904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59925 */     // (intrinsic_wo_chain:{ *:[i32] } 3865:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  59925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB),
     /*  59928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  59932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  59934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59937 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59943 */     GIR_RootConstrainSelectedInstOperands,
     /*  59944 */     // GIR_Coverage, 2131,
     /*  59944 */     GIR_EraseRootFromParent_Done,
     /*  59945 */   // Label 1272: @59945
     /*  59945 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(59999), // Rule ID 2171 //
     /*  59950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbb),
     /*  59958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59979 */     // (intrinsic_wo_chain:{ *:[i32] } 3895:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULBB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  59979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBB),
     /*  59982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59991 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59997 */     GIR_RootConstrainSelectedInstOperands,
     /*  59998 */     // GIR_Coverage, 2171,
     /*  59998 */     GIR_EraseRootFromParent_Done,
     /*  59999 */   // Label 1273: @59999
     /*  59999 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(60053), // Rule ID 2172 //
     /*  60004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbt),
     /*  60012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60033 */     // (intrinsic_wo_chain:{ *:[i32] } 3896:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBT),
     /*  60036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60045 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60051 */     GIR_RootConstrainSelectedInstOperands,
     /*  60052 */     // GIR_Coverage, 2172,
     /*  60052 */     GIR_EraseRootFromParent_Done,
     /*  60053 */   // Label 1274: @60053
     /*  60053 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(60107), // Rule ID 2173 //
     /*  60058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultb),
     /*  60066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60087 */     // (intrinsic_wo_chain:{ *:[i32] } 3897:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTB),
     /*  60090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60099 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60105 */     GIR_RootConstrainSelectedInstOperands,
     /*  60106 */     // GIR_Coverage, 2173,
     /*  60106 */     GIR_EraseRootFromParent_Done,
     /*  60107 */   // Label 1275: @60107
     /*  60107 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(60161), // Rule ID 2174 //
     /*  60112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultt),
     /*  60120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60141 */     // (intrinsic_wo_chain:{ *:[i32] } 3898:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULTT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTT),
     /*  60144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60153 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60159 */     GIR_RootConstrainSelectedInstOperands,
     /*  60160 */     // GIR_Coverage, 2174,
     /*  60160 */     GIR_EraseRootFromParent_Done,
     /*  60161 */   // Label 1276: @60161
     /*  60161 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(60215), // Rule ID 2175 //
     /*  60166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwb),
     /*  60174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60195 */     // (intrinsic_wo_chain:{ *:[i32] } 3899:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULWB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULWB),
     /*  60198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60207 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60213 */     GIR_RootConstrainSelectedInstOperands,
     /*  60214 */     // GIR_Coverage, 2175,
     /*  60214 */     GIR_EraseRootFromParent_Done,
     /*  60215 */   // Label 1277: @60215
     /*  60215 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(60269), // Rule ID 2176 //
     /*  60220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwt),
     /*  60228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60249 */     // (intrinsic_wo_chain:{ *:[i32] } 3900:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULWT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULWT),
     /*  60252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60261 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60267 */     GIR_RootConstrainSelectedInstOperands,
     /*  60268 */     // GIR_Coverage, 2176,
     /*  60268 */     GIR_EraseRootFromParent_Done,
     /*  60269 */   // Label 1278: @60269
     /*  60269 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(60317), // Rule ID 2513 //
     /*  60274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  60285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  60288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  60291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60303 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3748:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm)  =>  (VCADDv4f16:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /*  60303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f16),
     /*  60306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60315 */     GIR_RootConstrainSelectedInstOperands,
     /*  60316 */     // GIR_Coverage, 2513,
     /*  60316 */     GIR_EraseRootFromParent_Done,
     /*  60317 */   // Label 1279: @60317
     /*  60317 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(60365), // Rule ID 2514 //
     /*  60322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  60333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  60336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  60339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60351 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3747:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm)  =>  (VCADDv4f16:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /*  60351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f16),
     /*  60354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60363 */     GIR_RootConstrainSelectedInstOperands,
     /*  60364 */     // GIR_Coverage, 2514,
     /*  60364 */     GIR_EraseRootFromParent_Done,
     /*  60365 */   // Label 1280: @60365
     /*  60365 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(60413), // Rule ID 2515 //
     /*  60370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  60381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  60384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60399 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3748:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm)  =>  (VCADDv8f16:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /*  60399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv8f16),
     /*  60402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60411 */     GIR_RootConstrainSelectedInstOperands,
     /*  60412 */     // GIR_Coverage, 2515,
     /*  60412 */     GIR_EraseRootFromParent_Done,
     /*  60413 */   // Label 1281: @60413
     /*  60413 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(60461), // Rule ID 2516 //
     /*  60418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  60429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  60432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60447 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3747:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm)  =>  (VCADDv8f16:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /*  60447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv8f16),
     /*  60450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60459 */     GIR_RootConstrainSelectedInstOperands,
     /*  60460 */     // GIR_Coverage, 2516,
     /*  60460 */     GIR_EraseRootFromParent_Done,
     /*  60461 */   // Label 1282: @60461
     /*  60461 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(60509), // Rule ID 2517 //
     /*  60466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  60477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  60483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60495 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3748:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm)  =>  (VCADDv2f32:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /*  60495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv2f32),
     /*  60498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60507 */     GIR_RootConstrainSelectedInstOperands,
     /*  60508 */     // GIR_Coverage, 2517,
     /*  60508 */     GIR_EraseRootFromParent_Done,
     /*  60509 */   // Label 1283: @60509
     /*  60509 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(60557), // Rule ID 2518 //
     /*  60514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  60525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  60531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60543 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3747:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm)  =>  (VCADDv2f32:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /*  60543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv2f32),
     /*  60546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60555 */     GIR_RootConstrainSelectedInstOperands,
     /*  60556 */     // GIR_Coverage, 2518,
     /*  60556 */     GIR_EraseRootFromParent_Done,
     /*  60557 */   // Label 1284: @60557
     /*  60557 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(60605), // Rule ID 2519 //
     /*  60562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  60573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  60576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60591 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3748:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm)  =>  (VCADDv4f32:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /*  60591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f32),
     /*  60594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60603 */     GIR_RootConstrainSelectedInstOperands,
     /*  60604 */     // GIR_Coverage, 2519,
     /*  60604 */     GIR_EraseRootFromParent_Done,
     /*  60605 */   // Label 1285: @60605
     /*  60605 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(60653), // Rule ID 2520 //
     /*  60610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  60621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  60624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60639 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3747:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm)  =>  (VCADDv4f32:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /*  60639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f32),
     /*  60642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60651 */     GIR_RootConstrainSelectedInstOperands,
     /*  60652 */     // GIR_Coverage, 2520,
     /*  60652 */     GIR_EraseRootFromParent_Done,
     /*  60653 */   // Label 1286: @60653
     /*  60653 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(60758), // Rule ID 3105 //
     /*  60658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmv),
     /*  60666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60687 */     // (intrinsic_wo_chain:{ *:[f32] } 3556:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMINNMVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  60687 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60690 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60694 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60699 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60703 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMVf32),
     /*  60715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60720 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60723 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60727 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60730 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60736 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60752 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  60757 */     // GIR_Coverage, 3105,
     /*  60757 */     GIR_EraseRootFromParent_Done,
     /*  60758 */   // Label 1287: @60758
     /*  60758 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(60863), // Rule ID 3107 //
     /*  60763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmv),
     /*  60771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  60774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  60777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60792 */     // (intrinsic_wo_chain:{ *:[f16] } 3556:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMINNMVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  60792 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60795 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60799 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60804 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60808 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMVf16),
     /*  60820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60825 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60828 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60832 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60835 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60841 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60857 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  60862 */     // GIR_Coverage, 3107,
     /*  60862 */     GIR_EraseRootFromParent_Done,
     /*  60863 */   // Label 1288: @60863
     /*  60863 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(60968), // Rule ID 3109 //
     /*  60868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmv),
     /*  60876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60897 */     // (intrinsic_wo_chain:{ *:[f32] } 3547:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMAXNMVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  60897 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60900 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60904 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60909 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60913 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMVf32),
     /*  60925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60930 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60933 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60937 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60940 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60946 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60962 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  60967 */     // GIR_Coverage, 3109,
     /*  60967 */     GIR_EraseRootFromParent_Done,
     /*  60968 */   // Label 1289: @60968
     /*  60968 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(61073), // Rule ID 3111 //
     /*  60973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmv),
     /*  60981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  60984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  60987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61002 */     // (intrinsic_wo_chain:{ *:[f16] } 3547:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMAXNMVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  61002 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61005 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61009 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61014 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61018 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMVf16),
     /*  61030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61035 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61038 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61042 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61045 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61051 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61067 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  61072 */     // GIR_Coverage, 3111,
     /*  61072 */     GIR_EraseRootFromParent_Done,
     /*  61073 */   // Label 1290: @61073
     /*  61073 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(61178), // Rule ID 3113 //
     /*  61078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmav),
     /*  61086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61107 */     // (intrinsic_wo_chain:{ *:[f32] } 3554:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMINNMAVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  61107 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61110 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61114 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61119 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61123 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAVf32),
     /*  61135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61140 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61143 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61147 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61150 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61156 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61172 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  61177 */     // GIR_Coverage, 3113,
     /*  61177 */     GIR_EraseRootFromParent_Done,
     /*  61178 */   // Label 1291: @61178
     /*  61178 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(61283), // Rule ID 3115 //
     /*  61183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmav),
     /*  61191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  61194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  61197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61212 */     // (intrinsic_wo_chain:{ *:[f16] } 3554:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMINNMAVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  61212 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61215 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61219 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61224 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61228 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAVf16),
     /*  61240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61245 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61248 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61252 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61255 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61261 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61277 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  61282 */     // GIR_Coverage, 3115,
     /*  61282 */     GIR_EraseRootFromParent_Done,
     /*  61283 */   // Label 1292: @61283
     /*  61283 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(61388), // Rule ID 3117 //
     /*  61288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmav),
     /*  61296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61317 */     // (intrinsic_wo_chain:{ *:[f32] } 3545:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMAXNMAVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  61317 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61320 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61324 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61329 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61333 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAVf32),
     /*  61345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61350 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61353 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61357 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61360 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61366 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61382 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  61387 */     // GIR_Coverage, 3117,
     /*  61387 */     GIR_EraseRootFromParent_Done,
     /*  61388 */   // Label 1293: @61388
     /*  61388 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(61493), // Rule ID 3119 //
     /*  61393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmav),
     /*  61401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  61404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  61407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61422 */     // (intrinsic_wo_chain:{ *:[f16] } 3545:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMAXNMAVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  61422 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61425 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61429 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61434 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61438 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAVf16),
     /*  61450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61455 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61458 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61462 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61465 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61471 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61487 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  61492 */     // GIR_Coverage, 3119,
     /*  61492 */     GIR_EraseRootFromParent_Done,
     /*  61493 */   // Label 1294: @61493
     /*  61493 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(61553), // Rule ID 3169 //
     /*  61498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minav),
     /*  61506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61527 */     // (intrinsic_wo_chain:{ *:[i32] } 3552:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)  =>  (MVE_VMINAVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  61527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAVs8),
     /*  61530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61532 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61534 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61539 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61545 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61551 */     GIR_RootConstrainSelectedInstOperands,
     /*  61552 */     // GIR_Coverage, 3169,
     /*  61552 */     GIR_EraseRootFromParent_Done,
     /*  61553 */   // Label 1295: @61553
     /*  61553 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(61613), // Rule ID 3171 //
     /*  61558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minav),
     /*  61566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61587 */     // (intrinsic_wo_chain:{ *:[i32] } 3552:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)  =>  (MVE_VMINAVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  61587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAVs16),
     /*  61590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61592 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61594 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61599 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61605 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61611 */     GIR_RootConstrainSelectedInstOperands,
     /*  61612 */     // GIR_Coverage, 3171,
     /*  61612 */     GIR_EraseRootFromParent_Done,
     /*  61613 */   // Label 1296: @61613
     /*  61613 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(61673), // Rule ID 3173 //
     /*  61618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minav),
     /*  61626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61647 */     // (intrinsic_wo_chain:{ *:[i32] } 3552:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)  =>  (MVE_VMINAVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  61647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAVs32),
     /*  61650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61652 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61654 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61659 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61665 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61671 */     GIR_RootConstrainSelectedInstOperands,
     /*  61672 */     // GIR_Coverage, 3173,
     /*  61672 */     GIR_EraseRootFromParent_Done,
     /*  61673 */   // Label 1297: @61673
     /*  61673 */   GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(61733), // Rule ID 3175 //
     /*  61678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxav),
     /*  61686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61707 */     // (intrinsic_wo_chain:{ *:[i32] } 3543:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)  =>  (MVE_VMAXAVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  61707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAVs8),
     /*  61710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61712 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61714 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61719 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61725 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61731 */     GIR_RootConstrainSelectedInstOperands,
     /*  61732 */     // GIR_Coverage, 3175,
     /*  61732 */     GIR_EraseRootFromParent_Done,
     /*  61733 */   // Label 1298: @61733
     /*  61733 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(61793), // Rule ID 3177 //
     /*  61738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxav),
     /*  61746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61767 */     // (intrinsic_wo_chain:{ *:[i32] } 3543:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)  =>  (MVE_VMAXAVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  61767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAVs16),
     /*  61770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61772 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61774 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61779 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61791 */     GIR_RootConstrainSelectedInstOperands,
     /*  61792 */     // GIR_Coverage, 3177,
     /*  61792 */     GIR_EraseRootFromParent_Done,
     /*  61793 */   // Label 1299: @61793
     /*  61793 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(61853), // Rule ID 3179 //
     /*  61798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxav),
     /*  61806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61827 */     // (intrinsic_wo_chain:{ *:[i32] } 3543:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)  =>  (MVE_VMAXAVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  61827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAVs32),
     /*  61830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61832 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61834 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61839 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61845 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61851 */     GIR_RootConstrainSelectedInstOperands,
     /*  61852 */     // GIR_Coverage, 3179,
     /*  61852 */     GIR_EraseRootFromParent_Done,
     /*  61853 */   // Label 1300: @61853
     /*  61853 */   GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(61928), // Rule ID 3470 //
     /*  61858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmulh),
     /*  61866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  61869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  61872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61887 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3665:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQDMULHi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  61887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULHi8),
     /*  61902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  61904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  61906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  61908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61911 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61917 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61926 */     GIR_RootConstrainSelectedInstOperands,
     /*  61927 */     // GIR_Coverage, 3470,
     /*  61927 */     GIR_EraseRootFromParent_Done,
     /*  61928 */   // Label 1301: @61928
     /*  61928 */   GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(62003), // Rule ID 3477 //
     /*  61933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmulh),
     /*  61941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  61944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  61947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61962 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3665:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQDMULHi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  61962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULHi16),
     /*  61977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  61979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  61981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  61983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61986 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61992 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62001 */     GIR_RootConstrainSelectedInstOperands,
     /*  62002 */     // GIR_Coverage, 3477,
     /*  62002 */     GIR_EraseRootFromParent_Done,
     /*  62003 */   // Label 1302: @62003
     /*  62003 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(62078), // Rule ID 3481 //
     /*  62008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmulh),
     /*  62016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  62025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62037 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3665:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQDMULHi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  62037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULHi32),
     /*  62052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  62056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62061 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62067 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62076 */     GIR_RootConstrainSelectedInstOperands,
     /*  62077 */     // GIR_Coverage, 3481,
     /*  62077 */     GIR_EraseRootFromParent_Done,
     /*  62078 */   // Label 1303: @62078
     /*  62078 */   GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(62153), // Rule ID 3483 //
     /*  62083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmulh),
     /*  62091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  62100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62112 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3674:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQRDMULHi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  62112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMULHi8),
     /*  62127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  62131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62136 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62142 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62151 */     GIR_RootConstrainSelectedInstOperands,
     /*  62152 */     // GIR_Coverage, 3483,
     /*  62152 */     GIR_EraseRootFromParent_Done,
     /*  62153 */   // Label 1304: @62153
     /*  62153 */   GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(62228), // Rule ID 3485 //
     /*  62158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmulh),
     /*  62166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  62175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62187 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3674:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQRDMULHi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  62187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMULHi16),
     /*  62202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  62206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62211 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62217 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62226 */     GIR_RootConstrainSelectedInstOperands,
     /*  62227 */     // GIR_Coverage, 3485,
     /*  62227 */     GIR_EraseRootFromParent_Done,
     /*  62228 */   // Label 1305: @62228
     /*  62228 */   GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(62303), // Rule ID 3487 //
     /*  62233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmulh),
     /*  62241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  62250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62262 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3674:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQRDMULHi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  62262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMULHi32),
     /*  62277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  62281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62286 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62292 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62301 */     GIR_RootConstrainSelectedInstOperands,
     /*  62302 */     // GIR_Coverage, 3487,
     /*  62302 */     GIR_EraseRootFromParent_Done,
     /*  62303 */   // Label 1306: @62303
     /*  62303 */   GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(62378), // Rule ID 4755 //
     /*  62308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62337 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3598:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR8),
     /*  62352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62361 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62367 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62373 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62376 */     GIR_RootConstrainSelectedInstOperands,
     /*  62377 */     // GIR_Coverage, 4755,
     /*  62377 */     GIR_EraseRootFromParent_Done,
     /*  62378 */   // Label 1307: @62378
     /*  62378 */   GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(62453), // Rule ID 4760 //
     /*  62383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62412 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3598:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR16),
     /*  62427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62436 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62442 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62451 */     GIR_RootConstrainSelectedInstOperands,
     /*  62452 */     // GIR_Coverage, 4760,
     /*  62452 */     GIR_EraseRootFromParent_Done,
     /*  62453 */   // Label 1308: @62453
     /*  62453 */   GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(62528), // Rule ID 4762 //
     /*  62458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62487 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3598:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR32),
     /*  62502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62511 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62517 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62526 */     GIR_RootConstrainSelectedInstOperands,
     /*  62527 */     // GIR_Coverage, 4762,
     /*  62527 */     GIR_EraseRootFromParent_Done,
     /*  62528 */   // Label 1309: @62528
     /*  62528 */   GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(62603), // Rule ID 4764 //
     /*  62533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  62536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62562 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3598:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR16),
     /*  62577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62586 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62592 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62601 */     GIR_RootConstrainSelectedInstOperands,
     /*  62602 */     // GIR_Coverage, 4764,
     /*  62602 */     GIR_EraseRootFromParent_Done,
     /*  62603 */   // Label 1310: @62603
     /*  62603 */   GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(62678), // Rule ID 4766 //
     /*  62608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  62611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62637 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3598:{ *:[iPTR] }, MQPR:{ *:[v4f32] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR32),
     /*  62652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62661 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62667 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62673 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62676 */     GIR_RootConstrainSelectedInstOperands,
     /*  62677 */     // GIR_Coverage, 4766,
     /*  62677 */     GIR_EraseRootFromParent_Done,
     /*  62678 */   // Label 1311: @62678
     /*  62678 */   GIM_Reject,
     /*  62679 */ // Label 956: @62679
     /*  62679 */ GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(73602),
     /*  62684 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  62687 */   GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(62777), // Rule ID 3916 //
     /*  62692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  62729 */     // MIs[1] Operand 1
     /*  62729 */     // No operand predicates
     /*  62729 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  62733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62735 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3675:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm, 0:{ *:[i32] })  =>  (MVE_VQSHLimms8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  62735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimms8),
     /*  62750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62752 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62760 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62766 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62775 */     GIR_RootConstrainSelectedInstOperands,
     /*  62776 */     // GIR_Coverage, 3916,
     /*  62776 */     GIR_EraseRootFromParent_Done,
     /*  62777 */   // Label 1313: @62777
     /*  62777 */   GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(62867), // Rule ID 3918 //
     /*  62782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62815 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  62819 */     // MIs[1] Operand 1
     /*  62819 */     // No operand predicates
     /*  62819 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  62823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62825 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3675:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm, 1:{ *:[i32] })  =>  (MVE_VQSHLimmu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  62825 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62828 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62832 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimmu8),
     /*  62840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62842 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62844 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62850 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62856 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62865 */     GIR_RootConstrainSelectedInstOperands,
     /*  62866 */     // GIR_Coverage, 3918,
     /*  62866 */     GIR_EraseRootFromParent_Done,
     /*  62867 */   // Label 1314: @62867
     /*  62867 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(62957), // Rule ID 3920 //
     /*  62872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62905 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  62909 */     // MIs[1] Operand 1
     /*  62909 */     // No operand predicates
     /*  62909 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  62913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62915 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3675:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm, 0:{ *:[i32] })  =>  (MVE_VQSHLimms16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  62915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimms16),
     /*  62930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62932 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62940 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62946 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62955 */     GIR_RootConstrainSelectedInstOperands,
     /*  62956 */     // GIR_Coverage, 3920,
     /*  62956 */     GIR_EraseRootFromParent_Done,
     /*  62957 */   // Label 1315: @62957
     /*  62957 */   GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(63047), // Rule ID 3922 //
     /*  62962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62995 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  62999 */     // MIs[1] Operand 1
     /*  62999 */     // No operand predicates
     /*  62999 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63005 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3675:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm, 1:{ *:[i32] })  =>  (MVE_VQSHLimmu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  63005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimmu16),
     /*  63020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63022 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63030 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63036 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63045 */     GIR_RootConstrainSelectedInstOperands,
     /*  63046 */     // GIR_Coverage, 3922,
     /*  63046 */     GIR_EraseRootFromParent_Done,
     /*  63047 */   // Label 1316: @63047
     /*  63047 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(63137), // Rule ID 3924 //
     /*  63052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  63057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63085 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  63089 */     // MIs[1] Operand 1
     /*  63089 */     // No operand predicates
     /*  63089 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63095 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3675:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm, 0:{ *:[i32] })  =>  (MVE_VQSHLimms32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  63095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimms32),
     /*  63110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63112 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63114 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63120 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63126 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63135 */     GIR_RootConstrainSelectedInstOperands,
     /*  63136 */     // GIR_Coverage, 3924,
     /*  63136 */     GIR_EraseRootFromParent_Done,
     /*  63137 */   // Label 1317: @63137
     /*  63137 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(63227), // Rule ID 3926 //
     /*  63142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  63147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63175 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  63179 */     // MIs[1] Operand 1
     /*  63179 */     // No operand predicates
     /*  63179 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63185 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3675:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm, 1:{ *:[i32] })  =>  (MVE_VQSHLimmu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  63185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimmu32),
     /*  63200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63202 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63210 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63216 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63225 */     GIR_RootConstrainSelectedInstOperands,
     /*  63226 */     // GIR_Coverage, 3926,
     /*  63226 */     GIR_EraseRootFromParent_Done,
     /*  63227 */   // Label 1318: @63227
     /*  63227 */   GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(63317), // Rule ID 3934 //
     /*  63232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  63240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63265 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  63269 */     // MIs[1] Operand 1
     /*  63269 */     // No operand predicates
     /*  63269 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63275 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3691:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] })  =>  (MVE_VRSHR_imms8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)
     /*  63275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_imms8),
     /*  63290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63292 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63294 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63300 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63306 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63315 */     GIR_RootConstrainSelectedInstOperands,
     /*  63316 */     // GIR_Coverage, 3934,
     /*  63316 */     GIR_EraseRootFromParent_Done,
     /*  63317 */   // Label 1319: @63317
     /*  63317 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(63407), // Rule ID 3936 //
     /*  63322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  63330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  63359 */     // MIs[1] Operand 1
     /*  63359 */     // No operand predicates
     /*  63359 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63365 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3691:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] })  =>  (MVE_VRSHR_immu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)
     /*  63365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_immu8),
     /*  63380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63382 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63384 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63390 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63396 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63405 */     GIR_RootConstrainSelectedInstOperands,
     /*  63406 */     // GIR_Coverage, 3936,
     /*  63406 */     GIR_EraseRootFromParent_Done,
     /*  63407 */   // Label 1320: @63407
     /*  63407 */   GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(63497), // Rule ID 3938 //
     /*  63412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63445 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  63449 */     // MIs[1] Operand 1
     /*  63449 */     // No operand predicates
     /*  63449 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63455 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3691:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] })  =>  (MVE_VRSHR_imms16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)
     /*  63455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_imms16),
     /*  63470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63472 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63474 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63480 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63486 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63495 */     GIR_RootConstrainSelectedInstOperands,
     /*  63496 */     // GIR_Coverage, 3938,
     /*  63496 */     GIR_EraseRootFromParent_Done,
     /*  63497 */   // Label 1321: @63497
     /*  63497 */   GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(63587), // Rule ID 3940 //
     /*  63502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63535 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  63539 */     // MIs[1] Operand 1
     /*  63539 */     // No operand predicates
     /*  63539 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63545 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3691:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] })  =>  (MVE_VRSHR_immu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)
     /*  63545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_immu16),
     /*  63560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63562 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63564 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63570 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63576 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63585 */     GIR_RootConstrainSelectedInstOperands,
     /*  63586 */     // GIR_Coverage, 3940,
     /*  63586 */     GIR_EraseRootFromParent_Done,
     /*  63587 */   // Label 1322: @63587
     /*  63587 */   GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(63677), // Rule ID 3942 //
     /*  63592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63625 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm32),
     /*  63629 */     // MIs[1] Operand 1
     /*  63629 */     // No operand predicates
     /*  63629 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63635 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3691:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm, 0:{ *:[i32] })  =>  (MVE_VRSHR_imms32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)
     /*  63635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_imms32),
     /*  63650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63652 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63660 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63666 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63675 */     GIR_RootConstrainSelectedInstOperands,
     /*  63676 */     // GIR_Coverage, 3942,
     /*  63676 */     GIR_EraseRootFromParent_Done,
     /*  63677 */   // Label 1323: @63677
     /*  63677 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(63767), // Rule ID 3944 //
     /*  63682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63715 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm32),
     /*  63719 */     // MIs[1] Operand 1
     /*  63719 */     // No operand predicates
     /*  63719 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63725 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3691:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm, 1:{ *:[i32] })  =>  (MVE_VRSHR_immu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)
     /*  63725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_immu32),
     /*  63740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63742 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63744 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63750 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63756 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63765 */     GIR_RootConstrainSelectedInstOperands,
     /*  63766 */     // GIR_Coverage, 3944,
     /*  63766 */     GIR_EraseRootFromParent_Done,
     /*  63767 */   // Label 1324: @63767
     /*  63767 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(63856), // Rule ID 4042 //
     /*  63772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  63789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63796 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  63800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63812 */     // MIs[1] Operand 1
     /*  63812 */     // No operand predicates
     /*  63812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63814 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3611:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf16s16_fix:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16s16_fix),
     /*  63829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63839 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63845 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63854 */     GIR_RootConstrainSelectedInstOperands,
     /*  63855 */     // GIR_Coverage, 4042,
     /*  63855 */     GIR_EraseRootFromParent_Done,
     /*  63856 */   // Label 1325: @63856
     /*  63856 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(63945), // Rule ID 4044 //
     /*  63861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  63878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63885 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  63889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63901 */     // MIs[1] Operand 1
     /*  63901 */     // No operand predicates
     /*  63901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63903 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3611:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTs16f16_fix:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16_fix),
     /*  63918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63922 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63928 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63943 */     GIR_RootConstrainSelectedInstOperands,
     /*  63944 */     // GIR_Coverage, 4044,
     /*  63944 */     GIR_EraseRootFromParent_Done,
     /*  63945 */   // Label 1326: @63945
     /*  63945 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(64034), // Rule ID 4046 //
     /*  63950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  63967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63974 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  63978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63990 */     // MIs[1] Operand 1
     /*  63990 */     // No operand predicates
     /*  63990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63992 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3611:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf16u16_fix:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16u16_fix),
     /*  64007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64017 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64023 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64032 */     GIR_RootConstrainSelectedInstOperands,
     /*  64033 */     // GIR_Coverage, 4046,
     /*  64033 */     GIR_EraseRootFromParent_Done,
     /*  64034 */   // Label 1327: @64034
     /*  64034 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(64123), // Rule ID 4048 //
     /*  64039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  64050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64063 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  64067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64079 */     // MIs[1] Operand 1
     /*  64079 */     // No operand predicates
     /*  64079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64081 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3611:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTu16f16_fix:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16_fix),
     /*  64096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64100 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64106 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64112 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64121 */     GIR_RootConstrainSelectedInstOperands,
     /*  64122 */     // GIR_Coverage, 4048,
     /*  64122 */     GIR_EraseRootFromParent_Done,
     /*  64123 */   // Label 1328: @64123
     /*  64123 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(64212), // Rule ID 4050 //
     /*  64128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64152 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  64156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64168 */     // MIs[1] Operand 1
     /*  64168 */     // No operand predicates
     /*  64168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64170 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3611:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf32s32_fix:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32s32_fix),
     /*  64185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64195 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64201 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64210 */     GIR_RootConstrainSelectedInstOperands,
     /*  64211 */     // GIR_Coverage, 4050,
     /*  64211 */     GIR_EraseRootFromParent_Done,
     /*  64212 */   // Label 1329: @64212
     /*  64212 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(64301), // Rule ID 4052 //
     /*  64217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64241 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  64245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64257 */     // MIs[1] Operand 1
     /*  64257 */     // No operand predicates
     /*  64257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64259 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3611:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTs32f32_fix:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32_fix),
     /*  64274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64278 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64284 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64290 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64299 */     GIR_RootConstrainSelectedInstOperands,
     /*  64300 */     // GIR_Coverage, 4052,
     /*  64300 */     GIR_EraseRootFromParent_Done,
     /*  64301 */   // Label 1330: @64301
     /*  64301 */   GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(64390), // Rule ID 4054 //
     /*  64306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64330 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  64334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64346 */     // MIs[1] Operand 1
     /*  64346 */     // No operand predicates
     /*  64346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64348 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3611:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf32u32_fix:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32u32_fix),
     /*  64363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64373 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64379 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64388 */     GIR_RootConstrainSelectedInstOperands,
     /*  64389 */     // GIR_Coverage, 4054,
     /*  64389 */     GIR_EraseRootFromParent_Done,
     /*  64390 */   // Label 1331: @64390
     /*  64390 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(64479), // Rule ID 4056 //
     /*  64395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64419 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  64423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64435 */     // MIs[1] Operand 1
     /*  64435 */     // No operand predicates
     /*  64435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64437 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3611:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTu32f32_fix:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32_fix),
     /*  64452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64462 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64468 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64477 */     GIR_RootConstrainSelectedInstOperands,
     /*  64478 */     // GIR_Coverage, 4056,
     /*  64478 */     GIR_EraseRootFromParent_Done,
     /*  64479 */   // Label 1332: @64479
     /*  64479 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(64546), // Rule ID 3121 //
     /*  64484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64516 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64520 */     // (intrinsic_wo_chain:{ *:[i32] } 3558:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMINVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  64520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs8),
     /*  64523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64525 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64527 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64532 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64538 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64544 */     GIR_RootConstrainSelectedInstOperands,
     /*  64545 */     // GIR_Coverage, 3121,
     /*  64545 */     GIR_EraseRootFromParent_Done,
     /*  64546 */   // Label 1333: @64546
     /*  64546 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(64613), // Rule ID 3123 //
     /*  64551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64583 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64587 */     // (intrinsic_wo_chain:{ *:[i32] } 3558:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMINVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  64587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs16),
     /*  64590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64592 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64594 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64599 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64605 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64611 */     GIR_RootConstrainSelectedInstOperands,
     /*  64612 */     // GIR_Coverage, 3123,
     /*  64612 */     GIR_EraseRootFromParent_Done,
     /*  64613 */   // Label 1334: @64613
     /*  64613 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(64680), // Rule ID 3125 //
     /*  64618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64650 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64654 */     // (intrinsic_wo_chain:{ *:[i32] } 3558:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMINVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  64654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs32),
     /*  64657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64659 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64661 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64666 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64672 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64678 */     GIR_RootConstrainSelectedInstOperands,
     /*  64679 */     // GIR_Coverage, 3125,
     /*  64679 */     GIR_EraseRootFromParent_Done,
     /*  64680 */   // Label 1335: @64680
     /*  64680 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(64747), // Rule ID 3127 //
     /*  64685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64717 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64721 */     // (intrinsic_wo_chain:{ *:[i32] } 3558:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMINVu8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  64721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu8),
     /*  64724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64726 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64728 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64733 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64739 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64745 */     GIR_RootConstrainSelectedInstOperands,
     /*  64746 */     // GIR_Coverage, 3127,
     /*  64746 */     GIR_EraseRootFromParent_Done,
     /*  64747 */   // Label 1336: @64747
     /*  64747 */   GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(64814), // Rule ID 3129 //
     /*  64752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64784 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64788 */     // (intrinsic_wo_chain:{ *:[i32] } 3558:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMINVu16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  64788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu16),
     /*  64791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64793 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64795 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64800 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64806 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64812 */     GIR_RootConstrainSelectedInstOperands,
     /*  64813 */     // GIR_Coverage, 3129,
     /*  64813 */     GIR_EraseRootFromParent_Done,
     /*  64814 */   // Label 1337: @64814
     /*  64814 */   GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(64881), // Rule ID 3131 //
     /*  64819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64851 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64855 */     // (intrinsic_wo_chain:{ *:[i32] } 3558:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMINVu32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  64855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu32),
     /*  64858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64860 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64862 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64867 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64873 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64879 */     GIR_RootConstrainSelectedInstOperands,
     /*  64880 */     // GIR_Coverage, 3131,
     /*  64880 */     GIR_EraseRootFromParent_Done,
     /*  64881 */   // Label 1338: @64881
     /*  64881 */   GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(64948), // Rule ID 3133 //
     /*  64886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  64894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64918 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64922 */     // (intrinsic_wo_chain:{ *:[i32] } 3549:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMAXVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  64922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs8),
     /*  64925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64927 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64929 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64940 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64946 */     GIR_RootConstrainSelectedInstOperands,
     /*  64947 */     // GIR_Coverage, 3133,
     /*  64947 */     GIR_EraseRootFromParent_Done,
     /*  64948 */   // Label 1339: @64948
     /*  64948 */   GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(65015), // Rule ID 3135 //
     /*  64953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  64961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64985 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64989 */     // (intrinsic_wo_chain:{ *:[i32] } 3549:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMAXVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  64989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs16),
     /*  64992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64994 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64996 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65001 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65007 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65013 */     GIR_RootConstrainSelectedInstOperands,
     /*  65014 */     // GIR_Coverage, 3135,
     /*  65014 */     GIR_EraseRootFromParent_Done,
     /*  65015 */   // Label 1340: @65015
     /*  65015 */   GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(65082), // Rule ID 3137 //
     /*  65020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  65028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65052 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65056 */     // (intrinsic_wo_chain:{ *:[i32] } 3549:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMAXVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  65056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs32),
     /*  65059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65061 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65063 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65068 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65074 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65080 */     GIR_RootConstrainSelectedInstOperands,
     /*  65081 */     // GIR_Coverage, 3137,
     /*  65081 */     GIR_EraseRootFromParent_Done,
     /*  65082 */   // Label 1341: @65082
     /*  65082 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(65149), // Rule ID 3139 //
     /*  65087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  65095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65119 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65123 */     // (intrinsic_wo_chain:{ *:[i32] } 3549:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMAXVu8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  65123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu8),
     /*  65126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65128 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65130 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65135 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65141 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65147 */     GIR_RootConstrainSelectedInstOperands,
     /*  65148 */     // GIR_Coverage, 3139,
     /*  65148 */     GIR_EraseRootFromParent_Done,
     /*  65149 */   // Label 1342: @65149
     /*  65149 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(65216), // Rule ID 3141 //
     /*  65154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  65162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65186 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65190 */     // (intrinsic_wo_chain:{ *:[i32] } 3549:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMAXVu16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  65190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu16),
     /*  65193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65195 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65197 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65202 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65208 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65214 */     GIR_RootConstrainSelectedInstOperands,
     /*  65215 */     // GIR_Coverage, 3141,
     /*  65215 */     GIR_EraseRootFromParent_Done,
     /*  65216 */   // Label 1343: @65216
     /*  65216 */   GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(65283), // Rule ID 3143 //
     /*  65221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  65229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65253 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65257 */     // (intrinsic_wo_chain:{ *:[i32] } 3549:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMAXVu32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  65257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu32),
     /*  65260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65262 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65264 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65269 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65275 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65281 */     GIR_RootConstrainSelectedInstOperands,
     /*  65282 */     // GIR_Coverage, 3143,
     /*  65282 */     GIR_EraseRootFromParent_Done,
     /*  65283 */   // Label 1344: @65283
     /*  65283 */   GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(65365), // Rule ID 3548 //
     /*  65288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65320 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65324 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3595:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65324 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65327 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65331 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDs8),
     /*  65339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65348 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65354 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65363 */     GIR_RootConstrainSelectedInstOperands,
     /*  65364 */     // GIR_Coverage, 3548,
     /*  65364 */     GIR_EraseRootFromParent_Done,
     /*  65365 */   // Label 1345: @65365
     /*  65365 */   GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(65447), // Rule ID 3555 //
     /*  65370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65402 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65406 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3595:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  65406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDs16),
     /*  65421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65430 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65436 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65445 */     GIR_RootConstrainSelectedInstOperands,
     /*  65446 */     // GIR_Coverage, 3555,
     /*  65446 */     GIR_EraseRootFromParent_Done,
     /*  65447 */   // Label 1346: @65447
     /*  65447 */   GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(65529), // Rule ID 3559 //
     /*  65452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65484 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65488 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3595:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  65488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDs32),
     /*  65503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65512 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65518 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65527 */     GIR_RootConstrainSelectedInstOperands,
     /*  65528 */     // GIR_Coverage, 3559,
     /*  65528 */     GIR_EraseRootFromParent_Done,
     /*  65529 */   // Label 1347: @65529
     /*  65529 */   GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(65611), // Rule ID 3563 //
     /*  65534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65566 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65570 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3595:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VABDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDu8),
     /*  65585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65594 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65600 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65609 */     GIR_RootConstrainSelectedInstOperands,
     /*  65610 */     // GIR_Coverage, 3563,
     /*  65610 */     GIR_EraseRootFromParent_Done,
     /*  65611 */   // Label 1348: @65611
     /*  65611 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(65693), // Rule ID 3567 //
     /*  65616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65648 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65652 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3595:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VABDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  65652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDu16),
     /*  65667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65676 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65682 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65691 */     GIR_RootConstrainSelectedInstOperands,
     /*  65692 */     // GIR_Coverage, 3567,
     /*  65692 */     GIR_EraseRootFromParent_Done,
     /*  65693 */   // Label 1349: @65693
     /*  65693 */   GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(65775), // Rule ID 3571 //
     /*  65698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65730 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65734 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3595:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VABDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  65734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDu32),
     /*  65749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65758 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65764 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65773 */     GIR_RootConstrainSelectedInstOperands,
     /*  65774 */     // GIR_Coverage, 3571,
     /*  65774 */     GIR_EraseRootFromParent_Done,
     /*  65775 */   // Label 1350: @65775
     /*  65775 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(65857), // Rule ID 3572 //
     /*  65780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65812 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65816 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3681:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRHADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDs8),
     /*  65831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65840 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65846 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65855 */     GIR_RootConstrainSelectedInstOperands,
     /*  65856 */     // GIR_Coverage, 3572,
     /*  65856 */     GIR_EraseRootFromParent_Done,
     /*  65857 */   // Label 1351: @65857
     /*  65857 */   GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(65939), // Rule ID 3579 //
     /*  65862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65894 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65898 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3681:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRHADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  65898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDs16),
     /*  65913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65922 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65928 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65937 */     GIR_RootConstrainSelectedInstOperands,
     /*  65938 */     // GIR_Coverage, 3579,
     /*  65938 */     GIR_EraseRootFromParent_Done,
     /*  65939 */   // Label 1352: @65939
     /*  65939 */   GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(66021), // Rule ID 3583 //
     /*  65944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65976 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65980 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3681:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRHADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  65980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDs32),
     /*  65995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66004 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66010 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66019 */     GIR_RootConstrainSelectedInstOperands,
     /*  66020 */     // GIR_Coverage, 3583,
     /*  66020 */     GIR_EraseRootFromParent_Done,
     /*  66021 */   // Label 1353: @66021
     /*  66021 */   GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(66103), // Rule ID 3587 //
     /*  66026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  66034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66058 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66062 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3681:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRHADDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDu8),
     /*  66077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66086 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66092 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66101 */     GIR_RootConstrainSelectedInstOperands,
     /*  66102 */     // GIR_Coverage, 3587,
     /*  66102 */     GIR_EraseRootFromParent_Done,
     /*  66103 */   // Label 1354: @66103
     /*  66103 */   GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(66185), // Rule ID 3591 //
     /*  66108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  66116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66140 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66144 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3681:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRHADDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDu16),
     /*  66159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66168 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66174 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66183 */     GIR_RootConstrainSelectedInstOperands,
     /*  66184 */     // GIR_Coverage, 3591,
     /*  66184 */     GIR_EraseRootFromParent_Done,
     /*  66185 */   // Label 1355: @66185
     /*  66185 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(66267), // Rule ID 3595 //
     /*  66190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  66198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66222 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66226 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3681:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRHADDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDu32),
     /*  66241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66250 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66256 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66265 */     GIR_RootConstrainSelectedInstOperands,
     /*  66266 */     // GIR_Coverage, 3595,
     /*  66266 */     GIR_EraseRootFromParent_Done,
     /*  66267 */   // Label 1356: @66267
     /*  66267 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(66349), // Rule ID 3596 //
     /*  66272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66304 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66308 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3630:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDs8),
     /*  66323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66332 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66338 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66347 */     GIR_RootConstrainSelectedInstOperands,
     /*  66348 */     // GIR_Coverage, 3596,
     /*  66348 */     GIR_EraseRootFromParent_Done,
     /*  66349 */   // Label 1357: @66349
     /*  66349 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(66431), // Rule ID 3603 //
     /*  66354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66386 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66390 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3630:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDs16),
     /*  66405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66414 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66420 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66429 */     GIR_RootConstrainSelectedInstOperands,
     /*  66430 */     // GIR_Coverage, 3603,
     /*  66430 */     GIR_EraseRootFromParent_Done,
     /*  66431 */   // Label 1358: @66431
     /*  66431 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(66513), // Rule ID 3607 //
     /*  66436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66468 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66472 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3630:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDs32),
     /*  66487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66496 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66502 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66511 */     GIR_RootConstrainSelectedInstOperands,
     /*  66512 */     // GIR_Coverage, 3607,
     /*  66512 */     GIR_EraseRootFromParent_Done,
     /*  66513 */   // Label 1359: @66513
     /*  66513 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(66595), // Rule ID 3611 //
     /*  66518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66550 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66554 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3630:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHADDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66554 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66557 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66561 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDu8),
     /*  66569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66578 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66584 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66593 */     GIR_RootConstrainSelectedInstOperands,
     /*  66594 */     // GIR_Coverage, 3611,
     /*  66594 */     GIR_EraseRootFromParent_Done,
     /*  66595 */   // Label 1360: @66595
     /*  66595 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(66677), // Rule ID 3615 //
     /*  66600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66632 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66636 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3630:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHADDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDu16),
     /*  66651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66660 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66666 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66675 */     GIR_RootConstrainSelectedInstOperands,
     /*  66676 */     // GIR_Coverage, 3615,
     /*  66676 */     GIR_EraseRootFromParent_Done,
     /*  66677 */   // Label 1361: @66677
     /*  66677 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(66759), // Rule ID 3619 //
     /*  66682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66714 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66718 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3630:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHADDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDu32),
     /*  66733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66742 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66748 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66757 */     GIR_RootConstrainSelectedInstOperands,
     /*  66758 */     // GIR_Coverage, 3619,
     /*  66758 */     GIR_EraseRootFromParent_Done,
     /*  66759 */   // Label 1362: @66759
     /*  66759 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(66841), // Rule ID 3620 //
     /*  66764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66796 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66800 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3631:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHSUBs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBs8),
     /*  66815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66824 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66830 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66839 */     GIR_RootConstrainSelectedInstOperands,
     /*  66840 */     // GIR_Coverage, 3620,
     /*  66840 */     GIR_EraseRootFromParent_Done,
     /*  66841 */   // Label 1363: @66841
     /*  66841 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(66923), // Rule ID 3623 //
     /*  66846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66878 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66882 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3631:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHSUBs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBs16),
     /*  66897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66906 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66912 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66921 */     GIR_RootConstrainSelectedInstOperands,
     /*  66922 */     // GIR_Coverage, 3623,
     /*  66922 */     GIR_EraseRootFromParent_Done,
     /*  66923 */   // Label 1364: @66923
     /*  66923 */   GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(67005), // Rule ID 3626 //
     /*  66928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66960 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66964 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3631:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHSUBs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBs32),
     /*  66979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66988 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66994 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67003 */     GIR_RootConstrainSelectedInstOperands,
     /*  67004 */     // GIR_Coverage, 3626,
     /*  67004 */     GIR_EraseRootFromParent_Done,
     /*  67005 */   // Label 1365: @67005
     /*  67005 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(67087), // Rule ID 3629 //
     /*  67010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  67018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  67021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67042 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67046 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3631:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHSUBu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBu8),
     /*  67061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67070 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67076 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67085 */     GIR_RootConstrainSelectedInstOperands,
     /*  67086 */     // GIR_Coverage, 3629,
     /*  67086 */     GIR_EraseRootFromParent_Done,
     /*  67087 */   // Label 1366: @67087
     /*  67087 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(67169), // Rule ID 3632 //
     /*  67092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  67100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67124 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67128 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3631:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHSUBu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBu16),
     /*  67143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67158 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67167 */     GIR_RootConstrainSelectedInstOperands,
     /*  67168 */     // GIR_Coverage, 3632,
     /*  67168 */     GIR_EraseRootFromParent_Done,
     /*  67169 */   // Label 1367: @67169
     /*  67169 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(67251), // Rule ID 3635 //
     /*  67174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  67182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  67191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67206 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67210 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3631:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHSUBu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  67210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBu32),
     /*  67225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67234 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67240 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67249 */     GIR_RootConstrainSelectedInstOperands,
     /*  67250 */     // GIR_Coverage, 3635,
     /*  67250 */     GIR_EraseRootFromParent_Done,
     /*  67251 */   // Label 1368: @67251
     /*  67251 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(67333), // Rule ID 4036 //
     /*  67256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  67259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  67264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  67273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67288 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67292 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3595:{ *:[iPTR] }, MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /*  67292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf32),
     /*  67307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67316 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67322 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67331 */     GIR_RootConstrainSelectedInstOperands,
     /*  67332 */     // GIR_Coverage, 4036,
     /*  67332 */     GIR_EraseRootFromParent_Done,
     /*  67333 */   // Label 1369: @67333
     /*  67333 */   GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(67415), // Rule ID 4038 //
     /*  67338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  67341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  67346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67370 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67374 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3595:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /*  67374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf16),
     /*  67389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67398 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67404 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67413 */     GIR_RootConstrainSelectedInstOperands,
     /*  67414 */     // GIR_Coverage, 4038,
     /*  67414 */     GIR_EraseRootFromParent_Done,
     /*  67415 */   // Label 1370: @67415
     /*  67415 */   GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(67497), // Rule ID 4411 //
     /*  67420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67452 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67456 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3658:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULLBp8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBp8),
     /*  67471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67480 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67486 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67495 */     GIR_RootConstrainSelectedInstOperands,
     /*  67496 */     // GIR_Coverage, 4411,
     /*  67496 */     GIR_EraseRootFromParent_Done,
     /*  67497 */   // Label 1371: @67497
     /*  67497 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(67579), // Rule ID 4413 //
     /*  67502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67534 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67538 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3658:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULLTp8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTp8),
     /*  67553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67562 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67568 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67577 */     GIR_RootConstrainSelectedInstOperands,
     /*  67578 */     // GIR_Coverage, 4413,
     /*  67578 */     GIR_EraseRootFromParent_Done,
     /*  67579 */   // Label 1372: @67579
     /*  67579 */   GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(67661), // Rule ID 4415 //
     /*  67584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67616 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67620 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3658:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULLBp16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBp16),
     /*  67635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67644 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67659 */     GIR_RootConstrainSelectedInstOperands,
     /*  67660 */     // GIR_Coverage, 4415,
     /*  67660 */     GIR_EraseRootFromParent_Done,
     /*  67661 */   // Label 1373: @67661
     /*  67661 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(67743), // Rule ID 4417 //
     /*  67666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67698 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67702 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3658:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULLTp16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTp16),
     /*  67717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67721 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67726 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67732 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67741 */     GIR_RootConstrainSelectedInstOperands,
     /*  67742 */     // GIR_Coverage, 4417,
     /*  67742 */     GIR_EraseRootFromParent_Done,
     /*  67743 */   // Label 1374: @67743
     /*  67743 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(67825), // Rule ID 4444 //
     /*  67748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  67759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67780 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67784 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3656:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs8),
     /*  67799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67808 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67814 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67823 */     GIR_RootConstrainSelectedInstOperands,
     /*  67824 */     // GIR_Coverage, 4444,
     /*  67824 */     GIR_EraseRootFromParent_Done,
     /*  67825 */   // Label 1375: @67825
     /*  67825 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(67907), // Rule ID 4451 //
     /*  67830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67866 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3656:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs16),
     /*  67881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67890 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67896 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67905 */     GIR_RootConstrainSelectedInstOperands,
     /*  67906 */     // GIR_Coverage, 4451,
     /*  67906 */     GIR_EraseRootFromParent_Done,
     /*  67907 */   // Label 1376: @67907
     /*  67907 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(67989), // Rule ID 4455 //
     /*  67912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  67929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67948 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3656:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  67948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs32),
     /*  67963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67967 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67972 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67978 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67987 */     GIR_RootConstrainSelectedInstOperands,
     /*  67988 */     // GIR_Coverage, 4455,
     /*  67988 */     GIR_EraseRootFromParent_Done,
     /*  67989 */   // Label 1377: @67989
     /*  67989 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(68071), // Rule ID 4459 //
     /*  67994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  68002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68026 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68030 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3656:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULHu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  68030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu8),
     /*  68045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68054 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68060 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68069 */     GIR_RootConstrainSelectedInstOperands,
     /*  68070 */     // GIR_Coverage, 4459,
     /*  68070 */     GIR_EraseRootFromParent_Done,
     /*  68071 */   // Label 1378: @68071
     /*  68071 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(68153), // Rule ID 4463 //
     /*  68076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  68084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68108 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68112 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3656:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULHu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu16),
     /*  68127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68136 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68142 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68151 */     GIR_RootConstrainSelectedInstOperands,
     /*  68152 */     // GIR_Coverage, 4463,
     /*  68152 */     GIR_EraseRootFromParent_Done,
     /*  68153 */   // Label 1379: @68153
     /*  68153 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(68235), // Rule ID 4467 //
     /*  68158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  68166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68190 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68194 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3656:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULHu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu32),
     /*  68209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68218 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68233 */     GIR_RootConstrainSelectedInstOperands,
     /*  68234 */     // GIR_Coverage, 4467,
     /*  68234 */     GIR_EraseRootFromParent_Done,
     /*  68235 */   // Label 1380: @68235
     /*  68235 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(68317), // Rule ID 4468 //
     /*  68240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68272 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68276 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3690:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRMULHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  68276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHs8),
     /*  68291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68300 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68306 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68315 */     GIR_RootConstrainSelectedInstOperands,
     /*  68316 */     // GIR_Coverage, 4468,
     /*  68316 */     GIR_EraseRootFromParent_Done,
     /*  68317 */   // Label 1381: @68317
     /*  68317 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(68399), // Rule ID 4470 //
     /*  68322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68354 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68358 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3690:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRMULHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHs16),
     /*  68373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68382 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68388 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68397 */     GIR_RootConstrainSelectedInstOperands,
     /*  68398 */     // GIR_Coverage, 4470,
     /*  68398 */     GIR_EraseRootFromParent_Done,
     /*  68399 */   // Label 1382: @68399
     /*  68399 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(68481), // Rule ID 4472 //
     /*  68404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68436 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68440 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3690:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRMULHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHs32),
     /*  68455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68470 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68479 */     GIR_RootConstrainSelectedInstOperands,
     /*  68480 */     // GIR_Coverage, 4472,
     /*  68480 */     GIR_EraseRootFromParent_Done,
     /*  68481 */   // Label 1383: @68481
     /*  68481 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(68563), // Rule ID 4474 //
     /*  68486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68518 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68522 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3690:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRMULHu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  68522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHu8),
     /*  68537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68546 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68552 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68561 */     GIR_RootConstrainSelectedInstOperands,
     /*  68562 */     // GIR_Coverage, 4474,
     /*  68562 */     GIR_EraseRootFromParent_Done,
     /*  68563 */   // Label 1384: @68563
     /*  68563 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(68645), // Rule ID 4476 //
     /*  68568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68600 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68604 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3690:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRMULHu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHu16),
     /*  68619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68628 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68634 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68643 */     GIR_RootConstrainSelectedInstOperands,
     /*  68644 */     // GIR_Coverage, 4476,
     /*  68644 */     GIR_EraseRootFromParent_Done,
     /*  68645 */   // Label 1385: @68645
     /*  68645 */   GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(68727), // Rule ID 4478 //
     /*  68650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68682 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68686 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3690:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRMULHu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHu32),
     /*  68701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68710 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68716 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68725 */     GIR_RootConstrainSelectedInstOperands,
     /*  68726 */     // GIR_Coverage, 4478,
     /*  68726 */     GIR_EraseRootFromParent_Done,
     /*  68727 */   // Label 1386: @68727
     /*  68727 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(68794), // Rule ID 4529 //
     /*  68732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  68735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_narrow),
     /*  68740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68764 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68768 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3614:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm, 0:{ *:[i32] })  =>  (MVE_VCVTf16f32bh:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm)
     /*  68768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16f32bh),
     /*  68771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  68775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  68777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68780 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68786 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68792 */     GIR_RootConstrainSelectedInstOperands,
     /*  68793 */     // GIR_Coverage, 4529,
     /*  68793 */     GIR_EraseRootFromParent_Done,
     /*  68794 */   // Label 1387: @68794
     /*  68794 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(68861), // Rule ID 4535 //
     /*  68799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  68802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_narrow),
     /*  68807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68831 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68835 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3614:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm, 1:{ *:[i32] })  =>  (MVE_VCVTf16f32th:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm)
     /*  68835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16f32th),
     /*  68838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  68842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  68844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68847 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68853 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68859 */     GIR_RootConstrainSelectedInstOperands,
     /*  68860 */     // GIR_Coverage, 4535,
     /*  68860 */     GIR_EraseRootFromParent_Done,
     /*  68861 */   // Label 1388: @68861
     /*  68861 */   GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(68943), // Rule ID 4553 //
     /*  68866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  68874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68898 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68902 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3666:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VQDMULLs16bh:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs16bh),
     /*  68917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68926 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68932 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68941 */     GIR_RootConstrainSelectedInstOperands,
     /*  68942 */     // GIR_Coverage, 4553,
     /*  68942 */     GIR_EraseRootFromParent_Done,
     /*  68943 */   // Label 1389: @68943
     /*  68943 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(69025), // Rule ID 4555 //
     /*  68948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  68956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68980 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68984 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3666:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VQDMULLs16th:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs16th),
     /*  68999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  69003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69008 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69014 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69023 */     GIR_RootConstrainSelectedInstOperands,
     /*  69024 */     // GIR_Coverage, 4555,
     /*  69024 */     GIR_EraseRootFromParent_Done,
     /*  69025 */   // Label 1390: @69025
     /*  69025 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(69107), // Rule ID 4557 //
     /*  69030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  69033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  69038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  69041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69062 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  69066 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3666:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VQDMULLs32bh:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  69066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs32bh),
     /*  69081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  69085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69096 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69105 */     GIR_RootConstrainSelectedInstOperands,
     /*  69106 */     // GIR_Coverage, 4557,
     /*  69106 */     GIR_EraseRootFromParent_Done,
     /*  69107 */   // Label 1391: @69107
     /*  69107 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(69189), // Rule ID 4559 //
     /*  69112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  69115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  69120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  69123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69144 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  69148 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3666:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VQDMULLs32th:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  69148 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69151 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69155 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs32th),
     /*  69163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  69167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69172 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69178 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69187 */     GIR_RootConstrainSelectedInstOperands,
     /*  69188 */     // GIR_Coverage, 4559,
     /*  69188 */     GIR_EraseRootFromParent_Done,
     /*  69189 */   // Label 1392: @69189
     /*  69189 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(69266), // Rule ID 3904 //
     /*  69194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsli),
     /*  69199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69231 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  69235 */     // MIs[1] Operand 1
     /*  69235 */     // No operand predicates
     /*  69235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69237 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3705:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)  =>  (MVE_VSLIimm8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  69237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSLIimm8),
     /*  69240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69242 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69252 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69258 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69264 */     GIR_RootConstrainSelectedInstOperands,
     /*  69265 */     // GIR_Coverage, 3904,
     /*  69265 */     GIR_EraseRootFromParent_Done,
     /*  69266 */   // Label 1393: @69266
     /*  69266 */   GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(69343), // Rule ID 3906 //
     /*  69271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsli),
     /*  69276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69308 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  69312 */     // MIs[1] Operand 1
     /*  69312 */     // No operand predicates
     /*  69312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69314 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3705:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)  =>  (MVE_VSLIimm16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  69314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSLIimm16),
     /*  69317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69319 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69329 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69335 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69341 */     GIR_RootConstrainSelectedInstOperands,
     /*  69342 */     // GIR_Coverage, 3906,
     /*  69342 */     GIR_EraseRootFromParent_Done,
     /*  69343 */   // Label 1394: @69343
     /*  69343 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(69420), // Rule ID 3908 //
     /*  69348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsli),
     /*  69353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69385 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  69389 */     // MIs[1] Operand 1
     /*  69389 */     // No operand predicates
     /*  69389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69391 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3705:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)  =>  (MVE_VSLIimm32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  69391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSLIimm32),
     /*  69394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69396 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69400 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69406 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69412 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69418 */     GIR_RootConstrainSelectedInstOperands,
     /*  69419 */     // GIR_Coverage, 3908,
     /*  69419 */     GIR_EraseRootFromParent_Done,
     /*  69420 */   // Label 1395: @69420
     /*  69420 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(69497), // Rule ID 3910 //
     /*  69425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsri),
     /*  69430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69462 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  69466 */     // MIs[1] Operand 1
     /*  69466 */     // No operand predicates
     /*  69466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69468 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3707:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)  =>  (MVE_VSRIimm8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)
     /*  69468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSRIimm8),
     /*  69471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69473 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69483 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69489 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69495 */     GIR_RootConstrainSelectedInstOperands,
     /*  69496 */     // GIR_Coverage, 3910,
     /*  69496 */     GIR_EraseRootFromParent_Done,
     /*  69497 */   // Label 1396: @69497
     /*  69497 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(69574), // Rule ID 3912 //
     /*  69502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsri),
     /*  69507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69539 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  69543 */     // MIs[1] Operand 1
     /*  69543 */     // No operand predicates
     /*  69543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69545 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3707:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)  =>  (MVE_VSRIimm16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)
     /*  69545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSRIimm16),
     /*  69548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69550 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69554 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69560 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69566 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69572 */     GIR_RootConstrainSelectedInstOperands,
     /*  69573 */     // GIR_Coverage, 3912,
     /*  69573 */     GIR_EraseRootFromParent_Done,
     /*  69574 */   // Label 1397: @69574
     /*  69574 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(69651), // Rule ID 3914 //
     /*  69579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsri),
     /*  69584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69616 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm32),
     /*  69620 */     // MIs[1] Operand 1
     /*  69620 */     // No operand predicates
     /*  69620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69622 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3707:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)  =>  (MVE_VSRIimm32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)
     /*  69622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSRIimm32),
     /*  69625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69627 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69637 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69643 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69649 */     GIR_RootConstrainSelectedInstOperands,
     /*  69650 */     // GIR_Coverage, 3914,
     /*  69650 */     GIR_EraseRootFromParent_Done,
     /*  69651 */   // Label 1398: @69651
     /*  69651 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(69742), // Rule ID 4383 //
     /*  69656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  69659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmulq),
     /*  69664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  69676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69688 */     // MIs[1] Operand 1
     /*  69688 */     // No operand predicates
     /*  69688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69698 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3605:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm)  =>  (MVE_VCMULf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  69698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMULf16),
     /*  69713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69717 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qm
     /*  69719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  69722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69725 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69731 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69740 */     GIR_RootConstrainSelectedInstOperands,
     /*  69741 */     // GIR_Coverage, 4383,
     /*  69741 */     GIR_EraseRootFromParent_Done,
     /*  69742 */   // Label 1399: @69742
     /*  69742 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(69833), // Rule ID 4385 //
     /*  69747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  69750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmulq),
     /*  69755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  69767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69779 */     // MIs[1] Operand 1
     /*  69779 */     // No operand predicates
     /*  69779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69789 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3605:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm)  =>  (MVE_VCMULf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  69789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMULf32),
     /*  69804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69808 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qm
     /*  69810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  69813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69816 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69822 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69831 */     GIR_RootConstrainSelectedInstOperands,
     /*  69832 */     // GIR_Coverage, 4385,
     /*  69832 */     GIR_EraseRootFromParent_Done,
     /*  69833 */   // Label 1400: @69833
     /*  69833 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(69896), // Rule ID 146 //
     /*  69838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  69841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usada8),
     /*  69846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69874 */     // (intrinsic_wo_chain:{ *:[i32] } 3936:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (USADA8:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*  69874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USADA8),
     /*  69877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  69883 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  69885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  69888 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69894 */     GIR_RootConstrainSelectedInstOperands,
     /*  69895 */     // GIR_Coverage, 146,
     /*  69895 */     GIR_EraseRootFromParent_Done,
     /*  69896 */   // Label 1401: @69896
     /*  69896 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(69959), // Rule ID 469 //
     /*  69901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  69904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usada8),
     /*  69909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69937 */     // (intrinsic_wo_chain:{ *:[i32] } 3936:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2USADA8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  69937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USADA8),
     /*  69940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  69946 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  69948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  69951 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69957 */     GIR_RootConstrainSelectedInstOperands,
     /*  69958 */     // GIR_Coverage, 469,
     /*  69958 */     GIR_EraseRootFromParent_Done,
     /*  69959 */   // Label 1402: @69959
     /*  69959 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(70022), // Rule ID 528 //
     /*  69964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  69967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlad),
     /*  69972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70000 */     // (intrinsic_wo_chain:{ *:[i32] } 3881:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLAD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  70000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLAD),
     /*  70003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70009 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70014 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70020 */     GIR_RootConstrainSelectedInstOperands,
     /*  70021 */     // GIR_Coverage, 528,
     /*  70021 */     GIR_EraseRootFromParent_Done,
     /*  70022 */   // Label 1403: @70022
     /*  70022 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(70085), // Rule ID 529 //
     /*  70027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  70030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smladx),
     /*  70035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70063 */     // (intrinsic_wo_chain:{ *:[i32] } 3882:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLADX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  70063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLADX),
     /*  70066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70072 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70077 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70083 */     GIR_RootConstrainSelectedInstOperands,
     /*  70084 */     // GIR_Coverage, 529,
     /*  70084 */     GIR_EraseRootFromParent_Done,
     /*  70085 */   // Label 1404: @70085
     /*  70085 */   GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(70148), // Rule ID 530 //
     /*  70090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  70093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsd),
     /*  70098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70126 */     // (intrinsic_wo_chain:{ *:[i32] } 3889:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLSD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  70126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLSD),
     /*  70129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70135 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70140 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70146 */     GIR_RootConstrainSelectedInstOperands,
     /*  70147 */     // GIR_Coverage, 530,
     /*  70147 */     GIR_EraseRootFromParent_Done,
     /*  70148 */   // Label 1405: @70148
     /*  70148 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(70211), // Rule ID 531 //
     /*  70153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  70156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsdx),
     /*  70161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70189 */     // (intrinsic_wo_chain:{ *:[i32] } 3890:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLSDX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  70189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLSDX),
     /*  70192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70198 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70203 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70209 */     GIR_RootConstrainSelectedInstOperands,
     /*  70210 */     // GIR_Coverage, 531,
     /*  70210 */     GIR_EraseRootFromParent_Done,
     /*  70211 */   // Label 1406: @70211
     /*  70211 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(70265), // Rule ID 951 //
     /*  70216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_udot),
     /*  70224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  70227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  70230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70252 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3737:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VUDOTD:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUDOTD),
     /*  70255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70261 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70263 */     GIR_RootConstrainSelectedInstOperands,
     /*  70264 */     // GIR_Coverage, 951,
     /*  70264 */     GIR_EraseRootFromParent_Done,
     /*  70265 */   // Label 1407: @70265
     /*  70265 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(70319), // Rule ID 952 //
     /*  70270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sdot),
     /*  70278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  70281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  70284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70306 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3725:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VSDOTD:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSDOTD),
     /*  70309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70315 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70317 */     GIR_RootConstrainSelectedInstOperands,
     /*  70318 */     // GIR_Coverage, 952,
     /*  70318 */     GIR_EraseRootFromParent_Done,
     /*  70319 */   // Label 1408: @70319
     /*  70319 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(70373), // Rule ID 953 //
     /*  70324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_udot),
     /*  70332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70360 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3737:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUDOTQ:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUDOTQ),
     /*  70363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70369 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70371 */     GIR_RootConstrainSelectedInstOperands,
     /*  70372 */     // GIR_Coverage, 953,
     /*  70372 */     GIR_EraseRootFromParent_Done,
     /*  70373 */   // Label 1409: @70373
     /*  70373 */   GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(70427), // Rule ID 954 //
     /*  70378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sdot),
     /*  70386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70414 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3725:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VSDOTQ:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSDOTQ),
     /*  70417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70423 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70425 */     GIR_RootConstrainSelectedInstOperands,
     /*  70426 */     // GIR_Coverage, 954,
     /*  70426 */     GIR_EraseRootFromParent_Done,
     /*  70427 */   // Label 1410: @70427
     /*  70427 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(70481), // Rule ID 955 //
     /*  70432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_smmla),
     /*  70440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70468 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3736:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VSMMLA:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSMMLA),
     /*  70471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70477 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70479 */     GIR_RootConstrainSelectedInstOperands,
     /*  70480 */     // GIR_Coverage, 955,
     /*  70480 */     GIR_EraseRootFromParent_Done,
     /*  70481 */   // Label 1411: @70481
     /*  70481 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(70535), // Rule ID 956 //
     /*  70486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_ummla),
     /*  70494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70522 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3738:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUMMLA:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUMMLA),
     /*  70525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70531 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70533 */     GIR_RootConstrainSelectedInstOperands,
     /*  70534 */     // GIR_Coverage, 956,
     /*  70534 */     GIR_EraseRootFromParent_Done,
     /*  70535 */   // Label 1412: @70535
     /*  70535 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(70589), // Rule ID 957 //
     /*  70540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_usmmla),
     /*  70548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70576 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3740:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUSMMLA:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUSMMLA),
     /*  70579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70585 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70587 */     GIR_RootConstrainSelectedInstOperands,
     /*  70588 */     // GIR_Coverage, 957,
     /*  70588 */     GIR_EraseRootFromParent_Done,
     /*  70589 */   // Label 1413: @70589
     /*  70589 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(70643), // Rule ID 958 //
     /*  70594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_usdot),
     /*  70602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  70605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  70608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70630 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3739:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VUSDOTD:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUSDOTD),
     /*  70633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70639 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70641 */     GIR_RootConstrainSelectedInstOperands,
     /*  70642 */     // GIR_Coverage, 958,
     /*  70642 */     GIR_EraseRootFromParent_Done,
     /*  70643 */   // Label 1414: @70643
     /*  70643 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(70697), // Rule ID 959 //
     /*  70648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_usdot),
     /*  70656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70684 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3739:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUSDOTQ:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUSDOTQ),
     /*  70687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70693 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70695 */     GIR_RootConstrainSelectedInstOperands,
     /*  70696 */     // GIR_Coverage, 959,
     /*  70696 */     GIR_EraseRootFromParent_Done,
     /*  70697 */   // Label 1415: @70697
     /*  70697 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(70760), // Rule ID 1690 //
     /*  70702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx1),
     /*  70710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  70713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70738 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3856:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$orig, VecListOneD:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VTBX1:{ *:[v8i8] } DPR:{ *:[v8i8] }:$orig, VecListOneD:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX1),
     /*  70741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70743 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  70745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70747 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70752 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70758 */     GIR_RootConstrainSelectedInstOperands,
     /*  70759 */     // GIR_Coverage, 1690,
     /*  70759 */     GIR_EraseRootFromParent_Done,
     /*  70760 */   // Label 1416: @70760
     /*  70760 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(70814), // Rule ID 1721 //
     /*  70765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1su0),
     /*  70773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70801 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3730:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA1SU0:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1SU0),
     /*  70804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70806 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70810 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70812 */     GIR_RootConstrainSelectedInstOperands,
     /*  70813 */     // GIR_Coverage, 1721,
     /*  70813 */     GIR_EraseRootFromParent_Done,
     /*  70814 */   // Label 1417: @70814
     /*  70814 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(70868), // Rule ID 1722 //
     /*  70819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256h),
     /*  70827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70855 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3732:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256H:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256H),
     /*  70858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70860 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70864 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70866 */     GIR_RootConstrainSelectedInstOperands,
     /*  70867 */     // GIR_Coverage, 1722,
     /*  70867 */     GIR_EraseRootFromParent_Done,
     /*  70868 */   // Label 1418: @70868
     /*  70868 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(70922), // Rule ID 1723 //
     /*  70873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256h2),
     /*  70881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70909 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3733:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256H2:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256H2),
     /*  70912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70914 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70918 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70920 */     GIR_RootConstrainSelectedInstOperands,
     /*  70921 */     // GIR_Coverage, 1723,
     /*  70921 */     GIR_EraseRootFromParent_Done,
     /*  70922 */   // Label 1419: @70922
     /*  70922 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(70976), // Rule ID 1724 //
     /*  70927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256su1),
     /*  70935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70963 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3735:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256SU1:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256SU1),
     /*  70966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70968 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70972 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70974 */     GIR_RootConstrainSelectedInstOperands,
     /*  70975 */     // GIR_Coverage, 1724,
     /*  70975 */     GIR_EraseRootFromParent_Done,
     /*  70976 */   // Label 1420: @70976
     /*  70976 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(71039), // Rule ID 1899 //
     /*  70981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  70984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlad),
     /*  70989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71017 */     // (intrinsic_wo_chain:{ *:[i32] } 3881:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLAD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  71017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLAD),
     /*  71020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  71026 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  71028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71031 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71037 */     GIR_RootConstrainSelectedInstOperands,
     /*  71038 */     // GIR_Coverage, 1899,
     /*  71038 */     GIR_EraseRootFromParent_Done,
     /*  71039 */   // Label 1421: @71039
     /*  71039 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(71102), // Rule ID 1900 //
     /*  71044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  71047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smladx),
     /*  71052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71080 */     // (intrinsic_wo_chain:{ *:[i32] } 3882:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLADX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  71080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLADX),
     /*  71083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  71089 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  71091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71094 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71100 */     GIR_RootConstrainSelectedInstOperands,
     /*  71101 */     // GIR_Coverage, 1900,
     /*  71101 */     GIR_EraseRootFromParent_Done,
     /*  71102 */   // Label 1422: @71102
     /*  71102 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(71165), // Rule ID 1901 //
     /*  71107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  71110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsd),
     /*  71115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71143 */     // (intrinsic_wo_chain:{ *:[i32] } 3889:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLSD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  71143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLSD),
     /*  71146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  71152 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  71154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71157 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71163 */     GIR_RootConstrainSelectedInstOperands,
     /*  71164 */     // GIR_Coverage, 1901,
     /*  71164 */     GIR_EraseRootFromParent_Done,
     /*  71165 */   // Label 1423: @71165
     /*  71165 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(71228), // Rule ID 1902 //
     /*  71170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  71173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsdx),
     /*  71178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71206 */     // (intrinsic_wo_chain:{ *:[i32] } 3890:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLSDX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  71206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLSDX),
     /*  71209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  71215 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  71217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71220 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71226 */     GIR_RootConstrainSelectedInstOperands,
     /*  71227 */     // GIR_Coverage, 1902,
     /*  71227 */     GIR_EraseRootFromParent_Done,
     /*  71228 */   // Label 1424: @71228
     /*  71228 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(71291), // Rule ID 1990 //
     /*  71233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabb),
     /*  71241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71269 */     // (intrinsic_wo_chain:{ *:[i32] } 3879:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLABB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABB),
     /*  71272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71274 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71276 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71278 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71283 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71289 */     GIR_RootConstrainSelectedInstOperands,
     /*  71290 */     // GIR_Coverage, 1990,
     /*  71290 */     GIR_EraseRootFromParent_Done,
     /*  71291 */   // Label 1425: @71291
     /*  71291 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(71354), // Rule ID 1991 //
     /*  71296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabt),
     /*  71304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71332 */     // (intrinsic_wo_chain:{ *:[i32] } 3880:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLABT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*  71335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71337 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71339 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71341 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71346 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71352 */     GIR_RootConstrainSelectedInstOperands,
     /*  71353 */     // GIR_Coverage, 1991,
     /*  71353 */     GIR_EraseRootFromParent_Done,
     /*  71354 */   // Label 1426: @71354
     /*  71354 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(71417), // Rule ID 1992 //
     /*  71359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatb),
     /*  71367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71395 */     // (intrinsic_wo_chain:{ *:[i32] } 3885:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLATB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATB),
     /*  71398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71400 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71402 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71404 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71409 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71415 */     GIR_RootConstrainSelectedInstOperands,
     /*  71416 */     // GIR_Coverage, 1992,
     /*  71416 */     GIR_EraseRootFromParent_Done,
     /*  71417 */   // Label 1427: @71417
     /*  71417 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(71480), // Rule ID 1993 //
     /*  71422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatt),
     /*  71430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71458 */     // (intrinsic_wo_chain:{ *:[i32] } 3886:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLATT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATT),
     /*  71461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71463 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71465 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71467 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71472 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71478 */     GIR_RootConstrainSelectedInstOperands,
     /*  71479 */     // GIR_Coverage, 1993,
     /*  71479 */     GIR_EraseRootFromParent_Done,
     /*  71480 */   // Label 1428: @71480
     /*  71480 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(71543), // Rule ID 1994 //
     /*  71485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawb),
     /*  71493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71521 */     // (intrinsic_wo_chain:{ *:[i32] } 3887:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLAWB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLAWB),
     /*  71524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71526 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71528 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71530 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71535 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71541 */     GIR_RootConstrainSelectedInstOperands,
     /*  71542 */     // GIR_Coverage, 1994,
     /*  71542 */     GIR_EraseRootFromParent_Done,
     /*  71543 */   // Label 1429: @71543
     /*  71543 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(71606), // Rule ID 1995 //
     /*  71548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawt),
     /*  71556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71584 */     // (intrinsic_wo_chain:{ *:[i32] } 3888:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLAWT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLAWT),
     /*  71587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71589 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71591 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71593 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71598 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71604 */     GIR_RootConstrainSelectedInstOperands,
     /*  71605 */     // GIR_Coverage, 1995,
     /*  71605 */     GIR_EraseRootFromParent_Done,
     /*  71606 */   // Label 1430: @71606
     /*  71606 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(71669), // Rule ID 2181 //
     /*  71611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabb),
     /*  71619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71647 */     // (intrinsic_wo_chain:{ *:[i32] } 3879:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLABB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABB),
     /*  71650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71652 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71654 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71656 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71661 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71667 */     GIR_RootConstrainSelectedInstOperands,
     /*  71668 */     // GIR_Coverage, 2181,
     /*  71668 */     GIR_EraseRootFromParent_Done,
     /*  71669 */   // Label 1431: @71669
     /*  71669 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(71732), // Rule ID 2182 //
     /*  71674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabt),
     /*  71682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71710 */     // (intrinsic_wo_chain:{ *:[i32] } 3880:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLABT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*  71713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71715 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71717 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71719 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71724 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71730 */     GIR_RootConstrainSelectedInstOperands,
     /*  71731 */     // GIR_Coverage, 2182,
     /*  71731 */     GIR_EraseRootFromParent_Done,
     /*  71732 */   // Label 1432: @71732
     /*  71732 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(71795), // Rule ID 2183 //
     /*  71737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatb),
     /*  71745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71773 */     // (intrinsic_wo_chain:{ *:[i32] } 3885:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLATB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATB),
     /*  71776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71778 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71780 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71782 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71787 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71793 */     GIR_RootConstrainSelectedInstOperands,
     /*  71794 */     // GIR_Coverage, 2183,
     /*  71794 */     GIR_EraseRootFromParent_Done,
     /*  71795 */   // Label 1433: @71795
     /*  71795 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(71858), // Rule ID 2184 //
     /*  71800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatt),
     /*  71808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71836 */     // (intrinsic_wo_chain:{ *:[i32] } 3886:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLATT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATT),
     /*  71839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71841 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71843 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71845 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71850 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71856 */     GIR_RootConstrainSelectedInstOperands,
     /*  71857 */     // GIR_Coverage, 2184,
     /*  71857 */     GIR_EraseRootFromParent_Done,
     /*  71858 */   // Label 1434: @71858
     /*  71858 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(71921), // Rule ID 2185 //
     /*  71863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawb),
     /*  71871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71899 */     // (intrinsic_wo_chain:{ *:[i32] } 3887:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLAWB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLAWB),
     /*  71902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71904 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71906 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71908 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71913 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71919 */     GIR_RootConstrainSelectedInstOperands,
     /*  71920 */     // GIR_Coverage, 2185,
     /*  71920 */     GIR_EraseRootFromParent_Done,
     /*  71921 */   // Label 1435: @71921
     /*  71921 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(71984), // Rule ID 2186 //
     /*  71926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawt),
     /*  71934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71962 */     // (intrinsic_wo_chain:{ *:[i32] } 3888:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLAWT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLAWT),
     /*  71965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71967 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71969 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71971 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71976 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71982 */     GIR_RootConstrainSelectedInstOperands,
     /*  71983 */     // GIR_Coverage, 2186,
     /*  71983 */     GIR_EraseRootFromParent_Done,
     /*  71984 */   // Label 1436: @71984
     /*  71984 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(72047), // Rule ID 2472 //
     /*  71989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  71992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  71997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  72000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  72003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  72006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /*  72009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72025 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3809:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQRDMLAHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  72025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv4i16),
     /*  72028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72030 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72034 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72039 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72045 */     GIR_RootConstrainSelectedInstOperands,
     /*  72046 */     // GIR_Coverage, 2472,
     /*  72046 */     GIR_EraseRootFromParent_Done,
     /*  72047 */   // Label 1437: @72047
     /*  72047 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(72110), // Rule ID 2473 //
     /*  72052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  72060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  72063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  72066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  72069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /*  72072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72088 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3809:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQRDMLAHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  72088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv2i32),
     /*  72091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72093 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72097 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72102 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72108 */     GIR_RootConstrainSelectedInstOperands,
     /*  72109 */     // GIR_Coverage, 2473,
     /*  72109 */     GIR_EraseRootFromParent_Done,
     /*  72110 */   // Label 1438: @72110
     /*  72110 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(72173), // Rule ID 2474 //
     /*  72115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  72123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  72135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72151 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3809:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQRDMLAHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  72151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv8i16),
     /*  72154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72156 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72160 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72165 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72171 */     GIR_RootConstrainSelectedInstOperands,
     /*  72172 */     // GIR_Coverage, 2474,
     /*  72172 */     GIR_EraseRootFromParent_Done,
     /*  72173 */   // Label 1439: @72173
     /*  72173 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(72236), // Rule ID 2475 //
     /*  72178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  72186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  72198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72214 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3809:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQRDMLAHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  72214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv4i32),
     /*  72217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72219 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72223 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72228 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72234 */     GIR_RootConstrainSelectedInstOperands,
     /*  72235 */     // GIR_Coverage, 2475,
     /*  72235 */     GIR_EraseRootFromParent_Done,
     /*  72236 */   // Label 1440: @72236
     /*  72236 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(72299), // Rule ID 2480 //
     /*  72241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  72252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  72255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  72258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /*  72261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72277 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3810:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQRDMLSHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  72277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv4i16),
     /*  72280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72282 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72286 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72291 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72297 */     GIR_RootConstrainSelectedInstOperands,
     /*  72298 */     // GIR_Coverage, 2480,
     /*  72298 */     GIR_EraseRootFromParent_Done,
     /*  72299 */   // Label 1441: @72299
     /*  72299 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(72362), // Rule ID 2481 //
     /*  72304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  72315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  72318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  72321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /*  72324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72340 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3810:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQRDMLSHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  72340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv2i32),
     /*  72343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72345 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72349 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72354 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72360 */     GIR_RootConstrainSelectedInstOperands,
     /*  72361 */     // GIR_Coverage, 2481,
     /*  72361 */     GIR_EraseRootFromParent_Done,
     /*  72362 */   // Label 1442: @72362
     /*  72362 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(72425), // Rule ID 2482 //
     /*  72367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  72387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72403 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3810:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQRDMLSHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  72403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv8i16),
     /*  72406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72408 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72412 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72417 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72423 */     GIR_RootConstrainSelectedInstOperands,
     /*  72424 */     // GIR_Coverage, 2482,
     /*  72424 */     GIR_EraseRootFromParent_Done,
     /*  72425 */   // Label 1443: @72425
     /*  72425 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(72488), // Rule ID 2483 //
     /*  72430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  72450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72466 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3810:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQRDMLSHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  72466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv4i32),
     /*  72469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72471 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72475 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72480 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72486 */     GIR_RootConstrainSelectedInstOperands,
     /*  72487 */     // GIR_Coverage, 2483,
     /*  72487 */     GIR_EraseRootFromParent_Done,
     /*  72488 */   // Label 1444: @72488
     /*  72488 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(72557), // Rule ID 4840 //
     /*  72493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlah),
     /*  72501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72529 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3661:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLAH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLAH_qrs8),
     /*  72532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72534 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72536 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72538 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72543 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72549 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72555 */     GIR_RootConstrainSelectedInstOperands,
     /*  72556 */     // GIR_Coverage, 4840,
     /*  72556 */     GIR_EraseRootFromParent_Done,
     /*  72557 */   // Label 1445: @72557
     /*  72557 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(72626), // Rule ID 4842 //
     /*  72562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlah),
     /*  72570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72598 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3661:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLAH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLAH_qrs16),
     /*  72601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72603 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72605 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72607 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72612 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72618 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72624 */     GIR_RootConstrainSelectedInstOperands,
     /*  72625 */     // GIR_Coverage, 4842,
     /*  72625 */     GIR_EraseRootFromParent_Done,
     /*  72626 */   // Label 1446: @72626
     /*  72626 */   GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(72695), // Rule ID 4844 //
     /*  72631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlah),
     /*  72639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72667 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3661:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLAH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLAH_qrs32),
     /*  72670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72672 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72674 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72676 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72681 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72687 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72693 */     GIR_RootConstrainSelectedInstOperands,
     /*  72694 */     // GIR_Coverage, 4844,
     /*  72694 */     GIR_EraseRootFromParent_Done,
     /*  72695 */   // Label 1447: @72695
     /*  72695 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(72764), // Rule ID 4846 //
     /*  72700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlah),
     /*  72708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72736 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3670:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLAH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLAH_qrs8),
     /*  72739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72741 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72743 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72745 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72750 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72756 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72762 */     GIR_RootConstrainSelectedInstOperands,
     /*  72763 */     // GIR_Coverage, 4846,
     /*  72763 */     GIR_EraseRootFromParent_Done,
     /*  72764 */   // Label 1448: @72764
     /*  72764 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(72833), // Rule ID 4848 //
     /*  72769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlah),
     /*  72777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72805 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3670:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLAH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLAH_qrs16),
     /*  72808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72810 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72812 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72814 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72819 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72825 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72831 */     GIR_RootConstrainSelectedInstOperands,
     /*  72832 */     // GIR_Coverage, 4848,
     /*  72832 */     GIR_EraseRootFromParent_Done,
     /*  72833 */   // Label 1449: @72833
     /*  72833 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(72902), // Rule ID 4850 //
     /*  72838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlah),
     /*  72846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72874 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3670:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLAH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLAH_qrs32),
     /*  72877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72879 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72881 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72883 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72888 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72894 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72900 */     GIR_RootConstrainSelectedInstOperands,
     /*  72901 */     // GIR_Coverage, 4850,
     /*  72901 */     GIR_EraseRootFromParent_Done,
     /*  72902 */   // Label 1450: @72902
     /*  72902 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(72971), // Rule ID 4852 //
     /*  72907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlash),
     /*  72915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72943 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3663:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLASH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLASH_qrs8),
     /*  72946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72948 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72950 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72952 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72957 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72963 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72969 */     GIR_RootConstrainSelectedInstOperands,
     /*  72970 */     // GIR_Coverage, 4852,
     /*  72970 */     GIR_EraseRootFromParent_Done,
     /*  72971 */   // Label 1451: @72971
     /*  72971 */   GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(73040), // Rule ID 4854 //
     /*  72976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlash),
     /*  72984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73012 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3663:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLASH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLASH_qrs16),
     /*  73015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73017 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73019 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73021 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73026 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73032 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73038 */     GIR_RootConstrainSelectedInstOperands,
     /*  73039 */     // GIR_Coverage, 4854,
     /*  73039 */     GIR_EraseRootFromParent_Done,
     /*  73040 */   // Label 1452: @73040
     /*  73040 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(73109), // Rule ID 4856 //
     /*  73045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlash),
     /*  73053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  73062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73081 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3663:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLASH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLASH_qrs32),
     /*  73084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73086 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73088 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73090 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73095 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73101 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73107 */     GIR_RootConstrainSelectedInstOperands,
     /*  73108 */     // GIR_Coverage, 4856,
     /*  73108 */     GIR_EraseRootFromParent_Done,
     /*  73109 */   // Label 1453: @73109
     /*  73109 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(73178), // Rule ID 4858 //
     /*  73114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlash),
     /*  73122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  73125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73150 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3672:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLASH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLASH_qrs8),
     /*  73153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73155 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73157 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73159 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73164 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73170 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73176 */     GIR_RootConstrainSelectedInstOperands,
     /*  73177 */     // GIR_Coverage, 4858,
     /*  73177 */     GIR_EraseRootFromParent_Done,
     /*  73178 */   // Label 1454: @73178
     /*  73178 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(73247), // Rule ID 4860 //
     /*  73183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlash),
     /*  73191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  73200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73219 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3672:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLASH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLASH_qrs16),
     /*  73222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73224 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73226 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73228 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73233 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73239 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73245 */     GIR_RootConstrainSelectedInstOperands,
     /*  73246 */     // GIR_Coverage, 4860,
     /*  73246 */     GIR_EraseRootFromParent_Done,
     /*  73247 */   // Label 1455: @73247
     /*  73247 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(73316), // Rule ID 4862 //
     /*  73252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlash),
     /*  73260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  73269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73288 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3672:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLASH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLASH_qrs32),
     /*  73291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73293 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73295 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73297 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73302 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73308 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73314 */     GIR_RootConstrainSelectedInstOperands,
     /*  73315 */     // GIR_Coverage, 4862,
     /*  73315 */     GIR_EraseRootFromParent_Done,
     /*  73316 */   // Label 1456: @73316
     /*  73316 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(73411), // Rule ID 2694 //
     /*  73321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1c),
     /*  73329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  73341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  73345 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3726:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$hash_abcd, i32:{ *:[i32] }:$hash_e, v4i32:{ *:[v4i32] }:$wk)  =>  (SHA1C:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$hash_abcd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$hash_e, SPR:{ *:[i32] }), ssub_0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$wk)
     /*  73345 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  73348 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73352 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73357 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // hash_e
     /*  73361 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  73369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  73373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73378 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  73381 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  73384 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/17,
     /*  73387 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  73392 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1C),
     /*  73400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73402 */     GIR_RootToRootCopy, /*OpIdx*/2, // hash_abcd
     /*  73404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73407 */     GIR_RootToRootCopy, /*OpIdx*/4, // wk
     /*  73409 */     GIR_RootConstrainSelectedInstOperands,
     /*  73410 */     // GIR_Coverage, 2694,
     /*  73410 */     GIR_EraseRootFromParent_Done,
     /*  73411 */   // Label 1457: @73411
     /*  73411 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(73506), // Rule ID 2695 //
     /*  73416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1m),
     /*  73424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  73436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  73440 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3728:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$hash_abcd, i32:{ *:[i32] }:$hash_e, v4i32:{ *:[v4i32] }:$wk)  =>  (SHA1M:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$hash_abcd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$hash_e, SPR:{ *:[i32] }), ssub_0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$wk)
     /*  73440 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  73443 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73447 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73452 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // hash_e
     /*  73456 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  73464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  73468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73473 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  73476 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  73479 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/17,
     /*  73482 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  73487 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1M),
     /*  73495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73497 */     GIR_RootToRootCopy, /*OpIdx*/2, // hash_abcd
     /*  73499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73502 */     GIR_RootToRootCopy, /*OpIdx*/4, // wk
     /*  73504 */     GIR_RootConstrainSelectedInstOperands,
     /*  73505 */     // GIR_Coverage, 2695,
     /*  73505 */     GIR_EraseRootFromParent_Done,
     /*  73506 */   // Label 1458: @73506
     /*  73506 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(73601), // Rule ID 2696 //
     /*  73511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1p),
     /*  73519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  73531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  73535 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3729:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$hash_abcd, i32:{ *:[i32] }:$hash_e, v4i32:{ *:[v4i32] }:$wk)  =>  (SHA1P:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$hash_abcd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$hash_e, SPR:{ *:[i32] }), ssub_0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$wk)
     /*  73535 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  73538 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73542 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73547 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // hash_e
     /*  73551 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  73559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  73563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73568 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  73571 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  73574 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/17,
     /*  73577 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  73582 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1P),
     /*  73590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73592 */     GIR_RootToRootCopy, /*OpIdx*/2, // hash_abcd
     /*  73594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73597 */     GIR_RootToRootCopy, /*OpIdx*/4, // wk
     /*  73599 */     GIR_RootConstrainSelectedInstOperands,
     /*  73600 */     // GIR_Coverage, 2696,
     /*  73600 */     GIR_EraseRootFromParent_Done,
     /*  73601 */   // Label 1459: @73601
     /*  73601 */   GIM_Reject,
     /*  73602 */ // Label 1312: @73602
     /*  73602 */ GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(76988),
     /*  73607 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  73610 */   GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(73694), // Rule ID 3727 //
     /*  73615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73643 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  73647 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73651 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73655 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3701:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lws8bh:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  73655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws8bh),
     /*  73670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73672 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73677 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73683 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73692 */     GIR_RootConstrainSelectedInstOperands,
     /*  73693 */     // GIR_Coverage, 3727,
     /*  73693 */     GIR_EraseRootFromParent_Done,
     /*  73694 */   // Label 1461: @73694
     /*  73694 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(73778), // Rule ID 3731 //
     /*  73699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73727 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  73731 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73735 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  73739 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3701:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lws8th:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  73739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws8th),
     /*  73754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73756 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73761 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73767 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73776 */     GIR_RootConstrainSelectedInstOperands,
     /*  73777 */     // GIR_Coverage, 3731,
     /*  73777 */     GIR_EraseRootFromParent_Done,
     /*  73778 */   // Label 1462: @73778
     /*  73778 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(73862), // Rule ID 3735 //
     /*  73783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73811 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  73815 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73819 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73823 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3701:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lws16bh:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  73823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws16bh),
     /*  73838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73840 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73845 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73851 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73860 */     GIR_RootConstrainSelectedInstOperands,
     /*  73861 */     // GIR_Coverage, 3735,
     /*  73861 */     GIR_EraseRootFromParent_Done,
     /*  73862 */   // Label 1463: @73862
     /*  73862 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(73946), // Rule ID 3739 //
     /*  73867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73895 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  73899 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73903 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  73907 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3701:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lws16th:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  73907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws16th),
     /*  73922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73924 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73929 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73935 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73944 */     GIR_RootConstrainSelectedInstOperands,
     /*  73945 */     // GIR_Coverage, 3739,
     /*  73945 */     GIR_EraseRootFromParent_Done,
     /*  73946 */   // Label 1464: @73946
     /*  73946 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(74030), // Rule ID 3743 //
     /*  73951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73979 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  73983 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  73987 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73991 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3701:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lwu8bh:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  73991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu8bh),
     /*  74006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74008 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  74010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74013 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74019 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74028 */     GIR_RootConstrainSelectedInstOperands,
     /*  74029 */     // GIR_Coverage, 3743,
     /*  74029 */     GIR_EraseRootFromParent_Done,
     /*  74030 */   // Label 1465: @74030
     /*  74030 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(74114), // Rule ID 3747 //
     /*  74035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  74040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74063 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  74067 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74071 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74075 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3701:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lwu8th:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  74075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu8th),
     /*  74090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74092 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  74094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74097 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74103 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74112 */     GIR_RootConstrainSelectedInstOperands,
     /*  74113 */     // GIR_Coverage, 3747,
     /*  74113 */     GIR_EraseRootFromParent_Done,
     /*  74114 */   // Label 1466: @74114
     /*  74114 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(74198), // Rule ID 3751 //
     /*  74119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  74124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74147 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  74151 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74155 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74159 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3701:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lwu16bh:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  74159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu16bh),
     /*  74174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74176 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  74178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74181 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74187 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74196 */     GIR_RootConstrainSelectedInstOperands,
     /*  74197 */     // GIR_Coverage, 3751,
     /*  74197 */     GIR_EraseRootFromParent_Done,
     /*  74198 */   // Label 1467: @74198
     /*  74198 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(74282), // Rule ID 3755 //
     /*  74203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  74208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74231 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  74235 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74239 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74243 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3701:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lwu16th:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  74243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu16th),
     /*  74258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74260 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  74262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74265 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74271 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74280 */     GIR_RootConstrainSelectedInstOperands,
     /*  74281 */     // GIR_Coverage, 3755,
     /*  74281 */     GIR_EraseRootFromParent_Done,
     /*  74282 */   // Label 1468: @74282
     /*  74282 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(74371), // Rule ID 4387 //
     /*  74287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74322 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74326 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74330 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3657:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBs8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs8),
     /*  74345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74354 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74360 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74369 */     GIR_RootConstrainSelectedInstOperands,
     /*  74370 */     // GIR_Coverage, 4387,
     /*  74370 */     GIR_EraseRootFromParent_Done,
     /*  74371 */   // Label 1469: @74371
     /*  74371 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(74460), // Rule ID 4389 //
     /*  74376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74411 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74415 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74419 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3657:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTs8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTs8),
     /*  74434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74443 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74449 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74458 */     GIR_RootConstrainSelectedInstOperands,
     /*  74459 */     // GIR_Coverage, 4389,
     /*  74459 */     GIR_EraseRootFromParent_Done,
     /*  74460 */   // Label 1470: @74460
     /*  74460 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(74549), // Rule ID 4391 //
     /*  74465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  74482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74500 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74504 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74508 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3657:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBs16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  74508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs16),
     /*  74523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74532 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74538 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74547 */     GIR_RootConstrainSelectedInstOperands,
     /*  74548 */     // GIR_Coverage, 4391,
     /*  74548 */     GIR_EraseRootFromParent_Done,
     /*  74549 */   // Label 1471: @74549
     /*  74549 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(74638), // Rule ID 4393 //
     /*  74554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  74571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74589 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74593 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74597 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3657:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTs16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  74597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTs16),
     /*  74612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74621 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74627 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74636 */     GIR_RootConstrainSelectedInstOperands,
     /*  74637 */     // GIR_Coverage, 4393,
     /*  74637 */     GIR_EraseRootFromParent_Done,
     /*  74638 */   // Label 1472: @74638
     /*  74638 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(74727), // Rule ID 4395 //
     /*  74643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  74660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74678 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74682 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74686 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3657:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBs32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  74686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs32),
     /*  74701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74710 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74716 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74725 */     GIR_RootConstrainSelectedInstOperands,
     /*  74726 */     // GIR_Coverage, 4395,
     /*  74726 */     GIR_EraseRootFromParent_Done,
     /*  74727 */   // Label 1473: @74727
     /*  74727 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(74816), // Rule ID 4397 //
     /*  74732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  74749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74767 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74771 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74775 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3657:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTs32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  74775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTs32),
     /*  74790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74799 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74805 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74814 */     GIR_RootConstrainSelectedInstOperands,
     /*  74815 */     // GIR_Coverage, 4397,
     /*  74815 */     GIR_EraseRootFromParent_Done,
     /*  74816 */   // Label 1474: @74816
     /*  74816 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(74905), // Rule ID 4399 //
     /*  74821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74856 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74860 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74864 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3657:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBu8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBu8),
     /*  74879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74888 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74894 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74903 */     GIR_RootConstrainSelectedInstOperands,
     /*  74904 */     // GIR_Coverage, 4399,
     /*  74904 */     GIR_EraseRootFromParent_Done,
     /*  74905 */   // Label 1475: @74905
     /*  74905 */   GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(74994), // Rule ID 4401 //
     /*  74910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74945 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74949 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74953 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3657:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTu8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTu8),
     /*  74968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74977 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74983 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74992 */     GIR_RootConstrainSelectedInstOperands,
     /*  74993 */     // GIR_Coverage, 4401,
     /*  74993 */     GIR_EraseRootFromParent_Done,
     /*  74994 */   // Label 1476: @74994
     /*  74994 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(75083), // Rule ID 4403 //
     /*  74999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  75007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  75016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  75022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75034 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  75038 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  75042 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3657:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBu16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  75042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBu16),
     /*  75057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75066 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75072 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75081 */     GIR_RootConstrainSelectedInstOperands,
     /*  75082 */     // GIR_Coverage, 4403,
     /*  75082 */     GIR_EraseRootFromParent_Done,
     /*  75083 */   // Label 1477: @75083
     /*  75083 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(75172), // Rule ID 4405 //
     /*  75088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  75096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  75105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  75111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75123 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  75127 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  75131 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3657:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTu16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  75131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTu16),
     /*  75146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75155 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75161 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75170 */     GIR_RootConstrainSelectedInstOperands,
     /*  75171 */     // GIR_Coverage, 4405,
     /*  75171 */     GIR_EraseRootFromParent_Done,
     /*  75172 */   // Label 1478: @75172
     /*  75172 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(75261), // Rule ID 4407 //
     /*  75177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  75185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  75188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  75200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75212 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  75216 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  75220 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3657:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBu32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  75220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBu32),
     /*  75235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75244 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75250 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75256 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75259 */     GIR_RootConstrainSelectedInstOperands,
     /*  75260 */     // GIR_Coverage, 4407,
     /*  75260 */     GIR_EraseRootFromParent_Done,
     /*  75261 */   // Label 1479: @75261
     /*  75261 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(75350), // Rule ID 4409 //
     /*  75266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  75274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  75277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  75289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75301 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  75305 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  75309 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3657:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTu32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  75309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTu32),
     /*  75324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75333 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75339 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75348 */     GIR_RootConstrainSelectedInstOperands,
     /*  75349 */     // GIR_Coverage, 4409,
     /*  75349 */     GIR_EraseRootFromParent_Done,
     /*  75350 */   // Label 1480: @75350
     /*  75350 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(75448), // Rule ID 4032 //
     /*  75355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  75358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  75378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75382 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75394 */     // MIs[1] Operand 1
     /*  75394 */     // No operand predicates
     /*  75394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75404 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3600:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm)  =>  (MVE_VCADDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDf16),
     /*  75419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75421 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75423 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75431 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75437 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75446 */     GIR_RootConstrainSelectedInstOperands,
     /*  75447 */     // GIR_Coverage, 4032,
     /*  75447 */     GIR_EraseRootFromParent_Done,
     /*  75448 */   // Label 1481: @75448
     /*  75448 */   GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(75546), // Rule ID 4034 //
     /*  75453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  75456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  75476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75480 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75492 */     // MIs[1] Operand 1
     /*  75492 */     // No operand predicates
     /*  75492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75502 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3600:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm)  =>  (MVE_VCADDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDf32),
     /*  75517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75519 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75521 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75529 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75535 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75544 */     GIR_RootConstrainSelectedInstOperands,
     /*  75545 */     // GIR_Coverage, 4034,
     /*  75545 */     GIR_EraseRootFromParent_Done,
     /*  75546 */   // Label 1482: @75546
     /*  75546 */   GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(75644), // Rule ID 4541 //
     /*  75551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  75574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75578 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75590 */     // MIs[1] Operand 1
     /*  75590 */     // No operand predicates
     /*  75590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75600 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3600:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VCADDi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDi8),
     /*  75615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75617 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75619 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75627 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75633 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75642 */     GIR_RootConstrainSelectedInstOperands,
     /*  75643 */     // GIR_Coverage, 4541,
     /*  75643 */     GIR_EraseRootFromParent_Done,
     /*  75644 */   // Label 1483: @75644
     /*  75644 */   GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(75742), // Rule ID 4543 //
     /*  75649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  75672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75676 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75688 */     // MIs[1] Operand 1
     /*  75688 */     // No operand predicates
     /*  75688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75698 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3600:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VCADDi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDi16),
     /*  75713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75715 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75717 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75725 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75731 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75740 */     GIR_RootConstrainSelectedInstOperands,
     /*  75741 */     // GIR_Coverage, 4543,
     /*  75741 */     GIR_EraseRootFromParent_Done,
     /*  75742 */   // Label 1484: @75742
     /*  75742 */   GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(75840), // Rule ID 4545 //
     /*  75747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  75770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75774 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75786 */     // MIs[1] Operand 1
     /*  75786 */     // No operand predicates
     /*  75786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75796 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3600:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VCADDi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDi32),
     /*  75811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75813 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75815 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75823 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75829 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75838 */     GIR_RootConstrainSelectedInstOperands,
     /*  75839 */     // GIR_Coverage, 4545,
     /*  75839 */     GIR_EraseRootFromParent_Done,
     /*  75840 */   // Label 1485: @75840
     /*  75840 */   GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(75938), // Rule ID 4547 //
     /*  75845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  75868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75872 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  75876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75884 */     // MIs[1] Operand 1
     /*  75884 */     // No operand predicates
     /*  75884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75894 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3600:{ *:[iPTR] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VHCADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHCADDs8),
     /*  75909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75911 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75913 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75921 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75927 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75936 */     GIR_RootConstrainSelectedInstOperands,
     /*  75937 */     // GIR_Coverage, 4547,
     /*  75937 */     GIR_EraseRootFromParent_Done,
     /*  75938 */   // Label 1486: @75938
     /*  75938 */   GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(76036), // Rule ID 4549 //
     /*  75943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  75966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75970 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  75974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75982 */     // MIs[1] Operand 1
     /*  75982 */     // No operand predicates
     /*  75982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75992 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3600:{ *:[iPTR] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VHCADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHCADDs16),
     /*  76007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76009 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76011 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76019 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76025 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76034 */     GIR_RootConstrainSelectedInstOperands,
     /*  76035 */     // GIR_Coverage, 4549,
     /*  76035 */     GIR_EraseRootFromParent_Done,
     /*  76036 */   // Label 1487: @76036
     /*  76036 */   GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(76134), // Rule ID 4551 //
     /*  76041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  76049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76068 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  76072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  76076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  76080 */     // MIs[1] Operand 1
     /*  76080 */     // No operand predicates
     /*  76080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76090 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3600:{ *:[iPTR] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VHCADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  76090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  76093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHCADDs32),
     /*  76105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76107 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76109 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76117 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76123 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76132 */     GIR_RootConstrainSelectedInstOperands,
     /*  76133 */     // GIR_Coverage, 4551,
     /*  76133 */     GIR_EraseRootFromParent_Done,
     /*  76134 */   // Label 1488: @76134
     /*  76134 */   GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(76210), // Rule ID 3037 //
     /*  76139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  76159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  76162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76166 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  76170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76182 */     // (intrinsic_wo_chain:{ *:[i32] } 3593:{ *:[iPTR] }, 0:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VABAVs8:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  76182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVs8),
     /*  76185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76189 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76191 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76196 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76202 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76208 */     GIR_RootConstrainSelectedInstOperands,
     /*  76209 */     // GIR_Coverage, 3037,
     /*  76209 */     GIR_EraseRootFromParent_Done,
     /*  76210 */   // Label 1489: @76210
     /*  76210 */   GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(76286), // Rule ID 3039 //
     /*  76215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  76235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  76238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76242 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  76246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76258 */     // (intrinsic_wo_chain:{ *:[i32] } 3593:{ *:[iPTR] }, 0:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VABAVs16:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  76258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVs16),
     /*  76261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76265 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76267 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76272 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76278 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76284 */     GIR_RootConstrainSelectedInstOperands,
     /*  76285 */     // GIR_Coverage, 3039,
     /*  76285 */     GIR_EraseRootFromParent_Done,
     /*  76286 */   // Label 1490: @76286
     /*  76286 */   GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(76362), // Rule ID 3041 //
     /*  76291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76318 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  76322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76334 */     // (intrinsic_wo_chain:{ *:[i32] } 3593:{ *:[iPTR] }, 0:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VABAVs32:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  76334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVs32),
     /*  76337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76341 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76343 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76348 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76354 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76360 */     GIR_RootConstrainSelectedInstOperands,
     /*  76361 */     // GIR_Coverage, 3041,
     /*  76361 */     GIR_EraseRootFromParent_Done,
     /*  76362 */   // Label 1491: @76362
     /*  76362 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(76438), // Rule ID 3043 //
     /*  76367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  76387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  76390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76394 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  76398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76410 */     // (intrinsic_wo_chain:{ *:[i32] } 3593:{ *:[iPTR] }, 1:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VABAVu8:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  76410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVu8),
     /*  76413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76417 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76419 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76424 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76430 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76436 */     GIR_RootConstrainSelectedInstOperands,
     /*  76437 */     // GIR_Coverage, 3043,
     /*  76437 */     GIR_EraseRootFromParent_Done,
     /*  76438 */   // Label 1492: @76438
     /*  76438 */   GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(76514), // Rule ID 3045 //
     /*  76443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  76463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  76466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76470 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  76474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76486 */     // (intrinsic_wo_chain:{ *:[i32] } 3593:{ *:[iPTR] }, 1:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VABAVu16:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  76486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVu16),
     /*  76489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76493 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76495 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76500 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76506 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76512 */     GIR_RootConstrainSelectedInstOperands,
     /*  76513 */     // GIR_Coverage, 3045,
     /*  76513 */     GIR_EraseRootFromParent_Done,
     /*  76514 */   // Label 1493: @76514
     /*  76514 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(76590), // Rule ID 3047 //
     /*  76519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76546 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  76550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76562 */     // (intrinsic_wo_chain:{ *:[i32] } 3593:{ *:[iPTR] }, 1:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VABAVu32:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  76562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVu32),
     /*  76565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76567 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76569 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76571 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76576 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76582 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76588 */     GIR_RootConstrainSelectedInstOperands,
     /*  76589 */     // GIR_Coverage, 3047,
     /*  76589 */     GIR_EraseRootFromParent_Done,
     /*  76590 */   // Label 1494: @76590
     /*  76590 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(76675), // Rule ID 3996 //
     /*  76595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  76598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmlaq),
     /*  76603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  76606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  76612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  76615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  76618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  76630 */     // MIs[1] Operand 1
     /*  76630 */     // No operand predicates
     /*  76630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76644 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3603:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm)  =>  (MVE_VCMLAf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  76644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMLAf16),
     /*  76647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qd_src
     /*  76651 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76653 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76661 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76667 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76673 */     GIR_RootConstrainSelectedInstOperands,
     /*  76674 */     // GIR_Coverage, 3996,
     /*  76674 */     GIR_EraseRootFromParent_Done,
     /*  76675 */   // Label 1495: @76675
     /*  76675 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(76760), // Rule ID 3999 //
     /*  76680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  76683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmlaq),
     /*  76688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  76697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  76715 */     // MIs[1] Operand 1
     /*  76715 */     // No operand predicates
     /*  76715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76729 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3603:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4f32] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm)  =>  (MVE_VCMLAf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  76729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMLAf32),
     /*  76732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qd_src
     /*  76736 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76738 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76752 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76758 */     GIR_RootConstrainSelectedInstOperands,
     /*  76759 */     // GIR_Coverage, 3999,
     /*  76759 */     GIR_EraseRootFromParent_Done,
     /*  76760 */   // Label 1496: @76760
     /*  76760 */   GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(76856), // Rule ID 2688 //
     /*  76765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx2),
     /*  76773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  76776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  76782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  76785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  76788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  76792 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3857:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$orig, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBX2:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$orig, (REG_SEQUENCE:{ *:[v16i8] } DPair:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  76792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  76795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  76799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76804 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn0
     /*  76808 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  76811 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn1
     /*  76815 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  76818 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPairRegClassID),
     /*  76823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76828 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX2),
     /*  76836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76838 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  76840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76843 */     GIR_RootToRootCopy, /*OpIdx*/5, // Vm
     /*  76845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  76848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76854 */     GIR_RootConstrainSelectedInstOperands,
     /*  76855 */     // GIR_Coverage, 2688,
     /*  76855 */     GIR_EraseRootFromParent_Done,
     /*  76856 */   // Label 1497: @76856
     /*  76856 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(76987), // Rule ID 2689 //
     /*  76861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbl3),
     /*  76869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  76872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  76878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  76881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  76884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  76888 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3854:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBL3Pseudo:{ *:[v8i8] } (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, (IMPLICIT_DEF:{ *:[v8i8] }), dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  76888 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s8,
     /*  76891 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76895 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  76902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  76905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  76909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76914 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Vn0
     /*  76918 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  76921 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn1
     /*  76925 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  76928 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn2
     /*  76932 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  76935 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  76938 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  76941 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  76946 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76951 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76956 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76961 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBL3Pseudo),
     /*  76969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76974 */     GIR_RootToRootCopy, /*OpIdx*/5, // Vm
     /*  76976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  76979 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76985 */     GIR_RootConstrainSelectedInstOperands,
     /*  76986 */     // GIR_Coverage, 2689,
     /*  76986 */     GIR_EraseRootFromParent_Done,
     /*  76987 */   // Label 1498: @76987
     /*  76987 */   GIM_Reject,
     /*  76988 */ // Label 1460: @76988
     /*  76988 */ GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(82294),
     /*  76993 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /*  76996 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(77089), // Rule ID 3838 //
     /*  77001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77040 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77044 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77048 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3697:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecs8),
     /*  77063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77065 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77067 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77072 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77078 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77087 */     GIR_RootConstrainSelectedInstOperands,
     /*  77088 */     // GIR_Coverage, 3838,
     /*  77088 */     GIR_EraseRootFromParent_Done,
     /*  77089 */   // Label 1500: @77089
     /*  77089 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(77182), // Rule ID 3840 //
     /*  77094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77129 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77133 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77137 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77141 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3697:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecs16),
     /*  77156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77158 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77160 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77165 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77171 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77180 */     GIR_RootConstrainSelectedInstOperands,
     /*  77181 */     // GIR_Coverage, 3840,
     /*  77181 */     GIR_EraseRootFromParent_Done,
     /*  77182 */   // Label 1501: @77182
     /*  77182 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(77275), // Rule ID 3842 //
     /*  77187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77222 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77226 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77230 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77234 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3697:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecs32),
     /*  77249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77251 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77253 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77258 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77264 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77273 */     GIR_RootConstrainSelectedInstOperands,
     /*  77274 */     // GIR_Coverage, 3842,
     /*  77274 */     GIR_EraseRootFromParent_Done,
     /*  77275 */   // Label 1502: @77275
     /*  77275 */   GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(77368), // Rule ID 3844 //
     /*  77280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77315 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77319 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77323 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77327 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3697:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecu8),
     /*  77342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77344 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77346 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77351 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77357 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77366 */     GIR_RootConstrainSelectedInstOperands,
     /*  77367 */     // GIR_Coverage, 3844,
     /*  77367 */     GIR_EraseRootFromParent_Done,
     /*  77368 */   // Label 1503: @77368
     /*  77368 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(77461), // Rule ID 3846 //
     /*  77373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77408 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77412 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77416 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77420 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3697:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecu16),
     /*  77435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77437 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77439 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77444 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77450 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77459 */     GIR_RootConstrainSelectedInstOperands,
     /*  77460 */     // GIR_Coverage, 3846,
     /*  77460 */     GIR_EraseRootFromParent_Done,
     /*  77461 */   // Label 1504: @77461
     /*  77461 */   GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(77554), // Rule ID 3848 //
     /*  77466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77501 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77505 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77509 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77513 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3697:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecu32),
     /*  77528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77530 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77532 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77537 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77543 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77552 */     GIR_RootConstrainSelectedInstOperands,
     /*  77553 */     // GIR_Coverage, 3848,
     /*  77553 */     GIR_EraseRootFromParent_Done,
     /*  77554 */   // Label 1505: @77554
     /*  77554 */   GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(77647), // Rule ID 3850 //
     /*  77559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77594 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77598 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77602 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77606 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3697:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecs8),
     /*  77621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77623 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77625 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77630 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77636 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77645 */     GIR_RootConstrainSelectedInstOperands,
     /*  77646 */     // GIR_Coverage, 3850,
     /*  77646 */     GIR_EraseRootFromParent_Done,
     /*  77647 */   // Label 1506: @77647
     /*  77647 */   GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(77740), // Rule ID 3852 //
     /*  77652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77687 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77691 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77695 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77699 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3697:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecs16),
     /*  77714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77716 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77718 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77723 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77729 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77738 */     GIR_RootConstrainSelectedInstOperands,
     /*  77739 */     // GIR_Coverage, 3852,
     /*  77739 */     GIR_EraseRootFromParent_Done,
     /*  77740 */   // Label 1507: @77740
     /*  77740 */   GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(77833), // Rule ID 3854 //
     /*  77745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77780 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77784 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77788 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77792 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3697:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecs32),
     /*  77807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77809 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77811 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77816 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77822 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77831 */     GIR_RootConstrainSelectedInstOperands,
     /*  77832 */     // GIR_Coverage, 3854,
     /*  77832 */     GIR_EraseRootFromParent_Done,
     /*  77833 */   // Label 1508: @77833
     /*  77833 */   GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(77926), // Rule ID 3856 //
     /*  77838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77873 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77877 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77881 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77885 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3697:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecu8),
     /*  77900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77902 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77904 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77909 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77915 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77924 */     GIR_RootConstrainSelectedInstOperands,
     /*  77925 */     // GIR_Coverage, 3856,
     /*  77925 */     GIR_EraseRootFromParent_Done,
     /*  77926 */   // Label 1509: @77926
     /*  77926 */   GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(78019), // Rule ID 3858 //
     /*  77931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77966 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77970 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77974 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77978 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3697:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecu16),
     /*  77993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77995 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77997 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78002 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78008 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78017 */     GIR_RootConstrainSelectedInstOperands,
     /*  78018 */     // GIR_Coverage, 3858,
     /*  78018 */     GIR_EraseRootFromParent_Done,
     /*  78019 */   // Label 1510: @78019
     /*  78019 */   GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(78112), // Rule ID 3860 //
     /*  78024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78059 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78063 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  78067 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78071 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3697:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecu32),
     /*  78086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78088 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78090 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78095 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78101 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78110 */     GIR_RootConstrainSelectedInstOperands,
     /*  78111 */     // GIR_Coverage, 3860,
     /*  78111 */     GIR_EraseRootFromParent_Done,
     /*  78112 */   // Label 1511: @78112
     /*  78112 */   GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(78205), // Rule ID 3862 //
     /*  78117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78152 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78156 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78160 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78164 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3697:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  78164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecs8),
     /*  78179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78181 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78183 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78188 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78194 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78203 */     GIR_RootConstrainSelectedInstOperands,
     /*  78204 */     // GIR_Coverage, 3862,
     /*  78204 */     GIR_EraseRootFromParent_Done,
     /*  78205 */   // Label 1512: @78205
     /*  78205 */   GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(78298), // Rule ID 3864 //
     /*  78210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78245 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78249 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78253 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78257 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3697:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecs16),
     /*  78272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78274 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78276 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78281 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78287 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78296 */     GIR_RootConstrainSelectedInstOperands,
     /*  78297 */     // GIR_Coverage, 3864,
     /*  78297 */     GIR_EraseRootFromParent_Done,
     /*  78298 */   // Label 1513: @78298
     /*  78298 */   GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(78391), // Rule ID 3866 //
     /*  78303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78338 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78342 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78346 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78350 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3697:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecs32),
     /*  78365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78367 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78369 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78374 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78380 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78389 */     GIR_RootConstrainSelectedInstOperands,
     /*  78390 */     // GIR_Coverage, 3866,
     /*  78390 */     GIR_EraseRootFromParent_Done,
     /*  78391 */   // Label 1514: @78391
     /*  78391 */   GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(78484), // Rule ID 3868 //
     /*  78396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78431 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78435 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78439 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78443 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3697:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  78443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecu8),
     /*  78458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78460 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78462 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78467 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78473 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78482 */     GIR_RootConstrainSelectedInstOperands,
     /*  78483 */     // GIR_Coverage, 3868,
     /*  78483 */     GIR_EraseRootFromParent_Done,
     /*  78484 */   // Label 1515: @78484
     /*  78484 */   GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(78577), // Rule ID 3870 //
     /*  78489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78524 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78528 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78532 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78536 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3697:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecu16),
     /*  78551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78553 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78555 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78560 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78566 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78575 */     GIR_RootConstrainSelectedInstOperands,
     /*  78576 */     // GIR_Coverage, 3870,
     /*  78576 */     GIR_EraseRootFromParent_Done,
     /*  78577 */   // Label 1516: @78577
     /*  78577 */   GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(78670), // Rule ID 3872 //
     /*  78582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78617 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78621 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78625 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78629 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3697:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78629 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78632 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78636 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecu32),
     /*  78644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78646 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78648 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78653 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78659 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78668 */     GIR_RootConstrainSelectedInstOperands,
     /*  78669 */     // GIR_Coverage, 3872,
     /*  78669 */     GIR_EraseRootFromParent_Done,
     /*  78670 */   // Label 1517: @78670
     /*  78670 */   GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(78763), // Rule ID 3874 //
     /*  78675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78710 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78714 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78718 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78722 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3697:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  78722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecs8),
     /*  78737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78739 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78741 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78752 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78761 */     GIR_RootConstrainSelectedInstOperands,
     /*  78762 */     // GIR_Coverage, 3874,
     /*  78762 */     GIR_EraseRootFromParent_Done,
     /*  78763 */   // Label 1518: @78763
     /*  78763 */   GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(78856), // Rule ID 3876 //
     /*  78768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78803 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78807 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78811 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78815 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3697:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecs16),
     /*  78830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78832 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78834 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78839 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78845 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78854 */     GIR_RootConstrainSelectedInstOperands,
     /*  78855 */     // GIR_Coverage, 3876,
     /*  78855 */     GIR_EraseRootFromParent_Done,
     /*  78856 */   // Label 1519: @78856
     /*  78856 */   GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(78949), // Rule ID 3878 //
     /*  78861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78896 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78900 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78904 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78908 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3697:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecs32),
     /*  78923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78925 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78927 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78932 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78938 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78947 */     GIR_RootConstrainSelectedInstOperands,
     /*  78948 */     // GIR_Coverage, 3878,
     /*  78948 */     GIR_EraseRootFromParent_Done,
     /*  78949 */   // Label 1520: @78949
     /*  78949 */   GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(79042), // Rule ID 3880 //
     /*  78954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78989 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78993 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78997 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79001 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3697:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  79001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecu8),
     /*  79016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79018 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  79020 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  79022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79025 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79031 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79040 */     GIR_RootConstrainSelectedInstOperands,
     /*  79041 */     // GIR_Coverage, 3880,
     /*  79041 */     GIR_EraseRootFromParent_Done,
     /*  79042 */   // Label 1521: @79042
     /*  79042 */   GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(79135), // Rule ID 3882 //
     /*  79047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  79052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79082 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79086 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79090 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79094 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3697:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  79094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecu16),
     /*  79109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79111 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  79113 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  79115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79118 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79124 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79133 */     GIR_RootConstrainSelectedInstOperands,
     /*  79134 */     // GIR_Coverage, 3882,
     /*  79134 */     GIR_EraseRootFromParent_Done,
     /*  79135 */   // Label 1522: @79135
     /*  79135 */   GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(79228), // Rule ID 3884 //
     /*  79140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  79145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  79148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  79151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79175 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79179 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79183 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79187 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3697:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  79187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecu32),
     /*  79202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79204 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  79206 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  79208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79211 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79217 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79226 */     GIR_RootConstrainSelectedInstOperands,
     /*  79227 */     // GIR_Coverage, 3884,
     /*  79227 */     GIR_EraseRootFromParent_Done,
     /*  79228 */   // Label 1523: @79228
     /*  79228 */   GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(79306), // Rule ID 4489 //
     /*  79233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79268 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79272 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79276 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79280 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3668:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs32bh),
     /*  79283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79292 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79298 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79304 */     GIR_RootConstrainSelectedInstOperands,
     /*  79305 */     // GIR_Coverage, 4489,
     /*  79305 */     GIR_EraseRootFromParent_Done,
     /*  79306 */   // Label 1524: @79306
     /*  79306 */   GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(79384), // Rule ID 4491 //
     /*  79311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79346 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79350 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79354 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79358 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3668:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs32th),
     /*  79361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79370 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79376 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79382 */     GIR_RootConstrainSelectedInstOperands,
     /*  79383 */     // GIR_Coverage, 4491,
     /*  79383 */     GIR_EraseRootFromParent_Done,
     /*  79384 */   // Label 1525: @79384
     /*  79384 */   GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(79462), // Rule ID 4493 //
     /*  79389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79424 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79428 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79432 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79436 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3668:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs16bh),
     /*  79439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79448 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79454 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79460 */     GIR_RootConstrainSelectedInstOperands,
     /*  79461 */     // GIR_Coverage, 4493,
     /*  79461 */     GIR_EraseRootFromParent_Done,
     /*  79462 */   // Label 1526: @79462
     /*  79462 */   GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(79540), // Rule ID 4495 //
     /*  79467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79502 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79506 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79510 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79514 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3668:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs16th),
     /*  79517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79526 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79532 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79538 */     GIR_RootConstrainSelectedInstOperands,
     /*  79539 */     // GIR_Coverage, 4495,
     /*  79539 */     GIR_EraseRootFromParent_Done,
     /*  79540 */   // Label 1527: @79540
     /*  79540 */   GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(79618), // Rule ID 4497 //
     /*  79545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79584 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79592 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3668:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNu32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu32bh),
     /*  79595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79604 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79610 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79616 */     GIR_RootConstrainSelectedInstOperands,
     /*  79617 */     // GIR_Coverage, 4497,
     /*  79617 */     GIR_EraseRootFromParent_Done,
     /*  79618 */   // Label 1528: @79618
     /*  79618 */   GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(79696), // Rule ID 4499 //
     /*  79623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79658 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79662 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79666 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79670 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3668:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNu32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu32th),
     /*  79673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79682 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79688 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79694 */     GIR_RootConstrainSelectedInstOperands,
     /*  79695 */     // GIR_Coverage, 4499,
     /*  79695 */     GIR_EraseRootFromParent_Done,
     /*  79696 */   // Label 1529: @79696
     /*  79696 */   GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(79774), // Rule ID 4501 //
     /*  79701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79736 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79740 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79744 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79748 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3668:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNu16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu16bh),
     /*  79751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79760 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79766 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79772 */     GIR_RootConstrainSelectedInstOperands,
     /*  79773 */     // GIR_Coverage, 4501,
     /*  79773 */     GIR_EraseRootFromParent_Done,
     /*  79774 */   // Label 1530: @79774
     /*  79774 */   GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(79852), // Rule ID 4503 //
     /*  79779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79814 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79818 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79822 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79826 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3668:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNu16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu16th),
     /*  79829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79838 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79844 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79850 */     GIR_RootConstrainSelectedInstOperands,
     /*  79851 */     // GIR_Coverage, 4503,
     /*  79851 */     GIR_EraseRootFromParent_Done,
     /*  79852 */   // Label 1531: @79852
     /*  79852 */   GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(79930), // Rule ID 4505 //
     /*  79857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79892 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79896 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79900 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79904 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3668:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVUNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs32bh),
     /*  79907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79916 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79922 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79928 */     GIR_RootConstrainSelectedInstOperands,
     /*  79929 */     // GIR_Coverage, 4505,
     /*  79929 */     GIR_EraseRootFromParent_Done,
     /*  79930 */   // Label 1532: @79930
     /*  79930 */   GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(80008), // Rule ID 4507 //
     /*  79935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79970 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79974 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79978 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79982 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3668:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVUNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs32th),
     /*  79985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79994 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80000 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80006 */     GIR_RootConstrainSelectedInstOperands,
     /*  80007 */     // GIR_Coverage, 4507,
     /*  80007 */     GIR_EraseRootFromParent_Done,
     /*  80008 */   // Label 1533: @80008
     /*  80008 */   GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(80086), // Rule ID 4509 //
     /*  80013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  80018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  80027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  80052 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80056 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80060 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3668:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVUNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  80060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs16bh),
     /*  80063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  80067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  80069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80072 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80078 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80084 */     GIR_RootConstrainSelectedInstOperands,
     /*  80085 */     // GIR_Coverage, 4509,
     /*  80085 */     GIR_EraseRootFromParent_Done,
     /*  80086 */   // Label 1534: @80086
     /*  80086 */   GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(80164), // Rule ID 4511 //
     /*  80091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  80096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  80105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80126 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  80130 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80134 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80138 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3668:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVUNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  80138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs16th),
     /*  80141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  80145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  80147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80150 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80156 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80162 */     GIR_RootConstrainSelectedInstOperands,
     /*  80163 */     // GIR_Coverage, 4511,
     /*  80163 */     GIR_EraseRootFromParent_Done,
     /*  80164 */   // Label 1535: @80164
     /*  80164 */   GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(80242), // Rule ID 4701 //
     /*  80169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80204 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80208 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80212 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80216 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3695:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qrs8),
     /*  80219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80221 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80223 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80228 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80234 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80240 */     GIR_RootConstrainSelectedInstOperands,
     /*  80241 */     // GIR_Coverage, 4701,
     /*  80241 */     GIR_EraseRootFromParent_Done,
     /*  80242 */   // Label 1536: @80242
     /*  80242 */   GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(80320), // Rule ID 4703 //
     /*  80247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80282 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80286 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80290 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80294 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3695:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qrs16),
     /*  80297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80299 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80301 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80306 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80312 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80318 */     GIR_RootConstrainSelectedInstOperands,
     /*  80319 */     // GIR_Coverage, 4703,
     /*  80319 */     GIR_EraseRootFromParent_Done,
     /*  80320 */   // Label 1537: @80320
     /*  80320 */   GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(80398), // Rule ID 4705 //
     /*  80325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80360 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80364 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80368 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80372 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3695:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qrs32),
     /*  80375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80377 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80379 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80384 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80390 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80396 */     GIR_RootConstrainSelectedInstOperands,
     /*  80397 */     // GIR_Coverage, 4705,
     /*  80397 */     GIR_EraseRootFromParent_Done,
     /*  80398 */   // Label 1538: @80398
     /*  80398 */   GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(80476), // Rule ID 4707 //
     /*  80403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80438 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80442 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80446 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80450 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3695:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qru8),
     /*  80453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80455 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80457 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80462 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80468 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80474 */     GIR_RootConstrainSelectedInstOperands,
     /*  80475 */     // GIR_Coverage, 4707,
     /*  80475 */     GIR_EraseRootFromParent_Done,
     /*  80476 */   // Label 1539: @80476
     /*  80476 */   GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(80554), // Rule ID 4709 //
     /*  80481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80516 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80520 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80524 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80528 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3695:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qru16),
     /*  80531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80533 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80535 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80540 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80546 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80552 */     GIR_RootConstrainSelectedInstOperands,
     /*  80553 */     // GIR_Coverage, 4709,
     /*  80553 */     GIR_EraseRootFromParent_Done,
     /*  80554 */   // Label 1540: @80554
     /*  80554 */   GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(80632), // Rule ID 4711 //
     /*  80559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80594 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80598 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80602 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80606 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3695:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qru32),
     /*  80609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80611 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80613 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80618 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80630 */     GIR_RootConstrainSelectedInstOperands,
     /*  80631 */     // GIR_Coverage, 4711,
     /*  80631 */     GIR_EraseRootFromParent_Done,
     /*  80632 */   // Label 1541: @80632
     /*  80632 */   GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(80710), // Rule ID 4713 //
     /*  80637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80672 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80676 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80680 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80684 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3695:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qrs8),
     /*  80687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80689 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80691 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80696 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80702 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80708 */     GIR_RootConstrainSelectedInstOperands,
     /*  80709 */     // GIR_Coverage, 4713,
     /*  80709 */     GIR_EraseRootFromParent_Done,
     /*  80710 */   // Label 1542: @80710
     /*  80710 */   GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(80788), // Rule ID 4715 //
     /*  80715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80750 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80754 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80758 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80762 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3695:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qrs16),
     /*  80765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80767 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80769 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80774 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80780 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80786 */     GIR_RootConstrainSelectedInstOperands,
     /*  80787 */     // GIR_Coverage, 4715,
     /*  80787 */     GIR_EraseRootFromParent_Done,
     /*  80788 */   // Label 1543: @80788
     /*  80788 */   GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(80866), // Rule ID 4717 //
     /*  80793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80828 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80832 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80836 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80840 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3695:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qrs32),
     /*  80843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80845 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80847 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80852 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80858 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80864 */     GIR_RootConstrainSelectedInstOperands,
     /*  80865 */     // GIR_Coverage, 4717,
     /*  80865 */     GIR_EraseRootFromParent_Done,
     /*  80866 */   // Label 1544: @80866
     /*  80866 */   GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(80944), // Rule ID 4719 //
     /*  80871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80906 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80910 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80914 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80918 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3695:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qru8),
     /*  80921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80923 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80925 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80930 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80936 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80942 */     GIR_RootConstrainSelectedInstOperands,
     /*  80943 */     // GIR_Coverage, 4719,
     /*  80943 */     GIR_EraseRootFromParent_Done,
     /*  80944 */   // Label 1545: @80944
     /*  80944 */   GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(81022), // Rule ID 4721 //
     /*  80949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80984 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80988 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80992 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80996 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3695:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qru16),
     /*  80999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81001 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81003 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81008 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81014 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81020 */     GIR_RootConstrainSelectedInstOperands,
     /*  81021 */     // GIR_Coverage, 4721,
     /*  81021 */     GIR_EraseRootFromParent_Done,
     /*  81022 */   // Label 1546: @81022
     /*  81022 */   GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(81100), // Rule ID 4723 //
     /*  81027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81062 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  81066 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81070 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81074 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3695:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qru32),
     /*  81077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81079 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81081 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81086 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81092 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81098 */     GIR_RootConstrainSelectedInstOperands,
     /*  81099 */     // GIR_Coverage, 4723,
     /*  81099 */     GIR_EraseRootFromParent_Done,
     /*  81100 */   // Label 1547: @81100
     /*  81100 */   GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(81178), // Rule ID 4725 //
     /*  81105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81140 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81144 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81148 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81152 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3695:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qrs8),
     /*  81155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81157 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81159 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81164 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81170 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81176 */     GIR_RootConstrainSelectedInstOperands,
     /*  81177 */     // GIR_Coverage, 4725,
     /*  81177 */     GIR_EraseRootFromParent_Done,
     /*  81178 */   // Label 1548: @81178
     /*  81178 */   GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(81256), // Rule ID 4727 //
     /*  81183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81218 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81222 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81226 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81230 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3695:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qrs16),
     /*  81233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81235 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81237 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81242 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81248 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81254 */     GIR_RootConstrainSelectedInstOperands,
     /*  81255 */     // GIR_Coverage, 4727,
     /*  81255 */     GIR_EraseRootFromParent_Done,
     /*  81256 */   // Label 1549: @81256
     /*  81256 */   GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(81334), // Rule ID 4729 //
     /*  81261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81296 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81300 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81304 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81308 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3695:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qrs32),
     /*  81311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81313 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81315 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81320 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81326 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81332 */     GIR_RootConstrainSelectedInstOperands,
     /*  81333 */     // GIR_Coverage, 4729,
     /*  81333 */     GIR_EraseRootFromParent_Done,
     /*  81334 */   // Label 1550: @81334
     /*  81334 */   GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(81412), // Rule ID 4731 //
     /*  81339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81374 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81378 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81382 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81386 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3695:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qru8),
     /*  81389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81391 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81393 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81398 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81404 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81410 */     GIR_RootConstrainSelectedInstOperands,
     /*  81411 */     // GIR_Coverage, 4731,
     /*  81411 */     GIR_EraseRootFromParent_Done,
     /*  81412 */   // Label 1551: @81412
     /*  81412 */   GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(81490), // Rule ID 4733 //
     /*  81417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81452 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81456 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81460 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81464 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3695:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qru16),
     /*  81467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81469 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81471 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81476 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81482 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81488 */     GIR_RootConstrainSelectedInstOperands,
     /*  81489 */     // GIR_Coverage, 4733,
     /*  81489 */     GIR_EraseRootFromParent_Done,
     /*  81490 */   // Label 1552: @81490
     /*  81490 */   GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(81568), // Rule ID 4735 //
     /*  81495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81530 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81534 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81538 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81542 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3695:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qru32),
     /*  81545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81547 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81549 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81554 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81560 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81566 */     GIR_RootConstrainSelectedInstOperands,
     /*  81567 */     // GIR_Coverage, 4735,
     /*  81567 */     GIR_EraseRootFromParent_Done,
     /*  81568 */   // Label 1553: @81568
     /*  81568 */   GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(81646), // Rule ID 4737 //
     /*  81573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81608 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81612 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81616 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81620 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3695:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qrs8),
     /*  81623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81625 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81627 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81632 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81638 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81644 */     GIR_RootConstrainSelectedInstOperands,
     /*  81645 */     // GIR_Coverage, 4737,
     /*  81645 */     GIR_EraseRootFromParent_Done,
     /*  81646 */   // Label 1554: @81646
     /*  81646 */   GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(81724), // Rule ID 4739 //
     /*  81651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81686 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81690 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81694 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81698 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3695:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qrs16),
     /*  81701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81703 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81705 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81710 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81716 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81722 */     GIR_RootConstrainSelectedInstOperands,
     /*  81723 */     // GIR_Coverage, 4739,
     /*  81723 */     GIR_EraseRootFromParent_Done,
     /*  81724 */   // Label 1555: @81724
     /*  81724 */   GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(81802), // Rule ID 4741 //
     /*  81729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81764 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81768 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81772 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81776 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3695:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qrs32),
     /*  81779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81781 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81783 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81788 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81794 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81800 */     GIR_RootConstrainSelectedInstOperands,
     /*  81801 */     // GIR_Coverage, 4741,
     /*  81801 */     GIR_EraseRootFromParent_Done,
     /*  81802 */   // Label 1556: @81802
     /*  81802 */   GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(81880), // Rule ID 4743 //
     /*  81807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81842 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81846 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81850 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81854 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3695:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qru8),
     /*  81857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81859 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81861 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81866 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81872 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81878 */     GIR_RootConstrainSelectedInstOperands,
     /*  81879 */     // GIR_Coverage, 4743,
     /*  81879 */     GIR_EraseRootFromParent_Done,
     /*  81880 */   // Label 1557: @81880
     /*  81880 */   GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(81958), // Rule ID 4745 //
     /*  81885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81920 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81924 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81928 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81932 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3695:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qru16),
     /*  81935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81937 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81939 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81944 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81950 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81956 */     GIR_RootConstrainSelectedInstOperands,
     /*  81957 */     // GIR_Coverage, 4745,
     /*  81957 */     GIR_EraseRootFromParent_Done,
     /*  81958 */   // Label 1558: @81958
     /*  81958 */   GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(82036), // Rule ID 4747 //
     /*  81963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81998 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82002 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  82006 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  82010 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3695:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  82010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qru32),
     /*  82013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  82015 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  82017 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  82019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82022 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82028 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82034 */     GIR_RootConstrainSelectedInstOperands,
     /*  82035 */     // GIR_Coverage, 4747,
     /*  82035 */     GIR_EraseRootFromParent_Done,
     /*  82036 */   // Label 1559: @82036
     /*  82036 */   GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(82172), // Rule ID 2690 //
     /*  82041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx3),
     /*  82049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  82052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  82055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  82058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  82061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  82064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s8,
     /*  82067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  82071 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3858:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$orig, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBX3Pseudo:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$orig, (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, (IMPLICIT_DEF:{ *:[v8i8] }), dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  82071 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s8,
     /*  82074 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82078 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  82088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  82092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82097 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn0
     /*  82101 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  82104 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn1
     /*  82108 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  82111 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // Vn2
     /*  82115 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  82118 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82121 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  82124 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  82129 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82134 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82139 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82144 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX3Pseudo),
     /*  82152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82154 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  82156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82159 */     GIR_RootToRootCopy, /*OpIdx*/6, // Vm
     /*  82161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  82164 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82170 */     GIR_RootConstrainSelectedInstOperands,
     /*  82171 */     // GIR_Coverage, 2690,
     /*  82171 */     GIR_EraseRootFromParent_Done,
     /*  82172 */   // Label 1560: @82172
     /*  82172 */   GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(82293), // Rule ID 2691 //
     /*  82177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbl4),
     /*  82185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  82188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  82191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  82194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  82197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  82200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s8,
     /*  82203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  82207 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3855:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vn3, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBL4Pseudo:{ *:[v8i8] } (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn3, dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  82207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  82210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  82214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82219 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Vn0
     /*  82223 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  82226 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn1
     /*  82230 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  82233 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn2
     /*  82237 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  82240 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // Vn3
     /*  82244 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  82247 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  82252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82267 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBL4Pseudo),
     /*  82275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82280 */     GIR_RootToRootCopy, /*OpIdx*/6, // Vm
     /*  82282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  82285 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82291 */     GIR_RootConstrainSelectedInstOperands,
     /*  82292 */     // GIR_Coverage, 2691,
     /*  82292 */     GIR_EraseRootFromParent_Done,
     /*  82293 */   // Label 1561: @82293
     /*  82293 */   GIM_Reject,
     /*  82294 */ // Label 1499: @82294
     /*  82294 */ GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(87187),
     /*  82299 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/8,
     /*  82302 */   GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(82390), // Rule ID 3181 //
     /*  82307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  82333 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  82336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82340 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82344 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82348 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82352 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82356 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82360 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82364 */     // (intrinsic_wo_chain:{ *:[i32] } 3650:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  82364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVs8),
     /*  82367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82369 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82371 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82376 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82382 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82388 */     GIR_RootConstrainSelectedInstOperands,
     /*  82389 */     // GIR_Coverage, 3181,
     /*  82389 */     GIR_EraseRootFromParent_Done,
     /*  82390 */   // Label 1563: @82390
     /*  82390 */   GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(82478), // Rule ID 3185 //
     /*  82395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  82421 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  82424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82428 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82432 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82436 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82440 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82444 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82448 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82452 */     // (intrinsic_wo_chain:{ *:[i32] } 3650:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVxs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  82452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVxs8),
     /*  82455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82457 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82459 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82470 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82476 */     GIR_RootConstrainSelectedInstOperands,
     /*  82477 */     // GIR_Coverage, 3185,
     /*  82477 */     GIR_EraseRootFromParent_Done,
     /*  82478 */   // Label 1564: @82478
     /*  82478 */   GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(82566), // Rule ID 3189 //
     /*  82483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  82509 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  82512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82516 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  82520 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82524 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82528 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82532 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82536 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82540 */     // (intrinsic_wo_chain:{ *:[i32] } 3650:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVu8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  82540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu8),
     /*  82543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82545 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82547 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82552 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82558 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82564 */     GIR_RootConstrainSelectedInstOperands,
     /*  82565 */     // GIR_Coverage, 3189,
     /*  82565 */     GIR_EraseRootFromParent_Done,
     /*  82566 */   // Label 1565: @82566
     /*  82566 */   GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(82654), // Rule ID 3193 //
     /*  82571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82597 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82604 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82608 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82612 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82616 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82620 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82624 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82628 */     // (intrinsic_wo_chain:{ *:[i32] } 3650:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVs16),
     /*  82631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82633 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82635 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82640 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82646 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82652 */     GIR_RootConstrainSelectedInstOperands,
     /*  82653 */     // GIR_Coverage, 3193,
     /*  82653 */     GIR_EraseRootFromParent_Done,
     /*  82654 */   // Label 1566: @82654
     /*  82654 */   GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(82742), // Rule ID 3197 //
     /*  82659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82685 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82692 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82696 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82700 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82704 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82708 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82712 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82716 */     // (intrinsic_wo_chain:{ *:[i32] } 3650:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVxs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVxs16),
     /*  82719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82721 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82723 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82734 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82740 */     GIR_RootConstrainSelectedInstOperands,
     /*  82741 */     // GIR_Coverage, 3197,
     /*  82741 */     GIR_EraseRootFromParent_Done,
     /*  82742 */   // Label 1567: @82742
     /*  82742 */   GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(82830), // Rule ID 3201 //
     /*  82747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82773 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82780 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  82784 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82788 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82792 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82796 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82800 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82804 */     // (intrinsic_wo_chain:{ *:[i32] } 3650:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVu16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu16),
     /*  82807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82809 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82811 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82816 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82822 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82828 */     GIR_RootConstrainSelectedInstOperands,
     /*  82829 */     // GIR_Coverage, 3201,
     /*  82829 */     GIR_EraseRootFromParent_Done,
     /*  82830 */   // Label 1568: @82830
     /*  82830 */   GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(82918), // Rule ID 3205 //
     /*  82835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  82861 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  82864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82868 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82872 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82876 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82880 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82884 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82888 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82892 */     // (intrinsic_wo_chain:{ *:[i32] } 3650:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  82892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVs32),
     /*  82895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82897 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82899 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82904 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82910 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82916 */     GIR_RootConstrainSelectedInstOperands,
     /*  82917 */     // GIR_Coverage, 3205,
     /*  82917 */     GIR_EraseRootFromParent_Done,
     /*  82918 */   // Label 1569: @82918
     /*  82918 */   GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(83006), // Rule ID 3209 //
     /*  82923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  82949 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  82952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82956 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82960 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82964 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82968 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82972 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82976 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82980 */     // (intrinsic_wo_chain:{ *:[i32] } 3650:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVxs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  82980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVxs32),
     /*  82983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82985 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82987 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82992 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82998 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83004 */     GIR_RootConstrainSelectedInstOperands,
     /*  83005 */     // GIR_Coverage, 3209,
     /*  83005 */     GIR_EraseRootFromParent_Done,
     /*  83006 */   // Label 1570: @83006
     /*  83006 */   GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(83094), // Rule ID 3213 //
     /*  83011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83037 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83044 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  83048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83052 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83056 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83060 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83064 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83068 */     // (intrinsic_wo_chain:{ *:[i32] } 3650:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVu32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu32),
     /*  83071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83073 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83075 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83080 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83086 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83092 */     GIR_RootConstrainSelectedInstOperands,
     /*  83093 */     // GIR_Coverage, 3213,
     /*  83093 */     GIR_EraseRootFromParent_Done,
     /*  83094 */   // Label 1571: @83094
     /*  83094 */   GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(83182), // Rule ID 3217 //
     /*  83099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83125 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83132 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83136 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83140 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83144 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83148 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83152 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83156 */     // (intrinsic_wo_chain:{ *:[i32] } 3650:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVs8),
     /*  83159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83161 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83163 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83168 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83174 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83180 */     GIR_RootConstrainSelectedInstOperands,
     /*  83181 */     // GIR_Coverage, 3217,
     /*  83181 */     GIR_EraseRootFromParent_Done,
     /*  83182 */   // Label 1572: @83182
     /*  83182 */   GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(83270), // Rule ID 3221 //
     /*  83187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83213 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83224 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83228 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83232 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83236 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83240 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83244 */     // (intrinsic_wo_chain:{ *:[i32] } 3650:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVxs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVxs8),
     /*  83247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83249 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83251 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83256 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83262 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83268 */     GIR_RootConstrainSelectedInstOperands,
     /*  83269 */     // GIR_Coverage, 3221,
     /*  83269 */     GIR_EraseRootFromParent_Done,
     /*  83270 */   // Label 1573: @83270
     /*  83270 */   GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(83358), // Rule ID 3225 //
     /*  83275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83301 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83308 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83312 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83316 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83320 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83324 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83328 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83332 */     // (intrinsic_wo_chain:{ *:[i32] } 3650:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  83332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVs16),
     /*  83335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83337 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83339 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83344 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83350 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83356 */     GIR_RootConstrainSelectedInstOperands,
     /*  83357 */     // GIR_Coverage, 3225,
     /*  83357 */     GIR_EraseRootFromParent_Done,
     /*  83358 */   // Label 1574: @83358
     /*  83358 */   GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(83446), // Rule ID 3229 //
     /*  83363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83389 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83396 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83400 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83404 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83408 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83412 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83416 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83420 */     // (intrinsic_wo_chain:{ *:[i32] } 3650:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVxs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  83420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVxs16),
     /*  83423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83425 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83427 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83432 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83438 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83444 */     GIR_RootConstrainSelectedInstOperands,
     /*  83445 */     // GIR_Coverage, 3229,
     /*  83445 */     GIR_EraseRootFromParent_Done,
     /*  83446 */   // Label 1575: @83446
     /*  83446 */   GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(83534), // Rule ID 3233 //
     /*  83451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83477 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83484 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83492 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83496 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83500 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83504 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83508 */     // (intrinsic_wo_chain:{ *:[i32] } 3650:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVs32),
     /*  83511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83513 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83515 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83520 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83526 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83532 */     GIR_RootConstrainSelectedInstOperands,
     /*  83533 */     // GIR_Coverage, 3233,
     /*  83533 */     GIR_EraseRootFromParent_Done,
     /*  83534 */   // Label 1576: @83534
     /*  83534 */   GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(83622), // Rule ID 3237 //
     /*  83539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83565 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83572 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83576 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83584 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83588 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83592 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83596 */     // (intrinsic_wo_chain:{ *:[i32] } 3650:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVxs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVxs32),
     /*  83599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83601 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83603 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83608 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83614 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83620 */     GIR_RootConstrainSelectedInstOperands,
     /*  83621 */     // GIR_Coverage, 3237,
     /*  83621 */     GIR_EraseRootFromParent_Done,
     /*  83622 */   // Label 1577: @83622
     /*  83622 */   GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(83712), // Rule ID 3183 //
     /*  83627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83653 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83668 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83676 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83680 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83684 */     // (intrinsic_wo_chain:{ *:[i32] } 3650:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVas8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVas8),
     /*  83687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83689 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83691 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83693 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83698 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83704 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83710 */     GIR_RootConstrainSelectedInstOperands,
     /*  83711 */     // GIR_Coverage, 3183,
     /*  83711 */     GIR_EraseRootFromParent_Done,
     /*  83712 */   // Label 1578: @83712
     /*  83712 */   GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(83802), // Rule ID 3187 //
     /*  83717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83743 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83750 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83754 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83758 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83766 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83770 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83774 */     // (intrinsic_wo_chain:{ *:[i32] } 3650:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVaxs8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVaxs8),
     /*  83777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83779 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83781 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83783 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83788 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83794 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83800 */     GIR_RootConstrainSelectedInstOperands,
     /*  83801 */     // GIR_Coverage, 3187,
     /*  83801 */     GIR_EraseRootFromParent_Done,
     /*  83802 */   // Label 1579: @83802
     /*  83802 */   GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(83892), // Rule ID 3191 //
     /*  83807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83833 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  83844 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83848 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83856 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83860 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83864 */     // (intrinsic_wo_chain:{ *:[i32] } 3650:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVau8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau8),
     /*  83867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83869 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83871 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83873 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83878 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83884 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83890 */     GIR_RootConstrainSelectedInstOperands,
     /*  83891 */     // GIR_Coverage, 3191,
     /*  83891 */     GIR_EraseRootFromParent_Done,
     /*  83892 */   // Label 1580: @83892
     /*  83892 */   GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(83982), // Rule ID 3195 //
     /*  83897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83923 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83930 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83934 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83938 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83946 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83950 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83954 */     // (intrinsic_wo_chain:{ *:[i32] } 3650:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVas16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  83954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVas16),
     /*  83957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83959 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83961 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83963 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83968 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83974 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83980 */     GIR_RootConstrainSelectedInstOperands,
     /*  83981 */     // GIR_Coverage, 3195,
     /*  83981 */     GIR_EraseRootFromParent_Done,
     /*  83982 */   // Label 1581: @83982
     /*  83982 */   GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(84072), // Rule ID 3199 //
     /*  83987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84013 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84020 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84024 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84028 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84036 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84040 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84044 */     // (intrinsic_wo_chain:{ *:[i32] } 3650:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVaxs16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVaxs16),
     /*  84047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84049 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84051 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84053 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84058 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84064 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84070 */     GIR_RootConstrainSelectedInstOperands,
     /*  84071 */     // GIR_Coverage, 3199,
     /*  84071 */     GIR_EraseRootFromParent_Done,
     /*  84072 */   // Label 1582: @84072
     /*  84072 */   GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(84162), // Rule ID 3203 //
     /*  84077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84103 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84110 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  84114 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84118 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84126 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84130 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84134 */     // (intrinsic_wo_chain:{ *:[i32] } 3650:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVau16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau16),
     /*  84137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84139 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84141 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84143 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84148 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84154 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84160 */     GIR_RootConstrainSelectedInstOperands,
     /*  84161 */     // GIR_Coverage, 3203,
     /*  84161 */     GIR_EraseRootFromParent_Done,
     /*  84162 */   // Label 1583: @84162
     /*  84162 */   GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(84252), // Rule ID 3207 //
     /*  84167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84193 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84200 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84204 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84208 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84216 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84220 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84224 */     // (intrinsic_wo_chain:{ *:[i32] } 3650:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVas32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVas32),
     /*  84227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84229 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84231 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84233 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84238 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84244 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84250 */     GIR_RootConstrainSelectedInstOperands,
     /*  84251 */     // GIR_Coverage, 3207,
     /*  84251 */     GIR_EraseRootFromParent_Done,
     /*  84252 */   // Label 1584: @84252
     /*  84252 */   GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(84342), // Rule ID 3211 //
     /*  84257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84283 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84290 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84294 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84298 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84306 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84310 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84314 */     // (intrinsic_wo_chain:{ *:[i32] } 3650:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVaxs32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVaxs32),
     /*  84317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84319 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84321 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84323 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84328 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84334 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84340 */     GIR_RootConstrainSelectedInstOperands,
     /*  84341 */     // GIR_Coverage, 3211,
     /*  84341 */     GIR_EraseRootFromParent_Done,
     /*  84342 */   // Label 1585: @84342
     /*  84342 */   GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(84432), // Rule ID 3215 //
     /*  84347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84373 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84380 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  84384 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84388 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84396 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84400 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84404 */     // (intrinsic_wo_chain:{ *:[i32] } 3650:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVau32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau32),
     /*  84407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84409 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84411 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84413 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84418 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84424 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84430 */     GIR_RootConstrainSelectedInstOperands,
     /*  84431 */     // GIR_Coverage, 3215,
     /*  84431 */     GIR_EraseRootFromParent_Done,
     /*  84432 */   // Label 1586: @84432
     /*  84432 */   GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(84522), // Rule ID 3219 //
     /*  84437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  84463 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  84466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84470 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84474 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84478 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84486 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84490 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84494 */     // (intrinsic_wo_chain:{ *:[i32] } 3650:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVas8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  84494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVas8),
     /*  84497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84499 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84501 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84503 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84508 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84514 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84520 */     GIR_RootConstrainSelectedInstOperands,
     /*  84521 */     // GIR_Coverage, 3219,
     /*  84521 */     GIR_EraseRootFromParent_Done,
     /*  84522 */   // Label 1587: @84522
     /*  84522 */   GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(84612), // Rule ID 3223 //
     /*  84527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  84553 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  84556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84560 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84564 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84568 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84576 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84580 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84584 */     // (intrinsic_wo_chain:{ *:[i32] } 3650:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVaxs8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  84584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVaxs8),
     /*  84587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84589 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84591 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84593 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84598 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84604 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84610 */     GIR_RootConstrainSelectedInstOperands,
     /*  84611 */     // GIR_Coverage, 3223,
     /*  84611 */     GIR_EraseRootFromParent_Done,
     /*  84612 */   // Label 1588: @84612
     /*  84612 */   GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(84702), // Rule ID 3227 //
     /*  84617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84643 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84650 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84654 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84658 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84666 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84670 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84674 */     // (intrinsic_wo_chain:{ *:[i32] } 3650:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVas16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVas16),
     /*  84677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84679 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84681 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84683 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84688 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84694 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84700 */     GIR_RootConstrainSelectedInstOperands,
     /*  84701 */     // GIR_Coverage, 3227,
     /*  84701 */     GIR_EraseRootFromParent_Done,
     /*  84702 */   // Label 1589: @84702
     /*  84702 */   GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(84792), // Rule ID 3231 //
     /*  84707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84733 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84740 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84744 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84748 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84756 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84760 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84764 */     // (intrinsic_wo_chain:{ *:[i32] } 3650:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVaxs16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVaxs16),
     /*  84767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84769 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84771 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84773 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84778 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84784 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84790 */     GIR_RootConstrainSelectedInstOperands,
     /*  84791 */     // GIR_Coverage, 3231,
     /*  84791 */     GIR_EraseRootFromParent_Done,
     /*  84792 */   // Label 1590: @84792
     /*  84792 */   GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(84882), // Rule ID 3235 //
     /*  84797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84823 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84830 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84834 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84838 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84846 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84850 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84854 */     // (intrinsic_wo_chain:{ *:[i32] } 3650:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVas32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVas32),
     /*  84857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84859 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84861 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84863 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84868 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84874 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84880 */     GIR_RootConstrainSelectedInstOperands,
     /*  84881 */     // GIR_Coverage, 3235,
     /*  84881 */     GIR_EraseRootFromParent_Done,
     /*  84882 */   // Label 1591: @84882
     /*  84882 */   GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(84972), // Rule ID 3239 //
     /*  84887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84913 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84920 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84924 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84928 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84936 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84940 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84944 */     // (intrinsic_wo_chain:{ *:[i32] } 3650:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVaxs32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVaxs32),
     /*  84947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84949 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84951 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84953 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84958 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84964 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84970 */     GIR_RootConstrainSelectedInstOperands,
     /*  84971 */     // GIR_Coverage, 3239,
     /*  84971 */     GIR_EraseRootFromParent_Done,
     /*  84972 */   // Label 1592: @84972
     /*  84972 */   GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(85059), // Rule ID 4335 //
     /*  84977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  84982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  84985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  84988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85000 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85019 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85023 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85027 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85031 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3659:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHs8),
     /*  85034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85036 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85038 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85040 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85045 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85051 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85057 */     GIR_RootConstrainSelectedInstOperands,
     /*  85058 */     // GIR_Coverage, 4335,
     /*  85058 */     GIR_EraseRootFromParent_Done,
     /*  85059 */   // Label 1593: @85059
     /*  85059 */   GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(85146), // Rule ID 4337 //
     /*  85064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85087 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85106 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85110 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85114 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85118 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3659:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHs16),
     /*  85121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85123 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85125 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85127 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85132 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85138 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85144 */     GIR_RootConstrainSelectedInstOperands,
     /*  85145 */     // GIR_Coverage, 4337,
     /*  85145 */     GIR_EraseRootFromParent_Done,
     /*  85146 */   // Label 1594: @85146
     /*  85146 */   GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(85233), // Rule ID 4339 //
     /*  85151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85174 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85193 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85197 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85201 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85205 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3659:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHs32),
     /*  85208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85210 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85212 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85214 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85219 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85225 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85231 */     GIR_RootConstrainSelectedInstOperands,
     /*  85232 */     // GIR_Coverage, 4339,
     /*  85232 */     GIR_EraseRootFromParent_Done,
     /*  85233 */   // Label 1595: @85233
     /*  85233 */   GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(85320), // Rule ID 4341 //
     /*  85238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85261 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85280 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85284 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85288 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85292 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3659:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHXs8),
     /*  85295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85297 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85299 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85301 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85306 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85312 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85318 */     GIR_RootConstrainSelectedInstOperands,
     /*  85319 */     // GIR_Coverage, 4341,
     /*  85319 */     GIR_EraseRootFromParent_Done,
     /*  85320 */   // Label 1596: @85320
     /*  85320 */   GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(85407), // Rule ID 4343 //
     /*  85325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85348 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85367 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85371 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85375 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85379 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3659:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHXs16),
     /*  85382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85384 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85386 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85388 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85393 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85399 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85405 */     GIR_RootConstrainSelectedInstOperands,
     /*  85406 */     // GIR_Coverage, 4343,
     /*  85406 */     GIR_EraseRootFromParent_Done,
     /*  85407 */   // Label 1597: @85407
     /*  85407 */   GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(85494), // Rule ID 4345 //
     /*  85412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85435 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85454 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85458 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85462 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85466 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3659:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHXs32),
     /*  85469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85471 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85473 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85475 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85480 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85486 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85492 */     GIR_RootConstrainSelectedInstOperands,
     /*  85493 */     // GIR_Coverage, 4345,
     /*  85493 */     GIR_EraseRootFromParent_Done,
     /*  85494 */   // Label 1598: @85494
     /*  85494 */   GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(85581), // Rule ID 4347 //
     /*  85499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85522 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85541 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85545 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85549 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85553 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3659:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHs8),
     /*  85556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85558 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85560 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85562 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85567 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85573 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85579 */     GIR_RootConstrainSelectedInstOperands,
     /*  85580 */     // GIR_Coverage, 4347,
     /*  85580 */     GIR_EraseRootFromParent_Done,
     /*  85581 */   // Label 1599: @85581
     /*  85581 */   GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(85668), // Rule ID 4349 //
     /*  85586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85609 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85628 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85632 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85636 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85640 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3659:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHs16),
     /*  85643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85645 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85647 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85649 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85654 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85660 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85666 */     GIR_RootConstrainSelectedInstOperands,
     /*  85667 */     // GIR_Coverage, 4349,
     /*  85667 */     GIR_EraseRootFromParent_Done,
     /*  85668 */   // Label 1600: @85668
     /*  85668 */   GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(85755), // Rule ID 4351 //
     /*  85673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85696 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85715 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85719 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85723 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85727 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3659:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHs32),
     /*  85730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85732 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85734 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85736 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85741 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85747 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85753 */     GIR_RootConstrainSelectedInstOperands,
     /*  85754 */     // GIR_Coverage, 4351,
     /*  85754 */     GIR_EraseRootFromParent_Done,
     /*  85755 */   // Label 1601: @85755
     /*  85755 */   GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(85842), // Rule ID 4353 //
     /*  85760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85783 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85802 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85806 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85810 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85814 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3659:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHXs8),
     /*  85817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85819 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85821 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85823 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85828 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85840 */     GIR_RootConstrainSelectedInstOperands,
     /*  85841 */     // GIR_Coverage, 4353,
     /*  85841 */     GIR_EraseRootFromParent_Done,
     /*  85842 */   // Label 1602: @85842
     /*  85842 */   GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(85929), // Rule ID 4355 //
     /*  85847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85870 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85889 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85893 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85897 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85901 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3659:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHXs16),
     /*  85904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85906 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85908 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85910 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85915 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85921 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85927 */     GIR_RootConstrainSelectedInstOperands,
     /*  85928 */     // GIR_Coverage, 4355,
     /*  85928 */     GIR_EraseRootFromParent_Done,
     /*  85929 */   // Label 1603: @85929
     /*  85929 */   GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(86016), // Rule ID 4357 //
     /*  85934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85957 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85976 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85980 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85984 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85988 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3659:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHXs32),
     /*  85991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85993 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85995 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85997 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86002 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86008 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86014 */     GIR_RootConstrainSelectedInstOperands,
     /*  86015 */     // GIR_Coverage, 4357,
     /*  86015 */     GIR_EraseRootFromParent_Done,
     /*  86016 */   // Label 1604: @86016
     /*  86016 */   GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(86103), // Rule ID 4359 //
     /*  86021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86044 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86063 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86067 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86071 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86075 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3659:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHs8),
     /*  86078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86080 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86082 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86084 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86089 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86095 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86101 */     GIR_RootConstrainSelectedInstOperands,
     /*  86102 */     // GIR_Coverage, 4359,
     /*  86102 */     GIR_EraseRootFromParent_Done,
     /*  86103 */   // Label 1605: @86103
     /*  86103 */   GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(86190), // Rule ID 4361 //
     /*  86108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86131 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86150 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86154 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86158 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86162 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3659:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHs16),
     /*  86165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86167 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86169 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86171 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86176 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86182 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86188 */     GIR_RootConstrainSelectedInstOperands,
     /*  86189 */     // GIR_Coverage, 4361,
     /*  86189 */     GIR_EraseRootFromParent_Done,
     /*  86190 */   // Label 1606: @86190
     /*  86190 */   GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(86277), // Rule ID 4363 //
     /*  86195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86218 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86237 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86241 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86245 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86249 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3659:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHs32),
     /*  86252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86254 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86256 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86258 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86263 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86269 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86275 */     GIR_RootConstrainSelectedInstOperands,
     /*  86276 */     // GIR_Coverage, 4363,
     /*  86276 */     GIR_EraseRootFromParent_Done,
     /*  86277 */   // Label 1607: @86277
     /*  86277 */   GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(86364), // Rule ID 4365 //
     /*  86282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86305 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86324 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86328 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86332 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86336 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3659:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHXs8),
     /*  86339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86341 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86343 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86345 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86350 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86356 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86362 */     GIR_RootConstrainSelectedInstOperands,
     /*  86363 */     // GIR_Coverage, 4365,
     /*  86363 */     GIR_EraseRootFromParent_Done,
     /*  86364 */   // Label 1608: @86364
     /*  86364 */   GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(86451), // Rule ID 4367 //
     /*  86369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86392 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86411 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86415 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86419 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86423 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3659:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHXs16),
     /*  86426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86428 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86430 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86432 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86437 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86443 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86449 */     GIR_RootConstrainSelectedInstOperands,
     /*  86450 */     // GIR_Coverage, 4367,
     /*  86450 */     GIR_EraseRootFromParent_Done,
     /*  86451 */   // Label 1609: @86451
     /*  86451 */   GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(86538), // Rule ID 4369 //
     /*  86456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86479 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86498 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86502 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86506 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86510 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3659:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHXs32),
     /*  86513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86515 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86517 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86519 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86524 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86530 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86536 */     GIR_RootConstrainSelectedInstOperands,
     /*  86537 */     // GIR_Coverage, 4369,
     /*  86537 */     GIR_EraseRootFromParent_Done,
     /*  86538 */   // Label 1610: @86538
     /*  86538 */   GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(86625), // Rule ID 4371 //
     /*  86543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86566 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86585 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86589 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86593 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86597 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3659:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHs8),
     /*  86600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86602 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86604 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86606 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86611 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86617 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86623 */     GIR_RootConstrainSelectedInstOperands,
     /*  86624 */     // GIR_Coverage, 4371,
     /*  86624 */     GIR_EraseRootFromParent_Done,
     /*  86625 */   // Label 1611: @86625
     /*  86625 */   GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(86712), // Rule ID 4373 //
     /*  86630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86653 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86672 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86676 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86680 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86684 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3659:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHs16),
     /*  86687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86689 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86691 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86693 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86698 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86704 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86710 */     GIR_RootConstrainSelectedInstOperands,
     /*  86711 */     // GIR_Coverage, 4373,
     /*  86711 */     GIR_EraseRootFromParent_Done,
     /*  86712 */   // Label 1612: @86712
     /*  86712 */   GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(86799), // Rule ID 4375 //
     /*  86717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86740 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86759 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86763 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86767 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86771 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3659:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHs32),
     /*  86774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86776 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86778 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86780 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86797 */     GIR_RootConstrainSelectedInstOperands,
     /*  86798 */     // GIR_Coverage, 4375,
     /*  86798 */     GIR_EraseRootFromParent_Done,
     /*  86799 */   // Label 1613: @86799
     /*  86799 */   GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(86886), // Rule ID 4377 //
     /*  86804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86827 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86846 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86850 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86854 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86858 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3659:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHXs8),
     /*  86861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86863 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86865 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86867 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86872 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86878 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86884 */     GIR_RootConstrainSelectedInstOperands,
     /*  86885 */     // GIR_Coverage, 4377,
     /*  86885 */     GIR_EraseRootFromParent_Done,
     /*  86886 */   // Label 1614: @86886
     /*  86886 */   GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(86973), // Rule ID 4379 //
     /*  86891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86914 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86933 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86937 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86941 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86945 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3659:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHXs16),
     /*  86948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86950 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86952 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86954 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86959 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86965 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86971 */     GIR_RootConstrainSelectedInstOperands,
     /*  86972 */     // GIR_Coverage, 4379,
     /*  86972 */     GIR_EraseRootFromParent_Done,
     /*  86973 */   // Label 1615: @86973
     /*  86973 */   GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(87060), // Rule ID 4381 //
     /*  86978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87001 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87020 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  87024 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  87028 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87032 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3659:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  87032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHXs32),
     /*  87035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87037 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  87039 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  87041 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  87043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87046 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87052 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87058 */     GIR_RootConstrainSelectedInstOperands,
     /*  87059 */     // GIR_Coverage, 4381,
     /*  87059 */     GIR_EraseRootFromParent_Done,
     /*  87060 */   // Label 1616: @87060
     /*  87060 */   GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(87186), // Rule ID 2692 //
     /*  87065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  87068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx4),
     /*  87073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  87076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  87079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  87082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  87085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  87088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s8,
     /*  87091 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s8,
     /*  87094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  87098 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3859:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$orig, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vn3, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBX4Pseudo:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$orig, (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn3, dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  87098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  87101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  87105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87110 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn0
     /*  87114 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  87117 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn1
     /*  87121 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  87124 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // Vn2
     /*  87128 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  87131 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/6, // Vn3
     /*  87135 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  87138 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  87143 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  87148 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  87153 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  87158 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  87163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX4Pseudo),
     /*  87166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87168 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  87170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87173 */     GIR_RootToRootCopy, /*OpIdx*/7, // Vm
     /*  87175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  87178 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87184 */     GIR_RootConstrainSelectedInstOperands,
     /*  87185 */     // GIR_Coverage, 2692,
     /*  87185 */     GIR_EraseRootFromParent_Done,
     /*  87186 */   // Label 1617: @87186
     /*  87186 */   GIM_Reject,
     /*  87187 */ // Label 1562: @87187
     /*  87187 */ GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(91481),
     /*  87192 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/10,
     /*  87195 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshrn),
     /*  87200 */   GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(87307), // Rule ID 3758 //
     /*  87205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87223 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87226 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87229 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87252 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87256 */     // MIs[1] Operand 1
     /*  87256 */     // No operand predicates
     /*  87256 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87260 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87264 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87268 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87272 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87278 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3703:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16bh),
     /*  87281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87283 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87293 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87299 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87305 */     GIR_RootConstrainSelectedInstOperands,
     /*  87306 */     // GIR_Coverage, 3758,
     /*  87306 */     GIR_EraseRootFromParent_Done,
     /*  87307 */   // Label 1619: @87307
     /*  87307 */   GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(87414), // Rule ID 3760 //
     /*  87312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87330 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87333 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87336 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87359 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87363 */     // MIs[1] Operand 1
     /*  87363 */     // No operand predicates
     /*  87363 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87367 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87371 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87375 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87379 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87385 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3703:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16th),
     /*  87388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87390 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87394 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87400 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87406 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87412 */     GIR_RootConstrainSelectedInstOperands,
     /*  87413 */     // GIR_Coverage, 3760,
     /*  87413 */     GIR_EraseRootFromParent_Done,
     /*  87414 */   // Label 1620: @87414
     /*  87414 */   GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(87521), // Rule ID 3762 //
     /*  87419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87437 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87440 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87443 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87466 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87470 */     // MIs[1] Operand 1
     /*  87470 */     // No operand predicates
     /*  87470 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87474 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87478 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87482 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87486 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87492 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3703:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32bh),
     /*  87495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87497 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87507 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87513 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87519 */     GIR_RootConstrainSelectedInstOperands,
     /*  87520 */     // GIR_Coverage, 3762,
     /*  87520 */     GIR_EraseRootFromParent_Done,
     /*  87521 */   // Label 1621: @87521
     /*  87521 */   GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(87628), // Rule ID 3764 //
     /*  87526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87544 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87547 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87550 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87577 */     // MIs[1] Operand 1
     /*  87577 */     // No operand predicates
     /*  87577 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87581 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87585 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87589 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87593 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87599 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3703:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32th),
     /*  87602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87604 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87614 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87620 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87626 */     GIR_RootConstrainSelectedInstOperands,
     /*  87627 */     // GIR_Coverage, 3764,
     /*  87627 */     GIR_EraseRootFromParent_Done,
     /*  87628 */   // Label 1622: @87628
     /*  87628 */   GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(87735), // Rule ID 3766 //
     /*  87633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87651 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87654 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87657 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87680 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87684 */     // MIs[1] Operand 1
     /*  87684 */     // No operand predicates
     /*  87684 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87688 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87692 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87696 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87700 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87706 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3703:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16bh),
     /*  87709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87711 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87721 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87727 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87733 */     GIR_RootConstrainSelectedInstOperands,
     /*  87734 */     // GIR_Coverage, 3766,
     /*  87734 */     GIR_EraseRootFromParent_Done,
     /*  87735 */   // Label 1623: @87735
     /*  87735 */   GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(87842), // Rule ID 3768 //
     /*  87740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87758 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87761 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87764 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87791 */     // MIs[1] Operand 1
     /*  87791 */     // No operand predicates
     /*  87791 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87795 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87799 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87803 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87807 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87813 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3703:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16th),
     /*  87816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87818 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87822 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87828 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87840 */     GIR_RootConstrainSelectedInstOperands,
     /*  87841 */     // GIR_Coverage, 3768,
     /*  87841 */     GIR_EraseRootFromParent_Done,
     /*  87842 */   // Label 1624: @87842
     /*  87842 */   GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(87949), // Rule ID 3770 //
     /*  87847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87865 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87868 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87871 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87894 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87898 */     // MIs[1] Operand 1
     /*  87898 */     // No operand predicates
     /*  87898 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87902 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87906 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87910 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87914 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87920 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3703:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32bh),
     /*  87923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87925 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87935 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87941 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87947 */     GIR_RootConstrainSelectedInstOperands,
     /*  87948 */     // GIR_Coverage, 3770,
     /*  87948 */     GIR_EraseRootFromParent_Done,
     /*  87949 */   // Label 1625: @87949
     /*  87949 */   GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(88056), // Rule ID 3772 //
     /*  87954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87972 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87975 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87978 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88001 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88005 */     // MIs[1] Operand 1
     /*  88005 */     // No operand predicates
     /*  88005 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88009 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  88013 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88017 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88021 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88027 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3703:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32th),
     /*  88030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88032 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88036 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88042 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88048 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88054 */     GIR_RootConstrainSelectedInstOperands,
     /*  88055 */     // GIR_Coverage, 3772,
     /*  88055 */     GIR_EraseRootFromParent_Done,
     /*  88056 */   // Label 1626: @88056
     /*  88056 */   GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(88163), // Rule ID 3774 //
     /*  88061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88079 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88082 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88085 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88112 */     // MIs[1] Operand 1
     /*  88112 */     // No operand predicates
     /*  88112 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88120 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88124 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88128 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88134 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3703:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16bh),
     /*  88137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88139 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88149 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88155 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88161 */     GIR_RootConstrainSelectedInstOperands,
     /*  88162 */     // GIR_Coverage, 3774,
     /*  88162 */     GIR_EraseRootFromParent_Done,
     /*  88163 */   // Label 1627: @88163
     /*  88163 */   GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(88270), // Rule ID 3776 //
     /*  88168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88186 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88189 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88192 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88219 */     // MIs[1] Operand 1
     /*  88219 */     // No operand predicates
     /*  88219 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88223 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88227 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88231 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88235 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88241 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3703:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16th),
     /*  88244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88246 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88250 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88256 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88262 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88268 */     GIR_RootConstrainSelectedInstOperands,
     /*  88269 */     // GIR_Coverage, 3776,
     /*  88269 */     GIR_EraseRootFromParent_Done,
     /*  88270 */   // Label 1628: @88270
     /*  88270 */   GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(88377), // Rule ID 3778 //
     /*  88275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88293 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88296 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88299 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88322 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88326 */     // MIs[1] Operand 1
     /*  88326 */     // No operand predicates
     /*  88326 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88330 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88334 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88338 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88342 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88348 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3703:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32bh),
     /*  88351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88353 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88363 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88369 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88375 */     GIR_RootConstrainSelectedInstOperands,
     /*  88376 */     // GIR_Coverage, 3778,
     /*  88376 */     GIR_EraseRootFromParent_Done,
     /*  88377 */   // Label 1629: @88377
     /*  88377 */   GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(88484), // Rule ID 3780 //
     /*  88382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88400 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88403 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88406 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88429 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88433 */     // MIs[1] Operand 1
     /*  88433 */     // No operand predicates
     /*  88433 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88437 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88441 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88445 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88449 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88455 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3703:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32th),
     /*  88458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88460 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88464 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88470 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88476 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88482 */     GIR_RootConstrainSelectedInstOperands,
     /*  88483 */     // GIR_Coverage, 3780,
     /*  88483 */     GIR_EraseRootFromParent_Done,
     /*  88484 */   // Label 1630: @88484
     /*  88484 */   GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(88591), // Rule ID 3782 //
     /*  88489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88507 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88510 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88513 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88536 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88540 */     // MIs[1] Operand 1
     /*  88540 */     // No operand predicates
     /*  88540 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88544 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88548 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88552 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88556 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88562 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3703:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16bh),
     /*  88565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88567 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88577 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88583 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88589 */     GIR_RootConstrainSelectedInstOperands,
     /*  88590 */     // GIR_Coverage, 3782,
     /*  88590 */     GIR_EraseRootFromParent_Done,
     /*  88591 */   // Label 1631: @88591
     /*  88591 */   GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(88698), // Rule ID 3784 //
     /*  88596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88614 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88617 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88620 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88647 */     // MIs[1] Operand 1
     /*  88647 */     // No operand predicates
     /*  88647 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88651 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88655 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88659 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88663 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88669 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3703:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16th),
     /*  88672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88674 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88678 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88684 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88690 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88696 */     GIR_RootConstrainSelectedInstOperands,
     /*  88697 */     // GIR_Coverage, 3784,
     /*  88697 */     GIR_EraseRootFromParent_Done,
     /*  88698 */   // Label 1632: @88698
     /*  88698 */   GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(88805), // Rule ID 3786 //
     /*  88703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88721 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88724 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88727 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88750 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88754 */     // MIs[1] Operand 1
     /*  88754 */     // No operand predicates
     /*  88754 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88758 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88762 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88766 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88770 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88776 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3703:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32bh),
     /*  88779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88781 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88797 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88803 */     GIR_RootConstrainSelectedInstOperands,
     /*  88804 */     // GIR_Coverage, 3786,
     /*  88804 */     GIR_EraseRootFromParent_Done,
     /*  88805 */   // Label 1633: @88805
     /*  88805 */   GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(88912), // Rule ID 3788 //
     /*  88810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88828 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88831 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88834 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88857 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88861 */     // MIs[1] Operand 1
     /*  88861 */     // No operand predicates
     /*  88861 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88865 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88869 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88873 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88877 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88883 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3703:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32th),
     /*  88886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88888 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88898 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88904 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88910 */     GIR_RootConstrainSelectedInstOperands,
     /*  88911 */     // GIR_Coverage, 3788,
     /*  88911 */     GIR_EraseRootFromParent_Done,
     /*  88912 */   // Label 1634: @88912
     /*  88912 */   GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(89019), // Rule ID 3790 //
     /*  88917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88935 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88938 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88941 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88964 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88968 */     // MIs[1] Operand 1
     /*  88968 */     // No operand predicates
     /*  88968 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  88972 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  88976 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88980 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88984 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88990 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3703:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhs16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhs16),
     /*  88993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88995 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89005 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89011 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89017 */     GIR_RootConstrainSelectedInstOperands,
     /*  89018 */     // GIR_Coverage, 3790,
     /*  89018 */     GIR_EraseRootFromParent_Done,
     /*  89019 */   // Label 1635: @89019
     /*  89019 */   GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(89126), // Rule ID 3792 //
     /*  89024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89042 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89045 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89048 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89071 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89075 */     // MIs[1] Operand 1
     /*  89075 */     // No operand predicates
     /*  89075 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89079 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89083 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89087 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89091 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89097 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3703:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNths16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNths16),
     /*  89100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89102 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89106 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89112 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89118 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89124 */     GIR_RootConstrainSelectedInstOperands,
     /*  89125 */     // GIR_Coverage, 3792,
     /*  89125 */     GIR_EraseRootFromParent_Done,
     /*  89126 */   // Label 1636: @89126
     /*  89126 */   GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(89233), // Rule ID 3794 //
     /*  89131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89149 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89152 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89155 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89178 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89182 */     // MIs[1] Operand 1
     /*  89182 */     // No operand predicates
     /*  89182 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89186 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89190 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89194 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89198 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89204 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3703:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhs32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhs32),
     /*  89207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89209 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89219 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89225 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89231 */     GIR_RootConstrainSelectedInstOperands,
     /*  89232 */     // GIR_Coverage, 3794,
     /*  89232 */     GIR_EraseRootFromParent_Done,
     /*  89233 */   // Label 1637: @89233
     /*  89233 */   GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(89340), // Rule ID 3796 //
     /*  89238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89256 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89259 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89262 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89289 */     // MIs[1] Operand 1
     /*  89289 */     // No operand predicates
     /*  89289 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89293 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89297 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89301 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89305 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89311 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3703:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNths32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNths32),
     /*  89314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89316 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89320 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89326 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89332 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89338 */     GIR_RootConstrainSelectedInstOperands,
     /*  89339 */     // GIR_Coverage, 3796,
     /*  89339 */     GIR_EraseRootFromParent_Done,
     /*  89340 */   // Label 1638: @89340
     /*  89340 */   GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(89447), // Rule ID 3798 //
     /*  89345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89363 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89366 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89369 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89392 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89396 */     // MIs[1] Operand 1
     /*  89396 */     // No operand predicates
     /*  89396 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89400 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89404 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89408 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89412 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89418 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3703:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhu16),
     /*  89421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89423 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89433 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89439 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89445 */     GIR_RootConstrainSelectedInstOperands,
     /*  89446 */     // GIR_Coverage, 3798,
     /*  89446 */     GIR_EraseRootFromParent_Done,
     /*  89447 */   // Label 1639: @89447
     /*  89447 */   GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(89554), // Rule ID 3800 //
     /*  89452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89470 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89473 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89476 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89503 */     // MIs[1] Operand 1
     /*  89503 */     // No operand predicates
     /*  89503 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89507 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89511 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89515 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89519 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89525 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3703:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNthu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNthu16),
     /*  89528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89530 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89540 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89546 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89552 */     GIR_RootConstrainSelectedInstOperands,
     /*  89553 */     // GIR_Coverage, 3800,
     /*  89553 */     GIR_EraseRootFromParent_Done,
     /*  89554 */   // Label 1640: @89554
     /*  89554 */   GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(89661), // Rule ID 3802 //
     /*  89559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89577 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89580 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89583 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89606 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89610 */     // MIs[1] Operand 1
     /*  89610 */     // No operand predicates
     /*  89610 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89614 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89618 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89622 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89626 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89632 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3703:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhu32),
     /*  89635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89637 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89647 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89653 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89659 */     GIR_RootConstrainSelectedInstOperands,
     /*  89660 */     // GIR_Coverage, 3802,
     /*  89660 */     GIR_EraseRootFromParent_Done,
     /*  89661 */   // Label 1641: @89661
     /*  89661 */   GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(89768), // Rule ID 3804 //
     /*  89666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89684 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89687 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89690 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89717 */     // MIs[1] Operand 1
     /*  89717 */     // No operand predicates
     /*  89717 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89721 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89725 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89729 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89733 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89739 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3703:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNthu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNthu32),
     /*  89742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89744 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89754 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89760 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89766 */     GIR_RootConstrainSelectedInstOperands,
     /*  89767 */     // GIR_Coverage, 3804,
     /*  89767 */     GIR_EraseRootFromParent_Done,
     /*  89768 */   // Label 1642: @89768
     /*  89768 */   GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(89875), // Rule ID 3806 //
     /*  89773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89791 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89794 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89797 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89820 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89824 */     // MIs[1] Operand 1
     /*  89824 */     // No operand predicates
     /*  89824 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89828 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  89832 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89836 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89846 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3703:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhs16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhs16),
     /*  89849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89851 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89867 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89873 */     GIR_RootConstrainSelectedInstOperands,
     /*  89874 */     // GIR_Coverage, 3806,
     /*  89874 */     GIR_EraseRootFromParent_Done,
     /*  89875 */   // Label 1643: @89875
     /*  89875 */   GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(89982), // Rule ID 3808 //
     /*  89880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89898 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89901 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89904 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89927 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89931 */     // MIs[1] Operand 1
     /*  89931 */     // No operand predicates
     /*  89931 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89935 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  89939 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89943 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89947 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89953 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3703:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNths16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNths16),
     /*  89956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89958 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89968 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89974 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89980 */     GIR_RootConstrainSelectedInstOperands,
     /*  89981 */     // GIR_Coverage, 3808,
     /*  89981 */     GIR_EraseRootFromParent_Done,
     /*  89982 */   // Label 1644: @89982
     /*  89982 */   GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(90089), // Rule ID 3810 //
     /*  89987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90005 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90008 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90011 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90034 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90038 */     // MIs[1] Operand 1
     /*  90038 */     // No operand predicates
     /*  90038 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90042 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90046 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  90050 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90054 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90060 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3703:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhs32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhs32),
     /*  90063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90065 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90075 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90081 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90087 */     GIR_RootConstrainSelectedInstOperands,
     /*  90088 */     // GIR_Coverage, 3810,
     /*  90088 */     GIR_EraseRootFromParent_Done,
     /*  90089 */   // Label 1645: @90089
     /*  90089 */   GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(90196), // Rule ID 3812 //
     /*  90094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90112 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90115 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90118 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90141 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90145 */     // MIs[1] Operand 1
     /*  90145 */     // No operand predicates
     /*  90145 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90149 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90153 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  90157 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90161 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90167 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3703:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNths32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNths32),
     /*  90170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90172 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90182 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90188 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90194 */     GIR_RootConstrainSelectedInstOperands,
     /*  90195 */     // GIR_Coverage, 3812,
     /*  90195 */     GIR_EraseRootFromParent_Done,
     /*  90196 */   // Label 1646: @90196
     /*  90196 */   GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(90303), // Rule ID 3814 //
     /*  90201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90219 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90222 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90225 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90248 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90252 */     // MIs[1] Operand 1
     /*  90252 */     // No operand predicates
     /*  90252 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90256 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90260 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90264 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90268 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90274 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3703:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhu16),
     /*  90277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90279 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90289 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90295 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90301 */     GIR_RootConstrainSelectedInstOperands,
     /*  90302 */     // GIR_Coverage, 3814,
     /*  90302 */     GIR_EraseRootFromParent_Done,
     /*  90303 */   // Label 1647: @90303
     /*  90303 */   GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(90410), // Rule ID 3816 //
     /*  90308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90326 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90329 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90332 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90359 */     // MIs[1] Operand 1
     /*  90359 */     // No operand predicates
     /*  90359 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90363 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90367 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90371 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90375 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90381 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3703:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNthu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNthu16),
     /*  90384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90386 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90390 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90396 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90402 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90408 */     GIR_RootConstrainSelectedInstOperands,
     /*  90409 */     // GIR_Coverage, 3816,
     /*  90409 */     GIR_EraseRootFromParent_Done,
     /*  90410 */   // Label 1648: @90410
     /*  90410 */   GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(90517), // Rule ID 3818 //
     /*  90415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90433 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90436 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90439 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90462 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90466 */     // MIs[1] Operand 1
     /*  90466 */     // No operand predicates
     /*  90466 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90470 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90474 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90478 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90482 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90488 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3703:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhu32),
     /*  90491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90493 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90503 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90509 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90515 */     GIR_RootConstrainSelectedInstOperands,
     /*  90516 */     // GIR_Coverage, 3818,
     /*  90516 */     GIR_EraseRootFromParent_Done,
     /*  90517 */   // Label 1649: @90517
     /*  90517 */   GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(90624), // Rule ID 3820 //
     /*  90522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90540 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90543 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90546 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90569 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90573 */     // MIs[1] Operand 1
     /*  90573 */     // No operand predicates
     /*  90573 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90577 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90581 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90585 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90589 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90595 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3703:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNthu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNthu32),
     /*  90598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90600 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90610 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90616 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90622 */     GIR_RootConstrainSelectedInstOperands,
     /*  90623 */     // GIR_Coverage, 3820,
     /*  90623 */     GIR_EraseRootFromParent_Done,
     /*  90624 */   // Label 1650: @90624
     /*  90624 */   GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(90731), // Rule ID 3822 //
     /*  90629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90647 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90650 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90653 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90676 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90680 */     // MIs[1] Operand 1
     /*  90680 */     // No operand predicates
     /*  90680 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90684 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90688 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90692 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90696 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90702 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3703:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRUNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs16bh),
     /*  90705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90707 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90717 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90723 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90729 */     GIR_RootConstrainSelectedInstOperands,
     /*  90730 */     // GIR_Coverage, 3822,
     /*  90730 */     GIR_EraseRootFromParent_Done,
     /*  90731 */   // Label 1651: @90731
     /*  90731 */   GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(90838), // Rule ID 3824 //
     /*  90736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90754 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90757 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90760 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90787 */     // MIs[1] Operand 1
     /*  90787 */     // No operand predicates
     /*  90787 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90791 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90795 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90799 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90803 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90809 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3703:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRUNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs16th),
     /*  90812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90814 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90824 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90830 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90836 */     GIR_RootConstrainSelectedInstOperands,
     /*  90837 */     // GIR_Coverage, 3824,
     /*  90837 */     GIR_EraseRootFromParent_Done,
     /*  90838 */   // Label 1652: @90838
     /*  90838 */   GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(90945), // Rule ID 3826 //
     /*  90843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90861 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90864 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90867 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90890 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90894 */     // MIs[1] Operand 1
     /*  90894 */     // No operand predicates
     /*  90894 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90898 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90902 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90906 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90910 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90916 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3703:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRUNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs32bh),
     /*  90919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90921 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90931 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90937 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90943 */     GIR_RootConstrainSelectedInstOperands,
     /*  90944 */     // GIR_Coverage, 3826,
     /*  90944 */     GIR_EraseRootFromParent_Done,
     /*  90945 */   // Label 1653: @90945
     /*  90945 */   GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(91052), // Rule ID 3828 //
     /*  90950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90968 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90971 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90974 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90997 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  91001 */     // MIs[1] Operand 1
     /*  91001 */     // No operand predicates
     /*  91001 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91005 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  91009 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91013 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91017 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  91021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91023 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3703:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRUNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs32th),
     /*  91026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91028 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91038 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91044 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91050 */     GIR_RootConstrainSelectedInstOperands,
     /*  91051 */     // GIR_Coverage, 3828,
     /*  91051 */     GIR_EraseRootFromParent_Done,
     /*  91052 */   // Label 1654: @91052
     /*  91052 */   GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(91159), // Rule ID 3830 //
     /*  91057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  91060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  91063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  91066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  91069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91075 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91078 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91081 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91104 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  91108 */     // MIs[1] Operand 1
     /*  91108 */     // No operand predicates
     /*  91108 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91112 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  91116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91120 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91124 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  91128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91130 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3703:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRUNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs16bh),
     /*  91133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91135 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91145 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91151 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91157 */     GIR_RootConstrainSelectedInstOperands,
     /*  91158 */     // GIR_Coverage, 3830,
     /*  91158 */     GIR_EraseRootFromParent_Done,
     /*  91159 */   // Label 1655: @91159
     /*  91159 */   GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(91266), // Rule ID 3832 //
     /*  91164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  91167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  91170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  91173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  91176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91182 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91185 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91188 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91211 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  91215 */     // MIs[1] Operand 1
     /*  91215 */     // No operand predicates
     /*  91215 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91219 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  91223 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91227 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91231 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  91235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91237 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3703:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRUNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs16th),
     /*  91240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91242 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91252 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91258 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91264 */     GIR_RootConstrainSelectedInstOperands,
     /*  91265 */     // GIR_Coverage, 3832,
     /*  91265 */     GIR_EraseRootFromParent_Done,
     /*  91266 */   // Label 1656: @91266
     /*  91266 */   GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(91373), // Rule ID 3834 //
     /*  91271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  91274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  91280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  91283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91289 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91292 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91295 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91318 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  91322 */     // MIs[1] Operand 1
     /*  91322 */     // No operand predicates
     /*  91322 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91326 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  91330 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91334 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91338 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  91342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91344 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3703:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRUNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs32bh),
     /*  91347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91349 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91359 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91365 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91371 */     GIR_RootConstrainSelectedInstOperands,
     /*  91372 */     // GIR_Coverage, 3834,
     /*  91372 */     GIR_EraseRootFromParent_Done,
     /*  91373 */   // Label 1657: @91373
     /*  91373 */   GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(91480), // Rule ID 3836 //
     /*  91378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  91381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  91387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  91390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91396 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91399 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91402 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  91429 */     // MIs[1] Operand 1
     /*  91429 */     // No operand predicates
     /*  91429 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91433 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  91437 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91441 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91445 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  91449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91451 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3703:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRUNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs32th),
     /*  91454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91456 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91460 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91466 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91472 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91478 */     GIR_RootConstrainSelectedInstOperands,
     /*  91479 */     // GIR_Coverage, 3836,
     /*  91479 */     GIR_EraseRootFromParent_Done,
     /*  91480 */   // Label 1658: @91480
     /*  91480 */   GIM_Reject,
     /*  91481 */ // Label 1618: @91481
     /*  91481 */ GIM_Reject,
     /*  91482 */ // Label 16: @91482
     /*  91482 */ GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(91539),
     /*  91487 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /*  91490 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_clrex),
     /*  91495 */   GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(91512), // Rule ID 245 //
     /*  91500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6K_IsARM),
     /*  91503 */     // (intrinsic_void 3489:{ *:[iPTR] })  =>  (CLREX)
     /*  91503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CLREX),
     /*  91506 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91510 */     GIR_RootConstrainSelectedInstOperands,
     /*  91511 */     // GIR_Coverage, 245,
     /*  91511 */     GIR_EraseRootFromParent_Done,
     /*  91512 */   // Label 1660: @91512
     /*  91512 */   GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(91538), // Rule ID 574 //
     /*  91517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV7Clrex_IsThumb),
     /*  91520 */     // (intrinsic_void 3489:{ *:[iPTR] })  =>  (t2CLREX)
     /*  91520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CLREX),
     /*  91523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91526 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91536 */     GIR_RootConstrainSelectedInstOperands,
     /*  91537 */     // GIR_Coverage, 574,
     /*  91537 */     GIR_EraseRootFromParent_Done,
     /*  91538 */   // Label 1661: @91538
     /*  91538 */   GIM_Reject,
     /*  91539 */ // Label 1659: @91539
     /*  91539 */ GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(92341),
     /*  91544 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /*  91547 */   GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(91583), // Rule ID 344 //
     /*  91552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsWindows),
     /*  91555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91560 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91563 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/1, GIMT_Encode8(249),
     /*  91574 */     // (intrinsic_void 3928:{ *:[iPTR] }, 249:{ *:[i32] })  =>  (t__brkdiv0)
     /*  91574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t__brkdiv0),
     /*  91577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91581 */     GIR_RootConstrainSelectedInstOperands,
     /*  91582 */     // GIR_Coverage, 344,
     /*  91582 */     GIR_EraseRootFromParent_Done,
     /*  91583 */   // Label 1663: @91583
     /*  91583 */   GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(91635), // Rule ID 2 //
     /*  91588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  91591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_hint),
     /*  91596 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91607 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_239),
     /*  91611 */     // MIs[1] Operand 1
     /*  91611 */     // No operand predicates
     /*  91611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91613 */     // (intrinsic_void 3507:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_239>>:$imm)  =>  (HINT (imm:{ *:[i32] }):$imm)
     /*  91613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::HINT),
     /*  91616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91622 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91628 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91633 */     GIR_RootConstrainSelectedInstOperands,
     /*  91634 */     // GIR_Coverage, 2,
     /*  91634 */     GIR_EraseRootFromParent_Done,
     /*  91635 */   // Label 1664: @91635
     /*  91635 */   GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(91687), // Rule ID 10 //
     /*  91640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV7_IsARM),
     /*  91643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dbg),
     /*  91648 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91659 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91663 */     // MIs[1] Operand 1
     /*  91663 */     // No operand predicates
     /*  91663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91665 */     // (intrinsic_void 3502:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (DBG (imm:{ *:[i32] }):$opt)
     /*  91665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::DBG),
     /*  91668 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91674 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91685 */     GIR_RootConstrainSelectedInstOperands,
     /*  91686 */     // GIR_Coverage, 10,
     /*  91686 */     GIR_EraseRootFromParent_Done,
     /*  91687 */   // Label 1665: @91687
     /*  91687 */   GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(91730), // Rule ID 11 //
     /*  91692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  91695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91700 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91711 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  91715 */     // MIs[1] Operand 1
     /*  91715 */     // No operand predicates
     /*  91715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91717 */     // (intrinsic_void 3928:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm16)  =>  (UDF (imm:{ *:[i32] }):$imm16)
     /*  91717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UDF),
     /*  91720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  91723 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91728 */     GIR_RootConstrainSelectedInstOperands,
     /*  91729 */     // GIR_Coverage, 11,
     /*  91729 */     GIR_EraseRootFromParent_Done,
     /*  91730 */   // Label 1666: @91730
     /*  91730 */   GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(91773), // Rule ID 228 //
     /*  91735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsARM),
     /*  91738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dmb),
     /*  91743 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91754 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91758 */     // MIs[1] Operand 1
     /*  91758 */     // No operand predicates
     /*  91758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91760 */     // (intrinsic_void 3503:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (DMB (imm:{ *:[i32] }):$opt)
     /*  91760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::DMB),
     /*  91763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91766 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91771 */     GIR_RootConstrainSelectedInstOperands,
     /*  91772 */     // GIR_Coverage, 228,
     /*  91772 */     GIR_EraseRootFromParent_Done,
     /*  91773 */   // Label 1667: @91773
     /*  91773 */   GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(91816), // Rule ID 229 //
     /*  91778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsARM),
     /*  91781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dsb),
     /*  91786 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91797 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91801 */     // MIs[1] Operand 1
     /*  91801 */     // No operand predicates
     /*  91801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91803 */     // (intrinsic_void 3504:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (DSB (imm:{ *:[i32] }):$opt)
     /*  91803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::DSB),
     /*  91806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91809 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91814 */     GIR_RootConstrainSelectedInstOperands,
     /*  91815 */     // GIR_Coverage, 229,
     /*  91815 */     GIR_EraseRootFromParent_Done,
     /*  91816 */   // Label 1668: @91816
     /*  91816 */   GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(91859), // Rule ID 230 //
     /*  91821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsARM),
     /*  91824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_isb),
     /*  91829 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91840 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91844 */     // MIs[1] Operand 1
     /*  91844 */     // No operand predicates
     /*  91844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91846 */     // (intrinsic_void 3508:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (ISB (imm:{ *:[i32] }):$opt)
     /*  91846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ISB),
     /*  91849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91857 */     GIR_RootConstrainSelectedInstOperands,
     /*  91858 */     // GIR_Coverage, 230,
     /*  91858 */     GIR_EraseRootFromParent_Done,
     /*  91859 */   // Label 1669: @91859
     /*  91859 */   GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(91911), // Rule ID 276 //
     /*  91864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6M_IsThumb),
     /*  91867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_hint),
     /*  91872 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91883 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91887 */     // MIs[1] Operand 1
     /*  91887 */     // No operand predicates
     /*  91887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91889 */     // (intrinsic_void 3507:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)  =>  (tHINT (imm:{ *:[i32] }):$imm)
     /*  91889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tHINT),
     /*  91892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91898 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91909 */     GIR_RootConstrainSelectedInstOperands,
     /*  91910 */     // GIR_Coverage, 276,
     /*  91910 */     GIR_EraseRootFromParent_Done,
     /*  91911 */   // Label 1670: @91911
     /*  91911 */   GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(91954), // Rule ID 343 //
     /*  91916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb),
     /*  91919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91924 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91935 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255),
     /*  91939 */     // MIs[1] Operand 1
     /*  91939 */     // No operand predicates
     /*  91939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91941 */     // (intrinsic_void 3928:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$imm8)  =>  (tUDF (imm:{ *:[i32] }):$imm8)
     /*  91941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUDF),
     /*  91944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm8
     /*  91947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91952 */     GIR_RootConstrainSelectedInstOperands,
     /*  91953 */     // GIR_Coverage, 343,
     /*  91953 */     GIR_EraseRootFromParent_Done,
     /*  91954 */   // Label 1671: @91954
     /*  91954 */   GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(91997), // Rule ID 494 //
     /*  91959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  91962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91967 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91978 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  91982 */     // MIs[1] Operand 1
     /*  91982 */     // No operand predicates
     /*  91982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91984 */     // (intrinsic_void 3928:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm16)  =>  (t2UDF (imm:{ *:[i32] }):$imm16)
     /*  91984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UDF),
     /*  91987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  91990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91995 */     GIR_RootConstrainSelectedInstOperands,
     /*  91996 */     // GIR_Coverage, 494,
     /*  91996 */     GIR_EraseRootFromParent_Done,
     /*  91997 */   // Label 1672: @91997
     /*  91997 */   GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(92049), // Rule ID 559 //
     /*  92002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsThumb),
     /*  92005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dmb),
     /*  92010 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92021 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  92025 */     // MIs[1] Operand 1
     /*  92025 */     // No operand predicates
     /*  92025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92027 */     // (intrinsic_void 3503:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2DMB (imm:{ *:[i32] }):$opt)
     /*  92027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DMB),
     /*  92030 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  92033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92036 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92047 */     GIR_RootConstrainSelectedInstOperands,
     /*  92048 */     // GIR_Coverage, 559,
     /*  92048 */     GIR_EraseRootFromParent_Done,
     /*  92049 */   // Label 1673: @92049
     /*  92049 */   GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(92101), // Rule ID 560 //
     /*  92054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsThumb),
     /*  92057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dsb),
     /*  92062 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92073 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  92077 */     // MIs[1] Operand 1
     /*  92077 */     // No operand predicates
     /*  92077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92079 */     // (intrinsic_void 3504:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2DSB (imm:{ *:[i32] }):$opt)
     /*  92079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DSB),
     /*  92082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  92085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92088 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92099 */     GIR_RootConstrainSelectedInstOperands,
     /*  92100 */     // GIR_Coverage, 560,
     /*  92100 */     GIR_EraseRootFromParent_Done,
     /*  92101 */   // Label 1674: @92101
     /*  92101 */   GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(92153), // Rule ID 561 //
     /*  92106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsThumb),
     /*  92109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_isb),
     /*  92114 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  92129 */     // MIs[1] Operand 1
     /*  92129 */     // No operand predicates
     /*  92129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92131 */     // (intrinsic_void 3508:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2ISB (imm:{ *:[i32] }):$opt)
     /*  92131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ISB),
     /*  92134 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  92137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92140 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92151 */     GIR_RootConstrainSelectedInstOperands,
     /*  92152 */     // GIR_Coverage, 561,
     /*  92152 */     GIR_EraseRootFromParent_Done,
     /*  92153 */   // Label 1675: @92153
     /*  92153 */   GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(92205), // Rule ID 579 //
     /*  92158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  92161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_hint),
     /*  92166 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92177 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_239),
     /*  92181 */     // MIs[1] Operand 1
     /*  92181 */     // No operand predicates
     /*  92181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92183 */     // (intrinsic_void 3507:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_239>>:$imm)  =>  (t2HINT (imm:{ *:[i32] }):$imm)
     /*  92183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2HINT),
     /*  92186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  92189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92192 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92203 */     GIR_RootConstrainSelectedInstOperands,
     /*  92204 */     // GIR_Coverage, 579,
     /*  92204 */     GIR_EraseRootFromParent_Done,
     /*  92205 */   // Label 1676: @92205
     /*  92205 */   GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(92257), // Rule ID 580 //
     /*  92210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  92213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dbg),
     /*  92218 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92229 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  92233 */     // MIs[1] Operand 1
     /*  92233 */     // No operand predicates
     /*  92233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92235 */     // (intrinsic_void 3502:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2DBG (imm:{ *:[i32] }):$opt)
     /*  92235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DBG),
     /*  92238 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  92241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92244 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92255 */     GIR_RootConstrainSelectedInstOperands,
     /*  92256 */     // GIR_Coverage, 580,
     /*  92256 */     GIR_EraseRootFromParent_Done,
     /*  92257 */   // Label 1677: @92257
     /*  92257 */   GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(92297), // Rule ID 725 //
     /*  92262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs),
     /*  92265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_get_fpscr),
     /*  92270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92277 */     // (intrinsic_w_chain:{ *:[i32] } 3505:{ *:[iPTR] })  =>  (VMRS:{ *:[i32] })
     /*  92277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMRS),
     /*  92280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  92282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92285 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92295 */     GIR_RootConstrainSelectedInstOperands,
     /*  92296 */     // GIR_Coverage, 725,
     /*  92296 */     GIR_EraseRootFromParent_Done,
     /*  92297 */   // Label 1678: @92297
     /*  92297 */   GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(92340), // Rule ID 726 //
     /*  92302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs),
     /*  92305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_set_fpscr),
     /*  92310 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92317 */     // (intrinsic_void 3872:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rt)  =>  (VMSR:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rt)
     /*  92317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /*  92320 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rt
     /*  92322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92325 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92331 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /*  92334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92338 */     GIR_RootConstrainSelectedInstOperands,
     /*  92339 */     // GIR_Coverage, 726,
     /*  92339 */     GIR_EraseRootFromParent_Done,
     /*  92340 */   // Label 1679: @92340
     /*  92340 */   GIM_Reject,
     /*  92341 */ // Label 1662: @92341
     /*  92341 */ GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(92384), // Rule ID 604 //
     /*  92346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLOB_HasV8_1MMainline_IsThumb2),
     /*  92349 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  92352 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::start_loop_iterations),
     /*  92357 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRlrRegClassID),
     /*  92367 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  92371 */   // (intrinsic_w_chain:{ *:[i32] } 348:{ *:[iPTR] }, rGPR:{ *:[i32] }:$tc)  =>  (t2DoLoopStart:{ *:[i32] } rGPR:{ *:[i32] }:$tc)
     /*  92371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DoLoopStart),
     /*  92374 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[X]
     /*  92376 */   GIR_RootToRootCopy, /*OpIdx*/2, // tc
     /*  92378 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92382 */   GIR_RootConstrainSelectedInstOperands,
     /*  92383 */   // GIR_Coverage, 604,
     /*  92383 */   GIR_EraseRootFromParent_Done,
     /*  92384 */ // Label 1680: @92384
     /*  92384 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(94375),
     /*  92389 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  92392 */   GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(92446), // Rule ID 5051 //
     /*  92397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  92405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  92408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92427 */     // MIs[1] Operand 1
     /*  92427 */     // No operand predicates
     /*  92427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92429 */     // (intrinsic_w_chain:{ *:[v4i32] } 3638:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRWU32_qi:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_qi),
     /*  92432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92434 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92436 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92444 */     GIR_RootConstrainSelectedInstOperands,
     /*  92445 */     // GIR_Coverage, 5051,
     /*  92445 */     GIR_EraseRootFromParent_Done,
     /*  92446 */   // Label 1682: @92446
     /*  92446 */   GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(92500), // Rule ID 5057 //
     /*  92451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  92459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  92462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92481 */     // MIs[1] Operand 1
     /*  92481 */     // No operand predicates
     /*  92481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92483 */     // (intrinsic_w_chain:{ *:[v4f32] } 3638:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRWU32_qi:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_qi),
     /*  92486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92488 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92490 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92498 */     GIR_RootConstrainSelectedInstOperands,
     /*  92499 */     // GIR_Coverage, 5057,
     /*  92499 */     GIR_EraseRootFromParent_Done,
     /*  92500 */   // Label 1683: @92500
     /*  92500 */   GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(92554), // Rule ID 5059 //
     /*  92505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92535 */     // MIs[1] Operand 1
     /*  92535 */     // No operand predicates
     /*  92535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92537 */     // (intrinsic_w_chain:{ *:[v2i64] } 3638:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRDU64_qi:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_qi),
     /*  92540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92542 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92552 */     GIR_RootConstrainSelectedInstOperands,
     /*  92553 */     // GIR_Coverage, 5059,
     /*  92553 */     GIR_EraseRootFromParent_Done,
     /*  92554 */   // Label 1684: @92554
     /*  92554 */   GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(92608), // Rule ID 5061 //
     /*  92559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92589 */     // MIs[1] Operand 1
     /*  92589 */     // No operand predicates
     /*  92589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92591 */     // (intrinsic_w_chain:{ *:[v2f64] } 3638:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRDU64_qi:{ *:[v2f64] } MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_qi),
     /*  92594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92596 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92606 */     GIR_RootConstrainSelectedInstOperands,
     /*  92607 */     // GIR_Coverage, 5061,
     /*  92607 */     GIR_EraseRootFromParent_Done,
     /*  92608 */   // Label 1685: @92608
     /*  92608 */   GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(92650), // Rule ID 1741 //
     /*  92613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_space),
     /*  92618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92628 */     // MIs[0] size
     /*  92628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  92631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92635 */     // (intrinsic_w_chain:{ *:[i32] } 3903:{ *:[iPTR] }, (timm:{ *:[i32] }):$size, GPR:{ *:[i32] }:$Rn)  =>  (SPACE:{ *:[i32] } (timm:{ *:[i32] }):$size, GPR:{ *:[i32] }:$Rn)
     /*  92635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SPACE),
     /*  92638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92640 */     GIR_RootToRootCopy, /*OpIdx*/2, // size
     /*  92642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  92644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92648 */     GIR_RootConstrainSelectedInstOperands,
     /*  92649 */     // GIR_Coverage, 1741,
     /*  92649 */     GIR_EraseRootFromParent_Done,
     /*  92650 */   // Label 1686: @92650
     /*  92650 */   GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(92704), // Rule ID 5053 //
     /*  92655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92660 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92681 */     // MIs[1] Operand 1
     /*  92681 */     // No operand predicates
     /*  92681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92687 */     // (intrinsic_void 3711:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4i32] }:$data)  =>  (MVE_VSTRW32_qi MQPR:{ *:[v4i32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi),
     /*  92690 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92692 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92694 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92702 */     GIR_RootConstrainSelectedInstOperands,
     /*  92703 */     // GIR_Coverage, 5053,
     /*  92703 */     GIR_EraseRootFromParent_Done,
     /*  92704 */   // Label 1687: @92704
     /*  92704 */   GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(92758), // Rule ID 5063 //
     /*  92709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92714 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92735 */     // MIs[1] Operand 1
     /*  92735 */     // No operand predicates
     /*  92735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92741 */     // (intrinsic_void 3711:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4f32] }:$data)  =>  (MVE_VSTRW32_qi MQPR:{ *:[v4f32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi),
     /*  92744 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92746 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92756 */     GIR_RootConstrainSelectedInstOperands,
     /*  92757 */     // GIR_Coverage, 5063,
     /*  92757 */     GIR_EraseRootFromParent_Done,
     /*  92758 */   // Label 1688: @92758
     /*  92758 */   GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(92812), // Rule ID 5067 //
     /*  92763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92768 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  92777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92789 */     // MIs[1] Operand 1
     /*  92789 */     // No operand predicates
     /*  92789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92795 */     // (intrinsic_void 3711:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2i64] }:$data)  =>  (MVE_VSTRD64_qi MQPR:{ *:[v2i64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi),
     /*  92798 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92800 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92802 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92805 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92810 */     GIR_RootConstrainSelectedInstOperands,
     /*  92811 */     // GIR_Coverage, 5067,
     /*  92811 */     GIR_EraseRootFromParent_Done,
     /*  92812 */   // Label 1689: @92812
     /*  92812 */   GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(92866), // Rule ID 5071 //
     /*  92817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92822 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  92831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92843 */     // MIs[1] Operand 1
     /*  92843 */     // No operand predicates
     /*  92843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92849 */     // (intrinsic_void 3711:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2f64] }:$data)  =>  (MVE_VSTRD64_qi MQPR:{ *:[v2f64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi),
     /*  92852 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92854 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92856 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92864 */     GIR_RootConstrainSelectedInstOperands,
     /*  92865 */     // GIR_Coverage, 5071,
     /*  92865 */     GIR_EraseRootFromParent_Done,
     /*  92866 */   // Label 1690: @92866
     /*  92866 */   GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(92924), // Rule ID 3 //
     /*  92871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  92874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sel),
     /*  92879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92900 */     // (intrinsic_w_chain:{ *:[i32] } 3871:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SEL:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  92900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SEL),
     /*  92903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92912 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92922 */     GIR_RootConstrainSelectedInstOperands,
     /*  92923 */     // GIR_Coverage, 3,
     /*  92923 */     GIR_EraseRootFromParent_Done,
     /*  92924 */   // Label 1691: @92924
     /*  92924 */   GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(92982), // Rule ID 121 //
     /*  92929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sasx),
     /*  92937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92958 */     // (intrinsic_w_chain:{ *:[i32] } 3870:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  92958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SASX),
     /*  92961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92970 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92976 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92980 */     GIR_RootConstrainSelectedInstOperands,
     /*  92981 */     // GIR_Coverage, 121,
     /*  92981 */     GIR_EraseRootFromParent_Done,
     /*  92982 */   // Label 1692: @92982
     /*  92982 */   GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(93040), // Rule ID 122 //
     /*  92987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd16),
     /*  92995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93016 */     // (intrinsic_w_chain:{ *:[i32] } 3868:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SADD16),
     /*  93019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93028 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93038 */     GIR_RootConstrainSelectedInstOperands,
     /*  93039 */     // GIR_Coverage, 122,
     /*  93039 */     GIR_EraseRootFromParent_Done,
     /*  93040 */   // Label 1693: @93040
     /*  93040 */   GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(93098), // Rule ID 123 //
     /*  93045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd8),
     /*  93053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93074 */     // (intrinsic_w_chain:{ *:[i32] } 3869:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SADD8),
     /*  93077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93086 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93092 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93096 */     GIR_RootConstrainSelectedInstOperands,
     /*  93097 */     // GIR_Coverage, 123,
     /*  93097 */     GIR_EraseRootFromParent_Done,
     /*  93098 */   // Label 1694: @93098
     /*  93098 */   GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(93156), // Rule ID 124 //
     /*  93103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssax),
     /*  93111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93132 */     // (intrinsic_w_chain:{ *:[i32] } 3906:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SSAX),
     /*  93135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93144 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93154 */     GIR_RootConstrainSelectedInstOperands,
     /*  93155 */     // GIR_Coverage, 124,
     /*  93155 */     GIR_EraseRootFromParent_Done,
     /*  93156 */   // Label 1695: @93156
     /*  93156 */   GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(93214), // Rule ID 125 //
     /*  93161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub16),
     /*  93169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93190 */     // (intrinsic_w_chain:{ *:[i32] } 3907:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SSUB16),
     /*  93193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93202 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93212 */     GIR_RootConstrainSelectedInstOperands,
     /*  93213 */     // GIR_Coverage, 125,
     /*  93213 */     GIR_EraseRootFromParent_Done,
     /*  93214 */   // Label 1696: @93214
     /*  93214 */   GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(93272), // Rule ID 126 //
     /*  93219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub8),
     /*  93227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93248 */     // (intrinsic_w_chain:{ *:[i32] } 3908:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SSUB8),
     /*  93251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93260 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93270 */     GIR_RootConstrainSelectedInstOperands,
     /*  93271 */     // GIR_Coverage, 126,
     /*  93271 */     GIR_EraseRootFromParent_Done,
     /*  93272 */   // Label 1697: @93272
     /*  93272 */   GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(93330), // Rule ID 127 //
     /*  93277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uasx),
     /*  93285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93306 */     // (intrinsic_w_chain:{ *:[i32] } 3921:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UASX),
     /*  93309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93318 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93328 */     GIR_RootConstrainSelectedInstOperands,
     /*  93329 */     // GIR_Coverage, 127,
     /*  93329 */     GIR_EraseRootFromParent_Done,
     /*  93330 */   // Label 1698: @93330
     /*  93330 */   GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(93388), // Rule ID 128 //
     /*  93335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd16),
     /*  93343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93364 */     // (intrinsic_w_chain:{ *:[i32] } 3919:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UADD16),
     /*  93367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93376 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93386 */     GIR_RootConstrainSelectedInstOperands,
     /*  93387 */     // GIR_Coverage, 128,
     /*  93387 */     GIR_EraseRootFromParent_Done,
     /*  93388 */   // Label 1699: @93388
     /*  93388 */   GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(93446), // Rule ID 129 //
     /*  93393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd8),
     /*  93401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93422 */     // (intrinsic_w_chain:{ *:[i32] } 3920:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UADD8),
     /*  93425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93434 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93440 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93444 */     GIR_RootConstrainSelectedInstOperands,
     /*  93445 */     // GIR_Coverage, 129,
     /*  93445 */     GIR_EraseRootFromParent_Done,
     /*  93446 */   // Label 1700: @93446
     /*  93446 */   GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(93504), // Rule ID 130 //
     /*  93451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usax),
     /*  93459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93480 */     // (intrinsic_w_chain:{ *:[i32] } 3939:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (USAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAX),
     /*  93483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93492 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93502 */     GIR_RootConstrainSelectedInstOperands,
     /*  93503 */     // GIR_Coverage, 130,
     /*  93503 */     GIR_EraseRootFromParent_Done,
     /*  93504 */   // Label 1701: @93504
     /*  93504 */   GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(93562), // Rule ID 131 //
     /*  93509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub16),
     /*  93517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93538 */     // (intrinsic_w_chain:{ *:[i32] } 3940:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (USUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USUB16),
     /*  93541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93550 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93556 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93560 */     GIR_RootConstrainSelectedInstOperands,
     /*  93561 */     // GIR_Coverage, 131,
     /*  93561 */     GIR_EraseRootFromParent_Done,
     /*  93562 */   // Label 1702: @93562
     /*  93562 */   GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(93620), // Rule ID 132 //
     /*  93567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub8),
     /*  93575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93596 */     // (intrinsic_w_chain:{ *:[i32] } 3941:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (USUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USUB8),
     /*  93599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93608 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93614 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93618 */     GIR_RootConstrainSelectedInstOperands,
     /*  93619 */     // GIR_Coverage, 132,
     /*  93619 */     GIR_EraseRootFromParent_Done,
     /*  93620 */   // Label 1703: @93620
     /*  93620 */   GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(93678), // Rule ID 431 //
     /*  93625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sel),
     /*  93633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93654 */     // (intrinsic_w_chain:{ *:[i32] } 3871:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (t2SEL:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  93654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SEL),
     /*  93657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93666 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93676 */     GIR_RootConstrainSelectedInstOperands,
     /*  93677 */     // GIR_Coverage, 431,
     /*  93677 */     GIR_EraseRootFromParent_Done,
     /*  93678 */   // Label 1704: @93678
     /*  93678 */   GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(93736), // Rule ID 444 //
     /*  93683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sasx),
     /*  93691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93712 */     // (intrinsic_w_chain:{ *:[i32] } 3870:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SASX),
     /*  93715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93724 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93734 */     GIR_RootConstrainSelectedInstOperands,
     /*  93735 */     // GIR_Coverage, 444,
     /*  93735 */     GIR_EraseRootFromParent_Done,
     /*  93736 */   // Label 1705: @93736
     /*  93736 */   GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(93794), // Rule ID 445 //
     /*  93741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd16),
     /*  93749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93770 */     // (intrinsic_w_chain:{ *:[i32] } 3868:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SADD16),
     /*  93773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93777 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93782 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93792 */     GIR_RootConstrainSelectedInstOperands,
     /*  93793 */     // GIR_Coverage, 445,
     /*  93793 */     GIR_EraseRootFromParent_Done,
     /*  93794 */   // Label 1706: @93794
     /*  93794 */   GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(93852), // Rule ID 446 //
     /*  93799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd8),
     /*  93807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93828 */     // (intrinsic_w_chain:{ *:[i32] } 3869:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SADD8),
     /*  93831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93840 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93850 */     GIR_RootConstrainSelectedInstOperands,
     /*  93851 */     // GIR_Coverage, 446,
     /*  93851 */     GIR_EraseRootFromParent_Done,
     /*  93852 */   // Label 1707: @93852
     /*  93852 */   GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(93910), // Rule ID 447 //
     /*  93857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssax),
     /*  93865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93886 */     // (intrinsic_w_chain:{ *:[i32] } 3906:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SSAX),
     /*  93889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93898 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93908 */     GIR_RootConstrainSelectedInstOperands,
     /*  93909 */     // GIR_Coverage, 447,
     /*  93909 */     GIR_EraseRootFromParent_Done,
     /*  93910 */   // Label 1708: @93910
     /*  93910 */   GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(93968), // Rule ID 448 //
     /*  93915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub16),
     /*  93923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93944 */     // (intrinsic_w_chain:{ *:[i32] } 3907:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SSUB16),
     /*  93947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93956 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93966 */     GIR_RootConstrainSelectedInstOperands,
     /*  93967 */     // GIR_Coverage, 448,
     /*  93967 */     GIR_EraseRootFromParent_Done,
     /*  93968 */   // Label 1709: @93968
     /*  93968 */   GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(94026), // Rule ID 449 //
     /*  93973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub8),
     /*  93981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94002 */     // (intrinsic_w_chain:{ *:[i32] } 3908:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SSUB8),
     /*  94005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94014 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94024 */     GIR_RootConstrainSelectedInstOperands,
     /*  94025 */     // GIR_Coverage, 449,
     /*  94025 */     GIR_EraseRootFromParent_Done,
     /*  94026 */   // Label 1710: @94026
     /*  94026 */   GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(94084), // Rule ID 450 //
     /*  94031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uasx),
     /*  94039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94060 */     // (intrinsic_w_chain:{ *:[i32] } 3921:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UASX),
     /*  94063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94072 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94082 */     GIR_RootConstrainSelectedInstOperands,
     /*  94083 */     // GIR_Coverage, 450,
     /*  94083 */     GIR_EraseRootFromParent_Done,
     /*  94084 */   // Label 1711: @94084
     /*  94084 */   GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(94142), // Rule ID 451 //
     /*  94089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd16),
     /*  94097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94118 */     // (intrinsic_w_chain:{ *:[i32] } 3919:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UADD16),
     /*  94121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94130 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94140 */     GIR_RootConstrainSelectedInstOperands,
     /*  94141 */     // GIR_Coverage, 451,
     /*  94141 */     GIR_EraseRootFromParent_Done,
     /*  94142 */   // Label 1712: @94142
     /*  94142 */   GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(94200), // Rule ID 452 //
     /*  94147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd8),
     /*  94155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94176 */     // (intrinsic_w_chain:{ *:[i32] } 3920:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UADD8),
     /*  94179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94188 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94198 */     GIR_RootConstrainSelectedInstOperands,
     /*  94199 */     // GIR_Coverage, 452,
     /*  94199 */     GIR_EraseRootFromParent_Done,
     /*  94200 */   // Label 1713: @94200
     /*  94200 */   GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(94258), // Rule ID 453 //
     /*  94205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usax),
     /*  94213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94234 */     // (intrinsic_w_chain:{ *:[i32] } 3939:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAX),
     /*  94237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94246 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94252 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94256 */     GIR_RootConstrainSelectedInstOperands,
     /*  94257 */     // GIR_Coverage, 453,
     /*  94257 */     GIR_EraseRootFromParent_Done,
     /*  94258 */   // Label 1714: @94258
     /*  94258 */   GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(94316), // Rule ID 454 //
     /*  94263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub16),
     /*  94271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94292 */     // (intrinsic_w_chain:{ *:[i32] } 3940:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USUB16),
     /*  94295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94314 */     GIR_RootConstrainSelectedInstOperands,
     /*  94315 */     // GIR_Coverage, 454,
     /*  94315 */     GIR_EraseRootFromParent_Done,
     /*  94316 */   // Label 1715: @94316
     /*  94316 */   GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(94374), // Rule ID 455 //
     /*  94321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub8),
     /*  94329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94350 */     // (intrinsic_w_chain:{ *:[i32] } 3941:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USUB8),
     /*  94353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94362 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94372 */     GIR_RootConstrainSelectedInstOperands,
     /*  94373 */     // GIR_Coverage, 455,
     /*  94373 */     GIR_EraseRootFromParent_Done,
     /*  94374 */   // Label 1716: @94374
     /*  94374 */   GIM_Reject,
     /*  94375 */ // Label 1681: @94375
     /*  94375 */ GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(94621),
     /*  94380 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  94383 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base_wb),
     /*  94388 */   GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(94446), // Rule ID 5055 //
     /*  94393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  94405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94421 */     // MIs[1] Operand 1
     /*  94421 */     // No operand predicates
     /*  94421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94427 */     // (intrinsic_w_chain:{ *:[v4i32] } 3713:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4i32] }:$data)  =>  (MVE_VSTRW32_qi_pre:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi_pre),
     /*  94430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94432 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94434 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94436 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94444 */     GIR_RootConstrainSelectedInstOperands,
     /*  94445 */     // GIR_Coverage, 5055,
     /*  94445 */     GIR_EraseRootFromParent_Done,
     /*  94446 */   // Label 1718: @94446
     /*  94446 */   GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(94504), // Rule ID 5065 //
     /*  94451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  94463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94479 */     // MIs[1] Operand 1
     /*  94479 */     // No operand predicates
     /*  94479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94485 */     // (intrinsic_w_chain:{ *:[v4i32] } 3713:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4f32] }:$data)  =>  (MVE_VSTRW32_qi_pre:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi_pre),
     /*  94488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94490 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94492 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94494 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94497 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94502 */     GIR_RootConstrainSelectedInstOperands,
     /*  94503 */     // GIR_Coverage, 5065,
     /*  94503 */     GIR_EraseRootFromParent_Done,
     /*  94504 */   // Label 1719: @94504
     /*  94504 */   GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(94562), // Rule ID 5069 //
     /*  94509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  94521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94537 */     // MIs[1] Operand 1
     /*  94537 */     // No operand predicates
     /*  94537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94543 */     // (intrinsic_w_chain:{ *:[v2i64] } 3713:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2i64] }:$data)  =>  (MVE_VSTRD64_qi_pre:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi_pre),
     /*  94546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94548 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94550 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94552 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94560 */     GIR_RootConstrainSelectedInstOperands,
     /*  94561 */     // GIR_Coverage, 5069,
     /*  94561 */     GIR_EraseRootFromParent_Done,
     /*  94562 */   // Label 1720: @94562
     /*  94562 */   GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(94620), // Rule ID 5073 //
     /*  94567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  94579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94595 */     // MIs[1] Operand 1
     /*  94595 */     // No operand predicates
     /*  94595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94601 */     // (intrinsic_w_chain:{ *:[v2i64] } 3713:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2f64] }:$data)  =>  (MVE_VSTRD64_qi_pre:{ *:[v2i64] } MQPR:{ *:[v2f64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi_pre),
     /*  94604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94606 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94608 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94618 */     GIR_RootConstrainSelectedInstOperands,
     /*  94619 */     // GIR_Coverage, 5073,
     /*  94619 */     GIR_EraseRootFromParent_Done,
     /*  94620 */   // Label 1721: @94620
     /*  94620 */   GIM_Reject,
     /*  94621 */ // Label 1717: @94621
     /*  94621 */ GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(95792),
     /*  94626 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  94629 */   GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(94690), // Rule ID 4943 //
     /*  94634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94651 */     // MIs[0] base
     /*  94651 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94667 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94671 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94675 */     // (intrinsic_void 3715:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8i16] }:$data, 16:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRH16_rq_u MQPR:{ *:[v8i16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq_u),
     /*  94678 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94680 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94682 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94688 */     GIR_RootConstrainSelectedInstOperands,
     /*  94689 */     // GIR_Coverage, 4943,
     /*  94689 */     GIR_EraseRootFromParent_Done,
     /*  94690 */   // Label 1723: @94690
     /*  94690 */   GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(94751), // Rule ID 4944 //
     /*  94695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94712 */     // MIs[0] base
     /*  94712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94728 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94732 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  94736 */     // (intrinsic_void 3715:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8i16] }:$data, 16:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSTRH16_rq MQPR:{ *:[v8i16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq),
     /*  94739 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94741 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94743 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94745 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94749 */     GIR_RootConstrainSelectedInstOperands,
     /*  94750 */     // GIR_Coverage, 4944,
     /*  94750 */     GIR_EraseRootFromParent_Done,
     /*  94751 */   // Label 1724: @94751
     /*  94751 */   GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(94812), // Rule ID 4947 //
     /*  94756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  94764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  94767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94773 */     // MIs[0] base
     /*  94773 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94789 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  94793 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94797 */     // (intrinsic_void 3715:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets, MQPR:{ *:[v16i8] }:$data, 8:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRB8_rq MQPR:{ *:[v16i8] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets)
     /*  94797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRB8_rq),
     /*  94800 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94802 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94804 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94810 */     GIR_RootConstrainSelectedInstOperands,
     /*  94811 */     // GIR_Coverage, 4947,
     /*  94811 */     GIR_EraseRootFromParent_Done,
     /*  94812 */   // Label 1725: @94812
     /*  94812 */   GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(94873), // Rule ID 5027 //
     /*  94817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94834 */     // MIs[0] base
     /*  94834 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94850 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  94854 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94858 */     // (intrinsic_void 3715:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8i16] }:$data, 8:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRB16_rq MQPR:{ *:[v8i16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRB16_rq),
     /*  94861 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94863 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94865 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94871 */     GIR_RootConstrainSelectedInstOperands,
     /*  94872 */     // GIR_Coverage, 5027,
     /*  94872 */     GIR_EraseRootFromParent_Done,
     /*  94873 */   // Label 1726: @94873
     /*  94873 */   GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(94934), // Rule ID 5029 //
     /*  94878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94895 */     // MIs[0] base
     /*  94895 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94911 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  94915 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94919 */     // (intrinsic_void 3715:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 8:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRB32_rq MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  94919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRB32_rq),
     /*  94922 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94924 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94926 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94932 */     GIR_RootConstrainSelectedInstOperands,
     /*  94933 */     // GIR_Coverage, 5029,
     /*  94933 */     GIR_EraseRootFromParent_Done,
     /*  94934 */   // Label 1727: @94934
     /*  94934 */   GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(94995), // Rule ID 5031 //
     /*  94939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94956 */     // MIs[0] base
     /*  94956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94972 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94976 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94980 */     // (intrinsic_void 3715:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8f16] }:$data, 16:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRH16_rq_u MQPR:{ *:[v8f16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq_u),
     /*  94983 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94985 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94987 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94993 */     GIR_RootConstrainSelectedInstOperands,
     /*  94994 */     // GIR_Coverage, 5031,
     /*  94994 */     GIR_EraseRootFromParent_Done,
     /*  94995 */   // Label 1728: @94995
     /*  94995 */   GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(95056), // Rule ID 5032 //
     /*  95000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  95008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  95011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95017 */     // MIs[0] base
     /*  95017 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95033 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  95037 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  95041 */     // (intrinsic_void 3715:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8f16] }:$data, 16:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSTRH16_rq MQPR:{ *:[v8f16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  95041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq),
     /*  95044 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95046 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95048 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95054 */     GIR_RootConstrainSelectedInstOperands,
     /*  95055 */     // GIR_Coverage, 5032,
     /*  95055 */     GIR_EraseRootFromParent_Done,
     /*  95056 */   // Label 1729: @95056
     /*  95056 */   GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(95117), // Rule ID 5035 //
     /*  95061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95078 */     // MIs[0] base
     /*  95078 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95094 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  95098 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95102 */     // (intrinsic_void 3715:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 16:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRH32_rq_u MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH32_rq_u),
     /*  95105 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95107 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95109 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95115 */     GIR_RootConstrainSelectedInstOperands,
     /*  95116 */     // GIR_Coverage, 5035,
     /*  95116 */     GIR_EraseRootFromParent_Done,
     /*  95117 */   // Label 1730: @95117
     /*  95117 */   GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(95178), // Rule ID 5036 //
     /*  95122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95139 */     // MIs[0] base
     /*  95139 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95155 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  95159 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  95163 */     // (intrinsic_void 3715:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 16:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSTRH32_rq MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH32_rq),
     /*  95166 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95168 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95170 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95172 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95176 */     GIR_RootConstrainSelectedInstOperands,
     /*  95177 */     // GIR_Coverage, 5036,
     /*  95177 */     GIR_EraseRootFromParent_Done,
     /*  95178 */   // Label 1731: @95178
     /*  95178 */   GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(95239), // Rule ID 5039 //
     /*  95183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95200 */     // MIs[0] base
     /*  95200 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95216 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95224 */     // (intrinsic_void 3715:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 32:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRW32_rq_u MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq_u),
     /*  95227 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95229 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95231 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95237 */     GIR_RootConstrainSelectedInstOperands,
     /*  95238 */     // GIR_Coverage, 5039,
     /*  95238 */     GIR_EraseRootFromParent_Done,
     /*  95239 */   // Label 1732: @95239
     /*  95239 */   GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(95300), // Rule ID 5040 //
     /*  95244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95261 */     // MIs[0] base
     /*  95261 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95277 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95281 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  95285 */     // (intrinsic_void 3715:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 32:{ *:[i32] }, 2:{ *:[i32] })  =>  (MVE_VSTRW32_rq MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq),
     /*  95288 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95290 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95292 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95298 */     GIR_RootConstrainSelectedInstOperands,
     /*  95299 */     // GIR_Coverage, 5040,
     /*  95299 */     GIR_EraseRootFromParent_Done,
     /*  95300 */   // Label 1733: @95300
     /*  95300 */   GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(95361), // Rule ID 5043 //
     /*  95305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95322 */     // MIs[0] base
     /*  95322 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95338 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95342 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95346 */     // (intrinsic_void 3715:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4f32] }:$data, 32:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRW32_rq_u MQPR:{ *:[v4f32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq_u),
     /*  95349 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95351 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95353 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95359 */     GIR_RootConstrainSelectedInstOperands,
     /*  95360 */     // GIR_Coverage, 5043,
     /*  95360 */     GIR_EraseRootFromParent_Done,
     /*  95361 */   // Label 1734: @95361
     /*  95361 */   GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(95422), // Rule ID 5044 //
     /*  95366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95383 */     // MIs[0] base
     /*  95383 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95399 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95403 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  95407 */     // (intrinsic_void 3715:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4f32] }:$data, 32:{ *:[i32] }, 2:{ *:[i32] })  =>  (MVE_VSTRW32_rq MQPR:{ *:[v4f32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq),
     /*  95410 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95412 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95414 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95420 */     GIR_RootConstrainSelectedInstOperands,
     /*  95421 */     // GIR_Coverage, 5044,
     /*  95421 */     GIR_EraseRootFromParent_Done,
     /*  95422 */   // Label 1735: @95422
     /*  95422 */   GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(95483), // Rule ID 5047 //
     /*  95427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95444 */     // MIs[0] base
     /*  95444 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95460 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  95464 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95468 */     // (intrinsic_void 3715:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, MQPR:{ *:[v2i64] }:$data, 64:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRD64_rq_u MQPR:{ *:[v2i64] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  95468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_rq_u),
     /*  95471 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95473 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95475 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95481 */     GIR_RootConstrainSelectedInstOperands,
     /*  95482 */     // GIR_Coverage, 5047,
     /*  95482 */     GIR_EraseRootFromParent_Done,
     /*  95483 */   // Label 1736: @95483
     /*  95483 */   GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(95544), // Rule ID 5048 //
     /*  95488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95505 */     // MIs[0] base
     /*  95505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95521 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  95525 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  95529 */     // (intrinsic_void 3715:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, MQPR:{ *:[v2i64] }:$data, 64:{ *:[i32] }, 3:{ *:[i32] })  =>  (MVE_VSTRD64_rq MQPR:{ *:[v2i64] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  95529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_rq),
     /*  95532 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95534 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95536 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95542 */     GIR_RootConstrainSelectedInstOperands,
     /*  95543 */     // GIR_Coverage, 5048,
     /*  95543 */     GIR_EraseRootFromParent_Done,
     /*  95544 */   // Label 1737: @95544
     /*  95544 */   GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(95608), // Rule ID 258 //
     /*  95549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  95552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr),
     /*  95557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95563 */     // MIs[0] cop
     /*  95563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95566 */     // MIs[0] opc1
     /*  95566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95577 */     // MIs[0] CRm
     /*  95577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95580 */     // (intrinsic_void 3519:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (MCRR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCRR),
     /*  95583 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95585 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95589 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95591 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95596 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95606 */     GIR_RootConstrainSelectedInstOperands,
     /*  95607 */     // GIR_Coverage, 258,
     /*  95607 */     GIR_EraseRootFromParent_Done,
     /*  95608 */   // Label 1738: @95608
     /*  95608 */   GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(95663), // Rule ID 259 //
     /*  95613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  95616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr2),
     /*  95621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95627 */     // MIs[0] cop
     /*  95627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95630 */     // MIs[0] opc1
     /*  95630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95641 */     // MIs[0] CRm
     /*  95641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95644 */     // (intrinsic_void 3520:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (MCRR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCRR2),
     /*  95647 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95649 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95653 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95655 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95657 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95661 */     GIR_RootConstrainSelectedInstOperands,
     /*  95662 */     // GIR_Coverage, 259,
     /*  95662 */     GIR_EraseRootFromParent_Done,
     /*  95663 */   // Label 1739: @95663
     /*  95663 */   GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(95727), // Rule ID 596 //
     /*  95668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  95671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr),
     /*  95676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95682 */     // MIs[0] cop
     /*  95682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95685 */     // MIs[0] opc1
     /*  95685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95696 */     // MIs[0] CRm
     /*  95696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95699 */     // (intrinsic_void 3519:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (t2MCRR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCRR),
     /*  95702 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95704 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95708 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95710 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95715 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95725 */     GIR_RootConstrainSelectedInstOperands,
     /*  95726 */     // GIR_Coverage, 596,
     /*  95726 */     GIR_EraseRootFromParent_Done,
     /*  95727 */   // Label 1740: @95727
     /*  95727 */   GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(95791), // Rule ID 597 //
     /*  95732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  95735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr2),
     /*  95740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95746 */     // MIs[0] cop
     /*  95746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95749 */     // MIs[0] opc1
     /*  95749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95760 */     // MIs[0] CRm
     /*  95760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95763 */     // (intrinsic_void 3520:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (t2MCRR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCRR2),
     /*  95766 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95768 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95772 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95774 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95779 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95785 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95789 */     GIR_RootConstrainSelectedInstOperands,
     /*  95790 */     // GIR_Coverage, 597,
     /*  95790 */     GIR_EraseRootFromParent_Done,
     /*  95791 */   // Label 1741: @95791
     /*  95791 */   GIM_Reject,
     /*  95792 */ // Label 1722: @95792
     /*  95792 */ GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(99143),
     /*  95797 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /*  95800 */   GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(95861), // Rule ID 246 //
     /*  95805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  95808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp),
     /*  95813 */     // MIs[0] cop
     /*  95813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95816 */     // MIs[0] opc1
     /*  95816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95819 */     // MIs[0] CRd
     /*  95819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95822 */     // MIs[0] CRn
     /*  95822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95825 */     // MIs[0] CRm
     /*  95825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95828 */     // MIs[0] opc2
     /*  95828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  95831 */     // (intrinsic_void 3487:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (CDP (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  95831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CDP),
     /*  95834 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95836 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95838 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  95840 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  95842 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95844 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  95846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95849 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95859 */     GIR_RootConstrainSelectedInstOperands,
     /*  95860 */     // GIR_Coverage, 246,
     /*  95860 */     GIR_EraseRootFromParent_Done,
     /*  95861 */   // Label 1743: @95861
     /*  95861 */   GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(95913), // Rule ID 247 //
     /*  95866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  95869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp2),
     /*  95874 */     // MIs[0] cop
     /*  95874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95877 */     // MIs[0] opc1
     /*  95877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95880 */     // MIs[0] CRd
     /*  95880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95883 */     // MIs[0] CRn
     /*  95883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95886 */     // MIs[0] CRm
     /*  95886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95889 */     // MIs[0] opc2
     /*  95889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  95892 */     // (intrinsic_void 3488:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (CDP2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  95892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CDP2),
     /*  95895 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95897 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95899 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  95901 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  95903 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95905 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  95907 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95911 */     GIR_RootConstrainSelectedInstOperands,
     /*  95912 */     // GIR_Coverage, 247,
     /*  95912 */     GIR_EraseRootFromParent_Done,
     /*  95913 */   // Label 1744: @95913
     /*  95913 */   GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(95974), // Rule ID 598 //
     /*  95918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  95921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp),
     /*  95926 */     // MIs[0] cop
     /*  95926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95929 */     // MIs[0] opc1
     /*  95929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95932 */     // MIs[0] CRd
     /*  95932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95935 */     // MIs[0] CRn
     /*  95935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95938 */     // MIs[0] CRm
     /*  95938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95941 */     // MIs[0] opc2
     /*  95941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  95944 */     // (intrinsic_void 3487:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2CDP (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  95944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CDP),
     /*  95947 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95949 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95951 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  95953 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  95955 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95957 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  95959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95972 */     GIR_RootConstrainSelectedInstOperands,
     /*  95973 */     // GIR_Coverage, 598,
     /*  95973 */     GIR_EraseRootFromParent_Done,
     /*  95974 */   // Label 1745: @95974
     /*  95974 */   GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(96035), // Rule ID 599 //
     /*  95979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  95982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp2),
     /*  95987 */     // MIs[0] cop
     /*  95987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95990 */     // MIs[0] opc1
     /*  95990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95993 */     // MIs[0] CRd
     /*  95993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95996 */     // MIs[0] CRn
     /*  95996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95999 */     // MIs[0] CRm
     /*  95999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  96002 */     // MIs[0] opc2
     /*  96002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  96005 */     // (intrinsic_void 3488:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2CDP2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  96005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CDP2),
     /*  96008 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  96010 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  96012 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  96014 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  96016 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  96018 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  96020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  96023 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  96029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96033 */     GIR_RootConstrainSelectedInstOperands,
     /*  96034 */     // GIR_Coverage, 599,
     /*  96034 */     GIR_EraseRootFromParent_Done,
     /*  96035 */   // Label 1746: @96035
     /*  96035 */   GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(96103), // Rule ID 4937 //
     /*  96040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96064 */     // MIs[0] base
     /*  96064 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96076 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96080 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96084 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96088 */     // (intrinsic_w_chain:{ *:[v8i16] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96093 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96095 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96101 */     GIR_RootConstrainSelectedInstOperands,
     /*  96102 */     // GIR_Coverage, 4937,
     /*  96102 */     GIR_EraseRootFromParent_Done,
     /*  96103 */   // Label 1747: @96103
     /*  96103 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(96171), // Rule ID 4938 //
     /*  96108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96132 */     // MIs[0] base
     /*  96132 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96144 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96148 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96152 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96156 */     // (intrinsic_w_chain:{ *:[v8i16] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96161 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96163 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96169 */     GIR_RootConstrainSelectedInstOperands,
     /*  96170 */     // GIR_Coverage, 4938,
     /*  96170 */     GIR_EraseRootFromParent_Done,
     /*  96171 */   // Label 1748: @96171
     /*  96171 */   GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(96239), // Rule ID 4941 //
     /*  96176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  96184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  96187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96200 */     // MIs[0] base
     /*  96200 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96212 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96216 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96224 */     // (intrinsic_w_chain:{ *:[v16i8] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRBU8_rq:{ *:[v16i8] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets)
     /*  96224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU8_rq),
     /*  96227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96229 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96231 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96237 */     GIR_RootConstrainSelectedInstOperands,
     /*  96238 */     // GIR_Coverage, 4941,
     /*  96238 */     GIR_EraseRootFromParent_Done,
     /*  96239 */   // Label 1749: @96239
     /*  96239 */   GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(96307), // Rule ID 4949 //
     /*  96244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  96252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  96255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96268 */     // MIs[0] base
     /*  96268 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96280 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96284 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96288 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96292 */     // (intrinsic_w_chain:{ *:[v16i8] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRBU8_rq:{ *:[v16i8] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets)
     /*  96292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU8_rq),
     /*  96295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96297 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96299 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96301 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96305 */     GIR_RootConstrainSelectedInstOperands,
     /*  96306 */     // GIR_Coverage, 4949,
     /*  96306 */     GIR_EraseRootFromParent_Done,
     /*  96307 */   // Label 1750: @96307
     /*  96307 */   GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(96375), // Rule ID 4951 //
     /*  96312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96336 */     // MIs[0] base
     /*  96336 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96348 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96352 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96356 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96360 */     // (intrinsic_w_chain:{ *:[v8i16] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRBU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU16_rq),
     /*  96363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96365 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96367 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96373 */     GIR_RootConstrainSelectedInstOperands,
     /*  96374 */     // GIR_Coverage, 4951,
     /*  96374 */     GIR_EraseRootFromParent_Done,
     /*  96375 */   // Label 1751: @96375
     /*  96375 */   GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(96443), // Rule ID 4953 //
     /*  96380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96404 */     // MIs[0] base
     /*  96404 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96416 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96420 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96424 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96428 */     // (intrinsic_w_chain:{ *:[v8i16] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRBS16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBS16_rq),
     /*  96431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96433 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96435 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96441 */     GIR_RootConstrainSelectedInstOperands,
     /*  96442 */     // GIR_Coverage, 4953,
     /*  96442 */     GIR_EraseRootFromParent_Done,
     /*  96443 */   // Label 1752: @96443
     /*  96443 */   GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(96511), // Rule ID 4955 //
     /*  96448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96472 */     // MIs[0] base
     /*  96472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96484 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96492 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96496 */     // (intrinsic_w_chain:{ *:[v4i32] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRBU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  96496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU32_rq),
     /*  96499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96501 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96503 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96509 */     GIR_RootConstrainSelectedInstOperands,
     /*  96510 */     // GIR_Coverage, 4955,
     /*  96510 */     GIR_EraseRootFromParent_Done,
     /*  96511 */   // Label 1753: @96511
     /*  96511 */   GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(96579), // Rule ID 4957 //
     /*  96516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96540 */     // MIs[0] base
     /*  96540 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96552 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96556 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96560 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96564 */     // (intrinsic_w_chain:{ *:[v4i32] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRBS32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  96564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBS32_rq),
     /*  96567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96569 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96571 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96577 */     GIR_RootConstrainSelectedInstOperands,
     /*  96578 */     // GIR_Coverage, 4957,
     /*  96578 */     GIR_EraseRootFromParent_Done,
     /*  96579 */   // Label 1754: @96579
     /*  96579 */   GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(96647), // Rule ID 4959 //
     /*  96584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96608 */     // MIs[0] base
     /*  96608 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96620 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96624 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96628 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96632 */     // (intrinsic_w_chain:{ *:[v8i16] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96637 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96639 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96645 */     GIR_RootConstrainSelectedInstOperands,
     /*  96646 */     // GIR_Coverage, 4959,
     /*  96646 */     GIR_EraseRootFromParent_Done,
     /*  96647 */   // Label 1755: @96647
     /*  96647 */   GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(96715), // Rule ID 4960 //
     /*  96652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96676 */     // MIs[0] base
     /*  96676 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96688 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96692 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96696 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96700 */     // (intrinsic_w_chain:{ *:[v8i16] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96705 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96707 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96713 */     GIR_RootConstrainSelectedInstOperands,
     /*  96714 */     // GIR_Coverage, 4960,
     /*  96714 */     GIR_EraseRootFromParent_Done,
     /*  96715 */   // Label 1756: @96715
     /*  96715 */   GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(96783), // Rule ID 4963 //
     /*  96720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96744 */     // MIs[0] base
     /*  96744 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96756 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96760 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96764 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96768 */     // (intrinsic_w_chain:{ *:[v8i16] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96773 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96775 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96781 */     GIR_RootConstrainSelectedInstOperands,
     /*  96782 */     // GIR_Coverage, 4963,
     /*  96782 */     GIR_EraseRootFromParent_Done,
     /*  96783 */   // Label 1757: @96783
     /*  96783 */   GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(96851), // Rule ID 4964 //
     /*  96788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96812 */     // MIs[0] base
     /*  96812 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96824 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96828 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96832 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96836 */     // (intrinsic_w_chain:{ *:[v8i16] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96841 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96843 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96845 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96849 */     GIR_RootConstrainSelectedInstOperands,
     /*  96850 */     // GIR_Coverage, 4964,
     /*  96850 */     GIR_EraseRootFromParent_Done,
     /*  96851 */   // Label 1758: @96851
     /*  96851 */   GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(96919), // Rule ID 4967 //
     /*  96856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96880 */     // MIs[0] base
     /*  96880 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96892 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96896 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96900 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96904 */     // (intrinsic_w_chain:{ *:[v8i16] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96909 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96911 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96917 */     GIR_RootConstrainSelectedInstOperands,
     /*  96918 */     // GIR_Coverage, 4967,
     /*  96918 */     GIR_EraseRootFromParent_Done,
     /*  96919 */   // Label 1759: @96919
     /*  96919 */   GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(96987), // Rule ID 4968 //
     /*  96924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96948 */     // MIs[0] base
     /*  96948 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96960 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96964 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96968 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96972 */     // (intrinsic_w_chain:{ *:[v8i16] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96977 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96979 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96985 */     GIR_RootConstrainSelectedInstOperands,
     /*  96986 */     // GIR_Coverage, 4968,
     /*  96986 */     GIR_EraseRootFromParent_Done,
     /*  96987 */   // Label 1760: @96987
     /*  96987 */   GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(97055), // Rule ID 4971 //
     /*  96992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97016 */     // MIs[0] base
     /*  97016 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97028 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97032 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97040 */     // (intrinsic_w_chain:{ *:[v8f16] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  97040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  97043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97045 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97047 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97053 */     GIR_RootConstrainSelectedInstOperands,
     /*  97054 */     // GIR_Coverage, 4971,
     /*  97054 */     GIR_EraseRootFromParent_Done,
     /*  97055 */   // Label 1761: @97055
     /*  97055 */   GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(97123), // Rule ID 4972 //
     /*  97060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97084 */     // MIs[0] base
     /*  97084 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97096 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97100 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97104 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97108 */     // (intrinsic_w_chain:{ *:[v8f16] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  97108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  97111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97113 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97115 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97117 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97121 */     GIR_RootConstrainSelectedInstOperands,
     /*  97122 */     // GIR_Coverage, 4972,
     /*  97122 */     GIR_EraseRootFromParent_Done,
     /*  97123 */   // Label 1762: @97123
     /*  97123 */   GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(97191), // Rule ID 4975 //
     /*  97128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97152 */     // MIs[0] base
     /*  97152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97164 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97168 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97172 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97176 */     // (intrinsic_w_chain:{ *:[v8f16] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  97176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  97179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97181 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97183 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97189 */     GIR_RootConstrainSelectedInstOperands,
     /*  97190 */     // GIR_Coverage, 4975,
     /*  97190 */     GIR_EraseRootFromParent_Done,
     /*  97191 */   // Label 1763: @97191
     /*  97191 */   GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(97259), // Rule ID 4976 //
     /*  97196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97220 */     // MIs[0] base
     /*  97220 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97232 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97236 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97240 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97244 */     // (intrinsic_w_chain:{ *:[v8f16] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  97244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  97247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97249 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97251 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97253 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97257 */     GIR_RootConstrainSelectedInstOperands,
     /*  97258 */     // GIR_Coverage, 4976,
     /*  97258 */     GIR_EraseRootFromParent_Done,
     /*  97259 */   // Label 1764: @97259
     /*  97259 */   GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(97327), // Rule ID 4979 //
     /*  97264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97288 */     // MIs[0] base
     /*  97288 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97300 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97304 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97308 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97312 */     // (intrinsic_w_chain:{ *:[v4i32] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU32_rq_u),
     /*  97315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97317 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97319 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97321 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97325 */     GIR_RootConstrainSelectedInstOperands,
     /*  97326 */     // GIR_Coverage, 4979,
     /*  97326 */     GIR_EraseRootFromParent_Done,
     /*  97327 */   // Label 1765: @97327
     /*  97327 */   GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(97395), // Rule ID 4980 //
     /*  97332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97356 */     // MIs[0] base
     /*  97356 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97368 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97372 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97376 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97380 */     // (intrinsic_w_chain:{ *:[v4i32] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU32_rq),
     /*  97383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97385 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97387 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97393 */     GIR_RootConstrainSelectedInstOperands,
     /*  97394 */     // GIR_Coverage, 4980,
     /*  97394 */     GIR_EraseRootFromParent_Done,
     /*  97395 */   // Label 1766: @97395
     /*  97395 */   GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(97463), // Rule ID 4983 //
     /*  97400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97424 */     // MIs[0] base
     /*  97424 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97436 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97440 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97444 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97448 */     // (intrinsic_w_chain:{ *:[v4i32] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHS32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHS32_rq_u),
     /*  97451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97453 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97455 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97457 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97461 */     GIR_RootConstrainSelectedInstOperands,
     /*  97462 */     // GIR_Coverage, 4983,
     /*  97462 */     GIR_EraseRootFromParent_Done,
     /*  97463 */   // Label 1767: @97463
     /*  97463 */   GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(97531), // Rule ID 4984 //
     /*  97468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97492 */     // MIs[0] base
     /*  97492 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97504 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97508 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97512 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97516 */     // (intrinsic_w_chain:{ *:[v4i32] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHS32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHS32_rq),
     /*  97519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97521 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97523 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97529 */     GIR_RootConstrainSelectedInstOperands,
     /*  97530 */     // GIR_Coverage, 4984,
     /*  97530 */     GIR_EraseRootFromParent_Done,
     /*  97531 */   // Label 1768: @97531
     /*  97531 */   GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(97599), // Rule ID 4987 //
     /*  97536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97560 */     // MIs[0] base
     /*  97560 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97572 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97576 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97584 */     // (intrinsic_w_chain:{ *:[v4i32] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97589 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97591 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97597 */     GIR_RootConstrainSelectedInstOperands,
     /*  97598 */     // GIR_Coverage, 4987,
     /*  97598 */     GIR_EraseRootFromParent_Done,
     /*  97599 */   // Label 1769: @97599
     /*  97599 */   GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(97667), // Rule ID 4988 //
     /*  97604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97628 */     // MIs[0] base
     /*  97628 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97640 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97644 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97648 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97652 */     // (intrinsic_w_chain:{ *:[v4i32] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97657 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97659 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97665 */     GIR_RootConstrainSelectedInstOperands,
     /*  97666 */     // GIR_Coverage, 4988,
     /*  97666 */     GIR_EraseRootFromParent_Done,
     /*  97667 */   // Label 1770: @97667
     /*  97667 */   GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(97735), // Rule ID 4991 //
     /*  97672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97696 */     // MIs[0] base
     /*  97696 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97708 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97712 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97716 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97720 */     // (intrinsic_w_chain:{ *:[v4i32] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97725 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97727 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97733 */     GIR_RootConstrainSelectedInstOperands,
     /*  97734 */     // GIR_Coverage, 4991,
     /*  97734 */     GIR_EraseRootFromParent_Done,
     /*  97735 */   // Label 1771: @97735
     /*  97735 */   GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(97803), // Rule ID 4992 //
     /*  97740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97764 */     // MIs[0] base
     /*  97764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97776 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97780 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97784 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97788 */     // (intrinsic_w_chain:{ *:[v4i32] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97793 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97795 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97801 */     GIR_RootConstrainSelectedInstOperands,
     /*  97802 */     // GIR_Coverage, 4992,
     /*  97802 */     GIR_EraseRootFromParent_Done,
     /*  97803 */   // Label 1772: @97803
     /*  97803 */   GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(97871), // Rule ID 4995 //
     /*  97808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97832 */     // MIs[0] base
     /*  97832 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97844 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97848 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97852 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97856 */     // (intrinsic_w_chain:{ *:[v4i32] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97861 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97863 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97865 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97869 */     GIR_RootConstrainSelectedInstOperands,
     /*  97870 */     // GIR_Coverage, 4995,
     /*  97870 */     GIR_EraseRootFromParent_Done,
     /*  97871 */   // Label 1773: @97871
     /*  97871 */   GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(97939), // Rule ID 4996 //
     /*  97876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97900 */     // MIs[0] base
     /*  97900 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97912 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97916 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97920 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97924 */     // (intrinsic_w_chain:{ *:[v4i32] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97929 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97931 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97933 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97937 */     GIR_RootConstrainSelectedInstOperands,
     /*  97938 */     // GIR_Coverage, 4996,
     /*  97938 */     GIR_EraseRootFromParent_Done,
     /*  97939 */   // Label 1774: @97939
     /*  97939 */   GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(98007), // Rule ID 4999 //
     /*  97944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97968 */     // MIs[0] base
     /*  97968 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97980 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97984 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97988 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97992 */     // (intrinsic_w_chain:{ *:[v4i32] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97997 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97999 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98001 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98005 */     GIR_RootConstrainSelectedInstOperands,
     /*  98006 */     // GIR_Coverage, 4999,
     /*  98006 */     GIR_EraseRootFromParent_Done,
     /*  98007 */   // Label 1775: @98007
     /*  98007 */   GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(98075), // Rule ID 5000 //
     /*  98012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98036 */     // MIs[0] base
     /*  98036 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98052 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  98056 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98060 */     // (intrinsic_w_chain:{ *:[v4i32] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  98063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98065 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98067 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98073 */     GIR_RootConstrainSelectedInstOperands,
     /*  98074 */     // GIR_Coverage, 5000,
     /*  98074 */     GIR_EraseRootFromParent_Done,
     /*  98075 */   // Label 1776: @98075
     /*  98075 */   GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(98143), // Rule ID 5003 //
     /*  98080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98104 */     // MIs[0] base
     /*  98104 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98120 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98124 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98128 */     // (intrinsic_w_chain:{ *:[v4f32] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  98131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98133 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98135 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98137 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98141 */     GIR_RootConstrainSelectedInstOperands,
     /*  98142 */     // GIR_Coverage, 5003,
     /*  98142 */     GIR_EraseRootFromParent_Done,
     /*  98143 */   // Label 1777: @98143
     /*  98143 */   GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(98211), // Rule ID 5004 //
     /*  98148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98172 */     // MIs[0] base
     /*  98172 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98184 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98188 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  98192 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98196 */     // (intrinsic_w_chain:{ *:[v4f32] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  98199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98201 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98203 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98205 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98209 */     GIR_RootConstrainSelectedInstOperands,
     /*  98210 */     // GIR_Coverage, 5004,
     /*  98210 */     GIR_EraseRootFromParent_Done,
     /*  98211 */   // Label 1778: @98211
     /*  98211 */   GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(98279), // Rule ID 5007 //
     /*  98216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98240 */     // MIs[0] base
     /*  98240 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98252 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98256 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98260 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98264 */     // (intrinsic_w_chain:{ *:[v4f32] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  98267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98269 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98271 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98277 */     GIR_RootConstrainSelectedInstOperands,
     /*  98278 */     // GIR_Coverage, 5007,
     /*  98278 */     GIR_EraseRootFromParent_Done,
     /*  98279 */   // Label 1779: @98279
     /*  98279 */   GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(98347), // Rule ID 5008 //
     /*  98284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98308 */     // MIs[0] base
     /*  98308 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98320 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98324 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  98328 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98332 */     // (intrinsic_w_chain:{ *:[v4f32] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  98335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98337 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98339 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98345 */     GIR_RootConstrainSelectedInstOperands,
     /*  98346 */     // GIR_Coverage, 5008,
     /*  98346 */     GIR_EraseRootFromParent_Done,
     /*  98347 */   // Label 1780: @98347
     /*  98347 */   GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(98415), // Rule ID 5011 //
     /*  98352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98376 */     // MIs[0] base
     /*  98376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98388 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98392 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98396 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98400 */     // (intrinsic_w_chain:{ *:[v2i64] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98405 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98407 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98413 */     GIR_RootConstrainSelectedInstOperands,
     /*  98414 */     // GIR_Coverage, 5011,
     /*  98414 */     GIR_EraseRootFromParent_Done,
     /*  98415 */   // Label 1781: @98415
     /*  98415 */   GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(98483), // Rule ID 5012 //
     /*  98420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98444 */     // MIs[0] base
     /*  98444 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98456 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98460 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98464 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98468 */     // (intrinsic_w_chain:{ *:[v2i64] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98473 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98475 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98481 */     GIR_RootConstrainSelectedInstOperands,
     /*  98482 */     // GIR_Coverage, 5012,
     /*  98482 */     GIR_EraseRootFromParent_Done,
     /*  98483 */   // Label 1782: @98483
     /*  98483 */   GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(98551), // Rule ID 5015 //
     /*  98488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98512 */     // MIs[0] base
     /*  98512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98524 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98528 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98532 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98536 */     // (intrinsic_w_chain:{ *:[v2i64] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98541 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98543 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98549 */     GIR_RootConstrainSelectedInstOperands,
     /*  98550 */     // GIR_Coverage, 5015,
     /*  98550 */     GIR_EraseRootFromParent_Done,
     /*  98551 */   // Label 1783: @98551
     /*  98551 */   GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(98619), // Rule ID 5016 //
     /*  98556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98580 */     // MIs[0] base
     /*  98580 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98592 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98596 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98600 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98604 */     // (intrinsic_w_chain:{ *:[v2i64] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98609 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98611 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98617 */     GIR_RootConstrainSelectedInstOperands,
     /*  98618 */     // GIR_Coverage, 5016,
     /*  98618 */     GIR_EraseRootFromParent_Done,
     /*  98619 */   // Label 1784: @98619
     /*  98619 */   GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(98687), // Rule ID 5019 //
     /*  98624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98648 */     // MIs[0] base
     /*  98648 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98668 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98672 */     // (intrinsic_w_chain:{ *:[v2i64] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98677 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98679 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98685 */     GIR_RootConstrainSelectedInstOperands,
     /*  98686 */     // GIR_Coverage, 5019,
     /*  98686 */     GIR_EraseRootFromParent_Done,
     /*  98687 */   // Label 1785: @98687
     /*  98687 */   GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(98755), // Rule ID 5020 //
     /*  98692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98716 */     // MIs[0] base
     /*  98716 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98728 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98732 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98736 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98740 */     // (intrinsic_w_chain:{ *:[v2i64] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98745 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98747 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98753 */     GIR_RootConstrainSelectedInstOperands,
     /*  98754 */     // GIR_Coverage, 5020,
     /*  98754 */     GIR_EraseRootFromParent_Done,
     /*  98755 */   // Label 1786: @98755
     /*  98755 */   GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(98823), // Rule ID 5023 //
     /*  98760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98784 */     // MIs[0] base
     /*  98784 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98796 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98800 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98804 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98808 */     // (intrinsic_w_chain:{ *:[v2i64] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98813 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98815 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98821 */     GIR_RootConstrainSelectedInstOperands,
     /*  98822 */     // GIR_Coverage, 5023,
     /*  98822 */     GIR_EraseRootFromParent_Done,
     /*  98823 */   // Label 1787: @98823
     /*  98823 */   GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(98891), // Rule ID 5024 //
     /*  98828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98852 */     // MIs[0] base
     /*  98852 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98864 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98868 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98872 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98876 */     // (intrinsic_w_chain:{ *:[v2i64] } 3642:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98881 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98883 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98889 */     GIR_RootConstrainSelectedInstOperands,
     /*  98890 */     // GIR_Coverage, 5024,
     /*  98890 */     GIR_EraseRootFromParent_Done,
     /*  98891 */   // Label 1788: @98891
     /*  98891 */   GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(98956), // Rule ID 256 //
     /*  98896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  98899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr),
     /*  98904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  98907 */     // MIs[0] cop
     /*  98907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  98910 */     // MIs[0] opc1
     /*  98910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  98913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98917 */     // MIs[0] CRn
     /*  98917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98920 */     // MIs[0] CRm
     /*  98920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  98923 */     // MIs[0] opc2
     /*  98923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  98926 */     // (intrinsic_void 3517:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (MCR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  98926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCR),
     /*  98929 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  98931 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  98933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  98935 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  98937 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  98939 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  98941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  98944 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  98950 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98954 */     GIR_RootConstrainSelectedInstOperands,
     /*  98955 */     // GIR_Coverage, 256,
     /*  98955 */     GIR_EraseRootFromParent_Done,
     /*  98956 */   // Label 1789: @98956
     /*  98956 */   GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(99012), // Rule ID 257 //
     /*  98961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  98964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr2),
     /*  98969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  98972 */     // MIs[0] cop
     /*  98972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  98975 */     // MIs[0] opc1
     /*  98975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  98978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98982 */     // MIs[0] CRn
     /*  98982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98985 */     // MIs[0] CRm
     /*  98985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  98988 */     // MIs[0] opc2
     /*  98988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  98991 */     // (intrinsic_void 3518:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (MCR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  98991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCR2),
     /*  98994 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  98996 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  98998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  99000 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  99002 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  99004 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  99006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99010 */     GIR_RootConstrainSelectedInstOperands,
     /*  99011 */     // GIR_Coverage, 257,
     /*  99011 */     GIR_EraseRootFromParent_Done,
     /*  99012 */   // Label 1790: @99012
     /*  99012 */   GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(99077), // Rule ID 594 //
     /*  99017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  99020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr),
     /*  99025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  99028 */     // MIs[0] cop
     /*  99028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  99031 */     // MIs[0] opc1
     /*  99031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  99034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99038 */     // MIs[0] CRn
     /*  99038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99041 */     // MIs[0] CRm
     /*  99041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  99044 */     // MIs[0] opc2
     /*  99044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  99047 */     // (intrinsic_void 3517:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2MCR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  99047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCR),
     /*  99050 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  99052 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  99054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  99056 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  99058 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  99060 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  99062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99065 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99071 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99075 */     GIR_RootConstrainSelectedInstOperands,
     /*  99076 */     // GIR_Coverage, 594,
     /*  99076 */     GIR_EraseRootFromParent_Done,
     /*  99077 */   // Label 1791: @99077
     /*  99077 */   GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(99142), // Rule ID 595 //
     /*  99082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  99085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr2),
     /*  99090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  99093 */     // MIs[0] cop
     /*  99093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  99096 */     // MIs[0] opc1
     /*  99096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  99099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99103 */     // MIs[0] CRn
     /*  99103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99106 */     // MIs[0] CRm
     /*  99106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  99109 */     // MIs[0] opc2
     /*  99109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  99112 */     // (intrinsic_void 3518:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2MCR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  99112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCR2),
     /*  99115 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  99117 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  99119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  99121 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  99123 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  99125 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  99127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99130 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99140 */     GIR_RootConstrainSelectedInstOperands,
     /*  99141 */     // GIR_Coverage, 595,
     /*  99141 */     GIR_EraseRootFromParent_Done,
     /*  99142 */   // Label 1792: @99142
     /*  99142 */   GIM_Reject,
     /*  99143 */ // Label 1742: @99143
     /*  99143 */ GIM_Reject,
     /*  99144 */ // Label 17: @99144
     /*  99144 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(13), /*)*//*default:*//*Label 1796*/ GIMT_Encode4(99301),
     /*  99155 */ /*GILLT_v2s64*//*Label 1793*/ GIMT_Encode4(99187), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99167 */ /*GILLT_v4s32*//*Label 1794*/ GIMT_Encode4(99225), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99183 */ /*GILLT_v8s16*//*Label 1795*/ GIMT_Encode4(99263),
     /*  99187 */ // Label 1793: @99187
     /*  99187 */ GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(99224), // Rule ID 2668 //
     /*  99192 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  99198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99202 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99206 */   // (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)  =>  (VMOVLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  99206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv2i64),
     /*  99209 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99211 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99213 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99216 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99222 */   GIR_RootConstrainSelectedInstOperands,
     /*  99223 */   // GIR_Coverage, 2668,
     /*  99223 */   GIR_EraseRootFromParent_Done,
     /*  99224 */ // Label 1797: @99224
     /*  99224 */ GIM_Reject,
     /*  99225 */ // Label 1794: @99225
     /*  99225 */ GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(99262), // Rule ID 2667 //
     /*  99230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  99236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99244 */   // (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)  =>  (VMOVLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  99244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv4i32),
     /*  99247 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99249 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99251 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99254 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99260 */   GIR_RootConstrainSelectedInstOperands,
     /*  99261 */   // GIR_Coverage, 2667,
     /*  99261 */   GIR_EraseRootFromParent_Done,
     /*  99262 */ // Label 1798: @99262
     /*  99262 */ GIM_Reject,
     /*  99263 */ // Label 1795: @99263
     /*  99263 */ GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(99300), // Rule ID 2666 //
     /*  99268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  99274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99282 */   // (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)  =>  (VMOVLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  99282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv8i16),
     /*  99285 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99287 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99289 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99292 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99298 */   GIR_RootConstrainSelectedInstOperands,
     /*  99299 */   // GIR_Coverage, 2666,
     /*  99299 */   GIR_EraseRootFromParent_Done,
     /*  99300 */ // Label 1799: @99300
     /*  99300 */ GIM_Reject,
     /*  99301 */ // Label 1796: @99301
     /*  99301 */ GIM_Reject,
     /*  99302 */ // Label 18: @99302
     /*  99302 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(12), /*)*//*default:*//*Label 1803*/ GIMT_Encode4(99459),
     /*  99313 */ /*GILLT_v2s32*//*Label 1800*/ GIMT_Encode4(99345), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99325 */ /*GILLT_v4s16*//*Label 1801*/ GIMT_Encode4(99383), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99341 */ /*GILLT_v8s8*//*Label 1802*/ GIMT_Encode4(99421),
     /*  99345 */ // Label 1800: @99345
     /*  99345 */ GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(99382), // Rule ID 1588 //
     /*  99350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99360 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99364 */   // (trunc:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)  =>  (VMOVNv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  99364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVNv2i32),
     /*  99367 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99369 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99371 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99374 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99380 */   GIR_RootConstrainSelectedInstOperands,
     /*  99381 */   // GIR_Coverage, 1588,
     /*  99381 */   GIR_EraseRootFromParent_Done,
     /*  99382 */ // Label 1804: @99382
     /*  99382 */ GIM_Reject,
     /*  99383 */ // Label 1801: @99383
     /*  99383 */ GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(99420), // Rule ID 1587 //
     /*  99388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  99394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99398 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99402 */   // (trunc:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)  =>  (VMOVNv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  99402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVNv4i16),
     /*  99405 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99407 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99409 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99412 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99418 */   GIR_RootConstrainSelectedInstOperands,
     /*  99419 */   // GIR_Coverage, 1587,
     /*  99419 */   GIR_EraseRootFromParent_Done,
     /*  99420 */ // Label 1805: @99420
     /*  99420 */ GIM_Reject,
     /*  99421 */ // Label 1802: @99421
     /*  99421 */ GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(99458), // Rule ID 1586 //
     /*  99426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  99432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99440 */   // (trunc:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)  =>  (VMOVNv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  99440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVNv8i8),
     /*  99443 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99445 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99447 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99450 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99456 */   GIR_RootConstrainSelectedInstOperands,
     /*  99457 */   // GIR_Coverage, 1586,
     /*  99457 */   GIR_EraseRootFromParent_Done,
     /*  99458 */ // Label 1806: @99458
     /*  99458 */ GIM_Reject,
     /*  99459 */ // Label 1803: @99459
     /*  99459 */ GIM_Reject,
     /*  99460 */ // Label 19: @99460
     /*  99460 */ GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(99780),
     /*  99465 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  99468 */   GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(99509), // Rule ID 404 //
     /*  99473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  99476 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  99480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99484 */     // MIs[0] Operand 1
     /*  99484 */     // No operand predicates
     /*  99484 */     // (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm  =>  (t2MOVi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /*  99487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99495 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99501 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99507 */     GIR_RootConstrainSelectedInstOperands,
     /*  99508 */     // GIR_Coverage, 404,
     /*  99508 */     GIR_EraseRootFromParent_Done,
     /*  99509 */   // Label 1808: @99509
     /*  99509 */   GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(99550), // Rule ID 57 //
     /*  99514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  99517 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  99521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99525 */     // MIs[0] Operand 1
     /*  99525 */     // No operand predicates
     /*  99525 */     // (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm  =>  (MOVi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVi),
     /*  99528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99536 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99542 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99548 */     GIR_RootConstrainSelectedInstOperands,
     /*  99549 */     // GIR_Coverage, 57,
     /*  99549 */     GIR_EraseRootFromParent_Done,
     /*  99550 */   // Label 1809: @99550
     /*  99550 */   GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(99585), // Rule ID 58 //
     /*  99555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /*  99558 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  99562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99566 */     // MIs[0] Operand 1
     /*  99566 */     // No operand predicates
     /*  99566 */     // (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm  =>  (MOVi16:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVi16),
     /*  99569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99577 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99583 */     GIR_RootConstrainSelectedInstOperands,
     /*  99584 */     // GIR_Coverage, 58,
     /*  99584 */     GIR_EraseRootFromParent_Done,
     /*  99585 */   // Label 1810: @99585
     /*  99585 */   GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(99628), // Rule ID 168 //
     /*  99590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  99593 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm_not),
     /*  99597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99601 */     // MIs[0] Operand 1
     /*  99601 */     // No operand predicates
     /*  99601 */     // (imm:{ *:[i32] })<<P:Predicate_mod_imm_not>><<X:imm_not_XFORM>>:$imm  =>  (MVNi:{ *:[i32] } (imm_not_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  99601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVNi),
     /*  99604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99606 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderInvertedImm), // imm
     /*  99611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99614 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99620 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99626 */     GIR_RootConstrainSelectedInstOperands,
     /*  99627 */     // GIR_Coverage, 168,
     /*  99627 */     GIR_EraseRootFromParent_Done,
     /*  99628 */   // Label 1811: @99628
     /*  99628 */   GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(99654), // Rule ID 268 //
     /*  99633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  99636 */     GIM_CheckAPIntImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_arm_i32imm),
     /*  99640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99644 */     // MIs[0] Operand 1
     /*  99644 */     // No operand predicates
     /*  99644 */     // (imm:{ *:[i32] })<<P:Predicate_arm_i32imm>>:$src  =>  (MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /*  99644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVi32imm),
     /*  99647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /*  99652 */     GIR_RootConstrainSelectedInstOperands,
     /*  99653 */     // GIR_Coverage, 268,
     /*  99653 */     GIR_EraseRootFromParent_Done,
     /*  99654 */   // Label 1812: @99654
     /*  99654 */   GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(99695), // Rule ID 322 //
     /*  99659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  99662 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255_expr),
     /*  99666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  99670 */     // MIs[0] Operand 1
     /*  99670 */     // No operand predicates
     /*  99670 */     // (imm:{ *:[i32] })<<P:Predicate_imm0_255_expr>>:$imm8  =>  (tMOVi8:{ *:[i32] } (imm:{ *:[i32] }):$imm8)
     /*  99670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /*  99673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99675 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  99681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm8
     /*  99684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99687 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99693 */     GIR_RootConstrainSelectedInstOperands,
     /*  99694 */     // GIR_Coverage, 322,
     /*  99694 */     GIR_EraseRootFromParent_Done,
     /*  99695 */   // Label 1813: @99695
     /*  99695 */   GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(99730), // Rule ID 405 //
     /*  99700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV8MBaseline_IsThumb),
     /*  99703 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  99707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99711 */     // MIs[0] Operand 1
     /*  99711 */     // No operand predicates
     /*  99711 */     // (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm  =>  (t2MOVi16:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVi16),
     /*  99714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99728 */     GIR_RootConstrainSelectedInstOperands,
     /*  99729 */     // GIR_Coverage, 405,
     /*  99729 */     GIR_EraseRootFromParent_Done,
     /*  99730 */   // Label 1814: @99730
     /*  99730 */   GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(99779),
     /*  99735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99739 */     GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(99760), // Rule ID 353 //
     /*  99744 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseMovt_GenExecuteOnly_IsThumb1Only),
     /*  99747 */       // MIs[0] Operand 1
     /*  99747 */       // No operand predicates
     /*  99747 */       // (imm:{ *:[i32] }):$src  =>  (tMOVi32imm:{ *:[i32] }:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /*  99747 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMOVi32imm),
     /*  99750 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99752 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /*  99755 */       GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::CPSR*/0,
     /*  99758 */       GIR_RootConstrainSelectedInstOperands,
     /*  99759 */       // GIR_Coverage, 353,
     /*  99759 */       GIR_EraseRootFromParent_Done,
     /*  99760 */     // Label 1816: @99760
     /*  99760 */     GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(99778), // Rule ID 582 //
     /*  99765 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_UseMovt),
     /*  99768 */       // MIs[0] Operand 1
     /*  99768 */       // No operand predicates
     /*  99768 */       // (imm:{ *:[i32] }):$src  =>  (t2MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /*  99768 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVi32imm),
     /*  99771 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99773 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /*  99776 */       GIR_RootConstrainSelectedInstOperands,
     /*  99777 */       // GIR_Coverage, 582,
     /*  99777 */       GIR_EraseRootFromParent_Done,
     /*  99778 */     // Label 1817: @99778
     /*  99778 */     GIM_Reject,
     /*  99779 */   // Label 1815: @99779
     /*  99779 */   GIM_Reject,
     /*  99780 */ // Label 1807: @99780
     /*  99780 */ GIM_Reject,
     /*  99781 */ // Label 20: @99781
     /*  99781 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1820*/ GIMT_Encode4(99876),
     /*  99792 */ /*GILLT_s32*//*Label 1818*/ GIMT_Encode4(99800),
     /*  99796 */ /*GILLT_s64*//*Label 1819*/ GIMT_Encode4(99838),
     /*  99800 */ // Label 1818: @99800
     /*  99800 */ GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(99837), // Rule ID 728 //
     /*  99805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP3),
     /*  99808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  99812 */   // MIs[0] Operand 1
     /*  99812 */   // No operand predicates
     /*  99812 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_vfp_f32imm),
     /*  99816 */   // (fpimm:{ *:[f32] })<<P:Predicate_vfp_f32imm>><<X:vfp_f32imm_xform>>:$imm  =>  (FCONSTS:{ *:[f32] } (vfp_f32imm_xform:{ *:[f32] } (fpimm:{ *:[f32] }):$imm))
     /*  99816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::FCONSTS),
     /*  99819 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  99821 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderVFPF32Imm), // imm
     /*  99826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99829 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99835 */   GIR_RootConstrainSelectedInstOperands,
     /*  99836 */   // GIR_Coverage, 728,
     /*  99836 */   GIR_EraseRootFromParent_Done,
     /*  99837 */ // Label 1821: @99837
     /*  99837 */ GIM_Reject,
     /*  99838 */ // Label 1819: @99838
     /*  99838 */ GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(99875), // Rule ID 727 //
     /*  99843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP3),
     /*  99846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99850 */   // MIs[0] Operand 1
     /*  99850 */   // No operand predicates
     /*  99850 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_vfp_f64imm),
     /*  99854 */   // (fpimm:{ *:[f64] })<<P:Predicate_vfp_f64imm>><<X:vfp_f64imm_xform>>:$imm  =>  (FCONSTD:{ *:[f64] } (vfp_f64imm_xform:{ *:[f64] } (fpimm:{ *:[f64] }):$imm))
     /*  99854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::FCONSTD),
     /*  99857 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /*  99859 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderVFPF64Imm), // imm
     /*  99864 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99867 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99873 */   GIR_RootConstrainSelectedInstOperands,
     /*  99874 */   // GIR_Coverage, 727,
     /*  99874 */   GIR_EraseRootFromParent_Done,
     /*  99875 */ // Label 1822: @99875
     /*  99875 */ GIM_Reject,
     /*  99876 */ // Label 1820: @99876
     /*  99876 */ GIM_Reject,
     /*  99877 */ // Label 21: @99877
     /*  99877 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(13), /*)*//*default:*//*Label 1826*/ GIMT_Encode4(100034),
     /*  99888 */ /*GILLT_v2s64*//*Label 1823*/ GIMT_Encode4(99920), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99900 */ /*GILLT_v4s32*//*Label 1824*/ GIMT_Encode4(99958), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99916 */ /*GILLT_v8s16*//*Label 1825*/ GIMT_Encode4(99996),
     /*  99920 */ // Label 1823: @99920
     /*  99920 */ GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(99957), // Rule ID 1600 //
     /*  99925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  99931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99935 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99939 */   // (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)  =>  (VMOVLsv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  99939 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLsv2i64),
     /*  99942 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99944 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99949 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99955 */   GIR_RootConstrainSelectedInstOperands,
     /*  99956 */   // GIR_Coverage, 1600,
     /*  99956 */   GIR_EraseRootFromParent_Done,
     /*  99957 */ // Label 1827: @99957
     /*  99957 */ GIM_Reject,
     /*  99958 */ // Label 1824: @99958
     /*  99958 */ GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(99995), // Rule ID 1599 //
     /*  99963 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  99969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99977 */   // (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)  =>  (VMOVLsv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  99977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLsv4i32),
     /*  99980 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99982 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99984 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99987 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99993 */   GIR_RootConstrainSelectedInstOperands,
     /*  99994 */   // GIR_Coverage, 1599,
     /*  99994 */   GIR_EraseRootFromParent_Done,
     /*  99995 */ // Label 1828: @99995
     /*  99995 */ GIM_Reject,
     /*  99996 */ // Label 1825: @99996
     /*  99996 */ GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(100033), // Rule ID 1598 //
     /* 100001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 100007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100015 */   // (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)  =>  (VMOVLsv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)
     /* 100015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLsv8i16),
     /* 100018 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100020 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100022 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100025 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100031 */   GIR_RootConstrainSelectedInstOperands,
     /* 100032 */   // GIR_Coverage, 1598,
     /* 100032 */   GIR_EraseRootFromParent_Done,
     /* 100033 */ // Label 1829: @100033
     /* 100033 */ GIM_Reject,
     /* 100034 */ // Label 1826: @100034
     /* 100034 */ GIM_Reject,
     /* 100035 */ // Label 22: @100035
     /* 100035 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 1833*/ GIMT_Encode4(100639),
     /* 100046 */ /*GILLT_s32*//*Label 1830*/ GIMT_Encode4(100094), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100074 */ /*GILLT_v4s32*//*Label 1831*/ GIMT_Encode4(100386), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100090 */ /*GILLT_v8s16*//*Label 1832*/ GIMT_Encode4(100569),
     /* 100094 */ // Label 1830: @100094
     /* 100094 */ GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(100385),
     /* 100099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 100102 */   GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(100147), // Rule ID 340 //
     /* 100107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 100110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100118 */     // MIs[0] Operand 2
     /* 100118 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100129 */     // (sext_inreg:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, i8:{ *:[Other] })  =>  (tSXTB:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 100129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tSXTB),
     /* 100132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100134 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 100136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100139 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100145 */     GIR_RootConstrainSelectedInstOperands,
     /* 100146 */     // GIR_Coverage, 340,
     /* 100146 */     GIR_EraseRootFromParent_Done,
     /* 100147 */   // Label 1835: @100147
     /* 100147 */   GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(100192), // Rule ID 341 //
     /* 100152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 100155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100163 */     // MIs[0] Operand 2
     /* 100163 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 100174 */     // (sext_inreg:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })  =>  (tSXTH:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 100174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tSXTH),
     /* 100177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100179 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 100181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100184 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100190 */     GIR_RootConstrainSelectedInstOperands,
     /* 100191 */     // GIR_Coverage, 341,
     /* 100191 */     GIR_EraseRootFromParent_Done,
     /* 100192 */   // Label 1836: @100192
     /* 100192 */   GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(100240), // Rule ID 2002 //
     /* 100197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 100200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 100204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 100208 */     // MIs[0] Operand 2
     /* 100208 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100219 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Src, i8:{ *:[Other] })  =>  (SXTB:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTB),
     /* 100222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100224 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100232 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100238 */     GIR_RootConstrainSelectedInstOperands,
     /* 100239 */     // GIR_Coverage, 2002,
     /* 100239 */     GIR_EraseRootFromParent_Done,
     /* 100240 */   // Label 1837: @100240
     /* 100240 */   GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(100288), // Rule ID 2003 //
     /* 100245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 100248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 100252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 100256 */     // MIs[0] Operand 2
     /* 100256 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 100267 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Src, i16:{ *:[Other] })  =>  (SXTH:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTH),
     /* 100270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100272 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100280 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100286 */     GIR_RootConstrainSelectedInstOperands,
     /* 100287 */     // GIR_Coverage, 2003,
     /* 100287 */     GIR_EraseRootFromParent_Done,
     /* 100288 */   // Label 1838: @100288
     /* 100288 */   GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(100336), // Rule ID 2241 //
     /* 100293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100304 */     // MIs[0] Operand 2
     /* 100304 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100315 */     // (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Src, i8:{ *:[Other] })  =>  (t2SXTB:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTB),
     /* 100318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100320 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100328 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100334 */     GIR_RootConstrainSelectedInstOperands,
     /* 100335 */     // GIR_Coverage, 2241,
     /* 100335 */     GIR_EraseRootFromParent_Done,
     /* 100336 */   // Label 1839: @100336
     /* 100336 */   GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(100384), // Rule ID 2242 //
     /* 100341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100352 */     // MIs[0] Operand 2
     /* 100352 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 100363 */     // (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Src, i16:{ *:[Other] })  =>  (t2SXTH:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTH),
     /* 100366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100368 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100376 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100382 */     GIR_RootConstrainSelectedInstOperands,
     /* 100383 */     // GIR_Coverage, 2242,
     /* 100383 */     GIR_EraseRootFromParent_Done,
     /* 100384 */   // Label 1840: @100384
     /* 100384 */   GIM_Reject,
     /* 100385 */ // Label 1834: @100385
     /* 100385 */ GIM_Reject,
     /* 100386 */ // Label 1831: @100386
     /* 100386 */ GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(100568),
     /* 100391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100398 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100402 */   GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(100460), // Rule ID 3713 //
     /* 100407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 100410 */     // MIs[0] Operand 2
     /* 100410 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 100421 */     // (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, v4i16:{ *:[Other] })  =>  (MVE_VMOVLs16bh:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src)
     /* 100421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 100424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs16bh),
     /* 100436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 100438 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 100440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100443 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100449 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100458 */     GIR_RootConstrainSelectedInstOperands,
     /* 100459 */     // GIR_Coverage, 3713,
     /* 100459 */     GIR_EraseRootFromParent_Done,
     /* 100460 */   // Label 1842: @100460
     /* 100460 */   GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(100567), // Rule ID 3715 //
     /* 100465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 100468 */     // MIs[0] Operand 2
     /* 100468 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100479 */     // (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, v4i8:{ *:[Other] })  =>  (MVE_VMOVLs16bh:{ *:[v4i32] } (MVE_VMOVLs8bh:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src))
     /* 100479 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 100482 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100486 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100491 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 100494 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100498 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 100506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs8bh),
     /* 100510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100515 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 100519 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 100522 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100528 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100534 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 100539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs16bh),
     /* 100542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 100544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100550 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100556 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100565 */     GIR_RootConstrainSelectedInstOperands,
     /* 100566 */     // GIR_Coverage, 3715,
     /* 100566 */     GIR_EraseRootFromParent_Done,
     /* 100567 */   // Label 1843: @100567
     /* 100567 */   GIM_Reject,
     /* 100568 */ // Label 1841: @100568
     /* 100568 */ GIM_Reject,
     /* 100569 */ // Label 1832: @100569
     /* 100569 */ GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(100638), // Rule ID 3714 //
     /* 100574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 100577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 100580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100584 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100588 */   // MIs[0] Operand 2
     /* 100588 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100599 */   // (sext_inreg:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, v8i8:{ *:[Other] })  =>  (MVE_VMOVLs8bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src)
     /* 100599 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 100602 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100606 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100611 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs8bh),
     /* 100614 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 100616 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 100618 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100621 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100627 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100633 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100636 */   GIR_RootConstrainSelectedInstOperands,
     /* 100637 */   // GIR_Coverage, 3714,
     /* 100637 */   GIR_EraseRootFromParent_Done,
     /* 100638 */ // Label 1844: @100638
     /* 100638 */ GIM_Reject,
     /* 100639 */ // Label 1833: @100639
     /* 100639 */ GIM_Reject,
     /* 100640 */ // Label 23: @100640
     /* 100640 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(13), /*)*//*default:*//*Label 1848*/ GIMT_Encode4(100797),
     /* 100651 */ /*GILLT_v2s64*//*Label 1845*/ GIMT_Encode4(100683), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100663 */ /*GILLT_v4s32*//*Label 1846*/ GIMT_Encode4(100721), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100679 */ /*GILLT_v8s16*//*Label 1847*/ GIMT_Encode4(100759),
     /* 100683 */ // Label 1845: @100683
     /* 100683 */ GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(100720), // Rule ID 1603 //
     /* 100688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 100694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100702 */   // (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)  =>  (VMOVLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)
     /* 100702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv2i64),
     /* 100705 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100707 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100709 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100712 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100718 */   GIR_RootConstrainSelectedInstOperands,
     /* 100719 */   // GIR_Coverage, 1603,
     /* 100719 */   GIR_EraseRootFromParent_Done,
     /* 100720 */ // Label 1849: @100720
     /* 100720 */ GIM_Reject,
     /* 100721 */ // Label 1846: @100721
     /* 100721 */ GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(100758), // Rule ID 1602 //
     /* 100726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 100732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100740 */   // (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)  =>  (VMOVLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)
     /* 100740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv4i32),
     /* 100743 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100745 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100747 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100750 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100756 */   GIR_RootConstrainSelectedInstOperands,
     /* 100757 */   // GIR_Coverage, 1602,
     /* 100757 */   GIR_EraseRootFromParent_Done,
     /* 100758 */ // Label 1850: @100758
     /* 100758 */ GIM_Reject,
     /* 100759 */ // Label 1847: @100759
     /* 100759 */ GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(100796), // Rule ID 1601 //
     /* 100764 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 100770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100774 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100778 */   // (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)  =>  (VMOVLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)
     /* 100778 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv8i16),
     /* 100781 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100783 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100785 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100788 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100794 */   GIR_RootConstrainSelectedInstOperands,
     /* 100795 */   // GIR_Coverage, 1601,
     /* 100795 */   GIR_EraseRootFromParent_Done,
     /* 100796 */ // Label 1851: @100796
     /* 100796 */ GIM_Reject,
     /* 100797 */ // Label 1848: @100797
     /* 100797 */ GIM_Reject,
     /* 100798 */ // Label 24: @100798
     /* 100798 */ GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(101013),
     /* 100803 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 100806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 100809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 100812 */   GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(100869), // Rule ID 470 //
     /* 100817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 100836 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_31),
     /* 100840 */     // MIs[1] Operand 1
     /* 100840 */     // No operand predicates
     /* 100840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100842 */     // (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm1_31>>:$imm)  =>  (t2LSLri:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 100842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2LSLri),
     /* 100845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100847 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 100849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 100852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100855 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100867 */     GIR_RootConstrainSelectedInstOperands,
     /* 100868 */     // GIR_Coverage, 470,
     /* 100868 */     GIR_EraseRootFromParent_Done,
     /* 100869 */   // Label 1853: @100869
     /* 100869 */   GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(100966),
     /* 100874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100882 */     GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(100927), // Rule ID 318 //
     /* 100887 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 100890 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100894 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 100898 */       // MIs[1] Operand 1
     /* 100898 */       // No operand predicates
     /* 100898 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100900 */       // (shl:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm5)  =>  (tLSLri:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm5)
     /* 100900 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLSLri),
     /* 100903 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100905 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 100911 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 100913 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm5
     /* 100916 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100919 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100925 */       GIR_RootConstrainSelectedInstOperands,
     /* 100926 */       // GIR_Coverage, 318,
     /* 100926 */       GIR_EraseRootFromParent_Done,
     /* 100927 */     // Label 1855: @100927
     /* 100927 */     GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(100965), // Rule ID 319 //
     /* 100932 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 100935 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100939 */       // (shl:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tLSLrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 100939 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLSLrr),
     /* 100942 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 100944 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 100950 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 100952 */       GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 100954 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100957 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100963 */       GIR_RootConstrainSelectedInstOperands,
     /* 100964 */       // GIR_Coverage, 319,
     /* 100964 */       GIR_EraseRootFromParent_Done,
     /* 100965 */     // Label 1856: @100965
     /* 100965 */     GIM_Reject,
     /* 100966 */   // Label 1854: @100966
     /* 100966 */   GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(101012), // Rule ID 471 //
     /* 100971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100986 */     // (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2LSLrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 100986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2LSLrr),
     /* 100989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100991 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 100993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 100995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100998 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101004 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101010 */     GIR_RootConstrainSelectedInstOperands,
     /* 101011 */     // GIR_Coverage, 471,
     /* 101011 */     GIR_EraseRootFromParent_Done,
     /* 101012 */   // Label 1857: @101012
     /* 101012 */   GIM_Reject,
     /* 101013 */ // Label 1852: @101013
     /* 101013 */ GIM_Reject,
     /* 101014 */ // Label 25: @101014
     /* 101014 */ GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(101121),
     /* 101019 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 101022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 101025 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 101028 */   GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(101074), // Rule ID 321 //
     /* 101033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 101036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101048 */     // (srl:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tLSRrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 101048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLSRrr),
     /* 101051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 101053 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 101059 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101066 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101072 */     GIR_RootConstrainSelectedInstOperands,
     /* 101073 */     // GIR_Coverage, 321,
     /* 101073 */     GIR_EraseRootFromParent_Done,
     /* 101074 */   // Label 1859: @101074
     /* 101074 */   GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(101120), // Rule ID 473 //
     /* 101079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101094 */     // (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2LSRrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 101094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2LSRrr),
     /* 101097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101099 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101106 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101112 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101118 */     GIR_RootConstrainSelectedInstOperands,
     /* 101119 */     // GIR_Coverage, 473,
     /* 101119 */     GIR_EraseRootFromParent_Done,
     /* 101120 */   // Label 1860: @101120
     /* 101120 */   GIM_Reject,
     /* 101121 */ // Label 1858: @101121
     /* 101121 */ GIM_Reject,
     /* 101122 */ // Label 26: @101122
     /* 101122 */ GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(101394),
     /* 101127 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 101130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 101133 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 101136 */   GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(101191), // Rule ID 201 //
     /* 101141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 101144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101160 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101165 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101171 */     // (sra:{ *:[i32] } (bswap:{ *:[i32] } GPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (REVSH:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 101171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REVSH),
     /* 101174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101183 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101189 */     GIR_RootConstrainSelectedInstOperands,
     /* 101190 */     // GIR_Coverage, 201,
     /* 101190 */     GIR_EraseRootFromParent_Done,
     /* 101191 */   // Label 1862: @101191
     /* 101191 */   GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(101246), // Rule ID 328 //
     /* 101196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 101199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101226 */     // (sra:{ *:[i32] } (bswap:{ *:[i32] } tGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (tREVSH:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 101226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tREVSH),
     /* 101229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101238 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101244 */     GIR_RootConstrainSelectedInstOperands,
     /* 101245 */     // GIR_Coverage, 328,
     /* 101245 */     GIR_EraseRootFromParent_Done,
     /* 101246 */   // Label 1863: @101246
     /* 101246 */   GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(101301), // Rule ID 538 //
     /* 101251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101270 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101275 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101281 */     // (sra:{ *:[i32] } (bswap:{ *:[i32] } rGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (t2REVSH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 101281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REVSH),
     /* 101284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101293 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101299 */     GIR_RootConstrainSelectedInstOperands,
     /* 101300 */     // GIR_Coverage, 538,
     /* 101300 */     GIR_EraseRootFromParent_Done,
     /* 101301 */   // Label 1864: @101301
     /* 101301 */   GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(101347), // Rule ID 312 //
     /* 101306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 101309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101321 */     // (sra:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tASRrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 101321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tASRrr),
     /* 101324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 101326 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 101332 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101339 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101345 */     GIR_RootConstrainSelectedInstOperands,
     /* 101346 */     // GIR_Coverage, 312,
     /* 101346 */     GIR_EraseRootFromParent_Done,
     /* 101347 */   // Label 1865: @101347
     /* 101347 */   GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(101393), // Rule ID 475 //
     /* 101352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101367 */     // (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ASRrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 101367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ASRrr),
     /* 101370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101372 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101379 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101385 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101391 */     GIR_RootConstrainSelectedInstOperands,
     /* 101392 */     // GIR_Coverage, 475,
     /* 101392 */     GIR_EraseRootFromParent_Done,
     /* 101393 */   // Label 1866: @101393
     /* 101393 */   GIM_Reject,
     /* 101394 */ // Label 1861: @101394
     /* 101394 */ GIM_Reject,
     /* 101395 */ // Label 27: @101395
     /* 101395 */ GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(101726),
     /* 101400 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 101403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 101406 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 101409 */   GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(101464), // Rule ID 200 //
     /* 101414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 101417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101438 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101444 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } GPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (REV16:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 101444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REV16),
     /* 101447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101462 */     GIR_RootConstrainSelectedInstOperands,
     /* 101463 */     // GIR_Coverage, 200,
     /* 101463 */     GIR_EraseRootFromParent_Done,
     /* 101464 */   // Label 1868: @101464
     /* 101464 */   GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(101519), // Rule ID 327 //
     /* 101469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 101472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101493 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101499 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } tGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (tREV16:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 101499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tREV16),
     /* 101502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101511 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101517 */     GIR_RootConstrainSelectedInstOperands,
     /* 101518 */     // GIR_Coverage, 327,
     /* 101518 */     GIR_EraseRootFromParent_Done,
     /* 101519 */   // Label 1869: @101519
     /* 101519 */   GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(101633),
     /* 101524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101528 */     GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(101579), // Rule ID 537 //
     /* 101533 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101536 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101540 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101544 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101548 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101553 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101557 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101559 */       // (rotr:{ *:[i32] } (bswap:{ *:[i32] } rGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (t2REV16:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 101559 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REV16),
     /* 101562 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101564 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101568 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101571 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101577 */       GIR_RootConstrainSelectedInstOperands,
     /* 101578 */       // GIR_Coverage, 537,
     /* 101578 */       GIR_EraseRootFromParent_Done,
     /* 101579 */     // Label 1871: @101579
     /* 101579 */     GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(101632), // Rule ID 476 //
     /* 101584 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101587 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101591 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101595 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 101599 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_31),
     /* 101603 */       // MIs[1] Operand 1
     /* 101603 */       // No operand predicates
     /* 101603 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101605 */       // (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm1_31>>:$imm)  =>  (t2RORri:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 101605 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RORri),
     /* 101608 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101610 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 101612 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 101615 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101618 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101624 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101630 */       GIR_RootConstrainSelectedInstOperands,
     /* 101631 */       // GIR_Coverage, 476,
     /* 101631 */       GIR_EraseRootFromParent_Done,
     /* 101632 */     // Label 1872: @101632
     /* 101632 */     GIM_Reject,
     /* 101633 */   // Label 1870: @101633
     /* 101633 */   GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(101679), // Rule ID 329 //
     /* 101638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 101641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101653 */     // (rotr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tROR:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 101653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tROR),
     /* 101656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 101658 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 101664 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101671 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101677 */     GIR_RootConstrainSelectedInstOperands,
     /* 101678 */     // GIR_Coverage, 329,
     /* 101678 */     GIR_EraseRootFromParent_Done,
     /* 101679 */   // Label 1873: @101679
     /* 101679 */   GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(101725), // Rule ID 477 //
     /* 101684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101699 */     // (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2RORrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 101699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RORrr),
     /* 101702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101704 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101711 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101717 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101723 */     GIR_RootConstrainSelectedInstOperands,
     /* 101724 */     // GIR_Coverage, 477,
     /* 101724 */     GIR_EraseRootFromParent_Done,
     /* 101725 */   // Label 1874: @101725
     /* 101725 */   GIM_Reject,
     /* 101726 */ // Label 1867: @101726
     /* 101726 */ GIM_Reject,
     /* 101727 */ // Label 28: @101727
     /* 101727 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 1878*/ GIMT_Encode4(101974),
     /* 101738 */ /*GILLT_v4s32*//*Label 1875*/ GIMT_Encode4(101770), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101754 */ /*GILLT_v8s16*//*Label 1876*/ GIMT_Encode4(101838), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101766 */ /*GILLT_v16s8*//*Label 1877*/ GIMT_Encode4(101906),
     /* 101770 */ // Label 1875: @101770
     /* 101770 */ GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(101837), // Rule ID 4464 //
     /* 101775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101792 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101796 */   // (mulhu:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMULHu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 101796 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101799 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101803 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101808 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu32),
     /* 101811 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101813 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101815 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101820 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101826 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101832 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101835 */   GIR_RootConstrainSelectedInstOperands,
     /* 101836 */   // GIR_Coverage, 4464,
     /* 101836 */   GIR_EraseRootFromParent_Done,
     /* 101837 */ // Label 1879: @101837
     /* 101837 */ GIM_Reject,
     /* 101838 */ // Label 1876: @101838
     /* 101838 */ GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(101905), // Rule ID 4460 //
     /* 101843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 101849 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 101852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101860 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101864 */   // (mulhu:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMULHu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 101864 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101867 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101871 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu16),
     /* 101879 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101881 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101883 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101885 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101888 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101894 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101900 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101903 */   GIR_RootConstrainSelectedInstOperands,
     /* 101904 */   // GIR_Coverage, 4460,
     /* 101904 */   GIR_EraseRootFromParent_Done,
     /* 101905 */ // Label 1880: @101905
     /* 101905 */ GIM_Reject,
     /* 101906 */ // Label 1877: @101906
     /* 101906 */ GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(101973), // Rule ID 4456 //
     /* 101911 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 101917 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 101920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101928 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101932 */   // (mulhu:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMULHu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 101932 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101935 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101939 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu8),
     /* 101947 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101949 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101951 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101956 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101962 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101968 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101971 */   GIR_RootConstrainSelectedInstOperands,
     /* 101972 */   // GIR_Coverage, 4456,
     /* 101972 */   GIR_EraseRootFromParent_Done,
     /* 101973 */ // Label 1881: @101973
     /* 101973 */ GIM_Reject,
     /* 101974 */ // Label 1878: @101974
     /* 101974 */ GIM_Reject,
     /* 101975 */ // Label 29: @101975
     /* 101975 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 1886*/ GIMT_Encode4(102343),
     /* 101986 */ /*GILLT_s32*//*Label 1882*/ GIMT_Encode4(102046), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102014 */ /*GILLT_v4s32*//*Label 1883*/ GIMT_Encode4(102139), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102030 */ /*GILLT_v8s16*//*Label 1884*/ GIMT_Encode4(102207), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102042 */ /*GILLT_v16s8*//*Label 1885*/ GIMT_Encode4(102275),
     /* 102046 */ // Label 1882: @102046
     /* 102046 */ GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(102138),
     /* 102051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102054 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 102057 */   GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(102097), // Rule ID 178 //
     /* 102062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 102065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 102069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 102073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 102077 */     // (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SMMUL:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /* 102077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMMUL),
     /* 102080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 102082 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 102084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 102086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102089 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102095 */     GIR_RootConstrainSelectedInstOperands,
     /* 102096 */     // GIR_Coverage, 178,
     /* 102096 */     GIR_EraseRootFromParent_Done,
     /* 102097 */   // Label 1888: @102097
     /* 102097 */   GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(102137), // Rule ID 507 //
     /* 102102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 102105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102117 */     // (mulhs:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMMUL:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 102117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMMUL),
     /* 102120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 102122 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 102124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 102126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102129 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102135 */     GIR_RootConstrainSelectedInstOperands,
     /* 102136 */     // GIR_Coverage, 507,
     /* 102136 */     GIR_EraseRootFromParent_Done,
     /* 102137 */   // Label 1889: @102137
     /* 102137 */   GIM_Reject,
     /* 102138 */ // Label 1887: @102138
     /* 102138 */ GIM_Reject,
     /* 102139 */ // Label 1883: @102139
     /* 102139 */ GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(102206), // Rule ID 4452 //
     /* 102144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102161 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102165 */   // (mulhs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMULHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 102165 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102168 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102172 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs32),
     /* 102180 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102182 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102184 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102186 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102189 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102195 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102201 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102204 */   GIR_RootConstrainSelectedInstOperands,
     /* 102205 */   // GIR_Coverage, 4452,
     /* 102205 */   GIR_EraseRootFromParent_Done,
     /* 102206 */ // Label 1890: @102206
     /* 102206 */ GIM_Reject,
     /* 102207 */ // Label 1884: @102207
     /* 102207 */ GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(102274), // Rule ID 4448 //
     /* 102212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 102221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102229 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102233 */   // (mulhs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMULHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 102233 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102236 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102240 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs16),
     /* 102248 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102250 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102252 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102254 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102257 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102263 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102269 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102272 */   GIR_RootConstrainSelectedInstOperands,
     /* 102273 */   // GIR_Coverage, 4448,
     /* 102273 */   GIR_EraseRootFromParent_Done,
     /* 102274 */ // Label 1891: @102274
     /* 102274 */ GIM_Reject,
     /* 102275 */ // Label 1885: @102275
     /* 102275 */ GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(102342), // Rule ID 4445 //
     /* 102280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 102286 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 102289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102293 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102297 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102301 */   // (mulhs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMULHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 102301 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102304 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102308 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102313 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs8),
     /* 102316 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102318 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102320 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102322 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102325 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102331 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102337 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102340 */   GIR_RootConstrainSelectedInstOperands,
     /* 102341 */   // GIR_Coverage, 4445,
     /* 102341 */   GIR_EraseRootFromParent_Done,
     /* 102342 */ // Label 1892: @102342
     /* 102342 */ GIM_Reject,
     /* 102343 */ // Label 1886: @102343
     /* 102343 */ GIM_Reject,
     /* 102344 */ // Label 30: @102344
     /* 102344 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(16), /*)*//*default:*//*Label 1901*/ GIMT_Encode4(102988),
     /* 102355 */ /*GILLT_s64*//*Label 1893*/ GIMT_Encode4(102411), GIMT_Encode4(0),
     /* 102363 */ /*GILLT_v2s32*//*Label 1894*/ GIMT_Encode4(102458),
     /* 102367 */ /*GILLT_v2s64*//*Label 1895*/ GIMT_Encode4(102505), GIMT_Encode4(0),
     /* 102375 */ /*GILLT_v4s16*//*Label 1896*/ GIMT_Encode4(102552),
     /* 102379 */ /*GILLT_v4s32*//*Label 1897*/ GIMT_Encode4(102599), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102391 */ /*GILLT_v8s8*//*Label 1898*/ GIMT_Encode4(102713),
     /* 102395 */ /*GILLT_v8s16*//*Label 1899*/ GIMT_Encode4(102760), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102407 */ /*GILLT_v16s8*//*Label 1900*/ GIMT_Encode4(102874),
     /* 102411 */ // Label 1893: @102411
     /* 102411 */ GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(102457), // Rule ID 830 //
     /* 102416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102422 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 102425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102429 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102433 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102437 */   // (uaddsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQADDuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 102437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv1i64),
     /* 102440 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102442 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102444 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102446 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102449 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102455 */   GIR_RootConstrainSelectedInstOperands,
     /* 102456 */   // GIR_Coverage, 830,
     /* 102456 */   GIR_EraseRootFromParent_Done,
     /* 102457 */ // Label 1902: @102457
     /* 102457 */ GIM_Reject,
     /* 102458 */ // Label 1894: @102458
     /* 102458 */ GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(102504), // Rule ID 825 //
     /* 102463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 102469 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 102472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102480 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102484 */   // (uaddsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQADDuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 102484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv2i32),
     /* 102487 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102489 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102491 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102496 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102502 */   GIR_RootConstrainSelectedInstOperands,
     /* 102503 */   // GIR_Coverage, 825,
     /* 102503 */   GIR_EraseRootFromParent_Done,
     /* 102504 */ // Label 1903: @102504
     /* 102504 */ GIM_Reject,
     /* 102505 */ // Label 1895: @102505
     /* 102505 */ GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(102551), // Rule ID 831 //
     /* 102510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 102516 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 102519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102527 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102531 */   // (uaddsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQADDuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 102531 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv2i64),
     /* 102534 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102536 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102538 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102540 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102543 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102549 */   GIR_RootConstrainSelectedInstOperands,
     /* 102550 */   // GIR_Coverage, 831,
     /* 102550 */   GIR_EraseRootFromParent_Done,
     /* 102551 */ // Label 1904: @102551
     /* 102551 */ GIM_Reject,
     /* 102552 */ // Label 1896: @102552
     /* 102552 */ GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(102598), // Rule ID 824 //
     /* 102557 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 102563 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 102566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102574 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102578 */   // (uaddsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQADDuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 102578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv4i16),
     /* 102581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102583 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102585 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102587 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102590 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102596 */   GIR_RootConstrainSelectedInstOperands,
     /* 102597 */   // GIR_Coverage, 824,
     /* 102597 */   GIR_EraseRootFromParent_Done,
     /* 102598 */ // Label 1905: @102598
     /* 102598 */ GIM_Reject,
     /* 102599 */ // Label 1897: @102599
     /* 102599 */ GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(102712),
     /* 102604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102607 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102610 */   GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(102650), // Rule ID 827 //
     /* 102615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102630 */     // (uaddsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQADDuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 102630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv4i32),
     /* 102633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102635 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102642 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102648 */     GIR_RootConstrainSelectedInstOperands,
     /* 102649 */     // GIR_Coverage, 827,
     /* 102649 */     GIR_EraseRootFromParent_Done,
     /* 102650 */   // Label 1907: @102650
     /* 102650 */   GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(102711), // Rule ID 3527 //
     /* 102655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102670 */     // (uaddsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQADDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 102670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDu32),
     /* 102685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102687 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102694 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102700 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102709 */     GIR_RootConstrainSelectedInstOperands,
     /* 102710 */     // GIR_Coverage, 3527,
     /* 102710 */     GIR_EraseRootFromParent_Done,
     /* 102711 */   // Label 1908: @102711
     /* 102711 */   GIM_Reject,
     /* 102712 */ // Label 1906: @102712
     /* 102712 */ GIM_Reject,
     /* 102713 */ // Label 1898: @102713
     /* 102713 */ GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(102759), // Rule ID 828 //
     /* 102718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 102724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 102727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102735 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102739 */   // (uaddsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQADDuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 102739 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv8i8),
     /* 102742 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102744 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102746 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102748 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102751 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102757 */   GIR_RootConstrainSelectedInstOperands,
     /* 102758 */   // GIR_Coverage, 828,
     /* 102758 */   GIR_EraseRootFromParent_Done,
     /* 102759 */ // Label 1909: @102759
     /* 102759 */ GIM_Reject,
     /* 102760 */ // Label 1899: @102760
     /* 102760 */ GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(102873),
     /* 102765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 102771 */   GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(102811), // Rule ID 826 //
     /* 102776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102791 */     // (uaddsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQADDuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 102791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv8i16),
     /* 102794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102803 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102809 */     GIR_RootConstrainSelectedInstOperands,
     /* 102810 */     // GIR_Coverage, 826,
     /* 102810 */     GIR_EraseRootFromParent_Done,
     /* 102811 */   // Label 1911: @102811
     /* 102811 */   GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(102872), // Rule ID 3524 //
     /* 102816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102831 */     // (uaddsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQADDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 102831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDu16),
     /* 102846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102848 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102855 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102867 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102870 */     GIR_RootConstrainSelectedInstOperands,
     /* 102871 */     // GIR_Coverage, 3524,
     /* 102871 */     GIR_EraseRootFromParent_Done,
     /* 102872 */   // Label 1912: @102872
     /* 102872 */   GIM_Reject,
     /* 102873 */ // Label 1910: @102873
     /* 102873 */ GIM_Reject,
     /* 102874 */ // Label 1900: @102874
     /* 102874 */ GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(102987),
     /* 102879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 102882 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 102885 */   GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(102925), // Rule ID 829 //
     /* 102890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102905 */     // (uaddsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQADDuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 102905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv16i8),
     /* 102908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102910 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102917 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102923 */     GIR_RootConstrainSelectedInstOperands,
     /* 102924 */     // GIR_Coverage, 829,
     /* 102924 */     GIR_EraseRootFromParent_Done,
     /* 102925 */   // Label 1914: @102925
     /* 102925 */   GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(102986), // Rule ID 3521 //
     /* 102930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102945 */     // (uaddsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQADDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 102945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDu8),
     /* 102960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102962 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102969 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102975 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102984 */     GIR_RootConstrainSelectedInstOperands,
     /* 102985 */     // GIR_Coverage, 3521,
     /* 102985 */     GIR_EraseRootFromParent_Done,
     /* 102986 */   // Label 1915: @102986
     /* 102986 */   GIM_Reject,
     /* 102987 */ // Label 1913: @102987
     /* 102987 */ GIM_Reject,
     /* 102988 */ // Label 1901: @102988
     /* 102988 */ GIM_Reject,
     /* 102989 */ // Label 31: @102989
     /* 102989 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 1925*/ GIMT_Encode4(104288),
     /* 103000 */ /*GILLT_s32*//*Label 1916*/ GIMT_Encode4(103060),
     /* 103004 */ /*GILLT_s64*//*Label 1917*/ GIMT_Encode4(103401), GIMT_Encode4(0),
     /* 103012 */ /*GILLT_v2s32*//*Label 1918*/ GIMT_Encode4(103448),
     /* 103016 */ /*GILLT_v2s64*//*Label 1919*/ GIMT_Encode4(103495), GIMT_Encode4(0),
     /* 103024 */ /*GILLT_v4s16*//*Label 1920*/ GIMT_Encode4(103696),
     /* 103028 */ /*GILLT_v4s32*//*Label 1921*/ GIMT_Encode4(103743), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 103040 */ /*GILLT_v8s8*//*Label 1922*/ GIMT_Encode4(104013),
     /* 103044 */ /*GILLT_v8s16*//*Label 1923*/ GIMT_Encode4(104060), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 103056 */ /*GILLT_v16s8*//*Label 1924*/ GIMT_Encode4(104174),
     /* 103060 */ // Label 1916: @103060
     /* 103060 */ GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(103400),
     /* 103065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 103068 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 103071 */   GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(103133), // Rule ID 5654 //
     /* 103076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 103079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 103083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 103091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 103095 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103100 */     // MIs[1] Rn
     /* 103100 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 103105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103111 */     // (saddsat:{ *:[i32] } (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Rm)  =>  (QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /* 103114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 103118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103125 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103131 */     GIR_RootConstrainSelectedInstOperands,
     /* 103132 */     // GIR_Coverage, 5654,
     /* 103132 */     GIR_EraseRootFromParent_Done,
     /* 103133 */   // Label 1927: @103133
     /* 103133 */   GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(103195), // Rule ID 5688 //
     /* 103138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 103141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 103153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 103157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103162 */     // MIs[1] Rn
     /* 103162 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 103167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103173 */     // (saddsat:{ *:[i32] } (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Rm)  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /* 103176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 103180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103187 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103193 */     GIR_RootConstrainSelectedInstOperands,
     /* 103194 */     // GIR_Coverage, 5688,
     /* 103194 */     GIR_EraseRootFromParent_Done,
     /* 103195 */   // Label 1928: @103195
     /* 103195 */   GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(103257), // Rule ID 1870 //
     /* 103200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 103203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 103207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 103219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 103223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103228 */     // MIs[1] Rn
     /* 103228 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 103233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103235 */     // (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /* 103238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 103242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103249 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103255 */     GIR_RootConstrainSelectedInstOperands,
     /* 103256 */     // GIR_Coverage, 1870,
     /* 103256 */     GIR_EraseRootFromParent_Done,
     /* 103257 */   // Label 1929: @103257
     /* 103257 */   GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(103319), // Rule ID 2136 //
     /* 103262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 103265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 103281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 103285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103290 */     // MIs[1] Rn
     /* 103290 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 103295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103297 */     // (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /* 103300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103302 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 103304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103311 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103317 */     GIR_RootConstrainSelectedInstOperands,
     /* 103318 */     // GIR_Coverage, 2136,
     /* 103318 */     GIR_EraseRootFromParent_Done,
     /* 103319 */   // Label 1930: @103319
     /* 103319 */   GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(103359), // Rule ID 1868 //
     /* 103324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 103327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 103331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 103335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 103339 */     // (saddsat:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (QADD:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /* 103339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD),
     /* 103342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103344 */     GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 103346 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 103348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103351 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103357 */     GIR_RootConstrainSelectedInstOperands,
     /* 103358 */     // GIR_Coverage, 1868,
     /* 103358 */     GIR_EraseRootFromParent_Done,
     /* 103359 */   // Label 1931: @103359
     /* 103359 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(103399), // Rule ID 2134 //
     /* 103364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 103367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103379 */     // (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD),
     /* 103382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103384 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 103386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 103388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103391 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103397 */     GIR_RootConstrainSelectedInstOperands,
     /* 103398 */     // GIR_Coverage, 2134,
     /* 103398 */     GIR_EraseRootFromParent_Done,
     /* 103399 */   // Label 1932: @103399
     /* 103399 */   GIM_Reject,
     /* 103400 */ // Label 1926: @103400
     /* 103400 */ GIM_Reject,
     /* 103401 */ // Label 1917: @103401
     /* 103401 */ GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(103447), // Rule ID 822 //
     /* 103406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 103412 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 103415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103423 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103427 */   // (saddsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQADDsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 103427 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv1i64),
     /* 103430 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103432 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103434 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103436 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103439 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103445 */   GIR_RootConstrainSelectedInstOperands,
     /* 103446 */   // GIR_Coverage, 822,
     /* 103446 */   GIR_EraseRootFromParent_Done,
     /* 103447 */ // Label 1933: @103447
     /* 103447 */ GIM_Reject,
     /* 103448 */ // Label 1918: @103448
     /* 103448 */ GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(103494), // Rule ID 817 //
     /* 103453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 103459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 103462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103470 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103474 */   // (saddsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQADDsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 103474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv2i32),
     /* 103477 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103479 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103481 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103483 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103486 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103492 */   GIR_RootConstrainSelectedInstOperands,
     /* 103493 */   // GIR_Coverage, 817,
     /* 103493 */   GIR_EraseRootFromParent_Done,
     /* 103494 */ // Label 1934: @103494
     /* 103494 */ GIM_Reject,
     /* 103495 */ // Label 1919: @103495
     /* 103495 */ GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(103695),
     /* 103500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 103503 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 103506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103510 */   GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(103584), // Rule ID 5745 //
     /* 103515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103526 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103529 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103534 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 103538 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 103542 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103558 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 3804:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$src1)  =>  (VQDMLALv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 103558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv2i64),
     /* 103561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103563 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 103565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103576 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103582 */     GIR_RootConstrainSelectedInstOperands,
     /* 103583 */     // GIR_Coverage, 5745,
     /* 103583 */     GIR_EraseRootFromParent_Done,
     /* 103584 */   // Label 1936: @103584
     /* 103584 */   GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(103658), // Rule ID 2489 //
     /* 103589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103604 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103607 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 103616 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 103620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103632 */     // (saddsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, (intrinsic_wo_chain:{ *:[v2i64] } 3804:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VQDMLALv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 103632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv2i64),
     /* 103635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103637 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 103639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103656 */     GIR_RootConstrainSelectedInstOperands,
     /* 103657 */     // GIR_Coverage, 2489,
     /* 103657 */     GIR_EraseRootFromParent_Done,
     /* 103658 */   // Label 1937: @103658
     /* 103658 */   GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(103694), // Rule ID 823 //
     /* 103663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103674 */     // (saddsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQADDsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 103674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv2i64),
     /* 103677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103679 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103686 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103692 */     GIR_RootConstrainSelectedInstOperands,
     /* 103693 */     // GIR_Coverage, 823,
     /* 103693 */     GIR_EraseRootFromParent_Done,
     /* 103694 */   // Label 1938: @103694
     /* 103694 */   GIM_Reject,
     /* 103695 */ // Label 1935: @103695
     /* 103695 */ GIM_Reject,
     /* 103696 */ // Label 1920: @103696
     /* 103696 */ GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(103742), // Rule ID 816 //
     /* 103701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 103707 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 103710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103718 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103722 */   // (saddsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQADDsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 103722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv4i16),
     /* 103725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103727 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103729 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103731 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103734 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103740 */   GIR_RootConstrainSelectedInstOperands,
     /* 103741 */   // GIR_Coverage, 816,
     /* 103741 */   GIR_EraseRootFromParent_Done,
     /* 103742 */ // Label 1939: @103742
     /* 103742 */ GIM_Reject,
     /* 103743 */ // Label 1921: @103743
     /* 103743 */ GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(104012),
     /* 103748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 103751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 103754 */   GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(103832), // Rule ID 5744 //
     /* 103759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103774 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103777 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 103786 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 103790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103806 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 3804:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$src1)  =>  (VQDMLALv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 103806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv4i32),
     /* 103809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103811 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 103813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103824 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103830 */     GIR_RootConstrainSelectedInstOperands,
     /* 103831 */     // GIR_Coverage, 5744,
     /* 103831 */     GIR_EraseRootFromParent_Done,
     /* 103832 */   // Label 1941: @103832
     /* 103832 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(103910), // Rule ID 2488 //
     /* 103837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103856 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103859 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 103868 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 103872 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103884 */     // (saddsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (intrinsic_wo_chain:{ *:[v4i32] } 3804:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VQDMLALv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 103884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv4i32),
     /* 103887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103889 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 103891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103902 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103908 */     GIR_RootConstrainSelectedInstOperands,
     /* 103909 */     // GIR_Coverage, 2488,
     /* 103909 */     GIR_EraseRootFromParent_Done,
     /* 103910 */   // Label 1942: @103910
     /* 103910 */   GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(103950), // Rule ID 819 //
     /* 103915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103930 */     // (saddsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQADDsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 103930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv4i32),
     /* 103933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103935 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103948 */     GIR_RootConstrainSelectedInstOperands,
     /* 103949 */     // GIR_Coverage, 819,
     /* 103949 */     GIR_EraseRootFromParent_Done,
     /* 103950 */   // Label 1943: @103950
     /* 103950 */   GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(104011), // Rule ID 3518 //
     /* 103955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 103958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103970 */     // (saddsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 103970 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 103973 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103977 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDs32),
     /* 103985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 103987 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 103989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 103991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103994 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104000 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104009 */     GIR_RootConstrainSelectedInstOperands,
     /* 104010 */     // GIR_Coverage, 3518,
     /* 104010 */     GIR_EraseRootFromParent_Done,
     /* 104011 */   // Label 1944: @104011
     /* 104011 */   GIM_Reject,
     /* 104012 */ // Label 1940: @104012
     /* 104012 */ GIM_Reject,
     /* 104013 */ // Label 1922: @104013
     /* 104013 */ GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(104059), // Rule ID 820 //
     /* 104018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 104024 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 104027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104035 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104039 */   // (saddsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQADDsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 104039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv8i8),
     /* 104042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104044 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104046 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104051 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104057 */   GIR_RootConstrainSelectedInstOperands,
     /* 104058 */   // GIR_Coverage, 820,
     /* 104058 */   GIR_EraseRootFromParent_Done,
     /* 104059 */ // Label 1945: @104059
     /* 104059 */ GIM_Reject,
     /* 104060 */ // Label 1923: @104060
     /* 104060 */ GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(104173),
     /* 104065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104068 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104071 */   GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(104111), // Rule ID 818 //
     /* 104076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104091 */     // (saddsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQADDsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 104091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv8i16),
     /* 104094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104096 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104103 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104109 */     GIR_RootConstrainSelectedInstOperands,
     /* 104110 */     // GIR_Coverage, 818,
     /* 104110 */     GIR_EraseRootFromParent_Done,
     /* 104111 */   // Label 1947: @104111
     /* 104111 */   GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(104172), // Rule ID 3515 //
     /* 104116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104131 */     // (saddsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 104131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDs16),
     /* 104146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104148 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104155 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104161 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104170 */     GIR_RootConstrainSelectedInstOperands,
     /* 104171 */     // GIR_Coverage, 3515,
     /* 104171 */     GIR_EraseRootFromParent_Done,
     /* 104172 */   // Label 1948: @104172
     /* 104172 */   GIM_Reject,
     /* 104173 */ // Label 1946: @104173
     /* 104173 */ GIM_Reject,
     /* 104174 */ // Label 1924: @104174
     /* 104174 */ GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(104287),
     /* 104179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 104182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 104185 */   GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(104225), // Rule ID 821 //
     /* 104190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104205 */     // (saddsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQADDsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 104205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv16i8),
     /* 104208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104210 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104217 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104223 */     GIR_RootConstrainSelectedInstOperands,
     /* 104224 */     // GIR_Coverage, 821,
     /* 104224 */     GIR_EraseRootFromParent_Done,
     /* 104225 */   // Label 1950: @104225
     /* 104225 */   GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(104286), // Rule ID 3512 //
     /* 104230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104245 */     // (saddsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 104245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDs8),
     /* 104260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104262 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104269 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104275 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104284 */     GIR_RootConstrainSelectedInstOperands,
     /* 104285 */     // GIR_Coverage, 3512,
     /* 104285 */     GIR_EraseRootFromParent_Done,
     /* 104286 */   // Label 1951: @104286
     /* 104286 */   GIM_Reject,
     /* 104287 */ // Label 1949: @104287
     /* 104287 */ GIM_Reject,
     /* 104288 */ // Label 1925: @104288
     /* 104288 */ GIM_Reject,
     /* 104289 */ // Label 32: @104289
     /* 104289 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(16), /*)*//*default:*//*Label 1960*/ GIMT_Encode4(104933),
     /* 104300 */ /*GILLT_s64*//*Label 1952*/ GIMT_Encode4(104356), GIMT_Encode4(0),
     /* 104308 */ /*GILLT_v2s32*//*Label 1953*/ GIMT_Encode4(104403),
     /* 104312 */ /*GILLT_v2s64*//*Label 1954*/ GIMT_Encode4(104450), GIMT_Encode4(0),
     /* 104320 */ /*GILLT_v4s16*//*Label 1955*/ GIMT_Encode4(104497),
     /* 104324 */ /*GILLT_v4s32*//*Label 1956*/ GIMT_Encode4(104544), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104336 */ /*GILLT_v8s8*//*Label 1957*/ GIMT_Encode4(104658),
     /* 104340 */ /*GILLT_v8s16*//*Label 1958*/ GIMT_Encode4(104705), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104352 */ /*GILLT_v16s8*//*Label 1959*/ GIMT_Encode4(104819),
     /* 104356 */ // Label 1952: @104356
     /* 104356 */ GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(104402), // Rule ID 1022 //
     /* 104361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 104367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 104370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104378 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104382 */   // (usubsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQSUBuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 104382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv1i64),
     /* 104385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104387 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104389 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104391 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104394 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104400 */   GIR_RootConstrainSelectedInstOperands,
     /* 104401 */   // GIR_Coverage, 1022,
     /* 104401 */   GIR_EraseRootFromParent_Done,
     /* 104402 */ // Label 1961: @104402
     /* 104402 */ GIM_Reject,
     /* 104403 */ // Label 1953: @104403
     /* 104403 */ GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(104449), // Rule ID 1017 //
     /* 104408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 104414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 104417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104421 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104425 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104429 */   // (usubsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQSUBuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 104429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv2i32),
     /* 104432 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104434 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104436 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104438 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104441 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104447 */   GIR_RootConstrainSelectedInstOperands,
     /* 104448 */   // GIR_Coverage, 1017,
     /* 104448 */   GIR_EraseRootFromParent_Done,
     /* 104449 */ // Label 1962: @104449
     /* 104449 */ GIM_Reject,
     /* 104450 */ // Label 1954: @104450
     /* 104450 */ GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(104496), // Rule ID 1023 //
     /* 104455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 104461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 104464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104472 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104476 */   // (usubsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQSUBuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 104476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv2i64),
     /* 104479 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104481 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104483 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104485 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104488 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104494 */   GIR_RootConstrainSelectedInstOperands,
     /* 104495 */   // GIR_Coverage, 1023,
     /* 104495 */   GIR_EraseRootFromParent_Done,
     /* 104496 */ // Label 1963: @104496
     /* 104496 */ GIM_Reject,
     /* 104497 */ // Label 1955: @104497
     /* 104497 */ GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(104543), // Rule ID 1016 //
     /* 104502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 104508 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 104511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104515 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104519 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104523 */   // (usubsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQSUBuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 104523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv4i16),
     /* 104526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104528 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104530 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104535 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104541 */   GIR_RootConstrainSelectedInstOperands,
     /* 104542 */   // GIR_Coverage, 1016,
     /* 104542 */   GIR_EraseRootFromParent_Done,
     /* 104543 */ // Label 1964: @104543
     /* 104543 */ GIM_Reject,
     /* 104544 */ // Label 1956: @104544
     /* 104544 */ GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(104657),
     /* 104549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 104552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 104555 */   GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(104595), // Rule ID 1019 //
     /* 104560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104575 */     // (usubsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQSUBuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 104575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv4i32),
     /* 104578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104580 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104587 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104593 */     GIR_RootConstrainSelectedInstOperands,
     /* 104594 */     // GIR_Coverage, 1019,
     /* 104594 */     GIR_EraseRootFromParent_Done,
     /* 104595 */   // Label 1966: @104595
     /* 104595 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(104656), // Rule ID 3545 //
     /* 104600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104615 */     // (usubsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQSUBu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 104615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBu32),
     /* 104630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104639 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104645 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104654 */     GIR_RootConstrainSelectedInstOperands,
     /* 104655 */     // GIR_Coverage, 3545,
     /* 104655 */     GIR_EraseRootFromParent_Done,
     /* 104656 */   // Label 1967: @104656
     /* 104656 */   GIM_Reject,
     /* 104657 */ // Label 1965: @104657
     /* 104657 */ GIM_Reject,
     /* 104658 */ // Label 1957: @104658
     /* 104658 */ GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(104704), // Rule ID 1020 //
     /* 104663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 104669 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 104672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104676 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104680 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104684 */   // (usubsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQSUBuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 104684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv8i8),
     /* 104687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104689 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104691 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104696 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104702 */   GIR_RootConstrainSelectedInstOperands,
     /* 104703 */   // GIR_Coverage, 1020,
     /* 104703 */   GIR_EraseRootFromParent_Done,
     /* 104704 */ // Label 1968: @104704
     /* 104704 */ GIM_Reject,
     /* 104705 */ // Label 1958: @104705
     /* 104705 */ GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(104818),
     /* 104710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104716 */   GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(104756), // Rule ID 1018 //
     /* 104721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104736 */     // (usubsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQSUBuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 104736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv8i16),
     /* 104739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104741 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104748 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104754 */     GIR_RootConstrainSelectedInstOperands,
     /* 104755 */     // GIR_Coverage, 1018,
     /* 104755 */     GIR_EraseRootFromParent_Done,
     /* 104756 */   // Label 1970: @104756
     /* 104756 */   GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(104817), // Rule ID 3542 //
     /* 104761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104776 */     // (usubsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQSUBu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 104776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBu16),
     /* 104791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104793 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104800 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104806 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104815 */     GIR_RootConstrainSelectedInstOperands,
     /* 104816 */     // GIR_Coverage, 3542,
     /* 104816 */     GIR_EraseRootFromParent_Done,
     /* 104817 */   // Label 1971: @104817
     /* 104817 */   GIM_Reject,
     /* 104818 */ // Label 1969: @104818
     /* 104818 */ GIM_Reject,
     /* 104819 */ // Label 1959: @104819
     /* 104819 */ GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(104932),
     /* 104824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 104827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 104830 */   GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(104870), // Rule ID 1021 //
     /* 104835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104850 */     // (usubsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQSUBuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 104850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv16i8),
     /* 104853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104855 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104862 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104868 */     GIR_RootConstrainSelectedInstOperands,
     /* 104869 */     // GIR_Coverage, 1021,
     /* 104869 */     GIR_EraseRootFromParent_Done,
     /* 104870 */   // Label 1973: @104870
     /* 104870 */   GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(104931), // Rule ID 3539 //
     /* 104875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104890 */     // (usubsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQSUBu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 104890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBu8),
     /* 104905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104907 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104914 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104920 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104929 */     GIR_RootConstrainSelectedInstOperands,
     /* 104930 */     // GIR_Coverage, 3539,
     /* 104930 */     GIR_EraseRootFromParent_Done,
     /* 104931 */   // Label 1974: @104931
     /* 104931 */   GIM_Reject,
     /* 104932 */ // Label 1972: @104932
     /* 104932 */ GIM_Reject,
     /* 104933 */ // Label 1960: @104933
     /* 104933 */ GIM_Reject,
     /* 104934 */ // Label 33: @104934
     /* 104934 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 1984*/ GIMT_Encode4(105953),
     /* 104945 */ /*GILLT_s32*//*Label 1975*/ GIMT_Encode4(105005),
     /* 104949 */ /*GILLT_s64*//*Label 1976*/ GIMT_Encode4(105222), GIMT_Encode4(0),
     /* 104957 */ /*GILLT_v2s32*//*Label 1977*/ GIMT_Encode4(105269),
     /* 104961 */ /*GILLT_v2s64*//*Label 1978*/ GIMT_Encode4(105316), GIMT_Encode4(0),
     /* 104969 */ /*GILLT_v4s16*//*Label 1979*/ GIMT_Encode4(105439),
     /* 104973 */ /*GILLT_v4s32*//*Label 1980*/ GIMT_Encode4(105486), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104985 */ /*GILLT_v8s8*//*Label 1981*/ GIMT_Encode4(105678),
     /* 104989 */ /*GILLT_v8s16*//*Label 1982*/ GIMT_Encode4(105725), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 105001 */ /*GILLT_v16s8*//*Label 1983*/ GIMT_Encode4(105839),
     /* 105005 */ // Label 1975: @105005
     /* 105005 */ GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(105221),
     /* 105010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 105013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105016 */   GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(105078), // Rule ID 1871 //
     /* 105021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 105024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 105028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 105040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 105044 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105049 */     // MIs[1] Rn
     /* 105049 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 105054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105056 */     // (ssubsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (QDSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 105056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDSUB),
     /* 105059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105061 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 105063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 105067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105070 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105076 */     GIR_RootConstrainSelectedInstOperands,
     /* 105077 */     // GIR_Coverage, 1871,
     /* 105077 */     GIR_EraseRootFromParent_Done,
     /* 105078 */   // Label 1986: @105078
     /* 105078 */   GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(105140), // Rule ID 2137 //
     /* 105083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 105086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 105102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 105106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105111 */     // MIs[1] Rn
     /* 105111 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 105116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105118 */     // (ssubsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 105118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDSUB),
     /* 105121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105123 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 105125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 105129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105132 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105138 */     GIR_RootConstrainSelectedInstOperands,
     /* 105139 */     // GIR_Coverage, 2137,
     /* 105139 */     GIR_EraseRootFromParent_Done,
     /* 105140 */   // Label 1987: @105140
     /* 105140 */   GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(105180), // Rule ID 1869 //
     /* 105145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 105148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 105152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 105156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 105160 */     // (ssubsat:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (QSUB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /* 105160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB),
     /* 105163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105165 */     GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 105167 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 105169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105172 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105178 */     GIR_RootConstrainSelectedInstOperands,
     /* 105179 */     // GIR_Coverage, 1869,
     /* 105179 */     GIR_EraseRootFromParent_Done,
     /* 105180 */   // Label 1988: @105180
     /* 105180 */   GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(105220), // Rule ID 2135 //
     /* 105185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 105188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105200 */     // (ssubsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 105200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB),
     /* 105203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105205 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 105207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 105209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105212 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105218 */     GIR_RootConstrainSelectedInstOperands,
     /* 105219 */     // GIR_Coverage, 2135,
     /* 105219 */     GIR_EraseRootFromParent_Done,
     /* 105220 */   // Label 1989: @105220
     /* 105220 */   GIM_Reject,
     /* 105221 */ // Label 1985: @105221
     /* 105221 */ GIM_Reject,
     /* 105222 */ // Label 1976: @105222
     /* 105222 */ GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(105268), // Rule ID 1014 //
     /* 105227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105233 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105244 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105248 */   // (ssubsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQSUBsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 105248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv1i64),
     /* 105251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105253 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105255 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105257 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105260 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105266 */   GIR_RootConstrainSelectedInstOperands,
     /* 105267 */   // GIR_Coverage, 1014,
     /* 105267 */   GIR_EraseRootFromParent_Done,
     /* 105268 */ // Label 1990: @105268
     /* 105268 */ GIM_Reject,
     /* 105269 */ // Label 1977: @105269
     /* 105269 */ GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(105315), // Rule ID 1009 //
     /* 105274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 105280 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 105283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105291 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105295 */   // (ssubsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQSUBsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 105295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv2i32),
     /* 105298 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105300 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105302 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105304 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105307 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105313 */   GIR_RootConstrainSelectedInstOperands,
     /* 105314 */   // GIR_Coverage, 1009,
     /* 105314 */   GIR_EraseRootFromParent_Done,
     /* 105315 */ // Label 1991: @105315
     /* 105315 */ GIM_Reject,
     /* 105316 */ // Label 1978: @105316
     /* 105316 */ GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(105438),
     /* 105321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 105324 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 105327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105331 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105335 */   GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(105405), // Rule ID 2496 //
     /* 105340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105351 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105354 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 105359 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 105363 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 105367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105372 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105379 */     // (ssubsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, (intrinsic_wo_chain:{ *:[v2i64] } 3804:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VQDMLSLv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 105379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLSLv2i64),
     /* 105382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105384 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 105386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 105390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 105394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105397 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105403 */     GIR_RootConstrainSelectedInstOperands,
     /* 105404 */     // GIR_Coverage, 2496,
     /* 105404 */     GIR_EraseRootFromParent_Done,
     /* 105405 */   // Label 1993: @105405
     /* 105405 */   GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(105437), // Rule ID 1015 //
     /* 105410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105417 */     // (ssubsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQSUBsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 105417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv2i64),
     /* 105420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105422 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105429 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105435 */     GIR_RootConstrainSelectedInstOperands,
     /* 105436 */     // GIR_Coverage, 1015,
     /* 105436 */     GIR_EraseRootFromParent_Done,
     /* 105437 */   // Label 1994: @105437
     /* 105437 */   GIM_Reject,
     /* 105438 */ // Label 1992: @105438
     /* 105438 */ GIM_Reject,
     /* 105439 */ // Label 1979: @105439
     /* 105439 */ GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(105485), // Rule ID 1008 //
     /* 105444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 105450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 105453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105461 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105465 */   // (ssubsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQSUBsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 105465 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv4i16),
     /* 105468 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105470 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105472 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105474 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105477 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105483 */   GIR_RootConstrainSelectedInstOperands,
     /* 105484 */   // GIR_Coverage, 1008,
     /* 105484 */   GIR_EraseRootFromParent_Done,
     /* 105485 */ // Label 1995: @105485
     /* 105485 */ GIM_Reject,
     /* 105486 */ // Label 1980: @105486
     /* 105486 */ GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(105677),
     /* 105491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 105494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 105497 */   GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(105575), // Rule ID 2495 //
     /* 105502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105521 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105524 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 105529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 105533 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 105537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105542 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105549 */     // (ssubsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (intrinsic_wo_chain:{ *:[v4i32] } 3804:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VQDMLSLv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 105549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLSLv4i32),
     /* 105552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105554 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 105556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 105560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 105564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105567 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105573 */     GIR_RootConstrainSelectedInstOperands,
     /* 105574 */     // GIR_Coverage, 2495,
     /* 105574 */     GIR_EraseRootFromParent_Done,
     /* 105575 */   // Label 1997: @105575
     /* 105575 */   GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(105615), // Rule ID 1011 //
     /* 105580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105595 */     // (ssubsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQSUBsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 105595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv4i32),
     /* 105598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105600 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105607 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105613 */     GIR_RootConstrainSelectedInstOperands,
     /* 105614 */     // GIR_Coverage, 1011,
     /* 105614 */     GIR_EraseRootFromParent_Done,
     /* 105615 */   // Label 1998: @105615
     /* 105615 */   GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(105676), // Rule ID 3536 //
     /* 105620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 105623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105635 */     // (ssubsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQSUBs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 105635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 105638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBs32),
     /* 105650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 105652 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 105654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 105656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105659 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105665 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105674 */     GIR_RootConstrainSelectedInstOperands,
     /* 105675 */     // GIR_Coverage, 3536,
     /* 105675 */     GIR_EraseRootFromParent_Done,
     /* 105676 */   // Label 1999: @105676
     /* 105676 */   GIM_Reject,
     /* 105677 */ // Label 1996: @105677
     /* 105677 */ GIM_Reject,
     /* 105678 */ // Label 1981: @105678
     /* 105678 */ GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(105724), // Rule ID 1012 //
     /* 105683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 105689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 105692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105700 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105704 */   // (ssubsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQSUBsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 105704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv8i8),
     /* 105707 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105709 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105711 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105713 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105716 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105722 */   GIR_RootConstrainSelectedInstOperands,
     /* 105723 */   // GIR_Coverage, 1012,
     /* 105723 */   GIR_EraseRootFromParent_Done,
     /* 105724 */ // Label 2000: @105724
     /* 105724 */ GIM_Reject,
     /* 105725 */ // Label 1982: @105725
     /* 105725 */ GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(105838),
     /* 105730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 105733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 105736 */   GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(105776), // Rule ID 1010 //
     /* 105741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105756 */     // (ssubsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQSUBsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 105756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv8i16),
     /* 105759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105761 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105768 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105774 */     GIR_RootConstrainSelectedInstOperands,
     /* 105775 */     // GIR_Coverage, 1010,
     /* 105775 */     GIR_EraseRootFromParent_Done,
     /* 105776 */   // Label 2002: @105776
     /* 105776 */   GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(105837), // Rule ID 3533 //
     /* 105781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 105784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105796 */     // (ssubsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQSUBs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 105796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 105799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBs16),
     /* 105811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 105813 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 105815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 105817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105820 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105826 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105835 */     GIR_RootConstrainSelectedInstOperands,
     /* 105836 */     // GIR_Coverage, 3533,
     /* 105836 */     GIR_EraseRootFromParent_Done,
     /* 105837 */   // Label 2003: @105837
     /* 105837 */   GIM_Reject,
     /* 105838 */ // Label 2001: @105838
     /* 105838 */ GIM_Reject,
     /* 105839 */ // Label 1983: @105839
     /* 105839 */ GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(105952),
     /* 105844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 105847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 105850 */   GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(105890), // Rule ID 1013 //
     /* 105855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105870 */     // (ssubsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQSUBsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 105870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv16i8),
     /* 105873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105875 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105882 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105888 */     GIR_RootConstrainSelectedInstOperands,
     /* 105889 */     // GIR_Coverage, 1013,
     /* 105889 */     GIR_EraseRootFromParent_Done,
     /* 105890 */   // Label 2005: @105890
     /* 105890 */   GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(105951), // Rule ID 3530 //
     /* 105895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 105898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105910 */     // (ssubsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQSUBs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 105910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 105913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBs8),
     /* 105925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 105927 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 105929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 105931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105940 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105949 */     GIR_RootConstrainSelectedInstOperands,
     /* 105950 */     // GIR_Coverage, 3530,
     /* 105950 */     GIR_EraseRootFromParent_Done,
     /* 105951 */   // Label 2006: @105951
     /* 105951 */   GIM_Reject,
     /* 105952 */ // Label 2004: @105952
     /* 105952 */ GIM_Reject,
     /* 105953 */ // Label 1984: @105953
     /* 105953 */ GIM_Reject,
     /* 105954 */ // Label 34: @105954
     /* 105954 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2014*/ GIMT_Encode4(108306),
     /* 105965 */ /*GILLT_s16*//*Label 2007*/ GIMT_Encode4(106017),
     /* 105969 */ /*GILLT_s32*//*Label 2008*/ GIMT_Encode4(106064),
     /* 105973 */ /*GILLT_s64*//*Label 2009*/ GIMT_Encode4(107659), GIMT_Encode4(0),
     /* 105981 */ /*GILLT_v2s32*//*Label 2010*/ GIMT_Encode4(107706), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 105993 */ /*GILLT_v4s16*//*Label 2011*/ GIMT_Encode4(107753),
     /* 105997 */ /*GILLT_v4s32*//*Label 2012*/ GIMT_Encode4(107938), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 106013 */ /*GILLT_v8s16*//*Label 2013*/ GIMT_Encode4(108052),
     /* 106017 */ // Label 2007: @106017
     /* 106017 */ GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(106063), // Rule ID 614 //
     /* 106022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 106025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 106028 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 106031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 106035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 106039 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 106043 */   // (fadd:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VADDH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 106043 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDH),
     /* 106046 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 106048 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 106050 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 106052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 106055 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106061 */   GIR_RootConstrainSelectedInstOperands,
     /* 106062 */   // GIR_Coverage, 614,
     /* 106062 */   GIR_EraseRootFromParent_Done,
     /* 106063 */ // Label 2015: @106063
     /* 106063 */ GIM_Reject,
     /* 106064 */ // Label 2008: @106064
     /* 106064 */ GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(107658),
     /* 106069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 106072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 106075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106079 */   GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(106407), // Rule ID 5921 //
     /* 106084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseFPVMLx_UseNEONForFP),
     /* 106087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 106095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 106099 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106103 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106119 */     // (fadd:{ *:[f32] } (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b), SPR:{ *:[f32] }:$acc)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMLAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 106119 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 106122 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106126 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 106133 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 106136 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106140 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106145 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 106148 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106153 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 106156 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106160 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106165 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 106168 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 106172 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 106175 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106180 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106185 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106190 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 106193 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106197 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 106204 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 106207 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106211 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106216 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 106219 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106224 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 106227 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106231 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106236 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 106239 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 106243 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 106246 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106251 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106256 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106261 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 106264 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106268 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 106275 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 106278 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106282 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106287 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 106290 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106295 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 106298 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106302 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106307 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106310 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // acc
     /* 106314 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 106317 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106322 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106327 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106332 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106335 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMLAfd),
     /* 106339 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106344 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106347 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 106350 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 106353 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 106356 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 106367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106376 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106379 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106389 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 106396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106401 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106406 */     // GIR_Coverage, 5921,
     /* 106406 */     GIR_EraseRootFromParent_Done,
     /* 106407 */   // Label 2017: @106407
     /* 106407 */   GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(106735), // Rule ID 5922 //
     /* 106412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP),
     /* 106415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 106423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 106427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106436 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106447 */     // (fadd:{ *:[f32] } (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b), SPR:{ *:[f32] }:$acc)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VFMAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 106447 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 106450 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106454 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 106461 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 106464 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106468 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106473 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 106476 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106481 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 106484 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106488 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106493 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 106496 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 106500 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 106503 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106508 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106513 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106518 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 106521 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106525 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 106532 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 106535 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106539 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106544 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 106547 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106552 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 106555 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106559 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106564 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 106567 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 106571 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 106574 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106579 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106584 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106589 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 106592 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106596 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106601 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 106603 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 106606 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106610 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106615 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 106618 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106623 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 106626 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106630 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106635 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106638 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // acc
     /* 106642 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 106645 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106650 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106655 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106660 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106663 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VFMAfd),
     /* 106667 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106672 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106675 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 106678 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 106681 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 106684 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106690 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 106695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106704 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106707 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106717 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 106724 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106729 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106734 */     // GIR_Coverage, 5922,
     /* 106734 */     GIR_EraseRootFromParent_Done,
     /* 106735 */   // Label 2018: @106735
     /* 106735 */   GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(107063), // Rule ID 2700 //
     /* 106740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseFPVMLx_UseNEONForFP),
     /* 106743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 106751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 106755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 106759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106768 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106775 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMLAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 106775 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 106778 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106782 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 106789 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 106792 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106796 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106801 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 106804 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106809 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 106812 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106816 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106821 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 106824 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 106828 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 106831 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106836 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106841 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106846 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 106849 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106853 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 106860 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 106863 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106867 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106872 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 106875 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106880 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 106883 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106887 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106892 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 106895 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 106899 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 106902 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106907 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106912 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106917 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 106920 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106924 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 106931 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 106934 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106938 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106943 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 106946 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106951 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 106954 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106958 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106963 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106966 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 106970 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 106973 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106978 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106983 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106988 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106991 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMLAfd),
     /* 106995 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107000 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 107003 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 107006 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 107009 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 107012 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 107023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107032 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 107035 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107045 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 107052 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107057 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107062 */     // GIR_Coverage, 2700,
     /* 107062 */     GIR_EraseRootFromParent_Done,
     /* 107063 */   // Label 2019: @107063
     /* 107063 */   GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(107391), // Rule ID 2702 //
     /* 107068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP),
     /* 107071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 107079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 107087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107103 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VFMAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 107103 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 107106 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107110 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107115 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 107117 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 107120 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107124 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107129 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 107132 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107137 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 107140 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107144 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107149 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 107152 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 107156 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 107159 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107164 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107169 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107174 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 107177 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107181 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 107188 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 107191 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107195 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107200 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 107203 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107208 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 107211 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107215 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107220 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 107223 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 107227 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 107230 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107235 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107240 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107245 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 107248 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107252 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 107259 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 107262 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107266 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107271 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 107274 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107279 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 107282 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107286 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107291 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 107294 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 107298 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 107301 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107306 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107311 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107316 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 107319 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VFMAfd),
     /* 107323 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107328 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 107331 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 107334 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 107337 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 107340 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 107351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107360 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 107363 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107373 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 107380 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107385 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107390 */     // GIR_Coverage, 2702,
     /* 107390 */     GIR_EraseRootFromParent_Done,
     /* 107391 */   // Label 2020: @107391
     /* 107391 */   GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(107427), // Rule ID 613 //
     /* 107396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 107399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107407 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VADDS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 107407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDS),
     /* 107410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 107412 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 107414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 107416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107419 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107425 */     GIR_RootConstrainSelectedInstOperands,
     /* 107426 */     // GIR_Coverage, 613,
     /* 107426 */     GIR_EraseRootFromParent_Done,
     /* 107427 */   // Label 2021: @107427
     /* 107427 */   GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(107657), // Rule ID 2697 //
     /* 107432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 107435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107443 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VADDfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 107443 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 107446 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107450 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 107457 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 107460 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107464 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107469 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 107472 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107477 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 107480 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107484 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107489 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 107492 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 107496 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 107499 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107504 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107509 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107514 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 107517 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107521 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 107528 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 107531 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107535 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107540 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 107543 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107548 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 107551 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107555 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107560 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 107563 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 107567 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 107570 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107575 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107580 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107585 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 107588 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VADDfd),
     /* 107592 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107597 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 107600 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 107603 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 107606 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 107617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107626 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 107629 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107639 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 107646 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107651 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107656 */     // GIR_Coverage, 2697,
     /* 107656 */     GIR_EraseRootFromParent_Done,
     /* 107657 */   // Label 2022: @107657
     /* 107657 */   GIM_Reject,
     /* 107658 */ // Label 2016: @107658
     /* 107658 */ GIM_Reject,
     /* 107659 */ // Label 2009: @107659
     /* 107659 */ GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(107705), // Rule ID 612 //
     /* 107664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 107667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 107673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107681 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107685 */   // (fadd:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VADDD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 107685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDD),
     /* 107688 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 107690 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 107692 */   GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 107694 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107697 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107703 */   GIR_RootConstrainSelectedInstOperands,
     /* 107704 */   // GIR_Coverage, 612,
     /* 107704 */   GIR_EraseRootFromParent_Done,
     /* 107705 */ // Label 2023: @107705
     /* 107705 */ GIM_Reject,
     /* 107706 */ // Label 2010: @107706
     /* 107706 */ GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(107752), // Rule ID 764 //
     /* 107711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 107714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107717 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 107720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107728 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107732 */   // (fadd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VADDfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 107732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDfd),
     /* 107735 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107737 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 107739 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 107741 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107744 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107750 */   GIR_RootConstrainSelectedInstOperands,
     /* 107751 */   // GIR_Coverage, 764,
     /* 107751 */   GIR_EraseRootFromParent_Done,
     /* 107752 */ // Label 2024: @107752
     /* 107752 */ GIM_Reject,
     /* 107753 */ // Label 2011: @107753
     /* 107753 */ GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(107937),
     /* 107758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 107764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107768 */   GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(107834), // Rule ID 5584 //
     /* 107773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 107776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 107792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107808 */     // (fadd:{ *:[v4f16] } (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm), DPR:{ *:[v4f16] }:$src1)  =>  (VFMAhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 107808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhd),
     /* 107811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107813 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 107815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 107819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 107823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107826 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107832 */     GIR_RootConstrainSelectedInstOperands,
     /* 107833 */     // GIR_Coverage, 5584,
     /* 107833 */     GIR_EraseRootFromParent_Done,
     /* 107834 */   // Label 2026: @107834
     /* 107834 */   GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(107900), // Rule ID 945 //
     /* 107839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 107842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 107850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 107862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107874 */     // (fadd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm))  =>  (VFMAhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 107874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhd),
     /* 107877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107879 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 107885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 107889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107892 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107898 */     GIR_RootConstrainSelectedInstOperands,
     /* 107899 */     // GIR_Coverage, 945,
     /* 107899 */     GIR_EraseRootFromParent_Done,
     /* 107900 */   // Label 2027: @107900
     /* 107900 */   GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(107936), // Rule ID 766 //
     /* 107905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 107908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107916 */     // (fadd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VADDhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 107916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDhd),
     /* 107919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107921 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 107923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 107925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107928 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107934 */     GIR_RootConstrainSelectedInstOperands,
     /* 107935 */     // GIR_Coverage, 766,
     /* 107935 */     GIR_EraseRootFromParent_Done,
     /* 107936 */   // Label 2028: @107936
     /* 107936 */   GIM_Reject,
     /* 107937 */ // Label 2025: @107937
     /* 107937 */ GIM_Reject,
     /* 107938 */ // Label 2012: @107938
     /* 107938 */ GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(108051),
     /* 107943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 107946 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 107949 */   GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(107989), // Rule ID 765 //
     /* 107954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 107957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107969 */     // (fadd:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VADDfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 107969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDfq),
     /* 107972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107974 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 107976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 107978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107981 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107987 */     GIR_RootConstrainSelectedInstOperands,
     /* 107988 */     // GIR_Coverage, 765,
     /* 107988 */     GIR_EraseRootFromParent_Done,
     /* 107989 */   // Label 2030: @107989
     /* 107989 */   GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(108050), // Rule ID 4016 //
     /* 107994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 107997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108009 */     // (fadd:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VADDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 108009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 108012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDf32),
     /* 108024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 108026 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 108028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 108030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108033 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108039 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108048 */     GIR_RootConstrainSelectedInstOperands,
     /* 108049 */     // GIR_Coverage, 4016,
     /* 108049 */     GIR_EraseRootFromParent_Done,
     /* 108050 */   // Label 2031: @108050
     /* 108050 */   GIM_Reject,
     /* 108051 */ // Label 2029: @108051
     /* 108051 */ GIM_Reject,
     /* 108052 */ // Label 2013: @108052
     /* 108052 */ GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(108305),
     /* 108057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108060 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 108063 */   GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(108133), // Rule ID 5585 //
     /* 108068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 108071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 108091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108107 */     // (fadd:{ *:[v8f16] } (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm), QPR:{ *:[v8f16] }:$src1)  =>  (VFMAhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 108107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhq),
     /* 108110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 108112 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 108118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 108122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108125 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108131 */     GIR_RootConstrainSelectedInstOperands,
     /* 108132 */     // GIR_Coverage, 5585,
     /* 108132 */     GIR_EraseRootFromParent_Done,
     /* 108133 */   // Label 2033: @108133
     /* 108133 */   GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(108203), // Rule ID 946 //
     /* 108138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 108141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 108153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 108165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108177 */     // (fadd:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm))  =>  (VFMAhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 108177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhq),
     /* 108180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 108182 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 108188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 108192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108195 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108201 */     GIR_RootConstrainSelectedInstOperands,
     /* 108202 */     // GIR_Coverage, 946,
     /* 108202 */     GIR_EraseRootFromParent_Done,
     /* 108203 */   // Label 2034: @108203
     /* 108203 */   GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(108243), // Rule ID 767 //
     /* 108208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 108211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108223 */     // (fadd:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VADDhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 108223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDhq),
     /* 108226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 108228 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 108230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 108232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108235 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108241 */     GIR_RootConstrainSelectedInstOperands,
     /* 108242 */     // GIR_Coverage, 767,
     /* 108242 */     GIR_EraseRootFromParent_Done,
     /* 108243 */   // Label 2035: @108243
     /* 108243 */   GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(108304), // Rule ID 4020 //
     /* 108248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 108251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108263 */     // (fadd:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VADDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 108263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 108266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDf16),
     /* 108278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 108280 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 108282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 108284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108287 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108293 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108302 */     GIR_RootConstrainSelectedInstOperands,
     /* 108303 */     // GIR_Coverage, 4020,
     /* 108303 */     GIR_EraseRootFromParent_Done,
     /* 108304 */   // Label 2036: @108304
     /* 108304 */   GIM_Reject,
     /* 108305 */ // Label 2032: @108305
     /* 108305 */ GIM_Reject,
     /* 108306 */ // Label 2014: @108306
     /* 108306 */ GIM_Reject,
     /* 108307 */ // Label 35: @108307
     /* 108307 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2044*/ GIMT_Encode4(109983),
     /* 108318 */ /*GILLT_s16*//*Label 2037*/ GIMT_Encode4(108370),
     /* 108322 */ /*GILLT_s32*//*Label 2038*/ GIMT_Encode4(108417),
     /* 108326 */ /*GILLT_s64*//*Label 2039*/ GIMT_Encode4(109344), GIMT_Encode4(0),
     /* 108334 */ /*GILLT_v2s32*//*Label 2040*/ GIMT_Encode4(109391), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 108346 */ /*GILLT_v4s16*//*Label 2041*/ GIMT_Encode4(109438),
     /* 108350 */ /*GILLT_v4s32*//*Label 2042*/ GIMT_Encode4(109615), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 108366 */ /*GILLT_v8s16*//*Label 2043*/ GIMT_Encode4(109729),
     /* 108370 */ // Label 2037: @108370
     /* 108370 */ GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(108416), // Rule ID 617 //
     /* 108375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 108378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 108381 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 108384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 108388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 108392 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 108396 */   // (fsub:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VSUBH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 108396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBH),
     /* 108399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 108401 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 108403 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 108405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108408 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108414 */   GIR_RootConstrainSelectedInstOperands,
     /* 108415 */   // GIR_Coverage, 617,
     /* 108415 */   GIR_EraseRootFromParent_Done,
     /* 108416 */ // Label 2045: @108416
     /* 108416 */ GIM_Reject,
     /* 108417 */ // Label 2038: @108417
     /* 108417 */ GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(109343),
     /* 108422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 108425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 108428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108436 */   GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(108760), // Rule ID 2701 //
     /* 108441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseFPVMLx_UseNEONForFP),
     /* 108444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 108448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 108456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108472 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMLSfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 108472 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 108475 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108479 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 108486 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 108489 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108493 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108498 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 108501 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108506 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 108509 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108513 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108518 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 108521 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 108525 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 108528 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108533 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108538 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108543 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 108546 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108550 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 108557 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 108560 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108564 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108569 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 108572 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108577 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 108580 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108584 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108589 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 108592 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 108596 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 108599 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108604 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108609 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108614 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 108617 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108621 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 108628 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 108631 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108635 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108640 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 108643 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108648 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 108651 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108655 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108660 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 108663 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 108667 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 108670 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108675 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108680 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108685 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 108688 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMLSfd),
     /* 108692 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108697 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 108700 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 108703 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 108706 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 108709 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 108720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108729 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 108732 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108742 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 108749 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108759 */     // GIR_Coverage, 2701,
     /* 108759 */     GIR_EraseRootFromParent_Done,
     /* 108760 */   // Label 2047: @108760
     /* 108760 */   GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(109084), // Rule ID 2703 //
     /* 108765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP),
     /* 108768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 108772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 108780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108784 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108796 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VFMSfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 108796 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 108799 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108803 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 108810 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 108813 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108817 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108822 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 108825 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108830 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 108833 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108837 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108842 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 108845 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 108849 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 108852 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108857 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108862 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108867 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 108870 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108874 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 108881 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 108884 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108888 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108893 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 108896 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108901 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 108904 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108908 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108913 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 108916 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 108920 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 108923 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108928 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108933 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108938 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 108941 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108945 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 108952 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 108955 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108959 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108964 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 108967 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108972 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 108975 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108979 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108984 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 108987 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 108991 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 108994 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108999 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109004 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109009 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 109012 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VFMSfd),
     /* 109016 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109021 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 109024 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 109027 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 109030 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 109033 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109041 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 109044 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109048 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109053 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 109056 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109066 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 109073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109078 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109083 */     // GIR_Coverage, 2703,
     /* 109083 */     GIR_EraseRootFromParent_Done,
     /* 109084 */   // Label 2048: @109084
     /* 109084 */   GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(109116), // Rule ID 616 //
     /* 109089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 109092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109096 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VSUBS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 109096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBS),
     /* 109099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 109101 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 109103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 109105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109108 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109114 */     GIR_RootConstrainSelectedInstOperands,
     /* 109115 */     // GIR_Coverage, 616,
     /* 109115 */     GIR_EraseRootFromParent_Done,
     /* 109116 */   // Label 2049: @109116
     /* 109116 */   GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(109342), // Rule ID 2698 //
     /* 109121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 109124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109128 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VSUBfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 109128 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 109131 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109135 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 109142 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 109145 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109149 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109154 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 109157 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109162 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 109165 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 109169 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109174 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 109177 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 109181 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 109184 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109189 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109194 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109199 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 109202 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109206 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 109213 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 109216 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109220 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109225 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 109228 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109233 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 109236 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 109240 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109245 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 109248 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 109252 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 109255 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109260 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109265 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109270 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 109273 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VSUBfd),
     /* 109277 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109282 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 109285 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 109288 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 109291 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 109302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109311 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 109314 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109324 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 109331 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109336 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109341 */     // GIR_Coverage, 2698,
     /* 109341 */     GIR_EraseRootFromParent_Done,
     /* 109342 */   // Label 2050: @109342
     /* 109342 */   GIM_Reject,
     /* 109343 */ // Label 2046: @109343
     /* 109343 */ GIM_Reject,
     /* 109344 */ // Label 2039: @109344
     /* 109344 */ GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(109390), // Rule ID 615 //
     /* 109349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 109352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109355 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 109358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109362 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109366 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109370 */   // (fsub:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VSUBD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 109370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBD),
     /* 109373 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 109375 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 109377 */   GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 109379 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109382 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109388 */   GIR_RootConstrainSelectedInstOperands,
     /* 109389 */   // GIR_Coverage, 615,
     /* 109389 */   GIR_EraseRootFromParent_Done,
     /* 109390 */ // Label 2051: @109390
     /* 109390 */ GIM_Reject,
     /* 109391 */ // Label 2040: @109391
     /* 109391 */ GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(109437), // Rule ID 968 //
     /* 109396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 109399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 109402 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 109405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109409 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109413 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109417 */   // (fsub:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VSUBfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 109417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBfd),
     /* 109420 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109422 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109424 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109429 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109435 */   GIR_RootConstrainSelectedInstOperands,
     /* 109436 */   // GIR_Coverage, 968,
     /* 109436 */   GIR_EraseRootFromParent_Done,
     /* 109437 */ // Label 2052: @109437
     /* 109437 */ GIM_Reject,
     /* 109438 */ // Label 2041: @109438
     /* 109438 */ GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(109614),
     /* 109443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 109449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109457 */   GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(109519), // Rule ID 923 //
     /* 109462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFPVMLx),
     /* 109465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 109481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109486 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109493 */     // (fsub:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm))  =>  (VMLShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 109493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLShd),
     /* 109496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109498 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109511 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109517 */     GIR_RootConstrainSelectedInstOperands,
     /* 109518 */     // GIR_Coverage, 923,
     /* 109518 */     GIR_EraseRootFromParent_Done,
     /* 109519 */   // Label 2054: @109519
     /* 109519 */   GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(109581), // Rule ID 949 //
     /* 109524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 109527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 109543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109555 */     // (fsub:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm))  =>  (VFMShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 109555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMShd),
     /* 109558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109560 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109573 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109579 */     GIR_RootConstrainSelectedInstOperands,
     /* 109580 */     // GIR_Coverage, 949,
     /* 109580 */     GIR_EraseRootFromParent_Done,
     /* 109581 */   // Label 2055: @109581
     /* 109581 */   GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(109613), // Rule ID 970 //
     /* 109586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 109589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109593 */     // (fsub:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VSUBhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 109593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBhd),
     /* 109596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109598 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109605 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109611 */     GIR_RootConstrainSelectedInstOperands,
     /* 109612 */     // GIR_Coverage, 970,
     /* 109612 */     GIR_EraseRootFromParent_Done,
     /* 109613 */   // Label 2056: @109613
     /* 109613 */   GIM_Reject,
     /* 109614 */ // Label 2053: @109614
     /* 109614 */ GIM_Reject,
     /* 109615 */ // Label 2042: @109615
     /* 109615 */ GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(109728),
     /* 109620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 109626 */   GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(109666), // Rule ID 969 //
     /* 109631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 109634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109646 */     // (fsub:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VSUBfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 109646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBfq),
     /* 109649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109651 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109658 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109664 */     GIR_RootConstrainSelectedInstOperands,
     /* 109665 */     // GIR_Coverage, 969,
     /* 109665 */     GIR_EraseRootFromParent_Done,
     /* 109666 */   // Label 2058: @109666
     /* 109666 */   GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(109727), // Rule ID 4024 //
     /* 109671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 109674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109686 */     // (fsub:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VSUBf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 109686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 109689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBf32),
     /* 109701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 109703 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 109705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 109707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109710 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109716 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109725 */     GIR_RootConstrainSelectedInstOperands,
     /* 109726 */     // GIR_Coverage, 4024,
     /* 109726 */     GIR_EraseRootFromParent_Done,
     /* 109727 */   // Label 2059: @109727
     /* 109727 */   GIM_Reject,
     /* 109728 */ // Label 2057: @109728
     /* 109728 */ GIM_Reject,
     /* 109729 */ // Label 2043: @109729
     /* 109729 */ GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(109982),
     /* 109734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109737 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 109740 */   GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(109810), // Rule ID 924 //
     /* 109745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFPVMLx),
     /* 109748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 109772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109784 */     // (fsub:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm))  =>  (VMLShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 109784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLShq),
     /* 109787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109789 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109802 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109808 */     GIR_RootConstrainSelectedInstOperands,
     /* 109809 */     // GIR_Coverage, 924,
     /* 109809 */     GIR_EraseRootFromParent_Done,
     /* 109810 */   // Label 2061: @109810
     /* 109810 */   GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(109880), // Rule ID 950 //
     /* 109815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 109818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109838 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 109842 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109854 */     // (fsub:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm))  =>  (VFMShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 109854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMShq),
     /* 109857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109859 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109872 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109878 */     GIR_RootConstrainSelectedInstOperands,
     /* 109879 */     // GIR_Coverage, 950,
     /* 109879 */     GIR_EraseRootFromParent_Done,
     /* 109880 */   // Label 2062: @109880
     /* 109880 */   GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(109920), // Rule ID 971 //
     /* 109885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 109888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109900 */     // (fsub:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VSUBhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 109900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBhq),
     /* 109903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109905 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109912 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109918 */     GIR_RootConstrainSelectedInstOperands,
     /* 109919 */     // GIR_Coverage, 971,
     /* 109919 */     GIR_EraseRootFromParent_Done,
     /* 109920 */   // Label 2063: @109920
     /* 109920 */   GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(109981), // Rule ID 4028 //
     /* 109925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 109928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109940 */     // (fsub:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VSUBf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 109940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 109943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBf16),
     /* 109955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 109957 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 109959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 109961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109964 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109970 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109979 */     GIR_RootConstrainSelectedInstOperands,
     /* 109980 */     // GIR_Coverage, 4028,
     /* 109980 */     GIR_EraseRootFromParent_Done,
     /* 109981 */   // Label 2064: @109981
     /* 109981 */   GIM_Reject,
     /* 109982 */ // Label 2060: @109982
     /* 109982 */ GIM_Reject,
     /* 109983 */ // Label 2044: @109983
     /* 109983 */ GIM_Reject,
     /* 109984 */ // Label 36: @109984
     /* 109984 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2072*/ GIMT_Encode4(110964),
     /* 109995 */ /*GILLT_s16*//*Label 2065*/ GIMT_Encode4(110047),
     /* 109999 */ /*GILLT_s32*//*Label 2066*/ GIMT_Encode4(110094),
     /* 110003 */ /*GILLT_s64*//*Label 2067*/ GIMT_Encode4(110483), GIMT_Encode4(0),
     /* 110011 */ /*GILLT_v2s32*//*Label 2068*/ GIMT_Encode4(110642), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110023 */ /*GILLT_v4s16*//*Label 2069*/ GIMT_Encode4(110689),
     /* 110027 */ /*GILLT_v4s32*//*Label 2070*/ GIMT_Encode4(110736), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110043 */ /*GILLT_v8s16*//*Label 2071*/ GIMT_Encode4(110850),
     /* 110047 */ // Label 2065: @110047
     /* 110047 */ GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(110093), // Rule ID 623 //
     /* 110052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 110055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 110058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 110061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110069 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110073 */   // (fmul:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VMULH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 110073 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULH),
     /* 110076 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110078 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 110080 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 110082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110085 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110091 */   GIR_RootConstrainSelectedInstOperands,
     /* 110092 */   // GIR_Coverage, 623,
     /* 110092 */   GIR_EraseRootFromParent_Done,
     /* 110093 */ // Label 2073: @110093
     /* 110093 */ GIM_Reject,
     /* 110094 */ // Label 2066: @110094
     /* 110094 */ GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(110482),
     /* 110099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 110102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 110105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110109 */   GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(110162), // Rule ID 2302 //
     /* 110114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoHonorSignDependentRounding),
     /* 110117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 110129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110140 */     // (fmul:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$a), SPR:{ *:[f32] }:$b)  =>  (VNMULS:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)
     /* 110140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULS),
     /* 110143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110149 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 110151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110154 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110160 */     GIR_RootConstrainSelectedInstOperands,
     /* 110161 */     // GIR_Coverage, 2302,
     /* 110161 */     GIR_EraseRootFromParent_Done,
     /* 110162 */   // Label 2075: @110162
     /* 110162 */   GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(110215), // Rule ID 5711 //
     /* 110167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoHonorSignDependentRounding),
     /* 110170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 110178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 110186 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110193 */     // (fmul:{ *:[f32] } SPR:{ *:[f32] }:$b, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (VNMULS:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)
     /* 110193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULS),
     /* 110196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110202 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 110204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110207 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110213 */     GIR_RootConstrainSelectedInstOperands,
     /* 110214 */     // GIR_Coverage, 5711,
     /* 110214 */     GIR_EraseRootFromParent_Done,
     /* 110215 */   // Label 2076: @110215
     /* 110215 */   GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(110251), // Rule ID 622 //
     /* 110220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 110223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110231 */     // (fmul:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VMULS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 110231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULS),
     /* 110234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110236 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 110238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 110240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110243 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110249 */     GIR_RootConstrainSelectedInstOperands,
     /* 110250 */     // GIR_Coverage, 622,
     /* 110250 */     GIR_EraseRootFromParent_Done,
     /* 110251 */   // Label 2077: @110251
     /* 110251 */   GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(110481), // Rule ID 2699 //
     /* 110256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 110259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110267 */     // (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMULfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 110267 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 110270 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110274 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 110281 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 110284 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110288 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110293 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 110296 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110301 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 110304 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110308 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110313 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 110316 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 110320 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 110323 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110328 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110333 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 110338 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 110341 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110345 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 110352 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 110355 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110359 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110364 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 110367 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110372 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 110375 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110379 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110384 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 110387 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 110391 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 110394 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110399 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110404 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 110409 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 110412 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMULfd),
     /* 110416 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110421 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 110424 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 110427 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 110430 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 110441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110450 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 110453 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110463 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 110470 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 110475 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110480 */     // GIR_Coverage, 2699,
     /* 110480 */     GIR_EraseRootFromParent_Done,
     /* 110481 */   // Label 2078: @110481
     /* 110481 */   GIM_Reject,
     /* 110482 */ // Label 2074: @110482
     /* 110482 */ GIM_Reject,
     /* 110483 */ // Label 2067: @110483
     /* 110483 */ GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(110641),
     /* 110488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110491 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 110494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110498 */   GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(110551), // Rule ID 2301 //
     /* 110503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_NoHonorSignDependentRounding),
     /* 110506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 110518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110529 */     // (fmul:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$a), DPR:{ *:[f64] }:$b)  =>  (VNMULD:{ *:[f64] } DPR:{ *:[f64] }:$a, DPR:{ *:[f64] }:$b)
     /* 110529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULD),
     /* 110532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 110534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110538 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 110540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110543 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110549 */     GIR_RootConstrainSelectedInstOperands,
     /* 110550 */     // GIR_Coverage, 2301,
     /* 110550 */     GIR_EraseRootFromParent_Done,
     /* 110551 */   // Label 2080: @110551
     /* 110551 */   GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(110604), // Rule ID 5710 //
     /* 110556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_NoHonorSignDependentRounding),
     /* 110559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 110567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 110575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110582 */     // (fmul:{ *:[f64] } DPR:{ *:[f64] }:$b, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (VNMULD:{ *:[f64] } DPR:{ *:[f64] }:$a, DPR:{ *:[f64] }:$b)
     /* 110582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULD),
     /* 110585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 110587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110591 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 110593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110596 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110602 */     GIR_RootConstrainSelectedInstOperands,
     /* 110603 */     // GIR_Coverage, 5710,
     /* 110603 */     GIR_EraseRootFromParent_Done,
     /* 110604 */   // Label 2081: @110604
     /* 110604 */   GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(110640), // Rule ID 621 //
     /* 110609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 110612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110620 */     // (fmul:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VMULD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 110620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULD),
     /* 110623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 110625 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 110627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 110629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110632 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110638 */     GIR_RootConstrainSelectedInstOperands,
     /* 110639 */     // GIR_Coverage, 621,
     /* 110639 */     GIR_EraseRootFromParent_Done,
     /* 110640 */   // Label 2082: @110640
     /* 110640 */   GIM_Reject,
     /* 110641 */ // Label 2079: @110641
     /* 110641 */ GIM_Reject,
     /* 110642 */ // Label 2068: @110642
     /* 110642 */ GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(110688), // Rule ID 843 //
     /* 110647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 110650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 110656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110664 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110668 */   // (fmul:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VMULfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 110668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULfd),
     /* 110671 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110673 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110675 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110680 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110686 */   GIR_RootConstrainSelectedInstOperands,
     /* 110687 */   // GIR_Coverage, 843,
     /* 110687 */   GIR_EraseRootFromParent_Done,
     /* 110688 */ // Label 2083: @110688
     /* 110688 */ GIM_Reject,
     /* 110689 */ // Label 2069: @110689
     /* 110689 */ GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(110735), // Rule ID 845 //
     /* 110694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 110697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 110700 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 110703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110707 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110711 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110715 */   // (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VMULhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 110715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULhd),
     /* 110718 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110720 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110722 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110724 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110727 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110733 */   GIR_RootConstrainSelectedInstOperands,
     /* 110734 */   // GIR_Coverage, 845,
     /* 110734 */   GIR_EraseRootFromParent_Done,
     /* 110735 */ // Label 2084: @110735
     /* 110735 */ GIM_Reject,
     /* 110736 */ // Label 2070: @110736
     /* 110736 */ GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(110849),
     /* 110741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110744 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 110747 */   GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(110787), // Rule ID 844 //
     /* 110752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 110755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110767 */     // (fmul:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VMULfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 110767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULfq),
     /* 110770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110772 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110779 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110785 */     GIR_RootConstrainSelectedInstOperands,
     /* 110786 */     // GIR_Coverage, 844,
     /* 110786 */     GIR_EraseRootFromParent_Done,
     /* 110787 */   // Label 2086: @110787
     /* 110787 */   GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(110848), // Rule ID 3988 //
     /* 110792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 110795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110807 */     // (fmul:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VMULf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 110807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 110810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULf32),
     /* 110822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 110824 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 110826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 110828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110831 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110837 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110846 */     GIR_RootConstrainSelectedInstOperands,
     /* 110847 */     // GIR_Coverage, 3988,
     /* 110847 */     GIR_EraseRootFromParent_Done,
     /* 110848 */   // Label 2087: @110848
     /* 110848 */   GIM_Reject,
     /* 110849 */ // Label 2085: @110849
     /* 110849 */ GIM_Reject,
     /* 110850 */ // Label 2071: @110850
     /* 110850 */ GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(110963),
     /* 110855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110858 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 110861 */   GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(110901), // Rule ID 846 //
     /* 110866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 110869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110881 */     // (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VMULhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 110881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULhq),
     /* 110884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110886 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110893 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110899 */     GIR_RootConstrainSelectedInstOperands,
     /* 110900 */     // GIR_Coverage, 846,
     /* 110900 */     GIR_EraseRootFromParent_Done,
     /* 110901 */   // Label 2089: @110901
     /* 110901 */   GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(110962), // Rule ID 3992 //
     /* 110906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 110909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110921 */     // (fmul:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VMULf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 110921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 110924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULf16),
     /* 110936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 110938 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 110940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 110942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110945 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110951 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110960 */     GIR_RootConstrainSelectedInstOperands,
     /* 110961 */     // GIR_Coverage, 3992,
     /* 110961 */     GIR_EraseRootFromParent_Done,
     /* 110962 */   // Label 2090: @110962
     /* 110962 */   GIM_Reject,
     /* 110963 */ // Label 2088: @110963
     /* 110963 */ GIM_Reject,
     /* 110964 */ // Label 2072: @110964
     /* 110964 */ GIM_Reject,
     /* 110965 */ // Label 37: @110965
     /* 110965 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2098*/ GIMT_Encode4(113055),
     /* 110976 */ /*GILLT_s16*//*Label 2091*/ GIMT_Encode4(111028),
     /* 110980 */ /*GILLT_s32*//*Label 2092*/ GIMT_Encode4(111415),
     /* 110984 */ /*GILLT_s64*//*Label 2093*/ GIMT_Encode4(111802), GIMT_Encode4(0),
     /* 110992 */ /*GILLT_v2s32*//*Label 2094*/ GIMT_Encode4(112189), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 111004 */ /*GILLT_v4s16*//*Label 2095*/ GIMT_Encode4(112369),
     /* 111008 */ /*GILLT_v4s32*//*Label 2096*/ GIMT_Encode4(112425), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 111024 */ /*GILLT_v8s16*//*Label 2097*/ GIMT_Encode4(112803),
     /* 111028 */ // Label 2091: @111028
     /* 111028 */ GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(111414),
     /* 111033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 111036 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 111039 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 111042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111046 */   GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(111120), // Rule ID 2406 //
     /* 111051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 111087 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111094 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sdin))  =>  (VFNMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAH),
     /* 111097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111112 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111118 */     GIR_RootConstrainSelectedInstOperands,
     /* 111119 */     // GIR_Coverage, 2406,
     /* 111119 */     GIR_EraseRootFromParent_Done,
     /* 111120 */   // Label 2100: @111120
     /* 111120 */   GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(111194), // Rule ID 5719 //
     /* 111125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 111161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111168 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sdin))  =>  (VFNMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAH),
     /* 111171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111181 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111186 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111192 */     GIR_RootConstrainSelectedInstOperands,
     /* 111193 */     // GIR_Coverage, 5719,
     /* 111193 */     GIR_EraseRootFromParent_Done,
     /* 111194 */   // Label 2101: @111194
     /* 111194 */   GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(111253), // Rule ID 2398 //
     /* 111199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111214 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111229 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin)  =>  (VFMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSH),
     /* 111232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111245 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111251 */     GIR_RootConstrainSelectedInstOperands,
     /* 111252 */     // GIR_Coverage, 2398,
     /* 111252 */     GIR_EraseRootFromParent_Done,
     /* 111253 */   // Label 2102: @111253
     /* 111253 */   GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(111312), // Rule ID 5716 //
     /* 111258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111288 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sdin)  =>  (VFMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSH),
     /* 111291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111299 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111310 */     GIR_RootConstrainSelectedInstOperands,
     /* 111311 */     // GIR_Coverage, 5716,
     /* 111311 */     GIR_EraseRootFromParent_Done,
     /* 111312 */   // Label 2103: @111312
     /* 111312 */   GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(111371), // Rule ID 2411 //
     /* 111317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 111332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111347 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sdin))  =>  (VFNMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSH),
     /* 111350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sdin
     /* 111356 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111363 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111369 */     GIR_RootConstrainSelectedInstOperands,
     /* 111370 */     // GIR_Coverage, 2411,
     /* 111370 */     GIR_EraseRootFromParent_Done,
     /* 111371 */   // Label 2104: @111371
     /* 111371 */   GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(111413), // Rule ID 2392 //
     /* 111376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111391 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin)  =>  (VFMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAH),
     /* 111394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111398 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111405 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111411 */     GIR_RootConstrainSelectedInstOperands,
     /* 111412 */     // GIR_Coverage, 2392,
     /* 111412 */     GIR_EraseRootFromParent_Done,
     /* 111413 */   // Label 2105: @111413
     /* 111413 */   GIM_Reject,
     /* 111414 */ // Label 2099: @111414
     /* 111414 */ GIM_Reject,
     /* 111415 */ // Label 2092: @111415
     /* 111415 */ GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(111801),
     /* 111420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 111423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 111426 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 111429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111433 */   GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(111507), // Rule ID 2405 //
     /* 111438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 111474 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111481 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sdin))  =>  (VFNMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAS),
     /* 111484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111499 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111505 */     GIR_RootConstrainSelectedInstOperands,
     /* 111506 */     // GIR_Coverage, 2405,
     /* 111506 */     GIR_EraseRootFromParent_Done,
     /* 111507 */   // Label 2107: @111507
     /* 111507 */   GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(111581), // Rule ID 5718 //
     /* 111512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 111548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111553 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111555 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sdin))  =>  (VFNMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAS),
     /* 111558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111568 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111573 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111579 */     GIR_RootConstrainSelectedInstOperands,
     /* 111580 */     // GIR_Coverage, 5718,
     /* 111580 */     GIR_EraseRootFromParent_Done,
     /* 111581 */   // Label 2108: @111581
     /* 111581 */   GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(111640), // Rule ID 2397 //
     /* 111586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111616 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin)  =>  (VFMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSS),
     /* 111619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111632 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111638 */     GIR_RootConstrainSelectedInstOperands,
     /* 111639 */     // GIR_Coverage, 2397,
     /* 111639 */     GIR_EraseRootFromParent_Done,
     /* 111640 */   // Label 2109: @111640
     /* 111640 */   GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(111699), // Rule ID 5715 //
     /* 111645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111675 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sdin)  =>  (VFMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSS),
     /* 111678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111686 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111691 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111697 */     GIR_RootConstrainSelectedInstOperands,
     /* 111698 */     // GIR_Coverage, 5715,
     /* 111698 */     GIR_EraseRootFromParent_Done,
     /* 111699 */   // Label 2110: @111699
     /* 111699 */   GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(111758), // Rule ID 2410 //
     /* 111704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 111719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111734 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sdin))  =>  (VFNMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSS),
     /* 111737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sdin
     /* 111743 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111750 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111756 */     GIR_RootConstrainSelectedInstOperands,
     /* 111757 */     // GIR_Coverage, 2410,
     /* 111757 */     GIR_EraseRootFromParent_Done,
     /* 111758 */   // Label 2111: @111758
     /* 111758 */   GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(111800), // Rule ID 2391 //
     /* 111763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111778 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin)  =>  (VFMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAS),
     /* 111781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111785 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111792 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111798 */     GIR_RootConstrainSelectedInstOperands,
     /* 111799 */     // GIR_Coverage, 2391,
     /* 111799 */     GIR_EraseRootFromParent_Done,
     /* 111800 */   // Label 2112: @111800
     /* 111800 */   GIM_Reject,
     /* 111801 */ // Label 2106: @111801
     /* 111801 */ GIM_Reject,
     /* 111802 */ // Label 2093: @111802
     /* 111802 */ GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(112188),
     /* 111807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111810 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 111813 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 111816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111820 */   GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(111894), // Rule ID 2404 //
     /* 111825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111857 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 111861 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111868 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Ddin))  =>  (VFNMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAD),
     /* 111871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ddin
     /* 111877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 111881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 111883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111886 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111892 */     GIR_RootConstrainSelectedInstOperands,
     /* 111893 */     // GIR_Coverage, 2404,
     /* 111893 */     GIR_EraseRootFromParent_Done,
     /* 111894 */   // Label 2114: @111894
     /* 111894 */   GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(111968), // Rule ID 5717 //
     /* 111899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111931 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 111935 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111940 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111942 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Ddin))  =>  (VFNMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAD),
     /* 111945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ddin
     /* 111951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 111955 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 111957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111966 */     GIR_RootConstrainSelectedInstOperands,
     /* 111967 */     // GIR_Coverage, 5717,
     /* 111967 */     GIR_EraseRootFromParent_Done,
     /* 111968 */   // Label 2115: @111968
     /* 111968 */   GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(112027), // Rule ID 2396 //
     /* 111973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112003 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin)  =>  (VFMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 112003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSD),
     /* 112006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 112008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ddin
     /* 112010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 112014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 112016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112019 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112025 */     GIR_RootConstrainSelectedInstOperands,
     /* 112026 */     // GIR_Coverage, 2396,
     /* 112026 */     GIR_EraseRootFromParent_Done,
     /* 112027 */   // Label 2116: @112027
     /* 112027 */   GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(112086), // Rule ID 5714 //
     /* 112032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 112035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 112051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112062 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Ddin)  =>  (VFMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 112062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSD),
     /* 112065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 112067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ddin
     /* 112069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 112073 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 112075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112078 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112084 */     GIR_RootConstrainSelectedInstOperands,
     /* 112085 */     // GIR_Coverage, 5714,
     /* 112085 */     GIR_EraseRootFromParent_Done,
     /* 112086 */   // Label 2117: @112086
     /* 112086 */   GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(112145), // Rule ID 2409 //
     /* 112091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 112094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 112106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 112114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112121 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Ddin))  =>  (VFNMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 112121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSD),
     /* 112124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 112126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ddin
     /* 112130 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 112132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 112134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112137 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112143 */     GIR_RootConstrainSelectedInstOperands,
     /* 112144 */     // GIR_Coverage, 2409,
     /* 112144 */     GIR_EraseRootFromParent_Done,
     /* 112145 */   // Label 2118: @112145
     /* 112145 */   GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(112187), // Rule ID 2390 //
     /* 112150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 112153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112165 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin)  =>  (VFMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 112165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAD),
     /* 112168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 112170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ddin
     /* 112172 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 112174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 112176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112179 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112185 */     GIR_RootConstrainSelectedInstOperands,
     /* 112186 */     // GIR_Coverage, 2390,
     /* 112186 */     GIR_EraseRootFromParent_Done,
     /* 112187 */   // Label 2119: @112187
     /* 112187 */   GIM_Reject,
     /* 112188 */ // Label 2113: @112188
     /* 112188 */ GIM_Reject,
     /* 112189 */ // Label 2094: @112189
     /* 112189 */ GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(112368),
     /* 112194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 112197 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 112200 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 112203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112207 */   GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(112266), // Rule ID 2503 //
     /* 112212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 112227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112242 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn), DPR:{ *:[v2f32] }:$Vm, DPR:{ *:[v2f32] }:$src1)  =>  (VFMSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$src1, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 112242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfd),
     /* 112245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112247 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112258 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112264 */     GIR_RootConstrainSelectedInstOperands,
     /* 112265 */     // GIR_Coverage, 2503,
     /* 112265 */     GIR_EraseRootFromParent_Done,
     /* 112266 */   // Label 2121: @112266
     /* 112266 */   GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(112325), // Rule ID 5757 //
     /* 112271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 112290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112301 */     // (fma:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm, (fneg:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn), DPR:{ *:[v2f32] }:$src1)  =>  (VFMSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$src1, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 112301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfd),
     /* 112304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112306 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112312 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 112314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112317 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112323 */     GIR_RootConstrainSelectedInstOperands,
     /* 112324 */     // GIR_Coverage, 5757,
     /* 112324 */     GIR_EraseRootFromParent_Done,
     /* 112325 */   // Label 2122: @112325
     /* 112325 */   GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(112367), // Rule ID 2501 //
     /* 112330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112345 */     // (fma:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm, DPR:{ *:[v2f32] }:$src1)  =>  (VFMAfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$src1, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 112345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAfd),
     /* 112348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112350 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112352 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112359 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112365 */     GIR_RootConstrainSelectedInstOperands,
     /* 112366 */     // GIR_Coverage, 2501,
     /* 112366 */     GIR_EraseRootFromParent_Done,
     /* 112367 */   // Label 2123: @112367
     /* 112367 */   GIM_Reject,
     /* 112368 */ // Label 2120: @112368
     /* 112368 */ GIM_Reject,
     /* 112369 */ // Label 2095: @112369
     /* 112369 */ GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(112424), // Rule ID 2499 //
     /* 112374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 112377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 112380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 112383 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 112386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112394 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112398 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112402 */   // (fma:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm, DPR:{ *:[v4f16] }:$src1)  =>  (VFMAhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 112402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhd),
     /* 112405 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112407 */   GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112409 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112411 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112413 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112416 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112422 */   GIR_RootConstrainSelectedInstOperands,
     /* 112423 */   // GIR_Coverage, 2499,
     /* 112423 */   GIR_EraseRootFromParent_Done,
     /* 112424 */ // Label 2124: @112424
     /* 112424 */ GIM_Reject,
     /* 112425 */ // Label 2096: @112425
     /* 112425 */ GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(112802),
     /* 112430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112433 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 112436 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 112439 */   GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(112502), // Rule ID 2504 //
     /* 112444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112463 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112478 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn), QPR:{ *:[v4f32] }:$Vm, QPR:{ *:[v4f32] }:$src1)  =>  (VFMSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$src1, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 112478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfq),
     /* 112481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112483 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112494 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112500 */     GIR_RootConstrainSelectedInstOperands,
     /* 112501 */     // GIR_Coverage, 2504,
     /* 112501 */     GIR_EraseRootFromParent_Done,
     /* 112502 */   // Label 2126: @112502
     /* 112502 */   GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(112571), // Rule ID 4002 //
     /* 112507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112526 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112541 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m1), MQPR:{ *:[v4f32] }:$m2, MQPR:{ *:[v4f32] }:$add)  =>  (MVE_VFMSf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$add, ?:{ *:[v4f32] }:$m1, ?:{ *:[v4f32] }:$m2)
     /* 112541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf32),
     /* 112544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112546 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112552 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112557 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112563 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112569 */     GIR_RootConstrainSelectedInstOperands,
     /* 112570 */     // GIR_Coverage, 4002,
     /* 112570 */     GIR_EraseRootFromParent_Done,
     /* 112571 */   // Label 2127: @112571
     /* 112571 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(112634), // Rule ID 5758 //
     /* 112576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112610 */     // (fma:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm, (fneg:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn), QPR:{ *:[v4f32] }:$src1)  =>  (VFMSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$src1, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 112610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfq),
     /* 112613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112615 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112621 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 112623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112626 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112632 */     GIR_RootConstrainSelectedInstOperands,
     /* 112633 */     // GIR_Coverage, 5758,
     /* 112633 */     GIR_EraseRootFromParent_Done,
     /* 112634 */   // Label 2128: @112634
     /* 112634 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(112703), // Rule ID 6038 //
     /* 112639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112673 */     // (fma:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m2, (fneg:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m1), MQPR:{ *:[v4f32] }:$add)  =>  (MVE_VFMSf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$add, ?:{ *:[v4f32] }:$m1, ?:{ *:[v4f32] }:$m2)
     /* 112673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf32),
     /* 112676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112678 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112684 */     GIR_RootToRootCopy, /*OpIdx*/1, // m2
     /* 112686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112689 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112695 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112701 */     GIR_RootConstrainSelectedInstOperands,
     /* 112702 */     // GIR_Coverage, 6038,
     /* 112702 */     GIR_EraseRootFromParent_Done,
     /* 112703 */   // Label 2129: @112703
     /* 112703 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(112749), // Rule ID 2502 //
     /* 112708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112727 */     // (fma:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm, QPR:{ *:[v4f32] }:$src1)  =>  (VFMAfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$src1, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 112727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAfq),
     /* 112730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112732 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112734 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112741 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112747 */     GIR_RootConstrainSelectedInstOperands,
     /* 112748 */     // GIR_Coverage, 2502,
     /* 112748 */     GIR_EraseRootFromParent_Done,
     /* 112749 */   // Label 2130: @112749
     /* 112749 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(112801), // Rule ID 4006 //
     /* 112754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112773 */     // (fma:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m1, MQPR:{ *:[v4f32] }:$m2, MQPR:{ *:[v4f32] }:$add)  =>  (MVE_VFMAf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$add, ?:{ *:[v4f32] }:$m1, ?:{ *:[v4f32] }:$m2)
     /* 112773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMAf32),
     /* 112776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112778 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112780 */     GIR_RootToRootCopy, /*OpIdx*/1, // m1
     /* 112782 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112787 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112793 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112799 */     GIR_RootConstrainSelectedInstOperands,
     /* 112800 */     // GIR_Coverage, 4006,
     /* 112800 */     GIR_EraseRootFromParent_Done,
     /* 112801 */   // Label 2131: @112801
     /* 112801 */   GIM_Reject,
     /* 112802 */ // Label 2125: @112802
     /* 112802 */ GIM_Reject,
     /* 112803 */ // Label 2097: @112803
     /* 112803 */ GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(113054),
     /* 112808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112811 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 112814 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 112817 */   GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(112886), // Rule ID 4012 //
     /* 112822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112856 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m1), MQPR:{ *:[v8f16] }:$m2, MQPR:{ *:[v8f16] }:$add)  =>  (MVE_VFMSf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$add, ?:{ *:[v8f16] }:$m1, ?:{ *:[v8f16] }:$m2)
     /* 112856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf16),
     /* 112859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112861 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112867 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112872 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112878 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112884 */     GIR_RootConstrainSelectedInstOperands,
     /* 112885 */     // GIR_Coverage, 4012,
     /* 112885 */     GIR_EraseRootFromParent_Done,
     /* 112886 */   // Label 2133: @112886
     /* 112886 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(112955), // Rule ID 6040 //
     /* 112891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112925 */     // (fma:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m2, (fneg:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m1), MQPR:{ *:[v8f16] }:$add)  =>  (MVE_VFMSf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$add, ?:{ *:[v8f16] }:$m1, ?:{ *:[v8f16] }:$m2)
     /* 112925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf16),
     /* 112928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112930 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112936 */     GIR_RootToRootCopy, /*OpIdx*/1, // m2
     /* 112938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112941 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112947 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112953 */     GIR_RootConstrainSelectedInstOperands,
     /* 112954 */     // GIR_Coverage, 6040,
     /* 112954 */     GIR_EraseRootFromParent_Done,
     /* 112955 */   // Label 2134: @112955
     /* 112955 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(113001), // Rule ID 2500 //
     /* 112960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 112963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112979 */     // (fma:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm, QPR:{ *:[v8f16] }:$src1)  =>  (VFMAhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 112979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhq),
     /* 112982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112984 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112986 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112993 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112999 */     GIR_RootConstrainSelectedInstOperands,
     /* 113000 */     // GIR_Coverage, 2500,
     /* 113000 */     GIR_EraseRootFromParent_Done,
     /* 113001 */   // Label 2135: @113001
     /* 113001 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(113053), // Rule ID 4009 //
     /* 113006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 113009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 113013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 113017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 113021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 113025 */     // (fma:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m1, MQPR:{ *:[v8f16] }:$m2, MQPR:{ *:[v8f16] }:$add)  =>  (MVE_VFMAf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$add, ?:{ *:[v8f16] }:$m1, ?:{ *:[v8f16] }:$m2)
     /* 113025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMAf16),
     /* 113028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 113030 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 113032 */     GIR_RootToRootCopy, /*OpIdx*/1, // m1
     /* 113034 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 113036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113039 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113045 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113051 */     GIR_RootConstrainSelectedInstOperands,
     /* 113052 */     // GIR_Coverage, 4009,
     /* 113052 */     GIR_EraseRootFromParent_Done,
     /* 113053 */   // Label 2136: @113053
     /* 113053 */   GIM_Reject,
     /* 113054 */ // Label 2132: @113054
     /* 113054 */ GIM_Reject,
     /* 113055 */ // Label 2098: @113055
     /* 113055 */ GIM_Reject,
     /* 113056 */ // Label 38: @113056
     /* 113056 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2140*/ GIMT_Encode4(113220),
     /* 113067 */ /*GILLT_s16*//*Label 2137*/ GIMT_Encode4(113079),
     /* 113071 */ /*GILLT_s32*//*Label 2138*/ GIMT_Encode4(113126),
     /* 113075 */ /*GILLT_s64*//*Label 2139*/ GIMT_Encode4(113173),
     /* 113079 */ // Label 2137: @113079
     /* 113079 */ GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(113125), // Rule ID 620 //
     /* 113084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 113090 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 113093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113097 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113101 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113105 */   // (fdiv:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VDIVH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113105 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VDIVH),
     /* 113108 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113110 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 113112 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 113114 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113117 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113123 */   GIR_RootConstrainSelectedInstOperands,
     /* 113124 */   // GIR_Coverage, 620,
     /* 113124 */   GIR_EraseRootFromParent_Done,
     /* 113125 */ // Label 2141: @113125
     /* 113125 */ GIM_Reject,
     /* 113126 */ // Label 2138: @113126
     /* 113126 */ GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(113172), // Rule ID 619 //
     /* 113131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP2),
     /* 113134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 113137 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 113140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113148 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113152 */   // (fdiv:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VDIVS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113152 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VDIVS),
     /* 113155 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113157 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 113159 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 113161 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113164 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113170 */   GIR_RootConstrainSelectedInstOperands,
     /* 113171 */   // GIR_Coverage, 619,
     /* 113171 */   GIR_EraseRootFromParent_Done,
     /* 113172 */ // Label 2142: @113172
     /* 113172 */ GIM_Reject,
     /* 113173 */ // Label 2139: @113173
     /* 113173 */ GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(113219), // Rule ID 618 //
     /* 113178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 113181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 113187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113195 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113199 */   // (fdiv:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VDIVD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 113199 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VDIVD),
     /* 113202 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 113204 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 113206 */   GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 113208 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113211 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113217 */   GIR_RootConstrainSelectedInstOperands,
     /* 113218 */   // GIR_Coverage, 618,
     /* 113218 */   GIR_EraseRootFromParent_Done,
     /* 113219 */ // Label 2143: @113219
     /* 113219 */ GIM_Reject,
     /* 113220 */ // Label 2140: @113220
     /* 113220 */ GIM_Reject,
     /* 113221 */ // Label 39: @113221
     /* 113221 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2151*/ GIMT_Encode4(114751),
     /* 113232 */ /*GILLT_s16*//*Label 2144*/ GIMT_Encode4(113284),
     /* 113236 */ /*GILLT_s32*//*Label 2145*/ GIMT_Encode4(113631),
     /* 113240 */ /*GILLT_s64*//*Label 2146*/ GIMT_Encode4(114130), GIMT_Encode4(0),
     /* 113248 */ /*GILLT_v2s32*//*Label 2147*/ GIMT_Encode4(114477), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 113260 */ /*GILLT_v4s16*//*Label 2148*/ GIMT_Encode4(114515),
     /* 113264 */ /*GILLT_v4s32*//*Label 2149*/ GIMT_Encode4(114553), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 113280 */ /*GILLT_v8s16*//*Label 2150*/ GIMT_Encode4(114652),
     /* 113284 */ // Label 2144: @113284
     /* 113284 */ GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(113630),
     /* 113289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 113292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113296 */   GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(113381), // Rule ID 2414 //
     /* 113301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113320 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 113324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 113328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 113336 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113351 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113353 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin))  =>  (VFNMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSH),
     /* 113356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113373 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113379 */     GIR_RootConstrainSelectedInstOperands,
     /* 113380 */     // GIR_Coverage, 2414,
     /* 113380 */     GIR_EraseRootFromParent_Done,
     /* 113381 */   // Label 2153: @113381
     /* 113381 */   GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(113466), // Rule ID 5722 //
     /* 113386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113405 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 113409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 113418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 113426 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113436 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113438 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sdin))  =>  (VFNMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSH),
     /* 113441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sm
     /* 113455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113458 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113464 */     GIR_RootConstrainSelectedInstOperands,
     /* 113465 */     // GIR_Coverage, 5722,
     /* 113465 */     GIR_EraseRootFromParent_Done,
     /* 113466 */   // Label 2154: @113466
     /* 113466 */   GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(113539), // Rule ID 2403 //
     /* 113471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113490 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 113494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113511 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin))  =>  (VFNMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAH),
     /* 113514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113531 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113537 */     GIR_RootConstrainSelectedInstOperands,
     /* 113538 */     // GIR_Coverage, 2403,
     /* 113538 */     GIR_EraseRootFromParent_Done,
     /* 113539 */   // Label 2155: @113539
     /* 113539 */   GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(113599), // Rule ID 626 //
     /* 113544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 113555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113559 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113575 */     // (fneg:{ *:[f16] } (fmul:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm))  =>  (VNMULH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULH),
     /* 113578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113591 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113597 */     GIR_RootConstrainSelectedInstOperands,
     /* 113598 */     // GIR_Coverage, 626,
     /* 113598 */     GIR_EraseRootFromParent_Done,
     /* 113599 */   // Label 2156: @113599
     /* 113599 */   GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(113629), // Rule ID 664 //
     /* 113604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113611 */     // (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VNEGH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 113611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGH),
     /* 113614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113616 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 113618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113621 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113627 */     GIR_RootConstrainSelectedInstOperands,
     /* 113628 */     // GIR_Coverage, 664,
     /* 113628 */     GIR_EraseRootFromParent_Done,
     /* 113629 */   // Label 2157: @113629
     /* 113629 */   GIM_Reject,
     /* 113630 */ // Label 2152: @113630
     /* 113630 */ GIM_Reject,
     /* 113631 */ // Label 2145: @113631
     /* 113631 */ GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(114129),
     /* 113636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 113639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113643 */   GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(113728), // Rule ID 2413 //
     /* 113648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 113651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113667 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 113675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 113683 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113698 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113700 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin))  =>  (VFNMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSS),
     /* 113703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113720 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113726 */     GIR_RootConstrainSelectedInstOperands,
     /* 113727 */     // GIR_Coverage, 2413,
     /* 113727 */     GIR_EraseRootFromParent_Done,
     /* 113728 */   // Label 2159: @113728
     /* 113728 */   GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(113813), // Rule ID 5721 //
     /* 113733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 113736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113752 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 113765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 113773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113778 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113783 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113785 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sdin))  =>  (VFNMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSS),
     /* 113788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sm
     /* 113802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113805 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113811 */     GIR_RootConstrainSelectedInstOperands,
     /* 113812 */     // GIR_Coverage, 5721,
     /* 113812 */     GIR_EraseRootFromParent_Done,
     /* 113813 */   // Label 2160: @113813
     /* 113813 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(113886), // Rule ID 2402 //
     /* 113818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 113821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113833 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113837 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113846 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113858 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin))  =>  (VFNMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAS),
     /* 113861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113878 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113884 */     GIR_RootConstrainSelectedInstOperands,
     /* 113885 */     // GIR_Coverage, 2402,
     /* 113885 */     GIR_EraseRootFromParent_Done,
     /* 113886 */   // Label 2161: @113886
     /* 113886 */   GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(113946), // Rule ID 625 //
     /* 113891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP2),
     /* 113894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 113902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113922 */     // (fneg:{ *:[f32] } (fmul:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm))  =>  (VNMULS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULS),
     /* 113925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113938 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113944 */     GIR_RootConstrainSelectedInstOperands,
     /* 113945 */     // GIR_Coverage, 625,
     /* 113945 */     GIR_EraseRootFromParent_Done,
     /* 113946 */   // Label 2162: @113946
     /* 113946 */   GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(113976), // Rule ID 663 //
     /* 113951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 113954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113958 */     // (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VNEGS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 113958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGS),
     /* 113961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113963 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 113965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113968 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113974 */     GIR_RootConstrainSelectedInstOperands,
     /* 113975 */     // GIR_Coverage, 663,
     /* 113975 */     GIR_EraseRootFromParent_Done,
     /* 113976 */   // Label 2163: @113976
     /* 113976 */   GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(114128), // Rule ID 2705 //
     /* 113981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 113984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113988 */     // (fneg:{ *:[f32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VNEGfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 113988 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 113991 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 113995 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 114002 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 114005 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114009 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114014 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 114017 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 114022 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 114025 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 114029 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114034 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 114037 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 114041 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 114044 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 114049 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 114054 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 114059 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 114062 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VNEGfd),
     /* 114066 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114071 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 114074 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 114077 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 114088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114097 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 114100 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 114105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114110 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 114117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 114122 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 114127 */     // GIR_Coverage, 2705,
     /* 114127 */     GIR_EraseRootFromParent_Done,
     /* 114128 */   // Label 2164: @114128
     /* 114128 */   GIM_Reject,
     /* 114129 */ // Label 2158: @114129
     /* 114129 */ GIM_Reject,
     /* 114130 */ // Label 2146: @114130
     /* 114130 */ GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(114476),
     /* 114135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 114138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114142 */   GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(114227), // Rule ID 2412 //
     /* 114147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 114150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 114158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114162 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114166 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 114174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 114178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 114182 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114199 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin))  =>  (VFNMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 114199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSD),
     /* 114202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ddin
     /* 114208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Dn
     /* 114212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Dm
     /* 114216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114219 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114225 */     GIR_RootConstrainSelectedInstOperands,
     /* 114226 */     // GIR_Coverage, 2412,
     /* 114226 */     GIR_EraseRootFromParent_Done,
     /* 114227 */   // Label 2166: @114227
     /* 114227 */   GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(114312), // Rule ID 5720 //
     /* 114232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 114235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 114243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114251 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 114268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 114272 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114282 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114284 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Ddin))  =>  (VFNMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 114284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSD),
     /* 114287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ddin
     /* 114293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Dn
     /* 114297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dm
     /* 114301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114310 */     GIR_RootConstrainSelectedInstOperands,
     /* 114311 */     // GIR_Coverage, 5720,
     /* 114311 */     GIR_EraseRootFromParent_Done,
     /* 114312 */   // Label 2167: @114312
     /* 114312 */   GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(114385), // Rule ID 2401 //
     /* 114317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 114320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 114328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114336 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114350 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114357 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin))  =>  (VFNMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 114357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAD),
     /* 114360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ddin
     /* 114366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 114370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Dm
     /* 114374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114377 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114383 */     GIR_RootConstrainSelectedInstOperands,
     /* 114384 */     // GIR_Coverage, 2401,
     /* 114384 */     GIR_EraseRootFromParent_Done,
     /* 114385 */   // Label 2168: @114385
     /* 114385 */   GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(114445), // Rule ID 624 //
     /* 114390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 114393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 114401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114421 */     // (fneg:{ *:[f64] } (fmul:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm))  =>  (VNMULD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 114421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULD),
     /* 114424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 114430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Dm
     /* 114434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114437 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114443 */     GIR_RootConstrainSelectedInstOperands,
     /* 114444 */     // GIR_Coverage, 624,
     /* 114444 */     GIR_EraseRootFromParent_Done,
     /* 114445 */   // Label 2169: @114445
     /* 114445 */   GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(114475), // Rule ID 662 //
     /* 114450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 114453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114457 */     // (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VNEGD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 114457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGD),
     /* 114460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114462 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 114464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114467 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114473 */     GIR_RootConstrainSelectedInstOperands,
     /* 114474 */     // GIR_Coverage, 662,
     /* 114474 */     GIR_EraseRootFromParent_Done,
     /* 114475 */   // Label 2170: @114475
     /* 114475 */   GIM_Reject,
     /* 114476 */ // Label 2165: @114476
     /* 114476 */ GIM_Reject,
     /* 114477 */ // Label 2147: @114477
     /* 114477 */ GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(114514), // Rule ID 1530 //
     /* 114482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 114485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 114488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114496 */   // (fneg:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VNEGfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /* 114496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGfd),
     /* 114499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114501 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114503 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114506 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114512 */   GIR_RootConstrainSelectedInstOperands,
     /* 114513 */   // GIR_Coverage, 1530,
     /* 114513 */   GIR_EraseRootFromParent_Done,
     /* 114514 */ // Label 2171: @114514
     /* 114514 */ GIM_Reject,
     /* 114515 */ // Label 2148: @114515
     /* 114515 */ GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(114552), // Rule ID 1532 //
     /* 114520 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 114523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 114526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114530 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114534 */   // (fneg:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VNEGhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /* 114534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGhd),
     /* 114537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114539 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114544 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114550 */   GIR_RootConstrainSelectedInstOperands,
     /* 114551 */   // GIR_Coverage, 1532,
     /* 114551 */   GIR_EraseRootFromParent_Done,
     /* 114552 */ // Label 2172: @114552
     /* 114552 */ GIM_Reject,
     /* 114553 */ // Label 2149: @114553
     /* 114553 */ GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(114651),
     /* 114558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114561 */   GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(114595), // Rule ID 1531 //
     /* 114566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 114569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114577 */     // (fneg:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VNEGf32q:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /* 114577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGf32q),
     /* 114580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114582 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114587 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114593 */     GIR_RootConstrainSelectedInstOperands,
     /* 114594 */     // GIR_Coverage, 1531,
     /* 114594 */     GIR_EraseRootFromParent_Done,
     /* 114595 */   // Label 2174: @114595
     /* 114595 */   GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(114650), // Rule ID 4116 //
     /* 114600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 114603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114611 */     // (fneg:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$v)  =>  (MVE_VNEGf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$v)
     /* 114611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 114614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 114618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VNEGf32),
     /* 114626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 114628 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 114630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114633 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114639 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114648 */     GIR_RootConstrainSelectedInstOperands,
     /* 114649 */     // GIR_Coverage, 4116,
     /* 114649 */     GIR_EraseRootFromParent_Done,
     /* 114650 */   // Label 2175: @114650
     /* 114650 */   GIM_Reject,
     /* 114651 */ // Label 2173: @114651
     /* 114651 */ GIM_Reject,
     /* 114652 */ // Label 2150: @114652
     /* 114652 */ GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(114750),
     /* 114657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114660 */   GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(114694), // Rule ID 1533 //
     /* 114665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 114668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114676 */     // (fneg:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VNEGhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /* 114676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGhq),
     /* 114679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114681 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114686 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114692 */     GIR_RootConstrainSelectedInstOperands,
     /* 114693 */     // GIR_Coverage, 1533,
     /* 114693 */     GIR_EraseRootFromParent_Done,
     /* 114694 */   // Label 2177: @114694
     /* 114694 */   GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(114749), // Rule ID 4114 //
     /* 114699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 114702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114710 */     // (fneg:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$v)  =>  (MVE_VNEGf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$v)
     /* 114710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 114713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 114717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VNEGf16),
     /* 114725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 114727 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 114729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114732 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114738 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114747 */     GIR_RootConstrainSelectedInstOperands,
     /* 114748 */     // GIR_Coverage, 4114,
     /* 114748 */     GIR_EraseRootFromParent_Done,
     /* 114749 */   // Label 2178: @114749
     /* 114749 */   GIM_Reject,
     /* 114750 */ // Label 2176: @114750
     /* 114750 */ GIM_Reject,
     /* 114751 */ // Label 2151: @114751
     /* 114751 */ GIM_Reject,
     /* 114752 */ // Label 40: @114752
     /* 114752 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 2182*/ GIMT_Encode4(114987),
     /* 114763 */ /*GILLT_s32*//*Label 2179*/ GIMT_Encode4(114795),
     /* 114767 */ /*GILLT_s64*//*Label 2180*/ GIMT_Encode4(114855), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 114791 */ /*GILLT_v4s32*//*Label 2181*/ GIMT_Encode4(114952),
     /* 114795 */ // Label 2179: @114795
     /* 114795 */ GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(114854), // Rule ID 2303 //
     /* 114800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 114803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 114814 */   // (fpextend:{ *:[f32] } HPR:{ *:[f16] }:$Sm)  =>  (VCVTBHS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } HPR:{ *:[f16] }:$Sm, SPR:{ *:[i32] }))
     /* 114814 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114817 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114821 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114826 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Sm
     /* 114830 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 114835 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTBHS),
     /* 114838 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 114840 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114843 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114846 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114852 */   GIR_RootConstrainSelectedInstOperands,
     /* 114853 */   // GIR_Coverage, 2303,
     /* 114853 */   GIR_EraseRootFromParent_Done,
     /* 114854 */ // Label 2183: @114854
     /* 114854 */ GIM_Reject,
     /* 114855 */ // Label 2180: @114855
     /* 114855 */ GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(114892), // Rule ID 660 //
     /* 114860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 114863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 114866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114874 */   // (fpextend:{ *:[f64] } SPR:{ *:[f32] }:$Sm)  =>  (VCVTDS:{ *:[f64] } SPR:{ *:[f32] }:$Sm)
     /* 114874 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTDS),
     /* 114877 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114879 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 114881 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114884 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114890 */   GIR_RootConstrainSelectedInstOperands,
     /* 114891 */   // GIR_Coverage, 660,
     /* 114891 */   GIR_EraseRootFromParent_Done,
     /* 114892 */ // Label 2184: @114892
     /* 114892 */ GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(114951), // Rule ID 2313 //
     /* 114897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 114900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 114911 */   // (fpextend:{ *:[f64] } HPR:{ *:[f16] }:$Sm)  =>  (VCVTBHD:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f32] } HPR:{ *:[f16] }:$Sm, SPR:{ *:[i32] }))
     /* 114911 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114914 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114918 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114923 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Sm
     /* 114927 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 114932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTBHD),
     /* 114935 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114937 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114940 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114943 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114949 */   GIR_RootConstrainSelectedInstOperands,
     /* 114950 */   // GIR_Coverage, 2313,
     /* 114950 */   GIR_EraseRootFromParent_Done,
     /* 114951 */ // Label 2185: @114951
     /* 114951 */ GIM_Reject,
     /* 114952 */ // Label 2181: @114952
     /* 114952 */ GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(114986), // Rule ID 2670 //
     /* 114957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 114960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114968 */   // (fpextend:{ *:[v4f32] } DPR:{ *:[v4f16] }:$src)  =>  (VCVTh2f:{ *:[v4f32] } DPR:{ *:[v4f16] }:$src)
     /* 114968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2f),
     /* 114971 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114973 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114975 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114978 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114984 */   GIR_RootConstrainSelectedInstOperands,
     /* 114985 */   // GIR_Coverage, 2670,
     /* 114985 */   GIR_EraseRootFromParent_Done,
     /* 114986 */ // Label 2186: @114986
     /* 114986 */ GIM_Reject,
     /* 114987 */ // Label 2182: @114987
     /* 114987 */ GIM_Reject,
     /* 114988 */ // Label 41: @114988
     /* 114988 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(8), /*)*//*default:*//*Label 2190*/ GIMT_Encode4(115259),
     /* 114999 */ /*GILLT_s16*//*Label 2187*/ GIMT_Encode4(115031),
     /* 115003 */ /*GILLT_s32*//*Label 2188*/ GIMT_Encode4(115186), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 115027 */ /*GILLT_v4s16*//*Label 2189*/ GIMT_Encode4(115224),
     /* 115031 */ // Label 2187: @115031
     /* 115031 */ GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(115108), // Rule ID 2305 //
     /* 115036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 115039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115046 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115050 */   // (fpround:{ *:[f16] } SPR:{ *:[f32] }:$Sm)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VCVTBSH:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), SPR:{ *:[f32] }:$Sm), HPR:{ *:[i32] })
     /* 115050 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115053 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 115057 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115062 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115064 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115067 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTBSH),
     /* 115071 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115076 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 115079 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Sm
     /* 115083 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 115086 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115092 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115097 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115099 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115102 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /* 115107 */   // GIR_Coverage, 2305,
     /* 115107 */   GIR_EraseRootFromParent_Done,
     /* 115108 */ // Label 2191: @115108
     /* 115108 */ GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(115185), // Rule ID 2315 //
     /* 115113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115127 */   // (fpround:{ *:[f16] } DPR:{ *:[f64] }:$Dm)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VCVTBDH:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), DPR:{ *:[f64] }:$Dm), HPR:{ *:[i32] })
     /* 115127 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115130 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 115134 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115139 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115141 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115144 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTBDH),
     /* 115148 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115153 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 115156 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Dm
     /* 115160 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 115163 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115169 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115174 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115176 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115179 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /* 115184 */   // GIR_Coverage, 2315,
     /* 115184 */   GIR_EraseRootFromParent_Done,
     /* 115185 */ // Label 2192: @115185
     /* 115185 */ GIM_Reject,
     /* 115186 */ // Label 2188: @115186
     /* 115186 */ GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(115223), // Rule ID 661 //
     /* 115191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 115194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115201 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115205 */   // (fpround:{ *:[f32] } DPR:{ *:[f64] }:$Dm)  =>  (VCVTSD:{ *:[f32] } DPR:{ *:[f64] }:$Dm)
     /* 115205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTSD),
     /* 115208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 115210 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 115212 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 115215 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115221 */   GIR_RootConstrainSelectedInstOperands,
     /* 115222 */   // GIR_Coverage, 661,
     /* 115222 */   GIR_EraseRootFromParent_Done,
     /* 115223 */ // Label 2193: @115223
     /* 115223 */ GIM_Reject,
     /* 115224 */ // Label 2189: @115224
     /* 115224 */ GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(115258), // Rule ID 2669 //
     /* 115229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 115240 */   // (fpround:{ *:[v4f16] } QPR:{ *:[v4f32] }:$src)  =>  (VCVTf2h:{ *:[v4f16] } QPR:{ *:[v4f32] }:$src)
     /* 115240 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2h),
     /* 115243 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 115245 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115247 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 115250 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115256 */   GIR_RootConstrainSelectedInstOperands,
     /* 115257 */   // GIR_Coverage, 2669,
     /* 115257 */   GIR_EraseRootFromParent_Done,
     /* 115258 */ // Label 2194: @115258
     /* 115258 */ GIM_Reject,
     /* 115259 */ // Label 2190: @115259
     /* 115259 */ GIM_Reject,
     /* 115260 */ // Label 42: @115260
     /* 115260 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 2202*/ GIMT_Encode4(116593),
     /* 115271 */ /*GILLT_s32*//*Label 2195*/ GIMT_Encode4(115319), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 115283 */ /*GILLT_v2s32*//*Label 2196*/ GIMT_Encode4(116213), GIMT_Encode4(0),
     /* 115291 */ /*GILLT_v4s1*//*Label 2197*/ GIMT_Encode4(116251),
     /* 115295 */ /*GILLT_v4s16*//*Label 2198*/ GIMT_Encode4(116304),
     /* 115299 */ /*GILLT_v4s32*//*Label 2199*/ GIMT_Encode4(116342), GIMT_Encode4(0),
     /* 115307 */ /*GILLT_v8s1*//*Label 2200*/ GIMT_Encode4(116441), GIMT_Encode4(0),
     /* 115315 */ /*GILLT_v8s16*//*Label 2201*/ GIMT_Encode4(116494),
     /* 115319 */ // Label 2195: @115319
     /* 115319 */ GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(115385), // Rule ID 2323 //
     /* 115324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115334 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115338 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 115342 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 115346 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115351 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115353 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPSH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 115353 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115356 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPSH),
     /* 115360 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115365 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115369 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115374 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115376 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115379 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115384 */   // GIR_Coverage, 2323,
     /* 115384 */   GIR_EraseRootFromParent_Done,
     /* 115385 */ // Label 2203: @115385
     /* 115385 */ GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(115451), // Rule ID 2325 //
     /* 115390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115400 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115404 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 115408 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 115412 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115417 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115419 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPSS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115419 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115422 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPSS),
     /* 115426 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115431 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115435 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115440 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115442 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115445 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115450 */   // GIR_Coverage, 2325,
     /* 115450 */   GIR_EraseRootFromParent_Done,
     /* 115451 */ // Label 2204: @115451
     /* 115451 */ GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(115517), // Rule ID 2327 //
     /* 115456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115466 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115470 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 115474 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 115478 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115483 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115485 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPSD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115485 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115488 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPSD),
     /* 115492 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115497 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115501 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115503 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115506 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115508 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115511 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115516 */   // GIR_Coverage, 2327,
     /* 115516 */   GIR_EraseRootFromParent_Done,
     /* 115517 */ // Label 2205: @115517
     /* 115517 */ GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(115583), // Rule ID 2329 //
     /* 115522 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115532 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115536 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 115540 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 115544 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115549 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115551 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMSH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 115551 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115554 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMSH),
     /* 115558 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115563 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115567 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115569 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115572 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115574 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115577 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115582 */   // GIR_Coverage, 2329,
     /* 115582 */   GIR_EraseRootFromParent_Done,
     /* 115583 */ // Label 2206: @115583
     /* 115583 */ GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(115649), // Rule ID 2331 //
     /* 115588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115598 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115602 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 115606 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 115610 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115615 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115617 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMSS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115617 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115620 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMSS),
     /* 115624 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115629 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115633 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115638 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115640 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115643 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115648 */   // GIR_Coverage, 2331,
     /* 115648 */   GIR_EraseRootFromParent_Done,
     /* 115649 */ // Label 2207: @115649
     /* 115649 */ GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(115715), // Rule ID 2333 //
     /* 115654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115664 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115668 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 115672 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 115676 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115681 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115683 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMSD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115683 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115686 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMSD),
     /* 115690 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115695 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115699 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115704 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115706 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115709 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115714 */   // GIR_Coverage, 2333,
     /* 115714 */   GIR_EraseRootFromParent_Done,
     /* 115715 */ // Label 2208: @115715
     /* 115715 */ GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(115781), // Rule ID 2317 //
     /* 115720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115730 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115734 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 115738 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 115742 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115747 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115749 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTASH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 115749 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115752 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTASH),
     /* 115756 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115761 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115765 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115767 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115770 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115772 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115775 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115780 */   // GIR_Coverage, 2317,
     /* 115780 */   GIR_EraseRootFromParent_Done,
     /* 115781 */ // Label 2209: @115781
     /* 115781 */ GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(115847), // Rule ID 2319 //
     /* 115786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115796 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115800 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 115804 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 115808 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115813 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115815 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTASS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115815 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115818 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTASS),
     /* 115822 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115827 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115831 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115838 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115841 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115846 */   // GIR_Coverage, 2319,
     /* 115846 */   GIR_EraseRootFromParent_Done,
     /* 115847 */ // Label 2210: @115847
     /* 115847 */ GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(115913), // Rule ID 2321 //
     /* 115852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115862 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115866 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 115870 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 115874 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115879 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115881 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTASD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115881 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115884 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTASD),
     /* 115888 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115893 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115897 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115899 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115902 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115904 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115907 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115912 */   // GIR_Coverage, 2321,
     /* 115912 */   GIR_EraseRootFromParent_Done,
     /* 115913 */ // Label 2211: @115913
     /* 115913 */ GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(115973), // Rule ID 2352 //
     /* 115918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 115921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115932 */   // (fp_to_sint:{ *:[i32] } DPR:{ *:[f64] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOSIZD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115932 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115935 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOSIZD),
     /* 115939 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115944 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 115948 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 115951 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115957 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115964 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115967 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115972 */   // GIR_Coverage, 2352,
     /* 115972 */   GIR_EraseRootFromParent_Done,
     /* 115973 */ // Label 2212: @115973
     /* 115973 */ GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(116033), // Rule ID 2356 //
     /* 115978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 115981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115992 */   // (fp_to_sint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOSIZS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115992 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115995 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOSIZS),
     /* 115999 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116004 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 116008 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 116011 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116017 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116024 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116027 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116032 */   // GIR_Coverage, 2356,
     /* 116032 */   GIR_EraseRootFromParent_Done,
     /* 116033 */ // Label 2213: @116033
     /* 116033 */ GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(116093), // Rule ID 2360 //
     /* 116038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 116041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 116052 */   // (fp_to_sint:{ *:[i32] } HPR:{ *:[f16] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOSIZH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 116052 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116055 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOSIZH),
     /* 116059 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116064 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 116068 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 116071 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116077 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116084 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116087 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116092 */   // GIR_Coverage, 2360,
     /* 116092 */   GIR_EraseRootFromParent_Done,
     /* 116093 */ // Label 2214: @116093
     /* 116093 */ GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(116212), // Rule ID 2710 //
     /* 116098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 116101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116108 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116112 */   // (fp_to_sint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[i32] } (VCVTf2sd:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 116112 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 116115 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116119 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116124 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116126 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 116129 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 116133 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116138 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 116141 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 116145 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 116148 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 116153 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 116158 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 116163 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 116166 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTf2sd),
     /* 116170 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116175 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 116178 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 116181 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116187 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116192 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116194 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 116201 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 116206 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 116211 */   // GIR_Coverage, 2710,
     /* 116211 */   GIR_EraseRootFromParent_Done,
     /* 116212 */ // Label 2215: @116212
     /* 116212 */ GIM_Reject,
     /* 116213 */ // Label 2196: @116213
     /* 116213 */ GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(116250), // Rule ID 1604 //
     /* 116218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 116224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116232 */   // (fp_to_sint:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTf2sd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /* 116232 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2sd),
     /* 116235 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116237 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116239 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116242 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116248 */   GIR_RootConstrainSelectedInstOperands,
     /* 116249 */   // GIR_Coverage, 1604,
     /* 116249 */   GIR_EraseRootFromParent_Done,
     /* 116250 */ // Label 2216: @116250
     /* 116250 */ GIM_Reject,
     /* 116251 */ // Label 2197: @116251
     /* 116251 */ GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(116303), // Rule ID 5105 //
     /* 116256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 116262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 116266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116270 */   // (fp_to_sint:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1)  =>  (MVE_VCMPf32r:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 116270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf32r),
     /* 116273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 116275 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 116277 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116283 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 116286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116289 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116295 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116301 */   GIR_RootConstrainSelectedInstOperands,
     /* 116302 */   // GIR_Coverage, 5105,
     /* 116302 */   GIR_EraseRootFromParent_Done,
     /* 116303 */ // Label 2217: @116303
     /* 116303 */ GIM_Reject,
     /* 116304 */ // Label 2198: @116304
     /* 116304 */ GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(116341), // Rule ID 1612 //
     /* 116309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 116315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116323 */   // (fp_to_sint:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTh2sd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /* 116323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2sd),
     /* 116326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116328 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116333 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116339 */   GIR_RootConstrainSelectedInstOperands,
     /* 116340 */   // GIR_Coverage, 1612,
     /* 116340 */   GIR_EraseRootFromParent_Done,
     /* 116341 */ // Label 2218: @116341
     /* 116341 */ GIM_Reject,
     /* 116342 */ // Label 2199: @116342
     /* 116342 */ GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(116440),
     /* 116347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 116350 */   GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(116384), // Rule ID 1608 //
     /* 116355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116366 */     // (fp_to_sint:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTf2sq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /* 116366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2sq),
     /* 116369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116371 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116376 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116382 */     GIR_RootConstrainSelectedInstOperands,
     /* 116383 */     // GIR_Coverage, 1608,
     /* 116383 */     GIR_EraseRootFromParent_Done,
     /* 116384 */   // Label 2220: @116384
     /* 116384 */   GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(116439), // Rule ID 4094 //
     /* 116389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116400 */     // (fp_to_sint:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VCVTs32f32z:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)
     /* 116400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 116403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32z),
     /* 116415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 116417 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116422 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116428 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116437 */     GIR_RootConstrainSelectedInstOperands,
     /* 116438 */     // GIR_Coverage, 4094,
     /* 116438 */     GIR_EraseRootFromParent_Done,
     /* 116439 */   // Label 2221: @116439
     /* 116439 */   GIM_Reject,
     /* 116440 */ // Label 2219: @116440
     /* 116440 */ GIM_Reject,
     /* 116441 */ // Label 2200: @116441
     /* 116441 */ GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(116493), // Rule ID 5106 //
     /* 116446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 116452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 116456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116460 */   // (fp_to_sint:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1)  =>  (MVE_VCMPf16r:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 116460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf16r),
     /* 116463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 116465 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 116467 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 116476 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116479 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116485 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116491 */   GIR_RootConstrainSelectedInstOperands,
     /* 116492 */   // GIR_Coverage, 5106,
     /* 116492 */   GIR_EraseRootFromParent_Done,
     /* 116493 */ // Label 2222: @116493
     /* 116493 */ GIM_Reject,
     /* 116494 */ // Label 2201: @116494
     /* 116494 */ GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(116592),
     /* 116499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 116502 */   GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(116536), // Rule ID 1616 //
     /* 116507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116518 */     // (fp_to_sint:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTh2sq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /* 116518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2sq),
     /* 116521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116523 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116528 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116534 */     GIR_RootConstrainSelectedInstOperands,
     /* 116535 */     // GIR_Coverage, 1616,
     /* 116535 */     GIR_EraseRootFromParent_Done,
     /* 116536 */   // Label 2224: @116536
     /* 116536 */   GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(116591), // Rule ID 4090 //
     /* 116541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116552 */     // (fp_to_sint:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VCVTs16f16z:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)
     /* 116552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 116555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16z),
     /* 116567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 116569 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116574 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116580 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116589 */     GIR_RootConstrainSelectedInstOperands,
     /* 116590 */     // GIR_Coverage, 4090,
     /* 116590 */     GIR_EraseRootFromParent_Done,
     /* 116591 */   // Label 2225: @116591
     /* 116591 */   GIM_Reject,
     /* 116592 */ // Label 2223: @116592
     /* 116592 */ GIM_Reject,
     /* 116593 */ // Label 2202: @116593
     /* 116593 */ GIM_Reject,
     /* 116594 */ // Label 43: @116594
     /* 116594 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 2233*/ GIMT_Encode4(117927),
     /* 116605 */ /*GILLT_s32*//*Label 2226*/ GIMT_Encode4(116653), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 116617 */ /*GILLT_v2s32*//*Label 2227*/ GIMT_Encode4(117547), GIMT_Encode4(0),
     /* 116625 */ /*GILLT_v4s1*//*Label 2228*/ GIMT_Encode4(117585),
     /* 116629 */ /*GILLT_v4s16*//*Label 2229*/ GIMT_Encode4(117638),
     /* 116633 */ /*GILLT_v4s32*//*Label 2230*/ GIMT_Encode4(117676), GIMT_Encode4(0),
     /* 116641 */ /*GILLT_v8s1*//*Label 2231*/ GIMT_Encode4(117775), GIMT_Encode4(0),
     /* 116649 */ /*GILLT_v8s16*//*Label 2232*/ GIMT_Encode4(117828),
     /* 116653 */ // Label 2226: @116653
     /* 116653 */ GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(116719), // Rule ID 2324 //
     /* 116658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116668 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116672 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 116676 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 116680 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 116685 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116687 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPUH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 116687 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116690 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPUH),
     /* 116694 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116699 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116703 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116708 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116710 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116713 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116718 */   // GIR_Coverage, 2324,
     /* 116718 */   GIR_EraseRootFromParent_Done,
     /* 116719 */ // Label 2234: @116719
     /* 116719 */ GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(116785), // Rule ID 2326 //
     /* 116724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116734 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116738 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 116742 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116746 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116751 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116753 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPUS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 116753 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116756 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPUS),
     /* 116760 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116765 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116769 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116774 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116776 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116779 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116784 */   // GIR_Coverage, 2326,
     /* 116784 */   GIR_EraseRootFromParent_Done,
     /* 116785 */ // Label 2235: @116785
     /* 116785 */ GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(116851), // Rule ID 2328 //
     /* 116790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 116793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116800 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116804 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 116808 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116812 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116817 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116819 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPUD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 116819 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116822 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPUD),
     /* 116826 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116831 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116835 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116840 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116842 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116845 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116850 */   // GIR_Coverage, 2328,
     /* 116850 */   GIR_EraseRootFromParent_Done,
     /* 116851 */ // Label 2236: @116851
     /* 116851 */ GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(116917), // Rule ID 2330 //
     /* 116856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116866 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116870 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 116874 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 116878 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 116883 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116885 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMUH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 116885 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116888 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMUH),
     /* 116892 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116897 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116901 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116908 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116911 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116916 */   // GIR_Coverage, 2330,
     /* 116916 */   GIR_EraseRootFromParent_Done,
     /* 116917 */ // Label 2237: @116917
     /* 116917 */ GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(116983), // Rule ID 2332 //
     /* 116922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116932 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116936 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 116940 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116944 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116949 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116951 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMUS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 116951 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116954 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMUS),
     /* 116958 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116963 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116967 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116972 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116974 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116977 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116982 */   // GIR_Coverage, 2332,
     /* 116982 */   GIR_EraseRootFromParent_Done,
     /* 116983 */ // Label 2238: @116983
     /* 116983 */ GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(117049), // Rule ID 2334 //
     /* 116988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 116991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116998 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117002 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 117006 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 117010 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117015 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117017 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMUD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 117017 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117020 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMUD),
     /* 117024 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117029 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 117033 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117038 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117040 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117043 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117048 */   // GIR_Coverage, 2334,
     /* 117048 */   GIR_EraseRootFromParent_Done,
     /* 117049 */ // Label 2239: @117049
     /* 117049 */ GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(117115), // Rule ID 2318 //
     /* 117054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 117057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 117060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117064 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117068 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 117072 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 117076 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 117081 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117083 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTAUH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 117083 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117086 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTAUH),
     /* 117090 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117095 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 117099 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117104 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117106 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117109 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117114 */   // GIR_Coverage, 2318,
     /* 117114 */   GIR_EraseRootFromParent_Done,
     /* 117115 */ // Label 2240: @117115
     /* 117115 */ GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(117181), // Rule ID 2320 //
     /* 117120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117130 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117134 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 117138 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 117142 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117147 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117149 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTAUS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 117149 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117152 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTAUS),
     /* 117156 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117161 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 117165 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117170 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117172 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117175 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117180 */   // GIR_Coverage, 2320,
     /* 117180 */   GIR_EraseRootFromParent_Done,
     /* 117181 */ // Label 2241: @117181
     /* 117181 */ GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(117247), // Rule ID 2322 //
     /* 117186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 117189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117196 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117200 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 117204 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 117208 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117213 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117215 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTAUD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 117215 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117218 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTAUD),
     /* 117222 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117227 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 117231 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117238 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117241 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117246 */   // GIR_Coverage, 2322,
     /* 117246 */   GIR_EraseRootFromParent_Done,
     /* 117247 */ // Label 2242: @117247
     /* 117247 */ GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(117307), // Rule ID 2362 //
     /* 117252 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 117255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117266 */   // (fp_to_uint:{ *:[i32] } DPR:{ *:[f64] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOUIZD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 117266 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117269 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOUIZD),
     /* 117273 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117278 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117282 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117285 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117291 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117296 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117298 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117301 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117306 */   // GIR_Coverage, 2362,
     /* 117306 */   GIR_EraseRootFromParent_Done,
     /* 117307 */ // Label 2243: @117307
     /* 117307 */ GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(117367), // Rule ID 2366 //
     /* 117312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 117315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117326 */   // (fp_to_uint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOUIZS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 117326 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117329 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOUIZS),
     /* 117333 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117338 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117342 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117345 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117351 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117356 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117358 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117361 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117366 */   // GIR_Coverage, 2366,
     /* 117366 */   GIR_EraseRootFromParent_Done,
     /* 117367 */ // Label 2244: @117367
     /* 117367 */ GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(117427), // Rule ID 2370 //
     /* 117372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 117375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 117378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117382 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 117386 */   // (fp_to_uint:{ *:[i32] } HPR:{ *:[f16] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOUIZH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 117386 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117389 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOUIZH),
     /* 117393 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117398 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117402 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117405 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117411 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117416 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117418 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117421 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117426 */   // GIR_Coverage, 2370,
     /* 117426 */   GIR_EraseRootFromParent_Done,
     /* 117427 */ // Label 2245: @117427
     /* 117427 */ GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(117546), // Rule ID 2711 //
     /* 117432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 117435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117446 */   // (fp_to_uint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[i32] } (VCVTf2ud:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 117446 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 117449 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117453 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117458 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 117460 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 117463 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117467 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117472 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 117475 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117479 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 117482 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117487 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117492 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117497 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 117500 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTf2ud),
     /* 117504 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117509 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117512 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117515 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117521 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117528 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 117535 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117540 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117545 */   // GIR_Coverage, 2711,
     /* 117545 */   GIR_EraseRootFromParent_Done,
     /* 117546 */ // Label 2246: @117546
     /* 117546 */ GIM_Reject,
     /* 117547 */ // Label 2227: @117547
     /* 117547 */ GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(117584), // Rule ID 1605 //
     /* 117552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 117558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117566 */   // (fp_to_uint:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTf2ud:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /* 117566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2ud),
     /* 117569 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117571 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117573 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117576 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117582 */   GIR_RootConstrainSelectedInstOperands,
     /* 117583 */   // GIR_Coverage, 1605,
     /* 117583 */   GIR_EraseRootFromParent_Done,
     /* 117584 */ // Label 2247: @117584
     /* 117584 */ GIM_Reject,
     /* 117585 */ // Label 2228: @117585
     /* 117585 */ GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(117637), // Rule ID 5103 //
     /* 117590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 117596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 117600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117604 */   // (fp_to_uint:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1)  =>  (MVE_VCMPf32r:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 117604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf32r),
     /* 117607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 117609 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 117611 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117617 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 117620 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117623 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117629 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117635 */   GIR_RootConstrainSelectedInstOperands,
     /* 117636 */   // GIR_Coverage, 5103,
     /* 117636 */   GIR_EraseRootFromParent_Done,
     /* 117637 */ // Label 2248: @117637
     /* 117637 */ GIM_Reject,
     /* 117638 */ // Label 2229: @117638
     /* 117638 */ GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(117675), // Rule ID 1613 //
     /* 117643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 117646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 117649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117657 */   // (fp_to_uint:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTh2ud:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /* 117657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2ud),
     /* 117660 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117662 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117664 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117667 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117673 */   GIR_RootConstrainSelectedInstOperands,
     /* 117674 */   // GIR_Coverage, 1613,
     /* 117674 */   GIR_EraseRootFromParent_Done,
     /* 117675 */ // Label 2249: @117675
     /* 117675 */ GIM_Reject,
     /* 117676 */ // Label 2230: @117676
     /* 117676 */ GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(117774),
     /* 117681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 117684 */   GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(117718), // Rule ID 1609 //
     /* 117689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117700 */     // (fp_to_uint:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTf2uq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /* 117700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2uq),
     /* 117703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117705 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117710 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117716 */     GIR_RootConstrainSelectedInstOperands,
     /* 117717 */     // GIR_Coverage, 1609,
     /* 117717 */     GIR_EraseRootFromParent_Done,
     /* 117718 */   // Label 2251: @117718
     /* 117718 */   GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(117773), // Rule ID 4096 //
     /* 117723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117734 */     // (fp_to_uint:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VCVTu32f32z:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)
     /* 117734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 117737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32z),
     /* 117749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 117751 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 117753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117756 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117762 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117771 */     GIR_RootConstrainSelectedInstOperands,
     /* 117772 */     // GIR_Coverage, 4096,
     /* 117772 */     GIR_EraseRootFromParent_Done,
     /* 117773 */   // Label 2252: @117773
     /* 117773 */   GIM_Reject,
     /* 117774 */ // Label 2250: @117774
     /* 117774 */ GIM_Reject,
     /* 117775 */ // Label 2231: @117775
     /* 117775 */ GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(117827), // Rule ID 5104 //
     /* 117780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 117786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 117790 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117794 */   // (fp_to_uint:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1)  =>  (MVE_VCMPf16r:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 117794 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf16r),
     /* 117797 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 117799 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 117801 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 117810 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117813 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117819 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117825 */   GIR_RootConstrainSelectedInstOperands,
     /* 117826 */   // GIR_Coverage, 5104,
     /* 117826 */   GIR_EraseRootFromParent_Done,
     /* 117827 */ // Label 2253: @117827
     /* 117827 */ GIM_Reject,
     /* 117828 */ // Label 2232: @117828
     /* 117828 */ GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(117926),
     /* 117833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 117836 */   GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(117870), // Rule ID 1617 //
     /* 117841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 117844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117852 */     // (fp_to_uint:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTh2uq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /* 117852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2uq),
     /* 117855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117857 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117862 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117868 */     GIR_RootConstrainSelectedInstOperands,
     /* 117869 */     // GIR_Coverage, 1617,
     /* 117869 */     GIR_EraseRootFromParent_Done,
     /* 117870 */   // Label 2255: @117870
     /* 117870 */   GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(117925), // Rule ID 4092 //
     /* 117875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117886 */     // (fp_to_uint:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VCVTu16f16z:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)
     /* 117886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 117889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16z),
     /* 117901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 117903 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 117905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117908 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117914 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117923 */     GIR_RootConstrainSelectedInstOperands,
     /* 117924 */     // GIR_Coverage, 4092,
     /* 117924 */     GIR_EraseRootFromParent_Done,
     /* 117925 */   // Label 2256: @117925
     /* 117925 */   GIM_Reject,
     /* 117926 */ // Label 2254: @117926
     /* 117926 */ GIM_Reject,
     /* 117927 */ // Label 2233: @117927
     /* 117927 */ GIM_Reject,
     /* 117928 */ // Label 44: @117928
     /* 117928 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2264*/ GIMT_Encode4(118579),
     /* 117939 */ /*GILLT_s16*//*Label 2257*/ GIMT_Encode4(117991),
     /* 117943 */ /*GILLT_s32*//*Label 2258*/ GIMT_Encode4(118051),
     /* 117947 */ /*GILLT_s64*//*Label 2259*/ GIMT_Encode4(118245), GIMT_Encode4(0),
     /* 117955 */ /*GILLT_v2s32*//*Label 2260*/ GIMT_Encode4(118305), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 117967 */ /*GILLT_v4s16*//*Label 2261*/ GIMT_Encode4(118343),
     /* 117971 */ /*GILLT_v4s32*//*Label 2262*/ GIMT_Encode4(118381), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 117987 */ /*GILLT_v8s16*//*Label 2263*/ GIMT_Encode4(118480),
     /* 117991 */ // Label 2257: @117991
     /* 117991 */ GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(118050), // Rule ID 2346 //
     /* 117996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 117999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 118006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118010 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$a)  =>  (VSITOH:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118010 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118013 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118017 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118022 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118026 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSITOH),
     /* 118034 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118036 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118042 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118048 */   GIR_RootConstrainSelectedInstOperands,
     /* 118049 */   // GIR_Coverage, 2346,
     /* 118049 */   GIR_EraseRootFromParent_Done,
     /* 118050 */ // Label 2265: @118050
     /* 118050 */ GIM_Reject,
     /* 118051 */ // Label 2258: @118051
     /* 118051 */ GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(118244),
     /* 118056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 118063 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118067 */   GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(118115), // Rule ID 2344 //
     /* 118072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 118075 */     // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (VSITOS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118087 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118091 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSITOS),
     /* 118099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118107 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118113 */     GIR_RootConstrainSelectedInstOperands,
     /* 118114 */     // GIR_Coverage, 2344,
     /* 118114 */     GIR_EraseRootFromParent_Done,
     /* 118115 */   // Label 2267: @118115
     /* 118115 */   GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(118243), // Rule ID 2712 //
     /* 118120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 118123 */     // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (VCVTs2fd:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), (COPY_TO_REGCLASS:{ *:[i32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }), ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 118123 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118126 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118130 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118135 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118139 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118144 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 118147 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118151 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118158 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 118161 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118165 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118170 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 118173 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 118176 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 118179 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118184 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118189 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 118197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTs2fd),
     /* 118201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118206 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118209 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 118212 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 118220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118225 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 118232 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118237 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118242 */     // GIR_Coverage, 2712,
     /* 118242 */     GIR_EraseRootFromParent_Done,
     /* 118243 */   // Label 2268: @118243
     /* 118243 */   GIM_Reject,
     /* 118244 */ // Label 2266: @118244
     /* 118244 */ GIM_Reject,
     /* 118245 */ // Label 2259: @118245
     /* 118245 */ GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(118304), // Rule ID 2342 //
     /* 118250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 118253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118264 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$a)  =>  (VSITOD:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118264 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118267 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118271 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118276 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118280 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSITOD),
     /* 118288 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 118290 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118293 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118296 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118302 */   GIR_RootConstrainSelectedInstOperands,
     /* 118303 */   // GIR_Coverage, 2342,
     /* 118303 */   GIR_EraseRootFromParent_Done,
     /* 118304 */ // Label 2269: @118304
     /* 118304 */ GIM_Reject,
     /* 118305 */ // Label 2260: @118305
     /* 118305 */ GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(118342), // Rule ID 1606 //
     /* 118310 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 118313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 118316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118324 */   // (sint_to_fp:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VCVTs2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)
     /* 118324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2fd),
     /* 118327 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118329 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118331 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118334 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118340 */   GIR_RootConstrainSelectedInstOperands,
     /* 118341 */   // GIR_Coverage, 1606,
     /* 118341 */   GIR_EraseRootFromParent_Done,
     /* 118342 */ // Label 2270: @118342
     /* 118342 */ GIM_Reject,
     /* 118343 */ // Label 2261: @118343
     /* 118343 */ GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(118380), // Rule ID 1614 //
     /* 118348 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 118351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 118354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118358 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118362 */   // (sint_to_fp:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VCVTs2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)
     /* 118362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2hd),
     /* 118365 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118367 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118369 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118372 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118378 */   GIR_RootConstrainSelectedInstOperands,
     /* 118379 */   // GIR_Coverage, 1614,
     /* 118379 */   GIR_EraseRootFromParent_Done,
     /* 118380 */ // Label 2271: @118380
     /* 118380 */ GIM_Reject,
     /* 118381 */ // Label 2262: @118381
     /* 118381 */ GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(118479),
     /* 118386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 118389 */   GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(118423), // Rule ID 1610 //
     /* 118394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 118397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118405 */     // (sint_to_fp:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VCVTs2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)
     /* 118405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2fq),
     /* 118408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118415 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118421 */     GIR_RootConstrainSelectedInstOperands,
     /* 118422 */     // GIR_Coverage, 1610,
     /* 118422 */     GIR_EraseRootFromParent_Done,
     /* 118423 */   // Label 2273: @118423
     /* 118423 */   GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(118478), // Rule ID 4102 //
     /* 118428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 118431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118439 */     // (sint_to_fp:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VCVTf32s32n:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)
     /* 118439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 118442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32s32n),
     /* 118454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 118456 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 118458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118461 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118467 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118476 */     GIR_RootConstrainSelectedInstOperands,
     /* 118477 */     // GIR_Coverage, 4102,
     /* 118477 */     GIR_EraseRootFromParent_Done,
     /* 118478 */   // Label 2274: @118478
     /* 118478 */   GIM_Reject,
     /* 118479 */ // Label 2272: @118479
     /* 118479 */ GIM_Reject,
     /* 118480 */ // Label 2263: @118480
     /* 118480 */ GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(118578),
     /* 118485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 118488 */   GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(118522), // Rule ID 1618 //
     /* 118493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 118496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118504 */     // (sint_to_fp:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VCVTs2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)
     /* 118504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2hq),
     /* 118507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118509 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118514 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118520 */     GIR_RootConstrainSelectedInstOperands,
     /* 118521 */     // GIR_Coverage, 1618,
     /* 118521 */     GIR_EraseRootFromParent_Done,
     /* 118522 */   // Label 2276: @118522
     /* 118522 */   GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(118577), // Rule ID 4098 //
     /* 118527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 118530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118538 */     // (sint_to_fp:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VCVTf16s16n:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)
     /* 118538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 118541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16s16n),
     /* 118553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 118555 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 118557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118560 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118566 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118575 */     GIR_RootConstrainSelectedInstOperands,
     /* 118576 */     // GIR_Coverage, 4098,
     /* 118576 */     GIR_EraseRootFromParent_Done,
     /* 118577 */   // Label 2277: @118577
     /* 118577 */   GIM_Reject,
     /* 118578 */ // Label 2275: @118578
     /* 118578 */ GIM_Reject,
     /* 118579 */ // Label 2264: @118579
     /* 118579 */ GIM_Reject,
     /* 118580 */ // Label 45: @118580
     /* 118580 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2285*/ GIMT_Encode4(119231),
     /* 118591 */ /*GILLT_s16*//*Label 2278*/ GIMT_Encode4(118643),
     /* 118595 */ /*GILLT_s32*//*Label 2279*/ GIMT_Encode4(118703),
     /* 118599 */ /*GILLT_s64*//*Label 2280*/ GIMT_Encode4(118897), GIMT_Encode4(0),
     /* 118607 */ /*GILLT_v2s32*//*Label 2281*/ GIMT_Encode4(118957), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 118619 */ /*GILLT_v4s16*//*Label 2282*/ GIMT_Encode4(118995),
     /* 118623 */ /*GILLT_v4s32*//*Label 2283*/ GIMT_Encode4(119033), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 118639 */ /*GILLT_v8s16*//*Label 2284*/ GIMT_Encode4(119132),
     /* 118643 */ // Label 2278: @118643
     /* 118643 */ GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(118702), // Rule ID 2351 //
     /* 118648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 118651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 118658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118662 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$a)  =>  (VUITOH:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118662 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118665 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118669 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118674 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118678 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUITOH),
     /* 118686 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118688 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118691 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118694 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118700 */   GIR_RootConstrainSelectedInstOperands,
     /* 118701 */   // GIR_Coverage, 2351,
     /* 118701 */   GIR_EraseRootFromParent_Done,
     /* 118702 */ // Label 2286: @118702
     /* 118702 */ GIM_Reject,
     /* 118703 */ // Label 2279: @118703
     /* 118703 */ GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(118896),
     /* 118708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 118715 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118719 */   GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(118767), // Rule ID 2349 //
     /* 118724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 118727 */     // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (VUITOS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118739 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118743 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUITOS),
     /* 118751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118759 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118765 */     GIR_RootConstrainSelectedInstOperands,
     /* 118766 */     // GIR_Coverage, 2349,
     /* 118766 */     GIR_EraseRootFromParent_Done,
     /* 118767 */   // Label 2288: @118767
     /* 118767 */   GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(118895), // Rule ID 2713 //
     /* 118772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 118775 */     // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (VCVTu2fd:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), (COPY_TO_REGCLASS:{ *:[i32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }), ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 118775 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118778 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118782 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118787 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118791 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118796 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 118799 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118803 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118810 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 118813 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118817 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118822 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 118825 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 118828 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 118831 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118836 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118841 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 118849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTu2fd),
     /* 118853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118858 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118861 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 118864 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 118872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118877 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 118884 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118889 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118894 */     // GIR_Coverage, 2713,
     /* 118894 */     GIR_EraseRootFromParent_Done,
     /* 118895 */   // Label 2289: @118895
     /* 118895 */   GIM_Reject,
     /* 118896 */ // Label 2287: @118896
     /* 118896 */ GIM_Reject,
     /* 118897 */ // Label 2280: @118897
     /* 118897 */ GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(118956), // Rule ID 2347 //
     /* 118902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 118905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118912 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118916 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$a)  =>  (VUITOD:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118916 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118919 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118923 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118928 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118932 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUITOD),
     /* 118940 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 118942 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118945 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118948 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118954 */   GIR_RootConstrainSelectedInstOperands,
     /* 118955 */   // GIR_Coverage, 2347,
     /* 118955 */   GIR_EraseRootFromParent_Done,
     /* 118956 */ // Label 2290: @118956
     /* 118956 */ GIM_Reject,
     /* 118957 */ // Label 2281: @118957
     /* 118957 */ GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(118994), // Rule ID 1607 //
     /* 118962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 118965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 118968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118976 */   // (uint_to_fp:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VCVTu2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)
     /* 118976 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2fd),
     /* 118979 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118981 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118983 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118986 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118992 */   GIR_RootConstrainSelectedInstOperands,
     /* 118993 */   // GIR_Coverage, 1607,
     /* 118993 */   GIR_EraseRootFromParent_Done,
     /* 118994 */ // Label 2291: @118994
     /* 118994 */ GIM_Reject,
     /* 118995 */ // Label 2282: @118995
     /* 118995 */ GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(119032), // Rule ID 1615 //
     /* 119000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 119003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 119006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119014 */   // (uint_to_fp:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VCVTu2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)
     /* 119014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2hd),
     /* 119017 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119019 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119021 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119024 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119030 */   GIR_RootConstrainSelectedInstOperands,
     /* 119031 */   // GIR_Coverage, 1615,
     /* 119031 */   GIR_EraseRootFromParent_Done,
     /* 119032 */ // Label 2292: @119032
     /* 119032 */ GIM_Reject,
     /* 119033 */ // Label 2283: @119033
     /* 119033 */ GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(119131),
     /* 119038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 119041 */   GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(119075), // Rule ID 1611 //
     /* 119046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 119049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119057 */     // (uint_to_fp:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VCVTu2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)
     /* 119057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2fq),
     /* 119060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119062 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119067 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119073 */     GIR_RootConstrainSelectedInstOperands,
     /* 119074 */     // GIR_Coverage, 1611,
     /* 119074 */     GIR_EraseRootFromParent_Done,
     /* 119075 */   // Label 2294: @119075
     /* 119075 */   GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(119130), // Rule ID 4104 //
     /* 119080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119091 */     // (uint_to_fp:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VCVTf32u32n:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)
     /* 119091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32u32n),
     /* 119106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119108 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 119110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119113 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119119 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119128 */     GIR_RootConstrainSelectedInstOperands,
     /* 119129 */     // GIR_Coverage, 4104,
     /* 119129 */     GIR_EraseRootFromParent_Done,
     /* 119130 */   // Label 2295: @119130
     /* 119130 */   GIM_Reject,
     /* 119131 */ // Label 2293: @119131
     /* 119131 */ GIM_Reject,
     /* 119132 */ // Label 2284: @119132
     /* 119132 */ GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(119230),
     /* 119137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 119140 */   GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(119174), // Rule ID 1619 //
     /* 119145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 119148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119156 */     // (uint_to_fp:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VCVTu2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)
     /* 119156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2hq),
     /* 119159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119161 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119166 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119172 */     GIR_RootConstrainSelectedInstOperands,
     /* 119173 */     // GIR_Coverage, 1619,
     /* 119173 */     GIR_EraseRootFromParent_Done,
     /* 119174 */   // Label 2297: @119174
     /* 119174 */   GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(119229), // Rule ID 4100 //
     /* 119179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119190 */     // (uint_to_fp:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VCVTf16u16n:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)
     /* 119190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16u16n),
     /* 119205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119207 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 119209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119212 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119218 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119227 */     GIR_RootConstrainSelectedInstOperands,
     /* 119228 */     // GIR_Coverage, 4100,
     /* 119228 */     GIR_EraseRootFromParent_Done,
     /* 119229 */   // Label 2298: @119229
     /* 119229 */   GIM_Reject,
     /* 119230 */ // Label 2296: @119230
     /* 119230 */ GIM_Reject,
     /* 119231 */ // Label 2285: @119231
     /* 119231 */ GIM_Reject,
     /* 119232 */ // Label 46: @119232
     /* 119232 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2306*/ GIMT_Encode4(120007),
     /* 119243 */ /*GILLT_s16*//*Label 2299*/ GIMT_Encode4(119295),
     /* 119247 */ /*GILLT_s32*//*Label 2300*/ GIMT_Encode4(119333),
     /* 119251 */ /*GILLT_s64*//*Label 2301*/ GIMT_Encode4(119525), GIMT_Encode4(0),
     /* 119259 */ /*GILLT_v2s32*//*Label 2302*/ GIMT_Encode4(119563), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 119271 */ /*GILLT_v4s16*//*Label 2303*/ GIMT_Encode4(119601),
     /* 119275 */ /*GILLT_v4s32*//*Label 2304*/ GIMT_Encode4(119639), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 119291 */ /*GILLT_v8s16*//*Label 2305*/ GIMT_Encode4(119823),
     /* 119295 */ // Label 2299: @119295
     /* 119295 */ GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(119332), // Rule ID 653 //
     /* 119300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 119303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 119306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 119310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 119314 */   // (fabs:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VABSH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 119314 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSH),
     /* 119317 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 119319 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 119321 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119324 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119330 */   GIR_RootConstrainSelectedInstOperands,
     /* 119331 */   // GIR_Coverage, 653,
     /* 119331 */   GIR_EraseRootFromParent_Done,
     /* 119332 */ // Label 2307: @119332
     /* 119332 */ GIM_Reject,
     /* 119333 */ // Label 2300: @119333
     /* 119333 */ GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(119524),
     /* 119338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 119341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 119345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 119349 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(119375), // Rule ID 652 //
     /* 119354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 119357 */     // (fabs:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VABSS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 119357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSS),
     /* 119360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 119362 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 119364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119367 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119373 */     GIR_RootConstrainSelectedInstOperands,
     /* 119374 */     // GIR_Coverage, 652,
     /* 119374 */     GIR_EraseRootFromParent_Done,
     /* 119375 */   // Label 2309: @119375
     /* 119375 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(119523), // Rule ID 2704 //
     /* 119380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 119383 */     // (fabs:{ *:[f32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VABSfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 119383 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 119386 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119390 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 119397 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 119400 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119404 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119409 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 119412 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119417 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 119420 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119424 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119429 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 119432 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 119436 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 119439 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119444 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119449 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 119454 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 119457 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VABSfd),
     /* 119461 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119466 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 119469 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 119472 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 119483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119492 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119495 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119505 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 119512 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 119517 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119522 */     // GIR_Coverage, 2704,
     /* 119522 */     GIR_EraseRootFromParent_Done,
     /* 119523 */   // Label 2310: @119523
     /* 119523 */   GIM_Reject,
     /* 119524 */ // Label 2308: @119524
     /* 119524 */ GIM_Reject,
     /* 119525 */ // Label 2301: @119525
     /* 119525 */ GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(119562), // Rule ID 651 //
     /* 119530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 119533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 119536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119544 */   // (fabs:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VABSD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 119544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSD),
     /* 119547 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 119549 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 119551 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119554 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119560 */   GIR_RootConstrainSelectedInstOperands,
     /* 119561 */   // GIR_Coverage, 651,
     /* 119561 */   GIR_EraseRootFromParent_Done,
     /* 119562 */ // Label 2311: @119562
     /* 119562 */ GIM_Reject,
     /* 119563 */ // Label 2302: @119563
     /* 119563 */ GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(119600), // Rule ID 1514 //
     /* 119568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 119571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 119574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119582 */   // (fabs:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VABSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /* 119582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSfd),
     /* 119585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119587 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119592 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119598 */   GIR_RootConstrainSelectedInstOperands,
     /* 119599 */   // GIR_Coverage, 1514,
     /* 119599 */   GIR_EraseRootFromParent_Done,
     /* 119600 */ // Label 2312: @119600
     /* 119600 */ GIM_Reject,
     /* 119601 */ // Label 2303: @119601
     /* 119601 */ GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(119638), // Rule ID 1516 //
     /* 119606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 119609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 119612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119620 */   // (fabs:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VABShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /* 119620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABShd),
     /* 119623 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119625 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119627 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119630 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119636 */   GIR_RootConstrainSelectedInstOperands,
     /* 119637 */   // GIR_Coverage, 1516,
     /* 119637 */   GIR_EraseRootFromParent_Done,
     /* 119638 */ // Label 2313: @119638
     /* 119638 */ GIM_Reject,
     /* 119639 */ // Label 2304: @119639
     /* 119639 */ GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(119822),
     /* 119644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 119647 */   GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(119732), // Rule ID 4041 //
     /* 119652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 119667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 119671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 119675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119687 */     // (fabs:{ *:[v4f32] } (fsub:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn))  =>  (MVE_VABDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 119687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf32),
     /* 119702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 119708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Qn
     /* 119712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119715 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119721 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119730 */     GIR_RootConstrainSelectedInstOperands,
     /* 119731 */     // GIR_Coverage, 4041,
     /* 119731 */     GIR_EraseRootFromParent_Done,
     /* 119732 */   // Label 2315: @119732
     /* 119732 */   GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(119766), // Rule ID 1515 //
     /* 119737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 119740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119748 */     // (fabs:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VABSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /* 119748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSfq),
     /* 119751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119753 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119758 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119764 */     GIR_RootConstrainSelectedInstOperands,
     /* 119765 */     // GIR_Coverage, 1515,
     /* 119765 */     GIR_EraseRootFromParent_Done,
     /* 119766 */   // Label 2316: @119766
     /* 119766 */   GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(119821), // Rule ID 4112 //
     /* 119771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 119774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119782 */     // (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$v)  =>  (MVE_VABSf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$v)
     /* 119782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSf32),
     /* 119797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119799 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 119801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119804 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119810 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119819 */     GIR_RootConstrainSelectedInstOperands,
     /* 119820 */     // GIR_Coverage, 4112,
     /* 119820 */     GIR_EraseRootFromParent_Done,
     /* 119821 */   // Label 2317: @119821
     /* 119821 */   GIM_Reject,
     /* 119822 */ // Label 2314: @119822
     /* 119822 */ GIM_Reject,
     /* 119823 */ // Label 2305: @119823
     /* 119823 */ GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(120006),
     /* 119828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 119831 */   GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(119916), // Rule ID 4040 //
     /* 119836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 119851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 119855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 119859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119871 */     // (fabs:{ *:[v8f16] } (fsub:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn))  =>  (MVE_VABDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 119871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf16),
     /* 119886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 119892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Qn
     /* 119896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119899 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119914 */     GIR_RootConstrainSelectedInstOperands,
     /* 119915 */     // GIR_Coverage, 4040,
     /* 119915 */     GIR_EraseRootFromParent_Done,
     /* 119916 */   // Label 2319: @119916
     /* 119916 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(119950), // Rule ID 1517 //
     /* 119921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 119924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119932 */     // (fabs:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VABShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /* 119932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABShq),
     /* 119935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119937 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119948 */     GIR_RootConstrainSelectedInstOperands,
     /* 119949 */     // GIR_Coverage, 1517,
     /* 119949 */     GIR_EraseRootFromParent_Done,
     /* 119950 */   // Label 2320: @119950
     /* 119950 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(120005), // Rule ID 4110 //
     /* 119955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 119958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119966 */     // (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$v)  =>  (MVE_VABSf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$v)
     /* 119966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSf16),
     /* 119981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119983 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 119985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119988 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119994 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120003 */     GIR_RootConstrainSelectedInstOperands,
     /* 120004 */     // GIR_Coverage, 4110,
     /* 120004 */     GIR_EraseRootFromParent_Done,
     /* 120005 */   // Label 2321: @120005
     /* 120005 */   GIM_Reject,
     /* 120006 */ // Label 2318: @120006
     /* 120006 */ GIM_Reject,
     /* 120007 */ // Label 2306: @120007
     /* 120007 */ GIM_Reject,
     /* 120008 */ // Label 47: @120008
     /* 120008 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2329*/ GIMT_Encode4(120599),
     /* 120019 */ /*GILLT_s16*//*Label 2322*/ GIMT_Encode4(120071),
     /* 120023 */ /*GILLT_s32*//*Label 2323*/ GIMT_Encode4(120105),
     /* 120027 */ /*GILLT_s64*//*Label 2324*/ GIMT_Encode4(120139), GIMT_Encode4(0),
     /* 120035 */ /*GILLT_v2s32*//*Label 2325*/ GIMT_Encode4(120173), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120047 */ /*GILLT_v4s16*//*Label 2326*/ GIMT_Encode4(120207),
     /* 120051 */ /*GILLT_v4s32*//*Label 2327*/ GIMT_Encode4(120241), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120067 */ /*GILLT_v8s16*//*Label 2328*/ GIMT_Encode4(120420),
     /* 120071 */ // Label 2322: @120071
     /* 120071 */ GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(120104), // Rule ID 642 //
     /* 120076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 120079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 120082 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 120085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120093 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120097 */   // (fminnum:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VFP_VMINNMH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 120097 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMINNMH),
     /* 120102 */   GIR_RootConstrainSelectedInstOperands,
     /* 120103 */   // GIR_Coverage, 642,
     /* 120103 */   GIR_Done,
     /* 120104 */ // Label 2330: @120104
     /* 120104 */ GIM_Reject,
     /* 120105 */ // Label 2323: @120105
     /* 120105 */ GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(120138), // Rule ID 643 //
     /* 120110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 120113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 120116 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 120119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120127 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120131 */   // (fminnum:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VFP_VMINNMS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 120131 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMINNMS),
     /* 120136 */   GIR_RootConstrainSelectedInstOperands,
     /* 120137 */   // GIR_Coverage, 643,
     /* 120137 */   GIR_Done,
     /* 120138 */ // Label 2331: @120138
     /* 120138 */ GIM_Reject,
     /* 120139 */ // Label 2324: @120139
     /* 120139 */ GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(120172), // Rule ID 644 //
     /* 120144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 120147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 120150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 120153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120161 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120165 */   // (fminnum:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VFP_VMINNMD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 120165 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMINNMD),
     /* 120170 */   GIR_RootConstrainSelectedInstOperands,
     /* 120171 */   // GIR_Coverage, 644,
     /* 120171 */   GIR_Done,
     /* 120172 */ // Label 2332: @120172
     /* 120172 */ GIM_Reject,
     /* 120173 */ // Label 2325: @120173
     /* 120173 */ GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(120206), // Rule ID 1233 //
     /* 120178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 120184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 120187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120195 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120199 */   // (fminnum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (NEON_VMINNMNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 120199 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNDf),
     /* 120204 */   GIR_RootConstrainSelectedInstOperands,
     /* 120205 */   // GIR_Coverage, 1233,
     /* 120205 */   GIR_Done,
     /* 120206 */ // Label 2333: @120206
     /* 120206 */ GIM_Reject,
     /* 120207 */ // Label 2326: @120207
     /* 120207 */ GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(120240), // Rule ID 1235 //
     /* 120212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 120215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 120218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 120221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120229 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120233 */   // (fminnum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (NEON_VMINNMNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 120233 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNDh),
     /* 120238 */   GIR_RootConstrainSelectedInstOperands,
     /* 120239 */   // GIR_Coverage, 1235,
     /* 120239 */   GIR_Done,
     /* 120240 */ // Label 2334: @120240
     /* 120240 */ GIM_Reject,
     /* 120241 */ // Label 2327: @120241
     /* 120241 */ GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(120419),
     /* 120246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120249 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 120252 */   GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(120330), // Rule ID 4122 //
     /* 120257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120293 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120300 */     // (fminnum:{ *:[v4f32] } (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd), (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm))  =>  (MVE_VMINNMAf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd, MQPR:{ *:[v4f32] }:$Qm)
     /* 120300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAf32),
     /* 120303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 120309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 120313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120316 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120322 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120328 */     GIR_RootConstrainSelectedInstOperands,
     /* 120329 */     // GIR_Coverage, 4122,
     /* 120329 */     GIR_EraseRootFromParent_Done,
     /* 120330 */   // Label 2336: @120330
     /* 120330 */   GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(120357), // Rule ID 1234 //
     /* 120335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120350 */     // (fminnum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (NEON_VMINNMNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 120350 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNQf),
     /* 120355 */     GIR_RootConstrainSelectedInstOperands,
     /* 120356 */     // GIR_Coverage, 1234,
     /* 120356 */     GIR_Done,
     /* 120357 */   // Label 2337: @120357
     /* 120357 */   GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(120418), // Rule ID 3288 //
     /* 120362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 120365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120377 */     // (fminnum:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VMINNMf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 120377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMf32),
     /* 120392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120394 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 120396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 120398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120401 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120407 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120416 */     GIR_RootConstrainSelectedInstOperands,
     /* 120417 */     // GIR_Coverage, 3288,
     /* 120417 */     GIR_EraseRootFromParent_Done,
     /* 120418 */   // Label 2338: @120418
     /* 120418 */   GIM_Reject,
     /* 120419 */ // Label 2335: @120419
     /* 120419 */ GIM_Reject,
     /* 120420 */ // Label 2328: @120420
     /* 120420 */ GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(120598),
     /* 120425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120428 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 120431 */   GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(120509), // Rule ID 4124 //
     /* 120436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120472 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120477 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120479 */     // (fminnum:{ *:[v8f16] } (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd), (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm))  =>  (MVE_VMINNMAf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd, MQPR:{ *:[v8f16] }:$Qm)
     /* 120479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAf16),
     /* 120482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 120488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 120492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120495 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120501 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120507 */     GIR_RootConstrainSelectedInstOperands,
     /* 120508 */     // GIR_Coverage, 4124,
     /* 120508 */     GIR_EraseRootFromParent_Done,
     /* 120509 */   // Label 2340: @120509
     /* 120509 */   GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(120536), // Rule ID 1236 //
     /* 120514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 120517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120529 */     // (fminnum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (NEON_VMINNMNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 120529 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNQh),
     /* 120534 */     GIR_RootConstrainSelectedInstOperands,
     /* 120535 */     // GIR_Coverage, 1236,
     /* 120535 */     GIR_Done,
     /* 120536 */   // Label 2341: @120536
     /* 120536 */   GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(120597), // Rule ID 3291 //
     /* 120541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 120544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120556 */     // (fminnum:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VMINNMf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 120556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMf16),
     /* 120571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120573 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 120575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 120577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120580 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120586 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120595 */     GIR_RootConstrainSelectedInstOperands,
     /* 120596 */     // GIR_Coverage, 3291,
     /* 120596 */     GIR_EraseRootFromParent_Done,
     /* 120597 */   // Label 2342: @120597
     /* 120597 */   GIM_Reject,
     /* 120598 */ // Label 2339: @120598
     /* 120598 */ GIM_Reject,
     /* 120599 */ // Label 2329: @120599
     /* 120599 */ GIM_Reject,
     /* 120600 */ // Label 48: @120600
     /* 120600 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2350*/ GIMT_Encode4(121191),
     /* 120611 */ /*GILLT_s16*//*Label 2343*/ GIMT_Encode4(120663),
     /* 120615 */ /*GILLT_s32*//*Label 2344*/ GIMT_Encode4(120697),
     /* 120619 */ /*GILLT_s64*//*Label 2345*/ GIMT_Encode4(120731), GIMT_Encode4(0),
     /* 120627 */ /*GILLT_v2s32*//*Label 2346*/ GIMT_Encode4(120765), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120639 */ /*GILLT_v4s16*//*Label 2347*/ GIMT_Encode4(120799),
     /* 120643 */ /*GILLT_v4s32*//*Label 2348*/ GIMT_Encode4(120833), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120659 */ /*GILLT_v8s16*//*Label 2349*/ GIMT_Encode4(121012),
     /* 120663 */ // Label 2343: @120663
     /* 120663 */ GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(120696), // Rule ID 639 //
     /* 120668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 120671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 120674 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 120677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120681 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120685 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120689 */   // (fmaxnum:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VFP_VMAXNMH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 120689 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMAXNMH),
     /* 120694 */   GIR_RootConstrainSelectedInstOperands,
     /* 120695 */   // GIR_Coverage, 639,
     /* 120695 */   GIR_Done,
     /* 120696 */ // Label 2351: @120696
     /* 120696 */ GIM_Reject,
     /* 120697 */ // Label 2344: @120697
     /* 120697 */ GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(120730), // Rule ID 640 //
     /* 120702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 120705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 120708 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 120711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120715 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120719 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120723 */   // (fmaxnum:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VFP_VMAXNMS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 120723 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMAXNMS),
     /* 120728 */   GIR_RootConstrainSelectedInstOperands,
     /* 120729 */   // GIR_Coverage, 640,
     /* 120729 */   GIR_Done,
     /* 120730 */ // Label 2352: @120730
     /* 120730 */ GIM_Reject,
     /* 120731 */ // Label 2345: @120731
     /* 120731 */ GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(120764), // Rule ID 641 //
     /* 120736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 120739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 120742 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 120745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120753 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120757 */   // (fmaxnum:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VFP_VMAXNMD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 120757 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMAXNMD),
     /* 120762 */   GIR_RootConstrainSelectedInstOperands,
     /* 120763 */   // GIR_Coverage, 641,
     /* 120763 */   GIR_Done,
     /* 120764 */ // Label 2353: @120764
     /* 120764 */ GIM_Reject,
     /* 120765 */ // Label 2346: @120765
     /* 120765 */ GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(120798), // Rule ID 1213 //
     /* 120770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 120776 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 120779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120787 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120791 */   // (fmaxnum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (NEON_VMAXNMNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 120791 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNDf),
     /* 120796 */   GIR_RootConstrainSelectedInstOperands,
     /* 120797 */   // GIR_Coverage, 1213,
     /* 120797 */   GIR_Done,
     /* 120798 */ // Label 2354: @120798
     /* 120798 */ GIM_Reject,
     /* 120799 */ // Label 2347: @120799
     /* 120799 */ GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(120832), // Rule ID 1215 //
     /* 120804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 120807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 120810 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 120813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120821 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120825 */   // (fmaxnum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (NEON_VMAXNMNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 120825 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNDh),
     /* 120830 */   GIR_RootConstrainSelectedInstOperands,
     /* 120831 */   // GIR_Coverage, 1215,
     /* 120831 */   GIR_Done,
     /* 120832 */ // Label 2355: @120832
     /* 120832 */ GIM_Reject,
     /* 120833 */ // Label 2348: @120833
     /* 120833 */ GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(121011),
     /* 120838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 120844 */   GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(120922), // Rule ID 4118 //
     /* 120849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120881 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120885 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120892 */     // (fmaxnum:{ *:[v4f32] } (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd), (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm))  =>  (MVE_VMAXNMAf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd, MQPR:{ *:[v4f32] }:$Qm)
     /* 120892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAf32),
     /* 120895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 120901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 120905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120908 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120914 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120920 */     GIR_RootConstrainSelectedInstOperands,
     /* 120921 */     // GIR_Coverage, 4118,
     /* 120921 */     GIR_EraseRootFromParent_Done,
     /* 120922 */   // Label 2357: @120922
     /* 120922 */   GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(120949), // Rule ID 1214 //
     /* 120927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120942 */     // (fmaxnum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (NEON_VMAXNMNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 120942 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNQf),
     /* 120947 */     GIR_RootConstrainSelectedInstOperands,
     /* 120948 */     // GIR_Coverage, 1214,
     /* 120948 */     GIR_Done,
     /* 120949 */   // Label 2358: @120949
     /* 120949 */   GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(121010), // Rule ID 3030 //
     /* 120954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 120957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120969 */     // (fmaxnum:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VMAXNMf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 120969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMf32),
     /* 120984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120986 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 120988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 120990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120993 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120999 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121008 */     GIR_RootConstrainSelectedInstOperands,
     /* 121009 */     // GIR_Coverage, 3030,
     /* 121009 */     GIR_EraseRootFromParent_Done,
     /* 121010 */   // Label 2359: @121010
     /* 121010 */   GIM_Reject,
     /* 121011 */ // Label 2356: @121011
     /* 121011 */ GIM_Reject,
     /* 121012 */ // Label 2349: @121012
     /* 121012 */ GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(121190),
     /* 121017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 121020 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 121023 */   GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(121101), // Rule ID 4120 //
     /* 121028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 121031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 121043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 121047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 121056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 121060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 121064 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121069 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 121071 */     // (fmaxnum:{ *:[v8f16] } (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd), (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm))  =>  (MVE_VMAXNMAf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd, MQPR:{ *:[v8f16] }:$Qm)
     /* 121071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAf16),
     /* 121074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 121076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 121080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 121084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121087 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121093 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121099 */     GIR_RootConstrainSelectedInstOperands,
     /* 121100 */     // GIR_Coverage, 4120,
     /* 121100 */     GIR_EraseRootFromParent_Done,
     /* 121101 */   // Label 2361: @121101
     /* 121101 */   GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(121128), // Rule ID 1216 //
     /* 121106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 121109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121121 */     // (fmaxnum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (NEON_VMAXNMNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 121121 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNQh),
     /* 121126 */     GIR_RootConstrainSelectedInstOperands,
     /* 121127 */     // GIR_Coverage, 1216,
     /* 121127 */     GIR_Done,
     /* 121128 */   // Label 2362: @121128
     /* 121128 */   GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(121189), // Rule ID 3285 //
     /* 121133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 121136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121148 */     // (fmaxnum:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VMAXNMf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 121148 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 121151 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121155 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMf16),
     /* 121163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 121165 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 121167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 121169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121172 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121178 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121187 */     GIR_RootConstrainSelectedInstOperands,
     /* 121188 */     // GIR_Coverage, 3285,
     /* 121188 */     GIR_EraseRootFromParent_Done,
     /* 121189 */   // Label 2363: @121189
     /* 121189 */   GIM_Reject,
     /* 121190 */ // Label 2360: @121190
     /* 121190 */ GIM_Reject,
     /* 121191 */ // Label 2350: @121191
     /* 121191 */ GIM_Reject,
     /* 121192 */ // Label 49: @121192
     /* 121192 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2370*/ GIMT_Encode4(121925),
     /* 121203 */ /*GILLT_s16*//*Label 2364*/ GIMT_Encode4(121255),
     /* 121207 */ /*GILLT_s32*//*Label 2365*/ GIMT_Encode4(121496), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121219 */ /*GILLT_v2s32*//*Label 2366*/ GIMT_Encode4(121737), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121231 */ /*GILLT_v4s16*//*Label 2367*/ GIMT_Encode4(121784),
     /* 121235 */ /*GILLT_v4s32*//*Label 2368*/ GIMT_Encode4(121831), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121251 */ /*GILLT_v8s16*//*Label 2369*/ GIMT_Encode4(121878),
     /* 121255 */ // Label 2364: @121255
     /* 121255 */ GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(121495), // Rule ID 2707 //
     /* 121260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 121263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 121266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 121269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121273 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 121277 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 121281 */   // (fminimum:{ *:[f16] } HPR:{ *:[f16] }:$a, HPR:{ *:[f16] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (VMINhd:{ *:[f64] } (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 121281 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 121284 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121288 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121293 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 121295 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
     /* 121298 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121302 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121307 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 121310 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121315 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 121318 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121322 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121327 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 121330 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 121334 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 121337 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121342 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121347 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 121352 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
     /* 121355 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121359 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121364 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 121366 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
     /* 121369 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121373 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121378 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 121381 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121386 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 121389 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121393 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121398 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 121401 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 121405 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 121408 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121413 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121418 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 121423 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 121426 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMINhd),
     /* 121430 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121435 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 121438 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 121441 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 121444 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121450 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121452 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 121455 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121459 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121464 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121467 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121475 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121477 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 121484 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121489 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121494 */   // GIR_Coverage, 2707,
     /* 121494 */   GIR_EraseRootFromParent_Done,
     /* 121495 */ // Label 2371: @121495
     /* 121495 */ GIM_Reject,
     /* 121496 */ // Label 2365: @121496
     /* 121496 */ GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(121736), // Rule ID 2709 //
     /* 121501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 121507 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 121510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121518 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121522 */   // (fminimum:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMINfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 121522 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 121525 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121529 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121534 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 121536 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 121539 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121543 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121548 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 121551 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121556 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 121559 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121563 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121568 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 121571 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 121575 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 121578 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121583 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121588 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121593 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 121596 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121600 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121605 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 121607 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 121610 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121614 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121619 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 121622 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121627 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 121630 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121634 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121639 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 121642 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 121646 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 121649 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121654 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121659 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121664 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 121667 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMINfd),
     /* 121671 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121676 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 121679 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 121682 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 121685 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121691 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121693 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 121696 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121700 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121705 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121708 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121716 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121718 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 121725 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121730 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121735 */   // GIR_Coverage, 2709,
     /* 121735 */   GIR_EraseRootFromParent_Done,
     /* 121736 */ // Label 2372: @121736
     /* 121736 */ GIM_Reject,
     /* 121737 */ // Label 2366: @121737
     /* 121737 */ GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(121783), // Rule ID 1229 //
     /* 121742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 121748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 121751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121759 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121763 */   // (fminimum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VMINfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 121763 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINfd),
     /* 121766 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121768 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121770 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121772 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121775 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121781 */   GIR_RootConstrainSelectedInstOperands,
     /* 121782 */   // GIR_Coverage, 1229,
     /* 121782 */   GIR_EraseRootFromParent_Done,
     /* 121783 */ // Label 2373: @121783
     /* 121783 */ GIM_Reject,
     /* 121784 */ // Label 2367: @121784
     /* 121784 */ GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(121830), // Rule ID 1231 //
     /* 121789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 121792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 121795 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 121798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121806 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121810 */   // (fminimum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VMINhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 121810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINhd),
     /* 121813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121815 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121817 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121822 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121828 */   GIR_RootConstrainSelectedInstOperands,
     /* 121829 */   // GIR_Coverage, 1231,
     /* 121829 */   GIR_EraseRootFromParent_Done,
     /* 121830 */ // Label 2374: @121830
     /* 121830 */ GIM_Reject,
     /* 121831 */ // Label 2368: @121831
     /* 121831 */ GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(121877), // Rule ID 1230 //
     /* 121836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 121842 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 121845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121853 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121857 */   // (fminimum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VMINfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 121857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINfq),
     /* 121860 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121862 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121864 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121866 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121869 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121875 */   GIR_RootConstrainSelectedInstOperands,
     /* 121876 */   // GIR_Coverage, 1230,
     /* 121876 */   GIR_EraseRootFromParent_Done,
     /* 121877 */ // Label 2375: @121877
     /* 121877 */ GIM_Reject,
     /* 121878 */ // Label 2369: @121878
     /* 121878 */ GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(121924), // Rule ID 1232 //
     /* 121883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 121886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 121889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 121892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121900 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121904 */   // (fminimum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VMINhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 121904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINhq),
     /* 121907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121909 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121911 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121916 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121922 */   GIR_RootConstrainSelectedInstOperands,
     /* 121923 */   // GIR_Coverage, 1232,
     /* 121923 */   GIR_EraseRootFromParent_Done,
     /* 121924 */ // Label 2376: @121924
     /* 121924 */ GIM_Reject,
     /* 121925 */ // Label 2370: @121925
     /* 121925 */ GIM_Reject,
     /* 121926 */ // Label 50: @121926
     /* 121926 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2383*/ GIMT_Encode4(122659),
     /* 121937 */ /*GILLT_s16*//*Label 2377*/ GIMT_Encode4(121989),
     /* 121941 */ /*GILLT_s32*//*Label 2378*/ GIMT_Encode4(122230), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121953 */ /*GILLT_v2s32*//*Label 2379*/ GIMT_Encode4(122471), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121965 */ /*GILLT_v4s16*//*Label 2380*/ GIMT_Encode4(122518),
     /* 121969 */ /*GILLT_v4s32*//*Label 2381*/ GIMT_Encode4(122565), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121985 */ /*GILLT_v8s16*//*Label 2382*/ GIMT_Encode4(122612),
     /* 121989 */ // Label 2377: @121989
     /* 121989 */ GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(122229), // Rule ID 2706 //
     /* 121994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 121997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 122000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 122003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 122007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 122011 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 122015 */   // (fmaximum:{ *:[f16] } HPR:{ *:[f16] }:$a, HPR:{ *:[f16] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (VMAXhd:{ *:[f64] } (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 122015 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 122018 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122022 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122027 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 122029 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
     /* 122032 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122036 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122041 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 122044 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122049 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 122052 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122056 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122061 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 122064 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 122068 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 122071 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122076 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122081 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 122086 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
     /* 122089 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122093 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122098 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 122100 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
     /* 122103 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122107 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122112 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 122115 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122120 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 122123 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122127 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122132 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 122135 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 122139 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 122142 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122147 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122152 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 122157 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 122160 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMAXhd),
     /* 122164 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122169 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 122172 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 122175 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 122178 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122184 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122186 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 122189 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122193 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122198 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 122201 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122209 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122211 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 122218 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122223 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122228 */   // GIR_Coverage, 2706,
     /* 122228 */   GIR_EraseRootFromParent_Done,
     /* 122229 */ // Label 2384: @122229
     /* 122229 */ GIM_Reject,
     /* 122230 */ // Label 2378: @122230
     /* 122230 */ GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(122470), // Rule ID 2708 //
     /* 122235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 122241 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 122244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 122248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 122252 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 122256 */   // (fmaximum:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMAXfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 122256 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 122259 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122263 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122268 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 122270 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 122273 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122277 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122282 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 122285 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122290 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 122293 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122297 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122302 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 122305 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 122309 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 122312 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122317 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122322 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122327 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 122330 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122334 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122339 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 122341 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 122344 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122348 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122353 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 122356 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122361 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 122364 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122368 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122373 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 122376 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 122380 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 122383 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122388 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122393 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122398 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 122401 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMAXfd),
     /* 122405 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122410 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 122413 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 122416 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 122419 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122425 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122427 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 122430 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122434 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122439 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 122442 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122450 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122452 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 122459 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122464 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122469 */   // GIR_Coverage, 2708,
     /* 122469 */   GIR_EraseRootFromParent_Done,
     /* 122470 */ // Label 2385: @122470
     /* 122470 */ GIM_Reject,
     /* 122471 */ // Label 2379: @122471
     /* 122471 */ GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(122517), // Rule ID 1209 //
     /* 122476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 122482 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 122485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122493 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122497 */   // (fmaximum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VMAXfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 122497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXfd),
     /* 122500 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122502 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122504 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122506 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122509 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122515 */   GIR_RootConstrainSelectedInstOperands,
     /* 122516 */   // GIR_Coverage, 1209,
     /* 122516 */   GIR_EraseRootFromParent_Done,
     /* 122517 */ // Label 2386: @122517
     /* 122517 */ GIM_Reject,
     /* 122518 */ // Label 2380: @122518
     /* 122518 */ GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(122564), // Rule ID 1211 //
     /* 122523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 122526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 122529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 122532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122540 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122544 */   // (fmaximum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VMAXhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 122544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXhd),
     /* 122547 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122549 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122551 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122553 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122556 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122562 */   GIR_RootConstrainSelectedInstOperands,
     /* 122563 */   // GIR_Coverage, 1211,
     /* 122563 */   GIR_EraseRootFromParent_Done,
     /* 122564 */ // Label 2387: @122564
     /* 122564 */ GIM_Reject,
     /* 122565 */ // Label 2381: @122565
     /* 122565 */ GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(122611), // Rule ID 1210 //
     /* 122570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 122576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 122579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122587 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122591 */   // (fmaximum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VMAXfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 122591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXfq),
     /* 122594 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122596 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122598 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122600 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122603 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122609 */   GIR_RootConstrainSelectedInstOperands,
     /* 122610 */   // GIR_Coverage, 1210,
     /* 122610 */   GIR_EraseRootFromParent_Done,
     /* 122611 */ // Label 2388: @122611
     /* 122611 */ GIM_Reject,
     /* 122612 */ // Label 2382: @122612
     /* 122612 */ GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(122658), // Rule ID 1212 //
     /* 122617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 122620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 122623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 122626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122634 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122638 */   // (fmaximum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VMAXhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 122638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXhq),
     /* 122641 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122643 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122645 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122650 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122656 */   GIR_RootConstrainSelectedInstOperands,
     /* 122657 */   // GIR_Coverage, 1212,
     /* 122657 */   GIR_EraseRootFromParent_Done,
     /* 122658 */ // Label 2389: @122658
     /* 122658 */ GIM_Reject,
     /* 122659 */ // Label 2383: @122659
     /* 122659 */ GIM_Reject,
     /* 122660 */ // Label 51: @122660
     /* 122660 */ GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(122692), // Rule ID 2419 //
     /* 122665 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 122668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 122672 */   // (get_fpenv:{ *:[i32] })  =>  (VMRS:{ *:[i32] })
     /* 122672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMRS),
     /* 122675 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122680 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122686 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122690 */   GIR_RootConstrainSelectedInstOperands,
     /* 122691 */   // GIR_Coverage, 2419,
     /* 122691 */   GIR_EraseRootFromParent_Done,
     /* 122692 */ // Label 2390: @122692
     /* 122692 */ GIM_Reject,
     /* 122693 */ // Label 52: @122693
     /* 122693 */ GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(122728), // Rule ID 2420 //
     /* 122698 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 122701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 122705 */   // (set_fpenv GPRnopc:{ *:[i32] }:$Rt)  =>  (VMSR:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rt)
     /* 122705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /* 122708 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122710 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122713 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122719 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /* 122722 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122726 */   GIR_RootConstrainSelectedInstOperands,
     /* 122727 */   // GIR_Coverage, 2420,
     /* 122727 */   GIR_EraseRootFromParent_Done,
     /* 122728 */ // Label 2391: @122728
     /* 122728 */ GIM_Reject,
     /* 122729 */ // Label 53: @122729
     /* 122729 */ GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(122793), // Rule ID 2421 //
     /* 122734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /* 122737 */   // (reset_fpenv)  =>  (VMSR:{ *:[i32] } (MOVi:{ *:[i32] } 0:{ *:[i32] }))
     /* 122737 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122740 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MOVi),
     /* 122744 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122749 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 122752 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 122755 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122761 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122767 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122769 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /* 122772 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122775 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122778 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122784 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /* 122787 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122791 */   GIR_RootConstrainSelectedInstOperands,
     /* 122792 */   // GIR_Coverage, 2421,
     /* 122792 */   GIR_EraseRootFromParent_Done,
     /* 122793 */ // Label 2392: @122793
     /* 122793 */ GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(122857), // Rule ID 2422 //
     /* 122798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb),
     /* 122801 */   // (reset_fpenv)  =>  (VMSR:{ *:[i32] } (tMOVi8:{ *:[i32] } 0:{ *:[i32] }))
     /* 122801 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122804 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /* 122808 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122813 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 122819 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 122822 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 122825 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122831 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /* 122836 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122839 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122842 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122848 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /* 122851 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122855 */   GIR_RootConstrainSelectedInstOperands,
     /* 122856 */   // GIR_Coverage, 2422,
     /* 122856 */   GIR_EraseRootFromParent_Done,
     /* 122857 */ // Label 2393: @122857
     /* 122857 */ GIM_Reject,
     /* 122858 */ // Label 54: @122858
     /* 122858 */ GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(122890), // Rule ID 2423 //
     /* 122863 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 122866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 122870 */   // (get_fpmode:{ *:[i32] })  =>  (VMRS:{ *:[i32] })
     /* 122870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMRS),
     /* 122873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122875 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122878 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122884 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122888 */   GIR_RootConstrainSelectedInstOperands,
     /* 122889 */   // GIR_Coverage, 2423,
     /* 122889 */   GIR_EraseRootFromParent_Done,
     /* 122890 */ // Label 2394: @122890
     /* 122890 */ GIM_Reject,
     /* 122891 */ // Label 55: @122891
     /* 122891 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2401*/ GIMT_Encode4(123433),
     /* 122902 */ /*GILLT_v2s32*//*Label 2395*/ GIMT_Encode4(122950), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122914 */ /*GILLT_v4s16*//*Label 2396*/ GIMT_Encode4(122997),
     /* 122918 */ /*GILLT_v4s32*//*Label 2397*/ GIMT_Encode4(123044), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122930 */ /*GILLT_v8s8*//*Label 2398*/ GIMT_Encode4(123158),
     /* 122934 */ /*GILLT_v8s16*//*Label 2399*/ GIMT_Encode4(123205), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122946 */ /*GILLT_v16s8*//*Label 2400*/ GIMT_Encode4(123319),
     /* 122950 */ // Label 2395: @122950
     /* 122950 */ GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(122996), // Rule ID 1218 //
     /* 122955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 122961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 122964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122972 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122976 */   // (smin:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMINsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 122976 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv2i32),
     /* 122979 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122981 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122983 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122985 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122988 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122994 */   GIR_RootConstrainSelectedInstOperands,
     /* 122995 */   // GIR_Coverage, 1218,
     /* 122995 */   GIR_EraseRootFromParent_Done,
     /* 122996 */ // Label 2402: @122996
     /* 122996 */ GIM_Reject,
     /* 122997 */ // Label 2396: @122997
     /* 122997 */ GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(123043), // Rule ID 1217 //
     /* 123002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 123008 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 123011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123019 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123023 */   // (smin:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMINsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 123023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv4i16),
     /* 123026 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123028 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123030 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123035 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123041 */   GIR_RootConstrainSelectedInstOperands,
     /* 123042 */   // GIR_Coverage, 1217,
     /* 123042 */   GIR_EraseRootFromParent_Done,
     /* 123043 */ // Label 2403: @123043
     /* 123043 */ GIM_Reject,
     /* 123044 */ // Label 2397: @123044
     /* 123044 */ GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(123157),
     /* 123049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 123052 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 123055 */   GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(123095), // Rule ID 1220 //
     /* 123060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123075 */     // (smin:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMINsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 123075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv4i32),
     /* 123078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123080 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123087 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123093 */     GIR_RootConstrainSelectedInstOperands,
     /* 123094 */     // GIR_Coverage, 1220,
     /* 123094 */     GIR_EraseRootFromParent_Done,
     /* 123095 */   // Label 2405: @123095
     /* 123095 */   GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(123156), // Rule ID 3300 //
     /* 123100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123115 */     // (smin:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMINs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 123115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINs32),
     /* 123130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123132 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123139 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123145 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123154 */     GIR_RootConstrainSelectedInstOperands,
     /* 123155 */     // GIR_Coverage, 3300,
     /* 123155 */     GIR_EraseRootFromParent_Done,
     /* 123156 */   // Label 2406: @123156
     /* 123156 */   GIM_Reject,
     /* 123157 */ // Label 2404: @123157
     /* 123157 */ GIM_Reject,
     /* 123158 */ // Label 2398: @123158
     /* 123158 */ GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(123204), // Rule ID 1221 //
     /* 123163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 123169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 123172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123180 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123184 */   // (smin:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMINsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 123184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv8i8),
     /* 123187 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123189 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123191 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123193 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123196 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123202 */   GIR_RootConstrainSelectedInstOperands,
     /* 123203 */   // GIR_Coverage, 1221,
     /* 123203 */   GIR_EraseRootFromParent_Done,
     /* 123204 */ // Label 2407: @123204
     /* 123204 */ GIM_Reject,
     /* 123205 */ // Label 2399: @123205
     /* 123205 */ GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(123318),
     /* 123210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 123213 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 123216 */   GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(123256), // Rule ID 1219 //
     /* 123221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123236 */     // (smin:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMINsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 123236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv8i16),
     /* 123239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123241 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123248 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123254 */     GIR_RootConstrainSelectedInstOperands,
     /* 123255 */     // GIR_Coverage, 1219,
     /* 123255 */     GIR_EraseRootFromParent_Done,
     /* 123256 */   // Label 2409: @123256
     /* 123256 */   GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(123317), // Rule ID 3297 //
     /* 123261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123276 */     // (smin:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMINs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 123276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINs16),
     /* 123291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123293 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123300 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123306 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123315 */     GIR_RootConstrainSelectedInstOperands,
     /* 123316 */     // GIR_Coverage, 3297,
     /* 123316 */     GIR_EraseRootFromParent_Done,
     /* 123317 */   // Label 2410: @123317
     /* 123317 */   GIM_Reject,
     /* 123318 */ // Label 2408: @123318
     /* 123318 */ GIM_Reject,
     /* 123319 */ // Label 2400: @123319
     /* 123319 */ GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(123432),
     /* 123324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 123327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 123330 */   GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(123370), // Rule ID 1222 //
     /* 123335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123350 */     // (smin:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMINsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 123350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv16i8),
     /* 123353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123355 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123362 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123368 */     GIR_RootConstrainSelectedInstOperands,
     /* 123369 */     // GIR_Coverage, 1222,
     /* 123369 */     GIR_EraseRootFromParent_Done,
     /* 123370 */   // Label 2412: @123370
     /* 123370 */   GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(123431), // Rule ID 3294 //
     /* 123375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123390 */     // (smin:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMINs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 123390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINs8),
     /* 123405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123407 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123414 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123420 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123429 */     GIR_RootConstrainSelectedInstOperands,
     /* 123430 */     // GIR_Coverage, 3294,
     /* 123430 */     GIR_EraseRootFromParent_Done,
     /* 123431 */   // Label 2413: @123431
     /* 123431 */   GIM_Reject,
     /* 123432 */ // Label 2411: @123432
     /* 123432 */ GIM_Reject,
     /* 123433 */ // Label 2401: @123433
     /* 123433 */ GIM_Reject,
     /* 123434 */ // Label 56: @123434
     /* 123434 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2420*/ GIMT_Encode4(123976),
     /* 123445 */ /*GILLT_v2s32*//*Label 2414*/ GIMT_Encode4(123493), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123457 */ /*GILLT_v4s16*//*Label 2415*/ GIMT_Encode4(123540),
     /* 123461 */ /*GILLT_v4s32*//*Label 2416*/ GIMT_Encode4(123587), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123473 */ /*GILLT_v8s8*//*Label 2417*/ GIMT_Encode4(123701),
     /* 123477 */ /*GILLT_v8s16*//*Label 2418*/ GIMT_Encode4(123748), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123489 */ /*GILLT_v16s8*//*Label 2419*/ GIMT_Encode4(123862),
     /* 123493 */ // Label 2414: @123493
     /* 123493 */ GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(123539), // Rule ID 1198 //
     /* 123498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 123504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 123507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123515 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123519 */   // (smax:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMAXsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 123519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv2i32),
     /* 123522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123524 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123526 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123528 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123531 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123537 */   GIR_RootConstrainSelectedInstOperands,
     /* 123538 */   // GIR_Coverage, 1198,
     /* 123538 */   GIR_EraseRootFromParent_Done,
     /* 123539 */ // Label 2421: @123539
     /* 123539 */ GIM_Reject,
     /* 123540 */ // Label 2415: @123540
     /* 123540 */ GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(123586), // Rule ID 1197 //
     /* 123545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 123551 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 123554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123558 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123562 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123566 */   // (smax:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMAXsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 123566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv4i16),
     /* 123569 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123571 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123573 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123575 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123578 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123584 */   GIR_RootConstrainSelectedInstOperands,
     /* 123585 */   // GIR_Coverage, 1197,
     /* 123585 */   GIR_EraseRootFromParent_Done,
     /* 123586 */ // Label 2422: @123586
     /* 123586 */ GIM_Reject,
     /* 123587 */ // Label 2416: @123587
     /* 123587 */ GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(123700),
     /* 123592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 123595 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 123598 */   GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(123638), // Rule ID 1200 //
     /* 123603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123618 */     // (smax:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMAXsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 123618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv4i32),
     /* 123621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123623 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123630 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123636 */     GIR_RootConstrainSelectedInstOperands,
     /* 123637 */     // GIR_Coverage, 1200,
     /* 123637 */     GIR_EraseRootFromParent_Done,
     /* 123638 */   // Label 2424: @123638
     /* 123638 */   GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(123699), // Rule ID 3318 //
     /* 123643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123658 */     // (smax:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMAXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 123658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXs32),
     /* 123673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123675 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123682 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123688 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123697 */     GIR_RootConstrainSelectedInstOperands,
     /* 123698 */     // GIR_Coverage, 3318,
     /* 123698 */     GIR_EraseRootFromParent_Done,
     /* 123699 */   // Label 2425: @123699
     /* 123699 */   GIM_Reject,
     /* 123700 */ // Label 2423: @123700
     /* 123700 */ GIM_Reject,
     /* 123701 */ // Label 2417: @123701
     /* 123701 */ GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(123747), // Rule ID 1201 //
     /* 123706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 123712 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 123715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123723 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123727 */   // (smax:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMAXsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 123727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv8i8),
     /* 123730 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123732 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123734 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123739 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123745 */   GIR_RootConstrainSelectedInstOperands,
     /* 123746 */   // GIR_Coverage, 1201,
     /* 123746 */   GIR_EraseRootFromParent_Done,
     /* 123747 */ // Label 2426: @123747
     /* 123747 */ GIM_Reject,
     /* 123748 */ // Label 2418: @123748
     /* 123748 */ GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(123861),
     /* 123753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 123756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 123759 */   GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(123799), // Rule ID 1199 //
     /* 123764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123779 */     // (smax:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMAXsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 123779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv8i16),
     /* 123782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123797 */     GIR_RootConstrainSelectedInstOperands,
     /* 123798 */     // GIR_Coverage, 1199,
     /* 123798 */     GIR_EraseRootFromParent_Done,
     /* 123799 */   // Label 2428: @123799
     /* 123799 */   GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(123860), // Rule ID 3315 //
     /* 123804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123819 */     // (smax:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMAXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 123819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXs16),
     /* 123834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123836 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123843 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123849 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123858 */     GIR_RootConstrainSelectedInstOperands,
     /* 123859 */     // GIR_Coverage, 3315,
     /* 123859 */     GIR_EraseRootFromParent_Done,
     /* 123860 */   // Label 2429: @123860
     /* 123860 */   GIM_Reject,
     /* 123861 */ // Label 2427: @123861
     /* 123861 */ GIM_Reject,
     /* 123862 */ // Label 2419: @123862
     /* 123862 */ GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(123975),
     /* 123867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 123870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 123873 */   GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(123913), // Rule ID 1202 //
     /* 123878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123893 */     // (smax:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMAXsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 123893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv16i8),
     /* 123896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123898 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123911 */     GIR_RootConstrainSelectedInstOperands,
     /* 123912 */     // GIR_Coverage, 1202,
     /* 123912 */     GIR_EraseRootFromParent_Done,
     /* 123913 */   // Label 2431: @123913
     /* 123913 */   GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(123974), // Rule ID 3312 //
     /* 123918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123933 */     // (smax:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMAXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 123933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXs8),
     /* 123948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123950 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123957 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123963 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123972 */     GIR_RootConstrainSelectedInstOperands,
     /* 123973 */     // GIR_Coverage, 3312,
     /* 123973 */     GIR_EraseRootFromParent_Done,
     /* 123974 */   // Label 2432: @123974
     /* 123974 */   GIM_Reject,
     /* 123975 */ // Label 2430: @123975
     /* 123975 */ GIM_Reject,
     /* 123976 */ // Label 2420: @123976
     /* 123976 */ GIM_Reject,
     /* 123977 */ // Label 57: @123977
     /* 123977 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2439*/ GIMT_Encode4(124897),
     /* 123988 */ /*GILLT_v2s32*//*Label 2433*/ GIMT_Encode4(124036), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124000 */ /*GILLT_v4s16*//*Label 2434*/ GIMT_Encode4(124083),
     /* 124004 */ /*GILLT_v4s32*//*Label 2435*/ GIMT_Encode4(124130), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124016 */ /*GILLT_v8s8*//*Label 2436*/ GIMT_Encode4(124370),
     /* 124020 */ /*GILLT_v8s16*//*Label 2437*/ GIMT_Encode4(124417), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124032 */ /*GILLT_v16s8*//*Label 2438*/ GIMT_Encode4(124657),
     /* 124036 */ // Label 2433: @124036
     /* 124036 */ GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(124082), // Rule ID 1224 //
     /* 124041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 124047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 124050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124058 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124062 */   // (umin:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMINuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 124062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv2i32),
     /* 124065 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124067 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124069 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124071 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124074 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124080 */   GIR_RootConstrainSelectedInstOperands,
     /* 124081 */   // GIR_Coverage, 1224,
     /* 124081 */   GIR_EraseRootFromParent_Done,
     /* 124082 */ // Label 2440: @124082
     /* 124082 */ GIM_Reject,
     /* 124083 */ // Label 2434: @124083
     /* 124083 */ GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(124129), // Rule ID 1223 //
     /* 124088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 124094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 124097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124101 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124105 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124109 */   // (umin:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMINuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 124109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv4i16),
     /* 124112 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124114 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124116 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124118 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124121 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124127 */   GIR_RootConstrainSelectedInstOperands,
     /* 124128 */   // GIR_Coverage, 1223,
     /* 124128 */   GIR_EraseRootFromParent_Done,
     /* 124129 */ // Label 2441: @124129
     /* 124129 */ GIM_Reject,
     /* 124130 */ // Label 2435: @124130
     /* 124130 */ GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(124369),
     /* 124135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 124138 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 124141 */   GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(124204), // Rule ID 6027 //
     /* 124146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 124165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124176 */     // (umin:{ *:[v4i32] } (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm), MQPR:{ *:[v4i32] }:$Qd)  =>  (MVE_VMINAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 124176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs32),
     /* 124179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 124183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124190 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124196 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124202 */     GIR_RootConstrainSelectedInstOperands,
     /* 124203 */     // GIR_Coverage, 6027,
     /* 124203 */     GIR_EraseRootFromParent_Done,
     /* 124204 */   // Label 2443: @124204
     /* 124204 */   GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(124267), // Rule ID 3697 //
     /* 124209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 124232 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124239 */     // (umin:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm))  =>  (MVE_VMINAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 124239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs32),
     /* 124242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124244 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124253 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124259 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124265 */     GIR_RootConstrainSelectedInstOperands,
     /* 124266 */     // GIR_Coverage, 3697,
     /* 124266 */     GIR_EraseRootFromParent_Done,
     /* 124267 */   // Label 2444: @124267
     /* 124267 */   GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(124307), // Rule ID 1226 //
     /* 124272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124287 */     // (umin:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMINuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 124287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv4i32),
     /* 124290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124292 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124299 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124305 */     GIR_RootConstrainSelectedInstOperands,
     /* 124306 */     // GIR_Coverage, 1226,
     /* 124306 */     GIR_EraseRootFromParent_Done,
     /* 124307 */   // Label 2445: @124307
     /* 124307 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(124368), // Rule ID 3309 //
     /* 124312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124327 */     // (umin:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMINu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 124327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 124330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 124334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINu32),
     /* 124342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 124346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 124348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124351 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124357 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124366 */     GIR_RootConstrainSelectedInstOperands,
     /* 124367 */     // GIR_Coverage, 3309,
     /* 124367 */     GIR_EraseRootFromParent_Done,
     /* 124368 */   // Label 2446: @124368
     /* 124368 */   GIM_Reject,
     /* 124369 */ // Label 2442: @124369
     /* 124369 */ GIM_Reject,
     /* 124370 */ // Label 2436: @124370
     /* 124370 */ GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(124416), // Rule ID 1227 //
     /* 124375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 124381 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 124384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124392 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124396 */   // (umin:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMINuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 124396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv8i8),
     /* 124399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124401 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124403 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124408 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124414 */   GIR_RootConstrainSelectedInstOperands,
     /* 124415 */   // GIR_Coverage, 1227,
     /* 124415 */   GIR_EraseRootFromParent_Done,
     /* 124416 */ // Label 2447: @124416
     /* 124416 */ GIM_Reject,
     /* 124417 */ // Label 2437: @124417
     /* 124417 */ GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(124656),
     /* 124422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 124425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 124428 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(124491), // Rule ID 6026 //
     /* 124433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 124452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124463 */     // (umin:{ *:[v8i16] } (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm), MQPR:{ *:[v8i16] }:$Qd)  =>  (MVE_VMINAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 124463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs16),
     /* 124466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 124470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124477 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124483 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124489 */     GIR_RootConstrainSelectedInstOperands,
     /* 124490 */     // GIR_Coverage, 6026,
     /* 124490 */     GIR_EraseRootFromParent_Done,
     /* 124491 */   // Label 2449: @124491
     /* 124491 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(124554), // Rule ID 3695 //
     /* 124496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 124519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124526 */     // (umin:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm))  =>  (MVE_VMINAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 124526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs16),
     /* 124529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124531 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124540 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124546 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124552 */     GIR_RootConstrainSelectedInstOperands,
     /* 124553 */     // GIR_Coverage, 3695,
     /* 124553 */     GIR_EraseRootFromParent_Done,
     /* 124554 */   // Label 2450: @124554
     /* 124554 */   GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(124594), // Rule ID 1225 //
     /* 124559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124574 */     // (umin:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMINuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 124574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv8i16),
     /* 124577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124579 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124586 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124592 */     GIR_RootConstrainSelectedInstOperands,
     /* 124593 */     // GIR_Coverage, 1225,
     /* 124593 */     GIR_EraseRootFromParent_Done,
     /* 124594 */   // Label 2451: @124594
     /* 124594 */   GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(124655), // Rule ID 3306 //
     /* 124599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124614 */     // (umin:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMINu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 124614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 124617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 124621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINu16),
     /* 124629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124631 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 124633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 124635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124638 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124644 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124653 */     GIR_RootConstrainSelectedInstOperands,
     /* 124654 */     // GIR_Coverage, 3306,
     /* 124654 */     GIR_EraseRootFromParent_Done,
     /* 124655 */   // Label 2452: @124655
     /* 124655 */   GIM_Reject,
     /* 124656 */ // Label 2448: @124656
     /* 124656 */ GIM_Reject,
     /* 124657 */ // Label 2438: @124657
     /* 124657 */ GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(124896),
     /* 124662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 124665 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 124668 */   GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(124731), // Rule ID 6025 //
     /* 124673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 124692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124703 */     // (umin:{ *:[v16i8] } (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm), MQPR:{ *:[v16i8] }:$Qd)  =>  (MVE_VMINAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 124703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs8),
     /* 124706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 124710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124717 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124723 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124729 */     GIR_RootConstrainSelectedInstOperands,
     /* 124730 */     // GIR_Coverage, 6025,
     /* 124730 */     GIR_EraseRootFromParent_Done,
     /* 124731 */   // Label 2454: @124731
     /* 124731 */   GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(124794), // Rule ID 3693 //
     /* 124736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 124759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124766 */     // (umin:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm))  =>  (MVE_VMINAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 124766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs8),
     /* 124769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124771 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124780 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124786 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124792 */     GIR_RootConstrainSelectedInstOperands,
     /* 124793 */     // GIR_Coverage, 3693,
     /* 124793 */     GIR_EraseRootFromParent_Done,
     /* 124794 */   // Label 2455: @124794
     /* 124794 */   GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(124834), // Rule ID 1228 //
     /* 124799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124814 */     // (umin:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMINuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 124814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv16i8),
     /* 124817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124826 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124832 */     GIR_RootConstrainSelectedInstOperands,
     /* 124833 */     // GIR_Coverage, 1228,
     /* 124833 */     GIR_EraseRootFromParent_Done,
     /* 124834 */   // Label 2456: @124834
     /* 124834 */   GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(124895), // Rule ID 3303 //
     /* 124839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124854 */     // (umin:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMINu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 124854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 124857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 124861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINu8),
     /* 124869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124871 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 124873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 124875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124878 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124884 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124893 */     GIR_RootConstrainSelectedInstOperands,
     /* 124894 */     // GIR_Coverage, 3303,
     /* 124894 */     GIR_EraseRootFromParent_Done,
     /* 124895 */   // Label 2457: @124895
     /* 124895 */   GIM_Reject,
     /* 124896 */ // Label 2453: @124896
     /* 124896 */ GIM_Reject,
     /* 124897 */ // Label 2439: @124897
     /* 124897 */ GIM_Reject,
     /* 124898 */ // Label 58: @124898
     /* 124898 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2464*/ GIMT_Encode4(125818),
     /* 124909 */ /*GILLT_v2s32*//*Label 2458*/ GIMT_Encode4(124957), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124921 */ /*GILLT_v4s16*//*Label 2459*/ GIMT_Encode4(125004),
     /* 124925 */ /*GILLT_v4s32*//*Label 2460*/ GIMT_Encode4(125051), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124937 */ /*GILLT_v8s8*//*Label 2461*/ GIMT_Encode4(125291),
     /* 124941 */ /*GILLT_v8s16*//*Label 2462*/ GIMT_Encode4(125338), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124953 */ /*GILLT_v16s8*//*Label 2463*/ GIMT_Encode4(125578),
     /* 124957 */ // Label 2458: @124957
     /* 124957 */ GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(125003), // Rule ID 1204 //
     /* 124962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 124968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 124971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124975 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124979 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124983 */   // (umax:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMAXuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 124983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv2i32),
     /* 124986 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124988 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124990 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124992 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124995 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125001 */   GIR_RootConstrainSelectedInstOperands,
     /* 125002 */   // GIR_Coverage, 1204,
     /* 125002 */   GIR_EraseRootFromParent_Done,
     /* 125003 */ // Label 2465: @125003
     /* 125003 */ GIM_Reject,
     /* 125004 */ // Label 2459: @125004
     /* 125004 */ GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(125050), // Rule ID 1203 //
     /* 125009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 125015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 125018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125026 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125030 */   // (umax:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMAXuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 125030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv4i16),
     /* 125033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125035 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125037 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125042 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125048 */   GIR_RootConstrainSelectedInstOperands,
     /* 125049 */   // GIR_Coverage, 1203,
     /* 125049 */   GIR_EraseRootFromParent_Done,
     /* 125050 */ // Label 2466: @125050
     /* 125050 */ GIM_Reject,
     /* 125051 */ // Label 2460: @125051
     /* 125051 */ GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(125290),
     /* 125056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 125059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 125062 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(125125), // Rule ID 6030 //
     /* 125067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 125086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125097 */     // (umax:{ *:[v4i32] } (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm), MQPR:{ *:[v4i32] }:$Qd)  =>  (MVE_VMAXAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 125097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs32),
     /* 125100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 125104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125111 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125117 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125123 */     GIR_RootConstrainSelectedInstOperands,
     /* 125124 */     // GIR_Coverage, 6030,
     /* 125124 */     GIR_EraseRootFromParent_Done,
     /* 125125 */   // Label 2468: @125125
     /* 125125 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(125188), // Rule ID 3703 //
     /* 125130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 125153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125160 */     // (umax:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm))  =>  (MVE_VMAXAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 125160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs32),
     /* 125163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125165 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 125167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125174 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125180 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125186 */     GIR_RootConstrainSelectedInstOperands,
     /* 125187 */     // GIR_Coverage, 3703,
     /* 125187 */     GIR_EraseRootFromParent_Done,
     /* 125188 */   // Label 2469: @125188
     /* 125188 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(125228), // Rule ID 1206 //
     /* 125193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125208 */     // (umax:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMAXuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 125208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv4i32),
     /* 125211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125213 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125220 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125226 */     GIR_RootConstrainSelectedInstOperands,
     /* 125227 */     // GIR_Coverage, 1206,
     /* 125227 */     GIR_EraseRootFromParent_Done,
     /* 125228 */   // Label 2470: @125228
     /* 125228 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(125289), // Rule ID 3327 //
     /* 125233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125248 */     // (umax:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMAXu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 125248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXu32),
     /* 125263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125265 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 125267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 125269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125272 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125278 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125287 */     GIR_RootConstrainSelectedInstOperands,
     /* 125288 */     // GIR_Coverage, 3327,
     /* 125288 */     GIR_EraseRootFromParent_Done,
     /* 125289 */   // Label 2471: @125289
     /* 125289 */   GIM_Reject,
     /* 125290 */ // Label 2467: @125290
     /* 125290 */ GIM_Reject,
     /* 125291 */ // Label 2461: @125291
     /* 125291 */ GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(125337), // Rule ID 1207 //
     /* 125296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 125302 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 125305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125309 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125313 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125317 */   // (umax:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMAXuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 125317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv8i8),
     /* 125320 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125322 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125324 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125326 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125329 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125335 */   GIR_RootConstrainSelectedInstOperands,
     /* 125336 */   // GIR_Coverage, 1207,
     /* 125336 */   GIR_EraseRootFromParent_Done,
     /* 125337 */ // Label 2472: @125337
     /* 125337 */ GIM_Reject,
     /* 125338 */ // Label 2462: @125338
     /* 125338 */ GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(125577),
     /* 125343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 125346 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 125349 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(125412), // Rule ID 6029 //
     /* 125354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 125373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125384 */     // (umax:{ *:[v8i16] } (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm), MQPR:{ *:[v8i16] }:$Qd)  =>  (MVE_VMAXAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 125384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs16),
     /* 125387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 125391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125398 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125404 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125410 */     GIR_RootConstrainSelectedInstOperands,
     /* 125411 */     // GIR_Coverage, 6029,
     /* 125411 */     GIR_EraseRootFromParent_Done,
     /* 125412 */   // Label 2474: @125412
     /* 125412 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(125475), // Rule ID 3701 //
     /* 125417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 125440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125447 */     // (umax:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm))  =>  (MVE_VMAXAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 125447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs16),
     /* 125450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125452 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 125454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125461 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125467 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125473 */     GIR_RootConstrainSelectedInstOperands,
     /* 125474 */     // GIR_Coverage, 3701,
     /* 125474 */     GIR_EraseRootFromParent_Done,
     /* 125475 */   // Label 2475: @125475
     /* 125475 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(125515), // Rule ID 1205 //
     /* 125480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125495 */     // (umax:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMAXuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 125495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv8i16),
     /* 125498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125500 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125507 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125513 */     GIR_RootConstrainSelectedInstOperands,
     /* 125514 */     // GIR_Coverage, 1205,
     /* 125514 */     GIR_EraseRootFromParent_Done,
     /* 125515 */   // Label 2476: @125515
     /* 125515 */   GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(125576), // Rule ID 3324 //
     /* 125520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125535 */     // (umax:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMAXu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 125535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXu16),
     /* 125550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125552 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 125554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 125556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125559 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125565 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125574 */     GIR_RootConstrainSelectedInstOperands,
     /* 125575 */     // GIR_Coverage, 3324,
     /* 125575 */     GIR_EraseRootFromParent_Done,
     /* 125576 */   // Label 2477: @125576
     /* 125576 */   GIM_Reject,
     /* 125577 */ // Label 2473: @125577
     /* 125577 */ GIM_Reject,
     /* 125578 */ // Label 2463: @125578
     /* 125578 */ GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(125817),
     /* 125583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 125589 */   GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(125652), // Rule ID 6028 //
     /* 125594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125624 */     // (umax:{ *:[v16i8] } (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm), MQPR:{ *:[v16i8] }:$Qd)  =>  (MVE_VMAXAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 125624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs8),
     /* 125627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 125631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125638 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125644 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125650 */     GIR_RootConstrainSelectedInstOperands,
     /* 125651 */     // GIR_Coverage, 6028,
     /* 125651 */     GIR_EraseRootFromParent_Done,
     /* 125652 */   // Label 2479: @125652
     /* 125652 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(125715), // Rule ID 3699 //
     /* 125657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125687 */     // (umax:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm))  =>  (MVE_VMAXAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 125687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs8),
     /* 125690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125692 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 125694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125701 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125707 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125713 */     GIR_RootConstrainSelectedInstOperands,
     /* 125714 */     // GIR_Coverage, 3699,
     /* 125714 */     GIR_EraseRootFromParent_Done,
     /* 125715 */   // Label 2480: @125715
     /* 125715 */   GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(125755), // Rule ID 1208 //
     /* 125720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125735 */     // (umax:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMAXuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 125735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv16i8),
     /* 125738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125740 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125747 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125753 */     GIR_RootConstrainSelectedInstOperands,
     /* 125754 */     // GIR_Coverage, 1208,
     /* 125754 */     GIR_EraseRootFromParent_Done,
     /* 125755 */   // Label 2481: @125755
     /* 125755 */   GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(125816), // Rule ID 3321 //
     /* 125760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125775 */     // (umax:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMAXu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 125775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXu8),
     /* 125790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125792 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 125794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 125796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125799 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125805 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125814 */     GIR_RootConstrainSelectedInstOperands,
     /* 125815 */     // GIR_Coverage, 3321,
     /* 125815 */     GIR_EraseRootFromParent_Done,
     /* 125816 */   // Label 2482: @125816
     /* 125816 */   GIM_Reject,
     /* 125817 */ // Label 2478: @125817
     /* 125817 */ GIM_Reject,
     /* 125818 */ // Label 2464: @125818
     /* 125818 */ GIM_Reject,
     /* 125819 */ // Label 59: @125819
     /* 125819 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2489*/ GIMT_Encode4(126289),
     /* 125830 */ /*GILLT_v2s32*//*Label 2483*/ GIMT_Encode4(125878), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125842 */ /*GILLT_v4s16*//*Label 2484*/ GIMT_Encode4(125916),
     /* 125846 */ /*GILLT_v4s32*//*Label 2485*/ GIMT_Encode4(125954), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125858 */ /*GILLT_v8s8*//*Label 2486*/ GIMT_Encode4(126053),
     /* 125862 */ /*GILLT_v8s16*//*Label 2487*/ GIMT_Encode4(126091), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125874 */ /*GILLT_v16s8*//*Label 2488*/ GIMT_Encode4(126190),
     /* 125878 */ // Label 2483: @125878
     /* 125878 */ GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(125915), // Rule ID 1510 //
     /* 125883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 125889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125897 */   // (abs:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VABSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /* 125897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv2i32),
     /* 125900 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125902 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125907 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125913 */   GIR_RootConstrainSelectedInstOperands,
     /* 125914 */   // GIR_Coverage, 1510,
     /* 125914 */   GIR_EraseRootFromParent_Done,
     /* 125915 */ // Label 2490: @125915
     /* 125915 */ GIM_Reject,
     /* 125916 */ // Label 2484: @125916
     /* 125916 */ GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(125953), // Rule ID 1509 //
     /* 125921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 125927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125935 */   // (abs:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VABSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /* 125935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv4i16),
     /* 125938 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125940 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125942 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125945 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125951 */   GIR_RootConstrainSelectedInstOperands,
     /* 125952 */   // GIR_Coverage, 1509,
     /* 125952 */   GIR_EraseRootFromParent_Done,
     /* 125953 */ // Label 2491: @125953
     /* 125953 */ GIM_Reject,
     /* 125954 */ // Label 2485: @125954
     /* 125954 */ GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(126052),
     /* 125959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 125962 */   GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(125996), // Rule ID 1513 //
     /* 125967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125978 */     // (abs:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VABSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /* 125978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv4i32),
     /* 125981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125983 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125988 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125994 */     GIR_RootConstrainSelectedInstOperands,
     /* 125995 */     // GIR_Coverage, 1513,
     /* 125995 */     GIR_EraseRootFromParent_Done,
     /* 125996 */   // Label 2493: @125996
     /* 125996 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(126051), // Rule ID 3672 //
     /* 126001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126012 */     // (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v)  =>  (MVE_VABSs32:{ *:[v4i32] } ?:{ *:[v4i32] }:$v)
     /* 126012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 126015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSs32),
     /* 126027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126029 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 126031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126034 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126040 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126049 */     GIR_RootConstrainSelectedInstOperands,
     /* 126050 */     // GIR_Coverage, 3672,
     /* 126050 */     GIR_EraseRootFromParent_Done,
     /* 126051 */   // Label 2494: @126051
     /* 126051 */   GIM_Reject,
     /* 126052 */ // Label 2492: @126052
     /* 126052 */ GIM_Reject,
     /* 126053 */ // Label 2486: @126053
     /* 126053 */ GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(126090), // Rule ID 1508 //
     /* 126058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 126064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126072 */   // (abs:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)  =>  (VABSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /* 126072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv8i8),
     /* 126075 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126077 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126079 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126082 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126088 */   GIR_RootConstrainSelectedInstOperands,
     /* 126089 */   // GIR_Coverage, 1508,
     /* 126089 */   GIR_EraseRootFromParent_Done,
     /* 126090 */ // Label 2495: @126090
     /* 126090 */ GIM_Reject,
     /* 126091 */ // Label 2487: @126091
     /* 126091 */ GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(126189),
     /* 126096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 126099 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(126133), // Rule ID 1512 //
     /* 126104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126115 */     // (abs:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VABSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /* 126115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv8i16),
     /* 126118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126120 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126125 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126131 */     GIR_RootConstrainSelectedInstOperands,
     /* 126132 */     // GIR_Coverage, 1512,
     /* 126132 */     GIR_EraseRootFromParent_Done,
     /* 126133 */   // Label 2497: @126133
     /* 126133 */   GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(126188), // Rule ID 3666 //
     /* 126138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126149 */     // (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v)  =>  (MVE_VABSs16:{ *:[v8i16] } ?:{ *:[v8i16] }:$v)
     /* 126149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 126152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSs16),
     /* 126164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126166 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 126168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126171 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126177 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126186 */     GIR_RootConstrainSelectedInstOperands,
     /* 126187 */     // GIR_Coverage, 3666,
     /* 126187 */     GIR_EraseRootFromParent_Done,
     /* 126188 */   // Label 2498: @126188
     /* 126188 */   GIM_Reject,
     /* 126189 */ // Label 2496: @126189
     /* 126189 */ GIM_Reject,
     /* 126190 */ // Label 2488: @126190
     /* 126190 */ GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(126288),
     /* 126195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 126198 */   GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(126232), // Rule ID 1511 //
     /* 126203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126214 */     // (abs:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)  =>  (VABSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /* 126214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv16i8),
     /* 126217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126219 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126230 */     GIR_RootConstrainSelectedInstOperands,
     /* 126231 */     // GIR_Coverage, 1511,
     /* 126231 */     GIR_EraseRootFromParent_Done,
     /* 126232 */   // Label 2500: @126232
     /* 126232 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(126287), // Rule ID 3660 //
     /* 126237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126248 */     // (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v)  =>  (MVE_VABSs8:{ *:[v16i8] } ?:{ *:[v16i8] }:$v)
     /* 126248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 126251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSs8),
     /* 126263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126265 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 126267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126270 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126276 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126285 */     GIR_RootConstrainSelectedInstOperands,
     /* 126286 */     // GIR_Coverage, 3660,
     /* 126286 */     GIR_EraseRootFromParent_Done,
     /* 126287 */   // Label 2501: @126287
     /* 126287 */   GIM_Reject,
     /* 126288 */ // Label 2499: @126288
     /* 126288 */ GIM_Reject,
     /* 126289 */ // Label 2489: @126289
     /* 126289 */ GIM_Reject,
     /* 126290 */ // Label 60: @126290
     /* 126290 */ GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(126362),
     /* 126295 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 126298 */   GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(126313), // Rule ID 32 //
     /* 126303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /* 126306 */     // (br (bb:{ *:[Other] }):$target)  =>  (B (bb:{ *:[Other] }):$target)
     /* 126306 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::B),
     /* 126311 */     GIR_RootConstrainSelectedInstOperands,
     /* 126312 */     // GIR_Coverage, 32,
     /* 126312 */     GIR_Done,
     /* 126313 */   // Label 2503: @126313
     /* 126313 */   GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(126337), // Rule ID 283 //
     /* 126318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 126321 */     // (br (bb:{ *:[Other] }):$target)  =>  (tB (bb:{ *:[Other] }):$target)
     /* 126321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tB),
     /* 126324 */     GIR_RootToRootCopy, /*OpIdx*/0, // target
     /* 126326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126329 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126335 */     GIR_RootConstrainSelectedInstOperands,
     /* 126336 */     // GIR_Coverage, 283,
     /* 126336 */     GIR_EraseRootFromParent_Done,
     /* 126337 */   // Label 2504: @126337
     /* 126337 */   GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(126361), // Rule ID 577 //
     /* 126342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV8MBaseline_IsThumb),
     /* 126345 */     // (br (bb:{ *:[Other] }):$target)  =>  (t2B (bb:{ *:[Other] }):$target)
     /* 126345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2B),
     /* 126348 */     GIR_RootToRootCopy, /*OpIdx*/0, // target
     /* 126350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126353 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126359 */     GIR_RootConstrainSelectedInstOperands,
     /* 126360 */     // GIR_Coverage, 577,
     /* 126360 */     GIR_EraseRootFromParent_Done,
     /* 126361 */   // Label 2505: @126361
     /* 126361 */   GIM_Reject,
     /* 126362 */ // Label 2502: @126362
     /* 126362 */ GIM_Reject,
     /* 126363 */ // Label 61: @126363
     /* 126363 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(16), /*)*//*default:*//*Label 2510*/ GIMT_Encode4(126662),
     /* 126374 */ /*GILLT_v4s16*//*Label 2506*/ GIMT_Encode4(126410), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126390 */ /*GILLT_v8s8*//*Label 2507*/ GIMT_Encode4(126473),
     /* 126394 */ /*GILLT_v8s16*//*Label 2508*/ GIMT_Encode4(126536), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126406 */ /*GILLT_v16s8*//*Label 2509*/ GIMT_Encode4(126599),
     /* 126410 */ // Label 2506: @126410
     /* 126410 */ GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(126472), // Rule ID 1572 //
     /* 126415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 126421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126424 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126435 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126439 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126443 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126447 */   // MIs[1] Operand 1
     /* 126447 */   // No operand predicates
     /* 126447 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126449 */   // (vector_insert:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)  =>  (VSETLNi16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)
     /* 126449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSETLNi16),
     /* 126452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[V]
     /* 126454 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126456 */   GIR_RootToRootCopy, /*OpIdx*/2, // R
     /* 126458 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126464 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126470 */   GIR_RootConstrainSelectedInstOperands,
     /* 126471 */   // GIR_Coverage, 1572,
     /* 126471 */   GIR_EraseRootFromParent_Done,
     /* 126472 */ // Label 2511: @126472
     /* 126472 */ GIM_Reject,
     /* 126473 */ // Label 2507: @126473
     /* 126473 */ GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(126535), // Rule ID 1571 //
     /* 126478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 126484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126487 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126498 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126502 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126506 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126510 */   // MIs[1] Operand 1
     /* 126510 */   // No operand predicates
     /* 126510 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126512 */   // (vector_insert:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)  =>  (VSETLNi8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)
     /* 126512 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSETLNi8),
     /* 126515 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[V]
     /* 126517 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126519 */   GIR_RootToRootCopy, /*OpIdx*/2, // R
     /* 126521 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126527 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126533 */   GIR_RootConstrainSelectedInstOperands,
     /* 126534 */   // GIR_Coverage, 1571,
     /* 126534 */   GIR_EraseRootFromParent_Done,
     /* 126535 */ // Label 2512: @126535
     /* 126535 */ GIM_Reject,
     /* 126536 */ // Label 2508: @126536
     /* 126536 */ GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(126598), // Rule ID 3436 //
     /* 126541 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 126547 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126550 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126561 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126565 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126569 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126573 */   // MIs[1] Operand 1
     /* 126573 */   // No operand predicates
     /* 126573 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126575 */   // (vector_insert:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)  =>  (MVE_VMOV_to_lane_16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)
     /* 126575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOV_to_lane_16),
     /* 126578 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126580 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126582 */   GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 126584 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126587 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126590 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126596 */   GIR_RootConstrainSelectedInstOperands,
     /* 126597 */   // GIR_Coverage, 3436,
     /* 126597 */   GIR_EraseRootFromParent_Done,
     /* 126598 */ // Label 2513: @126598
     /* 126598 */ GIM_Reject,
     /* 126599 */ // Label 2509: @126599
     /* 126599 */ GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(126661), // Rule ID 3435 //
     /* 126604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 126610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126613 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126624 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126628 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126632 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126636 */   // MIs[1] Operand 1
     /* 126636 */   // No operand predicates
     /* 126636 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126638 */   // (vector_insert:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)  =>  (MVE_VMOV_to_lane_8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)
     /* 126638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOV_to_lane_8),
     /* 126641 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126643 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126645 */   GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 126647 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126650 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126653 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126659 */   GIR_RootConstrainSelectedInstOperands,
     /* 126660 */   // GIR_Coverage, 3435,
     /* 126660 */   GIR_EraseRootFromParent_Done,
     /* 126661 */ // Label 2514: @126661
     /* 126661 */ GIM_Reject,
     /* 126662 */ // Label 2510: @126662
     /* 126662 */ GIM_Reject,
     /* 126663 */ // Label 62: @126663
     /* 126663 */ GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(126719), // Rule ID 1570 //
     /* 126668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs_HasFastVGETLNi32),
     /* 126671 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 126674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 126677 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126688 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126692 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126696 */   // MIs[1] Operand 1
     /* 126696 */   // No operand predicates
     /* 126696 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126698 */   // (extractelt:{ *:[i32] } DPR:{ *:[v2i32] }:$V, (imm:{ *:[i32] }):$lane)  =>  (VGETLNi32:{ *:[i32] } DPR:{ *:[v2i32] }:$V, (imm:{ *:[i32] }):$lane)
     /* 126698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VGETLNi32),
     /* 126701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[R]
     /* 126703 */   GIR_RootToRootCopy, /*OpIdx*/1, // V
     /* 126705 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126711 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126717 */   GIR_RootConstrainSelectedInstOperands,
     /* 126718 */   // GIR_Coverage, 1570,
     /* 126718 */   GIR_EraseRootFromParent_Done,
     /* 126719 */ // Label 2515: @126719
     /* 126719 */ GIM_Reject,
     /* 126720 */ // Label 63: @126720
     /* 126720 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 2523*/ GIMT_Encode4(127280),
     /* 126731 */ /*GILLT_s32*//*Label 2516*/ GIMT_Encode4(126791), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126743 */ /*GILLT_v2s32*//*Label 2517*/ GIMT_Encode4(126869), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126755 */ /*GILLT_v4s16*//*Label 2518*/ GIMT_Encode4(126907),
     /* 126759 */ /*GILLT_v4s32*//*Label 2519*/ GIMT_Encode4(126945), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126771 */ /*GILLT_v8s8*//*Label 2520*/ GIMT_Encode4(127044),
     /* 126775 */ /*GILLT_v8s16*//*Label 2521*/ GIMT_Encode4(127082), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126787 */ /*GILLT_v16s8*//*Label 2522*/ GIMT_Encode4(127181),
     /* 126791 */ // Label 2516: @126791
     /* 126791 */ GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(126868),
     /* 126796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 126799 */   GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(126833), // Rule ID 197 //
     /* 126804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5T_IsARM),
     /* 126807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126815 */     // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$Rm)  =>  (CLZ:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 126815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CLZ),
     /* 126818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126820 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 126822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126825 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126831 */     GIR_RootConstrainSelectedInstOperands,
     /* 126832 */     // GIR_Coverage, 197,
     /* 126832 */     GIR_EraseRootFromParent_Done,
     /* 126833 */   // Label 2525: @126833
     /* 126833 */   GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(126867), // Rule ID 534 //
     /* 126838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 126841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126849 */     // (ctlz:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)  =>  (t2CLZ:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 126849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CLZ),
     /* 126852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126854 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 126856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126859 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126865 */     GIR_RootConstrainSelectedInstOperands,
     /* 126866 */     // GIR_Coverage, 534,
     /* 126866 */     GIR_EraseRootFromParent_Done,
     /* 126867 */   // Label 2526: @126867
     /* 126867 */   GIM_Reject,
     /* 126868 */ // Label 2524: @126868
     /* 126868 */ GIM_Reject,
     /* 126869 */ // Label 2517: @126869
     /* 126869 */ GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(126906), // Rule ID 1548 //
     /* 126874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 126880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126884 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126888 */   // (ctlz:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VCLZv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /* 126888 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv2i32),
     /* 126891 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126893 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126895 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126898 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126904 */   GIR_RootConstrainSelectedInstOperands,
     /* 126905 */   // GIR_Coverage, 1548,
     /* 126905 */   GIR_EraseRootFromParent_Done,
     /* 126906 */ // Label 2527: @126906
     /* 126906 */ GIM_Reject,
     /* 126907 */ // Label 2518: @126907
     /* 126907 */ GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(126944), // Rule ID 1547 //
     /* 126912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 126918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126926 */   // (ctlz:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VCLZv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /* 126926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv4i16),
     /* 126929 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126931 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126936 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126942 */   GIR_RootConstrainSelectedInstOperands,
     /* 126943 */   // GIR_Coverage, 1547,
     /* 126943 */   GIR_EraseRootFromParent_Done,
     /* 126944 */ // Label 2528: @126944
     /* 126944 */ GIM_Reject,
     /* 126945 */ // Label 2519: @126945
     /* 126945 */ GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(127043),
     /* 126950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 126953 */   GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(126987), // Rule ID 1551 //
     /* 126958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126969 */     // (ctlz:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VCLZv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /* 126969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv4i32),
     /* 126972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126974 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126979 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126985 */     GIR_RootConstrainSelectedInstOperands,
     /* 126986 */     // GIR_Coverage, 1551,
     /* 126986 */     GIR_EraseRootFromParent_Done,
     /* 126987 */   // Label 2530: @126987
     /* 126987 */   GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(127042), // Rule ID 3658 //
     /* 126992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127003 */     // (ctlz:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val)  =>  (MVE_VCLZs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val)
     /* 127003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLZs32),
     /* 127018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127020 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 127022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127025 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127031 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127040 */     GIR_RootConstrainSelectedInstOperands,
     /* 127041 */     // GIR_Coverage, 3658,
     /* 127041 */     GIR_EraseRootFromParent_Done,
     /* 127042 */   // Label 2531: @127042
     /* 127042 */   GIM_Reject,
     /* 127043 */ // Label 2529: @127043
     /* 127043 */ GIM_Reject,
     /* 127044 */ // Label 2520: @127044
     /* 127044 */ GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(127081), // Rule ID 1546 //
     /* 127049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 127055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127059 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127063 */   // (ctlz:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)  =>  (VCLZv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /* 127063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv8i8),
     /* 127066 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127068 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127070 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127073 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127079 */   GIR_RootConstrainSelectedInstOperands,
     /* 127080 */   // GIR_Coverage, 1546,
     /* 127080 */   GIR_EraseRootFromParent_Done,
     /* 127081 */ // Label 2532: @127081
     /* 127081 */ GIM_Reject,
     /* 127082 */ // Label 2521: @127082
     /* 127082 */ GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(127180),
     /* 127087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 127090 */   GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(127124), // Rule ID 1550 //
     /* 127095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127106 */     // (ctlz:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VCLZv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /* 127106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv8i16),
     /* 127109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127111 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127116 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127122 */     GIR_RootConstrainSelectedInstOperands,
     /* 127123 */     // GIR_Coverage, 1550,
     /* 127123 */     GIR_EraseRootFromParent_Done,
     /* 127124 */   // Label 2534: @127124
     /* 127124 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(127179), // Rule ID 3656 //
     /* 127129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127140 */     // (ctlz:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val)  =>  (MVE_VCLZs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val)
     /* 127140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLZs16),
     /* 127155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127157 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 127159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127162 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127168 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127177 */     GIR_RootConstrainSelectedInstOperands,
     /* 127178 */     // GIR_Coverage, 3656,
     /* 127178 */     GIR_EraseRootFromParent_Done,
     /* 127179 */   // Label 2535: @127179
     /* 127179 */   GIM_Reject,
     /* 127180 */ // Label 2533: @127180
     /* 127180 */ GIM_Reject,
     /* 127181 */ // Label 2522: @127181
     /* 127181 */ GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(127279),
     /* 127186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 127189 */   GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(127223), // Rule ID 1549 //
     /* 127194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127205 */     // (ctlz:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)  =>  (VCLZv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /* 127205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv16i8),
     /* 127208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127210 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127215 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127221 */     GIR_RootConstrainSelectedInstOperands,
     /* 127222 */     // GIR_Coverage, 1549,
     /* 127222 */     GIR_EraseRootFromParent_Done,
     /* 127223 */   // Label 2537: @127223
     /* 127223 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(127278), // Rule ID 3654 //
     /* 127228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127239 */     // (ctlz:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val)  =>  (MVE_VCLZs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val)
     /* 127239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLZs8),
     /* 127254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127256 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 127258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127261 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127267 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127276 */     GIR_RootConstrainSelectedInstOperands,
     /* 127277 */     // GIR_Coverage, 3654,
     /* 127277 */     GIR_EraseRootFromParent_Done,
     /* 127278 */   // Label 2538: @127278
     /* 127278 */   GIM_Reject,
     /* 127279 */ // Label 2536: @127279
     /* 127279 */ GIM_Reject,
     /* 127280 */ // Label 2523: @127280
     /* 127280 */ GIM_Reject,
     /* 127281 */ // Label 64: @127281
     /* 127281 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(11), GIMT_Encode2(16), /*)*//*default:*//*Label 2541*/ GIMT_Encode4(127388),
     /* 127292 */ /*GILLT_v8s8*//*Label 2539*/ GIMT_Encode4(127312), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127308 */ /*GILLT_v16s8*//*Label 2540*/ GIMT_Encode4(127350),
     /* 127312 */ // Label 2539: @127312
     /* 127312 */ GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(127349), // Rule ID 1552 //
     /* 127317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 127323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127327 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127331 */   // (ctpop:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)  =>  (VCNTd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /* 127331 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCNTd),
     /* 127334 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127336 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127338 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127341 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127347 */   GIR_RootConstrainSelectedInstOperands,
     /* 127348 */   // GIR_Coverage, 1552,
     /* 127348 */   GIR_EraseRootFromParent_Done,
     /* 127349 */ // Label 2542: @127349
     /* 127349 */ GIM_Reject,
     /* 127350 */ // Label 2540: @127350
     /* 127350 */ GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(127387), // Rule ID 1553 //
     /* 127355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 127361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127369 */   // (ctpop:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)  =>  (VCNTq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /* 127369 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCNTq),
     /* 127372 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127374 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127376 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127379 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127385 */   GIR_RootConstrainSelectedInstOperands,
     /* 127386 */   // GIR_Coverage, 1553,
     /* 127386 */   GIR_EraseRootFromParent_Done,
     /* 127387 */ // Label 2543: @127387
     /* 127387 */ GIM_Reject,
     /* 127388 */ // Label 2541: @127388
     /* 127388 */ GIM_Reject,
     /* 127389 */ // Label 65: @127389
     /* 127389 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 2547*/ GIMT_Encode4(127678),
     /* 127400 */ /*GILLT_s32*//*Label 2544*/ GIMT_Encode4(127448), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127428 */ /*GILLT_v4s32*//*Label 2545*/ GIMT_Encode4(127560), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127444 */ /*GILLT_v8s16*//*Label 2546*/ GIMT_Encode4(127619),
     /* 127448 */ // Label 2544: @127448
     /* 127448 */ GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(127559),
     /* 127453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 127456 */   GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(127490), // Rule ID 199 //
     /* 127461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 127464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127472 */     // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$Rm)  =>  (REV:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 127472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REV),
     /* 127475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127477 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127482 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127488 */     GIR_RootConstrainSelectedInstOperands,
     /* 127489 */     // GIR_Coverage, 199,
     /* 127489 */     GIR_EraseRootFromParent_Done,
     /* 127490 */   // Label 2549: @127490
     /* 127490 */   GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(127524), // Rule ID 326 //
     /* 127495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 127498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 127502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 127506 */     // (bswap:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)  =>  (tREV:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 127506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tREV),
     /* 127509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127511 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127516 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127522 */     GIR_RootConstrainSelectedInstOperands,
     /* 127523 */     // GIR_Coverage, 326,
     /* 127523 */     GIR_EraseRootFromParent_Done,
     /* 127524 */   // Label 2550: @127524
     /* 127524 */   GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(127558), // Rule ID 536 //
     /* 127529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 127532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127540 */     // (bswap:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)  =>  (t2REV:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 127540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REV),
     /* 127543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127545 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127550 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127556 */     GIR_RootConstrainSelectedInstOperands,
     /* 127557 */     // GIR_Coverage, 536,
     /* 127557 */     GIR_EraseRootFromParent_Done,
     /* 127558 */   // Label 2551: @127558
     /* 127558 */   GIM_Reject,
     /* 127559 */ // Label 2548: @127559
     /* 127559 */ GIM_Reject,
     /* 127560 */ // Label 2545: @127560
     /* 127560 */ GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(127618), // Rule ID 3331 //
     /* 127565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 127571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127579 */   // (bswap:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_8:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src)
     /* 127579 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127582 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127586 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /* 127594 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127596 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 127598 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127601 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127607 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127613 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127616 */   GIR_RootConstrainSelectedInstOperands,
     /* 127617 */   // GIR_Coverage, 3331,
     /* 127617 */   GIR_EraseRootFromParent_Done,
     /* 127618 */ // Label 2552: @127618
     /* 127618 */ GIM_Reject,
     /* 127619 */ // Label 2546: @127619
     /* 127619 */ GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(127677), // Rule ID 3330 //
     /* 127624 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 127630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127638 */   // (bswap:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV16_8:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src)
     /* 127638 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127641 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127645 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /* 127653 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127655 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 127657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127660 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127666 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127672 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127675 */   GIR_RootConstrainSelectedInstOperands,
     /* 127676 */   // GIR_Coverage, 3330,
     /* 127676 */   GIR_EraseRootFromParent_Done,
     /* 127677 */ // Label 2553: @127677
     /* 127677 */ GIM_Reject,
     /* 127678 */ // Label 2547: @127678
     /* 127678 */ GIM_Reject,
     /* 127679 */ // Label 66: @127679
     /* 127679 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 2558*/ GIMT_Encode4(128110),
     /* 127690 */ /*GILLT_s32*//*Label 2554*/ GIMT_Encode4(127750), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127718 */ /*GILLT_v4s32*//*Label 2555*/ GIMT_Encode4(127828), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127734 */ /*GILLT_v8s16*//*Label 2556*/ GIMT_Encode4(127922), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127746 */ /*GILLT_v16s8*//*Label 2557*/ GIMT_Encode4(128016),
     /* 127750 */ // Label 2554: @127750
     /* 127750 */ GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(127827),
     /* 127755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 127758 */   GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(127792), // Rule ID 198 //
     /* 127763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /* 127766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127774 */     // (bitreverse:{ *:[i32] } GPR:{ *:[i32] }:$Rm)  =>  (RBIT:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 127774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::RBIT),
     /* 127777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127779 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127784 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127790 */     GIR_RootConstrainSelectedInstOperands,
     /* 127791 */     // GIR_Coverage, 198,
     /* 127791 */     GIR_EraseRootFromParent_Done,
     /* 127792 */   // Label 2560: @127792
     /* 127792 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(127826), // Rule ID 535 //
     /* 127797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 127800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127808 */     // (bitreverse:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)  =>  (t2RBIT:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 127808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RBIT),
     /* 127811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127813 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127818 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127824 */     GIR_RootConstrainSelectedInstOperands,
     /* 127825 */     // GIR_Coverage, 535,
     /* 127825 */     GIR_EraseRootFromParent_Done,
     /* 127826 */   // Label 2561: @127826
     /* 127826 */   GIM_Reject,
     /* 127827 */ // Label 2559: @127827
     /* 127827 */ GIM_Reject,
     /* 127828 */ // Label 2555: @127828
     /* 127828 */ GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(127921), // Rule ID 4758 //
     /* 127833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 127839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127847 */   // (bitreverse:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val1)  =>  (MVE_VBRSR32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val1, (t2MOVi:{ *:[i32] } 32:{ *:[i32] }))
     /* 127847 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 127850 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127854 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127859 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127862 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 127866 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127871 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 127874 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 127877 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127883 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127889 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR32),
     /* 127894 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127896 */   GIR_RootToRootCopy, /*OpIdx*/1, // val1
     /* 127898 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127901 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127904 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127910 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127916 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 127919 */   GIR_RootConstrainSelectedInstOperands,
     /* 127920 */   // GIR_Coverage, 4758,
     /* 127920 */   GIR_EraseRootFromParent_Done,
     /* 127921 */ // Label 2562: @127921
     /* 127921 */ GIM_Reject,
     /* 127922 */ // Label 2556: @127922
     /* 127922 */ GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(128015), // Rule ID 4759 //
     /* 127927 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 127933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127937 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127941 */   // (bitreverse:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val1)  =>  (MVE_VBRSR16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val1, (t2MOVi:{ *:[i32] } 16:{ *:[i32] }))
     /* 127941 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 127944 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127948 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127953 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127956 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 127960 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127965 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 127968 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 127971 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127977 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127983 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127985 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR16),
     /* 127988 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127990 */   GIR_RootToRootCopy, /*OpIdx*/1, // val1
     /* 127992 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127998 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128004 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128010 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 128013 */   GIR_RootConstrainSelectedInstOperands,
     /* 128014 */   // GIR_Coverage, 4759,
     /* 128014 */   GIR_EraseRootFromParent_Done,
     /* 128015 */ // Label 2563: @128015
     /* 128015 */ GIM_Reject,
     /* 128016 */ // Label 2557: @128016
     /* 128016 */ GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(128109), // Rule ID 4757 //
     /* 128021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 128024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 128027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128035 */   // (bitreverse:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val1)  =>  (MVE_VBRSR8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val1, (t2MOVi:{ *:[i32] } 8:{ *:[i32] }))
     /* 128035 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 128038 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128042 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128047 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128050 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 128054 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128059 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 128062 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 128065 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128071 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128077 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR8),
     /* 128082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128084 */   GIR_RootToRootCopy, /*OpIdx*/1, // val1
     /* 128086 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128089 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128092 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128098 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128104 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 128107 */   GIR_RootConstrainSelectedInstOperands,
     /* 128108 */   // GIR_Coverage, 4757,
     /* 128108 */   GIR_EraseRootFromParent_Done,
     /* 128109 */ // Label 2564: @128109
     /* 128109 */ GIM_Reject,
     /* 128110 */ // Label 2558: @128110
     /* 128110 */ GIM_Reject,
     /* 128111 */ // Label 67: @128111
     /* 128111 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2570*/ GIMT_Encode4(128373),
     /* 128122 */ /*GILLT_s16*//*Label 2565*/ GIMT_Encode4(128174),
     /* 128126 */ /*GILLT_s32*//*Label 2566*/ GIMT_Encode4(128201),
     /* 128130 */ /*GILLT_s64*//*Label 2567*/ GIMT_Encode4(128228), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128154 */ /*GILLT_v4s32*//*Label 2568*/ GIMT_Encode4(128255), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128170 */ /*GILLT_v8s16*//*Label 2569*/ GIMT_Encode4(128314),
     /* 128174 */ // Label 2565: @128174
     /* 128174 */ GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(128200), // Rule ID 683 //
     /* 128179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128193 */   // (fceil:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTPH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128193 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPH),
     /* 128198 */   GIR_RootConstrainSelectedInstOperands,
     /* 128199 */   // GIR_Coverage, 683,
     /* 128199 */   GIR_Done,
     /* 128200 */ // Label 2571: @128200
     /* 128200 */ GIM_Reject,
     /* 128201 */ // Label 2566: @128201
     /* 128201 */ GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(128227), // Rule ID 684 //
     /* 128206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 128209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128220 */   // (fceil:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTPS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128220 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPS),
     /* 128225 */   GIR_RootConstrainSelectedInstOperands,
     /* 128226 */   // GIR_Coverage, 684,
     /* 128226 */   GIR_Done,
     /* 128227 */ // Label 2572: @128227
     /* 128227 */ GIM_Reject,
     /* 128228 */ // Label 2567: @128228
     /* 128228 */ GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(128254), // Rule ID 685 //
     /* 128233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 128236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128243 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128247 */   // (fceil:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTPD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128247 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPD),
     /* 128252 */   GIR_RootConstrainSelectedInstOperands,
     /* 128253 */   // GIR_Coverage, 685,
     /* 128253 */   GIR_Done,
     /* 128254 */ // Label 2573: @128254
     /* 128254 */ GIM_Reject,
     /* 128255 */ // Label 2568: @128255
     /* 128255 */ GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(128313), // Rule ID 3986 //
     /* 128260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 128266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128274 */   // (fceil:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32P:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /* 128274 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128277 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128281 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32P),
     /* 128289 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128291 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128293 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128296 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128302 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128308 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128311 */   GIR_RootConstrainSelectedInstOperands,
     /* 128312 */   // GIR_Coverage, 3986,
     /* 128312 */   GIR_EraseRootFromParent_Done,
     /* 128313 */ // Label 2574: @128313
     /* 128313 */ GIM_Reject,
     /* 128314 */ // Label 2569: @128314
     /* 128314 */ GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(128372), // Rule ID 3974 //
     /* 128319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 128325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128333 */   // (fceil:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16P:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /* 128333 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128336 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128340 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16P),
     /* 128348 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128350 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128355 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128361 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128367 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128370 */   GIR_RootConstrainSelectedInstOperands,
     /* 128371 */   // GIR_Coverage, 3974,
     /* 128371 */   GIR_EraseRootFromParent_Done,
     /* 128372 */ // Label 2575: @128372
     /* 128372 */ GIM_Reject,
     /* 128373 */ // Label 2570: @128373
     /* 128373 */ GIM_Reject,
     /* 128374 */ // Label 68: @128374
     /* 128374 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2579*/ GIMT_Encode4(128511),
     /* 128385 */ /*GILLT_s16*//*Label 2576*/ GIMT_Encode4(128397),
     /* 128389 */ /*GILLT_s32*//*Label 2577*/ GIMT_Encode4(128435),
     /* 128393 */ /*GILLT_s64*//*Label 2578*/ GIMT_Encode4(128473),
     /* 128397 */ // Label 2576: @128397
     /* 128397 */ GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(128434), // Rule ID 691 //
     /* 128402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128416 */   // (fsqrt:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VSQRTH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSQRTH),
     /* 128419 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128421 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128423 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128426 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128432 */   GIR_RootConstrainSelectedInstOperands,
     /* 128433 */   // GIR_Coverage, 691,
     /* 128433 */   GIR_EraseRootFromParent_Done,
     /* 128434 */ // Label 2580: @128434
     /* 128434 */ GIM_Reject,
     /* 128435 */ // Label 2577: @128435
     /* 128435 */ GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(128472), // Rule ID 690 //
     /* 128440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP2),
     /* 128443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128454 */   // (fsqrt:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VSQRTS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSQRTS),
     /* 128457 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128459 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128464 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128470 */   GIR_RootConstrainSelectedInstOperands,
     /* 128471 */   // GIR_Coverage, 690,
     /* 128471 */   GIR_EraseRootFromParent_Done,
     /* 128472 */ // Label 2581: @128472
     /* 128472 */ GIM_Reject,
     /* 128473 */ // Label 2578: @128473
     /* 128473 */ GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(128510), // Rule ID 689 //
     /* 128478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 128481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128492 */   // (fsqrt:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VSQRTD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSQRTD),
     /* 128495 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 128497 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 128499 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128502 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128508 */   GIR_RootConstrainSelectedInstOperands,
     /* 128509 */   // GIR_Coverage, 689,
     /* 128509 */   GIR_EraseRootFromParent_Done,
     /* 128510 */ // Label 2582: @128510
     /* 128510 */ GIM_Reject,
     /* 128511 */ // Label 2579: @128511
     /* 128511 */ GIM_Reject,
     /* 128512 */ // Label 69: @128512
     /* 128512 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2590*/ GIMT_Encode4(128886),
     /* 128523 */ /*GILLT_s16*//*Label 2583*/ GIMT_Encode4(128575),
     /* 128527 */ /*GILLT_s32*//*Label 2584*/ GIMT_Encode4(128602),
     /* 128531 */ /*GILLT_s64*//*Label 2585*/ GIMT_Encode4(128629), GIMT_Encode4(0),
     /* 128539 */ /*GILLT_v2s32*//*Label 2586*/ GIMT_Encode4(128656), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128551 */ /*GILLT_v4s16*//*Label 2587*/ GIMT_Encode4(128683),
     /* 128555 */ /*GILLT_v4s32*//*Label 2588*/ GIMT_Encode4(128710), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128571 */ /*GILLT_v8s16*//*Label 2589*/ GIMT_Encode4(128798),
     /* 128575 */ // Label 2583: @128575
     /* 128575 */ GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(128601), // Rule ID 686 //
     /* 128580 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128590 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128594 */   // (ffloor:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTMH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128594 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMH),
     /* 128599 */   GIR_RootConstrainSelectedInstOperands,
     /* 128600 */   // GIR_Coverage, 686,
     /* 128600 */   GIR_Done,
     /* 128601 */ // Label 2591: @128601
     /* 128601 */ GIM_Reject,
     /* 128602 */ // Label 2584: @128602
     /* 128602 */ GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(128628), // Rule ID 687 //
     /* 128607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 128610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128621 */   // (ffloor:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTMS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128621 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMS),
     /* 128626 */   GIR_RootConstrainSelectedInstOperands,
     /* 128627 */   // GIR_Coverage, 687,
     /* 128627 */   GIR_Done,
     /* 128628 */ // Label 2592: @128628
     /* 128628 */ GIM_Reject,
     /* 128629 */ // Label 2585: @128629
     /* 128629 */ GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(128655), // Rule ID 688 //
     /* 128634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 128637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128644 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128648 */   // (ffloor:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTMD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128648 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMD),
     /* 128653 */   GIR_RootConstrainSelectedInstOperands,
     /* 128654 */   // GIR_Coverage, 688,
     /* 128654 */   GIR_Done,
     /* 128655 */ // Label 2593: @128655
     /* 128655 */ GIM_Reject,
     /* 128656 */ // Label 2586: @128656
     /* 128656 */ GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(128682), // Rule ID 1707 //
     /* 128661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /* 128664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 128667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128675 */   // (ffloor:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTMNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /* 128675 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMNDf),
     /* 128680 */   GIR_RootConstrainSelectedInstOperands,
     /* 128681 */   // GIR_Coverage, 1707,
     /* 128681 */   GIR_Done,
     /* 128682 */ // Label 2594: @128682
     /* 128682 */ GIM_Reject,
     /* 128683 */ // Label 2587: @128683
     /* 128683 */ GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(128709), // Rule ID 1709 //
     /* 128688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /* 128691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 128694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128702 */   // (ffloor:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTMNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /* 128702 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMNDh),
     /* 128707 */   GIR_RootConstrainSelectedInstOperands,
     /* 128708 */   // GIR_Coverage, 1709,
     /* 128708 */   GIR_Done,
     /* 128709 */ // Label 2595: @128709
     /* 128709 */ GIM_Reject,
     /* 128710 */ // Label 2588: @128710
     /* 128710 */ GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(128797),
     /* 128715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 128718 */   GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(128741), // Rule ID 1708 //
     /* 128723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /* 128726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128734 */     // (ffloor:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTMNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /* 128734 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMNQf),
     /* 128739 */     GIR_RootConstrainSelectedInstOperands,
     /* 128740 */     // GIR_Coverage, 1708,
     /* 128740 */     GIR_Done,
     /* 128741 */   // Label 2597: @128741
     /* 128741 */   GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(128796), // Rule ID 3984 //
     /* 128746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128757 */     // (ffloor:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32M:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /* 128757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32M),
     /* 128772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128774 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128779 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128794 */     GIR_RootConstrainSelectedInstOperands,
     /* 128795 */     // GIR_Coverage, 3984,
     /* 128795 */     GIR_EraseRootFromParent_Done,
     /* 128796 */   // Label 2598: @128796
     /* 128796 */   GIM_Reject,
     /* 128797 */ // Label 2596: @128797
     /* 128797 */ GIM_Reject,
     /* 128798 */ // Label 2589: @128798
     /* 128798 */ GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(128885),
     /* 128803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 128806 */   GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(128829), // Rule ID 1710 //
     /* 128811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /* 128814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128822 */     // (ffloor:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTMNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /* 128822 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMNQh),
     /* 128827 */     GIR_RootConstrainSelectedInstOperands,
     /* 128828 */     // GIR_Coverage, 1710,
     /* 128828 */     GIR_Done,
     /* 128829 */   // Label 2600: @128829
     /* 128829 */   GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(128884), // Rule ID 3972 //
     /* 128834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128845 */     // (ffloor:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16M:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /* 128845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16M),
     /* 128860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128862 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128867 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128873 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128882 */     GIR_RootConstrainSelectedInstOperands,
     /* 128883 */     // GIR_Coverage, 3972,
     /* 128883 */     GIR_EraseRootFromParent_Done,
     /* 128884 */   // Label 2601: @128884
     /* 128884 */   GIM_Reject,
     /* 128885 */ // Label 2599: @128885
     /* 128885 */ GIM_Reject,
     /* 128886 */ // Label 2590: @128886
     /* 128886 */ GIM_Reject,
     /* 128887 */ // Label 70: @128887
     /* 128887 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2607*/ GIMT_Encode4(129182),
     /* 128898 */ /*GILLT_s16*//*Label 2602*/ GIMT_Encode4(128950),
     /* 128902 */ /*GILLT_s32*//*Label 2603*/ GIMT_Encode4(128988),
     /* 128906 */ /*GILLT_s64*//*Label 2604*/ GIMT_Encode4(129026), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128930 */ /*GILLT_v4s32*//*Label 2605*/ GIMT_Encode4(129064), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128946 */ /*GILLT_v8s16*//*Label 2606*/ GIMT_Encode4(129123),
     /* 128950 */ // Label 2602: @128950
     /* 128950 */ GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(128987), // Rule ID 671 //
     /* 128955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128969 */   // (frint:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTXH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXH),
     /* 128972 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128974 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128979 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128985 */   GIR_RootConstrainSelectedInstOperands,
     /* 128986 */   // GIR_Coverage, 671,
     /* 128986 */   GIR_EraseRootFromParent_Done,
     /* 128987 */ // Label 2608: @128987
     /* 128987 */ GIM_Reject,
     /* 128988 */ // Label 2603: @128988
     /* 128988 */ GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(129025), // Rule ID 672 //
     /* 128993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 128996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 129003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 129007 */   // (frint:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTXS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 129007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXS),
     /* 129010 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 129012 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 129014 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129017 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129023 */   GIR_RootConstrainSelectedInstOperands,
     /* 129024 */   // GIR_Coverage, 672,
     /* 129024 */   GIR_EraseRootFromParent_Done,
     /* 129025 */ // Label 2609: @129025
     /* 129025 */ GIM_Reject,
     /* 129026 */ // Label 2604: @129026
     /* 129026 */ GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(129063), // Rule ID 673 //
     /* 129031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 129034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 129037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 129041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 129045 */   // (frint:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTXD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 129045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXD),
     /* 129048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 129050 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 129052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129055 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129061 */   GIR_RootConstrainSelectedInstOperands,
     /* 129062 */   // GIR_Coverage, 673,
     /* 129062 */   GIR_EraseRootFromParent_Done,
     /* 129063 */ // Label 2610: @129063
     /* 129063 */ GIM_Reject,
     /* 129064 */ // Label 2605: @129064
     /* 129064 */ GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(129122), // Rule ID 3978 //
     /* 129069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 129072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 129075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129079 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129083 */   // (frint:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32X:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /* 129083 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 129086 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 129090 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32X),
     /* 129098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 129100 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 129102 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129105 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129111 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129117 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129120 */   GIR_RootConstrainSelectedInstOperands,
     /* 129121 */   // GIR_Coverage, 3978,
     /* 129121 */   GIR_EraseRootFromParent_Done,
     /* 129122 */ // Label 2611: @129122
     /* 129122 */ GIM_Reject,
     /* 129123 */ // Label 2606: @129123
     /* 129123 */ GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(129181), // Rule ID 3966 //
     /* 129128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 129131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 129134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129142 */   // (frint:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16X:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /* 129142 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 129145 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 129149 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129154 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16X),
     /* 129157 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 129159 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 129161 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129164 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129170 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129176 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129179 */   GIR_RootConstrainSelectedInstOperands,
     /* 129180 */   // GIR_Coverage, 3966,
     /* 129180 */   GIR_EraseRootFromParent_Done,
     /* 129181 */ // Label 2612: @129181
     /* 129181 */ GIM_Reject,
     /* 129182 */ // Label 2607: @129182
     /* 129182 */ GIM_Reject,
     /* 129183 */ // Label 71: @129183
     /* 129183 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2616*/ GIMT_Encode4(129320),
     /* 129194 */ /*GILLT_s16*//*Label 2613*/ GIMT_Encode4(129206),
     /* 129198 */ /*GILLT_s32*//*Label 2614*/ GIMT_Encode4(129244),
     /* 129202 */ /*GILLT_s64*//*Label 2615*/ GIMT_Encode4(129282),
     /* 129206 */ // Label 2613: @129206
     /* 129206 */ GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(129243), // Rule ID 668 //
     /* 129211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 129214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 129217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 129221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 129225 */   // (fnearbyint:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTRH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 129225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTRH),
     /* 129228 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 129230 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 129232 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129235 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129241 */   GIR_RootConstrainSelectedInstOperands,
     /* 129242 */   // GIR_Coverage, 668,
     /* 129242 */   GIR_EraseRootFromParent_Done,
     /* 129243 */ // Label 2617: @129243
     /* 129243 */ GIM_Reject,
     /* 129244 */ // Label 2614: @129244
     /* 129244 */ GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(129281), // Rule ID 669 //
     /* 129249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 129252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 129255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 129259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 129263 */   // (fnearbyint:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTRS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 129263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTRS),
     /* 129266 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 129268 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 129270 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129273 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129279 */   GIR_RootConstrainSelectedInstOperands,
     /* 129280 */   // GIR_Coverage, 669,
     /* 129280 */   GIR_EraseRootFromParent_Done,
     /* 129281 */ // Label 2618: @129281
     /* 129281 */ GIM_Reject,
     /* 129282 */ // Label 2615: @129282
     /* 129282 */ GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(129319), // Rule ID 670 //
     /* 129287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 129290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 129293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 129297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 129301 */   // (fnearbyint:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTRD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 129301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTRD),
     /* 129304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 129306 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 129308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129311 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129317 */   GIR_RootConstrainSelectedInstOperands,
     /* 129318 */   // GIR_Coverage, 670,
     /* 129318 */   GIR_EraseRootFromParent_Done,
     /* 129319 */ // Label 2619: @129319
     /* 129319 */ GIM_Reject,
     /* 129320 */ // Label 2616: @129320
     /* 129320 */ GIM_Reject,
     /* 129321 */ // Label 72: @129321
     /* 129321 */ GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(129336), // Rule ID 12 //
     /* 129326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_UseNaClTrap),
     /* 129329 */   // (trap)  =>  (TRAPNaCl)
     /* 129329 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::TRAPNaCl),
     /* 129334 */   GIR_RootConstrainSelectedInstOperands,
     /* 129335 */   // GIR_Coverage, 12,
     /* 129335 */   GIR_Done,
     /* 129336 */ // Label 2620: @129336
     /* 129336 */ GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(129351), // Rule ID 13 //
     /* 129341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNaClTrap_IsARM),
     /* 129344 */   // (trap)  =>  (TRAP)
     /* 129344 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::TRAP),
     /* 129349 */   GIR_RootConstrainSelectedInstOperands,
     /* 129350 */   // GIR_Coverage, 13,
     /* 129350 */   GIR_Done,
     /* 129351 */ // Label 2621: @129351
     /* 129351 */ GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(129366), // Rule ID 285 //
     /* 129356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb),
     /* 129359 */   // (trap)  =>  (tTRAP)
     /* 129359 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::tTRAP),
     /* 129364 */   GIR_RootConstrainSelectedInstOperands,
     /* 129365 */   // GIR_Coverage, 285,
     /* 129365 */   GIR_Done,
     /* 129366 */ // Label 2622: @129366
     /* 129366 */ GIM_Reject,
     /* 129367 */ // Label 73: @129367
     /* 129367 */ GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(129383), // Rule ID 1838 //
     /* 129372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5T_IsARM),
     /* 129375 */   // (debugtrap)  =>  (BKPT 0:{ *:[i32] })
     /* 129375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BKPT),
     /* 129378 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129381 */   GIR_RootConstrainSelectedInstOperands,
     /* 129382 */   // GIR_Coverage, 1838,
     /* 129382 */   GIR_EraseRootFromParent_Done,
     /* 129383 */ // Label 2623: @129383
     /* 129383 */ GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(129410), // Rule ID 1839 //
     /* 129388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV5T),
     /* 129391 */   // (debugtrap)  =>  (UDF 254:{ *:[i32] })
     /* 129391 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UDF),
     /* 129394 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(254),
     /* 129404 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129408 */   GIR_RootConstrainSelectedInstOperands,
     /* 129409 */   // GIR_Coverage, 1839,
     /* 129409 */   GIR_EraseRootFromParent_Done,
     /* 129410 */ // Label 2624: @129410
     /* 129410 */ GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(129426), // Rule ID 2024 //
     /* 129415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5T_IsThumb),
     /* 129418 */   // (debugtrap)  =>  (tBKPT 0:{ *:[i32] })
     /* 129418 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tBKPT),
     /* 129421 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129424 */   GIR_RootConstrainSelectedInstOperands,
     /* 129425 */   // GIR_Coverage, 2024,
     /* 129425 */   GIR_EraseRootFromParent_Done,
     /* 129426 */ // Label 2625: @129426
     /* 129426 */ GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(129453), // Rule ID 2025 //
     /* 129431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_NoV5T),
     /* 129434 */   // (debugtrap)  =>  (tUDF 254:{ *:[i32] })
     /* 129434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUDF),
     /* 129437 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(254),
     /* 129447 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129451 */   GIR_RootConstrainSelectedInstOperands,
     /* 129452 */   // GIR_Coverage, 2025,
     /* 129452 */   GIR_EraseRootFromParent_Done,
     /* 129453 */ // Label 2626: @129453
     /* 129453 */ GIM_Reject,
     /* 129454 */ // Label 74: @129454
     /* 129454 */ GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(129874),
     /* 129459 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 129462 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2631*/ GIMT_Encode4(129760),
     /* 129473 */   /*GILLT_v4s32*//*Label 2628*/ GIMT_Encode4(129505), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129489 */   /*GILLT_v8s16*//*Label 2629*/ GIMT_Encode4(129576), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129501 */   /*GILLT_v16s8*//*Label 2630*/ GIMT_Encode4(129647),
     /* 129505 */   // Label 2628: @129505
     /* 129505 */   GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(129575), // Rule ID 3241 //
     /* 129510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 129525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 129529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 129533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129545 */     // (vecreduce_add:{ *:[i32] } (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2))  =>  (MVE_VMLADAVu32:{ *:[i32] } ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /* 129545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu32),
     /* 129548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 129554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 129558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129561 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129567 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129573 */     GIR_RootConstrainSelectedInstOperands,
     /* 129574 */     // GIR_Coverage, 3241,
     /* 129574 */     GIR_EraseRootFromParent_Done,
     /* 129575 */   // Label 2632: @129575
     /* 129575 */   GIM_Reject,
     /* 129576 */   // Label 2629: @129576
     /* 129576 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(129646), // Rule ID 3242 //
     /* 129581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 129596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 129600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 129604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129616 */     // (vecreduce_add:{ *:[i32] } (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2))  =>  (MVE_VMLADAVu16:{ *:[i32] } ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /* 129616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu16),
     /* 129619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 129625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 129629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129632 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129638 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129644 */     GIR_RootConstrainSelectedInstOperands,
     /* 129645 */     // GIR_Coverage, 3242,
     /* 129645 */     GIR_EraseRootFromParent_Done,
     /* 129646 */   // Label 2633: @129646
     /* 129646 */   GIM_Reject,
     /* 129647 */   // Label 2630: @129647
     /* 129647 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(129759),
     /* 129652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129656 */     GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(129722), // Rule ID 3245 //
     /* 129661 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129664 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129668 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 129672 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 129676 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 129680 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129685 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129690 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129692 */       // (vecreduce_add:{ *:[i32] } (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, MQPR:{ *:[v16i8] }:$src2))  =>  (MVE_VMLADAVu8:{ *:[i32] } ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /* 129692 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu8),
     /* 129695 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129697 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 129701 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 129705 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129708 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129714 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129720 */       GIR_RootConstrainSelectedInstOperands,
     /* 129721 */       // GIR_Coverage, 3245,
     /* 129721 */       GIR_EraseRootFromParent_Done,
     /* 129722 */     // Label 2635: @129722
     /* 129722 */     GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(129758), // Rule ID 3049 //
     /* 129727 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129730 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129734 */       // (vecreduce_add:{ *:[i32] } MQPR:{ *:[v16i8] }:$vec)  =>  (MVE_VADDVu8no_acc:{ *:[i32] } ?:{ *:[v16i8] }:$vec)
     /* 129734 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu8no_acc),
     /* 129737 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /* 129739 */       GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 129741 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129744 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129750 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129756 */       GIR_RootConstrainSelectedInstOperands,
     /* 129757 */       // GIR_Coverage, 3049,
     /* 129757 */       GIR_EraseRootFromParent_Done,
     /* 129758 */     // Label 2636: @129758
     /* 129758 */     GIM_Reject,
     /* 129759 */   // Label 2634: @129759
     /* 129759 */   GIM_Reject,
     /* 129760 */   // Label 2631: @129760
     /* 129760 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 2639*/ GIMT_Encode4(129873),
     /* 129771 */   /*GILLT_v4s32*//*Label 2637*/ GIMT_Encode4(129791), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129787 */   /*GILLT_v8s16*//*Label 2638*/ GIMT_Encode4(129832),
     /* 129791 */   // Label 2637: @129791
     /* 129791 */   GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(129831), // Rule ID 3087 //
     /* 129796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129807 */     // (vecreduce_add:{ *:[i32] } MQPR:{ *:[v4i32] }:$vec)  =>  (MVE_VADDVu32no_acc:{ *:[i32] } ?:{ *:[v4i32] }:$vec)
     /* 129807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu32no_acc),
     /* 129810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /* 129812 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 129814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129817 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129823 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129829 */     GIR_RootConstrainSelectedInstOperands,
     /* 129830 */     // GIR_Coverage, 3087,
     /* 129830 */     GIR_EraseRootFromParent_Done,
     /* 129831 */   // Label 2640: @129831
     /* 129831 */   GIM_Reject,
     /* 129832 */   // Label 2638: @129832
     /* 129832 */   GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(129872), // Rule ID 3077 //
     /* 129837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129848 */     // (vecreduce_add:{ *:[i32] } MQPR:{ *:[v8i16] }:$vec)  =>  (MVE_VADDVu16no_acc:{ *:[i32] } ?:{ *:[v8i16] }:$vec)
     /* 129848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu16no_acc),
     /* 129851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /* 129853 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 129855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129858 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129864 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129870 */     GIR_RootConstrainSelectedInstOperands,
     /* 129871 */     // GIR_Coverage, 3077,
     /* 129871 */     GIR_EraseRootFromParent_Done,
     /* 129872 */   // Label 2641: @129872
     /* 129872 */   GIM_Reject,
     /* 129873 */   // Label 2639: @129873
     /* 129873 */   GIM_Reject,
     /* 129874 */ // Label 2627: @129874
     /* 129874 */ GIM_Reject,
     /* 129875 */ // Label 75: @129875
     /* 129875 */ GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(130154),
     /* 129880 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 129883 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2646*/ GIMT_Encode4(130153),
     /* 129894 */   /*GILLT_v4s32*//*Label 2643*/ GIMT_Encode4(129926), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129910 */   /*GILLT_v8s16*//*Label 2644*/ GIMT_Encode4(130009), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129922 */   /*GILLT_v16s8*//*Label 2645*/ GIMT_Encode4(130077),
     /* 129926 */   // Label 2643: @129926
     /* 129926 */   GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(130008), // Rule ID 3147 //
     /* 129931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 129938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129942 */     // (vecreduce_smax:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMAXVs32:{ *:[i32] } (t2MOVi:{ *:[i32] } -2147483648:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 129942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 129949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129954 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-2147483648),
     /* 129964 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 129967 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129973 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs32),
     /* 129984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129989 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 129991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129994 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130000 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130006 */     GIR_RootConstrainSelectedInstOperands,
     /* 130007 */     // GIR_Coverage, 3147,
     /* 130007 */     GIR_EraseRootFromParent_Done,
     /* 130008 */   // Label 2647: @130008
     /* 130008 */   GIM_Reject,
     /* 130009 */   // Label 2644: @130009
     /* 130009 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(130076), // Rule ID 3146 //
     /* 130014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130025 */     // (vecreduce_smax:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMAXVs16:{ *:[i32] } (t2MOVi32imm:{ *:[i32] } -32768:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi32imm),
     /* 130032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130037 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-32768),
     /* 130047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs16),
     /* 130052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130057 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130062 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130068 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130074 */     GIR_RootConstrainSelectedInstOperands,
     /* 130075 */     // GIR_Coverage, 3146,
     /* 130075 */     GIR_EraseRootFromParent_Done,
     /* 130076 */   // Label 2648: @130076
     /* 130076 */   GIM_Reject,
     /* 130077 */   // Label 2645: @130077
     /* 130077 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(130152), // Rule ID 3145 //
     /* 130082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130093 */     // (vecreduce_smax:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMAXVs8:{ *:[i32] } (t2MVNi:{ *:[i32] } 127:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /* 130100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130105 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/127,
     /* 130108 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130111 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130117 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs8),
     /* 130128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130133 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130138 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130144 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130150 */     GIR_RootConstrainSelectedInstOperands,
     /* 130151 */     // GIR_Coverage, 3145,
     /* 130151 */     GIR_EraseRootFromParent_Done,
     /* 130152 */   // Label 2649: @130152
     /* 130152 */   GIM_Reject,
     /* 130153 */   // Label 2646: @130153
     /* 130153 */   GIM_Reject,
     /* 130154 */ // Label 2642: @130154
     /* 130154 */ GIM_Reject,
     /* 130155 */ // Label 76: @130155
     /* 130155 */ GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(130443),
     /* 130160 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 130163 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2654*/ GIMT_Encode4(130442),
     /* 130174 */   /*GILLT_v4s32*//*Label 2651*/ GIMT_Encode4(130206), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130190 */   /*GILLT_v8s16*//*Label 2652*/ GIMT_Encode4(130289), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130202 */   /*GILLT_v16s8*//*Label 2653*/ GIMT_Encode4(130366),
     /* 130206 */   // Label 2651: @130206
     /* 130206 */   GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(130288), // Rule ID 3153 //
     /* 130211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130222 */     // (vecreduce_smin:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMINVs32:{ *:[i32] } (t2MVNi:{ *:[i32] } -2147483648:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 130222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /* 130229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130234 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-2147483648),
     /* 130244 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130247 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130253 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs32),
     /* 130264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130269 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130274 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130280 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130286 */     GIR_RootConstrainSelectedInstOperands,
     /* 130287 */     // GIR_Coverage, 3153,
     /* 130287 */     GIR_EraseRootFromParent_Done,
     /* 130288 */   // Label 2655: @130288
     /* 130288 */   GIM_Reject,
     /* 130289 */   // Label 2652: @130289
     /* 130289 */   GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(130365), // Rule ID 3152 //
     /* 130294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130305 */     // (vecreduce_smin:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMINVs16:{ *:[i32] } (t2MOVi16:{ *:[i32] } 32767:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi16),
     /* 130312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130317 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
     /* 130327 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130330 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130336 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs16),
     /* 130341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130346 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130351 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130357 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130363 */     GIR_RootConstrainSelectedInstOperands,
     /* 130364 */     // GIR_Coverage, 3152,
     /* 130364 */     GIR_EraseRootFromParent_Done,
     /* 130365 */   // Label 2656: @130365
     /* 130365 */   GIM_Reject,
     /* 130366 */   // Label 2653: @130366
     /* 130366 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(130441), // Rule ID 3151 //
     /* 130371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130382 */     // (vecreduce_smin:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMINVs8:{ *:[i32] } (t2MOVi:{ *:[i32] } 127:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130394 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/127,
     /* 130397 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130400 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130406 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs8),
     /* 130417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130422 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130427 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130433 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130439 */     GIR_RootConstrainSelectedInstOperands,
     /* 130440 */     // GIR_Coverage, 3151,
     /* 130440 */     GIR_EraseRootFromParent_Done,
     /* 130441 */   // Label 2657: @130441
     /* 130441 */   GIM_Reject,
     /* 130442 */   // Label 2654: @130442
     /* 130442 */   GIM_Reject,
     /* 130443 */ // Label 2650: @130443
     /* 130443 */ GIM_Reject,
     /* 130444 */ // Label 77: @130444
     /* 130444 */ GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(130724),
     /* 130449 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 130452 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2662*/ GIMT_Encode4(130723),
     /* 130463 */   /*GILLT_v4s32*//*Label 2659*/ GIMT_Encode4(130495), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130479 */   /*GILLT_v8s16*//*Label 2660*/ GIMT_Encode4(130571), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130491 */   /*GILLT_v16s8*//*Label 2661*/ GIMT_Encode4(130647),
     /* 130495 */   // Label 2659: @130495
     /* 130495 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(130570), // Rule ID 3150 //
     /* 130500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130511 */     // (vecreduce_umax:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMAXVu32:{ *:[i32] } (t2MOVi:{ *:[i32] } 0:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 130511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130523 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 130526 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130529 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130535 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu32),
     /* 130546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130551 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130556 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130562 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130568 */     GIR_RootConstrainSelectedInstOperands,
     /* 130569 */     // GIR_Coverage, 3150,
     /* 130569 */     GIR_EraseRootFromParent_Done,
     /* 130570 */   // Label 2663: @130570
     /* 130570 */   GIM_Reject,
     /* 130571 */   // Label 2660: @130571
     /* 130571 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(130646), // Rule ID 3149 //
     /* 130576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130587 */     // (vecreduce_umax:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMAXVu16:{ *:[i32] } (t2MOVi:{ *:[i32] } 0:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130599 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 130602 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130605 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130611 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu16),
     /* 130622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130627 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130632 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130638 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130644 */     GIR_RootConstrainSelectedInstOperands,
     /* 130645 */     // GIR_Coverage, 3149,
     /* 130645 */     GIR_EraseRootFromParent_Done,
     /* 130646 */   // Label 2664: @130646
     /* 130646 */   GIM_Reject,
     /* 130647 */   // Label 2661: @130647
     /* 130647 */   GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(130722), // Rule ID 3148 //
     /* 130652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130663 */     // (vecreduce_umax:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMAXVu8:{ *:[i32] } (t2MOVi:{ *:[i32] } 0:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130675 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 130678 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130681 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130687 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu8),
     /* 130698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130703 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130708 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130714 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130720 */     GIR_RootConstrainSelectedInstOperands,
     /* 130721 */     // GIR_Coverage, 3148,
     /* 130721 */     GIR_EraseRootFromParent_Done,
     /* 130722 */   // Label 2665: @130722
     /* 130722 */   GIM_Reject,
     /* 130723 */   // Label 2662: @130723
     /* 130723 */   GIM_Reject,
     /* 130724 */ // Label 2658: @130724
     /* 130724 */ GIM_Reject,
     /* 130725 */ // Label 78: @130725
     /* 130725 */ GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(131020),
     /* 130730 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 130733 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2670*/ GIMT_Encode4(131019),
     /* 130744 */   /*GILLT_v4s32*//*Label 2667*/ GIMT_Encode4(130776), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130760 */   /*GILLT_v8s16*//*Label 2668*/ GIMT_Encode4(130859), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130772 */   /*GILLT_v16s8*//*Label 2669*/ GIMT_Encode4(130936),
     /* 130776 */   // Label 2667: @130776
     /* 130776 */   GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(130858), // Rule ID 3156 //
     /* 130781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130792 */     // (vecreduce_umin:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMINVu32:{ *:[i32] } (t2MOVi:{ *:[i32] } 4294967295:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 130792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130804 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(4294967295),
     /* 130814 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130817 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130823 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu32),
     /* 130834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130839 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130844 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130850 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130856 */     GIR_RootConstrainSelectedInstOperands,
     /* 130857 */     // GIR_Coverage, 3156,
     /* 130857 */     GIR_EraseRootFromParent_Done,
     /* 130858 */   // Label 2671: @130858
     /* 130858 */   GIM_Reject,
     /* 130859 */   // Label 2668: @130859
     /* 130859 */   GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(130935), // Rule ID 3155 //
     /* 130864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130875 */     // (vecreduce_umin:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMINVu16:{ *:[i32] } (t2MOVi16:{ *:[i32] } 65535:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi16),
     /* 130882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130887 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
     /* 130897 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130900 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu16),
     /* 130911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130916 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130921 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130927 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130933 */     GIR_RootConstrainSelectedInstOperands,
     /* 130934 */     // GIR_Coverage, 3155,
     /* 130934 */     GIR_EraseRootFromParent_Done,
     /* 130935 */   // Label 2672: @130935
     /* 130935 */   GIM_Reject,
     /* 130936 */   // Label 2669: @130936
     /* 130936 */   GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(131018), // Rule ID 3154 //
     /* 130941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130952 */     // (vecreduce_umin:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMINVu8:{ *:[i32] } (t2MOVi:{ *:[i32] } 255:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130964 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(255),
     /* 130974 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130977 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130983 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu8),
     /* 130994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130999 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 131001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131004 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131010 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131016 */     GIR_RootConstrainSelectedInstOperands,
     /* 131017 */     // GIR_Coverage, 3154,
     /* 131017 */     GIR_EraseRootFromParent_Done,
     /* 131018 */   // Label 2673: @131018
     /* 131018 */   GIM_Reject,
     /* 131019 */   // Label 2670: @131019
     /* 131019 */   GIM_Reject,
     /* 131020 */ // Label 2666: @131020
     /* 131020 */ GIM_Reject,
     /* 131021 */ // Label 79: @131021
     /* 131021 */ GIM_Reject,
     /* 131022 */ }; // Size: 131022 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const ARMSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const ARMSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
